/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/platform/files/common/files","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/resources","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/process","os","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(Y){for(var e=[],k=0,t=Y.length;k<t;k++)e[k]=ne[Y[k]];return e};define(ne[99],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(t,L){if(!t)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=k}),define(ne[48],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(R,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=k;class t{constructor(R,C,E){this.id=R,this.definition=C,this.description=E,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function L(A,R){const C=["codicon","codicon-"+A];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function C(b){if(b instanceof t)return["codicon","codicon-"+b.id];const f=R.exec(b.id);if(!f)return C(t.error);let[,p,d]=f;const h=["codicon","codicon-"+p];return d&&h.push("codicon-modifier-"+d.substr(1)),h}A.asClassNameArray=C;function E(b){return C(b).join(" ")}A.asClassName=E;function P(b){return"."+C(b).join(".")}A.asCSSSelector=P})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ne[68],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function t(P){const b=[];for(let f in P)k.call(P,f)&&b.push(P[f]);return b}e.values=t;function L(P,b){for(let f in P)if(k.call(P,f)&&b({key:f,value:P[f]},function(){delete P[f]})===!1)return}e.forEach=L;function T(P,b){const f=Object.create(null);for(const p of P){const d=b(p);let h=f[d];h||(h=f[d]=[]),h.push(p)}return f}e.groupBy=T;function A(P){const b=Object.create(null);return P&&P.forEach((f,p)=>{b[p]=f}),b}e.fromMap=A;function R(P,b){const f=[],p=[];for(let d of P)b.has(d)||f.push(d);for(let d of b)P.has(d)||p.push(d);return{removed:f,added:p}}e.diffSets=R;function C(P,b){const f=[],p=[];for(let[d,h]of P)b.has(d)||f.push(h);for(let[d,h]of b)P.has(d)||p.push(h);return{removed:f,added:p}}e.diffMaps=C;class E{constructor(){this.map=new Map}add(b,f){let p=this.map.get(b);p||(p=new Set,this.map.set(b,p)),p.add(f)}delete(b,f){const p=this.map.get(b);!p||(p.delete(f),p.size===0&&this.map.delete(b))}forEach(b,f){const p=this.map.get(b);!p||p.forEach(f)}}e.SetMap=E}),define(ne[54],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(A){return(R,C,E)=>{let P=null,b=null;if(typeof E.value=="function"?(P="value",b=E.value):typeof E.get=="function"&&(P="get",b=E.get),!b)throw new Error("not supported");E[P]=A(b,C)}}e.createDecorator=k;function t(A,R,C){let E=null,P=null;if(typeof C.value=="function"?(E="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(E="get",P=C.get),!P)throw new Error("not supported");const b=`$memoize$${R}`;C[E]=function(...f){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,f)}),this[b]}}e.memoize=t;function L(A,R,C){return k((E,P)=>{const b=`$debounce$${P}`,f=`$debounce$result$${P}`;return function(...p){this[f]||(this[f]=C?C():void 0),clearTimeout(this[b]),R&&(this[f]=R(this[f],...p),p=[this[f]]),this[b]=setTimeout(()=>{E.apply(this,p),this[f]=C?C():void 0},A)}})}e.debounce=L;function T(A,R,C){return k((E,P)=>{const b=`$throttle$timer$${P}`,f=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,d=`$throttle$pending$${P}`;return function(...h){if(this[f]||(this[f]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...h)),this[d])return;const m=this[p]+A;m<=Date.now()?(this[p]=Date.now(),E.apply(this,[this[f]]),this[f]=C?C():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),E.apply(this,[this[f]]),this[f]=C?C():void 0},m-Date.now()))}})}e.throttle=T}),define(ne[9],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(c=>{c(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=k,e.errorHandler=new k;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function L(l){C(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=L;function T(l){C(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function A(l){if(l instanceof Error){let{name:i,message:c}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:i,message:c,stack:r}}return l}e.transformErrorForSerialization=A;const R="Canceled";function C(l){return l instanceof E?!0:l instanceof Error&&l.name===R&&l.message===R}e.isCancellationError=C;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function P(){const l=new Error(R);return l.name=l.message,l}e.canceled=P;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=b;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function h(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=h;class m extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=m;class g extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=g;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function w(l){const i=l;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=w;function S(l,i=Object.create(null)){const c=new Error(l);return i.actions&&(c.actions=i.actions),c}e.createErrorWithActions=S}),define(ne[16],ie([0,1,9]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(B,N=0){return B[B.length-(1+N)]}e.tail=t;function L(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=L;function T(B,N,$=(z,V)=>z===V){if(B===N)return!0;if(!B||!N||B.length!==N.length)return!1;for(let z=0,V=B.length;z<V;z++)if(!$(B[z],N[z]))return!1;return!0}e.equals=T;function A(B,N,$){let z=0,V=B.length-1;for(;z<=V;){const ee=(z+V)/2|0,se=$(B[ee],N);if(se<0)z=ee+1;else if(se>0)V=ee-1;else return ee}return-(z+1)}e.binarySearch=A;function R(B,N){let $=0,z=B.length;if(z===0)return 0;for(;$<z;){const V=Math.floor(($+z)/2);N(B[V])?z=V:$=V+1}return $}e.findFirstInSorted=R;function C(B,N,$){if(B=B|0,B>=N.length)throw new TypeError("invalid index");let z=N[Math.floor(N.length*Math.random())],V=[],ee=[],se=[];for(let ae of N){const de=$(ae,z);de<0?V.push(ae):de>0?ee.push(ae):se.push(ae)}return B<V.length?C(B,V,$):B<V.length+se.length?se[0]:C(B-(V.length+se.length),ee,$)}e.quickSelect=C;function E(B,N){const $=[];let z;for(const V of B.slice(0).sort(N))!z||N(z[0],V)!==0?(z=[V],$.push(z)):z.push(V);return $}e.groupBy=E;function P(B,N,$){const z=[];function V(ae,de,ve){if(de===0&&ve.length===0)return;const be=z[z.length-1];be&&be.start+be.deleteCount===ae?(be.deleteCount+=de,be.toInsert.push(...ve)):z.push({start:ae,deleteCount:de,toInsert:ve})}let ee=0,se=0;for(;;){if(ee===B.length){V(ee,0,N.slice(se));break}if(se===N.length){V(ee,B.length-ee,[]);break}const ae=B[ee],de=N[se],ve=$(ae,de);ve===0?(ee+=1,se+=1):ve<0?(V(ee,1,[]),ee+=1):ve>0&&(V(ee,0,[de]),se+=1)}return z}e.sortedDiff=P;function b(B,N,$){const z=P(B,N,$),V=[],ee=[];for(const se of z)V.push(...B.slice(se.start,se.start+se.deleteCount)),ee.push(...se.toInsert);return{removed:V,added:ee}}e.delta=b;function f(B,N,$){if($===0)return[];const z=B.slice(0,$).sort(N);return d(B,N,z,$,B.length),z}e.top=f;function p(B,N,$,z,V){return $===0?Promise.resolve([]):new Promise((ee,se)=>{(async()=>{const ae=B.length,de=B.slice(0,$).sort(N);for(let ve=$,be=Math.min($+z,ae);ve<ae;ve=be,be=Math.min(be+z,ae)){if(ve>$&&await new Promise(Se=>setTimeout(Se)),V&&V.isCancellationRequested)throw(0,k.canceled)();d(B,N,de,ve,be)}return de})().then(ee,se)})}e.topAsync=p;function d(B,N,$,z,V){for(const ee=$.length;z<V;z++){const se=B[z];if(N(se,$[ee-1])<0){$.pop();const ae=R($,de=>N(se,de)<0);$.splice(ae,0,se)}}}function h(B){return B.filter(N=>!!N)}e.coalesce=h;function m(B){let N=0;for(let $=0;$<B.length;$++)B[$]&&(B[N]=B[$],N+=1);B.length=N}e.coalesceInPlace=m;function g(B,N,$){B.splice($,0,B.splice(N,1)[0])}e.move=g;function y(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=y;function w(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=w;function S(B,N=$=>$){const $=new Set;return B.filter(z=>{const V=N(z);return $.has(V)?!1:($.add(V),!0)})}e.distinct=S;function l(B){const N=new Set;return $=>{const z=B($);return N.has(z)?!1:(N.add(z),!0)}}e.uniqueFilter=l;function i(B,N){const $=c(B,N);if($!==-1)return B[$]}e.findLast=i;function c(B,N){for(let $=B.length-1;$>=0;$--){const z=B[$];if(N(z))return $}return-1}e.lastIndex=c;function r(B,N){return B.length>0?B[0]:N}e.firstOrDefault=r;function n(B,N,$=(z,V)=>z===V){let z=0;for(let V=0,ee=Math.min(B.length,N.length);V<ee&&$(B[V],N[V]);V++)z++;return z}e.commonPrefixLength=n;function s(B){return[].concat(...B)}e.flatten=s;function o(B,N){let $=typeof N=="number"?B:0;typeof N=="number"?$=B:($=0,N=B);const z=[];if($<=N)for(let V=$;V<N;V++)z.push(V);else for(let V=$;V>N;V--)z.push(V);return z}e.range=o;function a(B,N,$){return B.reduce((z,V)=>(z[N(V)]=$?$(V):V,z),Object.create(null))}e.index=a;function u(B,N){return B.push(N),()=>v(B,N)}e.insert=u;function v(B,N){const $=B.indexOf(N);if($>-1)return B.splice($,1),N}e.remove=v;function I(B,N,$){const z=B.slice(0,N),V=B.slice(N);return z.concat($,V)}e.arrayInsert=I;function _(B,N){let $;if(typeof N=="number"){let z=N;$=()=>{const V=Math.sin(z++)*179426549;return V-Math.floor(V)}}else $=Math.random;for(let z=B.length-1;z>0;z-=1){const V=Math.floor($()*(z+1)),ee=B[z];B[z]=B[V],B[V]=ee}}e.shuffle=_;function O(B,N){const $=B.indexOf(N);$>-1&&(B.splice($,1),B.unshift(N))}e.pushToStart=O;function M(B,N){const $=B.indexOf(N);$>-1&&(B.splice($,1),B.push(N))}e.pushToEnd=M;function D(B,N){return Array.isArray(B)?B.map(N):N(B)}e.mapArrayOrNot=D;function U(B){return Array.isArray(B)?B:[B]}e.asArray=U;function F(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=F;function x(B,N){for(const $ of B){const z=N($);if(z!==void 0)return z}}e.mapFind=x;function q(B,N,$){const z=te(B,N),V=B.length,ee=$.length;B.length=V+ee;for(let se=V-1;se>=z;se--)B[se+ee]=B[se];for(let se=0;se<ee;se++)B[se+z]=$[se]}e.insertInto=q;function G(B,N,$,z){const V=te(B,N),ee=B.splice(V,$);return q(B,V,z),ee}e.splice=G;function te(B,N){return N<0?Math.max(N+B.length,0):Math.min(N,B.length)}function W(B,N){return($,z)=>N(B($),B(z))}e.compareBy=W;const j=(B,N)=>B-N;e.numberComparator=j;function J(B,N){if(B.length===0)return;let $=B[0];for(let z=1;z<B.length;z++){const V=B[z];N(V,$)>0&&($=V)}return $}e.findMaxBy=J;function H(B,N){if(B.length===0)return;let $=B[0];for(let z=1;z<B.length;z++){const V=B[z];N(V,$)>=0&&($=V)}return $}e.findLastMaxBy=H;function Q(B,N){return J(B,($,z)=>-N($,z))}e.findMinBy=Q;class Z{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let $=this.firstIdx;for(;$<this.items.length&&N(this.items[$]);)$++;const z=$===this.firstIdx?null:this.items.slice(this.firstIdx,$);return this.firstIdx=$,z}takeFromEndWhile(N){let $=this.lastIdx;for(;$>=0&&N(this.items[$]);)$--;const z=$===this.lastIdx?null:this.items.slice($+1,this.lastIdx+1);return this.lastIdx=$,z}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const $=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,$}}e.ArrayQueue=Z}),define(ne[69],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(t){const L=this;let T=!1,A;return function(){return T||(T=!0,A=t.apply(L,arguments)),A}}e.once=k}),define(ne[55],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(t){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}t.is=L;const T=Object.freeze([]);function A(){return T}t.empty=A;function*R(l){yield l}t.single=R;function C(l){return l||T}t.from=C;function E(l){return!l||l[Symbol.iterator]().next().done===!0}t.isEmpty=E;function P(l){return l[Symbol.iterator]().next().value}t.first=P;function b(l,i){for(const c of l)if(i(c))return!0;return!1}t.some=b;function f(l,i){for(const c of l)if(i(c))return c}t.find=f;function*p(l,i){for(const c of l)i(c)&&(yield c)}t.filter=p;function*d(l,i){let c=0;for(const r of l)yield i(r,c++)}t.map=d;function*h(...l){for(const i of l)for(const c of i)yield c}t.concat=h;function*m(l){for(const i of l)for(const c of i)yield c}t.concatNested=m;function g(l,i,c){let r=c;for(const n of l)r=i(r,n);return r}t.reduce=g;function*y(l,i,c=l.length){for(i<0&&(i+=l.length),c<0?c+=l.length:c>l.length&&(c=l.length);i<c;i++)yield l[i]}t.slice=y;function w(l,i=Number.POSITIVE_INFINITY){const c=[];if(i===0)return[c,l];const r=l[Symbol.iterator]();for(let n=0;n<i;n++){const s=r.next();if(s.done)return[c,t.empty()];c.push(s.value)}return[c,{[Symbol.iterator](){return r}}]}t.consume=w;function S(l,i,c=(r,n)=>r===n){const r=l[Symbol.iterator](),n=i[Symbol.iterator]();for(;;){const s=r.next(),o=n.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!c(s.value,o.value))return!1}}t.equals=S})(k=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(i,c=!1){let r=0,n=i.length,s="",o=0,a=16,u=0;function v(F){let x=0,q=0;for(;x<F;){const G=i.charCodeAt(r);if(G>=48&&G<=57)q=q*16+G-48;else if(G>=65&&G<=70)q=q*16+G-65+10;else if(G>=97&&G<=102)q=q*16+G-97+10;else break;r++,x++}return x<F&&(q=-1),q}function I(F){r=F,s="",o=0,a=16,u=0}function _(){const F=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&E(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&E(i.charCodeAt(r)))for(r++;r<i.length&&E(i.charCodeAt(r));)r++;else return u=3,i.substring(F,r);let x=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&E(i.charCodeAt(r))){for(r++;r<i.length&&E(i.charCodeAt(r));)r++;x=r}else u=3;return i.substring(F,x)}function O(){let F="",x=r;for(;;){if(r>=n){F+=i.substring(x,r),u=2;break}const q=i.charCodeAt(r);if(q===34){F+=i.substring(x,r),r++;break}if(q===92){if(F+=i.substring(x,r),r++,r>=n){u=2;break}switch(i.charCodeAt(r++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const te=v(4);te>=0?F+=String.fromCharCode(te):u=4;break}default:u=5}x=r;continue}if(q>=0&&q<=31)if(C(q)){F+=i.substring(x,r),u=2;break}else u=6;r++}return F}function M(){if(s="",u=0,o=r,r>=n)return o=n,a=17;let F=i.charCodeAt(r);if(R(F)){do r++,s+=String.fromCharCode(F),F=i.charCodeAt(r);while(R(F));return a=15}if(C(F))return r++,s+=String.fromCharCode(F),F===13&&i.charCodeAt(r)===10&&(r++,s+=`
`),a=14;switch(F){case 123:return r++,a=1;case 125:return r++,a=2;case 91:return r++,a=3;case 93:return r++,a=4;case 58:return r++,a=6;case 44:return r++,a=5;case 34:return r++,s=O(),a=10;case 47:{const x=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<n&&!C(i.charCodeAt(r));)r++;return s=i.substring(x,r),a=12}if(i.charCodeAt(r+1)===42){r+=2;const q=n-1;let G=!1;for(;r<q;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,G=!0;break}r++}return G||(r++,u=1),s=i.substring(x,r),a=13}return s+=String.fromCharCode(F),r++,a=16}case 45:if(s+=String.fromCharCode(F),r++,r===n||!E(i.charCodeAt(r)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=_(),a=11;default:for(;r<n&&D(F);)r++,F=i.charCodeAt(r);if(o!==r){switch(s=i.substring(o,r),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(F),r++,a=16}}function D(F){if(R(F)||C(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let F;do F=M();while(F>=12&&F<=15);return F}return{setPosition:I,getPosition:()=>r,scan:c?U:M,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>u}}e.createScanner=A;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function b(i,c){const r=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(v,I,_,O){o.value=v,o.offset=I,o.length=_,o.type=O,o.colonOffset=void 0,s=o}try{w(i,{onObjectBegin:(v,I)=>{if(c<=v)throw n;s=void 0,a=c>v,r.push("")},onObjectProperty:(v,I,_)=>{if(c<I||(u(v,I,_,"property"),r[r.length-1]=v,c<=I+_))throw n},onObjectEnd:(v,I)=>{if(c<=v)throw n;s=void 0,r.pop()},onArrayBegin:(v,I)=>{if(c<=v)throw n;s=void 0,r.push(0)},onArrayEnd:(v,I)=>{if(c<=v)throw n;s=void 0,r.pop()},onLiteralValue:(v,I,_)=>{if(c<I||(u(v,I,_,l(v)),c<=I+_))throw n},onSeparator:(v,I,_)=>{if(c<=I)throw n;if(v===":"&&s&&s.type==="property")s.colonOffset=I,a=!1,s=void 0;else if(v===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(a=!0,r[r.length-1]=""),s=void 0}}})}catch(v){if(v!==n)throw v}return{path:r,previousNode:s,isAtPropertyKey:a,matches:v=>{let I=0;for(let _=0;I<v.length&&_<r.length;_++)if(v[I]===r[_]||v[I]==="*")I++;else if(v[I]!=="**")return!1;return I===v.length}}}e.getLocation=b;function f(i,c=[],r=T.DEFAULT){let n=null,s=[];const o=[];function a(v){Array.isArray(s)?s.push(v):n!==null&&(s[n]=v)}return w(i,{onObjectBegin:()=>{const v={};a(v),o.push(s),s=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const v=[];a(v),o.push(s),s=v,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:a,onError:(v,I,_)=>{c.push({error:v,offset:I,length:_})}},r),s[0]}e.parse=f;function p(i,c=[],r=T.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){n.type==="property"&&(n.length=v-n.offset,n=n.parent)}function o(v){return n.children.push(v),v}w(i,{onObjectBegin:v=>{n=o({type:"object",offset:v,length:-1,parent:n,children:[]})},onObjectProperty:(v,I,_)=>{n=o({type:"property",offset:I,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:v,offset:I,length:_,parent:n})},onObjectEnd:(v,I)=>{n.length=v+I-n.offset,n=n.parent,s(v+I)},onArrayBegin:(v,I)=>{n=o({type:"array",offset:v,length:-1,parent:n,children:[]})},onArrayEnd:(v,I)=>{n.length=v+I-n.offset,n=n.parent,s(v+I)},onLiteralValue:(v,I,_)=>{o({type:l(v),offset:I,length:_,parent:n,value:v}),s(I+_)},onSeparator:(v,I,_)=>{n.type==="property"&&(v===":"?n.colonOffset=I:v===","&&s(I))},onError:(v,I,_)=>{c.push({error:v,offset:I,length:_})}},r);const u=n.children[0];return u&&delete u.parent,u}e.parseTree=p;function d(i,c){if(!i)return;let r=i;for(let n of c)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===n){r=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=d;function h(i){if(!i.parent||!i.parent.children)return[];const c=h(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;c.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&c.push(r)}return c}e.getNodePath=h;function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const c=Object.create(null);for(let r of i.children){const n=r.children[1];n&&(c[r.children[0].value]=m(n))}return c}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=m;function g(i,c,r=!1){return c>=i.offset&&c<i.offset+i.length||r&&c===i.offset+i.length}e.contains=g;function y(i,c,r=!1){if(g(i,c,r)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=c;s++){const o=y(n[s],c,r);if(o)return o}return i}}e.findNodeAtOffset=y;function w(i,c,r=T.DEFAULT){const n=A(i,!1);function s(Z){return Z?()=>Z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Z){return Z?B=>Z(B,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=s(c.onObjectBegin),u=o(c.onObjectProperty),v=s(c.onObjectEnd),I=s(c.onArrayBegin),_=s(c.onArrayEnd),O=o(c.onLiteralValue),M=o(c.onSeparator),D=s(c.onComment),U=o(c.onError),F=r&&r.disallowComments,x=r&&r.allowTrailingComma;function q(){for(;;){const Z=n.scan();switch(n.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:F||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(Z){case 12:case 13:F?G(10):D();break;case 16:G(1);break;case 15:case 14:break;default:return Z}}}function G(Z,B=[],N=[]){if(U(Z),B.length+N.length>0){let $=n.getToken();for(;$!==17;){if(B.indexOf($)!==-1){q();break}else if(N.indexOf($)!==-1)break;$=q()}}}function te(Z){const B=n.getTokenValue();return Z?O(B):u(B),q(),!0}function W(){switch(n.getToken()){case 11:{let Z=0;try{Z=JSON.parse(n.getTokenValue()),typeof Z!="number"&&(G(2),Z=0)}catch{G(2)}O(Z);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return q(),!0}function j(){return n.getToken()!==10?(G(3,[],[2,5]),!1):(te(!1),n.getToken()===6?(M(":"),q(),Q()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function J(){a(),q();let Z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Z||G(4,[],[]),M(","),q(),n.getToken()===2&&x)break}else Z&&G(6,[],[]);j()||G(4,[],[2,5]),Z=!0}return v(),n.getToken()!==2?G(7,[2],[]):q(),!0}function H(){I(),q();let Z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Z||G(4,[],[]),M(","),q(),n.getToken()===4&&x)break}else Z&&G(6,[],[]);Q()||G(4,[],[4,5]),Z=!0}return _(),n.getToken()!==4?G(8,[4],[]):q(),!0}function Q(){switch(n.getToken()){case 3:return H();case 1:return J();case 10:return te(!0);default:return W()}}return q(),n.getToken()===17?r.allowEmptyContent?!0:(G(4,[],[]),!1):Q()?(n.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=w;function S(i,c){let r=A(i),n=[],s,o=0,a;do switch(a=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:o!==a&&n.push(i.substring(o,a)),c!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,c)),o=r.getPosition();break}while(s!==17);return n.join("")}e.stripComments=S;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[49],ie([0,1,35]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(E,P,b){let f,p,d,h,m;if(P){for(h=P.offset,m=h+P.length,d=h;d>0&&!C(E,d-1);)d--;let a=m;for(;a<E.length&&!C(E,a);)a++;p=E.substring(d,a),f=A(p,b)}else p=E,f=0,d=0,h=0,m=E.length;const g=R(b,E);let y=!1,w=0,S;b.insertSpaces?S=T(" ",b.tabSize||4):S="	";const l=(0,k.createScanner)(p,!1);let i=!1;function c(){return g+T(S,f+w)}function r(){let a=l.scan();for(y=!1;a===15||a===14;)y=y||a===14,a=l.scan();return i=a===16||l.getTokenError()!==0,a}const n=[];function s(a,u,v){!i&&u<m&&v>h&&E.substring(u,v)!==a&&n.push({offset:u,length:v-u,content:a})}let o=r();if(o!==17){const a=l.getTokenOffset()+d,u=T(S,f);s(u,d,a)}for(;o!==17;){let a=l.getTokenOffset()+l.getTokenLength()+d,u=r(),v="";for(;!y&&(u===12||u===13);){const _=l.getTokenOffset()+d;s(" ",a,_),a=l.getTokenOffset()+l.getTokenLength()+d,v=u===12?c():"",u=r()}if(u===2)o!==1&&(w--,v=c());else if(u===4)o!==3&&(w--,v=c());else{switch(o){case 3:case 1:w++,v=c();break;case 5:case 12:v=c();break;case 13:y?v=c():v=" ";break;case 6:v=" ";break;case 10:if(u===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?v=" ":u!==5&&u!==17&&(i=!0);break;case 16:i=!0;break}y&&(u===12||u===13)&&(v=c())}const I=l.getTokenOffset()+d;s(v,a,I),o=u}return n}e.format=t;function L(E,P){const b=JSON.stringify(E,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?b.replace(/\r\n|\r|\n/g,P.eol):b}e.toFormattedString=L;function T(E,P){let b="";for(let f=0;f<P;f++)b+=E;return b}function A(E,P){let b=0,f=0;const p=P.tabSize||4;for(;b<E.length;){const d=E.charAt(b);if(d===" ")f++;else if(d==="	")f+=p;else break;b++}return Math.floor(f/p)}function R(E,P){for(let b=0;b<P.length;b++){const f=P.charAt(b);if(f==="\r")return b+1<P.length&&P.charAt(b+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=R;function C(E,P){return`\r
`.indexOf(E.charAt(P))!==-1}e.isEOL=C}),define(ne[70],ie([0,1,35,49]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(E,P,b){return T(E,P,void 0,b)}e.removeProperty=L;function T(E,P,b,f,p){const d=P.slice(),h=[],m=(0,k.parseTree)(E,h);let g,y;for(;d.length>0&&(y=d.pop(),g=(0,k.findNodeAtLocation)(m,d),g===void 0&&b!==void 0);)typeof y=="string"?b={[y]:b}:b=[b];if(g)if(g.type==="object"&&typeof y=="string"&&Array.isArray(g.children)){const w=(0,k.findNodeAtLocation)(g,[y]);if(w!==void 0)if(b===void 0){if(!w.parent)throw new Error("Malformed AST");const S=g.children.indexOf(w.parent);let l,i=w.parent.offset+w.parent.length;if(S>0){const c=g.children[S-1];l=c.offset+c.length}else l=g.offset+1,g.children.length>1&&(i=g.children[1].offset);return A(E,{offset:l,length:i-l,content:""},f)}else return A(E,{offset:w.offset,length:w.length,content:JSON.stringify(b)},f);else{if(b===void 0)return[];const S=`${JSON.stringify(y)}: ${JSON.stringify(b)}`,l=p?p(g.children.map(c=>c.children[0].value)):g.children.length;let i;if(l>0){const c=g.children[l-1];i={offset:c.offset+c.length,length:0,content:","+S}}else g.children.length===0?i={offset:g.offset+1,length:0,content:S}:i={offset:g.offset+1,length:0,content:S+","};return A(E,i,f)}}else if(g.type==="array"&&typeof y=="number"&&Array.isArray(g.children))if(b!==void 0){const w=`${JSON.stringify(b)}`;let S;if(g.children.length===0||y===0)S={offset:g.offset+1,length:0,content:g.children.length===0?w:w+","};else{const l=y===-1||y>g.children.length?g.children.length:y,i=g.children[l-1];S={offset:i.offset+i.length,length:0,content:","+w}}return A(E,S,f)}else{const w=y,S=g.children[w];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===w){const i=g.children[w-1],c=i.offset+i.length,r=g.offset+g.length;l={offset:c,length:r-2-c,content:""}}else l={offset:S.offset,length:g.children[w+1].offset-S.offset,content:""};return A(E,l,f)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${g.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return A(E,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(b)},f)}}e.setProperty=T;function A(E,P,b){let f=R(E,P),p=P.offset,d=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,t.isEOL)(f,p-1);)p--;for(;d<f.length&&!(0,t.isEOL)(f,d);)d++}const h=(0,t.format)(f,{offset:p,length:d-p},b);for(let g=h.length-1;g>=0;g--){const y=h[g];f=R(f,y),p=Math.min(p,y.offset),d=Math.max(d,y.offset+y.length),d+=y.content.length-y.length}const m=E.length-(f.length-d)-p;return[{offset:p,length:m,content:f.substring(p,d)}]}e.withFormatting=A;function R(E,P){return E.substring(0,P.offset)+P.content+E.substring(P.offset+P.length)}e.applyEdit=R;function C(E,P){let b=P.slice(0).sort((p,d)=>{const h=p.offset-d.offset;return h===0?p.length-d.length:h}),f=E.length;for(let p=b.length-1;p>=0;p--){let d=b[p];if(d.offset+d.length<=f)E=R(E,d);else throw new Error("Overlapping edit");f=d.offset}return E}e.applyEdits=C}),define(ne[100],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new k(()=>L(this.getValue()))}}e.Lazy=k}),define(ne[2],ie([0,1,69,55]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(n){T=n}if(e.setDisposableTracker=A,L){const n="__is_disposable_tracked__";A(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[n]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==y.None)try{s[n]=!0}catch{}}markAsDisposed(s){if(s&&s!==y.None)try{s[n]=!0}catch{}}markAsSingleton(s){}})}function R(n){return T?.trackDisposable(n),n}function C(n){T?.markAsDisposed(n)}function E(n,s){T?.setParent(n,s)}function P(n,s){if(!!T)for(const o of n)T.setParent(o,s)}function b(n){return T?.markAsSingleton(n),n}e.markAsSingleton=b;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function p(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=p;function d(n){if(t.Iterable.is(n)){let s=[];for(const o of n)if(o)try{o.dispose()}catch(a){s.push(a)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=d;function h(...n){const s=m(()=>d(n));return P(n,s),s}e.combinedDisposable=h;function m(n){const s=R({dispose:(0,k.once)(()=>{C(s),n()})});return s}e.toDisposable=m;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return E(s,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new g,R(this),E(this._store,this)}dispose(){C(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&E(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&E(s,null),s}}e.MutableDisposable=w;class S{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=S;class l{constructor(){this.references=new Map}acquire(s,...o){let a=this.references.get(s);a||(a={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,a));const{object:u}=a,v=(0,k.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(s,a.object),this.references.delete(s))});return a.counter++,{object:u,dispose:v}}}e.ReferenceCollection=l;class i{constructor(s){this.referenceCollection=s}async acquire(s,...o){const a=this.referenceCollection.acquire(s,...o);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(u){throw a.dispose(),u}}}e.AsyncReferenceCollection=i;class c{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=c;function r(n){const s=new g;try{n(s)}finally{s.dispose()}}e.disposeOnReturn=r}),define(ne[101],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(T){this.element=T,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class t{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let T=this._first;for(;T!==k.Undefined;){const A=T.next;T.prev=k.Undefined,T.next=k.Undefined,T=A}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const R=new k(T);if(this._first===k.Undefined)this._first=R,this._last=R;else if(A){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(R))}}shift(){if(this._first!==k.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==k.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==k.Undefined&&T.next!==k.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===k.Undefined&&T.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):T.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):T.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==k.Undefined;)yield T.element,T=T.next}}e.LinkedList=t}),function(){function Y(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(C){T.push(C,Date.now())}function R(){const C=[];for(let E=0;E<T.length;E+=2)C.push({name:T[E],startTime:T[E+1]});return C}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function k(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=k(t))}(),define(ne[4],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let t=!1,L=!1,T=!1,A=!1,R=!1,C=!1,E=!1,P=!1,b,f=k,p,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const m=typeof h?.versions?.electron=="string",g=m&&h?.type==="renderer";if(e.isElectronSandboxed=g&&h?.sandboxed,typeof navigator=="object"&&!g)d=navigator.userAgent,t=d.indexOf("Windows")>=0,L=d.indexOf("Macintosh")>=0,P=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=d.indexOf("Linux")>=0,C=!0,b=navigator.language,f=b;else if(typeof h=="object"){t=h.platform==="win32",L=h.platform==="darwin",T=h.platform==="linux",A=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,E=m,b=k,f=k;const s=h.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),a=o.availableLanguages["*"];b=o.locale,f=a||k,p=o._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var y;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function w(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let S=0;L?S=1:t?S=3:T&&(S=2),e.isWindows=t,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=A,e.isNative=R,e.isElectron=E,e.isWeb=C,e.isIOS=P,e.platform=S,e.userAgent=d,e.language=f;var l;(function(s){function o(){return e.language}s.value=o;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=a;function u(){return e.language==="en"}s.isDefault=u})(l=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=p,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let u=0,v=s.length;u<v;u++){const I=s[u];if(I.id===a.data.vscodeScheduleAsyncWork){s.splice(u,1),I.callback();return}}});let o=0;return a=>{const u=++o;s.push({id:u,callback:a}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||P?2:t?1:3;let c=!0,r=!1;function n(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,c=new Uint16Array(s.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[33],ie([0,1,4]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const L=k.globals.vscode.process;t={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ne[10],ie([0,1,33]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,L=97,T=90,A=122,R=46,C=47,E=92,P=58,b=63;class f extends Error{constructor(S,l,i){let c;typeof l=="string"&&l.indexOf("not ")===0?(c="must not be",l=l.replace(/^not /,"")):c="must be";const r=S.indexOf(".")!==-1?"property":"argument";let n=`The "${S}" ${r} ${c} of type ${l}`;n+=`. Received type ${typeof i}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function p(w,S){if(typeof w!="string")throw new f(S,"string",w)}function d(w){return w===C||w===E}function h(w){return w===C}function m(w){return w>=t&&w<=T||w>=L&&w<=A}function g(w,S,l,i){let c="",r=0,n=-1,s=0,o=0;for(let a=0;a<=w.length;++a){if(a<w.length)o=w.charCodeAt(a);else{if(i(o))break;o=C}if(i(o)){if(!(n===a-1||s===1))if(s===2){if(c.length<2||r!==2||c.charCodeAt(c.length-1)!==R||c.charCodeAt(c.length-2)!==R){if(c.length>2){const u=c.lastIndexOf(l);u===-1?(c="",r=0):(c=c.slice(0,u),r=c.length-1-c.lastIndexOf(l)),n=a,s=0;continue}else if(c.length!==0){c="",r=0,n=a,s=0;continue}}S&&(c+=c.length>0?`${l}..`:"..",r=2)}else c.length>0?c+=`${l}${w.slice(n+1,a)}`:c=w.slice(n+1,a),r=a-n-1;n=a,s=0}else o===R&&s!==-1?++s:s=-1}return c}function y(w,S){if(S===null||typeof S!="object")throw new f("pathObject","Object",S);const l=S.dir||S.root,i=S.base||`${S.name||""}${S.ext||""}`;return l?l===S.root?`${l}${i}`:`${l}${w}${i}`:i}e.win32={resolve(...w){let S="",l="",i=!1;for(let c=w.length-1;c>=-1;c--){let r;if(c>=0){if(r=w[c],p(r,"path"),r.length===0)continue}else S.length===0?r=k.cwd():(r=k.env[`=${S}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==S.toLowerCase()&&r.charCodeAt(2)===E)&&(r=`${S}\\`));const n=r.length;let s=0,o="",a=!1;const u=r.charCodeAt(0);if(n===1)d(u)&&(s=1,a=!0);else if(d(u))if(a=!0,d(r.charCodeAt(1))){let v=2,I=v;for(;v<n&&!d(r.charCodeAt(v));)v++;if(v<n&&v!==I){const _=r.slice(I,v);for(I=v;v<n&&d(r.charCodeAt(v));)v++;if(v<n&&v!==I){for(I=v;v<n&&!d(r.charCodeAt(v));)v++;(v===n||v!==I)&&(o=`\\\\${_}\\${r.slice(I,v)}`,s=v)}}}else s=1;else m(u)&&r.charCodeAt(1)===P&&(o=r.slice(0,2),s=2,n>2&&d(r.charCodeAt(2))&&(a=!0,s=3));if(o.length>0)if(S.length>0){if(o.toLowerCase()!==S.toLowerCase())continue}else S=o;if(i){if(S.length>0)break}else if(l=`${r.slice(s)}\\${l}`,i=a,a&&S.length>0)break}return l=g(l,!i,"\\",d),i?`${S}\\${l}`:`${S}${l}`||"."},normalize(w){p(w,"path");const S=w.length;if(S===0)return".";let l=0,i,c=!1;const r=w.charCodeAt(0);if(S===1)return h(r)?"\\":w;if(d(r))if(c=!0,d(w.charCodeAt(1))){let s=2,o=s;for(;s<S&&!d(w.charCodeAt(s));)s++;if(s<S&&s!==o){const a=w.slice(o,s);for(o=s;s<S&&d(w.charCodeAt(s));)s++;if(s<S&&s!==o){for(o=s;s<S&&!d(w.charCodeAt(s));)s++;if(s===S)return`\\\\${a}\\${w.slice(o)}\\`;s!==o&&(i=`\\\\${a}\\${w.slice(o,s)}`,l=s)}}}else l=1;else m(r)&&w.charCodeAt(1)===P&&(i=w.slice(0,2),l=2,S>2&&d(w.charCodeAt(2))&&(c=!0,l=3));let n=l<S?g(w.slice(l),!c,"\\",d):"";return n.length===0&&!c&&(n="."),n.length>0&&d(w.charCodeAt(S-1))&&(n+="\\"),i===void 0?c?`\\${n}`:n:c?`${i}\\${n}`:`${i}${n}`},isAbsolute(w){p(w,"path");const S=w.length;if(S===0)return!1;const l=w.charCodeAt(0);return d(l)||S>2&&m(l)&&w.charCodeAt(1)===P&&d(w.charCodeAt(2))},join(...w){if(w.length===0)return".";let S,l;for(let r=0;r<w.length;++r){const n=w[r];p(n,"path"),n.length>0&&(S===void 0?S=l=n:S+=`\\${n}`)}if(S===void 0)return".";let i=!0,c=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++c;const r=l.length;r>1&&d(l.charCodeAt(1))&&(++c,r>2&&(d(l.charCodeAt(2))?++c:i=!1))}if(i){for(;c<S.length&&d(S.charCodeAt(c));)c++;c>=2&&(S=`\\${S.slice(c)}`)}return e.win32.normalize(S)},relative(w,S){if(p(w,"from"),p(S,"to"),w===S)return"";const l=e.win32.resolve(w),i=e.win32.resolve(S);if(l===i||(w=l.toLowerCase(),S=i.toLowerCase(),w===S))return"";let c=0;for(;c<w.length&&w.charCodeAt(c)===E;)c++;let r=w.length;for(;r-1>c&&w.charCodeAt(r-1)===E;)r--;const n=r-c;let s=0;for(;s<S.length&&S.charCodeAt(s)===E;)s++;let o=S.length;for(;o-1>s&&S.charCodeAt(o-1)===E;)o--;const a=o-s,u=n<a?n:a;let v=-1,I=0;for(;I<u;I++){const O=w.charCodeAt(c+I);if(O!==S.charCodeAt(s+I))break;O===E&&(v=I)}if(I!==u){if(v===-1)return i}else{if(a>u){if(S.charCodeAt(s+I)===E)return i.slice(s+I+1);if(I===2)return i.slice(s+I)}n>u&&(w.charCodeAt(c+I)===E?v=I:I===2&&(v=3)),v===-1&&(v=0)}let _="";for(I=c+v+1;I<=r;++I)(I===r||w.charCodeAt(I)===E)&&(_+=_.length===0?"..":"\\..");return s+=v,_.length>0?`${_}${i.slice(s,o)}`:(i.charCodeAt(s)===E&&++s,i.slice(s,o))},toNamespacedPath(w){if(typeof w!="string")return w;if(w.length===0)return"";const S=e.win32.resolve(w);if(S.length<=2)return w;if(S.charCodeAt(0)===E){if(S.charCodeAt(1)===E){const l=S.charCodeAt(2);if(l!==b&&l!==R)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(m(S.charCodeAt(0))&&S.charCodeAt(1)===P&&S.charCodeAt(2)===E)return`\\\\?\\${S}`;return w},dirname(w){p(w,"path");const S=w.length;if(S===0)return".";let l=-1,i=0;const c=w.charCodeAt(0);if(S===1)return d(c)?w:".";if(d(c)){if(l=i=1,d(w.charCodeAt(1))){let s=2,o=s;for(;s<S&&!d(w.charCodeAt(s));)s++;if(s<S&&s!==o){for(o=s;s<S&&d(w.charCodeAt(s));)s++;if(s<S&&s!==o){for(o=s;s<S&&!d(w.charCodeAt(s));)s++;if(s===S)return w;s!==o&&(l=i=s+1)}}}}else m(c)&&w.charCodeAt(1)===P&&(l=S>2&&d(w.charCodeAt(2))?3:2,i=l);let r=-1,n=!0;for(let s=S-1;s>=i;--s)if(d(w.charCodeAt(s))){if(!n){r=s;break}}else n=!1;if(r===-1){if(l===-1)return".";r=l}return w.slice(0,r)},basename(w,S){S!==void 0&&p(S,"ext"),p(w,"path");let l=0,i=-1,c=!0,r;if(w.length>=2&&m(w.charCodeAt(0))&&w.charCodeAt(1)===P&&(l=2),S!==void 0&&S.length>0&&S.length<=w.length){if(S===w)return"";let n=S.length-1,s=-1;for(r=w.length-1;r>=l;--r){const o=w.charCodeAt(r);if(d(o)){if(!c){l=r+1;break}}else s===-1&&(c=!1,s=r+1),n>=0&&(o===S.charCodeAt(n)?--n==-1&&(i=r):(n=-1,i=s))}return l===i?i=s:i===-1&&(i=w.length),w.slice(l,i)}for(r=w.length-1;r>=l;--r)if(d(w.charCodeAt(r))){if(!c){l=r+1;break}}else i===-1&&(c=!1,i=r+1);return i===-1?"":w.slice(l,i)},extname(w){p(w,"path");let S=0,l=-1,i=0,c=-1,r=!0,n=0;w.length>=2&&w.charCodeAt(1)===P&&m(w.charCodeAt(0))&&(S=i=2);for(let s=w.length-1;s>=S;--s){const o=w.charCodeAt(s);if(d(o)){if(!r){i=s+1;break}continue}c===-1&&(r=!1,c=s+1),o===R?l===-1?l=s:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||c===-1||n===0||n===1&&l===c-1&&l===i+1?"":w.slice(l,c)},format:y.bind(null,"\\"),parse(w){p(w,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return S;const l=w.length;let i=0,c=w.charCodeAt(0);if(l===1)return d(c)?(S.root=S.dir=w,S):(S.base=S.name=w,S);if(d(c)){if(i=1,d(w.charCodeAt(1))){let v=2,I=v;for(;v<l&&!d(w.charCodeAt(v));)v++;if(v<l&&v!==I){for(I=v;v<l&&d(w.charCodeAt(v));)v++;if(v<l&&v!==I){for(I=v;v<l&&!d(w.charCodeAt(v));)v++;v===l?i=v:v!==I&&(i=v+1)}}}}else if(m(c)&&w.charCodeAt(1)===P){if(l<=2)return S.root=S.dir=w,S;if(i=2,d(w.charCodeAt(2))){if(l===3)return S.root=S.dir=w,S;i=3}}i>0&&(S.root=w.slice(0,i));let r=-1,n=i,s=-1,o=!0,a=w.length-1,u=0;for(;a>=i;--a){if(c=w.charCodeAt(a),d(c)){if(!o){n=a+1;break}continue}s===-1&&(o=!1,s=a+1),c===R?r===-1?r=a:u!==1&&(u=1):r!==-1&&(u=-1)}return s!==-1&&(r===-1||u===0||u===1&&r===s-1&&r===n+1?S.base=S.name=w.slice(n,s):(S.name=w.slice(n,r),S.base=w.slice(n,s),S.ext=w.slice(r,s))),n>0&&n!==i?S.dir=w.slice(0,n-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...w){let S="",l=!1;for(let i=w.length-1;i>=-1&&!l;i--){const c=i>=0?w[i]:k.cwd();p(c,"path"),c.length!==0&&(S=`${c}/${S}`,l=c.charCodeAt(0)===C)}return S=g(S,!l,"/",h),l?`/${S}`:S.length>0?S:"."},normalize(w){if(p(w,"path"),w.length===0)return".";const S=w.charCodeAt(0)===C,l=w.charCodeAt(w.length-1)===C;return w=g(w,!S,"/",h),w.length===0?S?"/":l?"./":".":(l&&(w+="/"),S?`/${w}`:w)},isAbsolute(w){return p(w,"path"),w.length>0&&w.charCodeAt(0)===C},join(...w){if(w.length===0)return".";let S;for(let l=0;l<w.length;++l){const i=w[l];p(i,"path"),i.length>0&&(S===void 0?S=i:S+=`/${i}`)}return S===void 0?".":e.posix.normalize(S)},relative(w,S){if(p(w,"from"),p(S,"to"),w===S||(w=e.posix.resolve(w),S=e.posix.resolve(S),w===S))return"";const l=1,i=w.length,c=i-l,r=1,n=S.length-r,s=c<n?c:n;let o=-1,a=0;for(;a<s;a++){const v=w.charCodeAt(l+a);if(v!==S.charCodeAt(r+a))break;v===C&&(o=a)}if(a===s)if(n>s){if(S.charCodeAt(r+a)===C)return S.slice(r+a+1);if(a===0)return S.slice(r+a)}else c>s&&(w.charCodeAt(l+a)===C?o=a:a===0&&(o=0));let u="";for(a=l+o+1;a<=i;++a)(a===i||w.charCodeAt(a)===C)&&(u+=u.length===0?"..":"/..");return`${u}${S.slice(r+o)}`},toNamespacedPath(w){return w},dirname(w){if(p(w,"path"),w.length===0)return".";const S=w.charCodeAt(0)===C;let l=-1,i=!0;for(let c=w.length-1;c>=1;--c)if(w.charCodeAt(c)===C){if(!i){l=c;break}}else i=!1;return l===-1?S?"/":".":S&&l===1?"//":w.slice(0,l)},basename(w,S){S!==void 0&&p(S,"ext"),p(w,"path");let l=0,i=-1,c=!0,r;if(S!==void 0&&S.length>0&&S.length<=w.length){if(S===w)return"";let n=S.length-1,s=-1;for(r=w.length-1;r>=0;--r){const o=w.charCodeAt(r);if(o===C){if(!c){l=r+1;break}}else s===-1&&(c=!1,s=r+1),n>=0&&(o===S.charCodeAt(n)?--n==-1&&(i=r):(n=-1,i=s))}return l===i?i=s:i===-1&&(i=w.length),w.slice(l,i)}for(r=w.length-1;r>=0;--r)if(w.charCodeAt(r)===C){if(!c){l=r+1;break}}else i===-1&&(c=!1,i=r+1);return i===-1?"":w.slice(l,i)},extname(w){p(w,"path");let S=-1,l=0,i=-1,c=!0,r=0;for(let n=w.length-1;n>=0;--n){const s=w.charCodeAt(n);if(s===C){if(!c){l=n+1;break}continue}i===-1&&(c=!1,i=n+1),s===R?S===-1?S=n:r!==1&&(r=1):S!==-1&&(r=-1)}return S===-1||i===-1||r===0||r===1&&S===i-1&&S===l+1?"":w.slice(S,i)},format:y.bind(null,"/"),parse(w){p(w,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return S;const l=w.charCodeAt(0)===C;let i;l?(S.root="/",i=1):i=0;let c=-1,r=0,n=-1,s=!0,o=w.length-1,a=0;for(;o>=i;--o){const u=w.charCodeAt(o);if(u===C){if(!s){r=o+1;break}continue}n===-1&&(s=!1,n=o+1),u===R?c===-1?c=o:a!==1&&(a=1):c!==-1&&(a=-1)}if(n!==-1){const u=r===0&&l?1:r;c===-1||a===0||a===1&&c===n-1&&c===r+1?S.base=S.name=w.slice(u,n):(S.name=w.slice(u,c),S.base=w.slice(u,n),S.ext=w.slice(c,n))}return r>0?S.dir=w.slice(0,r-1):l&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[102],ie([0,1,10]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(b){const f=(0,k.extname)(b),p=L[f.toLowerCase()];return p!==void 0?p:R(b)}e.getMediaOrTextMime=A;function R(b){const f=(0,k.extname)(b);return T[f.toLowerCase()]}e.getMediaMime=R;function C(b){for(const f in T)if(T[f]===b)return f}e.getExtensionForMimeType=C;const E=/^(.+)\/(.+?)(;.+)?$/;function P(b,f){const p=E.exec(b);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:f?void 0:b}e.normalizeMimeType=P}),define(ne[103],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var t;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(T,...A){const R=A.reduce((P,b)=>(P[b]=!0,P),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(P=>!R[P]).forEach(P=>{for(let b=0;b<C.length;b++)if(P.search(C[b])!==-1){delete T[P];break}})}e.sanitizeProcessEnvironment=L}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var t in k)(typeof exports=="object"?exports:Y)[t]=k[t]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function k(t){if(e[t])return e[t].exports;var L=e[t]={i:t,l:!1,exports:{}};return Y[t].call(L.exports,L,L.exports,k),L.l=!0,L.exports}return k.m=Y,k.c=e,k.d=function(t,L,T){k.o(t,L)||Object.defineProperty(t,L,{enumerable:!0,get:T})},k.r=function(t){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},k.t=function(t,L){if(1&L&&(t=k(t)),8&L||4&L&&typeof t=="object"&&t&&t.__esModule)return t;var T=Object.create(null);if(k.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:t}),2&L&&typeof t!="string")for(var A in t)k.d(T,A,function(R){return t[R]}.bind(null,A));return T},k.n=function(t){var L=t&&t.__esModule?function(){return t.default}:function(){return t};return k.d(L,"a",L),L},k.o=function(t,L){return Object.prototype.hasOwnProperty.call(t,L)},k.p="",k(k.s=0)}([function(Y,e,k){(function(t){var L;e=Y.exports=N,L=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],E=0,P=E++;C[P]="0|[1-9]\\d*";var b=E++;C[b]="[0-9]+";var f=E++;C[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=E++;C[p]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var d=E++;C[d]="("+C[b]+")\\.("+C[b]+")\\.("+C[b]+")";var h=E++;C[h]="(?:"+C[P]+"|"+C[f]+")";var m=E++;C[m]="(?:"+C[b]+"|"+C[f]+")";var g=E++;C[g]="(?:-("+C[h]+"(?:\\."+C[h]+")*))";var y=E++;C[y]="(?:-?("+C[m]+"(?:\\."+C[m]+")*))";var w=E++;C[w]="[0-9A-Za-z-]+";var S=E++;C[S]="(?:\\+("+C[w]+"(?:\\."+C[w]+")*))";var l=E++,i="v?"+C[p]+C[g]+"?"+C[S]+"?";C[l]="^"+i+"$";var c="[v=\\s]*"+C[d]+C[y]+"?"+C[S]+"?",r=E++;C[r]="^"+c+"$";var n=E++;C[n]="((?:<|>)?=?)";var s=E++;C[s]=C[b]+"|x|X|\\*";var o=E++;C[o]=C[P]+"|x|X|\\*";var a=E++;C[a]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[g]+")?"+C[S]+"?)?)?";var u=E++;C[u]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[y]+")?"+C[S]+"?)?)?";var v=E++;C[v]="^"+C[n]+"\\s*"+C[a]+"$";var I=E++;C[I]="^"+C[n]+"\\s*"+C[u]+"$";var _=E++;C[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;C[O]="(?:~>?)";var M=E++;C[M]="(\\s*)"+C[O]+"\\s+",R[M]=new RegExp(C[M],"g");var D=E++;C[D]="^"+C[O]+C[a]+"$";var U=E++;C[U]="^"+C[O]+C[u]+"$";var F=E++;C[F]="(?:\\^)";var x=E++;C[x]="(\\s*)"+C[F]+"\\s+",R[x]=new RegExp(C[x],"g");var q=E++;C[q]="^"+C[F]+C[a]+"$";var G=E++;C[G]="^"+C[F]+C[u]+"$";var te=E++;C[te]="^"+C[n]+"\\s*("+c+")$|^$";var W=E++;C[W]="^"+C[n]+"\\s*("+i+")$|^$";var j=E++;C[j]="(\\s*)"+C[n]+"\\s*("+c+"|"+C[a]+")",R[j]=new RegExp(C[j],"g");var J=E++;C[J]="^\\s*("+C[a]+")\\s+-\\s+("+C[a]+")\\s*$";var H=E++;C[H]="^\\s*("+C[u]+")\\s+-\\s+("+C[u]+")\\s*$";var Q=E++;C[Q]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)L(Z,C[Z]),R[Z]||(R[Z]=new RegExp(C[Z]));function B(re,ce){if(re instanceof N)return re;if(typeof re!="string"||re.length>T||!(ce?R[r]:R[l]).test(re))return null;try{return new N(re,ce)}catch{return null}}function N(re,ce){if(re instanceof N){if(re.loose===ce)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof N))return new N(re,ce);L("SemVer",re,ce),this.loose=ce;var ue=re.trim().match(ce?R[r]:R[l]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(we){if(/^[0-9]+$/.test(we)){var Ee=+we;if(Ee>=0&&Ee<A)return Ee}return we}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=B,e.valid=function(re,ce){var ue=B(re,ce);return ue?ue.version:null},e.clean=function(re,ce){var ue=B(re.trim().replace(/^[=v]+/,""),ce);return ue?ue.version:null},e.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(re){return L("SemVer.compare",this.version,this.loose,re),re instanceof N||(re=new N(re,this.loose)),this.compareMain(re)||this.comparePre(re)},N.prototype.compareMain=function(re){return re instanceof N||(re=new N(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},N.prototype.comparePre=function(re){if(re instanceof N||(re=new N(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ce=0;do{var ue=this.prerelease[ce],we=re.prerelease[ce];if(L("prerelease compare",ce,ue,we),ue===void 0&&we===void 0)return 0;if(we===void 0)return 1;if(ue===void 0)return-1;if(ue!==we)return z(ue,we)}while(++ce)},N.prototype.inc=function(re,ce){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ce,ue,we){typeof ue=="string"&&(we=ue,ue=void 0);try{return new N(re,ue).inc(ce,we).version}catch{return null}},e.diff=function(re,ce){if(ae(re,ce))return null;var ue=B(re),we=B(ce);if(ue.prerelease.length||we.prerelease.length){for(var Ee in ue)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ue[Ee]!==we[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in ue)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ue[Ee]!==we[Ee])return Ee},e.compareIdentifiers=z;var $=/^[0-9]+$/;function z(re,ce){var ue=$.test(re),we=$.test(ce);return ue&&we&&(re=+re,ce=+ce),ue&&!we?-1:we&&!ue?1:re<ce?-1:re>ce?1:0}function V(re,ce,ue){return new N(re,ue).compare(new N(ce,ue))}function ee(re,ce,ue){return V(re,ce,ue)>0}function se(re,ce,ue){return V(re,ce,ue)<0}function ae(re,ce,ue){return V(re,ce,ue)===0}function de(re,ce,ue){return V(re,ce,ue)!==0}function ve(re,ce,ue){return V(re,ce,ue)>=0}function be(re,ce,ue){return V(re,ce,ue)<=0}function Se(re,ce,ue,we){var Ee;switch(ce){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ee=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ee=re!==ue;break;case"":case"=":case"==":Ee=ae(re,ue,we);break;case"!=":Ee=de(re,ue,we);break;case">":Ee=ee(re,ue,we);break;case">=":Ee=ve(re,ue,we);break;case"<":Ee=se(re,ue,we);break;case"<=":Ee=be(re,ue,we);break;default:throw new TypeError("Invalid operator: "+ce)}return Ee}function pe(re,ce){if(re instanceof pe){if(re.loose===ce)return re;re=re.value}if(!(this instanceof pe))return new pe(re,ce);L("comparator",re,ce),this.loose=ce,this.parse(re),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(re,ce){return z(ce,re)},e.major=function(re,ce){return new N(re,ce).major},e.minor=function(re,ce){return new N(re,ce).minor},e.patch=function(re,ce){return new N(re,ce).patch},e.compare=V,e.compareLoose=function(re,ce){return V(re,ce,!0)},e.rcompare=function(re,ce,ue){return V(ce,re,ue)},e.sort=function(re,ce){return re.sort(function(ue,we){return e.compare(ue,we,ce)})},e.rsort=function(re,ce){return re.sort(function(ue,we){return e.rcompare(ue,we,ce)})},e.gt=ee,e.lt=se,e.eq=ae,e.neq=de,e.gte=ve,e.lte=be,e.cmp=Se,e.Comparator=pe;var Ie={};function Ce(re,ce){if(re instanceof Ce)return re.loose===ce?re:new Ce(re.raw,ce);if(re instanceof pe)return new Ce(re.value,ce);if(!(this instanceof Ce))return new Ce(re,ce);if(this.loose=ce,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function De(re){return!re||re.toLowerCase()==="x"||re==="*"}function Ue(re,ce,ue,we,Ee,Fe,Te,Oe,_e,X,oe,le,fe){return((ce=De(ue)?"":De(we)?">="+ue+".0.0":De(Ee)?">="+ue+"."+we+".0":">="+ce)+" "+(Oe=De(_e)?"":De(X)?"<"+(+_e+1)+".0.0":De(oe)?"<"+_e+"."+(+X+1)+".0":le?"<="+_e+"."+X+"."+oe+"-"+le:"<="+Oe)).trim()}function je(re,ce){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ce))return!1;if(ce.prerelease.length){for(ue=0;ue<re.length;ue++)if(L(re[ue].semver),re[ue].semver!==Ie&&re[ue].semver.prerelease.length>0){var we=re[ue].semver;if(we.major===ce.major&&we.minor===ce.minor&&we.patch===ce.patch)return!0}return!1}return!0}function Ge(re,ce,ue){try{ce=new Ce(ce,ue)}catch{return!1}return ce.test(re)}function Be(re,ce,ue,we){var Ee,Fe,Te,Oe,_e;switch(re=new N(re,we),ce=new Ce(ce,we),ue){case">":Ee=ee,Fe=be,Te=se,Oe=">",_e=">=";break;case"<":Ee=se,Fe=ve,Te=ee,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ge(re,ce,we))return!1;for(var X=0;X<ce.set.length;++X){var oe=ce.set[X],le=null,fe=null;if(oe.forEach(function(ge){ge.semver===Ie&&(ge=new pe(">=0.0.0")),le=le||ge,fe=fe||ge,Ee(ge.semver,le.semver,we)?le=ge:Te(ge.semver,fe.semver,we)&&(fe=ge)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&Fe(re,fe.semver)||fe.operator===_e&&Te(re,fe.semver))return!1}return!0}pe.prototype.parse=function(re){var ce=this.loose?R[te]:R[W],ue=re.match(ce);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new N(ue[2],this.loose):this.semver=Ie},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(re){return L("Comparator.test",re,this.loose),this.semver===Ie||(typeof re=="string"&&(re=new N(re,this.loose)),Se(re,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(re,ce){if(!(re instanceof pe))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ce(re.value,ce),Ge(this.value,ue,ce);if(re.operator==="")return ue=new Ce(this.value,ce),Ge(re.semver,ue,ce);var we=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Fe=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=Se(this.semver,"<",re.semver,ce)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=Se(this.semver,">",re.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return we||Ee||Fe&&Te||Oe||_e},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(re){var ce=this.loose;re=re.trim(),L("range",re,ce);var ue=ce?R[H]:R[J];re=re.replace(ue,Ue),L("hyphen replace",re),re=re.replace(R[j],"$1$2$3"),L("comparator trim",re,R[j]),re=(re=(re=re.replace(R[M],"$1~")).replace(R[x],"$1^")).split(/\s+/).join(" ");var we=ce?R[te]:R[W],Ee=re.split(" ").map(function(Fe){return function(Te,Oe){return L("comp",Te),Te=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){L("caret",le,fe);var ge=fe?R[G]:R[q];return le.replace(ge,function(Le,ye,Re,ke,Pe){var Ae;return L("caret",le,Le,ye,Re,ke,Pe),De(ye)?Ae="":De(Re)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":De(ke)?Ae=ye==="0"?">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+".0 <"+(+ye+1)+".0.0":Pe?(L("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+Re+"."+(+ke+1):">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+ke+Pe+" <"+(+ye+1)+".0.0"):(L("no pr"),Ae=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+ke+" <"+ye+"."+Re+"."+(+ke+1):">="+ye+"."+Re+"."+ke+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+ke+" <"+(+ye+1)+".0.0"),L("caret return",Ae),Ae})}(oe,X)}).join(" ")}(Te,Oe),L("caret",Te),Te=function(_e,X){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var ge=fe?R[U]:R[D];return le.replace(ge,function(Le,ye,Re,ke,Pe){var Ae;return L("tilde",le,Le,ye,Re,ke,Pe),De(ye)?Ae="":De(Re)?Ae=">="+ye+".0.0 <"+(+ye+1)+".0.0":De(ke)?Ae=">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":Pe?(L("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Ae=">="+ye+"."+Re+"."+ke+Pe+" <"+ye+"."+(+Re+1)+".0"):Ae=">="+ye+"."+Re+"."+ke+" <"+ye+"."+(+Re+1)+".0",L("tilde return",Ae),Ae})}(oe,X)}).join(" ")}(Te,Oe),L("tildes",Te),Te=function(_e,X){return L("replaceXRanges",_e,X),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var ge=fe?R[I]:R[v];return le.replace(ge,function(Le,ye,Re,ke,Pe,Ae){L("xRange",le,Le,ye,Re,ke,Pe,Ae);var Ne=De(Re),qe=Ne||De(ke),We=qe||De(Pe);return ye==="="&&We&&(ye=""),Ne?Le=ye===">"||ye==="<"?"<0.0.0":"*":ye&&We?(qe&&(ke=0),We&&(Pe=0),ye===">"?(ye=">=",qe?(Re=+Re+1,ke=0,Pe=0):We&&(ke=+ke+1,Pe=0)):ye==="<="&&(ye="<",qe?Re=+Re+1:ke=+ke+1),Le=ye+Re+"."+ke+"."+Pe):qe?Le=">="+Re+".0.0 <"+(+Re+1)+".0.0":We&&(Le=">="+Re+"."+ke+".0 <"+Re+"."+(+ke+1)+".0"),L("xRange return",Le),Le})}(oe,X)}).join(" ")}(Te,Oe),L("xrange",Te),Te=function(_e,X){return L("replaceStars",_e,X),_e.trim().replace(R[Q],"")}(Te,Oe),L("stars",Te),Te}(Fe,ce)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Fe){return!!Fe.match(we)})),Ee=Ee.map(function(Fe){return new pe(Fe,ce)})},Ce.prototype.intersects=function(re,ce){if(!(re instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(we){return re.set.some(function(Ee){return Ee.every(function(Fe){return we.intersects(Fe,ce)})})})})},e.toComparators=function(re,ce){return new Ce(re,ce).set.map(function(ue){return ue.map(function(we){return we.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new N(re,this.loose));for(var ce=0;ce<this.set.length;ce++)if(je(this.set[ce],re))return!0;return!1},e.satisfies=Ge,e.maxSatisfying=function(re,ce,ue){var we=null,Ee=null;try{var Fe=new Ce(ce,ue)}catch{return null}return re.forEach(function(Te){Fe.test(Te)&&(we&&Ee.compare(Te)!==-1||(Ee=new N(we=Te,ue)))}),we},e.minSatisfying=function(re,ce,ue){var we=null,Ee=null;try{var Fe=new Ce(ce,ue)}catch{return null}return re.forEach(function(Te){Fe.test(Te)&&(we&&Ee.compare(Te)!==1||(Ee=new N(we=Te,ue)))}),we},e.validRange=function(re,ce){try{return new Ce(re,ce).range||"*"}catch{return null}},e.ltr=function(re,ce,ue){return Be(re,ce,"<",ue)},e.gtr=function(re,ce,ue){return Be(re,ce,">",ue)},e.outside=Be,e.prerelease=function(re,ce){var ue=B(re,ce);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ce,ue){return re=new Ce(re,ue),ce=new Ce(ce,ue),re.intersects(ce)},e.coerce=function(re){if(re instanceof N)return re;if(typeof re!="string")return null;var ce=re.match(R[_]);return ce==null?null:B((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,k(1))},function(Y,e){var k,t,L=Y.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(m){if(k===setTimeout)return setTimeout(m,0);if((k===T||!k)&&setTimeout)return k=setTimeout,setTimeout(m,0);try{return k(m,0)}catch{try{return k.call(null,m,0)}catch{return k.call(this,m,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:T}catch{k=T}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var C,E=[],P=!1,b=-1;function f(){P&&C&&(P=!1,C.length?E=C.concat(E):b=-1,E.length&&p())}function p(){if(!P){var m=R(f);P=!0;for(var g=E.length;g;){for(C=E,E=[];++b<g;)C&&C[b].run();b=-1,g=E.length}C=null,P=!1,function(y){if(t===clearTimeout)return clearTimeout(y);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(y);try{t(y)}catch{try{return t.call(null,y)}catch{return t.call(this,y)}}}(m)}}function d(m,g){this.fun=m,this.array=g}function h(){}L.nextTick=function(m){var g=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)g[y-1]=arguments[y];E.push(new d(m,g)),E.length!==1||P||R(p)},d.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=h,L.addListener=h,L.once=h,L.off=h,L.removeListener=h,L.removeAllListeners=h,L.emit=h,L.prependListener=h,L.prependOnceListener=h,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ne[104],ie([0,1]),function(Y,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(R,C,E){this.level=R,this.key=C,this.value=E,this.forward=[]}}const L=void 0;class T{constructor(R,C=2**16){this.comparator=R,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new t(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,L,L)}has(R){return Boolean(T._search(this,R,this.comparator))}get(R){return T._search(this,R,this.comparator)?.value}set(R,C){return T._insert(this,R,C,this.comparator)&&(this._size+=1),this}delete(R){const C=T._delete(this,R,this.comparator);return C&&(this._size-=1),C}forEach(R,C){let E=this._header.forward[0];for(;E;)R.call(C,E.value,E.key,this),E=E.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this._header.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static _search(R,C,E){let P=R._header;for(let b=R._level-1;b>=0;b--)for(;P.forward[b]&&E(P.forward[b].key,C)<0;)P=P.forward[b];if(P=P.forward[0],P&&E(P.key,C)===0)return P}static _insert(R,C,E,P){let b=[],f=R._header;for(let p=R._level-1;p>=0;p--){for(;f.forward[p]&&P(f.forward[p].key,C)<0;)f=f.forward[p];b[p]=f}if(f=f.forward[0],f&&P(f.key,C)===0)return f.value=E,!1;{let p=T._randomLevel(R);if(p>R._level){for(let d=R._level;d<p;d++)b[d]=R._header;R._level=p}f=new t(p,C,E);for(let d=0;d<p;d++)f.forward[d]=b[d].forward[d],b[d].forward[d]=f;return!0}}static _randomLevel(R,C=.5){let E=1;for(;Math.random()<C&&E<R._maxLevel;)E+=1;return E}static _delete(R,C,E){let P=[],b=R._header;for(let f=R._level-1;f>=0;f--){for(;b.forward[f]&&E(b.forward[f].key,C)<0;)b=b.forward[f];P[f]=b}if(b=b.forward[0],!b||E(b.key,C)!==0)return!1;for(let f=0;f<R._level&&P[f].forward[f]===b;f++)P[f].forward[f]=b.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=T}),define(ne[105],ie([0,1,4]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=k.globals.performance&&typeof k.globals.performance.now=="function";class L{constructor(A){this._highResolution=t&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=L}),define(ne[3],ie([0,1,9,69,2,101,105]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(S){S.None=()=>L.Disposable.None;function l(te){return(W,j=null,J)=>{let H=!1,Q;return Q=te(Z=>{if(!H)return Q?Q.dispose():H=!0,W.call(j,Z)},null,J),H&&Q.dispose(),Q}}S.once=l;function i(te,W){return a((j,J=null,H)=>te(Q=>j.call(J,W(Q)),null,H))}S.map=i;function c(te,W){return a((j,J=null,H)=>te(Q=>{W(Q),j.call(J,Q)},null,H))}S.forEach=c;function r(te,W){return a((j,J=null,H)=>te(Q=>W(Q)&&j.call(J,Q),null,H))}S.filter=r;function n(te){return te}S.signal=n;function s(...te){return(W,j=null,J)=>(0,L.combinedDisposable)(...te.map(H=>H(Q=>W.call(j,Q),null,J)))}S.any=s;function o(te,W,j){let J=j;return i(te,H=>(J=W(J,H),J))}S.reduce=o;function a(te){let W;const j=new f({onFirstListenerAdd(){W=te(j.fire,j)},onLastListenerRemove(){W.dispose()}});return j.event}function u(te,W,j,J=100,H=!1){let Q,Z,B=0;return te(N=>{B++,Q=j(Q,N),H&&!Z&&(W(Q),Q=void 0),clearTimeout(Z),Z=setTimeout(()=>{const $=Q;Q=void 0,Z=void 0,(!H||B>1)&&W($),B=0},J)})}S.debouncedListener=u;function v(te,W,j=100,J=!1,H){let Q,Z,B,N=0;const $=new f({leakWarningThreshold:H,onFirstListenerAdd(){Q=te(z=>{N++,Z=W(Z,z),J&&!B&&($.fire(Z),Z=void 0),clearTimeout(B),B=setTimeout(()=>{const V=Z;Z=void 0,B=void 0,(!J||N>1)&&$.fire(V),N=0},j)})},onLastListenerRemove(){Q.dispose()}});return $.event}S.debounce=v;function I(te,W=(j,J)=>j===J){let j=!0,J;return r(te,H=>{const Q=j||!W(H,J);return j=!1,J=H,Q})}S.latch=I;function _(te,W){return[S.filter(te,W),S.filter(te,j=>!W(j))]}S.split=_;function O(te,W=!1,j=[]){let J=j.slice(),H=te(B=>{J?J.push(B):Z.fire(B)});const Q=()=>{J&&J.forEach(B=>Z.fire(B)),J=null},Z=new f({onFirstListenerAdd(){H||(H=te(B=>Z.fire(B)))},onFirstListenerDidAdd(){J&&(W?setTimeout(Q):Q())},onLastListenerRemove(){H&&H.dispose(),H=null}});return Z.event}S.buffer=O;class M{constructor(W){this.event=W}map(W){return new M(i(this.event,W))}forEach(W){return new M(c(this.event,W))}filter(W){return new M(r(this.event,W))}reduce(W,j){return new M(o(this.event,W,j))}latch(){return new M(I(this.event))}debounce(W,j=100,J=!1,H){return new M(v(this.event,W,j,J,H))}on(W,j,J){return this.event(W,j,J)}once(W,j,J){return l(this.event)(W,j,J)}}function D(te){return new M(te)}S.chain=D;function U(te,W,j=J=>J){const J=(...B)=>Z.fire(j(...B)),H=()=>te.on(W,J),Q=()=>te.removeListener(W,J),Z=new f({onFirstListenerAdd:H,onLastListenerRemove:Q});return Z.event}S.fromNodeEventEmitter=U;function F(te,W,j=J=>J){const J=(...B)=>Z.fire(j(...B)),H=()=>te.addEventListener(W,J),Q=()=>te.removeEventListener(W,J),Z=new f({onFirstListenerAdd:H,onLastListenerRemove:Q});return Z.event}S.fromDOMEventEmitter=F;function x(te){return new Promise(W=>l(te)(W))}S.toPromise=x;function q(te,W){return W(void 0),te(j=>W(j))}S.runAndSubscribe=q;function G(te,W){let j=null;function J(Q){j?.dispose(),j=new L.DisposableStore,W(Q,j)}J(void 0);const H=te(Q=>J(Q));return(0,L.toDisposable)(()=>{H.dispose(),j?.dispose()})}S.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class C{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${C._idPool++}`}start(l){this._stopWatch=new A.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let E=-1;function P(S){const l=E;return E=S,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=P;class b{constructor(l,i=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let i=E;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||l<i)return;this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(c)||0;if(this._stacks.set(c,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let n,s=0;for(const[o,a]of this._stacks)(!n||s<a)&&(n=o,s=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(n)}return()=>{const n=this._stacks.get(c)||0;this._stacks.set(c,n-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(l,i,c)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(i?[l,i]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,i);const s=this._leakageMon?.check(this._listeners.size),o=(0,L.toDisposable)(()=>{s&&s(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return c instanceof L.DisposableStore?c.add(o):Array.isArray(c)&&c.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,c]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,c):i[0].call(i[1],c)}catch(r){(0,k.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class p extends f{async fireAsync(l,i,c){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[r,n]=this._asyncDeliveryQueue.shift(),s=[],o={...n,token:i,waitUntil:a=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");c&&(a=c(a,typeof r=="function"?r:r[0])),s.push(a)}};try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(a){(0,k.onUnexpectedError)(a);continue}Object.freeze(s),await Promise.allSettled(s).then(a=>{for(const u of a)u.status==="rejected"&&(0,k.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=p;class d extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=d;class h extends d{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=h;class m extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=m;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const i={event:l,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const c=()=>{this.hasListeners&&this.unhook(i);const r=this.events.indexOf(i);this.events.splice(r,1)};return(0,L.toDisposable)((0,t.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(i=>this.emitter.fire(i))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class y{constructor(){this.buffers=[]}wrapEvent(l){return(i,c,r)=>l(n=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>i.call(c,n)):i.call(c,n)},void 0,r)}bufferEvents(l){const i=[];this.buffers.push(i);const c=l();return this.buffers.pop(),i.forEach(r=>r()),c}}e.EventBufferer=y;class w{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=L.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(ne[25],ie([0,1,3]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(R,C){const E=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(E)}}});var L;(function(R){function C(E){return E===R.None||E===R.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(ne[106],ie([0,1,25]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(A){this.task=A,this.result=null}get(){if(this.result)return this.result;const A=new k.CancellationTokenSource,R=this.task(A.token);return this.result={promise:R,dispose:()=>{this.result=null,A.cancel(),A.dispose()}},this.result}}e.Cache=t;class L{constructor(A){this.computeFn=A,this.lastCache=void 0,this.lastArgKey=void 0}get(A){const R=JSON.stringify(A);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(A)),this.lastCache}}e.LRUCachedComputed=L}),define(ne[40],ie([0,1,9,2]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(w){const S=w;return S?[S.on,S.pause,S.resume,S.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=L;function T(w){const S=w;return S?L(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(w,S){return new R(w,S)}e.newWriteableStream=A;class R{constructor(S,l){this.reducer=S,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S!="undefined"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(l=>l(S))}emitError(S){this.listeners.error.length===0?(0,k.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(l=>l(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,l){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(S,l){if(this.state.destroyed)return;let i;switch(S){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const c=i.indexOf(l);c>=0&&i.splice(c,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(w,S){const l=[];let i;for(;(i=w.read())!==null;)l.push(i);return S(l)}e.consumeReadable=C;function E(w,S,l){const i=[];let c;for(;(c=w.read())!==null&&i.length<l;)i.push(c);return c===null&&i.length>0?S(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c!="undefined"){const r=c;return c=void 0,r}return w.read()}}}e.peekReadable=E;function P(w,S){return new Promise((l,i)=>{const c=[];b(w,{onData:r=>{S&&c.push(r)},onError:r=>{S?i(r):l(void 0)},onEnd:()=>{l(S?S(c):void 0)}})})}e.consumeStream=P;function b(w,S){let l=!1;return w.on("error",i=>{l||S.onError(i)}),w.on("end",()=>{l||S.onEnd()}),w.on("data",i=>{l||S.onData(i)}),(0,t.toDisposable)(()=>l=!0)}e.listenStream=b;function f(w,S){return new Promise((l,i)=>{const c=new t.DisposableStore,r=[],n=a=>{if(r.push(a),r.length>S)return c.dispose(),w.pause(),l({stream:w,buffer:r,ended:!1})},s=a=>i(a),o=()=>l({stream:w,buffer:r,ended:!0});c.add((0,t.toDisposable)(()=>w.removeListener("error",s))),w.on("error",s),c.add((0,t.toDisposable)(()=>w.removeListener("end",o))),w.on("end",o),c.add((0,t.toDisposable)(()=>w.removeListener("data",n))),w.on("data",n)})}e.peekStream=f;function p(w,S){const l=A(S);return l.end(w),l}e.toStream=p;function d(){const w=A(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=d;function h(w){let S=!1;return{read:()=>S?null:(S=!0,w)}}e.toReadable=h;function m(w,S,l){const i=A(l);return b(w,{onData:c=>i.write(S.data(c)),onError:c=>i.error(S.error?S.error(c):c),onEnd:()=>i.end()}),i}e.transform=m;function g(w,S,l){let i=!1;return{read:()=>{const c=S.read();return i?c:(i=!0,c!==null?l([w,c]):w)}}}e.prefixedReadable=g;function y(w,S,l){let i=!1;const c=A(l);return b(S,{onData:r=>i?c.write(r):(i=!0,c.write(l([w,r]))),onError:r=>c.error(r),onEnd:()=>{i||(i=!0,c.write(w)),c.end()}}),c}e.prefixedStream=y}),define(ne[17],ie([0,1,40]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let L,T;class A{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return t?new A(Buffer.allocUnsafe(u)):new A(new Uint8Array(u))}static wrap(u){return t&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new A(u)}static fromString(u,v){return!(v?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(u)):(L||(L=new TextEncoder),new A(L.encode(u)))}static fromByteArray(u){const v=A.alloc(u.length);for(let I=0,_=u.length;I<_;I++)v.buffer[I]=u[I];return v}static concat(u,v){if(typeof v=="undefined"){v=0;for(let O=0,M=u.length;O<M;O++)v+=u[O].byteLength}const I=A.alloc(v);let _=0;for(let O=0,M=u.length;O<M;O++){const D=u[O];I.set(D,_),_+=D.byteLength}return I}clone(){const u=A.alloc(this.byteLength);return u.set(this),u}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(u,v){return new A(this.buffer.subarray(u,v))}set(u,v){if(u instanceof A)this.buffer.set(u.buffer,v);else if(u instanceof Uint8Array)this.buffer.set(u,v);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),v);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),v);else throw new Error("Unkown argument 'array'")}readUInt32BE(u){return E(this.buffer,u)}writeUInt32BE(u,v){P(this.buffer,u,v)}readUInt32LE(u){return b(this.buffer,u)}writeUInt32LE(u,v){f(this.buffer,u,v)}readUInt8(u){return p(this.buffer,u)}writeUInt8(u,v){d(this.buffer,u,v)}}e.VSBuffer=A;function R(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=R;function C(a,u,v){a[v+0]=u&255,u=u>>>8,a[v+1]=u&255}e.writeUInt16LE=C;function E(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=E;function P(a,u,v){a[v+3]=u,u=u>>>8,a[v+2]=u,u=u>>>8,a[v+1]=u,u=u>>>8,a[v]=u}e.writeUInt32BE=P;function b(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=b;function f(a,u,v){a[v+0]=u&255,u=u>>>8,a[v+1]=u&255,u=u>>>8,a[v+2]=u&255,u=u>>>8,a[v+3]=u&255}e.writeUInt32LE=f;function p(a,u){return a[u]}e.readUInt8=p;function d(a,u,v){a[v]=u}e.writeUInt8=d;function h(a){return k.consumeReadable(a,u=>A.concat(u))}e.readableToBuffer=h;function m(a){return k.toReadable(a)}e.bufferToReadable=m;function g(a){return k.consumeStream(a,u=>A.concat(u))}e.streamToBuffer=g;async function y(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await g(a.stream)])}e.bufferedStreamToBuffer=y;function w(a){return k.toStream(a,u=>A.concat(u))}e.bufferToStream=w;function S(a){return k.transform(a,{data:u=>typeof u=="string"?A.fromString(u):A.wrap(u)},u=>A.concat(u))}e.streamToBufferReadableStream=S;function l(a){return k.newWriteableStream(u=>A.concat(u),a)}e.newWriteableBufferStream=l;function i(a,u){return k.prefixedReadable(a,u,v=>A.concat(v))}e.prefixedBufferReadable=i;function c(a,u){return k.prefixedStream(a,u,v=>A.concat(v))}e.prefixedBufferStream=c;function r(a){let u=0,v=0,I=0;const _=new Uint8Array(Math.floor(a.length/4*3)),O=D=>{switch(v){case 3:_[I++]=u|D,v=0;break;case 2:_[I++]=u|D>>>2,u=D<<6,v=3;break;case 1:_[I++]=u|D>>>4,u=D<<4,v=2;break;default:u=D<<2,v=1}};for(let D=0;D<a.length;D++){const U=a.charCodeAt(D);if(U>=65&&U<=90)O(U-65);else if(U>=97&&U<=122)O(U-97+26);else if(U>=48&&U<=57)O(U-48+52);else if(U===43||U===45)O(62);else if(U===47||U===95)O(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${a[D]}`)}}const M=I;for(;v>0;)O(0);return A.wrap(_).slice(0,M)}e.decodeBase64=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:a},u=!0,v=!1){const I=v?s:n;let _="";const O=a.byteLength%3;let M=0;for(;M<a.byteLength-O;M+=3){const D=a[M+0],U=a[M+1],F=a[M+2];_+=I[D>>>2],_+=I[(D<<4|U>>>4)&63],_+=I[(U<<2|F>>>6)&63],_+=I[F&63]}if(O===1){const D=a[M+0];_+=I[D>>>2],_+=I[D<<4&63],u&&(_+="==")}else if(O===2){const D=a[M+0],U=a[M+1];_+=I[D>>>2],_+=I[(D<<4|U>>>4)&63],_+=I[U<<2&63],u&&(_+="=")}return _}e.encodeBase64=o}),define(ne[26],ie([0,1,106,100]),function(Y,e,k,t){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function R(X,...oe){return oe.length===0?X:X.replace(A,function(le,fe){const ge=parseInt(fe,10);return isNaN(ge)||ge<0||ge>=oe.length?le:oe[ge]})}e.format=R;const C=/{([^}]+)}/g;function E(X,oe){return X.replace(C,(le,fe)=>oe[fe]??le)}e.format2=E;function P(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function b(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function f(X,oe){let le=0;const fe=oe.charCodeAt(0);for(let ge=X.length-1;ge>=0;ge--)X.charCodeAt(ge)===fe&&le++;return le}e.count=f;function p(X,oe,le="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${le}`}e.truncate=p;function d(X,oe=" "){const le=h(X,oe);return m(le,oe)}e.trim=d;function h(X,oe){if(!X||!oe)return X;const le=oe.length;if(le===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+le;return X.substring(fe)}e.ltrim=h;function m(X,oe){if(!X||!oe)return X;const le=oe.length,fe=X.length;if(le===0||fe===0)return X;let ge=fe,Le=-1;for(;Le=X.lastIndexOf(oe,ge-1),!(Le===-1||Le+le!==ge);){if(Le===0)return"";ge=Le}return X.substring(0,ge)}e.rtrim=m;function g(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function y(X){return X.replace(/\*/g,"")}e.stripWildcards=y;function w(X,oe,le={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=b(X)),le.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=w;function S(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function l(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=i;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function r(X){for(let oe=0,le=X.length;oe<le;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function n(X,oe=0,le=X.length){for(let fe=oe;fe<le;fe++){const ge=X.charCodeAt(fe);if(ge!==32&&ge!==9)return X.substring(oe,fe)}return X.substring(oe,le)}e.getLeadingWhitespace=n;function s(X,oe=X.length-1){for(let le=oe;le>=0;le--){const fe=X.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function o(X,oe){return X<oe?-1:X>oe?1:0}e.compare=o;function a(X,oe,le=0,fe=X.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=X.charCodeAt(le),Pe=oe.charCodeAt(ge);if(ke<Pe)return-1;if(ke>Pe)return 1}const ye=fe-le,Re=Le-ge;return ye<Re?-1:ye>Re?1:0}e.compareSubstring=a;function u(X,oe){return v(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=u;function v(X,oe,le=0,fe=X.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=X.charCodeAt(le),Pe=oe.charCodeAt(ge);if(ke===Pe)continue;if(ke>=128||Pe>=128)return a(X.toLowerCase(),oe.toLowerCase(),le,fe,ge,Le);I(ke)&&(ke-=32),I(Pe)&&(Pe-=32);const Ae=ke-Pe;if(Ae!==0)return Ae}const ye=fe-le,Re=Le-ge;return ye<Re?-1:ye>Re?1:0}e.compareSubstringIgnoreCase=v;function I(X){return X>=97&&X<=122}e.isLowerAsciiLetter=I;function _(X){return X>=65&&X<=90}e.isUpperAsciiLetter=_;function O(X,oe){return X.length===oe.length&&v(X,oe)===0}e.equalsIgnoreCase=O;function M(X,oe){const le=oe.length;return oe.length>X.length?!1:v(X,oe,0,le)===0}e.startsWithIgnoreCase=M;function D(X,oe){let le,fe=Math.min(X.length,oe.length);for(le=0;le<fe;le++)if(X.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=D;function U(X,oe){let le,fe=Math.min(X.length,oe.length);const ge=X.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(X.charCodeAt(ge-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=U;function F(X){return 55296<=X&&X<=56319}e.isHighSurrogate=F;function x(X){return 56320<=X&&X<=57343}e.isLowSurrogate=x;function q(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=q;function G(X,oe,le){const fe=X.charCodeAt(le);if(F(fe)&&le+1<oe){const ge=X.charCodeAt(le+1);if(x(ge))return q(fe,ge)}return fe}e.getNextCodePoint=G;function te(X,oe){const le=X.charCodeAt(oe-1);if(x(le)&&oe>1){const fe=X.charCodeAt(oe-2);if(F(fe))return q(fe,le)}return le}class W{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=te(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class j{constructor(oe,le=0){this._iterator=new W(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ce.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,ye=oe.getGraphemeBreakType(le.nextCodePoint());if(Be(ge,ye)){le.setOffset(Le);break}ge=ye}return le.offset-fe}prevGraphemeLength(){const oe=ce.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,ye=oe.getGraphemeBreakType(le.prevCodePoint());if(Be(ye,ge)){le.setOffset(Le);break}ge=ye}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=j;function J(X,oe){return new j(X,oe).nextGraphemeLength()}e.nextCharLength=J;function H(X,oe){return new j(X,oe).prevGraphemeLength()}e.prevCharLength=H;function Q(X,oe){oe>0&&x(X.charCodeAt(oe))&&oe--;const le=oe+J(X,oe);return[le-H(X,le),le]}e.getCharContainingOffset=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function B(X){return Z.test(X)}e.containsRTL=B;const N=/^[\t\n\r\x20-\x7E]*$/;function $(X){return N.test(X)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=z;function V(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=V;function ee(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=ee;function se(X,oe){if(X.length<oe)return X;const le=/\b/g;let fe=0;for(;le.test(X)&&!(X.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ae=/\x1B\x5B[12]?K/g,de=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function be(X){return X&&(X=X.replace(ae,""),X=X.replace(de,""),X=X.replace(ve,"")),X}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function pe(X){return Se(X)?X.substr(1):X}e.stripUTF8BOM=pe;function Ie(X,oe){if(!X||!oe||X.length<oe.length)return!1;const le=oe.length,fe=X.toLowerCase();let ge=0,Le=-1;for(;ge<le;){const ye=fe.indexOf(oe[ge],Le+1);if(ye<0)return!1;Le=ye,ge++}return!0}e.fuzzyContains=Ie;function Ce(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ce;function De(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=De;function Ue(X,oe=1){if(oe===0)return"";let le=-1;do le=X.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?X:(X[le-1]==="\r"&&le--,X.substr(0,le))}e.getNLines=Ue;function je(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=je;function Ge(X){return ce.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Ge;function Be(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}var re;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ce{constructor(){this._data=ue()}static getInstance(){return ce._INSTANCE||(ce._INSTANCE=new ce),ce._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let ge=1;for(;ge<=fe;)if(oe<le[3*ge])ge=2*ge;else if(oe>le[3*ge+1])ge=2*ge+1;else return le[3*ge+2];return 0}}ce._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function we(X,oe){if(X===0)return 0;const le=Ee(X,oe);if(le!==void 0)return le;const fe=new W(oe,X);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=we;function Ee(X,oe){const le=new W(oe,X);let fe=le.prevCodePoint();for(;Fe(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!ee(fe))return;let ge=le.offset;return ge>0&&le.prevCodePoint()===8205&&(ge=le.offset),ge}function Fe(X){return 127995<=X&&X<=127999}var Te;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new k.LRUCachedComputed(X=>{function oe(Pe){const Ae=new Map;for(let Ne=0;Ne<Pe.length;Ne+=2)Ae.set(Pe[Ne],Pe[Ne+1]);return Ae}function le(Pe,Ae){const Ne=new Map(Pe);for(const[qe,We]of Ae)Ne.set(qe,We);return Ne}function fe(Pe,Ae){if(!Pe)return Ae;const Ne=new Map;for(const[qe,We]of Pe)Ae.has(qe)&&Ne.set(qe,We);return Ne}const ge=L.ambiguousCharacterData.getValue();let Le=X.filter(Pe=>!Pe.startsWith("_")&&Pe in ge);Le.length===0&&(Le=["_default"]);let ye;for(const Pe of Le){const Ae=oe(ge[Pe]);ye=fe(ye,Ae)}const Re=oe(ge._common),ke=le(Re,ye);return new Oe(ke)}),Oe._locales=new t.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[71],ie([0,1,26]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(g){return L(g,0)}e.hash=t;function L(g,y){switch(typeof g){case"object":return g===null?T(349,y):Array.isArray(g)?C(g,y):E(g,y);case"string":return R(g,y);case"boolean":return A(g,y);case"number":return T(g,y);case"undefined":return T(937,y);default:return T(617,y)}}e.doHash=L;function T(g,y){return(y<<5)-y+g|0}e.numberHash=T;function A(g,y){return T(g?433:863,y)}function R(g,y){y=T(149417,y);for(let w=0,S=g.length;w<S;w++)y=T(g.charCodeAt(w),y);return y}e.stringHash=R;function C(g,y){return y=T(104579,y),g.reduce((w,S)=>L(S,w),y)}function E(g,y){return y=T(181387,y),Object.keys(g).sort().reduce((w,S)=>(w=R(S,w),L(g[S],w)),y)}class P{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=L(y,this._value),this._value}}e.Hasher=P;var b;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function f(g,y,w=32){const S=w-y,l=~((1<<S)-1);return(g<<y|(l&g)>>>S)>>>0}function p(g,y=0,w=g.byteLength,S=0){for(let l=0;l<w;l++)g[y+l]=S}function d(g,y,w="0"){for(;g.length<y;)g=w+g;return g}function h(g,y=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(w=>w.toString(16).padStart(2,"0")).join(""):d((g>>>0).toString(16),y/4)}e.toHexString=h;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const w=y.length;if(w===0)return;const S=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,c,r;for(i!==0?(c=i,r=-1,i=0):(c=y.charCodeAt(0),r=0);;){let n=c;if(k.isHighSurrogate(c))if(r+1<w){const s=y.charCodeAt(r+1);k.isLowSurrogate(s)?(r++,n=k.computeCodePoint(c,s)):n=65533}else{i=c;break}else k.isLowSurrogate(c)&&(n=65533);if(l=this._push(S,l,n),r++,r<w)c=y.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(y,w,S){return S<128?y[w++]=S:S<2048?(y[w++]=192|(S&1984)>>>6,y[w++]=128|(S&63)>>>0):S<65536?(y[w++]=224|(S&61440)>>>12,y[w++]=128|(S&4032)>>>6,y[w++]=128|(S&63)>>>0):(y[w++]=240|(S&1835008)>>>18,y[w++]=128|(S&258048)>>>12,y[w++]=128|(S&4032)>>>6,y[w++]=128|(S&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=m._bigBlock32,w=this._buffDV;for(let a=0;a<64;a+=4)y.setUint32(a,w.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)y.setUint32(a,f(y.getUint32(a-12,!1)^y.getUint32(a-32,!1)^y.getUint32(a-56,!1)^y.getUint32(a-64,!1),1),!1);let S=this._h0,l=this._h1,i=this._h2,c=this._h3,r=this._h4,n,s,o;for(let a=0;a<80;a++)a<20?(n=l&i|~l&c,s=1518500249):a<40?(n=l^i^c,s=1859775393):a<60?(n=l&i|l&c|i&c,s=2400959708):(n=l^i^c,s=3395469782),o=f(S,5)+n+r+s+y.getUint32(a*4,!1)&4294967295,r=c,c=i,i=f(l,30),l=S,S=o;this._h0=this._h0+S&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+c&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(Y,e,k,t,L){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?L.call(Y,k):L?L.value=k:e.set(Y,k),k},He=this&&this.__classPrivateFieldGet||function(Y,e,k,t){if(k==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!t:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?t:k==="a"?t.call(Y):t?t.value:e.get(Y)};define(ne[39],ie([0,1,16,26]),function(Y,e,k,t){"use strict";var L,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(r,n,s){let o=r.get(n);return o===void 0&&(o=s,r.set(n,o)),o}e.getOrSet=R;function C(r){const n=[];return r.forEach((s,o)=>{n.push(`${o} => ${s}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.mapToString=C;function E(r){const n=[];return r.forEach(s=>{n.push(s)}),`Set(${r.size}) {${n.join(", ")}}`}e.setToString=E;class P{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class f{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class d{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(m||(m={}));class g{constructor(n){this._iter=n}static forUris(n=()=>!1){return new g(new d(n))}static forPaths(n=!1){return new g(new f(void 0,!n))}static forStrings(){return new g(new P)}static forConfigKeys(){return new g(new b)}clear(){this._root=void 0}fill(n,s){if(s){const o=s.slice(0);(0,k.shuffle)(o);for(let a of o)this.set(a,n)}else{const o=n.slice(0);(0,k.shuffle)(o);for(let a of o)this.set(a[0],a[1])}}set(n,s){const o=this._iter.reset(n);let a;this._root||(this._root=new h,this._root.segment=o.value());const u=[];for(a=this._root;;){const I=o.cmp(a.segment);if(I>0)a.left||(a.left=new h,a.left.segment=o.value()),u.push([-1,a]),a=a.left;else if(I<0)a.right||(a.right=new h,a.right.segment=o.value()),u.push([1,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new h,a.mid.segment=o.value()),u.push([0,a]),a=a.mid;else break}const v=a.value;a.value=s,a.key=n;for(let I=u.length-1;I>=0;I--){const _=u[I][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const M=u[I][0],D=u[I+1][0];if(M===1&&D===1)u[I][1]=_.rotateLeft();else if(M===-1&&D===-1)u[I][1]=_.rotateRight();else if(M===1&&D===-1)_.right=u[I+1][1]=u[I+1][1].rotateRight(),u[I][1]=_.rotateLeft();else if(M===-1&&D===1)_.left=u[I+1][1]=u[I+1][1].rotateLeft(),u[I][1]=_.rotateRight();else throw new Error;if(I>0)switch(u[I-1][0]){case-1:u[I-1][1].left=u[I][1];break;case 1:u[I-1][1].right=u[I][1];break;case 0:u[I-1][1].mid=u[I][1];break}else this._root=u[0][1]}}return v}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let o=this._root;for(;o;){const a=s.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const o=this._iter.reset(n),a=[];let u=this._root;for(;u;){const v=o.cmp(u.segment);if(v>0)a.push([-1,u]),u=u.left;else if(v<0)a.push([1,u]),u=u.right;else if(o.hasNext())o.next(),a.push([0,u]),u=u.mid;else break}if(!!u){if(s?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const v=this._min(u.right),{key:I,value:_,segment:O}=v;this._delete(v.key,!1),u.key=I,u.value=_,u.segment=O}else{const v=u.left??u.right;if(a.length>0){const[I,_]=a[a.length-1];switch(I){case-1:_.left=v;break;case 0:_.mid=v;break;case 1:_.right=v;break}}else this._root=v}for(let v=a.length-1;v>=0;v--){const I=a[v][1];I.updateHeight();const _=I.balanceFactor();if(_>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),a[v][1]=I.rotateLeft()):_<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),a[v][1]=I.rotateRight()),v>0)switch(a[v-1][0]){case-1:a[v-1][1].left=a[v][1];break;case 1:a[v-1][1].right=a[v][1];break;case 0:a[v-1][1].mid=a[v][1];break}else this._root=a[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let o=this._root,a;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(n){const s=this._iter.reset(n);let o=this._root;for(;o;){const a=s.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[s,o]of this)n(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=g;class y{constructor(n,s){this.uri=n,this.value=s}}class w{constructor(n,s){this[L]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=s??w.defaultToKey):(this.map=new Map,this.toKey=n??w.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new y(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[o,a]of this.map)n(a.value,a.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=w,w.defaultToKey=r=>r.toString();var S;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const o=this._map.get(n);if(!!o)return s!==0&&this.touch(o,s),o.value}set(n,s,o=0){let a=this._map.get(n);if(a)a.value=s,o!==0&&this.touch(a,o);else{switch(a={key:n,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const o=this._state;let a=this._head;for(;a;){if(s?n.bind(s)(a.value,a.key,this):n(a.value,a.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,s=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:o.key,done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return a}values(){const n=this,s=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:o.value,done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return a}entries(){const n=this,s=this._state;let o=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:[o.key,o.value],done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>n;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,o=n.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const o=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(o.previous=a,a.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const o=n.next,a=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=a,a.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,o)=>{n.push([o,s])}),n}fromJSON(n){this.clear();for(const[s,o]of n)this.set(s,o)}}e.LinkedMap=l;class i extends l{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class c{constructor(n){A.set(this,void 0),It(this,A,n,"f")}get size(){return He(this,A,"f").size}forEach(n,s){He(this,A,"f").forEach(n,s)}get(n){return He(this,A,"f").get(n)}has(n){return He(this,A,"f").has(n)}entries(){return He(this,A,"f").entries()}keys(){return He(this,A,"f").keys()}values(){return He(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return He(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(ne[72],ie([0,1,39]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new k.LRUCache(1e4);function L(E){return C(E,"NFC",t)}e.normalizeNFC=L;const T=new k.LRUCache(1e4);function A(E){return C(E,"NFD",T)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function C(E,P,b){if(!E)return E;const f=b.get(E);if(f)return f;let p;return R.test(E)?p=E.normalize(P):p=E,b.set(E,p),p}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(P){return A(P).replace(E,"")}}()}),define(ne[15],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(o){return Array.isArray(o)}e.isArray=k;function t(o){return typeof o=="string"}e.isString=t;function L(o){return Array.isArray(o)&&o.every(a=>t(a))}e.isStringArray=L;function T(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=T;function A(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=A;function R(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=R;function C(o){return o===!0||o===!1}e.isBoolean=C;function E(o){return typeof o=="undefined"}e.isUndefined=E;function P(o){return!b(o)}e.isDefined=P;function b(o){return E(o)||o===null}e.isUndefinedOrNull=b;function f(o,a){if(!o)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=f;function p(o){if(b(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=p;function d(...o){const a=[];for(let u=0;u<o.length;u++){const v=o[u];if(b(v))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);a.push(v)}return a}e.assertAllDefined=d;const h=Object.prototype.hasOwnProperty;function m(o){if(!T(o))return!1;for(let a in o)if(h.call(o,a))return!1;return!0}e.isEmptyObject=m;function g(o){return typeof o=="function"}e.isFunction=g;function y(...o){return o.length>0&&o.every(g)}e.areFunctions=y;function w(o,a){const u=Math.min(o.length,a.length);for(let v=0;v<u;v++)S(o[v],a[v])}e.validateConstraints=w;function S(o,a){if(t(a)){if(typeof o!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(g(a)){try{if(o instanceof a)return}catch{}if(!b(o)&&o.constructor===a||a.length===1&&a.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function l(o){let a=[],u=Object.getPrototypeOf(o);for(;Object.prototype!==u;)a=a.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return a}e.getAllPropertyNames=l;function i(o){const a=[];for(const u of l(o))typeof o[u]=="function"&&a.push(u);return a}e.getAllMethodNames=i;function c(o,a){const u=I=>function(){const _=Array.prototype.slice.call(arguments,0);return a(I,_)};let v={};for(const I of o)v[I]=u(I);return v}e.createProxyObject=c;function r(o){return o===null?void 0:o}e.withNullAsUndefined=r;function n(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=n;function s(o,a="Unreachable"){throw new Error(a)}e.assertNever=s}),define(ne[41],ie([0,1,10,4,26,15]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function R(s){return s.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function C(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function E(s,o=k.posix.sep){if(!s)return"";const a=s.length,u=s.charCodeAt(0);if(A(u)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let I=3;const _=I;for(;I<a&&!A(s.charCodeAt(I));I++);if(_!==I&&!A(s.charCodeAt(I+1))){for(I+=1;I<a;I++)if(A(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(g(u)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<a;v++)if(A(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=E;function P(s){if(!t.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let a=2;const u=a;for(;a<s.length&&(o=s.charCodeAt(a),o!==92);a++);return!(u===a||(o=s.charCodeAt(a+1),isNaN(o)||o===92))}e.isUNC=P;const b=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,o=t.isWindows){const a=o?b:f;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||o&&p.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function h(s,o,a){const u=s===o;return!a||u?u:!s||!o?!1:(0,L.equalsIgnoreCase)(s,o)}e.isEqual=h;function m(s,o,a,u=k.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(a){if(!(0,L.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let I=o.length;return o.charAt(o.length-1)===u&&I--,s.charAt(I)===u}return o.charAt(o.length-1)!==u&&(o+=u),s.indexOf(o)===0}e.isEqualOrParent=m;function g(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=g;function y(s,o){return t.isWindows&&s.endsWith(":")&&(s+=k.sep),(0,k.isAbsolute)(s)||(s=(0,k.join)(o,s)),s=(0,k.normalize)(s),t.isWindows?(s=(0,L.rtrim)(s,k.sep),s.endsWith(":")&&(s+=k.sep)):(s=(0,L.rtrim)(s,k.sep),s||(s=k.sep)),s}e.sanitizeFilePath=y;function w(s){const o=(0,k.normalize)(s);return t.isWindows?s.length>3?!1:S(o)&&(s.length===2||o.charCodeAt(2)===92):o===k.posix.sep}e.isRootOrDriveLetter=w;function S(s,o){return(o!==void 0?o:t.isWindows)?g(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function l(s){return S(s)?s[0]:void 0}e.getDriveLetter=l;function i(s,o,a){return o.length>s.length?-1:s===o?0:(a&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=i;function c(s){const o=s.split(":");let a,u,v;for(const I of o){const _=Number(I);(0,T.isNumber)(_)?u===void 0?u=_:v===void 0&&(v=_):a=a?[a,I].join(":"):I}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:v!==void 0?v:u!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,o,a=8){let u="";for(let I=0;I<a;I++)u+=r.charAt(Math.floor(Math.random()*r.length));let v;return o?v=`${o}-${u}`:v=u,s?(0,k.join)(s,v):v}e.randomPath=n}),define(ne[28],ie([0,1,15]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.keys(h).forEach(g=>{h[g]&&typeof h[g]=="object"?m[g]=t(h[g]):m[g]=h[g]}),m}e.deepClone=t;function L(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const g=m.shift();Object.freeze(g);for(const y in g)if(T.call(g,y)){const w=g[y];typeof w=="object"&&!Object.isFrozen(w)&&m.push(w)}}return h}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(h,m){return R(h,m,new Set)}e.cloneAndChange=A;function R(h,m,g){if((0,k.isUndefinedOrNull)(h))return h;const y=m(h);if(typeof y!="undefined")return y;if((0,k.isArray)(h)){const w=[];for(const S of h)w.push(R(S,m,g));return w}if((0,k.isObject)(h)){if(g.has(h))throw new Error("Cannot clone recursive data-structure");g.add(h);const w={};for(let S in h)T.call(h,S)&&(w[S]=R(h[S],m,g));return g.delete(h),w}return h}function C(h,m,g=!0){return(0,k.isObject)(h)?((0,k.isObject)(m)&&Object.keys(m).forEach(y=>{y in h?g&&((0,k.isObject)(h[y])&&(0,k.isObject)(m[y])?C(h[y],m[y],g):h[y]=m[y]):h[y]=m[y]}),h):m}e.mixin=C;function E(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let g,y;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(g=0;g<h.length;g++)if(!E(h[g],m[g]))return!1}else{const w=[];for(y in h)w.push(y);w.sort();const S=[];for(y in m)S.push(y);if(S.sort(),!E(w,S))return!1;for(g=0;g<w.length;g++)if(!E(h[w[g]],m[w[g]]))return!1}return!0}e.equals=E;function P(h){const m=new Set;return JSON.stringify(h,(g,y)=>{if((0,k.isObject)(y)||Array.isArray(y)){if(m.has(y))return"[Circular]";m.add(y)}return y})}e.safeStringify=P;function b(h,m,g){const y=m(h);return typeof y=="undefined"?g:y}e.getOrDefault=b;function f(h,m){const g=Object.create(null);return!h||!m||Object.keys(m).forEach(w=>{const S=h[w],l=m[w];E(S,l)||(g[w]=l)}),g}e.distinct=f;function p(h,m){const g=m.toLowerCase(),y=Object.keys(h).find(w=>w.toLowerCase()===g);return y?h[y]:h[m]}e.getCaseInsensitive=p;function d(h,m){const g=Object.create(null);for(const[y,w]of Object.entries(h))m(y,w)&&(g[y]=w);return g}e.filter=d}),define(ne[7],ie([0,1,10,4]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function R(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!L.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!T.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(r,n){return!r&&!n?"file":r}function E(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const P="",b="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,s,o,a,u,v=!1){typeof n=="object"?(this.scheme=n.scheme||P,this.authority=n.authority||P,this.path=n.path||P,this.query=n.query||P,this.fragment=n.fragment||P):(this.scheme=C(n,v),this.authority=s||P,this.path=E(this.scheme,o||P),this.query=a||P,this.fragment=u||P,R(this,v))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return w(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:o,path:a,query:u,fragment:v}=n;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),a===void 0?a=this.path:a===null&&(a=P),u===void 0?u=this.query:u===null&&(u=P),v===void 0?v=this.fragment:v===null&&(v=P),s===this.scheme&&o===this.authority&&a===this.path&&u===this.query&&v===this.fragment?this:new h(s,o,a,u,v)}static parse(n,s=!1){const o=f.exec(n);return o?new h(o[2]||P,c(o[4]||P),c(o[5]||P),c(o[7]||P),c(o[9]||P),s):new h(P,P,P,P,P)}static file(n){let s=P;if(t.isWindows&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const o=n.indexOf(b,2);o===-1?(s=n.substring(2),n=b):(s=n.substring(2,o),n=n.substring(o)||b)}return new h("file",s,n,P,P)}static from(n){const s=new h(n.scheme,n.authority,n.path,n.query,n.fragment);return R(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return t.isWindows&&n.scheme==="file"?o=p.file(k.win32.join(w(n,!0),...s)).path:o=k.posix.join(n.path,...s),n.with({path:o})}toString(n=!1){return S(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const s=new h(n);return s._formatted=n.external,s._fsPath=n._sep===d?n.fsPath:null,s}}else return n}}e.URI=p;const d=t.isWindows?1:void 0;class h extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(n=!1){return n?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(r,n){let s,o=-1;for(let a=0;a<r.length;a++){const u=r.charCodeAt(a);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||n&&u===47)o!==-1&&(s+=encodeURIComponent(r.substring(o,a)),o=-1),s!==void 0&&(s+=r.charAt(a));else{s===void 0&&(s=r.substr(0,a));const v=m[u];v!==void 0?(o!==-1&&(s+=encodeURIComponent(r.substring(o,a)),o=-1),s+=v):o===-1&&(o=a)}}return o!==-1&&(s+=encodeURIComponent(r.substring(o))),s!==void 0?s:r}function y(r){let n;for(let s=0;s<r.length;s++){const o=r.charCodeAt(s);o===35||o===63?(n===void 0&&(n=r.substr(0,s)),n+=m[o]):n!==void 0&&(n+=r[s])}return n!==void 0?n:r}function w(r,n){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=w;function S(r,n){const s=n?y:g;let o="",{scheme:a,authority:u,path:v,query:I,fragment:_}=r;if(a&&(o+=a,o+=":"),(u||a==="file")&&(o+=b,o+=b),u){let O=u.indexOf("@");if(O!==-1){const M=u.substr(0,O);u=u.substr(O+1),O=M.indexOf(":"),O===-1?o+=s(M,!1):(o+=s(M.substr(0,O),!1),o+=":",o+=s(M.substr(O+1),!1)),o+="@"}u=u.toLowerCase(),O=u.indexOf(":"),O===-1?o+=s(u,!1):(o+=s(u.substr(0,O),!1),o+=u.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const O=v.charCodeAt(1);O>=65&&O<=90&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const O=v.charCodeAt(0);O>=65&&O<=90&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}o+=s(v,!0)}return I&&(o+="?",o+=s(I,!1)),_&&(o+="#",o+=n?_:g(_,!1)),o}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(r){return r.match(i)?r.replace(i,n=>l(n)):r}}),define(ne[107],ie([0,1,7]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(E){const P=E;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=t;function L(E){const P=[];let b;try{const f=JSON.parse(E.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),b=p.__$stack),P.push(...f)}catch{P.push("Unable to log remote console arguments",E.arguments)}return{args:P,stack:b}}e.parse=L;function T(E){if(typeof E!="string")return T(L(E).stack);const P=E;if(P){const b=A(P),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(f&&f.length===4)return{uri:k.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(E){if(!E)return E;const P=E.indexOf(`
`);return P===-1?E:E.substring(0,P)}function R(E,P){const{args:b,stack:f}=L(E),p=typeof b[0]=="string"&&b.length===1;let d=A(f);d&&(d=`(${d.trim()})`);let h=[];if(typeof b[0]=="string"?d&&p?h=[`%c[${P}] %c${b[0]} %c${d}`,C("blue"),C(""),C("grey")]:h=[`%c[${P}] %c${b[0]}`,C("blue"),C(""),...b.slice(1)]:h=[`%c[${P}]%`,C("blue"),...b],d&&!p&&h.push(d),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,h)}e.log=R;function C(E){return`color: ${E}`}}),define(ne[108],ie([0,1,17,26,7]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(P){return JSON.stringify(P,C)}e.stringify=T;function A(P){let b=JSON.parse(P);return b=E(b),b}e.parse=A;var R;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext",P[P.Date=14]="Date"})(R=e.MarshalledId||(e.MarshalledId={}));function C(P,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function E(P,b=0){if(!P||b>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return L.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof k.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let f=0;f<P.length;++f)P[f]=E(P[f],b+1);else for(const f in P)Object.hasOwnProperty.call(P,f)&&(P[f]=E(P[f],b+1))}return P}e.revive=E}),define(ne[18],ie([0,1,4,7]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,E,P){this._hosts[C]=E,this._ports[C]=P}setConnectionToken(C,E){this._connectionTokens[C]=E}rewrite(C){if(this._delegate)return this._delegate(C);const E=C.authority;let P=this._hosts[E];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const b=this._ports[E],f=this._connectionTokens[E];let p=`path=${encodeURIComponent(C.path)}`;return typeof f=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:k.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${P}:${b}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class A{asBrowserUri(C,E){const P=this.toUri(C,E);return P.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===L.file&&(k.isNative||typeof k.globals.importScripts=="function"&&k.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(C,E){const P=this.toUri(C,E);return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==A.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(C,E){return t.URI.isUri(C)?C:t.URI.parse(E.toUrl(C))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ne[21],ie([0,1,41,18,10,4,26,7]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=C;class E{constructor(d){this._ignorePathCasing=d}compare(d,h,m=!1){return d===h?0:(0,A.compare)(this.getComparisonKey(d,m),this.getComparisonKey(h,m))}isEqual(d,h,m=!1){return d===h?!0:!d||!h?!1:this.getComparisonKey(d,m)===this.getComparisonKey(h,m)}getComparisonKey(d,h=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,h,m=!1){if(d.scheme===h.scheme){if(d.scheme===t.Schemas.file)return k.isEqualOrParent(C(d),C(h),this._ignorePathCasing(d))&&d.query===h.query&&(m||d.fragment===h.fragment);if((0,e.isEqualAuthority)(d.authority,h.authority))return k.isEqualOrParent(d.path,h.path,this._ignorePathCasing(d),"/")&&d.query===h.query&&(m||d.fragment===h.fragment)}return!1}joinPath(d,...h){return R.URI.joinPath(d,...h)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return L.posix.basename(d.path)}extname(d){return L.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let h;return d.scheme===t.Schemas.file?h=R.URI.file(L.dirname(C(d))).path:(h=L.posix.dirname(d.path),d.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),h="/")),d.with({path:h})}normalizePath(d){if(!d.path.length)return d;let h;return d.scheme===t.Schemas.file?h=R.URI.file(L.normalize(C(d))).path:h=L.posix.normalize(d.path),d.with({path:h})}relativePath(d,h){if(d.scheme!==h.scheme||!(0,e.isEqualAuthority)(d.authority,h.authority))return;if(d.scheme===t.Schemas.file){const y=L.relative(C(d),C(h));return T.isWindows?k.toSlashes(y):y}let m=d.path||"/",g=h.path||"/";if(this._ignorePathCasing(d)){let y=0;for(const w=Math.min(m.length,g.length);y<w&&!(m.charCodeAt(y)!==g.charCodeAt(y)&&m.charAt(y).toLowerCase()!==g.charAt(y).toLowerCase());y++);m=g.substr(0,y)+m.substr(y)}return L.posix.relative(m,g)}resolvePath(d,h){if(d.scheme===t.Schemas.file){const m=R.URI.file(L.resolve(C(d),h));return d.with({authority:m.authority,path:m.path})}return h=k.toPosixPath(h),d.with({path:L.posix.resolve(d.path,h)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,h){return d===h||d!==void 0&&h!==void 0&&(0,A.equalsIgnoreCase)(d,h)}hasTrailingPathSeparator(d,h=L.sep){if(d.scheme===t.Schemas.file){const m=C(d);return m.length>k.getRoot(m).length&&m[m.length-1]===h}else{const m=d.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,h=L.sep){return(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,h=L.sep){let m=!1;if(d.scheme===t.Schemas.file){const g=C(d);m=g!==void 0&&g.length===k.getRoot(g).length&&g[g.length-1]===h}else{h="/";const g=d.path;m=g.length===1&&g.charCodeAt(g.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path+"/"}):d}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(p=>p.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,d){const h=[];for(let m=0;m<p.length;m++){const g=d(p[m]);p.some((y,w)=>w===m?!1:(0,e.isEqualOrParent)(g,d(y)))||h.push(p[m])}return h}e.distinctParents=P;var b;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(h){const m=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(w=>{const[S,l]=w.split(":");S&&l&&m.set(S,l)});const y=h.path.substring(0,h.path.indexOf(";"));return y&&m.set(p.META_DATA_MIME,y),m}p.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function f(p,d,h){if(d){let m=p.path;return m&&m[0]!==L.posix.sep&&(m=L.posix.sep+m),p.with({scheme:h,authority:d,path:m})}return p.with({scheme:h})}e.toLocalResource=f}),define(ne[5],ie([0,1,25,9,3,2,21,4]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(B){return!!B&&typeof B.then=="function"}e.isThenable=C;function E(B){const N=new k.CancellationTokenSource,$=B(N.token),z=new Promise((V,ee)=>{const se=N.token.onCancellationRequested(()=>{se.dispose(),N.dispose(),ee(new t.CancellationError)});Promise.resolve($).then(ae=>{se.dispose(),N.dispose(),V(ae)},ae=>{se.dispose(),N.dispose(),ee(ae)})});return new class{cancel(){N.cancel()}then(V,ee){return z.then(V,ee)}catch(V){return this.then(void 0,V)}finally(V){return z.finally(V)}}}e.createCancelablePromise=E;function P(B,N,$){return new Promise((z,V)=>{const ee=N.onCancellationRequested(()=>{ee.dispose(),z($)});B.then(z,V).finally(()=>ee.dispose())})}e.raceCancellation=P;function b(B,N){return new Promise(($,z)=>{const V=N.onCancellationRequested(()=>{V.dispose(),z(new t.CancellationError)});B.then($,z).finally(()=>V.dispose())})}e.raceCancellationError=b;async function f(B){let N=-1;const $=B.map((V,ee)=>V.then(se=>(N=ee,se))),z=await Promise.race($);return B.forEach((V,ee)=>{ee!==N&&V.cancel()}),z}e.raceCancellablePromises=f;function p(B,N,$){let z;const V=setTimeout(()=>{z?.(void 0),$?.()},N);return Promise.race([B.finally(()=>clearTimeout(V)),new Promise(ee=>z=ee)])}e.raceTimeout=p;function d(B){return new Promise((N,$)=>{const z=B();C(z)?z.then(N,$):N(z)})}e.asPromise=d;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then($,$).then(z)})}return new Promise(($,z)=>{this.queuedPromise.then($,z)})}return this.activePromise=N(),new Promise(($,z)=>{this.activePromise.then(V=>{this.activePromise=null,$(V)},V=>{this.activePromise=null,z(V)})})}}e.Throttler=h;class m{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=m;class g{constructor(){this.promiseMap=new Map}queue(N,$){const V=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(N)===V&&this.promiseMap.delete(N)});return this.promiseMap.set(N,V),V}}e.SequencerByKey=g;const y=(B,N)=>{let $=!0;const z=setTimeout(()=>{$=!1,N()},B);return{isTriggered:()=>$,dispose:()=>{clearTimeout(z),$=!1}}},w=B=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,B())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(N){this.defaultDelay=N,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,$=this.defaultDelay){this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,ee)=>{this.doResolve=V,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=$===e.MicrotaskDelay?w(z):y($,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=S;class l{constructor(N){this.delayer=new S(N),this.throttler=new h}trigger(N,$){return this.delayer.trigger(()=>this.throttler.queue(N),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this._isOpen=!1,this._promise=new Promise((N,$)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class c extends i{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function r(B,N){return N?new Promise(($,z)=>{const V=setTimeout(()=>{ee.dispose(),$()},B),ee=N.onCancellationRequested(()=>{clearTimeout(V),ee.dispose(),z(new t.CancellationError)})}):E($=>r(B,$))}e.timeout=r;function n(B,N=0){const $=setTimeout(B,N);return(0,T.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=n;function s(B){const N=[];let $=0;const z=B.length;function V(){return $<z?B[$++]():null}function ee(se){se!=null&&N.push(se);const ae=V();return ae?ae.then(ee):Promise.resolve(N)}return Promise.resolve(null).then(ee)}e.sequence=s;function o(B,N=z=>!!z,$=null){let z=0;const V=B.length,ee=()=>{if(z>=V)return Promise.resolve($);const se=B[z++];return Promise.resolve(se()).then(de=>N(de)?Promise.resolve(de):ee())};return ee()}e.first=o;function a(B,N=z=>!!z,$=null){if(B.length===0)return Promise.resolve($);let z=B.length;const V=()=>{z=-1;for(const ee of B)ee.cancel?.()};return new Promise((ee,se)=>{for(const ae of B)ae.then(de=>{--z>=0&&N(de)?(V(),ee(de)):z===0&&ee($)}).catch(de=>{--z>=0&&(V(),se(de))})})}e.firstParallel=a;class u{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise(($,z)=>{this.outstandingPromises.push({factory:N,c:$,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const $=N.factory();$.then(N.c,N.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class v extends u{constructor(){super(1)}}e.Queue=v;class I{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new W;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,$=A.extUri){const z=$.getComparisonKey(N);let V=this.queues.get(z);return V||(V=new v,L.Event.once(V.onFinished)(()=>{V?.dispose(),this.queues.delete(z),this.onDidQueueFinish()}),this.queues.set(z,V)),V}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=I;class _{constructor(N,$){this._token=-1,typeof N=="function"&&typeof $=="number"&&this.setIfNotSet(N,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},$)}setIfNotSet(N,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},$))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,$){this.cancel(),this._token=setInterval(()=>{N()},$)}}e.IntervalTimer=O;class M{constructor(N,$){this.timeoutToken=-1,this.runner=N,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=M;class D{constructor(N,$){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=$,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=D;class U extends M{constructor(N,$){super(N,$);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class F extends T.Disposable{constructor(N,$){super();this.options=N,this.handler=$,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.options.maxBufferedWork)return!1}else if(this.pending+N.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,R.setTimeout0)(()=>{if(N)return;const $=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(B,N)=>{const $=requestIdleCallback(B,typeof N=="number"?{timeout:N}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback($))}}}}();class x{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function q(B,N,$){let z;for(let V=0;V<$;V++)try{return await B()}catch(ee){z=ee,await r(N)}throw z}e.retry=q;class G{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,$,z){return this._pending={taskId:N,cancel:()=>z?.(),promise:$},$.then(()=>this.donePending(N),()=>this.donePending(N)),$}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let $,z;const V=new Promise((ee,se)=>{$=ee,z=se});this._next={run:N,promise:V,promiseResolve:$,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=G;class te{constructor(N,$=()=>Date.now()){this.interval=N,this.nowFn=$,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,$)=>{this.completeCallback=N,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise($=>{this.completeCallback(N),this.resolved=!0,$()})}error(N){return new Promise($=>{this.errorCallback(N),this.rejected=!0,$()})}cancel(){new Promise(N=>{this.errorCallback(new t.CancellationError),this.rejected=!0,N()})}}e.DeferredPromise=W;var j;(function(B){async function N(z){let V;const ee=await Promise.all(z.map(se=>se.then(ae=>ae,ae=>{V||(V=ae)})));if(typeof V!="undefined")throw V;return ee}B.settled=N;function $(z){return new Promise(async(V,ee)=>{try{await z(V,ee)}catch(se){ee(se)}})}B.withAsyncBody=$})(j=e.Promises||(e.Promises={}));var J;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(J||(J={}));class H{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const $={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(N($)),this.resolve()}catch(z){this.reject(z)}finally{$.emitOne=void 0,$.emitMany=void 0,$.reject=void 0}})}static fromArray(N){return new H($=>{$.emitMany(N)})}static fromPromise(N){return new H(async $=>{$.emitMany(await N)})}static fromPromises(N){return new H(async $=>{await Promise.all(N.map(async z=>$.emitOne(await z)))})}static merge(N){return new H(async $=>{await Promise.all(N.map(async z=>{for await(const V of z)$.emitOne(V)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,$){return new H(async z=>{for await(const V of N)z.emitOne($(V))})}map(N){return H.map(this,N)}static filter(N,$){return new H(async z=>{for await(const V of N)$(V)&&z.emitOne(V)})}filter(N){return H.filter(this,N)}static coalesce(N){return H.filter(N,$=>!!$)}coalesce(){return H.coalesce(this)}static async toPromise(N){const $=[];for await(const z of N)$.push(z);return $}toPromise(){return H.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Q extends H{constructor(N,$){super($);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function Z(B){const N=new k.CancellationTokenSource,$=B(N.token);return new Q(N,async z=>{const V=N.token.onCancellationRequested(()=>{V.dispose(),N.dispose(),z.reject(new t.CancellationError)});try{for await(const ee of $){if(N.token.isCancellationRequested)return;z.emitOne(ee)}V.dispose(),N.dispose()}catch(ee){V.dispose(),N.dispose(),z.reject(ee)}})}e.createCancelableAsyncIterable=Z}),define(ne[109],ie([0,1,5,41,39,10,4,26]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",P="[^/\\\\]",b=/\//g;function f(W){switch(W){case 0:return"";case 1:return`${P}*?`;default:return`(?:${E}|${P}+${E}|${E}${P}+)*?`}}function p(W,j){if(!W)return[];const J=[];let H=!1,Q=!1,Z="";for(const B of W){switch(B){case j:if(!H&&!Q){J.push(Z),Z="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}Z+=B}return Z&&J.push(Z),J}e.splitGlobAware=p;function d(W){if(!W)return"";let j="";const J=p(W,e.GLOB_SPLIT);if(J.every(H=>H===e.GLOBSTAR))j=".*";else{let H=!1;J.forEach((Q,Z)=>{if(Q===e.GLOBSTAR){H||(j+=f(2),H=!0);return}let B=!1,N="",$=!1,z="";for(const V of Q){if(V!=="}"&&B){N+=V;continue}if($&&(V!=="]"||!z)){let ee;V==="-"?ee=V:(V==="^"||V==="!")&&!z?ee="^":V===e.GLOB_SPLIT?ee="":ee=(0,R.escapeRegExpCharacters)(V),z+=ee;continue}switch(V){case"{":B=!0;continue;case"[":$=!0;continue;case"}":{j+=`(?:${p(N,",").map(ae=>d(ae)).join("|")})`,B=!1,N="";break}case"]":j+="["+z+"]",$=!1,z="";break;case"?":j+=P;continue;case"*":j+=f(1);continue;default:j+=(0,R.escapeRegExpCharacters)(V)}}Z<J.length-1&&(J[Z+1]!==e.GLOBSTAR||Z+2<J.length)&&(j+=E),H=!1})}return j}const h=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new L.LRUCache(1e4),i=function(){return!1},c=function(){return null};function r(W,j){if(!W)return c;let J;typeof W!="string"?J=W.pattern:J=W,J=J.trim();const H=`${J}_${!!j.trimForExclusions}`;let Q=l.get(H);if(Q)return n(Q,W);let Z;if(h.test(J)){const B=J.substr(4);Q=function(N,$){return typeof N=="string"&&N.endsWith(B)?J:null}}else(Z=m.exec(s(J,j)))?Q=o(Z[1],J):(j.trimForExclusions?y:g).test(J)?Q=a(J,j):(Z=w.exec(s(J,j)))?Q=u(Z[1].substr(1),J,!0):(Z=S.exec(s(J,j)))?Q=u(Z[1],J,!1):Q=v(J);return l.set(H,Q),n(Q,W)}function n(W,j){return typeof j=="string"?W:function(J,H){return(0,t.isEqualOrParent)(J,j.base,!A.isLinux)?W(J.substr(j.base.length+1),H):null}}function s(W,j){return j.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function o(W,j){const J=`/${W}`,H=`\\${W}`,Q=function(B,N){return typeof B!="string"?null:N?N===W?j:null:B===W||B.endsWith(J)||B.endsWith(H)?j:null},Z=[W];return Q.basenames=Z,Q.patterns=[j],Q.allBasenames=Z,Q}function a(W,j){const J=te(W.slice(1,-1).split(",").map(N=>r(N,j)).filter(N=>N!==c),W),H=J.length;if(!H)return c;if(H===1)return J[0];const Q=function(N,$){for(let z=0,V=J.length;z<V;z++)if(J[z](N,$))return W;return null},Z=J.find(N=>!!N.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const B=J.reduce((N,$)=>$.allPaths?N.concat($.allPaths):N,[]);return B.length&&(Q.allPaths=B),Q}function u(W,j,J){const H=T.sep===T.posix.sep,Q=H?W:W.replace(b,T.sep),Z=T.sep+Q,B=T.posix.sep+W,N=J?function($,z){return typeof $=="string"&&($===Q||$.endsWith(Z)||!H&&($===W||$.endsWith(B)))?j:null}:function($,z){return typeof $=="string"&&($===Q||!H&&$===W)?j:null};return N.allPaths=[(J?"*/":"./")+W],N}function v(W){try{const j=new RegExp(`^${d(W)}$`);return function(J){return j.lastIndex=0,typeof J=="string"&&j.test(J)?W:null}}catch{return c}}function I(W,j,J){return!W||typeof j!="string"?!1:_(W)(j,void 0,J)}e.match=I;function _(W,j={}){if(!W)return i;if(typeof W=="string"||U(W)){const J=r(W,j);if(J===c)return i;const H=function(Q,Z){return!!J(Q,Z)};return J.allBasenames&&(H.allBasenames=J.allBasenames),J.allPaths&&(H.allPaths=J.allPaths),H}return q(W,j)}e.parse=_;function O(W){if(!W)return;let j;return J=>(j||(j=(W()||Promise.resolve([])).then(H=>H?D(H):{})),j.then(H=>!!H[J]))}e.hasSiblingPromiseFn=O;function M(W){if(!W)return;let j;return J=>{if(!j){const H=W();j=H?D(H):{}}return!!j[J]}}e.hasSiblingFn=M;function D(W){const j={};for(const J of W)j[J]=!0;return j}function U(W){const j=W;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=U;function F(W){return W.allBasenames||[]}e.getBasenameTerms=F;function x(W){return W.allPaths||[]}e.getPathTerms=x;function q(W,j){const J=te(Object.getOwnPropertyNames(W).map(N=>G(N,W[N],j)).filter(N=>N!==c)),H=J.length;if(!H)return c;if(!J.some(N=>!!N.requiresSiblings)){if(H===1)return J[0];const N=function(V,ee){for(let se=0,ae=J.length;se<ae;se++){const de=J[se](V,ee);if(de)return de}return null},$=J.find(V=>!!V.allBasenames);$&&(N.allBasenames=$.allBasenames);const z=J.reduce((V,ee)=>ee.allPaths?V.concat(ee.allPaths):V,[]);return z.length&&(N.allPaths=z),N}const Q=function(N,$,z){let V;for(let ee=0,se=J.length;ee<se;ee++){const ae=J[ee];ae.requiresSiblings&&z&&($||($=(0,T.basename)(N)),V||(V=$.substr(0,$.length-(0,T.extname)(N).length)));const de=ae(N,$,V,z);if(de)return de}return null},Z=J.find(N=>!!N.allBasenames);Z&&(Q.allBasenames=Z.allBasenames);const B=J.reduce((N,$)=>$.allPaths?N.concat($.allPaths):N,[]);return B.length&&(Q.allPaths=B),Q}function G(W,j,J){if(j===!1)return c;const H=r(W,J);if(H===c)return c;if(typeof j=="boolean")return H;if(j){const Q=j.when;if(typeof Q=="string"){const Z=(B,N,$,z)=>{if(!z||!H(B,N))return null;const V=Q.replace("$(basename)",$),ee=z(V);return(0,k.isThenable)(ee)?ee.then(se=>se?W:null):ee?W:null};return Z.requiresSiblings=!0,Z}}return H}function te(W,j){const J=W.filter(N=>!!N.basenames);if(J.length<2)return W;const H=J.reduce((N,$)=>{const z=$.basenames;return z?N.concat(z):N},[]);let Q;if(j){Q=[];for(let N=0,$=H.length;N<$;N++)Q.push(j)}else Q=J.reduce((N,$)=>{const z=$.patterns;return z?N.concat(z):N},[]);const Z=function(N,$){if(typeof N!="string")return null;if(!$){let V;for(V=N.length;V>0;V--){const ee=N.charCodeAt(V-1);if(ee===47||ee===92)break}$=N.substr(V)}const z=H.indexOf($);return z!==-1?Q[z]:null};Z.basenames=H,Z.patterns=Q,Z.allBasenames=H;const B=W.filter(N=>!N.basenames);return B.push(Z),B}}),define(ne[110],ie([0,1,7]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(P){return P.toJSON()}class L{constructor(b){this._uriTransformer=b}transformIncoming(b){const f=this._uriTransformer.transformIncoming(b);return f===b?b:t(k.URI.from(f))}transformOutgoing(b){const f=this._uriTransformer.transformOutgoing(b);return f===b?b:t(k.URI.from(f))}transformOutgoingURI(b){const f=this._uriTransformer.transformOutgoing(b);return f===b?b:k.URI.from(f)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function T(P,b,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof k.URI)return b.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const d=T(P[p],b,f+1);d!==null&&(P[p]=d)}}return null}function A(P,b){const f=T(P,b,0);return f===null?P:f}e.transformOutgoingURIs=A;function R(P,b,f,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?k.URI.revive(b.transformIncoming(P)):b.transformIncoming(P);for(let d in P)if(Object.hasOwnProperty.call(P,d)){const h=R(P[d],b,f,p+1);h!==null&&(P[d]=h)}}return null}function C(P,b){const f=R(P,b,!1,0);return f===null?P:f}e.transformIncomingURIs=C;function E(P,b){const f=R(P,b,!0,0);return f===null?P:f}e.transformAndReviveIncomingURIs=E}),define(ne[29],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return k.test(C)}e.isUUID=t;const L=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(C){for(let E=0;E<C.length;E++)C[E]=Math.floor(Math.random()*256);return C};function R(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let C=0,E="";return E+=T[L[C++]],E+=T[L[C++]],E+=T[L[C++]],E+=T[L[C++]],E+="-",E+=T[L[C++]],E+=T[L[C++]],E+="-",E+=T[L[C++]],E+=T[L[C++]],E+="-",E+=T[L[C++]],E+=T[L[C++]],E+="-",E+=T[L[C++]],E+=T[L[C++]],E+=T[L[C++]],E+=T[L[C++]],E+=T[L[C++]],E+=T[L[C++]],E}e.generateUuid=R}),define(ne[111],ie([0,1,251]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(T="utf8"){this.stringDecoder=new k.StringDecoder(T),this.remaining=null}write(T){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(R.length<1)return A;let C=0,E,P=C;for(;P<R.length;)if(E=R.charCodeAt(P),E===13||E===10){if(A.push(R.substring(C,P)),P++,P<R.length){const b=E;E=R.charCodeAt(P),(b===13&&E===10||b===10&&E===13)&&P++}C=P}else P++;return this.remaining=C<R.length?R.substr(C):null,A}end(){return this.remaining}}e.LineDecoder=t}),define(ne[112],ie([0,1,34]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const R=A.replace(/\-/g,":").toLowerCase();return!t.has(R)}function T(){const A=(0,k.networkInterfaces)();for(let R in A){const C=A[R];if(C){for(const{mac:E}of C)if(L(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ne[113],ie([0,1,34,9,39,29,112]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,b=0;const f=(0,k.networkInterfaces)();for(let p in f){const d=f[p];if(d)for(const{mac:h,internal:m}of d)m||(b+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(P+=1))}this._value=b>0?P/b:0}return this._value}};let R;async function C(){return R||(R=(async()=>await E()||T.generateUuid())()),R}e.getMachineId=C;async function E(){try{const P=await new Promise((f,p)=>{Y(["crypto"],f,p)}),b=(0,A.getMac)();return P.createHash("sha256").update(b,"utf8").digest("hex")}catch(P){t.onUnexpectedError(P);return}}}),define(ne[22],ie([0,1,50,34,252,5,41,72,10,4,21,7]),function(Y,e,k,t,L,T,A,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function p(F,x=f.UNLINK){if((0,A.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return x===f.UNLINK?h(F):d(F)}async function d(F){try{const x=(0,A.randomPath)((0,t.tmpdir)());try{await k.promises.rename(F,x)}catch{return h(F)}h(x).catch(q=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function h(F){return(0,L.promisify)(k.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,A.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function g(F,x){return S(await(x?y(F):(0,L.promisify)(k.readdir)(F)))}async function y(F){try{return await(0,L.promisify)(k.readdir)(F,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const x=[],q=await g(F);for(const G of q){let te=!1,W=!1,j=!1;try{const J=await e.Promises.lstat((0,C.join)(F,G));te=J.isFile(),W=J.isDirectory(),j=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}x.push({name:G,isFile:()=>te,isDirectory:()=>W,isSymbolicLink:()=>j})}return x}function w(F){return S(k.readdirSync(F))}e.readdirSync=w;function S(F){return F.map(x=>typeof x=="string"?E.isMacintosh?(0,R.normalizeNFC)(x):x:(x.name=E.isMacintosh?(0,R.normalizeNFC)(x.name):x.name,x))}async function l(F){const x=await g(F),q=[];for(const G of x)await c.existsDirectory((0,C.join)(F,G))&&q.push(G);return q}function i(F,x=1e3){return new Promise(q=>{let G=!1;const te=setInterval(()=>{G||(G=!0,k.access(F,W=>{G=!1,W&&(clearInterval(te),q(void 0))}))},x)})}e.whenDeleted=i;var c;(function(F){async function x(te){let W;try{if(W=await e.Promises.lstat(te),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(E.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw J}throw j}}F.stat=x;async function q(te){try{const{stat:W,symbolicLink:j}=await F.stat(te);return W.isFile()&&j?.dangling!==!0}catch{}return!1}F.existsFile=q;async function G(te){try{const{stat:W,symbolicLink:j}=await F.stat(te);return W.isDirectory()&&j?.dangling!==!0}catch{}return!1}F.existsDirectory=G})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new T.ResourceQueue;function n(F,x,q){return r.queueFor(b.URI.file(F),P.extUriBiasedIgnorePathCase).queue(()=>{const G=u(q);return new Promise((te,W)=>o(F,x,G,j=>j?W(j):te()))})}let s=!0;function o(F,x,q,G){if(!s)return k.writeFile(F,x,{mode:q.mode,flag:q.flag},G);k.open(F,q.flag,q.mode,(te,W)=>{if(te)return G(te);k.writeFile(W,x,j=>{if(j)return k.close(W,()=>G(j));k.fdatasync(W,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),s=!1),k.close(W,H=>G(H))))})})}function a(F,x,q){const G=u(q);if(!s)return k.writeFileSync(F,x,{mode:G.mode,flag:G.flag});const te=k.openSync(F,G.flag,G.mode);try{k.writeFileSync(te,x);try{k.fdatasyncSync(te)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),s=!1}}finally{k.closeSync(te)}}e.writeFileSync=a;function u(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function v(F,x){if(F===x)return;async function q(G){try{const te=await e.Promises.lstat(G);if(te.isDirectory()||te.isSymbolicLink())return;await e.Promises.utimes(G,te.atime,new Date)}catch{}}try{await e.Promises.rename(F,x),await q(x)}catch(G){if(F.toLowerCase()!==x.toLowerCase()&&G.code==="EXDEV"||F.endsWith("."))await I(F,x,{preserveSymlinks:!1}),await p(F,f.MOVE),await q(x);else throw G}}async function I(F,x,q){return O(F,x,{root:{source:F,target:x},options:q,handledSourcePaths:new Set})}const _=511;async function O(F,x,q){if(q.handledSourcePaths.has(F))return;q.handledSourcePaths.add(F);const{stat:G,symbolicLink:te}=await c.stat(F);if(te){if(q.options.preserveSymlinks)try{return await U(F,x,q)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(te.dangling)return}return G.isDirectory()?M(F,x,G.mode&_,q):D(F,x,G.mode&_)}async function M(F,x,q,G){await e.Promises.mkdir(x,{recursive:!0,mode:q});const te=await g(F);for(const W of te)await O((0,C.join)(F,W),(0,C.join)(x,W),G)}async function D(F,x,q){await e.Promises.copyFile(F,x),await e.Promises.chmod(x,q)}async function U(F,x,q){let G=await e.Promises.readlink(F);(0,A.isEqualOrParent)(G,q.root.source,!E.isLinux)&&(G=(0,C.join)(q.root.target,G.substr(q.root.source.length+1))),await e.Promises.symlink(G,x)}e.Promises=new class{get access(){return(0,L.promisify)(k.access)}get stat(){return(0,L.promisify)(k.stat)}get lstat(){return(0,L.promisify)(k.lstat)}get utimes(){return(0,L.promisify)(k.utimes)}get read(){return(F,x,q,G,te)=>new Promise((W,j)=>{k.read(F,x,q,G,te,(J,H,Q)=>J?j(J):W({bytesRead:H,buffer:Q}))})}get readFile(){return(0,L.promisify)(k.readFile)}get write(){return(F,x,q,G,te)=>new Promise((W,j)=>{k.write(F,x,q,G,te,(J,H,Q)=>J?j(J):W({bytesWritten:H,buffer:Q}))})}get appendFile(){return(0,L.promisify)(k.appendFile)}get fdatasync(){return(0,L.promisify)(k.fdatasync)}get truncate(){return(0,L.promisify)(k.truncate)}get rename(){return(0,L.promisify)(k.rename)}get copyFile(){return(0,L.promisify)(k.copyFile)}get open(){return(0,L.promisify)(k.open)}get close(){return(0,L.promisify)(k.close)}get symlink(){return(0,L.promisify)(k.symlink)}get readlink(){return(0,L.promisify)(k.readlink)}get chmod(){return(0,L.promisify)(k.chmod)}get mkdir(){return(0,L.promisify)(k.mkdir)}get unlink(){return(0,L.promisify)(k.unlink)}get rmdir(){return(0,L.promisify)(k.rmdir)}get realpath(){return(0,L.promisify)(k.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return l}get writeFile(){return n}get rm(){return p}get move(){return v}get copy(){return I}}}),define(ne[114],ie([0,1,50,10,4,26,22]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(L.isLinux)return f;const p=(0,t.dirname)(f);if(f===p)return f;const d=((0,t.basename)(f)||f).toLowerCase();try{const m=(0,A.readdirSync)(p).filter(g=>g.toLowerCase()===d);if(m.length===1){const g=R(p);if(g)return(0,t.join)(g,m[0])}else if(m.length>1){const g=m.indexOf(d);if(g>=0){const y=R(p);if(y)return(0,t.join)(y,m[g])}}}catch{}return null}e.realcaseSync=R;async function C(f){if(L.isLinux)return f;const p=(0,t.dirname)(f);if(f===p)return f;const d=((0,t.basename)(f)||f).toLowerCase();try{const m=(await A.Promises.readdir(p)).filter(g=>g.toLowerCase()===d);if(m.length===1){const g=await C(p);if(g)return(0,t.join)(g,m[0])}else if(m.length>1){const g=m.indexOf(d);if(g>=0){const y=await C(p);if(y)return(0,t.join)(y,m[g])}}}catch{}return null}e.realcase=C;async function E(f){try{return await A.Promises.realpath(f)}catch{const d=b(f);return await A.Promises.access(d,k.constants.R_OK),d}}e.realpath=E;function P(f){try{return k.realpathSync(f)}catch{const d=b(f);return k.accessSync(d,k.constants.R_OK),d}}e.realpathSync=P;function b(f){return(0,T.rtrim)((0,t.normalize)(f),t.sep)}}),define(ne[115],ie([0,1,56]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(R,C,E,P=1){let b=!1;return new Promise(f=>{const p=setTimeout(()=>{if(!b)return b=!0,f(0)},E);L(R,C,P,d=>{if(!b)return b=!0,clearTimeout(p),f(d)})})}e.findFreePort=t;function L(R,C,E,P){if(C===0)return P(0);const b=new k.Socket;b.once("connect",()=>(A(b),L(R+E,C-1,E,P))),b.once("data",()=>{}),b.once("error",f=>(A(b),f.code!=="ECONNREFUSED"?L(R+E,C-1,E,P):P(R))),b.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,C,E){let P=!1,b,f=1;const p=k.createServer({pauseOnConnect:!0});function d(h,m){P||(P=!0,p.removeAllListeners(),p.close(),b&&clearTimeout(b),m(h))}return new Promise(h=>{b=setTimeout(()=>{d(0,h)},E),p.on("listening",()=>{d(R,h)}),p.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&f<C?(R++,f++,p.listen(R,"127.0.0.1")):d(0,h)}),p.on("close",()=>{d(0,h)}),p.listen(R,"127.0.0.1")})}e.findFreePortFaster=T;function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(ne[73],ie([0,1,34,10,22]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var C;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(C||(C={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class b{constructor(l,i,c){this.exePath=l,this.displayName=i,this.knownToExist=c}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:S=!1}={}){return S?E===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:S=!1,findPreview:l=!1}={}){const i=f({useAlternateBitness:S});if(!i)return null;const c=t.join(i,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(c))return null;let r=-1,n=null;for(const a of await L.Promises.readdir(c)){let u=-1;if(l){const I=a.indexOf("-");if(I<0)continue;const _=a.substring(0,I);if(!T.test(_)||a.substring(I+1)!=="preview")continue;u=parseInt(_,10)}else{if(!T.test(a))continue;u=parseInt(a,10)}if(u<=r)continue;const v=t.join(c,a,"pwsh.exe");!await L.SymlinkSupport.existsFile(v)||(n=v,r=u)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=l?" Preview":"";return new b(n,`PowerShell${o}${s}`,!0)}async function d({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:c}=S?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await L.Promises.readdir(l))if(i.test(r)){const n=t.join(l,r,"pwsh.exe");return new b(n,c)}return null}function h(){const S=t.join(k.homedir(),".dotnet","tools","pwsh.exe");return new b(S,".NET Core PowerShell Global Tool")}function m(){const S=t.join(process.env.windir,E===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(S,"Windows PowerShell",!0)}async function*g(){let S=await p();S&&(yield S),S=await p({useAlternateBitness:!0}),S&&(yield S),S=await d(),S&&(yield S),S=h(),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await d({findPreview:!0}),S&&(yield S),S=await p({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=m(),S&&(yield S)}async function*y(){for await(const S of g())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=y;async function w(){for await(const S of y())return S;return null}e.getFirstAvailablePowerShellInstallation=w}),define(ne[116],ie([0,1,46,18]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((R,C)=>{let E;const P=new Map;function b(p,d,h,m,g){const y=P.get(d);if(p===A||y){const w={name:f(h),cmd:h,pid:p,ppid:d,load:m,mem:g};P.set(p,w),p===A&&(E=w),y&&(y.children||(y.children=[]),y.children.push(w),y.children.length>1&&(y.children=y.children.sort((S,l)=>S.pid-l.pid)))}}function f(p){const d=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,y=/--crashes-directory/,w=/\\pipe\\winpty-control/,S=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(y.exec(p))return"electron-crash-reporter";if(w.exec(p))return"winpty-process";if(S.exec(p))return"console-window-host (Windows internal process)";let i=l.exec(p);if(i&&i.length===2)return i[1]==="renderer"?d.exec(p)?"shared-process":h.exec(p)?"issue-reporter":m.exec(p)?"process-explorer":"window":i[1]==="utility"&&g.exec(p)?"utility-network-service":i[1];const c=/[a-zA-Z-]+\.js/g;let r="";do i=c.exec(p),i&&(r+=i+" ");while(i);return r&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${r}`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,h)=>{Y(["windows-process-tree"],d,h)}).then(d=>{d.getProcessList(A,h=>{d.getProcessCpuUsage(h,m=>{const g=new Map;m.forEach(y=>{const w=p(y.commandLine||"");g.set(y.pid,{name:f(w),cmd:w,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),E=g.get(A),E?(g.forEach(y=>{const w=g.get(y.ppid);w&&(w.children||(w.children=[]),w.children.push(y))}),g.forEach(y=>{y.children&&(y.children=y.children.sort((w,S)=>w.pid-S.pid))}),R(E)):C(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[E];const h=[];for(;d.length;){const g=d.shift();g&&(h.push(g.pid),g.children&&(d=d.concat(g.children)))}let m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);m+=" "+h.join(" "),(0,k.exec)(m,{},(g,y,w)=>{if(g||w)C(g||new Error(w.toString()));else{const S=y.toString().split(`
`);for(let l=0;l<h.length;l++){const i=P.get(h[l]);i.load=parseFloat(S[l])}if(!E){C(new Error(`Root process ${A} not found`));return}R(E)}})};(0,k.exec)("which ps",{},(d,h,m)=>{if(d||m)if(process.platform!=="linux")C(d||new Error(m.toString()));else{const g=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,k.exec)(g,{},(y,w,S)=>{y||S?C(y||new Error(S.toString())):(T(w,b),p())})}else{const g=h.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${g} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,S,l)=>{w||l&&!l.includes("screen size is bogus")?C(w||new Error(l.toString())):(T(S,b),process.platform==="linux"?p():E?R(E):C(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=A.toString().split(`
`);for(const P of E){const b=C.exec(P.trim());b&&b.length===6&&R(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var he=this&&this.__decorate||function(Y,e,k,t){var L=arguments.length,T=L<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,k):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Y,e,k,t);else for(var R=Y.length-1;R>=0;R--)(A=Y[R])&&(T=(L<3?A(T):L>3?A(e,k,T):A(e,k))||T);return L>3&&T&&Object.defineProperty(e,k,T),T};define(ne[36],ie([0,1,16,5,17,25,54,9,3,2,108,26,15]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function m(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(g||(g={}));class y{constructor(j){this.buffer=j,this.pos=0}read(j){const J=this.buffer.slice(this.pos,this.pos+j);return this.pos+=J.byteLength,J}}class w{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var S;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(S||(S={}));function l(W){const j=L.VSBuffer.alloc(4);return j.writeUInt32BE(W,0),j}function i(W){return W.read(4).readUInt32BE(0)}function c(W){const j=L.VSBuffer.alloc(1);return j.writeUInt8(W,0),j}const r={Undefined:c(S.Undefined),String:c(S.String),Buffer:c(S.Buffer),VSBuffer:c(S.VSBuffer),Array:c(S.Array),Object:c(S.Object)},n=typeof Buffer!="undefined";function s(W,j){if(typeof j=="undefined")W.write(r.Undefined);else if(typeof j=="string"){const J=L.VSBuffer.fromString(j);W.write(r.String),W.write(l(J.byteLength)),W.write(J)}else if(n&&Buffer.isBuffer(j)){const J=L.VSBuffer.wrap(j);W.write(r.Buffer),W.write(l(J.byteLength)),W.write(J)}else if(j instanceof L.VSBuffer)W.write(r.VSBuffer),W.write(l(j.byteLength)),W.write(j);else if(Array.isArray(j)){W.write(r.Array),W.write(l(j.length));for(const J of j)s(W,J)}else{const J=L.VSBuffer.fromString(JSON.stringify(j));W.write(r.Object),W.write(l(J.byteLength)),W.write(J)}}function o(W){switch(W.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return W.read(i(W)).toString();case S.Buffer:return W.read(i(W)).buffer;case S.VSBuffer:return W.read(i(W));case S.Array:{const J=i(W),H=[];for(let Q=0;Q<J;Q++)H.push(o(W));return H}case S.Object:return JSON.parse(W.read(i(W)).toString())}}class a{constructor(j,J,H=null,Q=1e3){this.protocol=j,this.ctx=J,this.logger=H,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Z=>this.onRawMessage(Z)),this.sendResponse({type:200})}registerChannel(j,J){this.channels.set(j,J),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const J=this.send([j.type]);this.logger&&this.logger.logOutgoing(J,0,1,m(j.type));return}case 201:case 202:case 204:case 203:{const J=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(J,j.id,1,m(j.type),j.data);return}}}send(j,J=void 0){const H=new w;return s(H,j),s(H,J),this.sendBuffer(H.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const J=new y(j),H=o(J),Q=o(J),Z=H[0];switch(Z){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],1,`${d(Z)}: ${H[2]}.${H[3]}`,Q),this.onPromise({type:Z,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],1,`${d(Z)}: ${H[2]}.${H[3]}`,Q),this.onEventListen({type:Z,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],1,`${d(Z)}`),this.disposeActiveRequest({type:Z,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],1,`${d(Z)}`),this.disposeActiveRequest({type:Z,id:H[1]})}}onPromise(j){const J=this.channels.get(j.channelName);if(!J){this.collectPendingRequest(j);return}const H=new T.CancellationTokenSource;let Q;try{Q=J.call(this.ctx,j.name,j.arg,H.token)}catch(N){Q=Promise.reject(N)}const Z=j.id;Q.then(N=>{this.sendResponse({id:Z,data:N,type:201}),this.activeRequests.delete(j.id)},N=>{N instanceof Error?this.sendResponse({id:Z,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:Z,data:N,type:203}),this.activeRequests.delete(j.id)});const B=(0,E.toDisposable)(()=>H.cancel());this.activeRequests.set(j.id,B)}onEventListen(j){const J=this.channels.get(j.channelName);if(!J){this.collectPendingRequest(j);return}const H=j.id,Z=J.listen(this.ctx,j.name,j.arg)(B=>this.sendResponse({id:H,data:B,type:204}));this.activeRequests.set(j.id,Z)}disposeActiveRequest(j){const J=this.activeRequests.get(j.id);J&&(J.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let J=this.pendingRequests.get(j.channelName);J||(J=[],this.pendingRequests.set(j.channelName,J));const H=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:j,timeoutTimer:H})}flushPendingRequests(j){const J=this.pendingRequests.get(j);if(J){for(const H of J)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=a;var u;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(j,J=null){this.protocol=j,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=J}getChannel(j){const J=this;return{call(H,Q,Z){return J.isDisposed?Promise.reject(R.canceled()):J.requestPromise(j,H,Q,Z)},listen(H,Q){return J.isDisposed?Promise.reject(R.canceled()):J.requestEvent(j,H,Q)}}}requestPromise(j,J,H,Q=T.CancellationToken.None){const Z=this.lastRequestId++,N={id:Z,type:100,channelName:j,name:J,arg:H};if(Q.isCancellationRequested)return Promise.reject(R.canceled());let $;return new Promise((V,ee)=>{if(Q.isCancellationRequested)return ee(R.canceled());const se=()=>{const be=Se=>{switch(Se.type){case 201:this.handlers.delete(Z),V(Se.data);break;case 202:{this.handlers.delete(Z);const pe=new Error(Se.data.message);pe.stack=Se.data.stack,pe.name=Se.data.name,ee(pe);break}case 203:this.handlers.delete(Z),ee(Se.data);break}};this.handlers.set(Z,be),this.sendRequest(N)};let ae=null;this.state===g.Idle?se():(ae=(0,t.createCancelablePromise)(be=>this.whenInitialized()),ae.then(()=>{ae=null,se()}));const de=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:Z,type:101}),ee(R.canceled())},ve=Q.onCancellationRequested(de);$=(0,E.combinedDisposable)((0,E.toDisposable)(de),ve),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(j,J,H){const Q=this.lastRequestId++,B={id:Q,type:102,channelName:j,name:J,arg:H};let N=null;const $=new C.Emitter({onFirstListenerAdd:()=>{N=(0,t.createCancelablePromise)(V=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add($),this.sendRequest(B)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete($),this.sendRequest({id:Q,type:103}))}}),z=V=>$.fire(V.data);return this.handlers.set(Q,z),$.event}sendRequest(j){switch(j.type){case 100:case 102:{const J=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(J,j.id,0,`${d(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const J=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(J,j.id,0,d(j.type));return}}}send(j,J=void 0){const H=new w;return s(H,j),s(H,J),this.sendBuffer(H.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const J=new y(j),H=o(J),Q=o(J),Z=H[0];switch(Z){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,m(Z)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,H[1],0,m(Z),Q),this.onResponse({type:H[0],id:H[1],data:Q})}}onResponse(j){if(j.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const J=this.handlers.get(j.id);J&&J(j)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}he([A.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class I{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:J,onDidClientDisconnect:H})=>{C.Event.once(J.onMessage)(Z=>{const B=new y(Z),N=o(B),$=new a(J,N),z=new v(J);this.channels.forEach((ee,se)=>$.registerChannel(se,ee));const V={channelServer:$,channelClient:z,ctx:N};this._connections.add(V),this._onDidAddConnection.fire(V),H(()=>{$.dispose(),z.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const j=[];return this._connections.forEach(J=>j.push(J)),j}getChannel(j,J){const H=this;return{call(Q,Z,B){let N;if((0,f.isFunction)(J)){let z=(0,k.getRandomElement)(H.connections.filter(J));N=z?Promise.resolve(z):C.Event.toPromise(C.Event.filter(H.onDidAddConnection,J))}else N=J.routeCall(H,Q,Z);const $=N.then(z=>z.channelClient.getChannel(j));return O($).call(Q,Z,B)},listen(Q,Z){if((0,f.isFunction)(J))return H.getMulticastEvent(j,J,Q,Z);const B=J.routeEvent(H,Q,Z).then(N=>N.channelClient.getChannel(j));return O(B).listen(Q,Z)}}}getMulticastEvent(j,J,H,Q){const Z=this;let B=new E.DisposableStore;const N=new C.Emitter({onFirstListenerAdd:()=>{B=new E.DisposableStore;const $=new C.EventMultiplexer,z=new Map,V=se=>{const de=se.channelClient.getChannel(j).listen(H,Q),ve=$.add(de);z.set(se,ve)},ee=se=>{const ae=z.get(se);!ae||(ae.dispose(),z.delete(se))};Z.connections.filter(J).forEach(V),C.Event.filter(Z.onDidAddConnection,J)(V,void 0,B),Z.onDidRemoveConnection(ee,void 0,B),$.event(N.fire,N,B),B.add($)},onLastListenerRemove:()=>{B.dispose()}});return N.event}registerChannel(j,J){this.channels.set(j,J),this._connections.forEach(H=>{H.channelServer.registerChannel(j,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class _{constructor(j,J,H=null){const Q=new w;s(Q,J),j.send(Q.buffer),this.channelClient=new v(j,H),this.channelServer=new a(j,J,H)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,J){this.channelServer.registerChannel(j,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(W){return{call(j,J,H){return W.then(Q=>Q.call(j,J,H))},listen(j,J){const H=new C.Relay;return W.then(Q=>H.input=Q.listen(j,J)),H.event}}}e.getDelayedChannel=O;function M(W){let j=!1;return{call(J,H,Q){return j?W.call(J,H,Q):(0,t.timeout)(0).then(()=>j=!0).then(()=>W.call(J,H,Q))},listen(J,H){if(j)return W.listen(J,H);const Q=new C.Relay;return(0,t.timeout)(0).then(()=>j=!0).then(()=>Q.input=W.listen(J,H)),Q.event}}}e.getNextTickChannel=M;class D{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const J of j.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await C.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=D;var U;(function(W){function j(Z,B){const N=Z,$=B&&B.disableMarshalling,z=new Map;for(const V in N)H(V)&&z.set(V,C.Event.buffer(N[V],!0));return new class{listen(V,ee,se){const ae=z.get(ee);if(ae)return ae;if(Q(ee)){const de=N[ee];if(typeof de=="function")return de.call(N,se)}throw new Error(`Event not found: ${ee}`)}call(V,ee,se){const ae=N[ee];if(typeof ae=="function"){if(!$&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=(0,P.revive)(se[de]);return ae.apply(N,se)}throw new Error(`Method not found: ${ee}`)}}}W.fromService=j;function J(Z,B){const N=B&&B.disableMarshalling;return new Proxy({},{get($,z){if(typeof z=="string")return B?.properties?.has(z)?B.properties.get(z):Q(z)?function(V){return Z.listen(z,V)}:H(z)?Z.listen(z):async function(...V){let ee;B&&!(0,f.isUndefinedOrNull)(B.context)?ee=[B.context,...V]:ee=V;const se=await Z.call(z,ee);return N?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}W.toService=J;function H(Z){return Z[0]==="o"&&Z[1]==="n"&&b.isUpperAsciiLetter(Z.charCodeAt(2))}function Q(Z){return/^onDynamic/.test(Z)&&b.isUpperAsciiLetter(Z.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let j=W.toString();if(j!=="[object Object]")return j}return W}function q(W){return Array.isArray(W)?W.map(x):x(W)}function G(W,j,J,H,Q,Z,B){B=q(B);const N=F[Q],$=N[H%N.length];let z=[`%c[${W}]%c[${String(j).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(Z)?(z=z.concat(B),z.push(")")):z.push(B),console.log.apply(console,z)}e.logWithColors=G;class te{constructor(j,J){this._outgoingPrefix=j,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,J,H,Q,Z){this._totalOutgoing+=j,G(this._outgoingPrefix,this._totalOutgoing,j,J,H,Q,Z)}logIncoming(j,J,H,Q,Z){this._totalIncoming+=j,G(this._incomingPrefix,this._totalIncoming,j,J,H,Q,Z)}}e.IPCLogger=te}),define(ne[117],ie([0,1,17,3,36]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(C){this.port=C,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",E=>k.VSBuffer.wrap(E.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(C,E){const P=new T(C);super(P,E);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[74],ie([0,1,17,3,2,36]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const s=new WeakMap;let o=0;function a(v,I){if(!s.has(v)){const _=String(++o);s.set(v,_)}return s.get(v)}function u(v,I,_,O){if(!n.enableDiagnostics)return;const M=a(v,I);if(O instanceof k.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const D=k.VSBuffer.alloc(O.byteLength);D.set(O),n.records.push({timestamp:Date.now(),id:M,label:I,type:_,buff:D})}else n.records.push({timestamp:Date.now(),id:M,label:I,type:_,data:O})}n.traceSocketEvent=u})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function P(){return E||(E=k.VSBuffer.alloc(0)),E}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),I}if(this._chunks[0].byteLength>s){const I=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),I}let a=k.VSBuffer.alloc(s),u=0,v=0;for(;s>0;){const I=this._chunks[v];if(I.byteLength>s){const _=I.slice(0,s);a.set(_,u),u+=s,o&&(this._chunks[v]=I.slice(s),this._totalLength-=s),s-=s}else a.set(I,u),u+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):v++,s-=I.byteLength}return a}}e.ChunkStream=b;var f;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume"})(f||(f={}));function p(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(s,o,a,u){this.type=s,this.id=o,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.Disposable{constructor(s){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,u=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new h(a,u,v,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=k.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const a=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,a}_bufferTake(){const s=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class y extends L.Disposable{constructor(s){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new h(1,0,0,s))}}e.Protocol=y;class w extends T.IPCClient{constructor(s,o,a=null){super(s,o,a);this.protocol=s}static fromSocket(s,o){return new w(new y(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=w;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class l{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,a=this._first;for(;a;)s[o++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new l(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<c._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=c._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),o=(1+c._HISTORY_LENGTH)*1e3;let a=0;for(let u=0;u<c._HISTORY_LENGTH;u++)s-this.lastRuns[u]<=o&&a++;return 1-a/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class r{constructor(s,o=null,a=c.getInstance()){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new h(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new h(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new h(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let a=0,u=o.length;a<u;a++)this._socketWriter.write(o[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new h(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let a=0,u=o.length;a<u;a++)this._socketWriter.write(o[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const o=new h(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&a>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const v=Math.max(2e4-o,2e4-a,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=r}),define(ne[118],ie([0,1,75,3,36,117]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const C=t.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(E,P)=>P);return t.Event.map(C,E=>{const{port1:P,port2:b}=new MessageChannel,p={protocol:new T.Protocol(P),onDidClientDisconnect:t.Event.fromDOMEventEmitter(P,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[b]),p})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[119],ie([0,1,17,9]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(R,C){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((P,b)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),T(E,R),E.responseType="arraybuffer",E.onerror=f=>b(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{P({res:{statusCode:E.status,headers:A(E)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>b(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),C.onCancellationRequested(()=>{E.abort(),b((0,t.canceled)())})})}e.request=L;function T(R,C){if(C.headers){e:for(let E in C.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,C.headers[E])}}}function A(R){const C=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const P=E.indexOf(":");C[E.substr(0,P).trim().toLowerCase()]=E.substr(P+1).trim()}return C}}),define(ne[76],ie([0,1,5,3,2,15]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function R(b){const f=b;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var C;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(C||(C={}));class E extends L.Disposable{constructor(f,p=Object.create(null)){super();this.database=f,this.options=p,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((p,d)=>this.accept(d,p)),f.deleted?.forEach(p=>this.accept(p,void 0))}accept(f,p){if(this.state===C.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(p)?d=this.cache.delete(f):this.cache.get(f)!==p&&(this.cache.set(f,p),d=!0),d&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,p){const d=this.cache.get(f);return(0,T.isUndefinedOrNull)(d)?p:d}getBoolean(f,p){const d=this.get(f);return(0,T.isUndefinedOrNull)(d)?p:d==="true"}getNumber(f,p){const d=this.get(f);return(0,T.isUndefinedOrNull)(d)?p:parseInt(d,10)}async set(f,p){if(this.state===C.Closed)return;if((0,T.isUndefinedOrNull)(p))return this.delete(f);const d=String(p);if(this.cache.get(f)!==d)return this.cache.set(f,d),this.pendingInserts.set(f,d),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===C.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((p,d)=>this.items.set(d,p)),f.delete&&f.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(ne[120],ie([12,13]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ne[57],ie([0,1,120]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,L=t*60,T=L*24,A=T*7,R=T*30,C=T*365;function E(b,f,p){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,k.localize)(0,null,E(new Date().getTime()+d*1e3,!1));if(d<30)return(0,k.localize)(1,null);let h;return d<t?(h=d,f?h===1?p?(0,k.localize)(2,null,h):(0,k.localize)(3,null,h):p?(0,k.localize)(4,null,h):(0,k.localize)(5,null,h):h===1?p?(0,k.localize)(6,null,h):(0,k.localize)(7,null,h):p?(0,k.localize)(8,null,h):(0,k.localize)(9,null,h)):d<L?(h=Math.floor(d/t),f?h===1?p?(0,k.localize)(10,null,h):(0,k.localize)(11,null,h):p?(0,k.localize)(12,null,h):(0,k.localize)(13,null,h):h===1?p?(0,k.localize)(14,null,h):(0,k.localize)(15,null,h):p?(0,k.localize)(16,null,h):(0,k.localize)(17,null,h)):d<T?(h=Math.floor(d/L),f?h===1?p?(0,k.localize)(18,null,h):(0,k.localize)(19,null,h):p?(0,k.localize)(20,null,h):(0,k.localize)(21,null,h):h===1?p?(0,k.localize)(22,null,h):(0,k.localize)(23,null,h):p?(0,k.localize)(24,null,h):(0,k.localize)(25,null,h)):d<A?(h=Math.floor(d/T),f?h===1?(0,k.localize)(26,null,h):(0,k.localize)(27,null,h):h===1?(0,k.localize)(28,null,h):(0,k.localize)(29,null,h)):d<R?(h=Math.floor(d/A),f?h===1?p?(0,k.localize)(30,null,h):(0,k.localize)(31,null,h):p?(0,k.localize)(32,null,h):(0,k.localize)(33,null,h):h===1?p?(0,k.localize)(34,null,h):(0,k.localize)(35,null,h):p?(0,k.localize)(36,null,h):(0,k.localize)(37,null,h)):d<C?(h=Math.floor(d/R),f?h===1?p?(0,k.localize)(38,null,h):(0,k.localize)(39,null,h):p?(0,k.localize)(40,null,h):(0,k.localize)(41,null,h):h===1?p?(0,k.localize)(42,null,h):(0,k.localize)(43,null,h):p?(0,k.localize)(44,null,h):(0,k.localize)(45,null,h)):(h=Math.floor(d/C),f?h===1?p?(0,k.localize)(46,null,h):(0,k.localize)(47,null,h):p?(0,k.localize)(48,null,h):(0,k.localize)(49,null,h):h===1?p?(0,k.localize)(50,null,h):(0,k.localize)(51,null,h):p?(0,k.localize)(52,null,h):(0,k.localize)(53,null,h))}e.fromNow=E;function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ne[121],ie([12,13]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,15,121]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(E,P){return P&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),A(E.stack)||A(E.stacktrace)):R(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function C(E=null,P=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const b=k.coalesce(E),f=C(b[0],P);return b.length>1?L.localize(4,null,f,b.length):f}if(t.isString(E))return E;if(E.detail){const b=E.detail;if(b.error)return T(b.error,P);if(b.exception)return T(b.exception,P)}return E.stack?T(E,P):E.message?E.message:L.localize(5,null)}e.toErrorMessage=C}),define(ne[122],ie([12,13]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(ne[77],ie([0,1,46,41,18,28,10,4,33,103,15,111,22,122]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function d(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(i,c){if(R.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};c&&(r.cwd=c);const n=k.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],r);return new Promise(s=>{n.once("error",o=>{s({success:!1,error:o})}),n.once("exit",(o,a)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?d(r.status):1})}else if(R.isLinux||R.isMacintosh)try{const r=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(n=>{k.execFile(r,[i.pid.toString()],{encoding:"utf8",shell:!0},(s,o,a)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function m(i){!i||(delete i.DEBUG,R.isMacintosh&&delete i.DYLD_LIBRARY_PATH,R.isLinux&&delete i.LD_PRELOAD)}e.removeDangerousEnvVariables=m;function g(i=C.env){return i.comspec||"cmd.exe"}e.getWindowsShell=g;class y{constructor(c,r,n,s){if(r!==void 0&&n!==void 0&&s!==void 0)this.cmd=c,this.args=r,this.shell=n,this.options=s;else{const o=c;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(C.env).forEach(a=>{o[a]=C.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const r=c.lastIndexOf(A.sep);return r!==-1&&(c=c.substring(r+1)),y.WellKnowCommands[c]?c:"other"}start(c){return R.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(C.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let n,s;const o=new Promise((a,u)=>{n=a,s=u});if(r){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(u,v,I)=>{this.childProcess=null;const _=u;_&&_.killed?s({killed:this.terminateRequested,stdout:v.toString(),stderr:I.toString()}):this.handleExec(n,c,u,v,I)})}else{let a=null;const u=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,n,c,s);const I={terminated:this.terminateRequested};P.isNumber(v)&&(I.cmdCode=v),n(I)};if(this.shell&&R.isWindows){const v=T.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let I=!1,_=!1;const O=[];let M=this.ensureQuotes(this.cmd);O.push(M.value),I=M.quoted,this.args&&this.args.forEach(U=>{M=this.ensureQuotes(U),O.push(M.value),_=_&&M.quoted});const D=["/s","/c"];I?_?D.push('"'+O.join(" ")+'"'):O.length>1?D.push('"'+O[0]+'" '+O.slice(1).join(" ")):D.push('"'+O[0]+'"'):D.push(O.join(" ")),a=k.spawn(g(),D,v)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(P.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",v=>{this.childProcess=null,s({terminated:this.terminateRequested,error:v})}),a.pid&&(this.childProcess.on("close",u),this.handleSpawn(a,n,c,s,!0)))}return o})}handleClose(c,r,n,s){}ensureQuotes(c){return y.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,h(c,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!R.isWindows)return c(!1);const r=k.spawn(g(),["/s","/c"]);r.on("error",n=>c(!0)),r.on("exit",n=>c(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class w extends y{constructor(c,r,n,s){super(c,r,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,r,n,s,o){[s,o].forEach((a,u)=>{const v=new b.LineDecoder;v.write(a).forEach(O=>{r({line:O,source:u===0?0:1})});const _=v.end();_&&r({line:_,source:u===0?0:1})}),c({terminated:this.terminateRequested,error:n})}handleSpawn(c,r,n,s,o){const a=new b.LineDecoder,u=new b.LineDecoder;c.stdout.on("data",v=>{a.write(v).forEach(_=>n({line:_,source:0}))}),c.stderr.on("data",v=>{u.write(v).forEach(_=>n({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=u}handleClose(c,r,n,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&n({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}e.LineProcess=w;function S(i){let c=[],r=!1;const n=function(s){if(r){c.push(s);return}(!i.send(s,a=>{if(a&&console.error(a),r=!1,c.length>0){const u=c.slice(0);c=[],u.forEach(v=>n(v))}})||R.isWindows)&&(r=!0)};return{send:n}}e.createQueuedSender=S;var l;(function(i){async function c(r,n,s){if(A.isAbsolute(r))return r;if(n===void 0&&(n=C.cwd()),A.dirname(r)!=="."||(s===void 0&&P.isString(C.env.PATH)&&(s=C.env.PATH.split(A.delimiter)),s===void 0||s.length===0))return A.join(n,r);async function a(u){if(await f.Promises.exists(u)){let v;try{v=await f.Promises.stat(u)}catch(I){I.message.startsWith("EACCES")&&(v=await f.Promises.lstat(u))}return v?!v.isDirectory():!1}return!1}for(let u of s){let v;if(A.isAbsolute(u)?v=A.join(u,r):v=A.join(n,u,r),await a(v))return v;let I=v+".com";if(await a(I)||(I=v+".exe",await a(I)))return I}return A.join(n,r)}i.findExecutable=c})(l=e.win32||(e.win32={}))}),define(ne[123],ie([0,1,34,4,73,77]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(p,d){return p===1?t.isWindows?b():T.getWindowsShell(d):E(p,d)}e.getSystemShell=A;function R(p,d){return p===1?t.isWindows?f(d):T.getWindowsShell(d):E(p,d)}e.getSystemShellSync=R;let C=null;function E(p,d){if(t.isLinux&&p===2||t.isMacintosh&&p===3)return"/bin/bash";if(!C){let h;if(t.isWindows)h="/bin/bash";else{if(h=d.SHELL,!h)try{h=(0,k.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}C=h}return C}let P=null;async function b(){return P||(P=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),P}function f(p){if(P)return P;const d=t.isWindows&&parseFloat((0,k.release)())>=10,h=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${p.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?m:T.getWindowsShell(p)}}),define(ne[58],ie([0,1,46,5,17,25,107,9,3,2,28,77,36]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(m){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",g=>L.VSBuffer.wrap(Buffer.from(g,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=p;class d{constructor(m,g){this.modulePath=m,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new t.Delayer(y),this.child=null,this._client=null}getChannel(m){const g=this;return{call(y,w,S){return g.requestPromise(m,y,w,S)},listen(y,w){return g.requestEvent(m,y,w)}}}requestPromise(m,g,y,w=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(m),l=(0,t.createCancelablePromise)(r=>S.call(g,y,r)),i=w.onCancellationRequested(()=>l.cancel()),c=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(c),l.finally(()=>{i.dispose(),this.activeRequests.delete(c),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(m,g,y){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let w;const S=new C.Emitter({onFirstListenerAdd:()=>{w=this.getCachedChannel(m).listen(g,y)(S.fire,S),this.activeRequests.add(w)},onLastListenerRemove:()=>{this.activeRequests.delete(w),w.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,b.removeDangerousEnvVariables)(g.env),this.child=(0,k.fork)(this.modulePath,m,g);const y=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,A.isRemoteConsoleLog)(n)){(0,A.log)(n,`IPC Library: ${this.options.serverName}`);return}y.fire(L.VSBuffer.wrap(Buffer.from(n,"base64")))});const S=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,l=n=>this.child&&this.child.connected&&S.send(n.buffer.toString("base64")),i=y.event,c={send:l,onMessage:i};this._client=new f.ChannelClient(c);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",r),this.activeRequests.forEach(o=>(0,E.dispose)(o)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(m){let g=this.channels.get(m);return g||(g=this.client.getChannel(m),this.channels.set(m,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=d}),define(ne[124],ie([12,13]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(ne[125],ie([12,13]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[126],ie([12,13]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(ne[127],ie([12,13]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(ne[128],ie([12,13]),function(Y,e){return Y.create("vs/platform/environment/node/shellEnv",e)}),define(ne[129],ie([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([12,13]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([12,13]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([12,13]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([12,13]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ne[138],ie([12,13]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(ne[139],ie([12,13]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([12,13]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(ne[141],ie([12,13]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[142],ie([12,13]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[143],ie([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[144],ie([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[145],ie([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[146],ie([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[147],ie([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[148],ie([12,13]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[149],ie([0,1,4]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var t;(function(A){A.Team="team",A.Internal="internal",A.Insiders="insider",A.Public="public"})(t=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(A){A.Market="X-MSEdge-Market",A.CorpNet="X-FD-Corpnet",A.ApplicationVersion="X-VSCode-AppVersion",A.Build="X-VSCode-Build",A.ClientId="X-MSEdge-ClientId",A.ExtensionName="X-VSCode-ExtensionName",A.Language="X-VSCode-Language",A.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class T{constructor(R,C,E,P){this.version=R,this.appName=C,this.machineId=E,this.targetPopulation=P}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return k.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,C=Object.values(L);for(let E of C)R.set(E,this.getFilterValue(E));return R}}e.AssignmentFilterProvider=T}),define(ne[78],ie([0,1,57,54,18,10,33,21,7]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(h,m,g){this._args=h,this.paths=m,this.productService=g}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(C.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=A.env.VSCODE_PORTABLE;return h?C.URI.file((0,T.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,T.resolve)(h):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,T.resolve)(h):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,T.resolve)(h);const m=A.env.VSCODE_EXTENSIONS;if(m)return m;const g=A.env.VSCODE_PORTABLE;return g?(0,T.join)(g,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(m=>/^[^:/?#]+?:\/\//.test(m)?C.URI.parse(m):C.URI.file((0,T.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?C.URI.parse(h):C.URI.file((0,T.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([t.memoize],E.prototype,"appRoot",null),he([t.memoize],E.prototype,"userHome",null),he([t.memoize],E.prototype,"userDataPath",null),he([t.memoize],E.prototype,"appSettingsHome",null),he([t.memoize],E.prototype,"tmpDir",null),he([t.memoize],E.prototype,"cacheHome",null),he([t.memoize],E.prototype,"userRoamingDataHome",null),he([t.memoize],E.prototype,"settingsResource",null),he([t.memoize],E.prototype,"userDataSyncHome",null),he([t.memoize],E.prototype,"userDataSyncLogResource",null),he([t.memoize],E.prototype,"sync",null),he([t.memoize],E.prototype,"machineSettingsResource",null),he([t.memoize],E.prototype,"globalStorageHome",null),he([t.memoize],E.prototype,"workspaceStorageHome",null),he([t.memoize],E.prototype,"keybindingsResource",null),he([t.memoize],E.prototype,"keyboardLayoutResource",null),he([t.memoize],E.prototype,"argvResource",null),he([t.memoize],E.prototype,"snippetsHome",null),he([t.memoize],E.prototype,"isExtensionDevelopment",null),he([t.memoize],E.prototype,"untitledWorkspacesHome",null),he([t.memoize],E.prototype,"installSourcePath",null),he([t.memoize],E.prototype,"builtinExtensionsPath",null),he([t.memoize],E.prototype,"extensionsPath",null),he([t.memoize],E.prototype,"extensionDevelopmentLocationURI",null),he([t.memoize],E.prototype,"extensionDevelopmentKind",null),he([t.memoize],E.prototype,"extensionTestsLocationURI",null),he([t.memoize],E.prototype,"debugExtensionHost",null),he([t.memoize],E.prototype,"serviceMachineIdResource",null),he([t.memoize],E.prototype,"telemetryLogResource",null),he([t.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function P(d,h){return p(d["inspect-extensions"],d["inspect-brk-extensions"],5870,h,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=P;function b(d,h){return p(d["inspect-search"],d["inspect-brk-search"],5876,h,d.extensionEnvironment)}e.parseSearchPort=b;function f(d,h){return p(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,h,d.extensionEnvironment)}e.parsePtyHostPort=f;function p(d,h,m,g,y,w){const l=Number(h||d)||(g?null:m),i=l?Boolean(!!h):!1;let c;if(w)try{c=JSON.parse(w)}catch{}return{port:l,break:i,debugId:y,env:c}}}),define(ne[150],ie([0,1,253,4,126]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(d,h,m=A){const g={},y=[],w=[];for(let c in h){const r=h[c];r.alias&&(g[c]=r.alias),r.type==="string"||r.type==="string[]"?(y.push(c),r.deprecates&&y.push(...r.deprecates)):r.type==="boolean"&&(w.push(c),r.deprecates&&w.push(...r.deprecates))}const S=k(d,{string:y,boolean:w,alias:g}),l={},i=S;l._=S._.map(c=>String(c)).filter(c=>c.length>0),delete i._;for(let c in h){const r=h[c];r.alias&&delete i[r.alias];let n=i[c];if(r.deprecates)for(const s of r.deprecates)i.hasOwnProperty(s)&&(n||(n=i[s],n&&m.onDeprecatedOption(s,r.deprecationMessage||(0,L.localize)(33,null))),delete i[s]);typeof n!="undefined"&&(r.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):r.type==="string"&&Array.isArray(n)&&(n=n.pop(),m.onMultipleValues(c,n)),l[c]=n,r.deprecationMessage&&m.onDeprecatedOption(c,r.deprecationMessage)),delete i[c]}for(let c in i)m.onUnknownOption(c);return l}e.parseArgs=R;function C(d,h){let m="";return h.args&&(Array.isArray(h.args)?m=` <${h.args.join("> <")}>`:m=` <${h.args}>`),h.alias?`-${h.alias} --${d}${m}`:`--${d}${m}`}function E(d,h){let m=0,g=[];for(const l in d){const i=d[l],c=C(l,i);m=Math.max(m,c.length),g.push([c,i.description])}let y=m+2+1;if(h-y<25)return g.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let w=h-y-1,S=[];for(const l of g){let i=l[0],c=b(l[1],w),r=P(y-i.length-2);S.push("  "+i+r+c[0]);for(let n=1;n<c.length;n++)S.push(P(y)+c[n])}return S}e.formatOptions=E;function P(d){return" ".repeat(d)}function b(d,h){let m=[];for(;d.length;){let g=d.length<h?d.length:d.lastIndexOf(" ",h),y=d.slice(0,g).trim();d=d.slice(g),m.push(y)}return m}function f(d,h,m,g,y){const w=process.stdout.isTTY&&process.stdout.columns||80,S=y?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",l=[`${d} ${m}`];l.push(""),l.push(`${(0,L.localize)(35,null)}: ${h} [${(0,L.localize)(36,null)}]${S}`),l.push(""),y?.noPipe!==!0&&(t.isWindows?l.push((0,L.localize)(37,null,h)):l.push((0,L.localize)(38,null,h)),l.push(""));const i={};for(const c in g){const r=g[c];if(r.description&&r.cat){let n=i[r.cat];n||(i[r.cat]=n={}),n[c]=r}}for(let c in i){const r=c;let n=i[r];n&&(l.push(T[r]),l.push(...E(n,w)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function p(d,h){return`${d||(0,L.localize)(39,null)}
${h||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function Y(e,k,t,L){function T(R){const C=A(R),E=[C];return e.isAbsolute(C)||E.unshift(L),e.resolve(...E)}function A(R){const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,t);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(b,"AppData","Roaming")}break;case"darwin":E=e.join(k.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,t)}return{getUserDataPath:T}}if(typeof define=="function")define(ne[151],ie([0,254,34,18,21,33]),function(e,k,t,L,T,A){const R=T.dirname(L.FileAccess.asFileUri("",e)),C=e.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);return Y(k,t,C.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),t=require("os");module.exports=Y(k,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[152],ie([0,1,34,78,151]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends t.AbstractNativeEnvironmentService{constructor(R,C){super(R,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},C)}}e.NativeEnvironmentService=T}),define(ne[153],ie([0,1,7]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const t=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(m){const g=m.match(A);return g?g[1]:null}function P(m){if(m.indexOf("://")===-1){const g=m.match(t);return g?E(g[2]):null}try{const g=k.URI.parse(m);if(g.authority)return E(g.authority)}catch{}return null}function b(m,g){const y=new Set;let w;for(;w=R.exec(m);){const l=P(w[1]);l&&y.add(l)}const S=new Set(g);return Array.from(y).map(l=>S.has(l)?l:l.replace(C,"a"))}e.getDomainsOfRemotes=b;function f(m){const g=m.match(T);return g?g[2]:null}function p(m,g,y){return m&&g?(y&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${m}${g}`:`${m}/${g}`):null}function d(m,g){if(m.indexOf("://")===-1){const y=m.match(L);if(y)return p(y[2],y[3],g)}try{const y=k.URI.parse(m);if(y.authority)return p(f(y.authority),y.path,g)}catch{}return null}function h(m,g=!1){const y=[];let w;for(;w=R.exec(m);){const S=d(w[1],g);S&&y.push(S)}return y}e.getRemotes=h}),define(ne[154],ie([0,1,28]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const t=/^%([\w\d.-]+)%$/i;function L(T,A){const R=C=>{if(typeof C!="string")return;const E=t.exec(C);if(!E)return;const P=A[E[1]]??C;return typeof P=="string"?P:typeof P.message=="string"?P.message:C};return(0,k.cloneAndChange)(T,R)}e.localizeManifest=L}),define(ne[155],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,R,C){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,R,C])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class t{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=t}),define(ne[79],ie([0,1,135]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||t.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=f.match(t);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=A;function R(f){if(!f)return null;let p=f.majorBase,d=f.majorMustEqual,h=f.minorBase,m=f.minorMustEqual,g=f.patchBase,y=f.patchMustEqual;f.hasCaret&&(p===0||(m=!1),y=!1);let w=0;if(f.preRelease){const S=L.exec(f.preRelease);if(S){const[,l,i,c]=S;w=Date.UTC(Number(l),Number(i)-1,Number(c))}}return{majorBase:p,majorMustEqual:d,minorBase:h,minorMustEqual:m,patchBase:g,patchMustEqual:y,isMinimum:f.hasGreaterEquals,notBefore:w}}e.normalizeVersion=R;function C(f,p,d){let h;typeof f=="string"?h=R(A(f)):h=f;let m;p instanceof Date?m=p.getTime():typeof p=="string"&&(m=new Date(p).getTime());let g;if(typeof d=="string"?g=R(A(d)):g=d,!h||!g)return!1;let y=h.majorBase,w=h.minorBase,S=h.patchBase,l=g.majorBase,i=g.minorBase,c=g.patchBase,r=g.notBefore,n=g.majorMustEqual,s=g.minorMustEqual,o=g.patchMustEqual;return g.isMinimum?y>l?!0:y<l?!1:w>i?!0:w<i||m&&m<r?!1:S>=c:(y===1&&l===0&&(!n||!s||!o)&&(l=1,i=0,c=0,n=!0,s=!1,o=!1),y<l?!1:y>l?!n:w<i?!1:w>i?!s:S<c?!1:S>c?!o:!(m&&m<r))}e.isValidVersion=C;function E(f,p,d,h){return d.isBuiltin||typeof d.main=="undefined"?!0:b(f,p,d.engines.vscode,h)}e.isValidExtensionVersion=E;function P(f,p,d){return f==="*"||b(p,d,f)}e.isEngineValid=P;function b(f,p,d,h=[]){let m=R(A(d));if(!m)return h.push(k.localize(0,null,d)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return h.push(k.localize(1,null,d)),!1}else if(!m.majorMustEqual)return h.push(k.localize(2,null,d)),!1;return C(f,p,m)?!0:(h.push(k.localize(3,null,f,d)),!1)}}),define(ne[47],ie([0,1,17,29]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,R){let C=R&&R.get("storage.serviceMachineId",0)||null;if(C)return C;try{const P=(await A.readFile(T.serviceMachineIdResource)).value.toString();C=(0,t.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,t.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,k.VSBuffer.fromString(C))}catch{}}return R&&R.store("storage.serviceMachineId",C,0,1),C}e.getServiceMachineId=L}),define(ne[51],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=k}),define(ne[80],ie([0,1,51]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function L(A,R,C){R instanceof k.SyncDescriptor||(R=new k.SyncDescriptor(R,[],C)),t.push([A,R])}e.registerSingleton=L;function T(){return t}e.getSingletonServiceDescriptors=T}),define(ne[156],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=k;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const R=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),C),C.incoming.set(this._hashFn(T),R)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let R=this._nodes.get(A);return R||(R=new k(T),this._nodes.set(A,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,R]of this._nodes)T.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const R=new Set([T]),C=this._findCycle(A,R);if(C)return C}}_findCycle(T,A){for(let[R,C]of T.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const E=this._findCycle(C,A);if(E)return E;A.delete(R)}}}e.Graph=t}),define(ne[6],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function t(A,R,C,E){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:A,index:C,optional:E}):(R[k.DI_DEPENDENCIES]=[{id:A,index:C,optional:E}],R[k.DI_TARGET]=R)}function L(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const R=function(C,E,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(R,C,P,!1)};return R.toString=()=>A,k.serviceIds.set(A,R),R}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(ne[157],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(ne[19],ie([0,1,15,7,6]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=T;function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||k.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var R;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function E(m,g){const y=Object.create(null);for(let w in m)P(y,w,m[w],g);return y}e.toValuesTree=E;function P(m,g,y,w){const S=g.split("."),l=S.pop();let i=m;for(let c=0;c<S.length;c++){let r=S[c],n=i[r];switch(typeof n){case"undefined":n=i[r]=Object.create(null);break;case"object":break;default:w(`Ignoring ${g} as ${S.slice(0,c+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[l]=y}catch{w(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(i)}`)}else w(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=P;function b(m,g){const y=g.split(".");f(m,y)}e.removeFromValueTree=b;function f(m,g){const y=g.shift();if(g.length===0){delete m[y];return}if(Object.keys(m).indexOf(y)!==-1){const w=m[y];typeof w=="object"&&!Array.isArray(w)&&(f(w,g),Object.keys(w).length===0&&delete m[y])}}function p(m,g,y){function w(i,c){let r=i;for(const n of c){if(typeof r!="object"||r===null)return;r=r[n]}return r}const S=g.split("."),l=w(m,S);return typeof l=="undefined"?y:l}e.getConfigurationValue=p;function d(m,g,y){Object.keys(g).forEach(w=>{w!=="__proto__"&&(w in m?k.isObject(m[w])&&k.isObject(g[w])?d(m[w],g[w],y):y&&(m[w]=g[w]):m[w]=g[w])})}e.merge=d;function h(m,g,y){const w=m.inspect(g),S=m.inspect(y);return typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:w.defaultValue}e.getMigratedSettingValue=h}),define(ne[158],ie([0,1,4,26,6]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",k.isMacintosh),T.set("isLinux",k.isLinux),T.set("isWindows",k.isWindows),T.set("isWeb",k.isWeb),T.set("isMacNative",k.isMacintosh&&!k.isWeb),T.set("isEdge",k.isEdge),T.set("isFirefox",k.isFirefox),T.set("isChrome",k.isChrome),T.set("isSafari",k.isSafari);const A=Object.prototype.hasOwnProperty;var R;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return b.INSTANCE}static true(){return f.INSTANCE}static has(D){return p.create(D)}static equals(D,U){return d.create(D,U)}static notEquals(D,U){return g.create(D,U)}static regex(D,U){return r.create(D,U)}static in(D,U){return h.create(D,U)}static not(D){return y.create(D)}static and(...D){return o.create(D,null)}static or(...D){return a.create(D,null,!0)}static greater(D,U){return S.create(D,U)}static greaterEquals(D,U){return l.create(D,U)}static smaller(D,U){return i.create(D,U)}static smallerEquals(D,U){return c.create(D,U)}static deserialize(D,U=!1){if(!!D)return this._deserializeOrExpression(D,U)}static _deserializeOrExpression(D,U){let F=D.split("||");return a.create(F.map(x=>this._deserializeAndExpression(x,U)),null,!0)}static _deserializeAndExpression(D,U){let F=D.split("&&");return o.create(F.map(x=>this._deserializeOne(x,U)),null)}static _deserializeOne(D,U){if(D=D.trim(),D.indexOf("!=")>=0){let F=D.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],U))}if(D.indexOf("==")>=0){let F=D.split("==");return d.create(F[0].trim(),this._deserializeValue(F[1],U))}if(D.indexOf("=~")>=0){let F=D.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(D.indexOf(" in ")>=0){let F=D.split(" in ");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const F=D.split(">=");return l.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const F=D.split(">");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const F=D.split("<=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const F=D.split("<");return i.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(D)?y.create(D.substr(1).trim()):p.create(D)}static _deserializeValue(D,U){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let F=/^'([^']*)'$/.exec(D);return F?F[1].trim():D}static _deserializeRegexValue(D,U){if((0,t.isFalsyOrWhitespace)(D)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=D.indexOf("/"),x=D.lastIndexOf("/");if(F===x||F<0){if(U)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let q=D.slice(F+1,x),G=D[x+1]==="i"?"i":"";try{return new RegExp(q,G)}catch(te){if(U)throw new Error(`bad regexp-value '${D}', parse error: ${te}`);return console.warn(`bad regexp-value '${D}', parse error: ${te}`),null}}}e.ContextKeyExpr=C;function E(M,D){const U=M?M.substituteConstants():void 0,F=D?D.substituteConstants():void 0;return!U&&!F?!0:!U||!F?!1:U.equals(F)}e.expressionsAreEqualWithConstantSubstitution=E;function P(M,D){return M.cmp(D)}class b{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class f{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class p{constructor(D,U){this.key=D,this.negated=U,this.type=2}static create(D,U=null){const F=T.get(D);return typeof F=="boolean"?F?f.INSTANCE:b.INSTANCE:new p(D,U)}cmp(D){return D.type!==this.type?this.type-D.type:v(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?f.INSTANCE:b.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=p;class d{constructor(D,U,F){this.key=D,this.value=U,this.negated=F,this.type=4}static create(D,U,F=null){if(typeof U=="boolean")return U?p.create(D,F):y.create(D,F);const x=T.get(D);return typeof x=="boolean"?U===(x?"true":"false")?f.INSTANCE:b.INSTANCE:new d(D,U,F)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const U=D?"true":"false";return this.value===U?f.INSTANCE:b.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class h{constructor(D,U){this.key=D,this.valueKey=U,this.type=10,this.negated=null}static create(D,U){return new h(D,U)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const U=D.getValue(this.valueKey),F=D.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?A.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=h;class m{constructor(D){this._actual=D,this.type=11}static create(D){return new m(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new m(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class g{constructor(D,U,F){this.key=D,this.value=U,this.negated=F,this.type=5}static create(D,U,F=null){if(typeof U=="boolean")return U?y.create(D,F):p.create(D,F);const x=T.get(D);return typeof x=="boolean"?U===(x?"true":"false")?b.INSTANCE:f.INSTANCE:new g(D,U,F)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const U=D?"true":"false";return this.value===U?b.INSTANCE:f.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class y{constructor(D,U){this.key=D,this.negated=U,this.type=3}static create(D,U=null){const F=T.get(D);return typeof F=="boolean"?F?b.INSTANCE:f.INSTANCE:new y(D,U)}cmp(D){return D.type!==this.type?this.type-D.type:v(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?b.INSTANCE:f.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;function w(M,D){if(typeof M=="string"){const U=parseFloat(M);isNaN(U)||(M=U)}return typeof M=="string"||typeof M=="number"?D(M):b.INSTANCE}class S{constructor(D,U,F){this.key=D,this.value=U,this.negated=F,this.type=12}static create(D,U,F=null){return w(U,x=>new S(D,x,F))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=S;class l{constructor(D,U,F){this.key=D,this.value=U,this.negated=F,this.type=13}static create(D,U,F=null){return w(U,x=>new l(D,x,F))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class i{constructor(D,U,F){this.key=D,this.value=U,this.negated=F,this.type=14}static create(D,U,F=null){return w(U,x=>new i(D,x,F))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class c{constructor(D,U,F){this.key=D,this.value=U,this.negated=F,this.type=15}static create(D,U,F=null){return w(U,x=>new c(D,x,F))}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class r{constructor(D,U){this.key=D,this.regexp=U,this.type=7,this.negated=null}static create(D,U){return new r(D,U)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const U=this.regexp?this.regexp.source:"",F=D.regexp?D.regexp.source:"";return U<F?-1:U>F?1:0}equals(D){if(D.type===this.type){const U=this.regexp?this.regexp.source:"",F=D.regexp?D.regexp.source:"";return this.key===D.key&&U===F}return!1}substituteConstants(){return this}evaluate(D){let U=D.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{constructor(D){this._actual=D,this.type=8}static create(D){return new n(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function s(M){let D=null;for(let U=0,F=M.length;U<F;U++){const x=M[U].substituteConstants();if(M[U]!==x&&D===null){D=[];for(let q=0;q<U;q++)D[q]=M[q]}D!==null&&(D[U]=x)}return D===null?M:D}class o{constructor(D,U){this.expr=D,this.negated=U,this.type=6}static create(D,U){return o._normalizeArr(D,U)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const x=P(this.expr[U],D.expr[U]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(D.expr[U]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:o.create(D,this.negated)}evaluate(D){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(D))return!1;return!0}static _normalizeArr(D,U){const F=[];let x=!1;for(const q of D)if(!!q){if(q.type===1){x=!0;continue}if(q.type===0)return b.INSTANCE;if(q.type===6){F.push(...q.expr);continue}F.push(q)}if(F.length===0&&x)return f.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(P);for(let q=1;q<F.length;q++)F[q-1].equals(F[q])&&(F.splice(q,1),q--);if(F.length===1)return F[0];for(;F.length>1;){const q=F[F.length-1];if(q.type!==9)break;F.pop();const G=F.pop(),te=F.length===0,W=a.create(q.expr.map(j=>o.create([j,G],null)),null,te);W&&(F.push(W),F.sort(P))}return F.length===1?F[0]:new o(F,U)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let U of this.expr)D.push(...U.keys());return D}map(D){return new o(this.expr.map(U=>U.map(D)),null)}negate(){if(!this.negated){const D=[];for(let U of this.expr)D.push(U.negate());this.negated=a.create(D,this,!0)}return this.negated}}class a{constructor(D,U){this.expr=D,this.negated=U,this.type=9}static create(D,U,F){return a._normalizeArr(D,U,F)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const x=P(this.expr[U],D.expr[U]);if(x!==0)return x}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(D.expr[U]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:a.create(D,this.negated,!1)}evaluate(D){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(D))return!0;return!1}static _normalizeArr(D,U,F){let x=[],q=!1;if(D){for(let G=0,te=D.length;G<te;G++){const W=D[G];if(!!W){if(W.type===0){q=!0;continue}if(W.type===1)return f.INSTANCE;if(W.type===9){x=x.concat(W.expr);continue}x.push(W)}}if(x.length===0&&q)return b.INSTANCE;x.sort(P)}if(x.length!==0){if(x.length===1)return x[0];for(let G=1;G<x.length;G++)x[G-1].equals(x[G])&&(x.splice(G,1),G--);if(x.length===1)return x[0];if(F){for(let G=0;G<x.length;G++)for(let te=G+1;te<x.length;te++)_(x[G],x[te])&&(x.splice(te,1),te--);if(x.length===1)return x[0]}return new a(x,U)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let U of this.expr)D.push(...U.keys());return D}map(D){return new a(this.expr.map(U=>U.map(D)),null)}negate(){if(!this.negated){let D=[];for(let U of this.expr)D.push(U.negate());for(;D.length>1;){const U=D.shift(),F=D.shift(),x=[];for(const G of O(U))for(const te of O(F))x.push(o.create([G,te],null));const q=D.length===0;D.unshift(a.create(x,null,q))}this.negated=D[0]}return this.negated}}class u extends p{constructor(D,U,F){super(D,null);this._defaultValue=U,typeof F=="object"?u._info.push({...F,key:D}):F!==!0&&u._info.push({key:D,description:F,type:U!=null?typeof U:void 0})}static all(){return u._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return d.create(this.key,D)}notEqualsTo(D){return g.create(this.key,D)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(M,D){return M<D?-1:M>D?1:0}function I(M,D,U,F){return M<U?-1:M>U?1:D<F?-1:D>F?1:0}function _(M,D){if(D.type===6&&M.type!==9&&M.type!==6){for(const x of D.expr)if(M.equals(x))return!0}const U=M.negate(),F=O(U).concat(O(D));F.sort(P);for(let x=0;x<F.length;x++){const G=F[x].negate();for(let te=x+1;te<F.length;te++){const W=F[te];if(G.equals(W))return!0}}return!1}e.implies=_;function O(M){return M.type===9?M.expr:[M]}}),define(ne[81],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t}),define(ne[82],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(ne[14],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[83],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var t;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(t=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[11],ie([0,1,39,10,26,15,7,137,6]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function E(q){return q.create===!0}e.isFileOpenForWriteOptions=E;var P;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var b;(function(q){q[q.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var f;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=p;function d(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=d;function h(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function m(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=m;function g(q){return p(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var y;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(y=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(G,te){super(G);this.code=te}}e.FileSystemProviderError=w;function S(q,G){const te=new w(q.toString(),G);return i(te,G),te}e.createFileSystemProviderError=S;function l(q){return q||S((0,R.localize)(0,null),y.Unknown)}e.ensureFileSystemProviderError=l;function i(q,G){return q.name=G?`${G} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=i;function c(q){if(!q)return y.Unknown;if(q instanceof w)return q.code;const G=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!G)return y.Unknown;switch(G[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileExceedsMemoryLimit:return y.FileExceedsMemoryLimit;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.toFileSystemProviderErrorCode=c;function r(q){if(q instanceof v)return q.fileOperationResult;switch(c(q)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 10;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileExceedsMemoryLimit:return 9;case y.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(G,te,W){this.resource=G,this.operation=te,this.target=W}isOperation(G){return this.operation===G}}e.FileOperationEvent=s;var o;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class a{constructor(G,te){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const W=new Map;for(const j of G){const J=W.get(j.type);switch(J?J.push([j.resource,j]):W.set(j.type,[[j.resource,j]]),j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}}for(const[j,J]of W)switch(j){case 1:this.added=k.TernarySearchTree.forUris(()=>te),this.added.fill(J);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>te),this.updated.fill(J);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>te),this.deleted.fill(J);break}}contains(G,...te){return this.doContains(G,{includeChildren:!1},...te)}affects(G,...te){return this.doContains(G,{includeChildren:!0},...te)}doContains(G,te,...W){if(!G)return!1;const j=W.length>0;return!!((!j||W.includes(1))&&(this.added?.get(G)||te.includeChildren&&this.added?.findSuperstr(G))||(!j||W.includes(0))&&(this.updated?.get(G)||te.includeChildren&&this.updated?.findSuperstr(G))||(!j||W.includes(2))&&(this.deleted?.findSubstr(G)||te.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function u(q,G,te){return!q||!G||q===G||G.length>q.length?!1:(G.charAt(G.length-1)!==t.sep&&(G+=t.sep),te?(0,L.startsWithIgnoreCase)(q,G):q.indexOf(G)===0)}e.isParent=u;class v extends Error{constructor(G,te,W){super(G);this.fileOperationResult=te,this.options=W}}e.FileOperationError=v;class I extends v{constructor(G,te,W){super(G,2,W);this.stat=te}}e.NotModifiedSinceFileOperationError=I;var _;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=M;async function D(q,G){if(!G.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(te=>{const W=G.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===q.scheme&&j.added&&(W.dispose(),te())})})}e.whenProviderRegistered=D,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(G){return(0,T.isNumber)(G)||(G=0),G<U.KB?(0,R.localize)(1,null,G.toFixed(0)):G<U.MB?(0,R.localize)(2,null,(G/U.KB).toFixed(2)):G<U.GB?(0,R.localize)(3,null,(G/U.MB).toFixed(2)):G<U.TB?(0,R.localize)(4,null,(G/U.GB).toFixed(2)):(0,R.localize)(5,null,(G/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var F;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function x(q){return{maxFileSize:q===0?300*U.MB:16*U.GB,maxHeapSize:q===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=x});var K=this&&this.__param||function(Y,e){return function(k,t){e(k,t,Y)}};define(ne[159],ie([0,1,84,40,11]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const C=(await this.fileService.readFileStream(R)).value;return new Promise((E,P)=>{const b=(0,k.createHash)("md5");(0,t.listenStream)(C,{onData:f=>b.update(f.buffer),onError:f=>P(f),onEnd:()=>E(b.digest("base64").replace(/=+$/,""))})})}};T=he([K(0,L.IFileService)],T),e.ChecksumService=T}),define(ne[160],ie([0,1,255,127,150,11]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(f,p){const d={onUnknownOption:m=>{console.warn((0,t.localize)(0,null,m))},onMultipleValues:(m,g)=>{console.warn((0,t.localize)(1,null,m,g))},onDeprecatedOption:(m,g)=>{console.warn((0,t.localize)(2,null,m,g))}},h=(0,L.parseArgs)(f,L.OPTIONS,p?d:void 0);return h.goto&&h._.forEach(m=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,t.localize)(3,null))),h["max-memory"]&&k(parseInt(h["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),h}function R(f){const p=f.findIndex(d=>!/^-/.test(d));if(p>-1)return[...f.slice(0,p),...f.slice(p+1)]}function C(f){let[,...p]=f;process.env.VSCODE_DEV&&(p=R(p)||[]);const d=!b(process.env);return A(p,d)}e.parseMainProcessArgv=C;function E(f){const[,,...p]=f;return A(p,!0)}e.parseCLIProcessArgv=E;function P(f,...p){const d=f.indexOf("--");return d===-1?f.push(...p):f.splice(d,0,...p),f}e.addArg=P;function b(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(ne[161],ie([0,1,46,10,128,25,37,9,4,29,123,160,5]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let d;async function h(g,y,w){return y["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(w)&&!y["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(w)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=f.Promises.withAsyncBody(async(S,l)=>{const i=new T.CancellationTokenSource,c=setTimeout(()=>{i.dispose(!0),l(new Error((0,L.localize)(0,null)))},p);try{S(await m(g,i.token))}catch(r){!(0,R.isCancellationError)(r)&&!i.token.isCancellationRequested?l(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(r)))):S({})}finally{clearTimeout(c),i.dispose()}})),d)}e.getResolvedShellEnv=h;async function m(g,y){const w=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",w);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",S);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",c);const r=await(0,P.getSystemShell)(C.OS,c);return g.trace("getUnixShellEnvironment#shell",r),new Promise((n,s)=>{if(y.isCancellationRequested)return s((0,R.canceled)());const o=(0,t.basename)(r);let a,u;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' ${v} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,u=["-Login","-Command"]):(a=`'${process.execPath}' ${v} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?u=["-ic"]:u=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),a);const I=(0,k.spawn)(r,[...u,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});y.onCancellationRequested(()=>(I.kill(),s((0,R.canceled)()))),I.on("error",M=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(M)),s(M)});const _=[];I.stdout.on("data",M=>_.push(M));const O=[];I.stderr.on("data",M=>O.push(M)),I.on("close",(M,D)=>{const U=Buffer.concat(_).toString("utf8");g.trace("getUnixShellEnvironment#raw",U);const F=Buffer.concat(O).toString("utf8");if(F.trim()&&g.trace("getUnixShellEnvironment#stderr",F),M||D)return s(new Error((0,L.localize)(2,null,M,D)));const x=i.exec(U),q=x?x[1]:"{}";try{const G=JSON.parse(q);w?G.ELECTRON_RUN_AS_NODE=w:delete G.ELECTRON_RUN_AS_NODE,S?G.ELECTRON_NO_ATTACH_CONSOLE=S:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",G),n(G)}catch(G){g.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(G)),s(G)}})})}}),define(ne[162],ie([0,1,17,37,9,3,2,40,7,29,11]),function(Y,e,k,t,L,T,A,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends A.Disposable{constructor(p,d){super();this.channel=p,this.extraCapabilities=d,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,d){const{buffer:h}=await this.channel.call("readFile",[p,d]);return h}readFileStream(p,d,h){const m=(0,R.newWriteableStream)(y=>k.VSBuffer.concat(y.map(w=>k.VSBuffer.wrap(w))).buffer),g=this.channel.listen("readFileStream",[p,d])(y=>{if(y instanceof k.VSBuffer)m.write(y.buffer);else{if(y==="end")m.end();else{let w=y;w instanceof Error||(w=(0,P.createFileSystemProviderError)((0,t.toErrorMessage)(w),P.FileSystemProviderErrorCode.Unknown)),m.error(w),m.end()}g.dispose()}});return h.onCancellationRequested(()=>{m.error((0,L.canceled)()),m.end(),g.dispose()}),m}writeFile(p,d,h){return this.channel.call("writeFile",[p,k.VSBuffer.wrap(d),h])}open(p,d){return this.channel.call("open",[p,d])}close(p){return this.channel.call("close",[p])}async read(p,d,h,m,g){const[y,w]=await this.channel.call("read",[p,d,g]);return h.set(y.buffer.slice(0,w),m),w}write(p,d,h,m,g){return this.channel.call("write",[p,d,k.VSBuffer.wrap(h),m,g])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,d){return this.channel.call("delete",[p,d])}rename(p,d,h){return this.channel.call("rename",[p,d,h])}copy(p,d,h){return this.channel.call("copy",[p,d,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const d=p;this._onDidChange.fire(d.map(h=>({resource:C.URI.revive(h.resource),type:h.type})))}else{const d=p;this._onDidWatchError.fire(d)}}))}watch(p,d){const h=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,h,p,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=b}),define(ne[85],ie([0,1,17,9,138,11]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(P,b,f,p,d,h){let m;try{await R(P,b,f,p,d,h)}catch(g){m=g}finally{m&&d.errorTransformer&&(m=d.errorTransformer(m)),typeof m!="undefined"&&f.error(m),f.end()}}e.readFileIntoStream=A;async function R(P,b,f,p,d,h){C(h);const m=await P.open(b,{create:!1});try{C(h);let g=0,y=0,w=d&&typeof d.length=="number"?d.length:void 0,S=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof w=="number"?w:d.bufferSize)),l=d&&typeof d.position=="number"?d.position:0,i=0;do y=await P.read(m,l,S.buffer,i,S.byteLength-i),l+=y,i+=y,g+=y,typeof w=="number"&&(w-=y),i===S.byteLength&&(await f.write(p(S)),S=k.VSBuffer.alloc(Math.min(d.bufferSize,typeof w=="number"?w:d.bufferSize)),i=0);while(y>0&&(typeof w!="number"||w>0)&&C(h)&&E(g,d));if(i>0){let c=i;typeof w=="number"&&(c=Math.min(i,w)),f.write(p(S.slice(0,c)))}}catch(g){throw(0,T.ensureFileSystemProviderError)(g)}finally{await P.close(m)}}function C(P){if(P.isCancellationRequested)throw(0,t.canceled)();return!0}function E(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[52],ie([0,1,2,4,7,11]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function A(p){return p.recursive===!0}e.isRecursiveWatchRequest=A;class R extends k.Disposable{constructor(d,h,m,g){super();this.onFileChanges=d,this.onLogMessage=h,this.verboseLogging=m,this.options=g,this.watcherDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new k.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),d.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),d.add(this.watcher.onDidError(h=>this.onError(h)))}onError(d){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class C extends R{constructor(d,h,m){super(d,h,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class E extends R{constructor(d,h,m){super(d,h,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function P(p){return p.map(d=>({type:d.type,resource:L.URI.file(d.path)}))}e.toFileChanges=P;function b(p){const d=new f;for(const h of p)d.processEvent(h);return d.coalesce()}e.coalesceEvents=b;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return t.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const h=this.mapPathToChange.get(this.toKey(d));let m=!1;if(h){const g=h.type,y=d.type;h.path!==d.path&&(d.type===2||d.type===1)?m=!0:g===1&&y===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(h)):g===2&&y===1?h.type=0:g===1&&y===0||(h.type=y)}else m=!0;m&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],h=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(d.push(m),!1):!0).sort((m,g)=>m.path.length-g.path.length).filter(m=>h.some(g=>(0,T.isParent)(m.path,g,!t.isLinux))?!1:(h.push(m.path),!0)).concat(d)}}}),define(ne[163],ie([0,1,50,5,25,41,109,2,72,10,4,114,22,52]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends R.Disposable{constructor(g,y,w,S){super();this.request=g,this.onDidFilesChange=y,this.onLogMessage=w,this.verboseLogging=S,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(d.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,A.parse)(l)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const y=await f.Promises.stat(g);this._register(await this.doWatch(g,y.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(g)}}async normalizePath(g){let y=g.path;try{y=await f.Promises.realpath(g.path),g.path===y&&(y=await(0,b.realcase)(g.path)??g.path),g.path!==y&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${y})`)}catch{}return y}async doWatch(g,y){if(P.isMacintosh&&(0,T.isEqualOrParent)(g,"/Volumes/",!0))return this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const w=new L.CancellationTokenSource(this.cts.token);let S=new R.DisposableStore;try{const l=(0,E.basename)(g),i=(0,k.watch)(g);S.add((0,R.toDisposable)(()=>{i.removeAllListeners(),i.close()})),this.trace(`Started watching: '${g}'`);const c=new Set;if(y)try{for(const n of await f.Promises.readdir(g))c.add(n)}catch(n){this.error(n)}const r=new Map;S.add((0,R.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),i.on("error",(n,s)=>{this.error(`Failed to watch ${g} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),i.on("change",(n,s)=>{if(w.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${s}`);let o="";if(s&&(o=s.toString(),P.isMacintosh&&(o=(0,C.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(y)if(n==="rename"){r.get(o)?.dispose();const a=setTimeout(async()=>{if(r.delete(o),o===l&&!await f.Promises.exists(g)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,E.join)(g,o));if(w.token.isCancellationRequested)return;let v;u?c.has(o)?v=0:(v=1,c.add(o)):(c.delete(o),v=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:v})},d.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,R.toDisposable)(()=>clearTimeout(a)))}else{let a;c.has(o)?a=0:(a=1,c.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:a})}else if(n==="rename"||o!==l){const a=setTimeout(async()=>{const u=await f.Promises.exists(g);w.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),S.add(await this.doWatch(g,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},d.FILE_DELETE_HANDLER_DELAY);S.clear(),S.add((0,R.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await f.Promises.exists(g)&&!w.token.isCancellationRequested&&this.error(`Failed to watch ${g} for changes using fs.watch() (${l.toString()})`)}return(0,R.toDisposable)(()=>{w.dispose(!0),S.dispose()})}async onFileChange(g,y=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!y&&this.excludes.some(w=>w(g.path))?this.verboseLogging&&this.trace(` >> ignored ${g.path}`):this.fileChangesBuffer.push(g);try{await this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,p.coalesceEvents)(w);if(S.length>0){if(this.verboseLogging)for(const i of S)this.trace(`>> normalized ${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.path}`);this.throttledFileChangesWorker.work(S)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${S.length}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(g){if(P.isLinux)return f.Promises.exists(g);try{const y=(0,E.basename)(g);return(await f.Promises.readdir((0,E.dirname)(g))).some(S=>S===y)}catch(y){return this.trace(y),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.FILE_DELETE_HANDLER_DELAY=100,d.FILE_CHANGES_HANDLER_DELAY=50;async function h(m,g,y,w,S=512){const l=await f.Promises.open(m,"r"),i=Buffer.allocUnsafe(S),c=new L.CancellationTokenSource(w);let r,n=!1;const s={path:m,excludes:[],recursive:!1},o=new d(s,a=>{(async()=>{for(const{type:u}of a)if(u===0){if(n)return;n=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:v}=await f.Promises.read(l,i,0,S,null);if(!v||c.token.isCancellationRequested)break;g(i.slice(0,v))}}catch(v){r=new Error(v),c.dispose(!0)}finally{n=!1}}})()});return await o.ready,y(),new Promise((a,u)=>{c.token.onCancellationRequested(async()=>{o.dispose();try{await f.Promises.close(l)}catch(v){r=new Error(v)}r?u(r):a()})})}e.watchFileContents=h}),define(ne[164],ie([0,1,16,3,2,4,163]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new t.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new t.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=t.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const P=this.normalizeRequests(E),b=P.filter(p=>{const d=this.watchers.get(p.path);return d?!(0,k.equals)(d.request.excludes,p.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:p})=>!P.find(d=>d.path===p.path&&(0,k.equals)(d.excludes,p.excludes))).map(({request:p})=>p.path);b.length&&this.trace(`Request to start watching: ${b.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const p of f)this.stopWatching(p);for(const p of b)this.startWatching(p)}startWatching(E){const P=new A.NodeJSFileWatcherLibrary(E,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),b={request:E,instance:P};this.watchers.set(E.path,b)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const P=this.watchers.get(E);P&&(this.watchers.delete(E),P.instance.dispose())}normalizeRequests(E){const P=new Map;for(const b of E){const f=T.isLinux?b.path:b.path.toLowerCase();P.set(f,b)}return Array.from(P.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,P]of this.watchers)P.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,P){return P?`[File Watcher (node.js)] ${E} (path: ${P.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=R}),define(ne[165],ie([0,1,52,164]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends k.AbstractNonRecursiveWatcherClient{constructor(A,R,C){super(A,R,C);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(ne[166],ie([0,1,18,36,58,52]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(C,E,P){super(C,E,P);this.init()}createWatcher(C){const E=C.add(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(E.onDidProcessExit(({code:P,signal:b})=>this.onError(`terminated by itself with code ${P}, signal: ${b}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[86],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...L){this._entries=new Map;for(let[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=k}),define(ne[167],ie([0,1,5,9,51,156,6,86]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class E extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class P{constructor(d=new R.ServiceCollection,h=!1,m){this._activeInstantiations=new Set,this._services=d,this._strict=h,this._parent=m,this._services.set(A.IInstantiationService,this)}createChild(d){return new P(d,this._strict,this)}invokeFunction(d,...h){let m=f.traceInvocation(d),g=!1;try{return d({get:w=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(w,m);if(!S)throw new Error(`[invokeFunction] unknown service '${w}'`);return S}},...h)}finally{g=!0,m.stop()}}createInstance(d,...h){let m,g;return d instanceof L.SyncDescriptor?(m=f.traceCreation(d.ctor),g=this._createInstance(d.ctor,d.staticArguments.concat(h),m)):(m=f.traceCreation(d),g=this._createInstance(d,h,m)),m.stop(),g}_createInstance(d,h=[],m){let g=A._util.getServiceDependencies(d).sort((S,l)=>S.index-l.index),y=[];for(const S of g){let l=this._getOrCreateServiceInstance(S.id,m);if(!l&&this._strict&&!S.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${S.id}.`);y.push(l)}let w=g.length>0?g[0].index:h.length;if(h.length!==w){console.warn(`[createInstance] First service dependency of ${d.name} at position ${w+1} conflicts with ${h.length} static arguments`);let S=w-h.length;S>0?h=h.concat(new Array(S)):h=h.slice(0,w)}return new d(...[...h,...y])}_setServiceInstance(d,h){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,h);else if(this._parent)this._parent._setServiceInstance(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let h=this._services.get(d);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):h}_getOrCreateServiceInstance(d,h){let m=this._getServiceInstanceOrDescriptor(d);return m instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,m,h.branch(d,!0)):(h.branch(d,!1),m)}_safeCreateAndCacheServiceInstance(d,h,m){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,h,m)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,h,m){const g=new T.Graph(S=>S.id.toString());let y=0;const w=[{id:d,desc:h,_trace:m}];for(;w.length;){const S=w.pop();if(g.lookupOrInsertNode(S),y++>1e3)throw new E(g);for(let l of A._util.getServiceDependencies(S.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(l.id);if(!i&&!l.optional&&console.warn(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`),i instanceof L.SyncDescriptor){const c={id:l.id,desc:i,_trace:S._trace.branch(l.id,!0)};g.insertEdge(S,c),w.push(c)}}}for(;;){const S=g.roots();if(S.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:l}of S){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const c=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,c)}g.removeNode(l)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,h,m=[],g,y){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(h,m,g,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,h,m,g,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(d,h=[],m,g){if(m){const y=new k.IdleValue(()=>this._createInstance(d,h,g));return new Proxy(Object.create(null),{get(w,S){if(S in w)return w[S];let l=y.value,i=l[S];return typeof i!="function"||(i=i.bind(l),w[S]=i),i},set(w,S,l){return y.value[S]=l,!0}})}else return this._createInstance(d,h,g)}}e.InstantiationService=P;var b;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(b||(b={}));class f{constructor(d,h){this.type=d,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return C?new f(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(d){return C?new f(0,d.name):f._None}branch(d,h){let m=new f(2,d.toString());return this._dep.push([d,h,m]),m}stop(){let d=Date.now()-this._start;f._totals+=d;let h=!1;function m(y,w){let S=[],l=new Array(y+1).join("	");for(const[i,c,r]of w._dep)if(c&&r){h=!0,S.push(`${l}CREATES -> ${i}`);let n=m(y+1,r);n&&S.push(n)}else S.push(`${l}uses -> ${i}`);return S.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(d>2||h)&&console.log(g.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ne[168],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=k}),define(ne[169],ie([0,1,36,51,80,6]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(p,d,h){const m=h.getChannel(p);return R(d)?new d.channelClientCtor(m):k.ProxyChannel.toService(m,d?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let C=class extends A{constructor(p,d,h){super(p,d,h)}};C=he([K(2,e.IMainProcessService)],C);function E(f,p,d){(0,L.registerSingleton)(f,new t.SyncDescriptor(C,[p,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let P=class extends A{constructor(p,d,h){super(p,d,h)}};P=he([K(2,e.ISharedProcessService)],P);function b(f,p,d){(0,L.registerSingleton)(f,new t.SyncDescriptor(P,[p,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=b}),define(ne[59],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function t(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const T of L.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=t}),define(ne[170],ie([0,1,2,59]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends k.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=he([K(0,t.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(ne[8],ie([0,1,37,3,2,4,6]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function R(){return new Date().toISOString()}var C;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function E(c,r,n){switch(r){case C.Trace:c.trace(n);break;case C.Debug:c.debug(n);break;case C.Info:c.info(n);break;case C.Warning:c.warn(n);break;case C.Error:c.error(n);break;case C.Critical:c.critical(n);break;default:throw new Error("Invalid log level")}}e.log=E;function P(c){let r="";for(let n=0;n<c.length;n++){let s=c[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}r+=(n>0?" ":"")+s}return r}e.format=P;class b extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class f extends b{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...n){this.checkLogLevel(C.Trace)&&this.log(C.Trace,P([r,...n]))}debug(r,...n){this.checkLogLevel(C.Debug)&&this.log(C.Debug,P([r,...n]))}info(r,...n){this.checkLogLevel(C.Info)&&this.log(C.Info,P([r,...n]))}warn(r,...n){this.checkLogLevel(C.Warning)&&this.log(C.Warning,P([r,...n]))}error(r,...n){if(this.checkLogLevel(C.Error))if(r instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=r.stack,this.log(C.Error,P(s))}else this.log(C.Error,P([r,...n]))}critical(r,...n){this.checkLogLevel(C.Critical)&&this.log(C.Critical,P([r,...n]))}flush(){}}e.AbstractMessageLogger=f;class p extends b{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...n){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}debug(r,...n){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}info(r,...n){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,r,...n):console.log(`[main ${R()}]`,r,...n))}warn(r,...n){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,r,...n):console.warn(`[main ${R()}]`,r,...n))}error(r,...n){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,r,...n):console.error(`[main ${R()}]`,r,...n))}critical(r,...n){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,r,...n):console.error(`[main ${R()}]`,r,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class d extends b{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...n){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...n)}debug(r,...n){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...n)}info(r,...n){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...n)}warn(r,...n){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...n)}error(r,...n){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...n)}critical(r,...n){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends b{constructor(r,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(n)}trace(r,...n){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...n])}debug(r,...n){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...n])}info(r,...n){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...n])}warn(r,...n){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...n])}error(r,...n){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...n])}critical(r,...n){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...n])}extractMessage(r){return typeof r=="string"?r:(0,k.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class m extends b{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const n of this.logServices)n.setLevel(r);super.setLevel(r)}trace(r,...n){for(const s of this.logServices)s.trace(r,...n)}debug(r,...n){for(const s of this.logServices)s.debug(r,...n)}info(r,...n){for(const s of this.logServices)s.info(r,...n)}warn(r,...n){for(const s of this.logServices)s.warn(r,...n)}error(r,...n){for(const s of this.logServices)s.error(r,...n)}critical(r,...n){for(const s of this.logServices)s.critical(r,...n)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=m;class g extends L.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...n){this.logger.trace(r,...n)}debug(r,...n){this.logger.debug(r,...n)}info(r,...n){this.logger.info(r,...n)}warn(r,...n){this.logger.warn(r,...n)}error(r,...n){this.logger.error(r,...n)}critical(r,...n){this.logger.critical(r,...n)}flush(){this.logger.flush()}}e.LogService=g;class y extends L.Disposable{constructor(r,n){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,n){let s=this.loggers.get(r.toString());return s||(s=this.doCreateLogger(r,n?.always?C.Trace:this.logLevel,n),this.loggers.set(r.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class w{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...n){}debug(r,...n){}info(r,...n){}warn(r,...n){}error(r,...n){}critical(r,...n){}dispose(){}flush(){}}e.NullLogService=w;function S(c){if(c.verbose)return C.Trace;if(typeof c.logLevel=="string"){const r=l(c.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function l(c){switch(c){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=l;function i(c){switch(c){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=i}),define(ne[171],ie([0,1,5,9,2,10,22,14,8]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends L.Disposable{constructor(b,f){super();this.environmentService=b,this.logService=f,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),h=(await A.Promises.readdir(f)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==b),m=h.slice(0,Math.max(0,h.length-9));m.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${m.join(", ")}'`),await Promise.all(m.map(g=>A.Promises.rm((0,T.join)(f,g)))))}catch(b){(0,t.onUnexpectedError)(b)}}};E=he([K(0,R.IEnvironmentService),K(1,C.ILogService)],E),e.LogsDataCleaner=E}),define(ne[172],ie([0,1,5,9,2,10,22,14,8]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class gt extends L.Disposable{constructor(b,f,p){super();this.backupWorkspacesPath=b,this.environmentService=f,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const b=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(b).emptyWorkspaceInfos.map(h=>h.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async h=>{h.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||h===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(h)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${h}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,h)))}))}catch(b){(0,t.onUnexpectedError)(b)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=he([K(1,R.INativeEnvironmentService),K(2,C.ILogService)],E),e.StorageDataCleaner=E}),define(ne[173],ie([0,1,46,5,37,3,2,18,10,22,14,8]),function(Y,e,k,t,L,T,A,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(d,h){super();this.environmentService=d,this.logService=h,this.processesLimiter=new t.Limiter(5)}async postUninstall(d){const h=this.parseScript(d,"uninstall");return h&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),m=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${m}`)))),E.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,m=>this.logService.error("Error while removing extension storage path",m))}parseScript(d,h){const m=`vscode:${h}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[m]=="string"){const g=d.manifest.scripts[m].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${m} should be a node script`),null):{script:(0,C.join)(d.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(d,h,m,g,y){return new Promise((w,S)=>{const l=this.start(d,h,m,y);let i;const c=r=>{i&&(clearTimeout(i),i=null),r?S(r):w(void 0)};l.on("error",r=>{c((0,L.toErrorMessage)(r)||"Unknown")}),l.on("exit",(r,n)=>{c(r?`post-${h} process exited with code ${r}`:void 0)}),g&&(i=setTimeout(()=>{i=null,l.kill(),S("timed out")},5e3))})}start(d,h,m,g){const y={silent:!0,execArgv:void 0},w=(0,k.fork)(d,[`--type=extension-post-${h}`,...m],y);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const S=T.Event.fromNodeEventEmitter(w.stdout,"data"),l=T.Event.fromNodeEventEmitter(w.stderr,"data");S(r=>this.logService.info(g.identifier.id,g.manifest.version,`post-${h}`,r)),l(r=>this.logService.error(g.identifier.id,g.manifest.version,`post-${h}`,r));const i=T.Event.any(T.Event.map(S,r=>({data:`%c${r}`,format:[""]})),T.Event.map(l,r=>({data:`%c${r}`,format:["color: red"]})));return T.Event.debounce(i,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(g.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),w}getExtensionStoragePath(d){return(0,C.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};f=he([K(0,P.IEnvironmentService),K(1,b.ILogService)],f),e.ExtensionsLifecycle=f}),define(ne[174],ie([0,1,16,5,9,3,2,10,52,8]),function(Y,e,k,t,L,T,A,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends A.Disposable{constructor(f,p){super();this.logService=f,this.options=p,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(f,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,p):this.watchNonRecursive(f,p)}watchUniversal(f,p){const d={path:this.toFilePath(f),excludes:p.excludes,recursive:p.recursive},h=(0,k.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,C.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const p of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const p of this.universalPathsToWatch)(0,C.isRecursiveWatchRequest)(p)&&f.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,p){const d={path:this.toFilePath(f),excludes:p.excludes,recursive:!1},h=(0,k.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,C.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ne[175],ie([0,1,16,5,17,25,3,71,55,2,39,18,176,21,40,136,11,85,8]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,i){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${l}`);const c=new E.DisposableStore;return this.provider.set(l,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:i}),c.add(i.onDidChangeFile(r=>this._onDidFilesChange.fire(new m.FileChangesEvent(r,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&c.add(i.onDidWatchError(r=>this._onDidWatchError.fire(new Error(r)))),c.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:i}),this.provider.delete(l),(0,E.dispose)(c)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(c){i.push(c)}}),!this.provider.has(l)&&await t.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,i){const c=this.provider.get(l.scheme);return!!(c&&c.capabilities&i)}listCapabilities(){return C.Iterable.map(this.provider,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async withProvider(l){if(!(0,p.isAbsolutePath)(l))throw new m.FileOperationError((0,h.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const i=this.provider.get(l.scheme);if(!i){const c=new Error;throw c.name="ENOPRO",c.message=(0,h.localize)(1,null,l.toString()),c}return i}async withReadProvider(l){const i=await this.withProvider(l);if((0,m.hasOpenReadWriteCloseCapability)(i)||(0,m.hasReadWriteCapability)(i)||(0,m.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const i=await this.withProvider(l);if((0,m.hasOpenReadWriteCloseCapability)(i)||(0,m.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.doResolveFile(l,i)}catch(c){throw(0,m.toFileSystemProviderErrorCode)(c)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,h.localize)(2,null,this.resourceForError(l)),1):(0,m.ensureFileSystemProviderError)(c)}}async doResolveFile(l,i){const c=await this.withProvider(l),r=this.isPathCaseSensitive(c),n=i?.resolveTo,s=i?.resolveSingleChildDescendants,o=i?.resolveMetadata,a=await c.stat(l);let u;return this.toFileStat(c,l,a,void 0,!!o,(v,I)=>(u||(u=P.TernarySearchTree.forUris(()=>!r),u.set(l,!0),n&&u.fill(!0,n)),u.get(v.resource)||u.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&s?I===1:!1))}async toFileStat(l,i,c,r,n,s){const{providerExtUri:o}=this.getExtUri(l),a={resource:i,name:o.basename(i),isFile:(c.type&m.FileType.File)!=0,isDirectory:(c.type&m.FileType.Directory)!=0,isSymbolicLink:(c.type&m.FileType.SymbolicLink)!=0,mtime:c.mtime,ctime:c.ctime,size:c.size,readonly:Boolean((c.permissions??0)&m.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,m.etag)({mtime:c.mtime,size:c.size})};if(a.isDirectory&&s(a,r)){try{const u=await l.readdir(i),v=await t.Promises.settled(u.map(async([I,_])=>{try{const O=o.joinPath(i,I),M=n?await l.stat(O):{type:_};return await this.toFileStat(l,O,M,u.length,n,s)}catch(O){return this.logService.trace(O),null}}));a.children=(0,k.coalesce)(v)}catch(u){this.logService.trace(u),a.children=[]}return a}return a}async resolveAll(l){return t.Promises.settled(l.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(c){return this.logService.trace(c),{stat:void 0,success:!1}}}))}async exists(l){const i=await this.withProvider(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.doValidateCreateFile(l,i)}catch(c){return c}return!0}async doValidateCreateFile(l,i){if(!i?.overwrite&&await this.exists(l))throw new m.FileOperationError((0,h.localize)(3,null,this.resourceForError(l)),3,i)}async createFile(l,i=L.VSBuffer.fromString(""),c){await this.doValidateCreateFile(l,c);const r=await this.writeFile(l,i);return this._onDidRunOperation.fire(new m.FileOperationEvent(l,0,r)),r}async writeFile(l,i,c){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,l,c)||await this.mkdirp(r,n.dirname(l));let o;if((0,m.hasReadWriteCapability)(r)&&!(i instanceof L.VSBuffer))if((0,d.isReadableStream)(i)){const a=await(0,d.peekStream)(i,3);a.ended?o=L.VSBuffer.concat(a.buffer):o=a}else o=(0,d.peekReadable)(i,a=>L.VSBuffer.concat(a),3);else o=i;!(0,m.hasOpenReadWriteCloseCapability)(r)||(0,m.hasReadWriteCapability)(r)&&o instanceof L.VSBuffer?await this.doWriteUnbuffered(r,l,c,o):await this.doWriteBuffered(r,l,c,o instanceof L.VSBuffer?(0,L.bufferToReadable)(o):o)}catch(s){throw new m.FileOperationError((0,h.localize)(4,null,this.resourceForError(l),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),c)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,i,c){if(!!c?.unlock&&!(l.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(i)));let n;try{n=await l.stat(i)}catch{return}if((n.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,h.localize)(6,null,this.resourceForError(i)),0,c);if(this.throwIfFileIsReadonly(i,n),typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==m.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&c.mtime<n.mtime&&c.etag!==(0,m.etag)({mtime:c.mtime,size:n.size}))throw new m.FileOperationError((0,h.localize)(7,null),3,c);return n}async readFile(l,i,c){const r=await this.withReadProvider(l);return i?.atomic?this.doReadFileAtomic(r,l,i,c):this.doReadFile(r,l,i,c)}async doReadFileAtomic(l,i,c,r){return new Promise((n,s)=>{this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(l,i,c,r);n(o)}catch(o){s(o)}})})}async doReadFile(l,i,c,r){const n=await this.doReadFileStream(l,i,{...c,preferUnbuffered:!0},r);return{...n,value:await(0,L.streamToBuffer)(n.value)}}async readFileStream(l,i,c){const r=await this.withReadProvider(l);return this.doReadFileStream(r,l,i,c)}async doReadFileStream(l,i,c,r){const n=new T.CancellationTokenSource(r),s=this.validateReadFile(i,c).then(a=>a,a=>{throw n.cancel(),a});let o;try{return typeof c?.etag=="string"&&c.etag!==m.ETAG_DISABLED&&await s,c?.atomic&&(0,m.hasFileAtomicReadCapability)(l)||!((0,m.hasOpenReadWriteCloseCapability)(l)||(0,m.hasFileReadStreamCapability)(l))||(0,m.hasReadWriteCapability)(l)&&c?.preferUnbuffered?o=this.readFileUnbuffered(l,i,c):(0,m.hasFileReadStreamCapability)(l)?o=this.readFileStreamed(l,i,n.token,c):o=this.readFileBuffered(l,i,n.token,c),{...await s,value:o}}catch(a){o&&await(0,d.consumeStream)(o);const u=(0,h.localize)(8,null,this.resourceForError(i),(0,m.ensureFileSystemProviderError)(a).toString());throw a instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(u,a.stat,c):new m.FileOperationError(u,(0,m.toFileOperationResult)(a),c)}}readFileStreamed(l,i,c,r=Object.create(null)){const n=l.readFileStream(i,r,c);return(0,d.transform)(n,{data:s=>s instanceof L.VSBuffer?s:L.VSBuffer.wrap(s),error:s=>new m.FileOperationError((0,h.localize)(9,null,this.resourceForError(i),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),r)},s=>L.VSBuffer.concat(s))}readFileBuffered(l,i,c,r=Object.create(null)){const n=(0,L.newWriteableBufferStream)();return(0,g.readFileIntoStream)(l,i,n,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new m.FileOperationError((0,h.localize)(10,null,this.resourceForError(i),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),r)},c),n}readFileUnbuffered(l,i,c){const r=(0,d.newWriteableStream)(n=>L.VSBuffer.concat(n));return(async()=>{try{let n;c?.atomic&&(0,m.hasFileAtomicReadCapability)(l)?n=await l.readFile(i,{atomic:!0}):n=await l.readFile(i),typeof c?.position=="number"&&(n=n.slice(c.position)),typeof c?.length=="number"&&(n=n.slice(0,c.length)),this.validateReadFileLimits(i,n.byteLength,c),r.end(L.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(l,i){const c=await this.resolve(l,{resolveMetadata:!0});if(c.isDirectory)throw new m.FileOperationError((0,h.localize)(11,null,this.resourceForError(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==m.ETAG_DISABLED&&i.etag===c.etag)throw new m.NotModifiedSinceFileOperationError((0,h.localize)(12,null),c,i);return this.validateReadFileLimits(l,c.size,i),c}validateReadFileLimits(l,i,c){if(c?.limits){let r;if(typeof c.limits.memory=="number"&&i>c.limits.memory&&(r=9),typeof c.limits.size=="number"&&i>c.limits.size&&(r=7),typeof r=="number")throw new m.FileOperationError((0,h.localize)(13,null,this.resourceForError(l)),r)}}async canMove(l,i,c){return this.doCanMoveCopy(l,i,"move",c)}async canCopy(l,i,c){return this.doCanMoveCopy(l,i,"copy",c)}async doCanMoveCopy(l,i,c,r){if(l.toString()!==i.toString())try{const n=c==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,l,s,i,c,r)}catch(n){return n}return!0}async move(l,i,c){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(r,l,n,i,"move",!!c),o=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,s==="move"?2:3,o)),o}async copy(l,i,c){const r=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(r,l,n,i,"copy",!!c),o=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,s==="copy"?3:2,o)),o}async doMoveCopy(l,i,c,r,n,s){if(i.toString()===r.toString())return n;const{exists:o,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(l,i,c,r,n,s);if(o&&!a&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(c,this.getExtUri(c).providerExtUri.dirname(r)),n==="copy"){if(l===c&&(0,m.hasFileFolderCopyCapability)(l))await l.copy(i,r,{overwrite:s});else{const u=await this.resolve(i);u.isDirectory?await this.doCopyFolder(l,u,c,r):await this.doCopyFile(l,i,c,r)}return n}else return l===c?(await l.rename(i,r,{overwrite:s}),n):(await this.doMoveCopy(l,i,c,r,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(l,i,c,r){if((0,m.hasOpenReadWriteCloseCapability)(l)&&(0,m.hasOpenReadWriteCloseCapability)(c))return this.doPipeBuffered(l,i,c,r);if((0,m.hasOpenReadWriteCloseCapability)(l)&&(0,m.hasReadWriteCapability)(c))return this.doPipeBufferedToUnbuffered(l,i,c,r);if((0,m.hasReadWriteCapability)(l)&&(0,m.hasOpenReadWriteCloseCapability)(c))return this.doPipeUnbufferedToBuffered(l,i,c,r);if((0,m.hasReadWriteCapability)(l)&&(0,m.hasReadWriteCapability)(c))return this.doPipeUnbuffered(l,i,c,r)}async doCopyFolder(l,i,c,r){await c.mkdir(r),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async n=>{const s=this.getExtUri(c).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),c,s):this.doCopyFile(l,n.resource,c,s)}))}async doValidateMoveCopy(l,i,c,r,n,s){let o=!1;if(l===c){const{providerExtUri:u,isPathCaseSensitive:v}=this.getExtUri(l);if(v||(o=u.isEqual(i,r)),o&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(i),this.resourceForError(r)));if(!o&&u.isEqualOrParent(r,i))throw new Error((0,h.localize)(15,null,this.resourceForError(i),this.resourceForError(r)))}const a=await this.exists(r);if(a&&!o){if(!s)throw new m.FileOperationError((0,h.localize)(16,null,this.resourceForError(i),this.resourceForError(r)),4);if(l===c){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(i,r))throw new Error((0,h.localize)(17,null,this.resourceForError(i),this.resourceForError(r)))}}return{exists:a,isSameResourceWithDifferentPathCase:o}}getExtUri(l){const i=this.isPathCaseSensitive(l);return{providerExtUri:i?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(i,l);const c=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,0,c)),c}async mkdirp(l,i){const c=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(i,r.dirname(i));)try{if(((await l.stat(i)).type&m.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,m.toFileSystemProviderErrorCode)(n)!==m.FileSystemProviderErrorCode.FileNotFound)throw n;c.push(r.basename(i)),i=r.dirname(i)}for(let n=c.length-1;n>=0;n--){i=r.joinPath(i,c[n]);try{await l.mkdir(i)}catch(s){if((0,m.toFileSystemProviderErrorCode)(s)!==m.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,i){try{await this.doValidateDelete(l,i)}catch(c){return c}return!0}async doValidateDelete(l,i){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!i?.useTrash&&!(c.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(l)));let n;try{n=await c.stat(l)}catch{}if(n)this.throwIfFileIsReadonly(l,n);else throw new m.FileOperationError((0,h.localize)(20,null,this.resourceForError(l)),1);if(!!!i?.recursive){const o=await this.resolve(l);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(l)))}return c}async del(l,i){const c=await this.doValidateDelete(l,i),r=!!i?.useTrash,n=!!i?.recursive;await c.delete(l,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new m.FileOperationEvent(l,1))}watch(l,i={recursive:!1,excludes:[]}){const c=new E.DisposableStore;let r=!1,n=()=>{r=!0};return c.add((0,E.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(l,i);r?(0,E.dispose)(s):n=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),c}async doWatch(l,i){const c=await this.withProvider(l),r=(0,R.hash)([this.getExtUri(c).providerExtUri.getComparisonKey(l),i]);let n=this.activeWatchers.get(r);return n||(n={count:0,disposable:c.watch(l,i)},this.activeWatchers.set(r,n)),n.count+=1,(0,E.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,E.dispose)(n.disposable),this.activeWatchers.delete(r)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,i,c,r){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{const n=await l.open(i,{create:!0,unlock:c?.unlock??!1});try{(0,d.isReadableStream)(r)||(0,d.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(l,n,r):await this.doWriteReadableBufferedQueued(l,n,r)}catch(s){throw(0,m.ensureFileSystemProviderError)(s)}finally{await l.close(n)}})}async doWriteStreamBufferedQueued(l,i,c){let r=0,n;if((0,d.isReadableBufferedStream)(c)){if(c.buffer.length>0){const s=L.VSBuffer.concat(c.buffer);await this.doWriteBuffer(l,i,s,s.byteLength,r,0),r+=s.byteLength}if(c.ended)return;n=c.stream}else n=c;return new Promise((s,o)=>{(0,d.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(l,i,a,a.byteLength,r,0)}catch(u){return o(u)}r+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>o(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,i,c){let r=0,n;for(;(n=c.read())!==null;)await this.doWriteBuffer(l,i,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(l,i,c,r,n,s){let o=0;for(;o<r;)o+=await l.write(i,n+o,c.buffer,s+o,r-o)}async doWriteUnbuffered(l,i,c,r){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,i,c,r))}async doWriteUnbufferedQueued(l,i,c,r){let n;r instanceof L.VSBuffer?n=r:(0,d.isReadableStream)(r)?n=await(0,L.streamToBuffer)(r):(0,d.isReadableBufferedStream)(r)?n=await(0,L.bufferedStreamToBuffer)(r):n=(0,L.readableToBuffer)(r),await l.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:c?.unlock??!1})}async doPipeBuffered(l,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,i,c,r))}async doPipeBufferedQueued(l,i,c,r){let n,s;try{n=await l.open(i,{create:!1}),s=await c.open(r,{create:!0,unlock:!1});const o=L.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,u=0,v=0;do v=await l.read(n,a,o.buffer,u,o.byteLength-u),await this.doWriteBuffer(c,s,o,v,a,u),a+=v,u+=v,u===o.byteLength&&(u=0);while(v>0)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await t.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof s=="number"?c.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,i,c,r))}async doPipeUnbufferedQueued(l,i,c,r){return c.writeFile(r,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,i,c,r){return this.writeQueue.queueFor(r,this.getExtUri(c).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,i,c,r))}async doPipeUnbufferedToBufferedQueued(l,i,c,r){const n=await c.open(r,{create:!0,unlock:!1});try{const s=await l.readFile(i);await this.doWriteBuffer(c,n,L.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,m.ensureFileSystemProviderError)(s)}finally{await c.close(n)}}async doPipeBufferedToUnbuffered(l,i,c,r){const n=await(0,L.streamToBuffer)(this.readFileBuffered(l,i,T.CancellationToken.None));await this.doWriteUnbuffered(c,r,void 0,n)}throwIfFileSystemIsReadonly(l,i){if(l.capabilities&2048)throw new m.FileOperationError((0,h.localize)(22,null,this.resourceForError(i)),6);return l}throwIfFileIsReadonly(l,i){if((i.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,h.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===b.Schemas.file?l.fsPath:l.toString(!0)}};w=he([K(0,y.ILogService)],w),e.FileService=w}),define(ne[177],ie([0,1,50,256,5,39,17,3,41,2,10,4,21,40,22,139,11,85,174,37,166,165]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(k)}catch(c){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(c)}`)}})();class i extends y.AbstractDiskFileSystemProvider{constructor(r,n){super(r,n);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new T.ResourceMap(s=>f.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:n,symbolicLink:s}=await d.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(r){try{const n=await d.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,f.joinPath)(r,o.name))).type:a=this.toType(o),s.push([o.name,a])}catch(a){this.logService.trace(a)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(r,n){let s;return n?.dangling?s=m.FileType.Unknown:r.isFile()?s=m.FileType.File:r.isDirectory()?s=m.FileType.Directory:s=m.FileType.Unknown,n&&(s|=m.FileType.SymbolicLink),s}async createResourceLock(r){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(r)})`);let n;for(;n=this.resourceLocks.get(r);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(r)})`),await n.wait();const s=new L.Barrier;return this.resourceLocks.set(r,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(r)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(r)})`),this.resourceLocks.delete(r),s.open()})}async readFile(r,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(r)})`),s=await this.createResourceLock(r));const o=this.toFilePath(r);return await d.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(r,n,s){const o=(0,p.newWriteableStream)(a=>A.VSBuffer.concat(a.map(u=>A.VSBuffer.wrap(u))).buffer);return(0,g.readFileIntoStream)(this,r,o,a=>a.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(r,n,s){let o;try{const a=this.toFilePath(r);if(!s.create||!s.overwrite){if(await d.Promises.exists(a)){if(!s.overwrite)throw(0,m.createFileSystemProviderError)((0,h.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,m.createFileSystemProviderError)((0,h.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:s.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(r,a)}finally{typeof o=="number"&&await this.close(o)}}async open(r,n){let s;(0,m.isFileOpenForWriteOptions)(n)&&(s=await this.createResourceLock(r));let o;try{const a=this.toFilePath(r);if((0,m.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:v}=await d.SymlinkSupport.stat(a);v.mode&128||await d.Promises.chmod(a,v.mode|128)}catch(v){this.logService.trace(v)}let u;if((0,m.isFileOpenForWriteOptions)(n)){if(b.isWindows)try{await d.Promises.truncate(a,0),u="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}u||(u="w")}else u="r";o=await d.Promises.open(a,u)}catch(a){throw s?.dispose(),(0,m.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(r,a):this.toFileSystemProviderError(a)}return this.mapHandleToPos.set(o,0),(0,m.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(o,r),s&&this.mapHandleToLock.set(o,s),o}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await d.Promises.fdatasync(r)}catch(n){this.canFlush=!1,this.logService.error(n)}return await d.Promises.close(r)}catch(n){throw this.toFileSystemProviderError(n)}finally{const n=this.mapHandleToLock.get(r);n&&(this.mapHandleToLock.delete(r),n.dispose())}}async read(r,n,s,o,a){const u=this.normalizePos(r,n);let v=null;try{const{bytesRead:I}=await d.Promises.read(r,s,o,a,u);return I}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(r,u,v)}}normalizePos(r,n){return n===this.mapHandleToPos.get(r)?null:n}updatePos(r,n,s){const o=this.mapHandleToPos.get(r);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(r,o+s):this.mapHandleToPos.delete(r)))}async write(r,n,s,o,a){return(0,L.retry)(()=>this.doWrite(r,n,s,o,a),100,3)}async doWrite(r,n,s,o,a){const u=this.normalizePos(r,n);let v=null;try{const{bytesWritten:I}=await d.Promises.write(r,s,o,a,u);return I}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),I)}finally{this.updatePos(r,u,v)}}async mkdir(r){try{await d.Promises.mkdir(this.toFilePath(r))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(r,n){try{const s=this.toFilePath(r);n.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(r,n,s){const o=this.toFilePath(r),a=this.toFilePath(n);if(o!==a)try{await this.validateTargetDeleted(r,n,"move",s.overwrite),await d.Promises.move(o,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,h.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(r,n,s){const o=this.toFilePath(r),a=this.toFilePath(n);if(o!==a)try{await this.validateTargetDeleted(r,n,"copy",s.overwrite),await d.Promises.copy(o,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,h.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(r,n,s,o){const a=this.toFilePath(r),u=this.toFilePath(n);let v=!1;if(!!(this.capabilities&1024)||(v=(0,C.isEqual)(a,u,!0)),v&&s==="copy")throw(0,m.createFileSystemProviderError)((0,h.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!v&&await d.Promises.exists(u)){if(!o)throw(0,m.createFileSystemProviderError)((0,h.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(r,n,s){return new S.UniversalWatcherClient(o=>r(o),o=>n(o),s)}createNonRecursiveWatcher(r,n,s){return new l.NodeJSWatcherClient(o=>r(o),o=>n(o),s)}toFileSystemProviderError(r){if(r instanceof m.FileSystemProviderError)return r;let n;switch(r.code){case"ENOENT":n=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=m.FileSystemProviderErrorCode.NoPermissions;break;default:n=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(r,n)}async toFileSystemProviderWriteError(r,n){let s=this.toFileSystemProviderError(n);if(r&&s.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await d.SymlinkSupport.stat(this.toFilePath(r));o.mode&128||(s=(0,m.createFileSystemProviderError)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=i}),define(ne[87],ie([0,1,3,7,8]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=k.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(f,p,d){switch(p){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,p){return f.call("setLevel",p)}}e.LogLevelChannelClient=A;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,p){throw new Error(`Event not found: ${p}`)}async call(f,p,d){switch(p){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${p}`)}createLogger(f,p){this.loggers.set(f.toString(),this.loggerService.createLogger(f,p))}consoleLog(f,p){let d=console.log;switch(f){case L.LogLevel.Error:d=console.error;break;case L.LogLevel.Warning:d=console.warn;break;case L.LogLevel.Info:d=console.info;break}d.call(console,...p)}log(f,p){const d=this.loggers.get(f.toString());if(!d)throw new Error("Create the logger before logging");for(const[h,m]of p)(0,L.log)(d,h,m)}}e.LoggerChannel=R;class C extends L.AbstractLoggerService{constructor(f,p,d){super(f,p);this.channel=d}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,p)=>{this.channel.call("consoleLog",[f,p])}})}doCreateLogger(f,p,d){return new E(this.channel,f,p,d)}}e.LoggerChannelClient=C;class E extends L.AbstractMessageLogger{constructor(f,p,d,h){super(h?.always);this.channel=f,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[p,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,p){const d=[[f,p]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(f){this.channel.call("log",[this.file,f])}}class P extends L.LogService{constructor(f,p){super(p);this.parent=f,this._register(f.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=P}),define(ne[60],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(ne[88],ie([0,1,18,4,33,21]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const R=t.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const R=(0,T.dirname)(k.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,T.joinPath)(R,"product.json").fsPath);const C=Y.__$__nodeRequire((0,T.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:C.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(ne[27],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[178],ie([0,1,5,9,2,10,22,8,27]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends L.Disposable{constructor(b,f,p){super();this.productService=f,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},30*1e3)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),p=(0,T.dirname)(b),d=(0,T.basename)(b),h=await A.Promises.readdir(p);await Promise.all(h.map(async m=>{if(m===d)return;const g=(0,T.join)(p,m),y=await A.Promises.stat(g);if(y.isDirectory()&&f-y.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${m}.`),A.Promises.rm(g)}))}catch(f){(0,t.onUnexpectedError)(f)}}};E=he([K(1,C.IProductService),K(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[179],ie([0,1,5,9,2,10,22,14,8,27]),function(Y,e,k,t,L,T,A,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends L.Disposable{constructor(f,p,d){super();this.environmentService=f,this.logService=p,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),p=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(p)){const w=p[y];f[`${w.hash}.${y}`]=!0}const d=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const m=await A.Promises.readdir(d);for(const y of m){if(f[y]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await A.Promises.rm((0,T.join)(d,y))}const g=Date.now();for(const y of Object.keys(f)){const w=(0,T.join)(d,y),S=await A.Promises.readdir(w);for(const l of S){if(l==="tcf.json")continue;const i=(0,T.join)(w,l),c=await A.Promises.stat(i);c.isDirectory()&&g-c.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(y,l)}`),await A.Promises.rm(i))}}}catch(f){(0,t.onUnexpectedError)(f)}}};P=he([K(0,R.INativeEnvironmentService),K(1,C.ILogService),K(2,E.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ne[180],ie([0,1,10,6]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,t.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(R,C="noAbsolutePaths"){for(const E of R.nodes)E.callFrame&&E.callFrame.url&&((0,k.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,k.join)(C,(0,k.basename)(E.callFrame.url)));return R}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(ne[181],ie([0,1,29]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class t{constructor(){this._sessions=new Map}async startProfiling(T){const R=await(await new Promise((E,P)=>{Y(["v8-inspect-profiler"],E,P)})).startProfiling({port:T.port,checkForPaused:!0}),C=(0,k.generateUuid)();return this._sessions.set(C,R),C}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const R=await A.stop();return this._sessions.delete(T),R.profile}}e.InspectProfilingService=t}),define(ne[38],ie([0,1,99,15]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,R){k.ok(t.isString(A)),k.ok(t.isObject(R)),k.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(ne[89],ie([0,1,3,38]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,E){this.schemasById[L(C)]=E,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[42],ie([0,1,16,3,15,125,89,38]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(A.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,i=!0){this.registerConfigurations([l],i)}registerConfigurations(l,i=!0){const c=this.doRegisterConfigurations(l,i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}deregisterConfigurations(l){const i=this.doDeregisterConfigurations(l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:l,remove:i}){const c=[];c.push(...this.doDeregisterConfigurations(i)),c.push(...this.doRegisterConfigurations(l,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,k.distinct)(c)})}registerDefaultConfigurations(l){const i=[],c=[];for(const{overrides:r,source:n}of l)for(const s in r)if(i.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...r[s]};this.configurationDefaultsOverrides.set(s,{source:n,value:o});const a={type:"object",default:o,description:T.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:L.isString(n)?void 0:n};c.push(...d(s)),this.configurationProperties[s]=a,this.defaultLanguageConfigurationOverridesNode.properties[s]=a}else{this.configurationDefaultsOverrides.set(s,{value:r[s],source:n});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const i=[];for(const{overrides:c,source:r}of l)for(const n in c){const s=this.configurationDefaultsOverrides.get(n),o=L.isString(r)?r:r?.id,a=L.isString(s?.source)?s?.source:s?.source?.id;if(o===a)if(i.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const u=this.configurationProperties[n];u&&(this.updatePropertyDefaultValue(n,u),this.updateSchema(n,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const i of l)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,i){const c=[];return l.forEach(r=>{c.push(...this.validateAndRegisterProperties(r,i,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),c}doDeregisterConfigurations(l){const i=[],c=r=>{if(r.properties)for(const n in r.properties)i.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,r.properties[n]);r.allOf&&r.allOf.forEach(n=>c(n))};for(const r of l){c(r);const n=this.configurationContributors.indexOf(r);n!==-1&&this.configurationContributors.splice(n,1)}return i}validateAndRegisterProperties(l,i=!0,c,r,n=3){n=L.isUndefinedOrNull(l.scope)?n:l.scope;let s=[],o=l.properties;if(o)for(let u in o){if(i&&y(u)){delete o[u];continue}const v=o[u];if(v.source=c,v.defaultDefaultValue=o[u].default,this.updatePropertyDefaultValue(u,v),e.OVERRIDE_PROPERTY_REGEX.test(u)?v.scope=void 0:(v.scope=L.isUndefinedOrNull(v.scope)?n:v.scope,v.restricted=L.isUndefinedOrNull(v.restricted)?!!r?.includes(u):v.restricted),o[u].hasOwnProperty("included")&&!o[u].included){this.excludedConfigurationProperties[u]=o[u],delete o[u];continue}else this.configurationProperties[u]=o[u];!o[u].deprecationMessage&&o[u].markdownDeprecationMessage&&(o[u].deprecationMessage=o[u].markdownDeprecationMessage),s.push(u)}let a=l.allOf;if(a)for(let u of a)s.push(...this.validateAndRegisterProperties(u,i,c,r,n));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const i=c=>{let r=c.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let n=c.allOf;n&&n.forEach(i)};i(l)}updateSchema(l,i){switch(e.allSettings.properties[l]=i,i.scope){case 1:e.applicationSettings.properties[l]=i;break;case 2:e.machineSettings.properties[l]=i;break;case 6:e.machineOverridableSettings.properties[l]=i;break;case 3:e.windowSettings.properties[l]=i;break;case 4:e.resourceSettings.properties[l]=i;break;case 5:e.resourceSettings.properties[l]=i,this.resourceLanguageSettingsSchema.properties[l]=i;break}}removeFromSchema(l,i){switch(delete e.allSettings.properties[l],i.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const i=`[${l}]`,c={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,c),e.allSettings.properties[i]=c,e.applicationSettings.properties[i]=c,e.machineSettings.properties[i]=c,e.machineOverridableSettings.properties[i]=c,e.windowSettings.properties[i]=c,e.resourceSettings.properties[i]=c}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,i){const c=this.configurationDefaultsOverrides.get(l);let r=c?.value,n=c?.source;L.isUndefined(r)&&(r=i.defaultDefaultValue,n=void 0),L.isUndefined(r)&&(r=m(i.type)),i.default=r,i.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(S){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let i=p.exec(S);for(;i?.length;){const c=i[1].trim();c&&l.push(c),i=p.exec(S)}}return(0,k.distinct)(l)}e.overrideIdentifiersFromKey=d;function h(S){return S.reduce((l,i)=>`${l}[${i}]`,"")}e.keyFromOverrideIdentifiers=h;function m(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const g=new b;R.Registry.add(e.Extensions.Configuration,g);function y(S){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?T.localize(7,null,S):g.getConfigurationProperties()[S]!==void 0?T.localize(8,null,S):null:T.localize(6,null)}e.validateProperty=y;function w(){const S=[],l=g.getConfigurationProperties();for(const i of Object.keys(l))S.push([i,l[i].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=w}),define(ne[90],ie([0,1,16,3,35,2,39,28,15,7,19,42,38]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(r={},n=[],s=[]){this._contents=r,this._keys=n,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,P.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,n){const s=this.getContentsForOverrideIdentifer(n);return s?r?(0,P.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const s of this.overrides)s.identifiers.includes(r)&&n.push(...s.keys);return k.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return k.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const a of r){this.mergeContents(n,a.contents);for(const u of a.overrides){const[v]=s.filter(I=>k.equals(I.identifiers,u.identifiers));v?(this.mergeContents(v.contents,u.contents),v.keys.push(...u.keys),v.keys=k.distinct(v.keys)):s.push(R.deepClone(u))}for(const u of a.keys)o.indexOf(u)===-1&&o.push(u)}return new p(n,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o],u=n[o];u&&(typeof a=="object"&&typeof u=="object"?(a=R.deepClone(a),this.mergeContents(a,u)):a=u),s[o]=a}return new p(s,this.keys,this.overrides)}mergeContents(r,n){for(const s of Object.keys(n)){if(s in r&&C.isObject(r[s])&&C.isObject(n[s])){this.mergeContents(r[s],n[s]);continue}r[s]=R.deepClone(n[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?R.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,s=null;const o=a=>{a&&(s?this.mergeContents(s,a):s=R.deepClone(a))};for(const a of this.overrides)k.equals(a.identifiers,[r])?n=a.contents:a.identifiers.includes(r)&&o(a.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,P.addToValueTree)(this.contents,r,n,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,P.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let s=0;s<n;s++)r.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,r)}removeKey(r){let n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=p;class d extends p{constructor(r={}){const n=f.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(n),o=Object.create(null),a=[];for(const u in n){const v=r[u],I=v!==void 0?v:n[u].default;(0,P.addToValueTree)(o,u,I,_=>console.error(`Conflict in default settings: ${_}`))}for(const u of Object.keys(o))b.OVERRIDE_PROPERTY_REGEX.test(u)&&a.push({identifiers:(0,b.overrideIdentifiersFromKey)(u),keys:Object.keys(o[u]),contents:(0,P.toValuesTree)(o[u],v=>console.error(`Conflict in default settings file: ${v}`))});super(o,s,a)}}e.DefaultConfigurationModel=d;class h{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!C.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:s,keys:o,overrides:a,restricted:u}=this.doParseRaw(r,n);this._configurationModel=new p(s,o,a),this._restrictedConfigurations=u||[]}doParseContent(r){let n={},s=null,o=[],a=[],u=[];function v(_){Array.isArray(o)?o.push(_):s!==null&&(o[s]=_)}let I={onObjectBegin:()=>{let _={};v(_),a.push(o),o=_,s=null},onObjectProperty:_=>{s=_},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let _=[];v(_),a.push(o),o=_,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:v,onError:(_,O,M)=>{u.push({error:_,offset:O,length:M})}};if(r)try{L.visit(r,I),n=o[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return n}doParseRaw(r,n){const s=f.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,s,!0,n);r=o.raw;const a=(0,P.toValuesTree)(r,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),u=Object.keys(r),v=this.toOverrides(r,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:a,keys:u,overrides:v,restricted:o.restricted}}filter(r,n,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const a={},u=[];for(let v in r)if(b.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const I=this.filter(r[v],n,!1,o);a[v]=I.raw,u.push(...I.restricted)}else{const I=n[v],_=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&u.push(v),(_===void 0||o.scopes===void 0||o.scopes.includes(_))&&(o.skipRestricted&&I?.restricted||(a[v]=r[v]))}return{raw:a,restricted:u}}toOverrides(r,n){const s=[];for(const o of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const u in r[o])a[u]=r[o][u];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,P.toValuesTree)(a,n)})}return s}}e.ConfigurationModelParser=h;class m extends T.Disposable{constructor(r,n,s,o){super();this.userSettingsResource=r,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class g{constructor(r,n,s=new p,o=new p,a=new A.ResourceMap,u=new p,v=new A.ResourceMap,I=!0){this._defaultConfiguration=r,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=u,this._memoryConfigurationByResource=v,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(r)}updateValue(r,n,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new p,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(r):o.setValue(r,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,s){const o=this.getConsolidateConfigurationModel(n,s),a=this.getFolderConfigurationModelForResource(n.resource,s),u=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,v=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),I=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),_=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),O=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),M=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,D=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,U=n.overrideIdentifier?u.override(n.overrideIdentifier).getValue(r):u.getValue(r),F=o.getValue(r),x=k.distinct(k.flatten(o.overrides.map(q=>q.identifiers))).filter(q=>o.getOverrideValue(r,q)!==void 0);return{defaultValue:v,userValue:I,userLocalValue:_,userRemoteValue:O,workspaceValue:M,workspaceFolderValue:D,memoryValue:U,value:F,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:a?.freeze().getValue(r),override:n.overrideIdentifier?a?.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:u.getValue(r),override:n.overrideIdentifier?u.getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const s=[];if(!n){const{added:o,updated:a,removed:u}=l(this._defaultConfiguration,r);n=[...o,...a,...u]}for(const o of n)for(const a of(0,b.overrideIdentifiersFromKey)(o)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(a),v=r.getKeysForOverrideIdentifier(a),I=[...v.filter(_=>u.indexOf(_)===-1),...u.filter(_=>v.indexOf(_)===-1),...u.filter(_=>!R.equals(this._defaultConfiguration.override(a).getValue(_),r.override(a).getValue(_)))];s.push([a,I])}return this.updateDefaultConfiguration(r),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:s,removed:o,overrides:a}=l(this.localUserConfiguration,r),u=[...n,...s,...o];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:s,removed:o,overrides:a}=l(this.remoteUserConfiguration,r);let u=[...n,...s,...o];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:s,removed:o,overrides:a}=l(this.workspaceConfiguration,r);let u=[...n,...s,...o];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:a}}compareAndUpdateFolderConfiguration(r,n){const s=this.folderConfigurations.get(r),{added:o,updated:a,removed:u,overrides:v}=l(s,n);let I=[...o,...a,...u];return(I.length||!s)&&this.updateFolderConfiguration(r,n),{keys:I,overrides:v}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:o,removed:a,overrides:u}=l(n,void 0);return{keys:[...s,...o,...a],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,n){let s=this.getConsolidatedConfigurationModelForResource(r,n);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const o=n.getFolder(r);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const a=this._memoryConfigurationByResource.get(r);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(n=s.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=s}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const s=n.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:s,overrides:o,keys:a}=this._folderConfigurations.get(n);return r.push([n,{contents:s,overrides:o,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),o=this.parseConfigurationModel(r.workspace),a=r.folders.reduce((u,v)=>(u.set(E.URI.revive(v[0]),this.parseConfigurationModel(v[1])),u),new A.ResourceMap);return new g(n,s,new p,o,a,new p,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=g;function y(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const r=new Set,n=new Map;for(const o of c)o.keys.forEach(a=>r.add(a)),o.overrides.forEach(([a,u])=>{const v=(0,A.getOrSet)(n,a,new Set);u.forEach(I=>v.add(I))});const s=[];return n.forEach((o,a)=>s.push([a,[...o.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=y;class w{constructor(r,n,s,o){this.change=r,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(v=>a.add(v)),r.overrides.forEach(([,v])=>v.forEach(I=>a.add(I))),this.affectedKeys=[...a.values()];const u=new p;this.affectedKeys.forEach(v=>u.setValue(v,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let s=(0,P.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(r=r[o],!r)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=w;class S extends w{constructor(r,n,s,o){super({keys:r.allKeys(),overrides:[]},void 0,r,n);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=S;function l(c,r){const{added:n,removed:s,updated:o}=i(r,c),a=[],u=c?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const I=v.filter(_=>!u.includes(_));for(const _ of I)a.push([_,r.getKeysForOverrideIdentifier(_)])}if(c){const I=u.filter(_=>!v.includes(_));for(const _ of I)a.push([_,c.getKeysForOverrideIdentifier(_)])}if(r&&c){for(const I of u)if(v.includes(I)){const _=i({contents:c.getOverrideValue(void 0,I)||{},keys:c.getKeysForOverrideIdentifier(I)},{contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)});a.push([I,[..._.added,..._.removed,..._.updated]])}}return{added:n,removed:s,updated:o,overrides:a}}function i(c,r){const n=c?r?c.keys.filter(a=>r.keys.indexOf(a)===-1):[...c.keys]:[],s=r?c?r.keys.filter(a=>c.keys.indexOf(a)===-1):[...r.keys]:[],o=[];if(c&&r){for(const a of r.keys)if(c.keys.indexOf(a)!==-1){const u=(0,P.getConfigurationValue)(r.contents,a),v=(0,P.getConfigurationValue)(c.contents,a);R.equals(u,v)||o.push(a)}}return{added:n,removed:s,updated:o}}}),define(ne[182],ie([0,1,5,3,2,21,19,90,42,38]),function(Y,e,k,t,L,T,A,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends L.Disposable{constructor(f,p){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,p)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:d})=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,p){const d=typeof f=="string"?f:void 0,h=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(d,h,void 0)}updateValue(f,p,d,h){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(d,p,1)}onDidDefaultConfigurationChange(f){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(d,p,6)}trigger(f,p,d){const h=new R.ConfigurationChangeEvent(f,{data:p},this.configuration);h.source=d,h.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ne[183],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(A,R=t.Unknown,C){super(A);this._message=A,this._code=R,this._detail=C,this.isHandled=R===t.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===t.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===t.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[184],ie([0,1,5,17,25,9,3,2,29,74,183]),function(Y,e,k,t,L,T,A,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(H){const Q=new L.CancellationTokenSource;return setTimeout(()=>Q.cancel(),H),Q.token}function h(H,Q){if(H.isCancellationRequested||Q.isCancellationRequested)return L.CancellationToken.Cancelled;const Z=new L.CancellationTokenSource;return H.onCancellationRequested(()=>Z.cancel()),Q.onCancellationRequested(()=>Z.cancel()),Z.token}class m{constructor(Q){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((Z,B)=>{this._resolvePromise=Z,this._rejectPromise=B}),Q.isCancellationRequested?this._timeout():this._disposables.add(Q.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Q){this._state==="pending"?this._disposables.add(Q):Q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Q))}reject(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Q))}}function g(H,Q){const Z=new m(Q);return Z.registerDisposable(H.onControlMessage(B=>{const N=JSON.parse(B.toString()),$=G(N);$?Z.reject($):Z.resolve(N)})),Z.promise}function y(H,Q,Z,B,N,$,z){const V=new m(z);return Q.connect(Z,B,N,$,(ee,se)=>{V.didTimeout?(ee&&H.error(ee),se?.dispose()):ee||!se?V.reject(ee):V.resolve(se)}),V.promise}function w(H,Q){const Z=new m(Q);return H.then(B=>{Z.didTimeout||Z.resolve(B)},B=>{Z.didTimeout||Z.reject(B)}),Z.promise}async function S(H,Q,Z,B){const N=j(H,Q);H.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let $;try{$=await y(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${p(Q)}-${H.reconnectionToken}`,B)}catch(ae){throw H.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ae),ae}H.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let z,V;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection($,null),z=H.reconnectionProtocol,V=!1):(z=new E.PersistentProtocol($,null),V=!0),H.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const ee=await w(H.signService.createNewMessage((0,C.generateUuid)()),B),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:ee.data};z.sendControl(t.VSBuffer.fromString(JSON.stringify(se)));try{const ae=await g(z,h(B,d(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(H.logService.trace(`${N} 4/6. received SignRequest control message.`),!await w(H.signService.validate(ee,ae.signedData),B)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const ve=await w(H.signService.sign(ae.data),B),be={type:"connectionType",commit:H.commit,signedData:ve,desiredConnectionType:Q};return Z&&(be.args=Z),H.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(t.VSBuffer.fromString(JSON.stringify(be))),{protocol:z,ownsProtocol:V}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(H.logService.error(`${N} the handshake timed out. Error:`),H.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${N} received error control message when negotiating connection. Error:`),H.logService.error(ae)),V&&q(z),ae}}async function l(H,Q,Z,B){const N=Date.now(),$=j(H,Q),{protocol:z,ownsProtocol:V}=await S(H,Q,Z,B),ee=new m(B);return ee.registerDisposable(z.onControlMessage(se=>{const ae=JSON.parse(se.toString()),de=G(ae);de?(H.logService.error(`${$} received error control message when negotiating connection. Error:`),H.logService.error(de),V&&q(z),ee.reject(de)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${J(N)}!`),ee.resolve({protocol:z,firstMessage:ae}))})),ee.promise}async function i(H,Q){const{protocol:Z}=await l(H,1,void 0,Q);return{protocol:Z}}async function c(H,Q,Z){const{protocol:B,firstMessage:N}=await l(H,2,Q,Z),$=N&&N.debugPort;return{protocol:B,debugPort:$}}async function r(H,Q,Z){const B=Date.now(),N=j(H,3),{protocol:$}=await S(H,3,Q,Z);return H.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${J(B)}!`),$}async function n(H,Q,Z){const{host:B,port:N,connectionToken:$}=await H.addressProvider.getAddress();return{commit:H.commit,host:B,port:N,connectionToken:$,reconnectionToken:Q,reconnectionProtocol:Z,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function s(H,Q,Z){try{const B=(0,C.generateUuid)(),N=await n(H,B,null),{protocol:$}=await i(N,L.CancellationToken.None);return new F(H,Q,Z,B,$)}catch(B){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(B),U.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentManagement=s;async function o(H,Q){try{const Z=(0,C.generateUuid)(),B=await n(H,Z,null),{protocol:N,debugPort:$}=await c(B,Q,L.CancellationToken.None);return new x(H,Q,Z,N,$)}catch(Z){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(Z),U.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(Z)),Z}}e.connectRemoteAgentExtensionHost=o;async function a(H,Q,Z){const B=await n(H,(0,C.generateUuid)(),null);return await r(B,{host:Q,port:Z},L.CancellationToken.None)}e.connectRemoteAgentTunnel=a;function u(H){return(0,k.createCancelablePromise)(Q=>new Promise((Z,B)=>{const N=setTimeout(Z,H*1e3);Q.onCancellationRequested(()=>{clearTimeout(N),Z()})}))}var v;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(v=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(Q,Z){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.type=0}}e.ConnectionLostEvent=I;class _{constructor(Q,Z,B,N){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.durationSeconds=B,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Q,Z,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=O;class M{constructor(Q,Z,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.type=4}}e.ConnectionGainEvent=M;class D{constructor(Q,Z,B,N){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=B,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=D;class U extends R.Disposable{constructor(Q,Z,B,N){super();this._connectionType=Q,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=Z,this.reconnectionToken=B,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new M(this.reconnectionToken,0,0)),this._register(N.onSocketClose($=>{const z=W(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const $=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${$} received socket timeout event.`),this._beginReconnecting()})),U._instances.push(this),U._permanentFailure&&this._gotoPermanentFailure(U._permanentFailureMillisSinceLastIncomingData,U._permanentFailureAttempt,U._permanentFailureHandled)}static triggerPermanentFailure(Q,Z,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Q,this._permanentFailureAttempt=Z,this._permanentFailureHandled=B,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Q=>Q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Q=>Q._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(U._permanentFailure)return;const Q=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Z=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const N=B<Z.length?Z[B]:Z[Z.length-1];try{if(N>0){const z=u(N);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,z)),this._options.logService.info(`${Q} waiting for ${N} seconds before reconnecting...`);try{await z}catch{}}if(U._permanentFailure){this._options.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${Q} resolving connection...`);const $=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Q} connecting to ${$.host}:${$.port}...`),await this._reconnect($,d(b)),this._options.logService.info(`${Q} reconnected!`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,T.isCancellationError)($)){this._options.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,P.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),U.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!U._permanentFailure)}_gotoPermanentFailure(Q,Z,B){this._onDidStateChange.fire(new D(this.reconnectionToken,Q,Z,B)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=U,U._permanentFailure=!1,U._permanentFailureMillisSinceLastIncomingData=0,U._permanentFailureAttempt=0,U._permanentFailureHandled=!1,U._instances=[];class F extends U{constructor(Q,Z,B,N,$){super(1,Q,N,$);this.client=this._register(new E.Client($,{remoteAuthority:Z,clientId:B},Q.ipcLogger))}async _reconnect(Q,Z){await i(Q,Z)}}e.ManagementPersistentConnection=F;class x extends U{constructor(Q,Z,B,N,$){super(2,Q,B,N);this._startArguments=Z,this.debugPort=$}async _reconnect(Q,Z){await c(Q,this._startArguments,Z)}}e.ExtensionHostPersistentConnection=x;function q(H){try{H.acceptDisconnect();const Q=H.getSocket();H.dispose(),Q.dispose()}catch(Q){(0,T.onUnexpectedError)(Q)}}function G(H){if(H&&H.type==="error"){const Q=new Error(`Connection error: ${H.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function te(H,Q){for(;H.length<Q;)H+=" ";return H}function W(H,Q,Z){return`[remote-connection][${te(p(H),13)}][${Q.substr(0,5)}\u2026][${Z?"reconnect":"initial"}]`}function j(H,Q){return`${W(Q,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function J(H){return`${Date.now()-H} ms`}}),define(ne[185],ie([0,1,18]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===k.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function L(T){if(!T)return;const A=T.indexOf("+");return A<0?T:T.substr(0,A)}e.getRemoteName=L}),define(ne[61],ie([0,1,26,6,185]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,d){if(typeof p=="undefined"||p===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof p=="string"||typeof d=="string"){let h=typeof p=="string"?p:p.value,m=typeof d=="string"?d:d.value;return k.equalsIgnoreCase(h,m)}return p._lower===d._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=C;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function P(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function b(f,p){if(p){const d=`onResolveRemoteAuthority:${(0,L.getRemoteName)(p)}`;return f.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[31],ie([0,1,26,61]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(d,h){return d.uuid&&h.uuid?d.uuid===h.uuid:d.id===h.id?!0:(0,k.compareIgnoreCase)(d.id,h.id)===0}e.areSameExtensions=L;class T{constructor(h,m){this.version=m,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof T?L(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(d,h){return`${d}.${h}`}e.getExtensionId=A;function R(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function C(d,h){return R(A(d,h))}e.getGalleryExtensionId=C;function E(d,h){const m=[],g=y=>{for(const w of m)if(w.some(S=>L(h(S),h(y))))return w;return null};for(const y of d){const w=g(y);w?w.push(y):m.push([y])}return m}e.groupByExtension=E;function P(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function b(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function f(d){const h=new Set;if(d.malicious)for(const m of d.malicious)h.add(m.id);return h}e.getMaliciousExtensionsSet=f;function p(d,h){const m=[],g=h.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const y=g.shift();if(y&&m.every(w=>!L(w.identifier,{id:y}))){const w=d.filter(S=>L(S.identifier,{id:y}));w.length===1&&(m.push(w[0]),g.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=p}),define(ne[30],ie([0,1,18,130,31,6]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const A=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function R(i){const c=A.exec(i);return c&&c[1]?[(0,L.adoptToGalleryExtensionId)(c[1]),c[2]]:[(0,L.adoptToGalleryExtensionId)(i),void 0]}e.getIdAndVersion=R;var C;(function(i){i.WIN32_X64="win32-x64",i.WIN32_IA32="win32-ia32",i.WIN32_ARM64="win32-arm64",i.LINUX_X64="linux-x64",i.LINUX_ARM64="linux-arm64",i.LINUX_ARMHF="linux-armhf",i.ALPINE_X64="alpine-x64",i.ALPINE_ARM64="alpine-arm64",i.DARWIN_X64="darwin-x64",i.DARWIN_ARM64="darwin-arm64",i.WEB="web",i.UNIVERSAL="universal",i.UNKNOWN="unknown",i.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function E(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function P(i){switch(i){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function b(i,c){switch(i){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=b;function f(i,c){return c==="web"&&!i.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function p(i,c,r){return f(c,r)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===r?!0:d(r).includes(i)}e.isTargetPlatformCompatible=p;function d(i){switch(i){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=d;function h(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=h;var m;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var g;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var y;(function(i){i.Install="install",i.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var S;(function(i){i.Unsupported="Unsupported",i.UnsupportedPreRelease="UnsupportedPreRelease",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatiblePreRelease="IncompatiblePreRelease",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(c,r){super(c);this.code=r,this.name=r}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(ne[186],ie([0,1,3,2,28,7,110,30]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(h,m){return T.URI.revive(m?m.transformIncoming(h):h)}function E(h,m){return m?m.transformOutgoingURI(h):h}function P(h,m){m=m||A.DefaultURITransformer;const g=h.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...h,manifest:void 0},m),manifest:g}}function b(h,m){return m?(0,L.cloneAndChange)(h,g=>g instanceof T.URI?m.transformOutgoingURI(g):void 0):h}class f{constructor(m,g){this.service=m,this.getUriTransformer=g,this.onInstallExtension=k.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,g){const y=this.getUriTransformer(m);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,w=>w.map(S=>({...S,local:S.local?b(S.local,y):S.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,g,y){const w=this.getUriTransformer(m);switch(g){case"zip":return this.service.zip(P(y[0],w)).then(S=>E(S,w));case"unzip":return this.service.unzip(C(y[0],w));case"install":return this.service.install(C(y[0],w),y[1]);case"getManifest":return this.service.getManifest(C(y[0],w));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(P(y[0],w),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(y[0],w));case"getInstalled":return this.service.getInstalled(y[0]).then(S=>S.map(l=>b(l,w)));case"updateMetadata":return this.service.updateMetadata(P(y[0],w),y[1]).then(S=>b(S,w));case"updateExtensionScope":return this.service.updateExtensionScope(P(y[0],w),y[1]).then(S=>b(S,w));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends t.Disposable{constructor(m){super();this.channel=m,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?T.URI.revive(g.source):g.source}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(y=>({...y,local:y.local?P(y.local,null):y.local,source:this.isUriComponents(y.source)?T.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire(g))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire(g)))}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const g=await this.getTargetPlatform();return m.allTargetPlatforms.some(y=>(0,R.isTargetPlatformCompatible)(y,m.allTargetPlatforms,g))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(g=>T.URI.revive(g)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,g){return Promise.resolve(this.channel.call("install",[m,g])).then(y=>P(y,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,g){return Promise.resolve(this.channel.call("installFromGallery",[m,g])).then(y=>P(y,null))}uninstall(m,g){return Promise.resolve(this.channel.call("uninstall",[m,g]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null){return Promise.resolve(this.channel.call("getInstalled",[m])).then(g=>g.map(y=>P(y,null)))}updateMetadata(m,g){return Promise.resolve(this.channel.call("updateMetadata",[m,g])).then(y=>P(y,null))}updateExtensionScope(m,g){return Promise.resolve(this.channel.call("updateExtensionScope",[m,g])).then(y=>P(y,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class d{constructor(m){this.service=m}listen(m,g){throw new Error("Invalid listen")}call(m,g,y){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(ne[187],ie([0,1,25,31]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,R,C,E){try{const P=await T.getExtensionsControlManifest();if(!P.unsupportedPreReleaseExtensions)return;const b=await T.getInstalled(1);for(const[f,{id:p,migrateStorage:d}]of Object.entries(P.unsupportedPreReleaseExtensions)){const h=b.find(g=>(0,t.areSameExtensions)(g.identifier,{id:f}));if(!h)continue;const m=(await A.getExtensions([{id:p,preRelease:!0}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!m){E.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{E.info(`Migrating '${h.identifier.id}' extension to '${p}' extension...`);const g=!C.getDisabledExtensions().some(w=>(0,t.areSameExtensions)(w,h.identifier));await T.uninstall(h),E.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let y=b.find(w=>(0,t.areSameExtensions)(w.identifier,{id:p}));(!y||!y.isPreReleaseVersion&&g)&&(y=await T.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${y.identifier.id}'`),g||(await C.disableExtension(y.identifier),E.info(`Disabled the pre-release extension '${y.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),d&&(R.addToMigrationList((0,t.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,t.getExtensionId)(y.manifest.publisher,y.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${h.identifier.id}' extension to '${p}' extension.`)}catch(g){E.error(g)}}}catch(P){E.error(P)}}e.migrateUnsupportedExtensions=L}),define(ne[188],ie([0,1,5,9,2,4,21,62,7,29,22,14,30,31,11,8]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends L.Disposable{constructor(w,S,l,i){super();this.fileService=S,this.extensionGalleryService=l,this.logService=i,this.extensionsDownloadDir=C.URI.file(w.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(w,S){await this.cleanUpPromise;const l=this.getName(w),i=(0,A.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(i)){const c=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(c)||await this.extensionGalleryService.download(w,c,S);try{await this.rename(c,i,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(c)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",w.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,c.path),r}}return i}async delete(w){await this.cleanUpPromise,await this.fileService.del(w)}async rename(w,S,l){try{await P.Promises.rename(w.fsPath,S.fsPath)}catch(i){if(T.isWindows&&i&&i.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${w} to ${S} with 'EPERM' error. Trying again...`),this.rename(w,S,l);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const w=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(w.children){const S=[],l=[];for(const r of w.children){const n=this.parse(r.name);n&&l.push([n,r])}const i=(0,p.groupByExtension)(l,([r])=>r),c=[];for(const r of i)r.sort((n,s)=>R.rcompare(n[0].version,s[0].version)),S.push(...r.slice(1).map(n=>n[1].resource)),c.push(r[0][1]);c.sort((r,n)=>r.mtime-n.mtime),S.push(...c.slice(0,Math.max(0,c.length-this.cache)).map(r=>r.resource)),await k.Promises.settled(S.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(w){this.logService.error(w)}}getName(w){return this.cache?`${new p.ExtensionIdentifierWithVersion(w.identifier,w.version).key().toLowerCase()}${w.properties.targetPlatform!=="undefined"?`-${w.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(w){const S=m.exec(w);return S&&S[1]&&S[2]?new p.ExtensionIdentifierWithVersion({id:S[1]},S[2]):null}};g=he([K(0,b.INativeEnvironmentService),K(1,d.IFileService),K(2,f.IExtensionGalleryService),K(3,h.ILogService)],g),e.ExtensionsDownloader=g}),define(ne[189],ie([0,1,2,10,22,61]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends k.Disposable{constructor(C,E){super();this.environmentService=C,this.extensionsManifestCache=(0,t.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(E.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(C){C.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[190],ie([0,1,84,16,5,2,18,10,22,14,30,31,59,8]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let d=class extends T.Disposable{constructor(g,y,w){super();this.extensionManagementService=g,this.logService=w,this.cache=this._register(new h(y,w)),this.extensionManagementService.registerParticipant({postInstall:async S=>this.postInstallExtension(S),postUninstall:async S=>this.postUninstallExtension(S)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),y=["en",...Object.keys(g)];return(0,t.distinct)(y)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const y=await this.cache.getLanguagePacks();Object.keys(y).some(w=>y[w]&&y[w].extensions.some(S=>(0,b.areSameExtensions)(S.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),w=await this.cache.update(y);return!(0,t.equals)(Object.keys(g),Object.keys(w))}};d=he([K(0,P.IExtensionManagementService),K(1,E.INativeEnvironmentService),K(2,p.ILogService)],d),e.LocalizationsService=d;let h=class extends T.Disposable{constructor(g,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(y=>{Object.keys(y).forEach(w=>delete y[w]),this.createLanguagePacksFromExtensions(y,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...y){for(const w of y)w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,w);Object.keys(g).forEach(w=>this.updateHash(g[w]))}createLanguagePacksFromExtension(g,y){const w=y.identifier,S=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const l of S)if(y.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(l)){let i=g[l.languageId];i||(i={hash:"",extensions:[],translations:{}},g[l.languageId]=i);let c=i.extensions.filter(r=>(0,b.areSameExtensions)(r.extensionIdentifier,w))[0];c?c.version=y.manifest.version:i.extensions.push({extensionIdentifier:w,version:y.manifest.version});for(const r of l.translations)i.translations[r.id]=(0,R.join)(y.location.fsPath,r.path)}}updateHash(g){if(g){const y=(0,k.createHash)("md5");for(const w of g.extensions)y.update(w.extensionIdentifier.uuid||w.extensionIdentifier.id).update(w.version);g.hash=y.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,w=>w.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(w)).then(w=>{try{return JSON.parse(w)}catch{return{}}}).then(w=>(y=g(w),w)).then(w=>{for(const l of Object.keys(w))w[l]||delete w[l];this.languagePacks=w,this.initializedCache=!0;const S=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",S),C.Promises.writeFile(this.languagePacksFilePath,S)}).then(()=>y,w=>this.logService.error(w))})}};h=he([K(0,E.INativeEnvironmentService),K(1,p.ILogService)],h)}),define(ne[191],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[192],ie([0,1,119,19,8]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(R,C){this.configurationService=R,this.logService=C}request(R,C){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(R,C)}async resolveProxy(R){}};T=he([K(0,t.IConfigurationService),K(1,L.ILogService)],T),e.RequestService=T}),define(ne[43],ie([0,1,17,140,42,6,38]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function R(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=R;function C(d){return d.res.statusCode===204}async function E(d){if(!R(d))throw new Error("Server returned "+d.res.statusCode);return C(d)?null:(await(0,k.streamToBuffer)(d.stream)).toString()}e.asText=E;async function P(d){if(!R(d))throw new Error("Server returned "+d.res.statusCode);if(C(d))return null;const m=(await(0,k.streamToBuffer)(d.stream)).toString();try{return JSON.parse(m)}catch(g){throw g.message+=`:
`+m,g}}e.asJson=P;function b(d){p(d)}e.updateProxyConfigurationsScope=b;let f;function p(d){const h=A.Registry.as(L.Extensions.Configuration),m=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[f],remove:m?[m]:[]})}p(2)}),define(ne[193],ie([0,1,25,18,11,43]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(C,E){this.requestService=C,this.fileService=E}async download(C,E,P=k.CancellationToken.None){if(C.scheme===t.Schemas.file||C.scheme===t.Schemas.vscodeRemote){await this.fileService.copy(C,E);return}const b={type:"GET",url:C.toString()},f=await this.requestService.request(b,P);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const p=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};A=he([K(0,T.IRequestService),K(1,L.IFileService)],A),e.DownloadService=A}),define(ne[194],ie([0,1,16,25,68,2,21,153,11,8,27,43]),function(Y,e,k,t,L,T,A,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(d,h,m,g){super();this.fileService=d,this.productService=h,this.requestService=m,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(d){return this.getValidConfigBasedTips(d)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(d){const h=[];for(const[m,g]of this.allConfigBasedTips)if(!(g.configScheme&&g.configScheme!==d.scheme))try{const y=await this.fileService.readFile((0,A.joinPath)(d,m)),w=new Map;(0,L.forEach)(g.recommendations,({key:l,value:i})=>{if((0,k.isNonEmptyArray)(i.remotes))for(const c of i.remotes)w.set(c,{extensionId:l,extensionName:i.name,configName:g.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack});else h.push({extensionId:l,extensionName:i.name,configName:g.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack})});const S=(0,R.getDomainsOfRemotes)(y.value.toString(),[...w.keys()]);for(const l of S){const i=w.get(l);i&&h.push(i)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const d=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},t.CancellationToken.None);if(d.res.statusCode!==200)return[];const h=await(0,b.asJson)(d);return h?h.workspaceRecommendations||[]:[]}catch(d){return this.logService.error(d),[]}}};f=he([K(0,C.IFileService),K(1,P.IProductService),K(2,b.IRequestService),K(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(ne[91],ie([0,1,71,6]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,k.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,t.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[195],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(t){t.Spawn="vscode:shared-process->shared-process-worker=spawn",t.Terminate="vscode:shared-process->shared-process-worker=terminate",t.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",t.Ready="vscode:shared-process-worker->shared-process=ready",t.Ack="vscode:shared-process-worker->shared-process=ack",t.Trace="vscode:shared-process-worker->shared-process=trace",t.Info="vscode:shared-process-worker->shared-process=info",t.Warn="vscode:shared-process-worker->shared-process=warn",t.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[196],ie([0,1,75,5,25,3,2,18,29,8,91,195]),function(Y,e,k,t,L,T,A,R,C,E,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let f=class{constructor(h){this.logService=h,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(h){const m=`window: ${h.reply.windowId}, moduleId: ${h.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${m})`);const g=(0,P.hash)(h);this.processeDisposables.has(g)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${m})`),this.doDisposeWorker(h));const y=new L.CancellationTokenSource;let w,S,l;this.processeDisposables.set(g,n=>{y.dispose(!0),w?.terminate(h,L.CancellationToken.None),S?.close(),l?.close(),this.processeDisposables.delete(g);const s=this.processResolvers.get(g);s&&(this.processResolvers.delete(g),s({reason:n}))}),w=await this.getOrCreateWebWorker(h);const i=new Promise(n=>{this.processResolvers.set(g,n)});if(y.token.isCancellationRequested)return i;const{port1:c,port2:r}=new MessageChannel;return S=c,l=r,await w.spawn(h,l,y.token),y.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${m})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",h,[S])),i}getOrCreateWebWorker(h){let m=this.workers.get(h.process.moduleId);if(!m){this.logService.trace(`SharedProcess: creating new web worker (${h.process.moduleId})`);const g=new p(h.process.type,this.logService);m=g.init(),g.onDidProcessSelfTerminate(({configuration:y,reason:w})=>{this.doDisposeWorker(y,w)}),this.workers.set(h.process.moduleId,m)}return m}async disposeWorker(h){return this.doDisposeWorker(h)}doDisposeWorker(h,m){const g=this.processeDisposables.get((0,P.hash)(h));g&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${h.reply.windowId}, moduleId: ${h.process.moduleId})`),g(m))}};f=he([K(0,E.ILogService)],f),e.SharedProcessWorkerService=f;class p extends A.Disposable{constructor(h,m){super();this.type=h,this.logService=m,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const h=new t.DeferredPromise,m=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return m.onerror=g=>{this.logService.error(`SharedProcess: worker error (${this.type})`,g.message)},m.onmessageerror=g=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,g)},m.onmessage=g=>{const{id:y,message:w,configuration:S,nonce:l}=g.data;switch(y){case b.SharedProcessWorkerMessages.Ready:h.complete(m);break;case b.SharedProcessWorkerMessages.Ack:if(l){const i=this.mapMessageNonceToPendingMessageResolve.get(l);i&&(this.mapMessageNonceToPendingMessageResolve.delete(l),i())}break;case b.SharedProcessWorkerMessages.SelfTerminated:S&&w&&this._onDidProcessSelfTerminate.fire({configuration:S,reason:JSON.parse(w)});break;case b.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,w);break;case b.SharedProcessWorkerMessages.Info:w&&this.logService.info(w);break;case b.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,w);break;case b.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,w);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,g)}},m.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),h.p}async send(h,m,g){const y=await this.workerReady;if(!m.isCancellationRequested)return new Promise(w=>{const S=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(S,w);const l={...h,nonce:S};g?y.postMessage(l,[g]):y.postMessage(l),m.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(S)&&w()})})}spawn(h,m,g){const y={id:b.SharedProcessWorkerMessages.Spawn,configuration:h,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",Y).fsPath}};return this.send(y,g,m)}terminate(h,m){const g={id:b.SharedProcessWorkerMessages.Terminate,configuration:h};return this.send(g,m)}}}),define(ne[197],ie([0,1,54,18,152]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:t.Schemas.userData})}}he([k.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ne[92],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[198],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>Y(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const R=String(k._nextId++);return this.validators.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=k,k._nextId=1}),define(ne[23],ie([0,1,5,3,2,176,15,76,6]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var f;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class p extends L.Disposable{constructor(g={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,y){y===E?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:y,target:this.getKeyTargets(g)[y]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,y,w){return this.getStorage(y)?.get(g,w)}getBoolean(g,y,w){return this.getStorage(y)?.getBoolean(g,w)}getNumber(g,y,w){return this.getStorage(y)?.getNumber(g,w)}store(g,y,w,S){if((0,A.isUndefinedOrNull)(y)){this.remove(g,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,w,S),this.getStorage(w)?.set(g,y)})}remove(g,y){this.withPausedEmitters(()=>{this.updateKeyTarget(g,y,void 0),this.getStorage(y)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,y){const w=[],S=this.getKeyTargets(g);for(const l of Object.keys(S))S[l]===y&&w.push(l);return w}updateKeyTarget(g,y,w){const S=this.getKeyTargets(y);typeof w=="number"?S[g]!==w&&(S[g]=w,this.getStorage(y)?.set(E,JSON.stringify(S))):typeof S[g]=="number"&&(delete S[g],this.getStorage(y)?.set(E,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const y=this.get(E,g);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this._onWillSaveState.fire({reason:g});const y=this.getStorage(0),w=this.getStorage(1);switch(g){case P.NONE:await k.Promises.settled([y?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await k.Promises.settled([y?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return h(g,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends p{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=d;async function h(m,g,y,w){const S=o=>{try{return JSON.parse(o)}catch{return o}},l=new Map,i=new Map;m.forEach((o,a)=>{l.set(a,o),i.set(a,S(o))});const c=new Map,r=new Map;g.forEach((o,a)=>{c.set(a,o),r.set(a,S(o))}),console.group(`Storage: Global (path: ${y})`);let n=[];l.forEach((o,a)=>{n.push({key:a,value:o})}),console.table(n),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${w})`);let s=[];c.forEach((o,a)=>{s.push({key:a,value:o})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=h}),define(ne[199],ie([0,1,3,2,15,30,31,23]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends t.Disposable{constructor(b,f){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(b)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(f.onDidInstallExtensions(p=>p.forEach(({local:d,operation:h})=>{d&&h===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(b,f){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:f}),!0):!1}async disableExtension(b,f){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){let f=this.getDisabledExtensions();return f.every(p=>!(0,A.areSameExtensions)(p,b))?(f.push(b),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(b){let f=this.getDisabledExtensions();for(let p=0;p<f.length;p++){const d=f[p];if((0,A.areSameExtensions)(d,b))return f.splice(p,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(b){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,f){this.storageManger.set(b,f,0)}};C=he([K(0,R.IStorageService),K(1,T.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class E extends t.Disposable{constructor(b){super();this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(b,f){let p;return f===0?((0,L.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,f)),p=this.storage[b]):p=this._get(b,f),JSON.parse(p)}set(b,f,p){let d=JSON.stringify(f.map(({id:m,uuid:g})=>({id:m,uuid:g})));this._get(b,p)!==d&&(p===0&&(f.length?this.storage[b]=d:delete this.storage[b]),this._set(b,f.length?d:void 0,p))}onDidStorageChange(b){if(b.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const p=this.get(b.key,b.scope);delete this.storage[b.key];const d=this.get(b.key,b.scope),h=p.filter(g=>!d.some(y=>(0,A.areSameExtensions)(g,y))),m=d.filter(g=>!p.some(y=>(0,A.areSameExtensions)(y,g)));(h.length||m.length)&&this._onDidChange.fire([...h,...m])}}_get(b,f){return this.storageService.get(b,f,"[]")}_set(b,f,p){f?this.storageService.store(b,f,p,1):this.storageService.remove(b,p)}}e.StorageManager=E}),define(ne[63],ie([0,1,6,3,2,23,31,27,16,8,15]),function(Y,e,k,t,L,T,A,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class nt extends L.Disposable{constructor(d,h,m){super();this.storageService=d,this.productService=h,this.logService=m,this._onDidChangeExtensionStorageToSync=this._register(new t.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(g=>this.onDidChangeStorageValue(g)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const h=b.exec(d);if(h&&h[1])return{id:h[1],version:h[2]}}initialize(){const d=this.storageService.keys(0,1);for(const h of d){const m=nt.fromKey(h);m&&this.extensionsWithKeysForSync.add(m.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const h=nt.fromKey(d.key);if(h){this.extensionsWithKeysForSync.add(h.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(d){if((0,P.isString)(d))return d;const h=d.manifest?d.manifest.publisher:d.publisher,m=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(h,m)}getExtensionState(d,h){const m=this.getExtensionId(d),g=this.storageService.get(m,h?0:1);if(g)try{return JSON.parse(g)}catch(y){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${h}): ${y}`)}}setExtensionState(d,h,m){const g=this.getExtensionId(d);h===void 0?this.storageService.remove(g,m?0:1):this.storageService.store(g,JSON.stringify(h),m?0:1,1)}setKeysForSync(d,h){this.storageService.store(nt.toKey(d),JSON.stringify(h),0,1)}getKeysForSync(d){const h=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],m=this.storageService.get(nt.toKey(d),0),g=m?JSON.parse(m):void 0;return g&&h?(0,C.distinct)([...g,...h]):g||h}addToMigrationList(d,h){if(d!==h){const m=this.migrationList.filter(g=>!g.includes(d)&&!g.includes(h));m.push([d,h]),this.migrationList=m}}getSourceExtensionToMigrate(d){const h=this.migrationList.find(([,m])=>d===m);return h?h[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const h=JSON.parse(d);if((0,P.isArray)(h))return h}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=he([K(0,T.IStorageService),K(1,R.IProductService),K(2,E.ILogService)],f),e.ExtensionStorageService=f}),define(ne[200],ie([0,1,2,30,63,187,8]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends k.Disposable{constructor(E,P,b,f,p){super();E.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(E,P,b,f,p)}};R=he([K(0,t.IExtensionManagementService),K(1,t.IExtensionGalleryService),K(2,L.IExtensionStorageService),K(3,t.IGlobalExtensionEnablementService),K(4,A.ILogService)],R),e.ExtensionsCleaner=R}),define(ne[201],ie([0,1,3,2]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends t.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P}async getItems(){const E={workspace:this.workspace},P=await this.channel.call("getItems",E);return new Map(P)}updateItems(E){const P={workspace:this.workspace};return E.insert&&(P.insert=Array.from(E.insert.entries())),E.delete&&(P.delete=Array.from(E.delete.values())),this.channel.call("updateItems",P)}}class T extends L{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(E,P){super(E,P);this.onDidChangeItemsExternal=k.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends t.Disposable{constructor(E,P){super();this.channel=E,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ne[202],ie([0,1,5,2,21,76,23,201]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class C extends A.AbstractStorageService{constructor(P,b,f){super();this.mainProcessService=b,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new t.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),b=new T.Storage(P.globalStorage);return this._register(b.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),b}createWorkspaceStorage(P){const b=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(b.workspaceStorage){const f=new T.Storage(b.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=P?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const b=this.workspaceStorage,f=b?.items??new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[p,d]of f)this.workspaceStorage.set(p,d)}}e.NativeStorageService=C}),define(ne[203],ie([0,1,4,33,7,29]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(E){if(k.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,P,b,f,p,d,h,m,g,y){const w=Object.create(null);w["common.machineId"]=h,w.sessionID=(0,T.generateUuid)()+Date.now(),w.commitHash=p,w.version=d,w["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,k.PlatformToString)(k.platform),w["common.nodePlatform"]=t.platform,w["common.nodeArch"]=f,w["common.product"]=y||"desktop";const S=C(m||[]);S&&(w["common.msftInternal"]=S);let l=0;const i=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),k.isLinuxSnap&&(w["common.snap"]="true");const c=A(b);c&&(w["common.platformDetail"]=c);try{const r=await E.readFile(L.URI.file(g));w["common.source"]=r.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=R;function C(E){const P=t.env.USERDNSDOMAIN;if(!P)return!1;const b=P.toLowerCase();return E.some(f=>b===f)}e.verifyMicrosoftInternalDomain=C}),define(ne[20],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[204],ie([0,1,34,55,5,35,18,10,4,7,113,22,116,81,11,27,20]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(i,c){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],n=new Map,s=new Map,o=2e4;function a(I,_,O,M){const D=_.substring(I.length+1);return L.Promises.withAsyncBody(async U=>{let F;try{F=await b.Promises.readdir(_,{withFileTypes:!0})}catch{U();return}if(M.count>=o){M.count+=F.length,M.maxReached=!0,U();return}let x=F.length;if(x===0){U();return}let q=F;M.count+F.length>o&&(M.maxReached=!0,x=o-M.count,q=F.slice(0,x)),M.count+=F.length;for(const G of q)if(G.isDirectory()){if(O.includes(G.name)||await a(I,(0,R.join)(_,G.name),O,M),--x==0){U();return}}else{const te=G.name.lastIndexOf(".");if(te>=0){const W=G.name.substring(te+1);W&&n.set(W,(n.get(W)??0)+1)}for(const W of r)W.relativePathPattern?.test(D)!==!1&&W.filePattern.test(G.name)&&s.set(W.tag,(s.get(W.tag)??0)+1);if(--x==0){U();return}}})}const u={count:0,maxReached:!1};await a(i,i,c,u);const v=await S(i);return{configFiles:y(s),fileTypes:y(n),fileCount:u.count,maxFilesReached:u.maxReached,launchConfigFiles:v}}e.collectWorkspaceStats=g;function y(i){return[...t.Iterable.map(i.entries(),([c,r])=>({name:c,count:r}))].sort((c,r)=>r.count-c.count)}function w(){const i={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},c=k.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}e.getMachineInfo=w;async function S(i){try{const c=new Map,r=(0,R.join)(i,".vscode","launch.json"),n=await b.Promises.readFile(r),s=[],o=(0,T.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,T.getNodeType)(o)==="object"&&o.configurations)for(const a of o.configurations){const u=a.type;u&&(c.has(u)?c.set(u,c.get(u)+1):c.set(u,1))}return y(c)}catch{return[]}}e.collectLaunchConfigs=S;let l=class{constructor(c,r){this.telemetryService=c,this.productService=r}formatMachineInfo(c){const r=[];return r.push(`OS Version:       ${c.os}`),r.push(`CPUs:             ${c.cpus}`),r.push(`Memory (System):  ${c.memory}`),r.push(`VM:               ${c.vmHint}`),r.join(`
`)}formatEnvironment(c){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const n=k.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(k.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||r.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${c.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(c.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(c,r){return Promise.all([(0,f.listProcesses)(c.mainPID),this.formatWorkspaceMetadata(c)]).then(async n=>{let[s,o]=n,a=this.formatProcessList(c,s);return r.forEach(u=>{if((0,p.isRemoteDiagnosticError)(u))a+=`
${u.errorMessage}`,o+=`
${u.errorMessage}`;else if(a+=`

Remote: ${u.hostName}`,u.processes&&(a+=`
${this.formatProcessList(c,u.processes)}`),u.workspaceMetadata){o+=`
|  Remote: ${u.hostName}`;for(const v of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[v];let _=`${I.fileCount} files`;I.maxFilesReached&&(_=`more than ${_}`),o+=`|    Folder (${v}): ${_}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(c,r){const{memory:n,vmHint:s,os:o,cpus:a}=w(),u={os:o,memory:n,cpus:a,vmHint:s,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:r};return C.isWindows||(u.load=`${k.loadavg().map(v=>Math.round(v)).join(", ")}`),C.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(c,r){const n=[];return(0,f.listProcesses)(c.mainPID).then(async s=>(n.push(""),n.push(this.formatEnvironment(c)),n.push(""),n.push(this.formatProcessList(c,s)),c.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(c))),r.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.formatMachineInfo(o.machineInfo)),o.processes&&n.push(this.formatProcessList(c,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const u=o.workspaceMetadata[a];let v=`${u.fileCount} files`;u.maxFilesReached&&(v=`more than ${v}`),n.push(`Folder (${a}): ${v}`),n.push(this.formatWorkspaceStats(u))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(c){const r=[],n=60;let s=0;const o=(I,_)=>{const O=` ${I}(${_})`;s+O.length>n?(r.push(a),a="|                 ",s=a.length):s+=O.length,a+=O};let a="|      File types:";const u=10;let v=c.fileTypes.length>u?u:c.fileTypes.length;for(let I=0;I<v;I++){const _=c.fileTypes[I];o(_.name,_.count)}if(r.push(a),c.configFiles.length>=0&&(a="|      Conf files:",s=0,c.configFiles.forEach(I=>{o(I.name,I.count)}),r.push(a)),c.launchConfigFiles.length>0){let I="|      Launch Configs:";c.launchConfigFiles.forEach(_=>{I+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),r.push(I)}return r.join(`
`)}expandGPUFeatures(c){const r=Math.max(...Object.keys(c).map(n=>n.length));return Object.keys(c).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${c[n]}`).join(`
                  `)}formatWorkspaceMetadata(c){const r=[],n=[];return c.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const a=E.URI.revive(o);if(a.scheme===A.Schemas.file){const u=a.fsPath;n.push(g(u,["node_modules",".git"]).then(v=>{let I=`${v.fileCount} files`;v.maxFilesReached&&(I=`more than ${I}`),r.push(`|    Folder (${(0,R.basename)(u)}): ${I}`),r.push(this.formatWorkspaceStats(v))}).catch(v=>{r.push(`|      Error: Unable to collect workspace stats for folder ${u} (${v.toString()})`)}))}else r.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(c,r){const n=new Map;c.windows.forEach(o=>n.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(c.mainPID,n,s,r,0),s.join(`
`)}formatProcessItem(c,r,n,s,o){const a=o===0;let u;a?u=s.pid===c?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(u=`${u} (${r.get(s.pid)})`));const v=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(v/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(s.children)&&s.children.forEach(I=>this.formatProcessItem(c,r,n,I,o+1))}async reportWorkspaceStats(c){for(const{uri:r}of c.folders){const n=E.URI.revive(r);if(n.scheme!==A.Schemas.file)continue;const s=n.fsPath;try{const o=await g(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),o.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};l=he([K(0,m.ITelemetryService),K(1,h.IProductService)],l),e.DiagnosticsService=l}),define(ne[205],ie([0,1,16,5,25,9,3,2,4,15,7,129,30,31,8,27,20]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends R.Disposable{constructor(c,r,n,s){super();this.galleryService=c,this.telemetryService=r,this.logService=n,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const r=await this.getTargetPlatform();return c.allTargetPlatforms.some(n=>(0,f.isTargetPlatformCompatible)(n,c.allTargetPlatforms,r))}async installFromGallery(c,r={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(b.localize(0,null),f.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(c,!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,r)}catch(n){throw S(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(c),void 0,n),this.logService.error("Failed to install extension.",c.identifier.id),this.logService.error(n),w(n)}}async uninstall(c,r={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,r)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const r=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...c.identifier,preRelease:c.preRelease}],{targetPlatform:r,compatible:!0},L.CancellationToken.None);if(!n)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.extensionsControlManifest||c-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=c),this.extensionsControlManifest}registerParticipant(c){this.participants.push(c)}async installExtension(c,r,n){if(!P.URI.isUri(r)){let v=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(v)return this.logService.info("Extensions is already requested to install",r.identifier.id),v.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],a=this.createInstallExtensionTask(c,r,n);P.URI.isUri(r)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:r}),this.logService.info("Installing extension:",a.identifier.id),s.push({task:a,manifest:c});let u=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:_,manifest:O}of I)if(u=u||!!O.extensionDependencies?.some(M=>(0,p.areSameExtensions)({id:M},a.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const M=this.createInstallExtensionTask(O,_,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(M.identifier,O.version).key(),M),this._onInstallExtension.fire({identifier:M.identifier,source:_}),this.logService.info("Installing extension:",M.identifier.id),s.push({task:M,manifest:O})}}catch(I){if(P.URI.isUri(a.source))(0,k.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,I.message),(0,k.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),I}const v=s.reduce((I,{task:_,manifest:O})=>(I.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),I),new Map);for(;v.size;){let I;const _=[...v.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(M=>v.has(M.toLowerCase())));_.length?I=v.size===1?_:_.filter(({task:O})=>!(O===a&&!u)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),I=[...v.values()]),await this.joinAllSettled(I.map(async({task:O})=>{const M=new Date().getTime(),D=(0,E.isUndefined)(n.operation)?O.operation:n.operation;try{const U=await O.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(U,O.source,n,L.CancellationToken.None))),!P.URI.isUri(O.source)&&(S(this.telemetryService,D===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-M,void 0),C.isWeb&&D!==3))try{await this.galleryService.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch{}o.push({local:U,identifier:O.identifier,operation:D,source:O.source})}catch(U){throw P.URI.isUri(O.source)||S(this.telemetryService,D===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-M,U),this.logService.error("Error while installing the extension:",O.identifier.id),U}finally{v.delete(O.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,p.areSameExtensions)(I,a.identifier))[0].local}catch(v){if(s.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<I.length;_++){const O=I[_],{identifier:M}=o[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",M.id):this.logService.warn("Rollback: Error while uninstalling extension",M.id,(0,T.getErrorMessage)(O.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(I),o.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),v}finally{for(const{task:v,manifest:I}of s)if(!P.URI.isUri(v.source)){const _=new p.ExtensionIdentifierWithVersion(v.identifier,I.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(c){const r=[],n=[],s=await Promise.allSettled(c);for(const o of s)o.status==="fulfilled"?r.push(o.value):n.push(o.reason);if(n.length)throw y(n);return r}async getAllDepsAndPackExtensionsToInstall(c,r,n,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const a=[c,...o.map(I=>I.identifier)],u=[],v=async(I,_)=>{const O=_.extensionDependencies||[],M=[...O];if(_.extensionPack){const D=n?o.find(U=>(0,p.areSameExtensions)(U.identifier,I)):void 0;for(const U of _.extensionPack)D&&D.manifest.extensionPack&&D.manifest.extensionPack.some(F=>(0,p.areSameExtensions)({id:F},{id:U}))||M.every(F=>!(0,p.areSameExtensions)({id:F},{id:U}))&&M.push(U)}if(M.length){const D=[...a,...u.map(F=>F.gallery.identifier)],U=M.filter(F=>D.every(x=>!(0,p.areSameExtensions)(x,{id:F})));if(U.length){const F=await this.galleryService.getExtensions(U.map(x=>({id:x,preRelease:s})),L.CancellationToken.None);for(const x of F){if(D.find(te=>(0,p.areSameExtensions)(te,x.identifier)))continue;const q=O.some(te=>(0,p.areSameExtensions)({id:te},x.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(x,!0,s)}catch(te){if(te instanceof f.ExtensionManagementError&&te.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!q){this.logService.info("Skipping the packed extension as it cannot be installed",x.identifier.id);continue}else throw te}u.push({gallery:G.extension,manifest:G.manifest}),await v(G.extension.identifier,G.manifest)}}}};return await v(c,r),o=await this.getInstalled(),u.filter(I=>!o.some(_=>(0,p.areSameExtensions)(_.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(c,r,n){const s=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(s).has(c.identifier.id))throw new f.ExtensionManagementError(b.localize(3,null,c.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[c.identifier.id])throw new f.ExtensionManagementError(b.localize(4,null,c.identifier.id,s.unsupportedPreReleaseExtensions[c.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(c)){const u=await this.getTargetPlatform();throw new f.ExtensionManagementError(b.localize(5,null,c.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(u)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(c,r,n);if(o){if(n&&r&&c.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(b.localize(6,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&c.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([c.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(b.localize(7,null,c.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(b.localize(8,null,c.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const a=await this.galleryService.getManifest(o,L.CancellationToken.None);if(a===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(a.version!==o.version)throw new f.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:a}}async getCompatibleVersion(c,r,n){const s=await this.getTargetPlatform();let o=null;return r&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==n&&(o=(await this.galleryService.getExtensions([{...c.identifier,preRelease:n}],{targetPlatform:s,compatible:!0},L.CancellationToken.None))[0]||null),!o&&await this.galleryService.isExtensionCompatible(c,n,s)&&(o=c),!o&&r&&(o=await this.galleryService.getCompatibleExtension(c,n,s)),o}async unininstallExtension(c,r){const n=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),n.waitUntilTaskIsFinished();const s=(v,I)=>{const _=this.createUninstallExtensionTask(v,I);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",v.identifier.id),this._onUninstallExtension.fire(v.identifier),_},o=(v,I)=>{I?this.logService.error("Failed to uninstall extension:",v.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",v.identifier.id),S(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(v),void 0,I),this._onDidUninstallExtension.fire({identifier:v.identifier,error:I?.code})},a=[],u=[];try{a.push(s(c,{}));const v=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(c,v);for(const _ of I)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):a.push(s(_,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(I=>I.extension),v,c),await this.joinAllSettled(a.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(I.extension,r,L.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(_){const O=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,T.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw o(I.extension,O),O}finally{u.push(I)}}))}catch(v){const I=v instanceof f.ExtensionManagementError?v:new f.ExtensionManagementError((0,T.getErrorMessage)(v),f.ExtensionManagementErrorCode.Internal);for(const _ of a){try{_.cancel()}catch{}u.includes(_)||o(_.extension,I)}throw I}finally{for(const v of a)this.uninstallingExtensions.delete(v.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",v.extension.identifier.id)}}checkForDependents(c,r,n){for(const s of c){const o=this.getDependents(s,r);if(o.length){const a=o.filter(u=>!c.some(v=>(0,p.areSameExtensions)(v.identifier,u.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(s,a,n))}}}getDependentsErrorMessage(c,r,n){return n===c?r.length===1?b.localize(9,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(10,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(11,null,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(12,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(13,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(14,null,n.manifest.displayName||n.manifest.name,c.manifest.displayName||c.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(c,r,n=[]){if(n.indexOf(c)!==-1)return[];n.push(c);const s=c.manifest.extensionPack?c.manifest.extensionPack:[];if(s.length){const o=r.filter(u=>!u.isBuiltin&&s.some(v=>(0,p.areSameExtensions)({id:v},u.identifier))),a=[];for(const u of o)a.push(...this.getAllPackExtensionsToUninstall(u,r,n));return[...o,...a]}return[]}getDependents(c,r){return r.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(s=>(0,p.areSameExtensions)({id:s},c.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",c),c}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};g=he([K(0,f.IExtensionGalleryService),K(1,m.ITelemetryService),K(2,d.ILogService),K(3,h.IProductService)],g),e.AbstractExtensionManagementService=g;function y(i){const c=Array.isArray(i)?i:[i];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((r,n)=>new Error(`${r.message}${r.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=y;function w(i){if(i instanceof f.ExtensionManagementError)return i;const c=new f.ExtensionManagementError(i.message,f.ExtensionManagementErrorCode.Internal);return c.stack=i.stack,c}function S(i,c,r,n,s){const o=s?s instanceof f.ExtensionManagementError?s.code:f.ExtensionManagementErrorCode.Internal:void 0;i.publicLogError(c,{...r,success:!s,duration:n,errorcode:o})}e.reportTelemetry=S;class l{constructor(){this.barrier=new t.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,t.createCancelablePromise)(c=>new Promise((r,n)=>{const s=c.onCancellationRequested(()=>{s.dispose(),n((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(ne[206],ie([0,1,16,5,68,3,10,4,33,7,131,14,30,194,83,11,8,60,27,43,23,20]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",c="extensionTips/lastPromptedMediumImpExeTime";let r=class extends p.ExtensionTipsService{constructor(s,o,a,u,v,I,_,O,M,D){super(_,O,M,D);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=a,this.storageService=u,this.nativeHostService=v,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,L.forEach)(O.exeBasedExtensionTips,({key:U,value:F})=>{const x=[],q=[],G=[];(0,L.forEach)(F.recommendations,({key:te,value:W})=>{W.important?F.important?x.push({extensionId:te,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):q.push({extensionId:te,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):G.push({extensionId:te,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),x.length&&this.highImportanceExecutableTips.set(U,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:x}),q.length&&this.mediumImportanceExecutableTips.set(U,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:q}),G.length&&this.allOtherExecutableTips.set(U,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:G})}),(0,t.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,a)}groupImportantTipsByExe(s,o){const a=new Map;s.forEach(O=>a.set(O.extensionId.toLowerCase(),O));const{installed:u,uninstalled:v}=this.groupByInstalled([...a.keys()],o);for(const O of u){const M=a.get(O);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:M.exeName})}for(const O of v){const M=a.get(O);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:M.exeName})}const I=this.getPromptedExecutableTips(),_=new Map;for(const O of v){const M=a.get(O);if(M&&(!I[M.exeName]||!I[M.exeName].includes(M.extensionId))){let D=_.get(M.exeName);D||(D=[],_.set(M.exeName,D)),D.push(M)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const u=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(u(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const u=this._register((0,t.disposableTimeout)(()=>{u.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,a=7*24*60*60*1e3;if(o<a){const I=this._register((0,t.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},a-o));return}const[u,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(I=>{switch(I){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(u),this.addToRecommendedExecutables(v[0].exeName,v);const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(u),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,t.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(s){const o=s.map(({extensionId:u})=>u.toLowerCase()),a=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,a,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(c,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(c,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,0,"{}"))}addToRecommendedExecutables(s,o){const a=this.getPromptedExecutableTips();a[s]=o.map(({extensionId:u})=>u.toLowerCase()),this.storageService.store(i,JSON.stringify(a),0,0)}groupByInstalled(s,o){const a=[],u=[],v=o.reduce((I,_)=>(I.add(_.identifier.id.toLowerCase()),I),new Set);return s.forEach(I=>{v.has(I.toLowerCase())?a.push(I):u.push(I)}),{installed:a,uninstalled:u}}async getValidExecutableBasedExtensionTips(s){const o=[],a=new Map;for(const u of s.keys()){const v=s.get(u);if(!v||!(0,k.isNonEmptyArray)(v.recommendations))continue;const I=[];R.isWindows?v.windowsPath&&I.push(v.windowsPath.replace("%USERPROFILE%",C.env.USERPROFILE).replace("%ProgramFiles(x86)%",C.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",C.env.ProgramFiles).replace("%APPDATA%",C.env.APPDATA).replace("%WINDIR%",C.env.WINDIR)):(I.push((0,A.join)("/usr/local/bin",u)),I.push((0,A.join)("/usr/bin",u)),I.push((0,A.join)(this.environmentService.userHome.fsPath,u)));for(const _ of I){let O=a.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),a.set(_,O)),O)for(const{extensionId:M,extensionName:D,isExtensionPack:U}of v.recommendations)o.push({extensionId:M,extensionName:D,isExtensionPack:U,exeName:u,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return o}};r=he([K(0,b.INativeEnvironmentService),K(1,l.ITelemetryService),K(2,f.IExtensionManagementService),K(3,S.IStorageService),K(4,g.INativeHostService),K(5,d.IExtensionRecommendationNotificationService),K(6,h.IFileService),K(7,y.IProductService),K(8,w.IRequestService),K(9,m.ILogService)],r),e.ExtensionTipsService=r}),define(ne[93],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:R,data:C}){return this.appenders.forEach(E=>E.log(R,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class t{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ne[44],ie([0,1,28,15,19,20]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class A{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,y){return Promise.resolve(void 0)}publicLog2(g,y){return this.publicLog(g,y)}publicLogError(g,y){return Promise.resolve(void 0)}publicLogError2(g,y){return this.publicLogError(g,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=A,e.NullTelemetryService=new A;class R{async publicLog(g,y,w){}async publicLogError(g,y,w){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(m,g){return g.onDidChangeConfiguration(y=>{y.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(y.source),configurationKeys:d(y.sourceConfig)})})}e.configurationTelemetry=C;function E(m,g){return!(g.disableTelemetry||!m.enableTelemetry||g.extensionTestsLocationURI)}e.supportsTelemetry=E;function P(m){const g=m.getValue(T.TELEMETRY_SETTING_ID),y=m.getValue("telemetry.enableCrashReporter");if(m.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function b(m){const g=Object.create(null),y=Object.create(null),w=Object.create(null);p(m,w);for(let S in w){S=S.length>150?S.substr(S.length-149):S;const l=w[S];typeof l=="number"?y[S]=l:typeof l=="boolean"?y[S]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${l.length}`),g[S]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(g[S]=l)}return{properties:g,measurements:y}}e.validateTelemetryData=b;function f(m){if(!m)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(w=>{m.indexOf(`${w}+`)===0&&(g=w)}),g}e.cleanRemoteAuthority=f;function p(m,g,y=0,w){if(!!m)for(let S of Object.getOwnPropertyNames(m)){const l=m[S],i=w?w+S:S;Array.isArray(l)?g[i]=(0,k.safeStringify)(l):l instanceof Date?g[i]=l.toISOString():(0,t.isObject)(l)?y<2?p(l,g,y+1,i+"."):g[i]=(0,k.safeStringify)(l):g[i]=l}}function d(m){if(!m)return[];const g=[];return h(g,"",m),g}function h(m,g,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(w=>h(m,g?`${g}.${w}`:w,y[w])):m.push(g)}}),define(ne[207],ie([0,1,44,149]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(C,E){}postEvent(C,E){}}class T{constructor(C,E,P,b,f){this.getMachineId=C,this.configurationService=E,this.productService=P,this.telemetry=b,this.keyValueStorage=f,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,k.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),d=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(h=>setTimeout(h,d))}get experimentsEnabled(){return!0}async getTreatment(C){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+C);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let P;const b=await this.tasClient;return this.networkInitialized?P=b.getTreatmentVariable("vscode",C):P=await b.getTreatmentVariableAsync("vscode",C,!0),P=b.getTreatmentVariable("vscode",C),P}async setupTASClient(){const C=this.productService.quality==="stable"?t.TargetPopulation.Public:t.TargetPopulation.Insiders,E=await this.getMachineId(),P=new t.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,C),b=this.productService.tasConfig,f=new(await new Promise((p,d)=>{Y(["tas-client-umd"],p,d)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:t.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:b.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:b.assignmentContextTelemetryPropertyName,telemetryEventName:b.telemetryEventName,endpoint:b.endpoint,refetchInterval:t.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=T;class A extends T{constructor(C,E,P){super(()=>Promise.resolve(C),E,P,new L)}}e.AssignmentService=A}),define(ne[208],ie([0,1,47,44]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(T,A,R,C,E,P){const b={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},f=await(0,k.getServiceMachineId)(R,E,P);return(0,t.supportsTelemetry)(A,R)&&(0,t.getTelemetryLevel)(C)===3&&(b["X-Market-User-Id"]=f),b}e.resolveMarketplaceHeaders=L}),define(ne[209],ie([0,1,16,25,9,28,4,33,15,7,19,14,30,31,79,11,8,27,43,208,23,20]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=A.isWeb?"web":(0,f.getTargetPlatform)(A.platform,R.arch);var c;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished",$[$.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(c||(c={}));function r(...$){return String($.reduce((z,V)=>z|V,0))}var n;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class v{constructor(z=u){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(z,V=this.state.pageSize){return new v({...this.state,pageNumber:z,pageSize:V})}withFilter(z,...V){const ee=[...this.state.criteria,...V.length?V.map(se=>({filterType:z,value:se})):[{filterType:z}]];return new v({...this.state,criteria:ee})}withSortBy(z){return new v({...this.state,sortBy:z})}withSortOrder(z){return new v({...this.state,sortOrder:z})}withFlags(...z){return new v({...this.state,flags:z.reduce((V,ee)=>V|ee,0)})}withAssetTypes(...z){return new v({...this.state,assetTypes:z})}get raw(){const{criteria:z,pageNumber:V,pageSize:ee,sortBy:se,sortOrder:ae,flags:de,assetTypes:ve}=this.state;return{filters:[{criteria:z,pageNumber:V,pageSize:ee,sortBy:se,sortOrder:ae}],assetTypes:ve,flags:de}}get searchText(){const z=this.state.criteria.filter(V=>V.filterType===n.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function I($,z){const V=($||[]).filter(ee=>ee.statisticName===z)[0];return V?V.value:0}function _($){const z="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(ee=>ee.assetType.indexOf(z)===0).reduce((ee,se)=>{const ae=U($,se.assetType);return ae&&ee.push([se.assetType.substring(z.length),ae]),ee},[])}function O($){if($.properties){const z=$.properties.filter(se=>se.key===s.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=z.filter(se=>V.test(se.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return U($,s.Repository)}function M($){return{uri:`${$.fallbackAssetUri}/${s.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${s.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function D($){const z=U($,s.Icon);if(z)return z;const V=f.DefaultIconPath;return{uri:V,fallbackUri:V}}function U($,z){return $.files.filter(ee=>ee.assetType===z)[0]?{uri:`${$.assetUri}/${z}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${z}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}:null}function F($,z){const V=$.properties?$.properties.filter(se=>se.key===z):[],ee=V.length>0&&V[0].value;return ee?ee.split(",").map(se=>(0,p.adoptToGalleryExtensionId)(se)):[]}function x($){const z=$.properties?$.properties.filter(V=>V.key===o.Engine):[];return z.length>0&&z[0].value||""}function q($){const z=$.properties?$.properties.filter(V=>V.key===o.PreRelease):[];return z.length>0&&z[0].value==="true"}function G($){const z=$.properties?$.properties.filter(ee=>ee.key===o.LocalizedLanguages):[],V=z.length>0&&z[0].value||"";return V?V.split(","):[]}function te($){return $.indexOf("preview")!==-1}function W($){return $.targetPlatform?(0,f.toTargetPlatform)($.targetPlatform):"undefined"}function j($){const z=(0,k.distinct)($.versions.map(W)),V=!!$.tags?.includes(f.WEB_EXTENSION_TAG),ee=z.indexOf("web");return V?ee===-1&&z.push("web"):ee!==-1&&z.splice(ee,1),z}function J($,z){const V=(0,f.getFallbackTargetPlarforms)(z);for(let ee=0;ee<$.length;ee++){const se=$[ee];if(se.version===$[ee-1]?.version){let ae=ee;const de=W(se);if(de===z)for(;ae>0&&$[ae-1].version===se.version;)ae--;else if(V.includes(de))for(;ae>0&&$[ae-1].version===se.version&&W($[ae-1])!==z;)ae--;ae!==ee&&($.splice(ee,1),$.splice(ae,0,se))}}return $}e.sortExtensionVersions=J;function H($,z,V){$.telemetryData={index:z,querySource:V}}function Q($,z,V){const ee=$.versions[0],se={manifest:U(z,s.Manifest),readme:U(z,s.Details),changelog:U(z,s.Changelog),license:U(z,s.License),repository:O(z),download:M(z),icon:D(z),coreTranslations:_(z)};return{identifier:{id:(0,p.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:z.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,publisherDomain:$.publisher.domain?{link:$.publisher.domain,verified:!!$.publisher.isDomainVerified}:void 0,description:$.shortDescription||"",installCount:I($.statistics,"install"),rating:I($.statistics,"averagerating"),ratingCount:I($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:V,assets:se,properties:{dependencies:F(z,o.Dependency),extensionPack:F(z,o.ExtensionPack),engine:x(z),localizedLanguages:G(z),targetPlatform:W(z),isPreReleaseVersion:q(z)},hasPreReleaseVersion:q(ee),hasReleaseVersion:!0,preview:te($.flags)}}let Z=class{constructor(z,V,ee,se,ae,de,ve,be){this.requestService=V,this.logService=ee,this.environmentService=se,this.telemetryService=ae,this.fileService=de,this.productService=ve,this.configurationService=be;const Se=ve.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=(0,w.resolveMarketplaceHeaders)(ve.version,ve,this.environmentService,this.configurationService,this.fileService,z)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,V,ee){const se=t.CancellationToken.isCancellationToken(V)?{}:V,ae=t.CancellationToken.isCancellationToken(V)?V:ee,de=[],ve=[],be=[],Se=[];let pe=!0;for(const De of z){De.uuid?ve.push(De.uuid):de.push(De.id);const Ue=!!(De.version||De.preRelease);be.push({id:De.id,uuid:De.uuid,includePreRelease:Ue}),De.version&&Se.push({id:De.id,uuid:De.uuid,version:De.version}),pe=pe&&!!De.hasPreRelease&&!Ue}if(!ve.length&&!de.length)return[];let Ie=new v().withPage(1,z.length);ve.length&&(Ie=Ie.withFilter(n.ExtensionId,...ve)),de.length&&(Ie=Ie.withFilter(n.ExtensionName,...de)),(se.queryAllVersions||pe)&&(Ie=Ie.withFlags(Ie.flags,c.IncludeVersions));const{extensions:Ce}=await this.queryGalleryExtensions(Ie,{targetPlatform:se.targetPlatform??i,includePreRelease:be,versions:Se,compatible:!!se.compatible},ae);return se.source&&Ce.forEach((De,Ue)=>H(De,Ue,se.source)),Ce}async getCompatibleExtension(z,V,ee){if((0,f.isNotWebExtensionInWebTargetPlatform)(z.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(z,V,ee))return z;const se=new v().withFlags(c.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,z.identifier.uuid),{extensions:ae}=await this.queryGalleryExtensions(se,{targetPlatform:ee,compatible:!0,includePreRelease:V},t.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(z,V,ee){if(!(0,f.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,ee)||!V&&z.properties.isPreReleaseVersion)return!1;let se=z.properties.engine;if(!se){const ae=await this.getManifest(z,t.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");se=ae.engines.vscode}return(0,d.isEngineValid)(se,this.productService.version,this.productService.date)}async isValidVersion(z,V,ee,se,ae){if(!(0,f.isTargetPlatformCompatible)(W(z),se,ae)||V!=="any"&&q(z)!==(V==="prerelease"))return!1;if(ee){const de=await this.getEngine(z);if(!(0,d.isEngineValid)(de,this.productService.version,this.productService.date))return!1}return!0}async query(z,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ee=z.text||"";const se=(0,T.getOrDefault)(z,pe=>pe.pageSize,50);let ae=new v().withPage(1,se);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ie,Ce)=>(ae=ae.withFilter(n.Category,Ce||Ie),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ie,Ce)=>(ae=ae.withFilter(n.Tag,Ce||Ie),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(n.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),ae=ae.withFilter(n.SearchText,ee)),ae=ae.withSortBy(0)):z.ids?ae=ae.withFilter(n.ExtensionId,...z.ids):z.names?ae=ae.withFilter(n.ExtensionName,...z.names):ae=ae.withSortBy(4),typeof z.sortBy=="number"&&(ae=ae.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(ae=ae.withSortOrder(z.sortOrder));const de=async(pe,Ie)=>{const{extensions:Ce,total:De}=await this.queryGalleryExtensions(pe,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease},Ie);return Ce.forEach((Ue,je)=>H(Ue,(pe.pageNumber-1)*pe.pageSize+je,z.source)),{extensions:Ce,total:De}},{extensions:ve,total:be}=await de(ae,V),Se=async(pe,Ie)=>{if(Ie.isCancellationRequested)throw new L.CancellationError;const{extensions:Ce}=await de(ae.withPage(pe+1),Ie);return Ce};return{firstPage:ve,total:be,pageSize:ae.pageSize,getPage:Se}}async queryGalleryExtensions(z,V,ee){const se=z.flags;!!(z.flags&c.IncludeLatestVersionOnly)&&!!(z.flags&c.IncludeVersions)&&(z=z.withFlags(z.flags&~c.IncludeVersions,c.IncludeLatestVersionOnly)),!(z.flags&c.IncludeLatestVersionOnly)&&!(z.flags&c.IncludeVersions)&&(z=z.withFlags(z.flags,c.IncludeLatestVersionOnly)),V.versions?.length&&(z=z.withFlags(z.flags&~c.IncludeLatestVersionOnly,c.IncludeVersions)),z=z.withFlags(z.flags,c.IncludeAssetUri,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeStatistics,c.IncludeVersionProperties);const{galleryExtensions:ae,total:de}=await this.queryRawGalleryExtensions(z,ee);if(!(z.flags&c.IncludeLatestVersionOnly)){const pe=[];for(const Ie of ae){const Ce=await this.toGalleryExtensionWithCriteria(Ie,V,!0);Ce&&pe.push(Ce)}return{extensions:pe,total:de}}const be=[],Se=new Map;for(let pe=0;pe<ae.length;pe++){const Ie=ae[pe],Ce={id:(0,p.getGalleryExtensionId)(Ie.publisher.publisherName,Ie.extensionName),uuid:Ie.extensionId},De=(0,C.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(je=>(0,p.areSameExtensions)(je,Ce))?.includePreRelease;let Ue=await this.toGalleryExtensionWithCriteria(Ie,V,!1);!Ue||Ue.properties.isPreReleaseVersion&&(!De||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==V.targetPlatform&&Ue.hasPreReleaseVersion?Se.set(Ie.extensionId,pe):be.push([pe,Ue])}if(Se.size){const pe=new Date().getTime(),Ie=new v().withFlags(se&~c.IncludeLatestVersionOnly,c.IncludeVersions).withPage(1,Se.size).withFilter(n.ExtensionId,...Se.keys()),{extensions:Ce}=await this.queryGalleryExtensions(Ie,V,ee);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-pe,count:Se.size});for(const De of Ce){const Ue=Se.get(De.identifier.uuid);be.push([Ue,De])}}return{extensions:be.sort((pe,Ie)=>pe[0]-Ie[0]).map(([,pe])=>pe),total:de}}async toGalleryExtensionWithCriteria(z,V,ee){const se={id:(0,p.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},ae=V.versions?.find(Se=>(0,p.areSameExtensions)(Se,se))?.version,de=(0,C.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(Se=>(0,p.areSameExtensions)(Se,se))?.includePreRelease,ve=j(z),be=J(z.versions,V.targetPlatform);if(V.compatible&&ee&&(0,f.isNotWebExtensionInWebTargetPlatform)(ve,V.targetPlatform))return null;for(let Se=0;Se<be.length;Se++){const pe=be[Se];if(!(ae&&pe.version!==ae)){if(await this.isValidVersion(pe,de?"any":"release",V.compatible,ve,V.targetPlatform))return Q(z,pe,ve);if(ae&&pe.version===ae)return null}}return ae||V.compatible?null:Q(z,z.versions[0],ve)}async queryRawGalleryExtensions(z,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,c.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,r(c.Unpublished));const ee=await this.commonHeadersPromise,se=JSON.stringify(z.raw),ae={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},de=new Date().getTime();let ve,be,Se=0;try{if(ve=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:se,headers:ae},V),ve.res.statusCode&&ve.res.statusCode>=400&&ve.res.statusCode<500)return{galleryExtensions:[],total:Se};const pe=await(0,y.asJson)(ve);if(pe){const Ie=pe.results[0],Ce=Ie.extensions,De=Ie.resultMetadata&&Ie.resultMetadata.filter(Ue=>Ue.metadataType==="ResultCount")[0];return Se=De&&De.metadataItems.filter(Ue=>Ue.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:Se}}return{galleryExtensions:[],total:Se}}catch(pe){throw be=pe,pe}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(se.length),duration:new Date().getTime()-de,success:!!ve&&(0,y.isSuccess)(ve),responseBodySize:ve?.res.headers["Content-Length"],statusCode:ve?String(ve.res.statusCode):void 0,errorCode:be?(0,L.isCancellationError)(be)?"canceled":(0,L.getErrorMessage)(be).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(z,V,ee,se){if(!this.isEnabled())return;const ae=A.isWeb?this.api(`/itemName/${z}.${V}/version/${ee}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${V}/${ee}/stats?statType=${se}`),de=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:ae,headers:be},t.CancellationToken.None)}catch{}}async download(z,V,ee){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const se=(0,p.getGalleryExtensionTelemetryData)(z),ae=new Date().getTime(),de=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:pe}),ve=ee===2?"install":ee===3?"update":"",be=ve?{uri:`${z.assets.download.uri}${E.URI.parse(z.assets.download.uri).query?"&":"?"}${ve}=true`,fallbackUri:`${z.assets.download.fallbackUri}${E.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ve}=true`}:z.assets.download,Se=await this.getAsset(be);await this.fileService.writeFile(V,Se.stream),de(new Date().getTime()-ae)}async getReadme(z,V){if(z.assets.readme){const ee=await this.getAsset(z.assets.readme,{},V);return await(0,y.asText)(ee)||""}return""}async getManifest(z,V){if(z.assets.manifest){const ee=await this.getAsset(z.assets.manifest,{},V),se=await(0,y.asText)(ee);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion(z,V){const ee=U(z,s.Manifest);if(!ee)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},ae=await this.getAsset(ee,{headers:se});return await(0,y.asJson)(ae)}async getCoreTranslation(z,V){const ee=z.assets.coreTranslations.filter(se=>se[0]===V.toUpperCase())[0];if(ee){const se=await this.getAsset(ee[1]),ae=await(0,y.asText)(se);return ae?JSON.parse(ae):null}return null}async getChangelog(z,V){if(z.assets.changelog){const ee=await this.getAsset(z.assets.changelog,{},V);return await(0,y.asText)(ee)||""}return""}async getAllCompatibleVersions(z,V,ee){let se=new v().withFlags(c.IncludeVersions,c.IncludeCategoryAndTags,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?se=se.withFilter(n.ExtensionId,z.identifier.uuid):se=se.withFilter(n.ExtensionName,z.identifier.id);const{galleryExtensions:ae}=await this.queryRawGalleryExtensions(se,t.CancellationToken.None);if(!ae.length)return[];const de=j(ae[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(de,ee))return[];const ve=[],be=new Set;return await Promise.all(ae[0].versions.map(async Se=>{try{if(be.has(Se.version))return;be.add(Se.version),await this.isValidVersion(Se,V?"prerelease":"release",!0,de,ee)&&ve.push({version:Se.version,date:Se.lastUpdated,isPreReleaseVersion:q(Se)})}catch{}})),ve}async getAsset(z,V={},ee=t.CancellationToken.None){const se=await this.commonHeadersPromise,ae={type:"GET"},de={...se,...V.headers||{}};V={...V,...ae,headers:de};const ve=z.uri,be=z.fallbackUri,Se={...V,url:ve};try{const pe=await this.requestService.request(Se,ee);if(pe.res.statusCode===200)return pe;const Ie=await(0,y.asText)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${Ie}`)}catch(pe){if((0,L.isCancellationError)(pe))throw pe;const Ie=(0,L.getErrorMessage)(pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ve,message:Ie});const Ce={...V,url:be};return this.requestService.request(Ce,ee)}}async getEngine(z){let V=x(z);if(!V){const ee=await this.getManifestFromRawExtensionVersion(z,t.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");V=ee.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},t.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,y.asJson)(z),ee=[],se={};if(V){for(const ae of V.malicious)ee.push({id:ae});if(V.unsupported)for(const ae of Object.keys(V.unsupported)){const de=V.unsupported[ae];(0,C.isBoolean)(de)||(se[ae.toLowerCase()]=de.preReleaseExtension)}if(V.migrateToPreRelease)for(const[ae,de]of Object.entries(V.migrateToPreRelease))(!de.engine||(0,d.isEngineValid)(de.engine,this.productService.version,this.productService.date))&&(se[ae.toLowerCase()]=de)}return{malicious:ee,unsupportedPreReleaseExtensions:se}}};Z=he([K(1,y.IRequestService),K(2,m.ILogService),K(3,b.IEnvironmentService),K(4,l.ITelemetryService),K(5,h.IFileService),K(6,g.IProductService),K(7,P.IConfigurationService)],Z);let B=class extends Z{constructor(z,V,ee,se,ae,de,ve,be){super(z,V,ee,se,ae,de,ve,be)}};B=he([K(0,S.IStorageService),K(1,y.IRequestService),K(2,m.ILogService),K(3,b.IEnvironmentService),K(4,l.ITelemetryService),K(5,h.IFileService),K(6,g.IProductService),K(7,P.IConfigurationService)],B),e.ExtensionGalleryService=B;let N=class extends Z{constructor(z,V,ee,se,ae,de,ve){super(void 0,z,V,ee,se,ae,de,ve)}};N=he([K(0,y.IRequestService),K(1,m.ILogService),K(2,b.IEnvironmentService),K(3,l.ITelemetryService),K(4,h.IFileService),K(5,g.IProductService),K(6,P.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N}),define(ne[94],ie([0,1,2,14,8,44]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends k.Disposable{constructor(C,E,P=""){super();this.prefix=P;const b=C.getLogger(E.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(C.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(C,E){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,T.validateTelemetryData)(E))}};A=he([K(0,L.ILoggerService),K(1,t.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[95],ie([0,1,2,28,4,26,141,19,42,88,38,20,44]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(m,g){this._configurationService=g,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3})}setExperimentProperty(m,g){this._experimentProperties[m]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let g=m.sessionID,y=m["common.machineId"],w=m["common.firstSessionDate"],S=m["common.msftInternal"];return{sessionId:g,machineId:y,firstSessionDate:w,msftInternal:S}}dispose(){this._disposables.dispose()}_log(m,g,y,w){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(S=>{y=(0,t.mixin)(y,S),y=(0,t.mixin)(y,this._experimentProperties),y=(0,t.cloneAndChange)(y,l=>{if(typeof l=="string")return this._cleanupInfo(l,w)}),this._appenders.forEach(l=>l.log(m,y))},S=>{console.error(S)})}publicLog(m,g,y){return this._log(m,3,g,y)}publicLog2(m,g,y){return this.publicLog(m,g,y)}publicLogError(m,g){return this.sendErrorTelemetry?this._log(m,2,g,!0):Promise.resolve(void 0)}publicLogError2(m,g){return this.publicLogError(m,g)}_anonymizeFilePaths(m){let g=m;const y=[];for(let i of this._cleanupPatterns)for(;;){const c=i.exec(m);if(!c)break;y.push([c.index,i.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(g="";;){const i=S.exec(m);if(!i)break;!w.test(i[0])&&y.every(([c,r])=>i.index<c||i.index>=r)&&(g+=m.substring(l,i.index)+"<REDACTED: user-file-path>",l=S.lastIndex)}return l<m.length&&(g+=m.substr(l)),g}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const g=m.toLowerCase(),y=/@[a-zA-Z0-9-.]+/,w=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,S=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return w.test(g)?"<REDACTED: secret>":y.test(g)?"<REDACTED: email>":S.test(g)?"<REDACTED: token>":m}_cleanupInfo(m,g){let y=m;g&&(y=this._anonymizeFilePaths(y));for(let w of this._cleanupPatterns)y=y.replace(w,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([K(1,R.IConfigurationService)],p),e.TelemetryService=p;function d(){const h=(0,A.localize)(0,null,E.default.nameLong),m=E.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=L.isWeb?"":(0,A.localize)(3,null),y=(0,A.localize)(4,null),w=(0,A.localize)(5,null),S=(0,A.localize)(6,null),l=(0,A.localize)(7,null),i=`
|       | ${y} | ${w} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,c=(0,A.localize)(8,null);return`
${h} ${m} ${g}

&nbsp;

${l}
${i}

&nbsp;

${c}
`}P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,A.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,A.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[210],ie([0,1,9,28,44]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(R,C){const E=await new Promise((b,f)=>{Y(["applicationinsights"],b,f)});let P;return E.defaultClient?(P=new E.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(E.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=E.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=C?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class A{constructor(C,E,P,b,f){this._eventPrefix=C,this._defaultData=E,this.testCollector=b,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(C){if(!!this._aiClient){if(typeof this._aiClient!="string"){C(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{C(E)},E=>{(0,k.onUnexpectedError)(E),console.error(E)})}}log(C,E){if(!!this._aiClient){E=(0,t.mixin)(E,this._defaultData),E=(0,L.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+C,properties:E.properties,measurements:E.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(C=>{this._withAIClient(E=>{try{E.flush({callback:()=>{this._aiClient=void 0,C(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(ne[211],ie([0,1,18,58,19,14,8,20,93,94,95]),function(Y,e,k,t,L,T,A,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let b=class{constructor(p,d,h,m){this.configurationService=p,this.telemetryService=d,this.loggerService=h,this.environmentService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:d,sessionId:h}=await this.telemetryService.getTelemetryInfo(),m=Object.create(null);m["common.vscodemachineid"]=d,m["common.vscodesessionid"]=h;const g=[p.id,JSON.stringify(m),p.aiKey],w=new t.Client(k.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),S=[new C.TelemetryAppenderClient(w),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new P.TelemetryService({appenders:S,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,d,h){await(await this.getCustomTelemetryService(p)).publicLog(d,h)}async publicLogError(p,d,h){await(await this.getCustomTelemetryService(p)).publicLogError(d,h)}};b=he([K(0,L.IConfigurationService),K(1,R.ITelemetryService),K(2,A.ILoggerService),K(3,T.IEnvironmentService)],b),e.CustomEndpointTelemetryService=b}),define(ne[212],ie([0,1,5,25,3,2,8]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends T.Disposable{constructor(E,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((P,b)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,P),this._onCreateRequest.fire({requestId:f,...E});const p=new t.CancellationTokenSource;(0,k.timeout)(this._timeout,p.token).then(()=>b(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>p.cancel())])})}acceptReply(E,P){const b=this._pendingRequests.get(E);b?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),b(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=he([K(1,A.ILogService)],R),e.RequestStore=R}),define(ne[96],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(h){h.Shell="terminal.integrated.shell.",h.ShellArgs="terminal.integrated.shellArgs.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(h){h.ShellLinux="terminal.integrated.shell.linux",h.ShellMacOs="terminal.integrated.shell.osx",h.ShellWindows="terminal.integrated.shell.windows",h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationShellLinux="terminal.integrated.automationShell.linux",h.AutomationShellMacOs="terminal.integrated.automationShell.osx",h.AutomationShellWindows="terminal.integrated.automationShell.windows",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ShellArgsLinux="terminal.integrated.shellArgs.linux",h.ShellArgsMacOs="terminal.integrated.shellArgs.osx",h.ShellArgsWindows="terminal.integrated.shellArgs.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.Log="log",h.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var C;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var b;(function(h){h.TerminalView="view",h.Editor="editor"})(b=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var d;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(d=e.ProfileSource||(e.ProfileSource={}))}),define(ne[213],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(ne[214],ie([0,1,34,28,10,4,33,15,22]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let f=0;return b&&b.length===4&&(f=parseInt(b[3])),f}e.getWindowsBuildNumber=E;async function P(b,f,p,d=A.env,h=C.Promises.exists){if(L.isAbsolute(b))return await h(b)?b:void 0;if(f===void 0&&(f=A.cwd()),L.dirname(b)!=="."){const w=L.join(f,b);return await h(w)?w:void 0}const g=(0,t.getCaseInsensitive)(d,"PATH");if(p===void 0&&(0,R.isString)(g)&&(p=g.split(L.delimiter)),p===void 0||p.length===0){const w=L.join(f,b);return await h(w)?w:void 0}for(let w of p){let S;if(L.isAbsolute(w)?S=L.join(w,b):S=L.join(f,w,b),await h(S))return S;if(T.isWindows){let l=S+".com";if(await h(l)||(l=S+".exe",await h(l)))return l}}const y=L.join(f,b);return await h(y)?y:void 0}e.findExecutable=P}),define(ne[215],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var k;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(k=e.ColorScheme||(e.ColorScheme={}))}),define(ne[97],ie([0,1,48,3,2,6,38,215]),function(Y,e,k,t,L,T,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var C;(function(m){function g(y){return y&&typeof y=="object"&&typeof y.id=="string"}m.isThemeColor=g})(C=e.ThemeColor||(e.ThemeColor={}));function E(m){return{id:m}}e.themeColorFromId=E;var P;(function(m){function g(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||C.isThemeColor(n.color))}m.isThemeIcon=g;const y=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function w(n){const s=y.exec(n);if(!s)return;let[,o]=s;return{id:o}}m.fromString=w;function S(n){return{id:n}}m.fromId=S;function l(n,s){let o=n.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),s&&(o=`${o}~${s}`),{id:o}}m.modify=l;function i(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}m.getModifier=i;function c(n,s){return n.id===s.id&&n.color?.id===s.color?.id}m.isEqual=c;function r(n,s){return{id:n.id,color:s?E(s):void 0}}m.asThemeIcon=r,m.asClassNameArray=k.CSSIcon.asClassNameArray,m.asClassName=k.CSSIcon.asClassName,m.asCSSSelector=k.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function b(m){switch(m){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,L.toDisposable)(()=>{const y=this.themingParticipants.indexOf(g);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;A.Registry.add(e.Extensions.ThemingContribution,p);function d(m){return p.onColorThemeChange(m)}e.registerThemingParticipant=d;class h extends L.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,y){let w=this.theme.getColor(g);return w&&y&&(w=y(w,this.theme)),w?w.toString():null}}e.Themable=h}),define(ne[216],ie([0,1,48,7,97]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(b,f){const p=b.map(d=>({name:d.profileName,description:A(d)}));return f&&p.push(...f.map(d=>({name:d.title,description:R(d)}))),{values:p.map(d=>d.name),markdownDescriptions:p.map(d=>d.description)}}e.createProfileSchemaEnums=T;function A(b){let f=`$(${L.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:k.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?f+=`
- args: "${b.args}"`:f+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(f+=`
- overrideName: ${b.overrideName}`),b.color&&(f+=`
- color: ${b.color}`),b.env&&(f+=`
- env: ${JSON.stringify(b.env)}`),f}function R(b){return`$(${L.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:k.Codicon.terminal.id}) ${b.title}
- extensionIdenfifier: ${b.extensionIdentifier}`}function C(b,f){if(!b&&!f)return!0;if(typeof b=="string"&&typeof f=="string")return b===f;if(Array.isArray(b)&&Array.isArray(f)){if(b.length!==f.length)return!1;for(let p=0;p<b.length;p++)if(b[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function E(b,f){if(!b&&!f)return!0;if(!b||!f)return!1;if(L.ThemeIcon.isThemeIcon(b)&&L.ThemeIcon.isThemeIcon(f))return b.id===f.id&&b.color===f.color;if(typeof b=="object"&&b&&"light"in b&&"dark"in b&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const p=b,d=f;if((t.URI.isUri(p.light)||P(p.light))&&(t.URI.isUri(p.dark)||P(p.dark))&&(t.URI.isUri(d.light)||P(d.light))&&(t.URI.isUri(d.dark)||P(d.dark)))return p.light.path===d.light.path&&p.dark.path===d.dark.path}if(t.URI.isUri(b)&&t.URI.isUri(f)||P(b)||P(f)){const p=b,d=f;return p.path===d.path&&p.scheme===d.scheme}return!1}e.terminalIconsEqual=E;function P(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.isUriComponents=P}),define(ne[217],ie([0,1,48,142,42,38,216]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),type:"string",enum:Array.from(k.Codicon.getAll(),S=>S.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),S=>`$(${S.id})`)},color:{description:(0,t.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),m={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,t.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,t.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(m),w()}e.registerTerminalPlatformConfiguration=g;let y;function w(S,l){const i=T.Registry.as(L.Extensions.Configuration);let c;S&&(c=(0,A.createProfileSchemaEnums)(S?.profiles,l));const r=y;y={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?c?.values:void 0,markdownEnumDescriptions:S?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?c?.values:void 0,markdownEnumDescriptions:S?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?c?.values:void 0,markdownEnumDescriptions:S?.os===1?c?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[y],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(ne[218],ie([0,1,46,48,10,4,22,73,214,97]),function(Y,e,k,t,L,T,A,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,b=!0;function f(c,r,n,s,o=process.env,a,u,v,I){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?p(n,a,o,u,s.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),I,v):S(a,u,n,c&&typeof c=="object"?{...c}:s.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,v,o)}e.detectAvailableProfiles=f;async function p(c,r,n,s,o,a,u,v,I){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let M=!1;(0,C.getWindowsBuildNumber)()>=16299&&(M=!0),await m(v);const D=new Map;c&&(D.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),D.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),D.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),D.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),l(a,D);const U=await d(D.entries(),u,r,n,s,I);if(c||!c&&o)try{const F=await y(`${O}\\${M?"wsl":"bash"}.exe`,u);for(const x of F)(!a||!(x.profileName in a))&&U.push(x)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return U}async function d(c,r,n,s=process.env,o,a){const u=[];for(const[v,I]of c){if(I===null)continue;let _,O,M;if("source"in I){const F=P?.get(I.source);if(!F)continue;_=F.paths,O=I.args||F.args,I.icon?M=h(I.icon):F.icon&&(M=F.icon)}else _=Array.isArray(I.path)?I.path:[I.path],O=T.isWindows||Array.isArray(I.args)?I.args:void 0,M=h(I.icon);const D=await a?.(_)||_.slice(),U=await i(v,r,D,n,s,O,I.env,I.overrideName,I.isAutoDetected,o);U?(U.isAutoDetected=I.isAutoDetected,U.icon=M,U.color=I.color,u.push(U)):o?.trace("profile not validated",v,_)}return u}function h(c){return typeof c=="string"?{id:c}:c}async function m(c){P&&!c||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:c||await g(),icon:E.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function g(){const c=[];for await(const r of(0,R.enumeratePowerShellInstallations)())c.push(r.exePath);return c}async function y(c,r){const n=[],s=await new Promise((u,v)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,_)=>{if(I)return v("Problem occurred when getting wsl distros");u(_)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),a=s.split(o).filter(u=>u.trim().length>0&&u!=="");for(const u of a){if(u===""||u.startsWith("docker-desktop"))continue;const v=`${u} (WSL)`,I={profileName:v,path:c,args:["-d",`${u}`],isDefault:v===r,icon:w(u),isAutoDetected:!1};n.push(I)}return n}function w(c){return c.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):c.includes("Debian")?E.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function S(c,r,n,s,o,a,u,v){const I=new Map;if(n){const _=(await c.readFile("/etc/shells")).toString(),O=a||_.split(`
`).filter(D=>D.trim().indexOf("#")!==0&&D.trim().length>0),M=new Map;for(const D of O){let U=(0,L.basename)(D),F=M.get(U)||0;F++,F>1&&(U=`${U} (${F})`),M.set(U,F),I.set(U,{path:D,isAutoDetected:!0})}}return l(s,I),await d(I.entries(),o,c,v,r,u)}function l(c,r){if(!!c)for(const[n,s]of Object.entries(c))s===null||!("path"in s)&&!("source"in s)?r.delete(n):(s.icon=s.icon||r.get(n)?.icon,r.set(n,s))}async function i(c,r,n,s,o,a,u,v,I,_){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return i(c,r,n,s,o,a,u,v,I);const M={profileName:c,path:O,args:a,env:u,overrideName:v,isAutoDetected:I,isDefault:c===r};if((0,L.basename)(O)===O){const U=o.PATH?o.PATH.split(L.delimiter):void 0,F=await(0,C.findExecutable)(O,void 0,U,void 0,s.existsFile);return F?(M.path=F,M.isFromPath=!0,M):i(c,r,n,s,o,a)}return await s.existsFile((0,L.normalize)(O))?M:i(c,r,n,s,o,a,u,v,I)}}),define(ne[219],ie([0,1,3,2,18,4,36,58,19,14,78,161,8,87,20,212,96,217,218]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var w;(function(i){i[i.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let S=0,l=class extends t.Disposable{constructor(c,r,n,s,o){super();this._reconnectConstants=c,this._configurationService=r,this._environmentService=n,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,t.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(c){return this._logService.error("ptyHost was unable to resolve shell environment",c),{}}}_startPtyHost(){const c={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:S,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?c.debugBrk=r.port:!r.break&&r.port&&(c.debug=r.port));const n=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,c);this._onPtyHostStart.fire(),A.ProxyChannel.toService(n.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(n.onDidProcessExit(u=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=w.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const o=n.getChannel(m.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const a=A.ProxyChannel.toService(n.getChannel(m.TerminalIpcChannels.PtyHost));return this._register(a.onProcessData(u=>this._onProcessData.fire(u))),this._register(a.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(a.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(a.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(a.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(a.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(a.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[n,a]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(c,r,n,s,o,a,u,v,I,_,O){const M=setTimeout(()=>this._handleUnresponsiveCreateProcess(),m.HeartbeatConstants.CreateProcessTimeout),D=await this._proxy.createProcess(c,r,n,s,o,a,u,v,I,_,O);return clearTimeout(M),S=Math.max(S,D),D}updateTitle(c,r,n){return this._proxy.updateTitle(c,r,n)}updateIcon(c,r,n){return this._proxy.updateIcon(c,r,n)}attachToProcess(c){return this._proxy.attachToProcess(c)}detachFromProcess(c){return this._proxy.detachFromProcess(c)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(c){return this._proxy.start(c)}shutdown(c,r){return this._proxy.shutdown(c,r)}input(c,r){return this._proxy.input(c,r)}processBinary(c,r){return this._proxy.processBinary(c,r)}resize(c,r,n){return this._proxy.resize(c,r,n)}acknowledgeDataEvent(c,r){return this._proxy.acknowledgeDataEvent(c,r)}setUnicodeVersion(c,r){return this._proxy.setUnicodeVersion(c,r)}getInitialCwd(c){return this._proxy.getInitialCwd(c)}getCwd(c){return this._proxy.getCwd(c)}getLatency(c){return this._proxy.getLatency(c)}orphanQuestionReply(c){return this._proxy.orphanQuestionReply(c)}installAutoReply(c,r){return this._proxy.installAutoReply(c,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(c){return this._proxy.uninstallAutoReply(c)}getDefaultSystemShell(c){return this._proxy.getDefaultSystemShell(c)}async getProfiles(c,r,n,s=!1){const o=await this._shellEnv;return(0,y.detectAvailableProfiles)(r,n,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,c))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(c){return this._proxy.getWslPath(c)}setTerminalLayoutInfo(c){return this._proxy.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return await this._proxy.getTerminalLayoutInfo(c)}async requestDetachInstance(c,r){return this._proxy.requestDetachInstance(c,r)}async acceptDetachInstanceReply(c,r){return this._proxy.acceptDetachInstanceReply(c,r)}async serializeTerminalState(c){return this._proxy.serializeTerminalState(c)}async reviveTerminalProcesses(c,r){return this._proxy.reviveTerminalProcesses(c,r)}async refreshProperty(c,r){return this._proxy.refreshProperty(c,r)}async updateProperty(c,r,n){return this._proxy.updateProperty(c,r,n)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(c,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:c,originalText:r})}async acceptPtyHostResolvedVariables(c,r){this._resolveVariablesRequestStore.acceptReply(c,r)}};l=he([K(1,C.IConfigurationService),K(2,E.IEnvironmentService),K(3,f.ILogService),K(4,d.ITelemetryService)],l),e.PtyHostService=l}),define(ne[64],ie([0,1,3,4,6,8]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=b;function f(d,h){return h?h!==1&&d<1024:!t.isWindows&&d<1024}e.isPortPrivileged=f;let p=class{constructor(h){this.logService=h,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],m=Array.from(this._tunnels.values());for(let g of m){const y=Array.from(g.values());for(let w of y){const S=await w.value;S&&h.push(S)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:m}of h.values())await m.then(g=>g?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,m,g,y,w=!1,S=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${g} on local port ${y}.`),!h)return;m||(m="localhost");const i=this.retainOrCreateTunnel(h,m,g,y,w,S,l);return i?i.then(c=>{if(!c){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(c);return(c.tunnelRemoteHost!==m||c.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const m=this._tunnels.get(h.tunnelRemoteHost);if(m){const g=m.get(h.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,g))}}}}async tryDisposeTunnel(h,m,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${m}.`);const y=g.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(m),y}}async closeTunnel(h,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${m} `);const g=this._tunnels.get(h);if(g&&g.has(m)){const y=g.get(m);y.refcount=0,await this.tryDisposeTunnel(h,m,y)}}addTunnelToMap(h,m,g){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(m,{refcount:1,value:g})}async removeEmptyTunnelFromMap(h,m){const g=this._tunnels.get(h);g&&(await g.get(m)||g.delete(m),g.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,m){let g=[h];P(h)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):b(h)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const y=g.map(w=>this._tunnels.get(w));for(const w of y){const S=w?.get(m);if(S)return S}}canTunnel(h){return!!E(h)}createWithProvider(h,m,g,y,w,S,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${g} on local port ${y}.`);const c={elevationRequired:w?f(y===void 0?g:y):!1},r={remoteAddress:{host:m,port:g},localAddressPort:y,privacy:S,public:S!==R.Private,protocol:l},n=h.forwardPort(r,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(m,g,n),n}};p=he([K(0,T.ILogService)],p),e.AbstractTunnelService=p}),define(ne[220],ie([0,1,8,64,2,9,5]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let C=class Ct extends L.Disposable{constructor(P,b){super();this._tunnelService=P,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(P,b,f,p,d,h){const m=new R,g=await Promise.resolve(this._tunnelService.openTunnel(P,m,f,p,d,h));if(!g)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${p} (remote).`),m.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),m.dispose(),await g.dispose(),(0,T.canceled)();return m.setTunnel(g),this._tunnels.set(b,m),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${g.localAddress} (local) to ${f}:${p} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(P,b){const f=this._tunnels.get(P);!f||f.setAddress(b)}async destroyTunnel(P){const b=this._tunnels.get(P);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await b.dispose();return}this._disposedTunnels.add(P)}};C._lastId=0,C=he([K(0,t.ISharedTunnelsService),K(1,k.ILogService)],C),e.SharedProcessTunnelService=C}),define(ne[32],ie([0,1,6]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(ne[221],ie([0,1,3,2,7,14,31,11,8,32]),function(Y,e,k,t,L,T,A,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends t.Disposable{constructor(f,p,d,h,m){super();this.extensionsManagementService=f,this.logService=h,this.uriIdentityService=m,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(w=>w.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(y=>this.onInstallExtension(y))),this._register(f.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(f.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const g=L.URI.file(d.extensionsPath);this._register(p.watch(g)),this._register(k.Event.filter(p.onDidFilesChange,y=>y.rawChanges.some(w=>this.doesChangeAffects(w,g)))(()=>this.onDidChange()))}doesChangeAffects(f,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),p)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const p of f)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(p=>!(0,A.areSameExtensions)(p,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,A.areSameExtensions)(p,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),p=f.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(m=>(0,A.areSameExtensions)(m,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),d=this.installedExtensions.filter(h=>this.installingExtensions.some(m=>(0,A.areSameExtensions)(m,h))?!1:f.every(m=>!(0,A.areSameExtensions)(m.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=f.map(h=>h.identifier),(p.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:d})}}};P=he([K(1,R.IFileService),K(2,T.INativeEnvironmentService),K(3,C.ILogService),K(4,E.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(ne[222],ie([0,1,32,80,11,21,104,3,2]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(f){this.uri=f,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let P=class{constructor(f){this._fileService=f,this._dispooables=new C.DisposableStore,this._limit=2**16;const p=new Map,d=h=>{let m=p.get(h.scheme);return m===void 0&&(m=f.hasProvider(h)&&!this._fileService.hasCapability(h,1024),p.set(h.scheme,m)),m};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(h=>{p.delete(h.scheme)})),this.extUri=new T.ExtUri(d),this._canonicalUris=new A.SkipList((h,m)=>this.extUri.compare(h,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,T.normalizePath)(f));let p=this._canonicalUris.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new E(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((d,h)=>d[1].touch<h[1].touch?1:d[1].touch>h[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let d=0;d<p;d++)this._canonicalUris.set(f[d][0],f[d][1].touch())}};P=he([K(0,L.IFileService)],P),e.UriIdentityService=P,(0,t.registerSingleton)(k.IUriIdentityService,P,!0)}),define(ne[223],ie([0,1,3,2,40,39,17]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends t.Disposable{constructor(E,P,b,f){super();this.fileSystemScheme=E,this.fileSystemProvider=P,this.userDataScheme=b,this.logService=f,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,P){this.watchResources.set(E,E);const b=this.fileSystemProvider.watch(this.toFileSystemResource(E),P);return(0,t.toDisposable)(()=>{this.watchResources.delete(E),b.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,P,b){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(P),b)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,P,b){const f=(0,L.newWriteableStream)(p=>A.VSBuffer.concat(p.map(d=>A.VSBuffer.wrap(d))).buffer);return(async()=>{try{const p=await this.readFile(E);f.end(p)}catch(p){f.error(p),f.end()}})(),f}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,P,b){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),P,b)}delete(E,P){return this.fileSystemProvider.delete(this.toFileSystemResource(E),P)}handleFileChanges(E){const P=[];for(const b of E){if(b.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(b.resource);this.watchResources.findSubstr(f)&&P.push({resource:f,type:b.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ne[53],ie([0,1,70]),function(Y,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function t(A,R,C,E){const P=(0,k.setProperty)(A,R,C,E)[0];return P&&(A=A.substring(0,P.offset)+P.content+A.substring(P.offset+P.length)),A}e.edit=t;function L(A,R,C){let E=C;for(;E>=0;){if(A.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&A.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=L;function T(A,R,C){let E=C;for(;E>=0;)if(A.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&A.charAt(E)===R.charAt(1)))return E;return A.length-1}e.getLineEndOffset=T}),define(ne[224],ie([0,1,28,62,15]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(f,p,d,h,m){const g=[],y=[],w=[];if(!p){const O=f.filter(({identifier:M})=>m.every(D=>D.toLowerCase()!==M.id.toLowerCase()));return{local:{added:g,removed:y,updated:w},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(P),p=p.map(P),d=d?d.map(P):null;const S=new Map,l=O=>{O.uuid&&S.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>l(O)),p.forEach(({identifier:O})=>l(O)),d&&d.forEach(({identifier:O})=>l(O));const i=O=>{const M=O.identifier.uuid||S.get(O.identifier.id.toLowerCase());return M?`uuid:${M}`:`id:${O.identifier.id.toLowerCase()}`},c=(O,M)=>(O.set(i(M),M),O),r=f.reduce(c,new Map),n=p.reduce(c,new Map),s=p.reduce((O,M)=>{const D=i(M);M=(0,k.deepClone)(M);const U=r.get(D);return U&&(U.installed&&(M.installed=!0),M.version||(M.version=U.version)),c(O,M)},new Map),o=d?d.reduce(c,new Map):null,a=h.reduce(c,new Map),u=m.reduce((O,M)=>{const D=S.get(M.toLowerCase());return O.add(D?`uuid:${D}`:`id:${M.toLowerCase()}`)},new Set),v=A(r,n,u);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const O=A(o,r,u),M=A(o,n,u),D=(U,F)=>{const x=r.get(U);if(x){const q=n.get(U),G=F?q:x;return{...G,version:q.version&&(!x.installed||t.gt(q.version,x.version))?q.version:x.version,state:R(x,q,o?.get(U)),preRelease:(0,L.isUndefined)(G.preRelease)?x.preRelease:x.installed?G.preRelease:q.preRelease}}};for(const U of M.removed.values()){const F=r.get(U);F&&y.push(F.identifier)}for(const U of M.added.values())if(O.added.has(U)){if(v.updated.has(U)){const F=D(U,!0);F&&(w.push(b(F,U)),s.set(U,F))}}else{const F=n.get(U);F.installed&&g.push(b(F,U))}for(const U of M.updated.values()){const F=D(U,!0);F&&(w.push(b(F,U)),s.set(U,F))}for(const U of O.added.values())M.added.has(U)||s.set(U,r.get(U));for(const U of O.updated.values())if(!M.removed.has(U)&&!M.updated.has(U)){const F=D(U,!1);F&&(s.get(U)?.installed&&(F.installed=!0),s.set(U,F))}for(const U of O.removed.values())!a.has(U)&&!M.updated.has(U)&&o?.get(U)?.installed&&s.delete(U)}const I=[],_=A(n,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&s.forEach((O,M)=>I.push(b(O,M))),{local:{added:g,removed:y,updated:w},remote:I.length?{added:[..._.added].map(O=>s.get(O)),updated:[..._.updated].map(O=>s.get(O)),removed:[..._.removed].map(O=>n.get(O)),all:I}:null}}e.merge=T;function A(f,p,d,{checkInstalledProperty:h,checkVersionProperty:m}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=f?[...f.keys()].filter(i=>!d.has(i)):[],y=[...p.keys()].filter(i=>!d.has(i)),w=y.filter(i=>g.indexOf(i)===-1).reduce((i,c)=>(i.add(c),i),new Set),S=g.filter(i=>y.indexOf(i)===-1).reduce((i,c)=>(i.add(c),i),new Set),l=new Set;for(const i of g){if(S.has(i))continue;const c=f.get(i),r=p.get(i);(!r||c.disabled!==r.disabled||c.installed&&r.installed&&c.preRelease!==r.preRelease||!E(c.state,r.state)||m&&c.version!==r.version||h&&c.installed!==r.installed)&&l.add(i)}return{added:w,removed:S,updated:l}}function R(f,p,d){const h=f.state,m=p.state,g=d?.state;if(!p.version||h&&t.gt(f.version,p.version))return h;if(m&&t.gt(p.version,f.version)||!h)return m;if(!m)return h;const y=(0,k.deepClone)(h),w=g?C(g,m):{added:Object.keys(m).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set},S=g?C(g,h):{added:Object.keys(h).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set};for(const l of[...w.added.values(),...w.updated.values()])y[l]=m[l];for(const l of w.removed.values())S.updated.has(l)||delete y[l];return y}function C(f,p){const d=Object.keys(f),h=Object.keys(p),m=h.filter(w=>d.indexOf(w)===-1).reduce((w,S)=>(w.add(S),w),new Set),g=d.filter(w=>h.indexOf(w)===-1).reduce((w,S)=>(w.add(S),w),new Set),y=new Set;for(const w of d){if(g.has(w))continue;const S=f[w],l=p[w];(0,k.equals)(S,l)||y.add(w)}return{added:m,removed:g,updated:y}}function E(f={},p={}){const{added:d,removed:h,updated:m}=C(f,p);return d.size===0&&h.size===0&&m.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function b(f,p){const d={identifier:{id:f.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(d.version=f.version),f.disabled&&(d.disabled=!0),f.installed&&(d.installed=!0),f.state&&(d.state=f.state),d}}),define(ne[98],ie([0,1,16,19,6]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),C&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,C){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return E=E.filter(P=>P!==R&&P!==`-${R}`),C&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const C=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),P=[],b=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?b.push(f.substring(1)):P.push(f);return(0,k.distinct)([...C,...P].filter(f=>b.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};T=he([K(0,t.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ne[225],ie([0,1,16,35,28,158,53]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(S){return(0,t.parse)(S)||[]}e.parseKeybindings=R;async function C(S,l,i,c,r){const n=R(S),s=R(l),o=i?R(i):null,a=[...n,...s,...o||[]].map(q=>q.key),u=await r.resolveUserBindings(a);let v=P(n,s,o,u);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const I=f(n),_=f(s),O=o?f(o):null,M=d(I,_,u),D=O?d(O,I,u):{added:[...I.keys()].reduce((q,G)=>(q.add(G),q),new Set),removed:new Set,updated:new Set},U=O?d(O,_,u):{added:[..._.keys()].reduce((q,G)=>(q.add(G),q),new Set),removed:new Set,updated:new Set},F=E(M,D,U);let x=S;for(const q of F.removed.values())F.conflicts.has(q)||(x=y(x,q,c));for(const q of F.added.values()){if(F.conflicts.has(q))continue;const G=_.get(q);if(G.some(te=>te.command!==`-${q}`&&v.conflicts.has(u[te.key]))){F.conflicts.add(q);continue}x=g(x,G,c)}for(const q of F.updated.values()){if(F.conflicts.has(q))continue;const G=_.get(q);if(G.some(te=>te.command!==`-${q}`&&v.conflicts.has(u[te.key]))){F.conflicts.add(q);continue}x=w(x,q,G,c)}return{mergeContent:x,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=C;function E(S,l,i){const c=new Set,r=new Set,n=new Set,s=new Set;for(const o of l.removed.values())i.updated.has(o)&&s.add(o);for(const o of i.removed.values())s.has(o)||(l.updated.has(o)?s.add(o):r.add(o));for(const o of l.added.values())s.has(o)||i.added.has(o)&&S.updated.has(o)&&s.add(o);for(const o of i.added.values())s.has(o)||(l.added.has(o)?S.updated.has(o)&&s.add(o):c.add(o));for(const o of l.updated.values())s.has(o)||i.updated.has(o)&&S.updated.has(o)&&s.add(o);for(const o of i.updated.values())s.has(o)||(l.updated.has(o)?S.updated.has(o)&&s.add(o):n.add(o));return{added:c,removed:r,updated:n,conflicts:s}}function P(S,l,i,c){const r=new Set,n=b(S,c),s=b(l,c),o=i?b(i,c):null,a=p(n,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const u=o?p(o,n):{added:[...n.keys()].reduce((D,U)=>(D.add(U),D),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const v=o?p(o,s):{added:[...s.keys()].reduce((D,U)=>(D.add(U),D),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:I,removed:_,updated:O,conflicts:M}=E(a,u,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:_,updated:O,conflicts:M}}function b(S,l){const i=new Map;for(const c of S){const r=l[c.key];let n=i.get(r);n||(n=[],i.set(r,n)),n.push(c)}return i}function f(S){const l=new Map;for(const i of S){const c=i.command[0]==="-"?i.command.substring(1):i.command;let r=l.get(c);r||(r=[],l.set(c,r)),r.push(i)}return l}function p(S,l){const i=[...S.keys()],c=[...l.keys()],r=c.filter(o=>i.indexOf(o)===-1).reduce((o,a)=>(o.add(a),o),new Set),n=i.filter(o=>c.indexOf(o)===-1).reduce((o,a)=>(o.add(a),o),new Set),s=new Set;for(const o of i){if(n.has(o))continue;const a=S.get(o).map(v=>({...v,key:o})),u=l.get(o).map(v=>({...v,key:o}));(0,k.equals)(a,u,(v,I)=>m(v,I))||s.add(o)}return{added:r,removed:n,updated:s}}function d(S,l,i){const c=[...S.keys()],r=[...l.keys()],n=r.filter(a=>c.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),s=c.filter(a=>r.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),o=new Set;for(const a of c){if(s.has(a))continue;const u=S.get(a).map(I=>({...I,key:i[I.key]})),v=l.get(a).map(I=>({...I,key:i[I.key]}));h(u,v)||o.add(a)}return{added:n,removed:s,updated:o}}function h(S,l){return!(!(0,k.equals)(S.filter(({command:i})=>i[0]!=="-"),l.filter(({command:i})=>i[0]!=="-"),(i,c)=>m(i,c))||!(0,k.equals)(S.filter(({command:i})=>i[0]==="-"),l.filter(({command:i})=>i[0]==="-"),(i,c)=>m(i,c)))}function m(S,l){if(S.command!==l.command||S.key!==l.key)return!1;const i=T.ContextKeyExpr.deserialize(S.when),c=T.ContextKeyExpr.deserialize(l.when);return!(i&&!c||!i&&c||i&&c&&!i.equals(c)||!L.equals(S.args,l.args))}function g(S,l,i){for(const c of l)S=A.edit(S,[-1],c,i);return S}function y(S,l,i){const c=R(S);for(let r=c.length-1;r>=0;r--)(c[r].command===l||c[r].command===`-${l}`)&&(S=A.edit(S,[r],void 0,i));return S}function w(S,l,i,c){const r=R(S),n=r.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=r.length-1;s>=0;s--)(r[s].command===l||r[s].command===`-${l}`)&&(S=A.edit(S,[s],void 0,c));for(let s=i.length-1;s>=0;s--)S=A.edit(S,[n],i[s],c);return S}}),define(ne[226],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(T,A,R){const C={},E={},P=new Set;if(!A)return{local:{added:C,updated:E,removed:[...P.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const b=t(T,A);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:C,updated:E,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=t(R,T),p=t(R,A),d={},h={},m=new Set,g=new Set;for(const y of f.removed.values())p.updated.has(y)?C[y]=A[y]:m.add(y);for(const y of p.removed.values())g.has(y)||(f.updated.has(y)?g.add(y):P.add(y));for(const y of f.updated.values())g.has(y)||(p.updated.has(y)?b.updated.has(y)&&g.add(y):h[y]=T[y]);for(const y of p.updated.values())g.has(y)||(f.updated.has(y)?b.updated.has(y)&&g.add(y):T[y]!==void 0&&(E[y]=A[y]));for(const y of f.added.values())g.has(y)||(p.added.has(y)?b.updated.has(y)&&g.add(y):d[y]=T[y]);for(const y of p.added.values())g.has(y)||(f.added.has(y)?b.updated.has(y)&&g.add(y):C[y]=A[y]);return{local:{added:C,removed:[...P.values()],updated:E},remote:{added:d,removed:[...m.values()],updated:h},conflicts:[...g.values()]}}e.merge=k;function t(T,A){const R=T?Object.keys(T):[],C=A?Object.keys(A):[],E=C.filter(f=>R.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),P=R.filter(f=>C.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),b=new Set;for(const f of R){if(P.has(f))continue;const p=T[f],d=A[f];p!==d&&b.add(f)}return{added:E,removed:P,updated:b}}function L(T,A){const{added:R,removed:C,updated:E}=t(T,A);return R.size===0&&C.size===0&&E.size===0}e.areSame=L}),define(ne[24],ie([0,1,16,21,15,147,42,30,6,89,38]),function(Y,e,k,t,L,T,A,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const o=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(a=>!!o[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function f(){const o=P.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(o).filter(I=>!!o[I].ignoreSync),u=Object.keys(o).filter(I=>o[I].scope===2||o[I].scope===6),v=b();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...u,...v])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const o="vscode://schemas/ignoredSettings",a=P.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=P.Registry.as(E.Extensions.JSONContribution),v=()=>{const I=b(),_=f().filter(U=>U!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(U=>_.indexOf(U)===-1),M=_.filter(U=>I.indexOf(U)===-1),D={items:{type:"string",enum:[...O,...M.map(U=>`-${U}`)]}};u.registerSchema(o,D)};return a.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=p;function d(o){return o&&(0,L.isObject)(o)&&(0,L.isString)(o.id)&&(0,L.isArray)(o.scopes)}e.isAuthenticationProvider=d;var h;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function m(o,a,u){return u.joinPath(a.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=m,e.IUserDataSyncStoreManagementService=(0,C.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,C.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,C.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(o){const a={};return a[e.HEADER_EXECUTION_ID]=o,a}e.createSyncHeaders=g;var y;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class w extends Error{constructor(a,u,v,I){super(a);this.code=u,this.resource=v,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class S extends w{constructor(a,u,v,I,_){super(a,v,void 0,_);this.url=u,this.serverCode=I}}e.UserDataSyncStoreError=S;class l extends w{constructor(a,u){super(a,u)}}e.UserDataAutoSyncError=l,function(o){function a(u){if(u instanceof o)return u;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(v&&v[1]){const I=v[2]==="unknown"?void 0:v[2],_=v[3]==="unknown"?void 0:v[3];return new o(u.message,v[1],I,_)}return new o(u.message,"Unknown")}o.toUserDataSyncError=a}(w=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var c;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var r;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(o){return`sync.enable.${o}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,C.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,C.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,C.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,C.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,C.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,a){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,t.isEqualOrParent)(o,(0,t.joinPath)(a.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(ne[45],ie([0,1,16,5,17,25,3,35,2,26,15,7,143,19,14,11,8,47,23,20,32,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function i(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=i;let c=class extends C.Disposable{constructor(a,u,v,I,_,O,M,D,U,F,x){super();this.resource=a,this.fileService=u,this.environmentService=v,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=M,this.telemetryService=D,this.logService=U,this.configurationService=F,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new t.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=x.extUri,this.syncFolder=this.extUri.joinPath(v.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(a,v,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(v,u,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?await this.hasRemoteChanged(a):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const u=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,u={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),u)}async preview(a,u,v={}){return this._sync(a,!1,u,v)}async apply(a,u={}){try{this.syncHeaders={...u};const v=await this.doApply(a);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,u,v,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(a,O);return _=await this.performSync(M,O,u,v),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(a){const u=await this.resolveContent(a);if(!u)return!1;const v=this.parseSyncData(u);if(!v)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,I),O=await this.isRemoteDataFromCurrentMachine(_),M=await this.generateSyncPreview({ref:_.ref,syncData:v},I,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),D=[];for(const U of M){const F=await this.getAcceptResult(U,U.remoteResource,void 0,T.CancellationToken.None),{remoteChange:x}=await this.getAcceptResult(U,U.previewResource,U.remoteContent,T.CancellationToken.None);D.push([U,{...F,remoteChange:x!==0?x:2}])}await this.applyResult(_,I,D,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const u=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===u}async getLatestRemoteUserData(a,u){if(u){const v=a&&a.latest?a.latest[this.resource]:void 0;if(u.ref===v||v===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(a,u,v,I){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,u,v,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,u,v,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(a,u,v,I)}throw _}}async doSync(a,u,v,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,t.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(a,u,v,I,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(a){return await this.updateSyncResourcePreview(a,async u=>{const v=await this.getMergeResult(u,T.CancellationToken.None);await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(v?.content||""));const I=v&&!v.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,T.CancellationToken.None):void 0;return u.acceptResult=I,u.mergeState=v.hasConflicts?"conflict":I?"accepted":"preview",u.localChange=I?I.localChange:v.localChange,u.remoteChange=I?I.remoteChange:v.remoteChange,u}),this.syncPreviewPromise}async accept(a,u){return await this.updateSyncResourcePreview(a,async v=>{const I=await this.getAcceptResult(v,a,u,T.CancellationToken.None);return v.acceptResult=I,v.mergeState="accepted",v.localChange=I.localChange,v.remoteChange=I.remoteChange,v}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async u=>{const v=await this.getMergeResult(u,T.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(v.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=v.localChange,u.remoteChange=v.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(a,u){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const I=v.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:M})=>this.extUri.isEqual(_,a)||this.extUri.isEqual(O,a)||this.extUri.isEqual(M,a));I!==-1&&(this.syncPreviewPromise=(0,t.createCancelablePromise)(async _=>{const O=[...v.resourcePreviews];return O[I]=await u(O[I]),{...v,resourcePreviews:O}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(v=>[v,v.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(a){const u=a.filter(({mergeState:v})=>v==="conflict");(0,k.equals)(this._conflicts,u,(v,I)=>this.extUri.isEqual(v.previewResource,I.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:v})=>({created:u,uri:this.toRemoteBackupResource(v)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:v})=>({created:u,uri:this.toLocalBackupResource(v)}))}toRemoteBackupResource(a){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:v}=await this.getUserData(u);if(v)return this.parseSyncData(v)?.machineId}}async resolveContent(a){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:v}=await this.getUserData(u);return v}return this.extUri.isEqual(a,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(a){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const v of u.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,a))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,a))return v.remoteContent;if(this.extUri.isEqual(v.localResource,a))return v.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(a,u,v,I,_){const O=await this.isRemoteDataFromCurrentMachine(a),M=await this.generateSyncPreview(a,u,O,I,_),D=[];for(const U of M){const F=U.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)D.push({...U,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=v?await this.getMergeResult(U,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,L.VSBuffer.fromString(x?.content||""));const q=x&&!x.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,_):void 0;D.push({...U,acceptResult:q,mergeState:x?.hasConflicts?"conflict":q?"accepted":"preview",localChange:q?q.localChange:x?x.localChange:U.localChange,remoteChange:q?q.remoteChange:x?x.remoteChange:U.remoteChange})}}return{remoteUserData:a,lastSyncUserData:u,resourcePreviews:D,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(a.value.toString()),v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&v&&u.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;const I=u;if(I.content===null)return{ref:u.ref,syncData:null};const _=JSON.parse(I.content);if(i(_))return{...u,syncData:_,content:void 0}}catch(a){a instanceof h.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:v,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(a){const{ref:u,content:v}=await this.getUserData(a);let I=null;return v!==null&&(I=this.parseSyncData(v)),{ref:u,syncData:I}}parseSyncData(a){try{const u=JSON.parse(a);if(i(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,P.isString)(a)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:u}}else{const u=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(a,u){const v=await this.currentMachineIdPromise,I={version:this.version,machineId:v,content:a};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),u,this.syncHeaders),{ref:u,syncData:I}}async backupLocal(a){const u={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};c=he([K(1,h.IFileService),K(2,d.IEnvironmentService),K(3,y.IStorageService),K(4,l.IUserDataSyncStoreService),K(5,l.IUserDataSyncBackupStoreService),K(6,l.IUserDataSyncEnablementService),K(7,w.ITelemetryService),K(8,l.IUserDataSyncLogService),K(9,p.IConfigurationService),K(10,S.IUriIdentityService)],c),e.AbstractSynchroniser=c;let r=class extends c{constructor(a,u,v,I,_,O,M,D,U,F,x,q){super(u,v,I,_,O,M,D,U,F,x,q);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(a,u,v){try{u?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(a),v?void 0:u):await this.fileService.createFile(this.file,L.VSBuffer.fromString(a),{overwrite:v})}catch(I){throw I instanceof h.FileOperationError&&I.fileOperationResult===1||I instanceof h.FileOperationError&&I.fileOperationResult===3?new l.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};r=he([K(2,h.IFileService),K(3,d.IEnvironmentService),K(4,y.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncEnablementService),K(8,w.ITelemetryService),K(9,l.IUserDataSyncLogService),K(10,p.IConfigurationService),K(11,S.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let n=class extends r{constructor(a,u,v,I,_,O,M,D,U,F,x,q,G){super(a,u,v,I,_,O,M,D,U,F,q,G);this.userDataSyncUtilService=x,this._formattingOptions=void 0}hasErrors(a){const u=[];return(0,R.parse)(a,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=he([K(2,h.IFileService),K(3,d.IEnvironmentService),K(4,y.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncEnablementService),K(8,w.ITelemetryService),K(9,l.IUserDataSyncLogService),K(10,l.IUserDataSyncUtilService),K(11,p.IConfigurationService),K(12,S.IUriIdentityService)],n),e.AbstractJsonFileSynchroniser=n;let s=class{constructor(a,u,v,I,_){this.resource=a,this.environmentService=u,this.logService=v,this.fileService=I,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:a,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(u);if(!!v)try{await this.doInitialize({ref:a,syncData:v})}catch(I){this.logService.error(I)}}parseSyncData(a){try{const u=JSON.parse(a);if(i(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,u={}){const v={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(v)))}};s=he([K(1,d.IEnvironmentService),K(2,m.ILogService),K(3,h.IFileService),K(4,S.IUriIdentityService)],s),e.AbstractInitializer=s}),define(ne[227],ie([0,1,5,25,9,3,49,26,7,19,14,30,31,63,11,8,23,20,32,45,224,98,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function c(s,o){const a=JSON.parse(s.content);if(s.version===1||s.version===2){const u=(await o.getInstalled(0)).filter(v=>v.isBuiltin);for(const v of a)s.version===1&&(v.enabled===!1&&(v.disabled=!0),delete v.enabled),s.version===2&&u.every(I=>!(0,f.areSameExtensions)(I.identifier,v.identifier))&&(v.installed=!0)}return a}let r=class mt extends w.AbstractSynchroniser{constructor(o,a,u,v,I,_,O,M,D,U,F,x,q,G,te){super("extensions",a,o,u,v,I,x,q,D,F,te);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=M,this.extensionGalleryService=U,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,W=>W.some(({local:j})=>!!j)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,W=>!W.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(o,a){const u=o.syncData?await c(o.syncData,this.extensionManagementService):null,v=a?.skippedExtensions||[],I=a?.syncData?await c(a.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);u?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:D,remote:U}=(0,S.merge)(O,u,I,v,M),F={local:D,remote:U,content:this.getPreviewContent(O,D.added,D.updated,D.removed),localChange:D.added.length>0||D.removed.length>0||D.updated.length>0?2:0,remoteChange:U!==null?2:0};return[{skippedExtensions:v,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:u?this.stringify(u,!1):null,previewResource:this.previewResource,previewResult:F,localChange:F.localChange,remoteChange:F.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const a=o.syncData?await c(o.syncData,this.extensionManagementService):null,u=await this.extensionManagementService.getInstalled(void 0,!0),v=this.getLocalExtensions(u),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),{remote:_}=(0,S.merge)(v,a,a,o.skippedExtensions||[],I);return _!==null}getPreviewContent(o,a,u,v){const I=[...a,...u],_=new Set,O=M=>{_.add(M.id.toLowerCase()),M.uuid&&_.add(M.uuid)};I.forEach(({identifier:M})=>O(M)),v.forEach(O);for(const M of o)_.has(M.identifier.id.toLowerCase())||M.identifier.uuid&&_.has(M.identifier.uuid)||I.push(M);return this.stringify(I,!1)}async getMergeResult(o,a){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,a,u,v){if(this.extUri.isEqual(a,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(a,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(a,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${a.toString()}`)}async acceptLocal(o){const a=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),v=(0,S.merge)(o.localExtensions,null,null,o.skippedExtensions,u),{local:I,remote:_}=v;return{content:o.localContent,local:I,remote:_,localChange:I.added.length>0||I.removed.length>0||I.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(o){const a=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(a),v=o.remoteContent?JSON.parse(o.remoteContent):null;if(v!==null){const I=(0,S.merge)(o.localExtensions,v,o.localExtensions,[],u),{local:_,remote:O}=I;return{content:o.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,a,u,v){let{skippedExtensions:I,localExtensions:_}=u[0][0],{local:O,remote:M,localChange:D,remoteChange:U}=u[0][1];if(D===0&&U===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),D!==0&&(await this.backupLocal(JSON.stringify(_)),I=await this.updateLocalExtensions(O.added,O.removed,O.updated,I)),M){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const F=JSON.stringify(M.all);o=await this.updateRemoteUserData(F,v?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${M.added.length?` Added: ${JSON.stringify(M.added.map(x=>x.identifier.id))}.`:""}${M.updated.length?` Updated: ${JSON.stringify(M.updated.map(x=>x.identifier.id))}.`:""}${M.removed.length?` Removed: ${JSON.stringify(M.removed.map(x=>x.identifier.id))}.`:""}`)}a?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:I}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${I.length?` Skipped: ${JSON.stringify(I.map(F=>F.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,mt.EXTENSIONS_DATA_URI)){const u=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),I=this.getLocalExtensions(u).filter(_=>!v.some(O=>(0,f.areSameExtensions)({id:O},_.identifier)));return this.stringify(I,!0)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)){const u=await this.resolvePreviewContent(o);return u&&this.stringify(JSON.parse(u),!0)}let a=await super.resolveContent(o);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(o)),a){const u=this.parseSyncData(a);if(u)switch(this.extUri.basename(o)){case"extensions.json":return this.stringify(this.parseExtensions(u),!0)}}return null}stringify(o,a){return o.sort((u,v)=>!u.identifier.uuid&&v.identifier.uuid?-1:u.identifier.uuid&&!v.identifier.uuid?1:(0,R.compare)(u.identifier.id,v.identifier.id)),a?(0,A.toFormattedString)(o,{}):JSON.stringify(o)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(u=>u.installed||u.disabled))return!0}catch{}return!1}async updateLocalExtensions(o,a,u,v){const I=[],_=[],O=await this.extensionManagementService.getInstalled();if(a.length){const D=O.filter(({identifier:U,isBuiltin:F})=>!F&&a.some(x=>(0,f.areSameExtensions)(U,x)));await k.Promises.settled(D.map(async U=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,U.identifier.id),await this.extensionManagementService.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,U.identifier.id),I.push(U.identifier)}))}(o.length||u.length)&&await k.Promises.settled([...o,...u].map(async D=>{const U=O.find(x=>(0,f.areSameExtensions)(x.identifier,D.identifier));if(U&&U.isBuiltin){D.state&&U.manifest.version===D.version&&this.updateExtensionState(D.state,U,U.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(q=>(0,f.areSameExtensions)(q,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id),await this.extensionEnablementService.disableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id),await this.extensionEnablementService.enableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id))),I.push(D.identifier);return}const F=(await this.extensionGalleryService.getExtensions([{...D.identifier,preRelease:D.preRelease}],t.CancellationToken.None))[0];if(D.state&&(U?U.manifest.version===D.version:!!F)&&this.updateExtensionState(D.state,U||F,U?.manifest.version),F)try{this.extensionEnablementService.getDisabledExtensions().some(q=>(0,f.areSameExtensions)(q,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id,F.version),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id,F.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id,F.version),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id,F.version))),(!U||U.preRelease!==D.preRelease)&&(await this.extensionManagementService.canInstall(F)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,D.identifier.id,F.version),await this.extensionManagementService.installFromGallery(F,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:D.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,D.identifier.id,F.version),I.push(F.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,F.displayName||F.identifier.id),_.push(D)))}catch(x){_.push(D),x instanceof b.ExtensionManagementError&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatiblePreRelease,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(x.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,F.displayName||F.identifier.id):(this.logService.error(x),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,F.displayName||F.identifier.id))}else _.push(D),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}));const M=[];for(const D of v)I.some(U=>(0,f.areSameExtensions)(U,D.identifier))||M.push(D);for(const D of _)M.some(U=>(0,f.areSameExtensions)(U.identifier,D.identifier))||M.push(D);return M}updateExtensionState(o,a,u){const v=this.extensionStorageService.getExtensionState(a,!0)||{},I=u?this.extensionStorageService.getKeysForSync({id:a.identifier.id,version:u}):void 0;I?I.forEach(_=>{v[_]=o[_]}):Object.keys(o).forEach(_=>v[_]=o[_]),this.extensionStorageService.setExtensionState(a,v,!0)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const a=this.extensionEnablementService.getDisabledExtensions();return o.map(u=>{const{identifier:v,isBuiltin:I,manifest:_,preRelease:O}=u,M={identifier:v,preRelease:O,version:_.version};a.some(D=>(0,f.areSameExtensions)(D,v))&&(M.disabled=!0),I||(M.installed=!0);try{const D=this.extensionStorageService.getKeysForSync({id:v.id,version:_.version});if(D){const U=this.extensionStorageService.getExtensionState(u,!0)||{};M.state=Object.keys(U).reduce((F,x)=>(D.includes(x)&&(F[x]=U[x]),F),{})}}catch(D){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(D))}return M})}};r.EXTENSIONS_DATA_URI=C.URI.from({scheme:i.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=he([K(0,P.IEnvironmentService),K(1,d.IFileService),K(2,m.IStorageService),K(3,i.IUserDataSyncStoreService),K(4,i.IUserDataSyncBackupStoreService),K(5,b.IExtensionManagementService),K(6,b.IGlobalExtensionEnablementService),K(7,l.IIgnoredExtensionsManagementService),K(8,i.IUserDataSyncLogService),K(9,b.IExtensionGalleryService),K(10,E.IConfigurationService),K(11,i.IUserDataSyncEnablementService),K(12,g.ITelemetryService),K(13,p.IExtensionStorageService),K(14,y.IUriIdentityService)],r),e.ExtensionsSynchroniser=r;let n=class extends w.AbstractInitializer{constructor(o,a,u,v,I,_){super("extensions",v,I,u,_);this.extensionManagementService=o,this.ignoredExtensionsManagementService=a}async parseExtensions(o){return o.syncData?await c(o.syncData,this.extensionManagementService):null}generatePreview(o,a){const u=[],v=[],I=[];for(const _ of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=a.find(M=>(0,f.areSameExtensions)(M.identifier,_.identifier));O?(u.push(O),_.disabled&&I.push(_.identifier)):_.installed&&(v.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&I.push(_.identifier))}return{installedExtensions:u,newExtensions:v,disabledExtensions:I,remoteExtensions:o}}};n=he([K(0,b.IExtensionManagementService),K(1,l.IIgnoredExtensionsManagementService),K(2,d.IFileService),K(3,P.IEnvironmentService),K(4,h.ILogService),K(5,y.IUriIdentityService)],n),e.AbstractExtensionsInitializer=n}),define(ne[228],ie([0,1,28,24]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,C,E,P,b){if(!C)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=T(R,C);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=E?T(E,C):{added:Object.keys(C).reduce((y,w)=>(y.add(w),y),new Set),removed:new Set,updated:new Set},d=E?T(E,R):{added:Object.keys(R).reduce((y,w)=>(y.add(w),y),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},m=k.deepClone(C),g=!E;for(const y of d.added.values())y!==t.SYNC_SERVICE_URL_TYPE&&g&&p.added.has(y)||(m[y]=R[y]);for(const y of d.updated.values())m[y]=R[y];for(const y of d.removed.values())P.unregistered.includes(y)||delete m[y];for(const y of p.added.values()){const w=C[y];if(P.machine.includes(y)){b.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(E&&d.added.has(y))continue;const S=R[y];S&&S.value===w.value||y===t.SYNC_SERVICE_URL_TYPE&&g&&d.added.has(y)||(S?h.updated[y]=w:h.added[y]=w)}for(const y of p.updated.values()){const w=C[y];if(P.machine.includes(y)){b.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(y)||d.removed.has(y))continue;const S=R[y];S&&S.value===w.value||(h.updated[y]=w)}for(const y of p.removed.values()){if(P.machine.includes(y)){b.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}d.updated.has(y)||d.removed.has(y)||h.removed.push(y)}return{local:h,remote:A(m,C)?null:m}}e.merge=L;function T(R,C){const E=Object.keys(R),P=Object.keys(C),b=P.filter(d=>E.indexOf(d)===-1).reduce((d,h)=>(d.add(h),d),new Set),f=E.filter(d=>P.indexOf(d)===-1).reduce((d,h)=>(d.add(h),d),new Set),p=new Set;for(const d of E){if(f.has(d))continue;const h=R[d],m=C[d];k.equals(h,m)||p.add(d)}return{added:b,removed:f,updated:p}}function A(R,C){const{added:E,removed:P,updated:b}=T(R,C);return E.size===0&&P.size===0&&b.size===0}}),define(ne[229],ie([0,1,17,9,3,35,49,4,7,29,19,14,11,8,47,23,20,32,45,53,228,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const i="globalState.argv.",c=["locale"];function r(u,v){const I=u.storage?Object.keys(u.storage).sort():[],_={};return I.forEach(O=>_[O]=u.storage[O]),u.storage=_,v?(0,A.toFormattedString)(u,{}):JSON.stringify(u)}const n=1;let s=class vt extends y.AbstractSynchroniser{constructor(v,I,_,O,M,D,U,F,x,q){super("globalState",v,M,x,I,_,D,U,O,F,q);this.storageService=x,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(v.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),L.Event.filter(x.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:x.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(v,I,_){const O=v.syncData?JSON.parse(v.syncData.content):null;I=I===null&&_?v:I;const M=I&&I.syncData?JSON.parse(I.syncData.content):null,D=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const U=this.getStorageKeys(M),{local:F,remote:x}=(0,S.merge)(D.storage,O?O.storage:null,M?M.storage:null,U,this.logService),q={content:null,local:F,remote:x,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:x!==null?2:0};return[{localResource:this.localResource,localContent:r(D,!1),localUserData:D,remoteResource:this.remoteResource,remoteContent:O?r(O,!1):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource,storageKeys:U}]}async hasRemoteChanged(v){const I=v.syncData?JSON.parse(v.syncData.content):null;if(I===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(I),{remote:M}=(0,S.merge)(_.storage,I.storage,I.storage,O,this.logService);return M!==null}async getMergeResult(v,I){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,I,_,O){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(I,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:v.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(v){if(v.remoteContent!==null){const I=JSON.parse(v.remoteContent),{local:_,remote:O}=(0,S.merge)(v.localUserData.storage,I.storage,null,v.storageKeys,this.logService);return{content:v.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(v,I,_,O){let{localUserData:M}=_[0][0],{local:D,remote:U,localChange:F,remoteChange:x}=_[0][1];if(F===0&&x===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),F!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(M)),await this.writeLocalGlobalState(D),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),x!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const q=JSON.stringify({storage:U});v=await this.updateRemoteUserData(q,O?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return r(_,!0)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v)){const _=await this.resolvePreviewContent(v);return _&&r(JSON.parse(_),!0)}let I=await super.resolveContent(v);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(v)),I){const _=this.parseSyncData(I);if(_)switch(this.extUri.basename(v)){case"globalState.json":return r(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:v}=await this.getLocalGlobalState();if(Object.keys(v).length>1||v[`${i}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const v={},I=await this.getLocalArgvContent(),_=(0,T.parse)(I);for(const O of c)_[O]!==void 0&&(v[`${i}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const M=this.storageService.get(O,0);M&&(v[O]={version:1,value:M})}return{storage:v}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const v=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),v.value.toString()}catch(v){this.logService.debug((0,t.getErrorMessage)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:I,updated:_}){const O={},M={},D=(F,x)=>{for(const q of F){if(q.startsWith(i)){O[q.substring(i.length)]=x?x[q].value:void 0;continue}if(x){const G=x[q];G.value!==String(this.storageService.get(q,0))&&(M[q]=G.value)}else this.storageService.get(q,0)!==void 0&&(M[q]=void 0)}};if(D(Object.keys(v),v),D(Object.keys(_),_),D(I),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(M).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const F of Object.keys(M))this.storageService.store(F,M[F],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(M))}}async updateArgv(v){const I=await this.getLocalArgvContent();let _=I;for(const O of Object.keys(v))_=(0,w.edit)(_,[O],v[O],{});I!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(v){const I=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...I,..._],M=v?.storage?Object.keys(v.storage).filter(D=>!D.startsWith(i)&&!O.includes(D)&&this.storageService.get(D,0)!==void 0):[];if(!R.isWeb){const D=[...l.ALL_SYNC_RESOURCES.map(U=>(0,l.getEnablementKey)(U)),l.SYNC_SERVICE_URL_TYPE];M.push(...D),_.push(...D)}return{user:I,machine:_,unregistered:M}}};s.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=he([K(0,f.IFileService),K(1,l.IUserDataSyncStoreService),K(2,l.IUserDataSyncBackupStoreService),K(3,l.IUserDataSyncLogService),K(4,b.IEnvironmentService),K(5,l.IUserDataSyncEnablementService),K(6,m.ITelemetryService),K(7,P.IConfigurationService),K(8,h.IStorageService),K(9,g.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends y.AbstractInitializer{constructor(v,I,_,O,M){super("globalState",_,O,I,M);this.storageService=v}async doInitialize(v){const I=v.syncData?JSON.parse(v.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const M of Object.keys(I.storage))M.startsWith(i)?_[M.substring(i.length)]=I.storage[M].value:this.storageService.get(M,0)===void 0&&(O[M]=I.storage[M].value);if(Object.keys(_).length){let M="{}";try{M=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const D of Object.keys(_))M=(0,w.edit)(M,[D],_[D],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(M))}if(Object.keys(O).length)for(const M of Object.keys(O))this.storageService.store(M,O[M],0,0)}};o=he([K(0,h.IStorageService),K(1,f.IFileService),K(2,b.IEnvironmentService),K(3,l.IUserDataSyncLogService),K(4,g.IUriIdentityService)],o),e.GlobalStateInitializer=o;let a=class{constructor(v,I,_,O,M){this.userDataSyncStoreClient=v,this.storageService=I,this.environmentService=_,this.fileService=O,this.logService=M}getSyncStoreType(v){return this.parseGlobalState(v)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(v){const I=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(v,I)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(v,I)}throw _}}async doSync(v,I){const _=await this.userDataSyncStoreClient.read("globalState",null,I),O=this.parseGlobalState(_)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:v,version:n};const M=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),D={version:n,machineId:M,content:r(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(D),_.ref,I)}parseGlobalState({content:v}){if(!v)return null;const I=JSON.parse(v);if((0,y.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};a=he([K(1,h.IStorageService),K(2,b.IEnvironmentService),K(3,f.IFileService),K(4,p.ILogService)],a),e.UserDataSyncStoreTypeSynchronizer=a}),define(ne[230],ie([0,1,16,17,3,35,4,15,144,19,14,11,23,20,32,45,225,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function y(l,i,c){try{const r=JSON.parse(l);if(!i)return(0,R.isUndefined)(r.all)?null:r.all;switch(A.OS){case 2:return(0,R.isUndefined)(r.mac)?null:r.mac;case 3:return(0,R.isUndefined)(r.linux)?null:r.linux;case 1:return(0,R.isUndefined)(r.windows)?null:r.windows}}catch(r){return c.error(r),null}}e.getKeybindingsContentFromSyncContent=y;let w=class extends h.AbstractJsonFileSynchroniser{constructor(i,c,r,n,s,o,a,u,v,I,_){super(a.keybindingsResource,"keybindings",o,a,u,i,c,s,I,r,v,n,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(n.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,c,r,n){const s=i.syncData?y(i.syncData.content,n.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;c=c===null&&r?i:c;const o=c?this.getKeybindingsContentFromLastSyncUserData(c):null,a=await this.getLocalFileContent(),u=await this.getFormattingOptions();let v=null,I=!1,_=!1,O=!1;if(s){let D=a?a.value.toString():"[]";if(D=D||"[]",this.hasErrors(D))throw new g.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==D||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const U=await(0,m.merge)(D,s,o,u,this.userDataSyncUtilService);U.hasChanges&&(v=U.mergeContent,O=U.hasConflicts,I=O||U.mergeContent!==D,_=O||U.mergeContent!==s)}}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=a.value.toString(),_=!0);const M={content:v,localChange:I?a?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const c=this.getKeybindingsContentFromLastSyncUserData(i);if(c===null)return!0;const r=await this.getLocalFileContent(),n=r?r.value.toString():"",s=await this.getFormattingOptions(),o=await(0,m.merge)(n||"[]",c,c,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==c}async getMergeResult(i,c){return i.previewResult}async getAcceptResult(i,c,r,n){if(this.extUri.isEqual(c,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(i,c,r,n){const{fileContent:s}=r[0][0];let{content:o,localChange:a,remoteChange:u}=r[0][1];if(a===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new g.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const v=this.toSyncContent(o||"[]",i.syncData?.content);i=await this.updateRemoteUserData(v,n?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const c=(0,T.parse)(i.value.toString());if((0,k.isNonEmptyArray)(c))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:c}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let c=await super.resolveContent(i);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(i)),c){const r=this.parseSyncData(c);if(r)switch(this.extUri.basename(i)){case"keybindings.json":return y(r.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:y(i.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(i,c){let r={};try{r=JSON.parse(c||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=i,A.OS){case 2:r.mac=i;break;case 3:r.linux=i;break;case 1:r.windows=i;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};w=he([K(0,g.IUserDataSyncStoreService),K(1,g.IUserDataSyncBackupStoreService),K(2,g.IUserDataSyncLogService),K(3,E.IConfigurationService),K(4,g.IUserDataSyncEnablementService),K(5,b.IFileService),K(6,P.IEnvironmentService),K(7,f.IStorageService),K(8,g.IUserDataSyncUtilService),K(9,p.ITelemetryService),K(10,d.IUriIdentityService)],w),e.KeybindingsSynchroniser=w;let S=class extends h.AbstractInitializer{constructor(i,c,r,n){super("keybindings",c,r,i,n)}async doInitialize(i){const c=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!c){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,t.VSBuffer.fromString(c)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),c=(0,T.parse)(i.value.toString());return!(0,k.isNonEmptyArray)(c)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return y(i,!0,this.logService)}catch(c){return this.logService.error(c),null}}};S=he([K(0,b.IFileService),K(1,P.IEnvironmentService),K(2,g.IUserDataSyncLogService),K(3,d.IUriIdentityService)],S),e.KeybindingsInitializer=S}),define(ne[231],ie([0,1,16,35,70,49,28,53,24]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(o,a,u){let v=[];u?v=b(u):v=P(a);const I=[],_=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const O of v)O.startsWith("-")?_.push(O.substring(1)):I.push(O);return(0,k.distinct)([...o,...I].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function P(o){let a=o.inspect("settingsSync.ignoredSettings").userValue;return a!==void 0||(a=o.inspect("sync.ignoredSettings").userValue,a!==void 0)?a:o.getValue("settingsSync.ignoredSettings")||[]}function b(o){const a=(0,t.parse)(o);return a?a["settingsSync.ignoredSettings"]||a["sync.ignoredSettings"]||[]:[]}function f(o,a,u,v){if(u.length){const I=s(a),_=(0,t.parse)(a),O=(0,t.parse)(o),M=[];for(const D of u){const U=_[D],F=O[D];U===void 0?o=R.edit(o,[D],void 0,v):F!==void 0?o=R.edit(o,[D],U,v):M.push(l(D,I))}M.sort((D,U)=>D.startOffset-U.startOffset),M.forEach(D=>o=g(D.setting.key,a,o,v))}return o}e.updateIgnoredSettings=f;function p(o,a,u,v,I,_){const O=f(o,a,v,_),M=u!==O,D=u!==a;if(!M&&!D)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!D)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(D&&!M)return{conflictsSettings:[],localContent:f(a,o,v,_),remoteContent:null,hasConflicts:!1};if(u===null&&h(o)){const z=d(o,a,v)?null:f(a,o,v,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let U=o,F=a;const x=(0,t.parse)(o),q=(0,t.parse)(a),G=u?(0,t.parse)(u):null,te=v.reduce((z,V)=>(z.add(V),z),new Set),W=m(x,q,te),j=m(G,x,te),J=m(G,q,te),H=new Map,Q=new Set,Z=z=>{Q.add(z);const V=I.filter(({key:ee})=>ee===z)[0];V?(U=R.edit(U,[z],V.value,_),F=R.edit(F,[z],V.value,_)):H.set(z,{key:z,localValue:x[z],remoteValue:q[z]})};for(const z of j.removed.values())J.updated.has(z)?Z(z):F=R.edit(F,[z],void 0,_);for(const z of J.removed.values())Q.has(z)||(j.updated.has(z)?Z(z):U=R.edit(U,[z],void 0,_));for(const z of j.updated.values())Q.has(z)||(J.updated.has(z)?W.updated.has(z)&&Z(z):F=R.edit(F,[z],x[z],_));for(const z of J.updated.values())Q.has(z)||(j.updated.has(z)?W.updated.has(z)&&Z(z):U=R.edit(U,[z],q[z],_));for(const z of j.added.values())Q.has(z)||(J.added.has(z)?W.updated.has(z)&&Z(z):F=g(z,U,F,_));for(const z of J.added.values())Q.has(z)||(j.added.has(z)?W.updated.has(z)&&Z(z):U=g(z,F,U,_));const B=H.size>0||!d(U,F,v),N=B||!d(U,o,[]),$=B||!d(F,a,[]);return{localContent:N?U:null,remoteContent:$?F:null,conflictsSettings:[...H.values()],hasConflicts:B}}e.merge=p;function d(o,a,u){if(o===a)return!0;const v=(0,t.parse)(o),I=(0,t.parse)(a),_=u.reduce((D,U)=>(D.add(U),D),new Set),O=s(o).filter(D=>!(D.setting&&_.has(D.setting.key))),M=s(a).filter(D=>!(D.setting&&_.has(D.setting.key)));if(O.length!==M.length)return!1;for(let D=0;D<O.length;D++){const U=O[D],F=M[D];if(U.setting&&F.setting){if(U.setting.key!==F.setting.key||!A.equals(v[U.setting.key],I[U.setting.key]))return!1}else if(!U.setting&&!F.setting){if(U.value!==F.value)return!1}else return!1}return!0}e.areSame=d;function h(o){return o?s(o).length===0:!0}e.isEmpty=h;function m(o,a,u){const v=o?Object.keys(o).filter(D=>!u.has(D)):[],I=Object.keys(a).filter(D=>!u.has(D)),_=I.filter(D=>v.indexOf(D)===-1).reduce((D,U)=>(D.add(U),D),new Set),O=v.filter(D=>I.indexOf(D)===-1).reduce((D,U)=>(D.add(U),D),new Set),M=new Set;if(o)for(const D of v){if(O.has(D))continue;const U=o[D],F=a[D];A.equals(U,F)||M.add(D)}return{added:_,removed:O,updated:M}}function g(o,a,u,v){const I=(0,t.parse)(a),_=s(a),O=s(u),M=y(o,_,O);return w(u,o,I[o],M,O,v)}e.addSetting=g;function y(o,a,u){const v=a.findIndex(_=>_.setting?.key===o),I=a[v-1];if(I){if(I.setting){const O=l(I.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!0}}else{const O=i(v,a);if(O){const M=l(O.setting.key,u);if(M){const D=c(u.indexOf(M),u),U=r(a,O,a[v]);if(D){const F=r(u,M,D),x=n(U,F);return x?{index:u.indexOf(x),insertAfter:!0}:{index:u.indexOf(D),insertAfter:!1}}else{const F=r(u,M,u[u.length-1]),x=n(U,F);return x?{index:u.indexOf(x),insertAfter:!0}:{index:u.length-1,insertAfter:!0}}}}}const _=a[v+1];if(_)if(_.setting){const O=l(_.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!1}}else{const O=c(v,a);if(O){const M=l(O.setting.key,u);if(M){const D=i(u.indexOf(M),u),U=r(a,a[v],O);if(D){const F=r(u,D,M),x=n(U.reverse(),F.reverse());return x?{index:u.indexOf(x),insertAfter:!1}:{index:u.indexOf(D),insertAfter:!0}}else{const F=r(u,u[0],M),x=n(U.reverse(),F.reverse());return x?{index:u.indexOf(x),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:u.length-1,insertAfter:!0}}function w(o,a,u,v,I,_){let O;return v.index===-1?O=(0,L.setProperty)(o,[a],u,_):O=S(o,a,u,v,I,_).map(M=>(0,L.withFormatting)(o,M,_)[0]),(0,L.applyEdits)(o,O)}function S(o,a,u,v,I,_){const O=`${JSON.stringify(a)}: ${JSON.stringify(u)}`,M=(0,T.getEOL)(_,o),D=I[v.index];if(v.insertAfter){const U=[];if(D.setting)U.push({offset:D.endOffset,length:0,content:","+O});else{const F=c(v.index,I),x=i(v.index,I),q=x?.setting?.commaOffset;x&&q===void 0&&U.push({offset:x.endOffset,length:0,content:","});const G=q!==void 0&&q>D.endOffset;U.push({offset:G?q+1:D.endOffset,length:0,content:F?M+O+",":M+O})}return U}else{if(D.setting)return[{offset:D.startOffset,length:0,content:O+","}];const U=(I[v.index-1]&&!I[v.index-1].setting?M:"")+O+(c(v.index,I)?",":"")+M;return[{offset:D.startOffset,length:0,content:U}]}}function l(o,a){return a.filter(u=>u.setting?.key===o)[0]}function i(o,a){for(let u=o-1;u>=0;u--)if(a[u].setting)return a[u]}function c(o,a){for(let u=o+1;u<a.length;u++)if(a[u].setting)return a[u]}function r(o,a,u){const v=o.indexOf(a),I=o.indexOf(u);return o.filter((_,O)=>v<O&&O<I)}function n(o,a){if(o.length&&a.length){let u=0;for(;u<a.length&&u<o.length;u++)if(o[u].value!==a[u].value)return a[u-1];return a[u-1]}}function s(o){const a=[];let u=-1,v,I;const _={onObjectBegin:O=>{u++},onObjectProperty:(O,M,D)=>{u===0&&(v=M,I=O)},onObjectEnd:(O,M)=>{u--,u===0&&a.push({startOffset:v,endOffset:O+M,value:o.substring(v,O+M),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(O,M)=>{u++},onArrayEnd:(O,M)=>{u--,u===0&&a.push({startOffset:v,endOffset:O+M,value:o.substring(v,O+M),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(O,M,D)=>{u===0&&a.push({startOffset:v,endOffset:M+D,value:o.substring(v,M+D),setting:{key:I,commaOffset:void 0}})},onSeparator:(O,M,D)=>{if(u===0&&O===","){let U=a.length-1;for(;U>=0&&!a[U].setting;U--);const F=a[U];F&&a.splice(U,1,{startOffset:F.startOffset,endOffset:F.endOffset,value:F.value,setting:{key:F.setting.key,commaOffset:M}})}},onComment:(O,M)=>{u===0&&a.push({startOffset:O,endOffset:O+M,value:o.substring(O,O+M)})}};return(0,t.visit)(o,_),a}}),define(ne[232],ie([0,1,17,3,145,19,90,14,30,11,23,20,32,45,53,231,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function y(l){const i=JSON.parse(l);return g(i)?i:{settings:l}}e.parseSettingsSyncContent=y;let w=class extends p.AbstractJsonFileSynchroniser{constructor(i,c,r,n,s,o,a,u,v,I,_,O){super(c.settingsResource,"settings",i,c,r,n,s,v,I,o,a,u,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(i){const c=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(i,c),n=this.getSettingsSyncContent(r),s=new A.ConfigurationModelParser(m.USER_DATA_SYNC_CONFIGURATION_SCOPE);return n?.settings&&s.parse(n.settings),s.configurationModel.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(i,c,r){const n=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(i);c=c===null&&r?i:c;const a=c?this.getSettingsSyncContent(c):null,u=await this.getIgnoredSettings();let v=null,I=!1,_=!1,O=!1;if(o){let D=n?n.value.toString().trim():"{}";D=D||"{}",this.validateContent(D),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const U=(0,h.merge)(D,o.settings,a?a.settings:null,u,[],s);v=U.localContent||U.remoteContent,I=U.localContent!==null,_=U.remoteContent!==null,O=U.hasConflicts}else n&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),v=n.value.toString(),_=!0);const M={content:v,localChange:I?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:n,localResource:this.localResource,localContent:n?n.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(i){const c=this.getSettingsSyncContent(i);if(c===null)return!0;const r=await this.getLocalFileContent(),n=r?r.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,h.merge)(n||"{}",c.settings,c.settings,s,[],o).remoteContent!==null}async getMergeResult(i,c){const r=await this.getFormattingOptions(),n=await this.getIgnoredSettings();return{...i.previewResult,content:i.previewResult.content?(0,h.updateIgnoredSettings)(i.previewResult.content,"{}",n,r):null}}async getAcceptResult(i,c,r,n){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(c,this.localResource))return{content:i.fileContent?(0,h.updateIgnoredSettings)(i.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(c,this.remoteResource))return{content:i.remoteContent!==null?(0,h.updateIgnoredSettings)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(c,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r!==null?(0,h.updateIgnoredSettings)(r,i.fileContent?i.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(i,c,r,n){const{fileContent:s}=r[0][0];let{content:o,localChange:a,remoteChange:u}=r[0][1];if(a===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,n),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),u!==0){const v=await this.getFormattingOptions(),I=this.getSettingsSyncContent(i),_=await this.getIgnoredSettings(o);o=(0,h.updateIgnoredSettings)(o,I?I.settings:"{}",_,v),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),i=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),n?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}c?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(i),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const c=await this.getFormattingOptions(),r=(0,d.edit)(i.value.toString(),[m.CONFIGURATION_SYNC_STORE_KEY],void 0,c);return!(0,h.isEmpty)(r)}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const c=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"settings.json"),comparableResource:c}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let c=await super.resolveContent(i);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(i)),c){const r=this.parseSyncData(c);if(r){const n=this.parseSettingsSyncContent(r.content);if(n)switch(this.extUri.basename(i)){case"settings.json":return n.settings}}}return null}async resolvePreviewContent(i){let c=await super.resolvePreviewContent(i);if(c){const r=await this.getFormattingOptions(),n=await this.getIgnoredSettings();c=(0,h.updateIgnoredSettings)(c,"{}",n,r)}return c}getSettingsSyncContent(i){return i.syncData?this.parseSettingsSyncContent(i.syncData.content):null}parseSettingsSyncContent(i){try{return y(i)}catch(c){this.logService.error(c)}return null}toSettingsSyncContent(i){return{settings:i}}async getIgnoredSettings(i){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=t.Event.any(t.Event.filter(this.extensionManagementService.onDidInstallExtensions,n=>n.some(({local:s})=>!!s)),t.Event.filter(this.extensionManagementService.onDidUninstallExtension,n=>!n.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const c=await this._defaultIgnoredSettings;return(0,h.getIgnoredSettings)(c,this.configurationService,i)}validateContent(i){if(this.hasErrors(i))throw new m.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};w=he([K(0,E.IFileService),K(1,R.IEnvironmentService),K(2,P.IStorageService),K(3,m.IUserDataSyncStoreService),K(4,m.IUserDataSyncBackupStoreService),K(5,m.IUserDataSyncLogService),K(6,m.IUserDataSyncUtilService),K(7,T.IConfigurationService),K(8,m.IUserDataSyncEnablementService),K(9,b.ITelemetryService),K(10,C.IExtensionManagementService),K(11,f.IUriIdentityService)],w),e.SettingsSynchroniser=w;let S=class extends p.AbstractInitializer{constructor(i,c,r,n){super("settings",c,r,i,n)}async doInitialize(i){const c=i.syncData?this.parseSettingsSyncContent(i.syncData.content):null;if(!c){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(c.settings)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource);return(0,h.isEmpty)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}parseSettingsSyncContent(i){try{return y(i)}catch(c){this.logService.error(c)}return null}};S=he([K(0,E.IFileService),K(1,R.IEnvironmentService),K(2,m.IUserDataSyncLogService),K(3,f.IUriIdentityService)],S),e.SettingsInitializer=S}),define(ne[233],ie([0,1,17,3,28,19,14,11,23,20,32,45,226,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let d=class extends b.AbstractSynchroniser{constructor(g,y,w,S,l,i,c,r,n,s){super("snippets",y,g,w,S,l,r,n,i,c,s);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(t.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,y,w){const S=await this.getSnippetsFileContents(),l=this.toSnippetsContents(S),i=g.syncData?this.parseSnippets(g.syncData):null;y=y===null&&w?g:y;const c=y&&y.syncData?this.parseSnippets(y.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,f.merge)(l,i,c);return this.getResourcePreviews(r,S,i||{})}async hasRemoteChanged(g){const y=g.syncData?this.parseSnippets(g.syncData):null;if(y===null)return!0;const w=await this.getSnippetsFileContents(),S=this.toSnippetsContents(w),l=(0,f.merge)(S,y,y);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(g,y){return g.previewResult}async getAcceptResult(g,y,w,S){if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(y,this.syncPreviewFolder))return w===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:w,localChange:w===null?g.fileContent!==null?3:0:2,remoteChange:w===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${y.toString()}`)}async applyResult(g,y,w,S){const l=w.map(([i,c])=>({...i,acceptResult:c}));l.every(({localChange:i,remoteChange:c})=>i===0&&c===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,S)),l.some(({remoteChange:i})=>i!==0)&&(g=await this.updateRemoteSnippets(l,g,S)),y?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of l)try{await this.fileService.del(i)}catch{}}getResourcePreviews(g,y,w){const S=new Map;for(const l of Object.keys(g.local.added)){const i={content:g.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};S.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.local.updated)){const i={content:g.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l],localContent:y[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l],localContent:y[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.added)){const i={content:g.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l],localContent:y[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.updated)){const i={content:g.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l],localContent:y[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.conflicts){const i={content:y[l]?y[l].value.toString():null,hasConflicts:!0,localChange:y[l]?2:1,remoteChange:w[l]?2:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l]||null,localContent:y[l]?y[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(y))if(!S.has(l)){const i={content:y[l]?y[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:y[l]||null,localContent:y[l]?y[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:g}){let y=await super.resolveContent(g);if(y){const w=this.parseSyncData(y);if(w){const S=this.parseSnippets(w),l=[];for(const i of Object.keys(S)){const c=this.extUri.joinPath(g,i),r=this.extUri.joinPath(this.snippetsFolder,i),n=await this.fileService.exists(r);l.push({resource:c,comparableResource:n?r:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let y=await super.resolveContent(g);if(y)return y;if(y=await super.resolveContent(this.extUri.dirname(g)),y){const w=this.parseSyncData(y);if(w)return this.parseSnippets(w)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const y={};for(const w of g)w.fileContent&&(y[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(y)))}async updateLocalSnippets(g,y){for(const{fileContent:w,acceptResult:S,localResource:l,remoteResource:i,localChange:c}of g)if(c!==0){const r=i?this.extUri.basename(i):this.extUri.basename(l),n=this.extUri.joinPath(this.snippetsFolder,r);c===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):c===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,k.VSBuffer.fromString(S.content),{overwrite:y}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,k.VSBuffer.fromString(S.content),y?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(g,y,w){const S=y.syncData?this.parseSnippets(y.syncData):{},l=(0,L.deepClone)(S);for(const{acceptResult:i,localResource:c,remoteResource:r,remoteChange:n}of g)if(n!==0){const s=c?this.extUri.basename(c):this.extUri.basename(r);n===3?delete l[s]:l[s]=i.content}return(0,f.areSame)(S,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),y=await this.updateRemoteUserData(JSON.stringify(l),w?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),y}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const y={};for(const w of Object.keys(g))y[w]=g[w].value.toString();return y}async getSnippetsFileContents(){const g={};let y;try{y=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof R.FileOperationError&&w.fileOperationResult===1)return g;throw w}for(const w of y.children||[]){const S=w.resource,l=this.extUri.extname(S);if(l===".json"||l===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,S),c=await this.fileService.readFile(S);g[i]=c}}return g}};d=he([K(0,A.IEnvironmentService),K(1,R.IFileService),K(2,C.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncBackupStoreService),K(5,p.IUserDataSyncLogService),K(6,T.IConfigurationService),K(7,p.IUserDataSyncEnablementService),K(8,E.ITelemetryService),K(9,P.IUriIdentityService)],d),e.SnippetsSynchroniser=d;let h=class extends b.AbstractInitializer{constructor(g,y,w,S){super("snippets",y,w,g,S)}async doInitialize(g){const y=g.syncData?JSON.parse(g.syncData.content):null;if(!y){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(y)){const l=y[S];if(l){const i=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(i,k.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};h=he([K(0,R.IFileService),K(1,A.IEnvironmentService),K(2,p.IUserDataSyncLogService),K(3,P.IUriIdentityService)],h),e.SnippetsInitializer=h}),define(ne[234],ie([0,1,17,19,14,11,23,20,32,45,24]),function(Y,e,k,t,L,T,A,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function b(h,m){try{return JSON.parse(h).tasks}catch(g){return m.error(g),null}}e.getTasksContentFromSyncContent=b;let f=class extends E.AbstractFileSynchroniser{constructor(m,g,y,w,S,l,i,c,r,n){super(n.extUri.joinPath(n.extUri.dirname(i.settingsResource),"tasks.json"),"tasks",l,i,c,m,g,S,r,y,w,n);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:P.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(m,g,y,w){const S=m.syncData?b(m.syncData.content,this.logService):null;g=g===null&&y?m:g;const l=g?.syncData?b(g.syncData.content,this.logService):null,i=await this.getLocalFileContent();let c=null,r=!1,n=!1,s=!1;if(S){const a=i?i.value.toString():null;if(!l||l!==a||l!==S){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const u=d(a,S,l);c=u.content,s=u.hasConflicts,r=u.hasLocalChanged,n=u.hasRemoteChanged}}else i&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),c=i.value.toString(),n=!0);const o={content:c,localChange:r?i?2:1:0,remoteChange:n?2:0,hasConflicts:s};return[{fileContent:i,localResource:this.localResource,localContent:i?i.value.toString():null,localChange:o.localChange,remoteResource:this.remoteResource,remoteContent:S,remoteChange:o.remoteChange,previewResource:this.previewResource,previewResult:o,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(m){const g=m?.syncData?b(m.syncData.content,this.logService):null;if(g===null)return!0;const y=await this.getLocalFileContent(),w=y?y.value.toString():null,S=d(w,g,g);return S.hasLocalChanged||S.hasRemoteChanged}async getMergeResult(m,g){return m.previewResult}async getAcceptResult(m,g,y,w){if(this.extUri.isEqual(g,this.localResource))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:m.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return y===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:y,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(m,g,y,w){const{fileContent:S}=y[0][0];let{content:l,localChange:i,remoteChange:c}=y[0][1];if(i===0&&c===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),i!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),S&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(S.value.toString()))),await this.updateLocalFileContent(l||"{}",S,w),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),c!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const r=JSON.stringify(this.toTasksSyncContent(l||"{}"));m=await this.updateRemoteUserData(r,w?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:m}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(m,"tasks.json"),comparableResource:g}]}async resolveContent(m){if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m))return this.resolvePreviewContent(m);let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const y=this.parseSyncData(g);if(y)switch(this.extUri.basename(m)){case"tasks.json":return b(y.content,this.logService)}}return null}toTasksSyncContent(m){return{tasks:m}}};f=he([K(0,P.IUserDataSyncStoreService),K(1,P.IUserDataSyncBackupStoreService),K(2,P.IUserDataSyncLogService),K(3,t.IConfigurationService),K(4,P.IUserDataSyncEnablementService),K(5,T.IFileService),K(6,L.IEnvironmentService),K(7,A.IStorageService),K(8,R.ITelemetryService),K(9,C.IUriIdentityService)],f),e.TasksSynchroniser=f;let p=class extends E.AbstractInitializer{constructor(m,g,y,w){super("tasks",g,y,m,w);this.uriIdentityService=w,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(m){const g=m.syncData?b(m.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,k.VSBuffer.fromString(g)),await this.updateLastSyncUserData(m)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};p=he([K(0,T.IFileService),K(1,L.IEnvironmentService),K(2,P.IUserDataSyncLogService),K(3,C.IUriIdentityService)],p),e.TasksInitializer=p;function d(h,m,g){if(h===null&&m===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(h===m)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const y=g!==h,w=g!==m;return!y&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:y&&!w?{content:h,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!y?{content:m,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:h,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[65],ie([0,1,3,2,6,24]),function(Y,e,k,t,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends t.Disposable{constructor(C,E){super();this.userDataSyncStoreService=C,this.logService=E,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};A=he([K(0,T.IUserDataSyncStoreService),K(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[235],ie([0,1,5,17,57,2,21,19,14,11,24]),function(Y,e,k,t,L,T,A,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let b=class extends T.Disposable{constructor(p,d,h,m){super();this.environmentService=p,this.fileService=d,this.configurationService=h,this.logService=m,P.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(p){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),h=await this.fileService.resolve(d);return h.children?h.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(p,d){if(!d){const h=await this.getAllRefs(p);h.length&&(d=h[h.length-1].ref)}if(d){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,p,d);return(await this.fileService.readFile(h)).value.toString()}return null}async backup(p,d){const h=(0,A.joinPath)(this.environmentService.userDataSyncHome,p),m=(0,A.joinPath)(h,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(m,t.VSBuffer.fromString(d))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(p)}catch{}}async cleanUpBackup(p){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(d))return}catch{return}const h=await this.fileService.resolve(d);if(h.children){const m=h.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=m.filter(S=>Date.now()-this.getCreationTime(S)>g);const w=m.length-y.length;w<10&&(y=y.slice(10-w)),await k.Promises.settled(y.map(async S=>{this.logService.info("Deleting from backup",S.resource.path),await this.fileService.del(S.resource)}))}}catch(h){this.logService.error(h)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};b=he([K(0,C.IEnvironmentService),K(1,E.IFileService),K(2,R.IConfigurationService),K(3,P.IUserDataSyncLogService)],b),e.UserDataSyncBackupStoreService=b}),define(ne[236],ie([0,1,3,2,4,14,23,20,24]),function(Y,e,k,t,L,T,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let P=class extends t.Disposable{constructor(f,p,d,h){super();this.storageService=f,this.telemetryService=p,this.environmentService=d,this.userDataSyncStoreManagementService=h,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(m=>this.onDidStorageChange(m)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:f}),this.storageService.store(E,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,C.getEnablementKey)(f),0,!0)}setResourceEnablement(f,p){if(this.isResourceEnabled(f)!==p){const d=(0,C.getEnablementKey)(f);this.telemetryService.publicLog2(d,{enabled:p}),this.storeResourceEnablement(d,p)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,p){this.storageService.store(f,p,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(E===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=C.ALL_SYNC_RESOURCES.filter(d=>(0,C.getEnablementKey)(d)===f.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};P=he([K(0,A.IStorageService),K(1,R.ITelemetryService),K(2,T.IEnvironmentService),K(3,C.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ne[237],ie([0,1,2,7]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(f,p,d){switch(p){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(f){this.service=f}listen(f,p){throw new Error(`Event not found: ${p}`)}call(f,p,d){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(t.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(f,p,d){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class C{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(f,p,d){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class E{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(f,p,d){switch(p){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class P extends k.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:t.URI.revive(f.url),type:f.type,defaultUrl:t.URI.revive(f.defaultUrl),insidersUrl:t.URI.revive(f.insidersUrl),stableUrl:t.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ne[238],ie([0,1,14,8]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends t.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};L=he([K(0,t.ILoggerService),K(1,k.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(ne[66],ie([0,1,3,2,4,26,148,14,11,6,27,47,23,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",h="Safari",m="Chrome",g="Edge",y="Firefox",w="Android";function S(c){switch(c){case h:case m:case g:case y:case w:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=S;function l(){return L.isSafari?h:L.isChrome?m:L.isEdge?g:L.isFirefox?y:L.isAndroid?w:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let i=class Ze extends t.Disposable{constructor(r,n,s,o,a,u){super();this.storageService=s,this.userDataSyncStoreService=o,this.logService=a,this.productService=u,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(r,n,s)}async getMachines(r){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(r)).machines.map(o=>({...o,isCurrent:o.id===n}))}async addCurrentMachine(r){const n=await this.currentMachineIdPromise,s=await this.readMachinesData(r);s.machines.some(({id:o})=>o===n)||(s.machines.push({id:n,name:this.computeCurrentMachineName(s.machines),platform:l()}),await this.writeMachinesData(s))}async removeCurrentMachine(r){const n=await this.currentMachineIdPromise,s=await this.readMachinesData(r),o=s.machines.filter(({id:a})=>a!==n);o.length!==s.machines.length&&(s.machines=o,await this.writeMachinesData(s))}async renameMachine(r,n,s){const o=await this.readMachinesData(s),a=o.machines.find(({id:u})=>u===r);if(a){a.name=n,await this.writeMachinesData(o);const u=await this.currentMachineIdPromise;r===u&&this.storageService.store(d,n,0,1)}}async setEnablements(r){const n=await this.readMachinesData();for(const[s,o]of r){const a=n.machines.find(u=>u.id===s);a&&(a.disabled=o?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(r){const n=this.storageService.get(d,0);if(n)return n;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,o=new RegExp(`${(0,T.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const u of r){const v=o.exec(u.name),I=v?parseInt(v[1]):0;a=I>a?I:a}return`${s} #${a+1}`}async readMachinesData(r){this.userData=await this.readUserData(r);const n=this.parse(this.userData);if(n.version!==Ze.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(r){const n=JSON.stringify(r),s=await this.userDataSyncStoreService.write(Ze.RESOURCE,n,this.userData?.ref||null);this.userData={ref:s,content:n},this._onDidChange.fire()}async readUserData(r){if(this.userData){const n=r&&r.latest?r.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(r){if(r.content!==null)try{return JSON.parse(r.content)}catch(n){this.logService.error(n)}return{version:Ze.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=he([K(0,R.IEnvironmentService),K(1,C.IFileService),K(2,f.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncLogService),K(5,P.IProductService)],i),e.UserDataSyncMachinesService=i}),define(ne[239],ie([0,1,5,57,37,9,3,2,4,21,7,146,27,23,20,24,65,66]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const y="sync.disableMachineEventually",w="sync.sessionId",S="sync.storeUrl",l="sync.productQuality";let i=class extends R.Disposable{constructor(n,s,o,a,u,v,I,_,O,M){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=a,this.userDataSyncService=u,this.logService=v,this.userDataSyncAccountService=I,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=M,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new k.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(u.onDidChangeLocal(D=>this.triggerSync([D],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,D])=>D)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const n=this.storageService.get(S,0);return n?P.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(S,n.toString(),0,1):this.storageService.remove(S,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(n){n?this.storageService.store(l,n,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:n,message:s}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new c(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,t.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(w,0),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(s)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const s=h.UserDataSyncError.toUserDataSyncError(n);s instanceof h.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?C.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(y,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(y,0,!1)}stopDisableMachineEventually(){this.storageService.remove(y,0)}async triggerSync(n,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=he([K(0,f.IProductService),K(1,h.IUserDataSyncStoreManagementService),K(2,h.IUserDataSyncStoreService),K(3,h.IUserDataSyncEnablementService),K(4,h.IUserDataSyncService),K(5,h.IUserDataSyncLogService),K(6,m.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,g.IUserDataSyncMachinesService),K(9,p.IStorageService)],i),e.UserDataAutoSyncService=i;class c extends R.Disposable{constructor(n,s,o,a,u,v,I,_){super();this.lastSyncUrl=n,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=a,this.userDataSyncService=u,this.userDataSyncMachinesService=v,this.logService=I,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(c.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(c.INTERVAL_SYNCING,!1),this.interval)}sync(n,s){const o=(0,k.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,T.isCancellationError)(u))return}return this.doSync(n,s,a)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!n&&(!(0,E.isEqual)(s.defaultUrl,n.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,n.insidersUrl)||!(0,E.isEqual)(s.stableUrl,n.stableUrl))}async doSync(n,s,o){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new h.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new h.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new h.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const u=this.storageService.get(w,0);if(u&&this.manifest&&u!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new h.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new h.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new h.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const I=v.find(_=>_.isCurrent);if(I?.disabled)throw new h.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new h.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof h.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==u&&this.storageService.store(w,this.manifest.session,0,1),o.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(u){this.logService.error(u),a=u}this._onDidFinishSync.fire(a)}register(n){return super._register(n)}}c.INTERVAL_SYNCING="Interval"}),define(ne[240],ie([0,1,16,5,37,3,2,21,15,29,19,30,6,23,20,227,229,230,232,233,234,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let c=class extends A.Disposable{constructor(a,u,v,I,_,O,M,D){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=u,this.instantiationService=v,this.configurationService=I,this.logService=_,this.telemetryService=O,this.storageService=M,this.userDataSyncEnablementService=D,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(i,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,u){this.checkEnablement();const v=(0,E.generateUuid)();try{const D=(0,l.createSyncHeaders)(v);u&&(D["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,D)}catch(D){const U=l.UserDataSyncError.toUserDataSyncError(D);throw this.reportUserDataSyncError(U,v),U}let I=!1;const _=this,O=this.getEnabledSynchronizers();let M;return{manifest:a,async run(){if(I)throw new Error("Can run a task only once");return M=(0,t.createCancelablePromise)(D=>_.sync(O,a,v,D)),M.finally(()=>M=void 0)},async stop(){if(M&&M.cancel(),_.status!=="idle")return _.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new l.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,E.generateUuid)(),u=(0,l.createSyncHeaders)(a);let v;try{v=await this.userDataSyncStoreService.manifest(null,u)}catch(_){const O=l.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(O,a),O}await this.resetLocal();const I=this.getEnabledSynchronizers();return new r(a,v,u,I,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(a,u,v,I){if(I.isCancellationRequested||!a.length)return;const _=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,l.createSyncHeaders)(v);for(const M of a){if(I.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(M.resource))return;try{await M.sync(u,O)}catch(D){let U=!1;if(D instanceof l.UserDataSyncError)switch(D.code){case"TooLarge":D=new l.UserDataSyncError(D.message,D.code,M.resource),U=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":U=!0;break}const F=l.UserDataSyncError.toUserDataSyncError(D);if(this.reportUserDataSyncError(F,v),U)throw F;this.logService.error(D),this.logService.error(`${M.resource}: ${(0,L.toErrorMessage)(D)}`),this._syncErrors.push([M.resource,F])}}this.logService.info(`Sync done. Took ${new Date().getTime()-_}ms`),this.updateLastSyncTime()}catch(O){const M=l.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(M,v),M}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const u of a)try{u.status!=="idle"&&await u.stop()}catch(v){this.logService.error(v)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async u=>{if(await u.replace(a))return!0})}async accept(a,u,v,I){this.checkEnablement(),await this.performSynchronizerAction(async _=>{if(_.resource===a)return await _.accept(u,v),I&&await _.apply(!1,(0,l.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async u=>{const v=await u.resolveContent(a);if(v)return v})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async v=>{if(v.resource===a)return v.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async v=>{if(v.resource===a)return v.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,u){return await this.performSynchronizerAction(async I=>{if(I.resource===a)return I.getAssociatedResources(u)})||[]}async getMachineId(a,u){return await this.performSynchronizerAction(async I=>{if(I.resource===a)return await I.getMachineId(u)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async u=>{if(u.resource!=="globalState"&&await u.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async u=>{if(await u.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(i,0),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(u){this.logService.error(`${a.resource}: ${(0,L.toErrorMessage)(u)}`),this.logService.error(u)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const u=new A.DisposableStore;try{const v=this.synchronizers.value||u.add(this.instantiationService.createInstance(n,()=>{},()=>{},()=>{})),I=[...v.enabled,...v.disabled.map(_=>u.add(v.createSynchronizer(_)))];for(const _ of I){const O=await a(_);if(!(0,C.isUndefined)(O))return O}return null}finally{u.dispose()}}setStatus(a){const u=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),u==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const u=this.computeStatus(a);this.setStatus(u)}updateConflicts(a){const u=this.computeConflicts(a);(0,k.equals)(this._conflicts,u,([v,I],[_,O])=>v===v&&(0,k.equals)(I,O,(M,D)=>(0,R.isEqual)(M.previewResource,D.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(u))}computeConflicts(a){return a.filter(u=>u.status==="hasConflicts").map(u=>[u.resource,u.conflicts.map(s)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(u=>u.status==="hasConflicts")?"hasConflicts":a.some(u=>u.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(i,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,u){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof l.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof l.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:u,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(n,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([K(0,l.IUserDataSyncStoreService),K(1,l.IUserDataSyncStoreManagementService),K(2,f.IInstantiationService),K(3,P.IConfigurationService),K(4,l.IUserDataSyncLogService),K(5,d.ITelemetryService),K(6,p.IStorageService),K(7,l.IUserDataSyncEnablementService)],c),e.UserDataSyncService=c;class r extends A.Disposable{constructor(a,u,v,I,_,O,M){super();this.id=a,this.manifest=u,this.syncHeaders=v,this.synchronisers=I,this.onStop=_,this.configurationService=O,this.logService=M,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,t.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,u){try{return await this.performAction(a,v=>v.accept(a,u))}catch(v){throw this.logService.error(v),v}}async merge(a){try{return a?await this.performAction(a,u=>u.merge(a)):await this.mergeAll()}catch(u){throw this.logService.error(u),u}}async discard(a){try{return await this.performAction(a,u=>u.discard(a))}catch(u){throw this.logService.error(u),u}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,u]of this.previews)for(const v of u.resourcePreviews)v.mergeState==="conflict"&&a.push(v.previewResource);for(const u of a)await this.discard(u);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[u,v]of this.previews){this.synchronizingResources.push([u,v.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const I=this.synchronisers.find(O=>O.resource===u);for(const O of v.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await I.merge(O.previewResource);const _=await I.apply(!1,this.syncHeaders);_&&a.push(this.toSyncResourcePreview(I.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(I=>I.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(I=>I.resource===a);for(const I of u.resourcePreviews)await v.accept(I.remoteResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(I=>I[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,u]of this.previews){this.synchronizingResources.push([a,u.resourcePreviews.map(I=>I.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(I=>I.resource===a);for(const I of u.resourcePreviews)await v.accept(I.localResource);await v.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(I=>I[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,u){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const v=this.previews.findIndex(([,x])=>x.resourcePreviews.some(({localResource:q,previewResource:G,remoteResource:te})=>(0,R.isEqual)(a,q)||(0,R.isEqual)(a,G)||(0,R.isEqual)(a,te)));if(v===-1)return this.previews;const[I,_]=this.previews[v],O=_.resourcePreviews.find(({localResource:x,remoteResource:q,previewResource:G})=>(0,R.isEqual)(x,a)||(0,R.isEqual)(q,a)||(0,R.isEqual)(G,a));if(!O)return this.previews;let M=this.synchronizingResources.find(x=>x[0]===I);M||(M=[I,[]],this.synchronizingResources.push(M)),M[1].some(x=>(0,R.isEqual)(x,O.localResource))||(M[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const D=this.synchronisers.find(x=>x.resource===this.previews[v][0]),U=await u(D);U?this.previews.splice(v,1,this.toSyncResourcePreview(D.resource,U)):this.previews.splice(v,1);const F=this.synchronizingResources.findIndex(x=>x[0]===I);return this.synchronizingResources[F][1].splice(M[1].findIndex(x=>(0,R.isEqual)(x,O.localResource)),1),M[1].length||(this.synchronizingResources.splice(F,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[u,v]of this.previews){this.synchronizingResources.push([u,v.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const I=this.synchronisers.find(O=>O.resource===u);let _=v;for(const O of v.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(_=await I.merge(O.previewResource));_&&a.push(this.toSyncResourcePreview(I.resource,_)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const u=[],v=await this.getUserDataSyncConfiguration();for(const I of this.synchronisers){if(a.isCancellationRequested)return[];const _=await I.preview(this.manifest,v,this.syncHeaders);_&&u.push(this.toSyncResourcePreview(I.resource,_))}return u}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE),u=await this.synchronisers.find(v=>v instanceof y.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...u}}toSyncResourcePreview(a,u){return[a,{isLastSyncFromCurrentMachine:u.isLastSyncFromCurrentMachine,resourcePreviews:u.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let n=class extends A.Disposable{constructor(a,u,v,I,_,O,M){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=u,this.onDidChangeLocal=v,this.userDataSyncEnablementService=I,this.instantiationService=_,this.extensionGalleryService=O,this.logService=M,this._enabled=[],this._register(I.onDidChangeResourceEnablement(([D,U])=>this.onDidChangeResourceEnablement(D,U))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,D])=>D.dispose())));for(const D of l.ALL_SYNC_RESOURCES)I.isResourceEnabled(D)&&this.registerSynchronizer(D)}get enabled(){return this._enabled.sort((a,u)=>a[1]-u[1]).map(([a])=>a)}get disabled(){return l.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,u){u?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([_])=>_.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const u=new A.DisposableStore,v=u.add(this.createSynchronizer(a));u.add(v.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),u.add(v.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),u.add(v.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const I=this.getOrder(a);this._enabled.push([v,I,u])}deRegisterSynchronizer(a){const u=this._enabled.findIndex(([v])=>v.resource===a);if(u!==-1){const v=this._enabled.splice(u,1);for(const[I,,_]of v){if(I.status!=="idle"){const O=I.conflicts.length>0;I.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}_.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(y.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(w.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(S.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(m.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(h.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};n=he([K(3,l.IUserDataSyncEnablementService),K(4,f.IInstantiationService),K(5,b.IExtensionGalleryService),K(6,l.IUserDataSyncLogService)],n);function s(o){return{localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(ne[241],ie([0,1,3,2,15,7,24]),function(Y,e,k,t,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(b,f){this.service=b,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(b,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(b,f,p){try{return await this._call(b,f,p)}catch(d){throw this.logService.error(d),d}}async _call(b,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],T.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const d=f.substring("manualSync/".length),h=p[0],m=this.getManualSyncTask(h);switch(p=p.slice(1),d){case"preview":return m.preview();case"accept":return m.accept(T.URI.revive(p[0]),p[1]);case"merge":return m.merge(T.URI.revive(p[0]));case"discard":return m.discard(T.URI.revive(p[0]));case"discardConflicts":return m.discardConflicts();case"apply":return m.apply();case"pull":return m.pull();case"push":return m.push();case"stop":return m.stop();case"_getStatus":return m.status;case"dispose":return this.disposeManualSyncTask(m)}}throw new Error("Invalid call")}getManualSyncTask(b){const f=this.manualSyncTasks.get(this.createKey(b));if(!f)throw new Error(`Manual sync taks not found: ${b}`);return f.manualSyncTask}async createManualSyncTask(){const b=new t.DisposableStore,f=b.add(await this.service.createManualSyncTask());return b.add(f.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:p}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:b}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(b){b.dispose();const f=this.createKey(b.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(b){return`manualSyncTask-${b}`}}e.UserDataSyncChannel=R;class C extends t.Disposable{constructor(b){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,d){return b.call(f,p,d).then(null,h=>{throw A.UserDataSyncError.toUserDataSyncError(h)})},listen(f,p){return b.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,d])=>{this.updateStatus(f),this.updateConflicts(p),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([p,d])=>[p,A.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:b,manifest:f,status:p}=await this.channel.call("createManualSyncTask"),d=this,h=new E(b,f,p,{async call(m,g,y){return d.channel.call(`manualSync/${m}`,[b,...(0,L.isArray)(g)?g:[g]],y)},listen(m,g){return k.Event.map(k.Event.filter(d.channel.listen(`manualSync/${m}`,g),y=>!h.isDiposed()&&y.manualSyncTaskId===b),y=>y.data)}});return h}replace(b){return this.channel.call("replace",[b])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(b,f,p,d){return this.channel.call("accept",[b,f,p,d])}resolveContent(b){return this.channel.call("resolveContent",[b])}async getLocalSyncResourceHandles(b){return(await this.channel.call("getLocalSyncResourceHandles",[b])).map(({created:p,uri:d})=>({created:p,uri:T.URI.revive(d)}))}async getRemoteSyncResourceHandles(b){return(await this.channel.call("getRemoteSyncResourceHandles",[b])).map(({created:p,uri:d})=>({created:p,uri:T.URI.revive(d)}))}async getAssociatedResources(b,f){return(await this.channel.call("getAssociatedResources",[b,f])).map(({resource:d,comparableResource:h})=>({resource:T.URI.revive(d),comparableResource:T.URI.revive(h)}))}async getMachineId(b,f){return this.channel.call("getMachineId",[b,f])}async updateStatus(b){this._status=b,this._onDidChangeStatus.fire(b)}async updateConflicts(b){this._conflicts=b.map(([f,p])=>[f,p.map(d=>({...d,localResource:T.URI.revive(d.localResource),remoteResource:T.URI.revive(d.remoteResource),previewResource:T.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(b){this._lastSyncTime!==b&&(this._lastSyncTime=b,this._onDidChangeLastSyncTime.fire(b))}}e.UserDataSyncChannelClient=C;class E extends t.Disposable{constructor(b,f,p,d){super();this.id=b,this.manifest=f,this._disposed=!1,this._status=p;const h=this;this.channel={async call(m,g,y){try{const w=await d.call(m,g,y);return h.isDiposed()||(h._status=await d.call("_getStatus")),w}catch(w){throw A.UserDataSyncError.toUserDataSyncError(w)}},listen(m,g){return d.listen(m,g)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const b=await this.channel.call("preview");return this.deserializePreviews(b)}async accept(b,f){const p=await this.channel.call("accept",[b,f]);return this.deserializePreviews(p)}async merge(b){const f=await this.channel.call("merge",[b]);return this.deserializePreviews(f)}async discard(b){const f=await this.channel.call("discard",[b]);return this.deserializePreviews(f)}async discardConflicts(){const b=await this.channel.call("discardConflicts");return this.deserializePreviews(b)}async apply(){const b=await this.channel.call("apply");return this.deserializePreviews(b)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(b){return b.map(([f,p])=>[f,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(d=>({...d,localResource:T.URI.revive(d.localResource),remoteResource:T.URI.revive(d.remoteResource),previewResource:T.URI.revive(d.previewResource),acceptedResource:T.URI.revive(d.acceptedResource)}))}])}}}),define(ne[242],ie([0,1,5,25,9,3,2,102,4,21,15,7,29,19,14,11,27,43,47,23,24]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",i="sync.donot-make-requests-until",c="sync.user-session-id",r="sync.machine-session-id",n=100,s=1e3*60*5;let o=class extends A.Disposable{constructor(O,M,D){super();this.productService=O,this.configurationService=M,this.storageService=D,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(D.onDidChangeValue,U=>U.key===S.SYNC_SERVICE_URL_TYPE&&U.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(S.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(S.SYNC_SERVICE_URL_TYPE,O,0,C.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[S.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,M){O=C.isWeb&&O?.web?{...O,...O.web}:O;const D={...O||{},...M||{}};if(D&&(0,P.isString)(D.url)&&(0,P.isObject)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(U=>(0,P.isArray)(D.authenticationProviders[U].scopes))){const U=D,F=!!U.canSwitch&&!M?.url,x=U.url===U.insidersUrl?"insiders":"stable",q=(F?this.userDataSyncStoreType:void 0)||x,G=M?.url||(q==="insiders"?U.insidersUrl:q==="stable"?U.stableUrl:U.url);return{url:b.URI.parse(G),type:q,defaultType:x,defaultUrl:b.URI.parse(U.url),stableUrl:b.URI.parse(U.stableUrl),insidersUrl:b.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((te,W)=>(te.push({id:W,scopes:U.authenticationProviders[W].scopes}),te),[])}}}};o=he([K(0,m.IProductService),K(1,p.IConfigurationService),K(2,w.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let a=class extends o{constructor(O,M,D){super(O,M,D);const U=this.storageService.get(l,0);U&&(this.previousConfigurationSyncStore=JSON.parse(U));const F=this.productService[S.CONFIGURATION_SYNC_STORE_KEY];F?this.storageService.store(l,JSON.stringify(F),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=he([K(0,m.IProductService),K(1,p.IConfigurationService),K(2,w.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let u=class extends A.Disposable{constructor(O,M,D,U,F,x,q){super();this.requestService=D,this.logService=U,this.storageService=q,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,y.getServiceMachineId)(F,x,q).then(G=>{const te={"X-Client-Name":`${M.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(te["X-Client-Commit"]=M.commit),te}),this.session=new I(n,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,M){this.authToken={token:O,type:M}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(i,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(M=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),D={},U=await this.request(M.toString(),{type:"GET",headers:D},[],t.CancellationToken.None);return(await(0,g.asJson)(U)||[]).map(({url:x,created:q})=>({ref:(0,E.relativePath)(M,M.with({path:x})),created:q*1e3}))}async resolveContent(O,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,M).toString(),U={};U["Cache-Control"]="no-cache";const F=await this.request(D,{type:"GET",headers:U},[],t.CancellationToken.None);return await(0,g.asText)(F)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),D={};await this.request(M,{type:"DELETE",headers:D},[],t.CancellationToken.None)}async read(O,M,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();D={...D},D["Cache-Control"]="no-cache",M&&(D["If-None-Match"]=M.ref);const F=await this.request(U,{type:"GET",headers:D},[304],t.CancellationToken.None);let x=null;if(F.res.statusCode===304&&(x=M),x===null){const q=F.res.headers.etag;if(!q)throw new S.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",F.res.statusCode,F.res.headers[S.HEADER_OPERATION_ID]);const G=await(0,g.asText)(F);if(!G&&F.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",U,"EmptyResponse",F.res.statusCode,F.res.headers[S.HEADER_OPERATION_ID]);x={ref:q,content:G}}return x}async write(O,M,D,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();U={...U},U["Content-Type"]=R.Mimes.text,D&&(U["If-Match"]=D);const x=await this.request(F,{type:"POST",data:M,headers:U},[],t.CancellationToken.None),q=x.res.headers.etag;if(!q)throw new S.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",x.res.statusCode,x.res.headers[S.HEADER_OPERATION_ID]);return q}async manifest(O,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",O&&(M["If-None-Match"]=O.ref);const U=await this.request(D,{type:"GET",headers:M},[304],t.CancellationToken.None);let F=null;if(U.res.statusCode===304&&(F=O),!F){const q=U.res.headers.etag;if(!q)throw new S.UserDataSyncStoreError("Server did not return the ref",D,"NoRef",U.res.statusCode,U.res.headers[S.HEADER_OPERATION_ID]);const G=await(0,g.asText)(U);if(!G&&U.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",D,"EmptyResponse",U.res.statusCode,U.res.headers[S.HEADER_OPERATION_ID]);G&&(F={...JSON.parse(G),ref:q})}const x=this.storageService.get(c,0);return x&&F&&x!==F.session&&this.clearSession(),F===null&&x&&this.clearSession(),F&&this.storageService.store(c,F.session,0,1),F}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:M},[],t.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(c,0),this.storageService.remove(r,0)}async request(O,M,D,U){if(!this.authToken)throw new S.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const F=await this.commonHeadersPromise;M.headers={...M.headers||{},...F,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:O,type:M.type,headers:{...M.headers,authorization:void 0}});let x;try{x=await this.session.request(O,M,U)}catch(W){if(!(W instanceof S.UserDataSyncStoreError)){let j="RequestFailed";const J=(0,L.getErrorMessage)(W).toLowerCase();J.includes("xhr timeout")?j="RequestTimeout":J.includes("protocol")&&J.includes("not supported")?j="RequestProtocolNotSupported":J.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":J.includes("headers must be an object")?j="RequestHeadersNotObject":(0,L.isCancellationError)(W)&&(j="RequestCanceled"),W=new S.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,j,void 0,void 0)}throw this.logService.info("Request failed",O),W}const q=x.res.headers[S.HEADER_OPERATION_ID],G={url:O,status:x.res.statusCode,"execution-id":M.headers[S.HEADER_EXECUTION_ID],"operation-id":q},te=(0,g.isSuccess)(x)||x.res.statusCode&&D.indexOf(x.res.statusCode)!==-1;if(te?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),x.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new S.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",x.res.statusCode,q);if(this._onTokenSucceed.fire(),x.res.statusCode===409)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",x.res.statusCode,q);if(x.res.statusCode===410)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",x.res.statusCode,q);if(x.res.statusCode===412)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",x.res.statusCode,q);if(x.res.statusCode===413)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",x.res.statusCode,q);if(x.res.statusCode===426)throw new S.UserDataSyncStoreError(`${M.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",x.res.statusCode,q);if(x.res.statusCode===429){const W=x.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",x.res.statusCode,q)):new S.UserDataSyncStoreError(`${M.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",x.res.statusCode,q)}if(!te)throw new S.UserDataSyncStoreError("Server returned "+x.res.statusCode,O,"Unknown",x.res.statusCode,q);return x}addSessionHeaders(O){let M=this.storageService.get(r,0);M===void 0&&(M=(0,f.generateUuid)(),this.storageService.store(r,M,0,1)),O["X-Machine-Session-Id"]=M;const D=this.storageService.get(c,0);D!==void 0&&(O["X-User-Session-Id"]=D)}};u=he([K(1,m.IProductService),K(2,g.IRequestService),K(3,S.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,h.IFileService),K(6,w.IStorageService)],u),e.UserDataSyncStoreClient=u;let v=class extends u{constructor(O,M,D,U,F,x,q){super(O.userDataSyncStore?.url,M,D,U,F,x,q);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};v=he([K(0,S.IUserDataSyncStoreManagementService),K(1,m.IProductService),K(2,g.IRequestService),K(3,S.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,h.IFileService),K(6,w.IStorageService)],v),e.UserDataSyncStoreService=v;class I{constructor(O,M,D,U){this.limit=O,this.interval=M,this.requestService=D,this.logService=U,this.requests=[],this.startTime=void 0}request(O,M,D){if(this.isExpired()&&this.reset(),M.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new S.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(M,D)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(ne[243],ie([0,1,3,60,27,23,20,239,24,65,66]),function(Y,e,k,t,L,T,A,R,C,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends R.UserDataAutoSyncService{constructor(p,d,h,m,g,y,w,S,l,i,c){super(p,d,h,m,g,w,S,l,i,c);this._register(k.Event.debounce(k.Event.any(k.Event.map(y.onDidFocusWindow,()=>"windowFocus"),k.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(r,n)=>r?[...r,n]:[n],1e3)(r=>this.triggerSync(r,!0,!1)))}};b=he([K(0,L.IProductService),K(1,C.IUserDataSyncStoreManagementService),K(2,C.IUserDataSyncStoreService),K(3,C.IUserDataSyncEnablementService),K(4,C.IUserDataSyncService),K(5,t.INativeHostService),K(6,C.IUserDataSyncLogService),K(7,E.IUserDataSyncAccountService),K(8,A.ITelemetryService),K(9,P.IUserDataSyncMachinesService),K(10,T.IStorageService)],b),e.UserDataAutoSyncService=b}),define(ne[244],ie([0,1,5,3,2]),function(Y,e,k,t,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:C,getActiveWindowId:E}){super();this.disposables=this._register(new L.DisposableStore),t.Event.latch(t.Event.any(R,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>E()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ne[67],ie([0,1,50,5,10,15,22,124,257,258]),function(Y,e,k,t,L,T,A,R,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(i,c){let r=c.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=i,this.cause=c}}e.ExtractError=P;function b(l){const i=l.externalFileAttributes>>16||33188;return[448,56,7].map(c=>i&c).reduce((c,r)=>c+r,i&61440)}function f(l){if(l instanceof P)return l;let i;return/end of central directory record signature not found/.test(l.message)&&(i="CorruptZip"),new P(i,l)}function p(l,i,c,r,n,s){const o=L.dirname(i),a=L.join(r,o);if(!a.startsWith(r))return Promise.reject(new Error(R.localize(0,null,i)));const u=L.join(r,i);let v;return s.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((I,_)=>{if(!s.isCancellationRequested)try{v=(0,k.createWriteStream)(u,{mode:c}),v.once("close",()=>I()),v.once("error",_),l.once("error",_),l.pipe(v)}catch(O){_(O)}}))}function d(l,i,c,r){let n=(0,t.createCancelablePromise)(()=>Promise.resolve()),s=0;return r.onCancellationRequested(()=>{n.cancel(),l.close()}),new Promise((o,a)=>{const u=new t.Sequencer,v=I=>{I.isCancellationRequested||(s++,l.readEntry())};l.once("error",a),l.once("close",()=>n.then(()=>{r.isCancellationRequested||l.entryCount===s?o():a(new P("Incomplete",new Error(R.localize(1,null,s,l.entryCount))))},a)),l.readEntry(),l.on("entry",I=>{if(r.isCancellationRequested)return;if(!c.sourcePathRegex.test(I.fileName)){v(r);return}const _=I.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(_)){const D=L.join(i,_);n=(0,t.createCancelablePromise)(U=>A.Promises.mkdir(D,{recursive:!0}).then(()=>v(U)).then(void 0,a));return}const O=m(l,I),M=b(I);n=(0,t.createCancelablePromise)(D=>u.queue(()=>O.then(U=>p(U,_,M,i,c,D).then(()=>v(D)))).then(null,a))})})}function h(l,i=!1){return new Promise((c,r)=>{(0,C.open)(l,i?{lazyEntries:!0}:void 0,(n,s)=>{n?r(f(n)):c((0,T.assertIsDefined)(s))})})}function m(l,i){return new Promise((c,r)=>{l.openReadStream(i,(n,s)=>{n?r(f(n)):c((0,T.assertIsDefined)(s))})})}function g(l,i){return new Promise((c,r)=>{const n=new E.ZipFile;i.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,k.createWriteStream)(l);n.outputStream.pipe(s),n.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>c(l))})}e.zip=g;function y(l,i,c={},r){const n=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let s=h(l,!0);return c.overwrite&&(s=s.then(o=>A.Promises.rm(i).then(()=>o))),s.then(o=>d(o,i,{sourcePathRegex:n},r))}e.extract=y;function w(l,i){return h(l).then(c=>new Promise((r,n)=>{c.on("entry",s=>{s.fileName===i&&m(c,s).then(o=>r(o),o=>n(o))}),c.once("close",()=>n(new Error(R.localize(2,null,i))))}))}function S(l,i){return w(l,i).then(c=>new Promise((r,n)=>{const s=[];c.once("error",n),c.on("data",o=>s.push(o)),c.on("end",()=>r(Buffer.concat(s)))}))}e.buffer=S}),define(ne[245],ie([0,1,67,133]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,k.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=L}),define(ne[246],ie([0,1,16,5,9,2,18,10,4,21,62,7,29,22,67,134,14,30,31,154,61,11,8,27]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let r=class extends T.Disposable{constructor(s,o,a,u,v){super();this.beforeRemovingExtension=s,this.fileService=o,this.logService=a,this.environmentService=u,this.productService=v,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new t.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(s){const o=[];(s===null||s===0)&&o.push(this.scanSystemExtensions().then(null,a=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(a).message,g.ExtensionManagementErrorCode.Internal)))),(s===null||s===1)&&o.push(this.scanUserExtensions(!0).then(null,a=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(a).message,g.ExtensionManagementErrorCode.Internal))));try{const a=await Promise.all(o);return(0,k.flatten)(a)}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(s){this.logService.trace("Started scanning user extensions");let[o,a]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return a=a.filter(u=>!o[new y.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),s&&(a=(0,y.groupByExtension)(a,v=>v.identifier).map(v=>v.sort((I,_)=>P.rcompare(I.manifest.version,_.manifest.version))[0])),this.logService.trace("Scanned user extensions:",a.length),a}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(s,o,a,u){const v=s.key(),I=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),_=R.join(this.extensionsPath,v);try{await p.Promises.rm(_)}catch{try{await p.Promises.rm(_)}catch{}throw new g.ExtensionManagementError((0,h.localize)(0,null,_,s.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(s,o,I,u);let O=await this.scanExtension(b.URI.file(I),1);if(!O)throw new Error((0,h.localize)(1,null,I));await this.storeMetadata(O,{...a,installedTimestamp:Date.now()});try{await this.rename(s,I,_,Date.now()+2*60*1e3),this.logService.info("Renamed to",_)}catch(M){try{await p.Promises.rm(I)}catch{}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",s.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(M)}. Deleted from extracted location`,I),M}try{O=await this.scanExtension(b.URI.file(_),1)}catch{}if(O)return O;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(s,o){return this.setMetadata(s,o),await this.storeMetadata(s,{...o,installedTimestamp:s.installedTimestamp}),s}async storeMetadata(s,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const a=R.join(s.location.fsPath,"package.json"),u=await p.Promises.readFile(a,"utf8"),{manifest:v}=await this.parseManifest(u);return v.__metadata=o,await p.Promises.writeFile(a,JSON.stringify(v,null,"	")),s}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...s){const o=s.map(a=>new y.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version));await this.withUninstalledExtensions(a=>{o.forEach(u=>a[u.key()]=!0)})}async setInstalled(s){await this.withUninstalledExtensions(u=>delete u[s.key()]);const a=(await this.scanExtensions(1)).find(u=>new y.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(s))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,1)):null}async withUninstalledExtensions(s){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let a={};if(o)try{a=JSON.parse(o)}catch{}return s&&(s(a),Object.keys(a).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await p.Promises.rm(this.uninstalledPath)),a})}async removeExtension(s,o){this.logService.trace(`Deleting ${o} extension from disk`,s.identifier.id,s.location.fsPath),await p.Promises.rm(s.location.fsPath),this.logService.info("Deleted from disk",s.identifier.id,s.location.fsPath)}async removeUninstalledExtension(s){await this.removeExtension(s,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new y.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version).key()])}async extractAtLocation(s,o,a,u){this.logService.trace(`Started extracting the extension from ${o} to ${a}`);try{await p.Promises.rm(a)}catch(v){throw new g.ExtensionManagementError(this.joinErrors(v).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(o,a,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${a}:`,s.id)}catch(v){try{await p.Promises.rm(a)}catch{}let I=g.ExtensionManagementErrorCode.Extract;throw v instanceof d.ExtractError&&(v.type==="CorruptZip"?I=g.ExtensionManagementErrorCode.CorruptZip:v.type==="Incomplete"&&(I=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(v.message,I)}}async rename(s,o,a,u){try{await p.Promises.rename(o,a)}catch(v){if(C.isWindows&&v&&v.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${o} to ${a} with 'EPERM' error. Trying again...`,s.id),this.rename(s,o,a,u);throw new g.ExtensionManagementError(v.message||(0,h.localize)(3,null,o,a),v.code||g.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const s=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return s;const o=this.scanDevSystemExtensions(),[a,u]=await Promise.all([s,o]);return[...a,...u]}async scanExtensionsInDir(s,o){const a=new t.Limiter(10),u=await this.fileService.resolve(b.URI.file(s));return u.children?(await Promise.all(u.children.filter(I=>I.isDirectory).map(I=>a.queue(async()=>o===1&&(0,E.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,o))))).filter(I=>I&&I.identifier):[]}async scanExtension(s,o){try{const a=await this.fileService.resolve(s);if(a.children){const{manifest:u,metadata:v}=await this.readManifest(s.fsPath),I=a.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D))?.resource,_=a.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D))?.resource,O={id:(0,y.getGalleryExtensionId)(u.publisher,u.name)},M={type:o,identifier:O,manifest:u,location:s,readmeUrl:I,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return this.setMetadata(M,v),M}}catch(a){o!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){const s=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",s.length),s}async scanDevSystemExtensions(){const s=this.getDevSystemExtensionsList();if(s.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(a=>s.some(u=>(0,y.areSameExtensions)(a.identifier,{id:u})))}else return[]}setMetadata(s,o){s.publisherDisplayName=o?.publisherDisplayName||null,s.publisherId=o?.publisherId||null,s.identifier.uuid=o?.id,s.isMachineScoped=!!o?.isMachineScoped,s.isPreReleaseVersion=!!o?.isPreReleaseVersion,s.preRelease=!!o?.preRelease,s.isBuiltin=s.type===0||!!o?.isBuiltin,s.installedTimestamp=o?.installedTimestamp}async removeUninstalledExtensions(){const s=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),a=new Set;for(const I of o)s[new y.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||a.add(I.identifier.id.toLowerCase());const u=(0,y.groupByExtension)(o,I=>I.identifier);await t.Promises.settled(u.map(async I=>{const _=I.sort((O,M)=>P.rcompare(O.manifest.version,M.manifest.version))[0];a.has(_.identifier.id.toLowerCase())||await this.beforeRemovingExtension(_)}));const v=o.filter(I=>s[new y.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await t.Promises.settled(v.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const s=await this.scanAllUserExtensions(),o=[],a=(0,y.groupByExtension)(s,u=>u.identifier);o.push(...(0,k.flatten)(a.map(u=>u.sort((v,I)=>P.rcompare(v.manifest.version,I.manifest.version)).slice(1)))),await t.Promises.settled(o.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(s=>s.name)}joinErrors(s){const o=Array.isArray(s)?s:[s];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((a,u)=>new Error(`${a.message}${a.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(A.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(s){const o=[p.Promises.readFile(R.join(s,"package.json"),"utf8").then(I=>this.parseManifest(I)),p.Promises.readFile(R.join(s,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:a,metadata:u},v]=await Promise.all(o);return{manifest:(0,w.localizeManifest)(a,v),metadata:u}}parseManifest(s){return new Promise((o,a)=>{try{const u=JSON.parse(s);u.publisher||(u.publisher=S.UNDEFINED_PUBLISHER);const v=u.__metadata||null;o({manifest:u,metadata:v})}catch{a(new Error((0,h.localize)(4,null)))}})}};r=he([K(1,l.IFileService),K(2,i.ILogService),K(3,m.INativeEnvironmentService),K(4,c.IProductService)],r),e.ExtensionsScanner=r}),define(ne[247],ie([0,1,37,9,18,10,4,33,21,62,7,29,22,67,132,82,14,205,30,31,188,173,245,189,246,221,79,11,6,8,27,20,32]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l,i,c,r,n,s,o,a,u,v,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends g.AbstractExtensionManagementService{constructor(q,G,te,W,j,J,H,Q,Z){super(q,G,te,Q);this.environmentService=W,this.downloadService=j,this.fileService=H;const B=this._register(J.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(J.createInstance(r.ExtensionsScanner,$=>B.postUninstall($))),this.manifestCache=this._register(new c.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(J.createInstance(S.ExtensionsDownloader));const N=this._register(new n.ExtensionsWatcher(this,H,W,te,Z));this._register(N.onDidChangeExtensionsByAnotherSource(({added:$,removed:z})=>{$.length&&this._onDidInstallExtensions.fire($.map(V=>({identifier:V.identifier,operation:1,local:V}))),z.forEach(V=>this._onDidUninstallExtension.fire({identifier:V}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const q=await this.isAlpineLinux(),G=(0,y.getTargetPlatform)(q?"alpine":A.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!A.isLinux)return!1;let q;try{q=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{q=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(te){this.logService.debug("Error while getting the os-release file.",(0,t.getErrorMessage)(te))}}return!!q&&(q.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(q){this.logService.trace("ExtensionManagementService#zip",q.identifier.id);const G=await this.collectFiles(q),te=await(0,p.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)()).fsPath,G);return P.URI.file(te)}async unzip(q){return this.logService.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const G=await this.downloadVsix(q),te=T.resolve(G.fsPath);return(0,i.getManifest)(te)}getInstalled(q=null){return this.extensionsScanner.scanExtensions(q)}async install(q,G={}){this.logService.trace("ExtensionManagementService#install",q.toString());const te=await this.downloadVsix(q),W=await(0,i.getManifest)(T.resolve(te.fsPath));if(W.engines&&W.engines.vscode&&!(0,s.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(d.localize(0,null,(0,w.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return this.installExtension(W,te,G)}async updateMetadata(q,G){this.logService.trace("ExtensionManagementService#updateMetadata",q.identifier.id);const te={...q.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(te.preRelease=!0),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,te),this.manifestCache.invalidate(),q}async updateExtensionScope(q,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",q.identifier.id),q=await this.extensionsScanner.saveMetadataForLocalExtension(q,{...q.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),q}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(q){if(q.scheme===L.Schemas.file)return q;const G=(0,C.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)());return await this.downloadService.download(q,G),G}createInstallExtensionTask(q,G,te){return P.URI.isUri(G)?new U(q,G,te,this.galleryService,this.extensionsScanner,this.logService):new D(G,te,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(q,G){return new F(q,G,this.extensionsScanner)}async collectFiles(q){const G=async W=>{let j=await f.Promises.readdir(W);j=j.map(Q=>T.join(W,Q));const J=await Promise.all(j.map(Q=>f.Promises.stat(Q)));let H=Promise.resolve([]);return J.forEach((Q,Z)=>{const B=j[Z];Q.isFile()&&(H=H.then(N=>[...N,B])),Q.isDirectory()&&(H=H.then(N=>G(B).then($=>[...N,...$])))}),H};return(await G(q.location.fsPath)).map(W=>({path:`extension/${T.relative(q.location.fsPath,W)}`,localPath:W}))}};O=he([K(0,y.IExtensionGalleryService),K(1,I.ITelemetryService),K(2,u.ILogService),K(3,m.INativeEnvironmentService),K(4,h.IDownloadService),K(5,a.IInstantiationService),K(6,o.IFileService),K(7,v.IProductService),K(8,_.IUriIdentityService)],O),e.ExtensionManagementService=O;class M extends g.AbstractExtensionTask{constructor(q,G,te,W){super();this.identifier=q,this.source=G,this.extensionsScanner=te,this.logService=W,this._operation=2}get operation(){return this._operation}async installExtension(q,G){try{const te=await this.unsetUninstalledAndGetLocal(q.identifierWithVersion);if(te)return q.metadata?this.extensionsScanner.saveMetadataForLocalExtension(te,{...te.manifest.__metadata||{},...q.metadata}):te}catch{throw A.isMacintosh?new y.ExtensionManagementError(d.localize(1,null),y.ExtensionManagementErrorCode.Internal):new y.ExtensionManagementError(d.localize(2,null),y.ExtensionManagementErrorCode.Internal)}return this.extract(q,G)}async unsetUninstalledAndGetLocal(q){if(!await this.isUninstalled(q))return null;this.logService.trace("Removing the extension from uninstalled list:",q.id);const te=await this.extensionsScanner.setInstalled(q);return this.logService.info("Removed the extension from uninstalled list:",q.id),te}async isUninstalled(q){return!!(await this.extensionsScanner.getUninstalledExtensions())[q.key()]}async extract({zipPath:q,identifierWithVersion:G,metadata:te},W){let j=await this.extensionsScanner.extractUserExtension(G,q,te,W);return this.logService.info("Extracting completed.",G.id),j}}class D extends M{constructor(q,G,te,W,j){super(q.identifier,q,W,j);this.gallery=q,this.options=G,this.extensionsDownloader=te}async doRun(q){const te=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,w.areSameExtensions)(j.identifier,this.gallery.identifier));te&&(this._operation=3);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||te?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||te?.isBuiltin,W.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,W.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:te?.preRelease||this.options.installPreReleaseVersion;try{const j=await this.installExtension(W,q);return te&&E.neq(te.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(te),j}catch(j){throw await this.deleteDownloadedVSIX(W.zipPath),j}}async deleteDownloadedVSIX(q){try{await this.extensionsDownloader.delete(P.URI.file(q))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",q.toString(),(0,t.getErrorMessage)(G))}}async downloadInstallableExtension(q,G){const te={id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName};let W;try{this.logService.trace("Started downloading extension:",q.identifier.id),W=(await this.extensionsDownloader.downloadExtension(q,G)).fsPath,this.logService.info("Downloaded extension:",q.identifier.id,W)}catch(j){throw new y.ExtensionManagementError((0,g.joinErrors)(j).message,y.ExtensionManagementErrorCode.Download)}try{const j=await(0,i.getManifest)(W);return{zipPath:W,identifierWithVersion:new w.ExtensionIdentifierWithVersion(q.identifier,j.version),metadata:te}}catch(j){throw await this.deleteDownloadedVSIX(W),new y.ExtensionManagementError((0,g.joinErrors)(j).message,y.ExtensionManagementErrorCode.Invalid)}}}class U extends M{constructor(q,G,te,W,j,J){super({id:(0,w.getGalleryExtensionId)(q.publisher,q.name)},G,j,J);this.manifest=q,this.location=G,this.options=te,this.galleryService=W}async doRun(q){const G=new w.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(J=>(0,w.areSameExtensions)(this.identifier,J.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,q);if(j.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||W?.isBuiltin,W)if(this._operation=3,G.equals(new w.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(d.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const J=await this.unsetUninstalledAndGetLocal(G);if(J)try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(d.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:G,metadata:j},q)}async getMetadata(q,G,te){try{let[W]=await this.galleryService.getExtensions([{id:q,version:G}],te);if(W||([W]=await this.galleryService.getExtensions([{id:q}],te)),W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId,isPreReleaseVersion:W.properties.isPreReleaseVersion,preRelease:W.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F extends g.AbstractExtensionTask{constructor(q,G,te){super();this.extension=q,this.options=G,this.extensionsScanner=te}async doRun(q){const G=[],te=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=new w.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...te.filter(j=>W.equals(new w.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else G.push(...te.filter(W=>(0,w.areSameExtensions)(W.identifier,this.extension.identifier)));if(!G.length)throw new Error(d.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const W of G)try{q.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch(j){throw new Error(d.localize(6,null,(0,k.toErrorMessage)(j)))}}}}),define(ne[248],ie([0,1,84,56,34,17,9,3,2,10,4,29,36,74,259]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(I,_=""){this.debugLabel=_,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,_){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const _=O=>{this.traceSocketEvent("read",O),I(T.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(I){const _=O=>{this.traceSocketEvent("close",{hadError:O}),I({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(I){const _=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,A.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=h;var m;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var g;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(g||(g={}));class y extends C.Disposable{constructor(I,_,O,M){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:M}),this._flowManager=this._register(new w(this,_,O,M,this._onData,(D,U)=>this._write(D,U))),this._register(this._flowManager.onError(D=>{console.error(D),(0,A.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,_){this.socket.traceSocketEvent(I,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let O=2;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const M=T.VSBuffer.alloc(O);if(_?M.writeUInt8(194,0):M.writeUInt8(130,0),I.byteLength<126)M.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){M.writeUInt8(126,1);let D=1;M.writeUInt8(I.byteLength>>>8&255,++D),M.writeUInt8(I.byteLength>>>0&255,++D)}else{M.writeUInt8(127,1);let D=1;M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(0,++D),M.writeUInt8(I.byteLength>>>24&255,++D),M.writeUInt8(I.byteLength>>>16&255,++D),M.writeUInt8(I.byteLength>>>8&255,++D),M.writeUInt8(I.byteLength>>>0&255,++D)}this.socket.write(T.VSBuffer.concat([M,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),M=(O&128)>>>7,D=(O&64)>>>6,U=_.readUInt8(1),F=(U&128)>>>7,x=U&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=M,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(D)),this._state.firstFrameOfMessage=Boolean(M),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),M=(O&128)>>>7;let D=O&127,U=1;D===126?D=_.readUInt8(++U)*2**8+_.readUInt8(++U):D===127&&(D=_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*0+_.readUInt8(++U)*2**24+_.readUInt8(++U)*2**16+_.readUInt8(++U)*2**8+_.readUInt8(++U));let F=0;M&&(F=_.readUInt8(++U)*2**24+_.readUInt8(++U)*2**16+_.readUInt8(++U)*2**8+_.readUInt8(++U)),this._state.state=3,this._state.readLen=D,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),i(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class w extends C.Disposable{constructor(I,_,O,M,D,U){super();this._tracer=I,this._onData=D,this._writeFn=U,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new S(this._tracer,M,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(_,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,_){return new Promise((O,M)=>{I.write(_),I.flush(D=>O(D))})}acceptFrame(I,_,O){this._readQueue.push({data:I,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,_,O){return new Promise((M,D)=>{I.write(_),O&&I.write(T.VSBuffer.fromByteArray([0,0,255,255])),I.flush(U=>M(U))})}}class S extends C.Disposable{constructor(I,_,O,M){super();this._tracer=I,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(M),this._zlibInflate.on("error",D=>{this._tracer.traceSocketEvent("zlibInflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibInflate.on("data",D=>{this._tracer.traceSocketEvent("zlibInflateData",D),this._pendingInflateData.push(T.VSBuffer.wrap(D))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(_)})}}class l extends C.Disposable{constructor(I,_){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(T.VSBuffer.wrap(O))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),I(_)})}}function i(v,I){if(I===0)return;let _=v.byteLength>>>2;for(let x=0;x<_;x++){const q=v.readUInt32BE(x*4);v.writeUInt32BE(q^I,x*4)}let O=_*4,M=v.byteLength-O;const D=I>>>24&255,U=I>>>16&255,F=I>>>8&255;M>=1&&v.writeUInt8(v.readUInt8(O)^D,O),M>=2&&v.writeUInt8(v.readUInt8(O+1)^U,O+1),M>=3&&v.writeUInt8(v.readUInt8(O+2)^F,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function r(){const v=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):I=(0,E.join)((0,L.tmpdir)(),`vscode-ipc-${v}.sock`),s(I),I}e.createRandomIPCHandle=r;function n(v,I,_){const O=(0,k.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${I}-sock`;let M;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${I}.sock`):M=(0,E.join)(v,`${_}-${I}.sock`),s(M),M}e.createStaticIPCHandle=n;function s(v){const I=c[P.platform];typeof I=="number"&&v.length>=I&&console.warn(`WARNING: IPC handle "${v}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const _=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(_,O=>({protocol:new p.Protocol(new h(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function a(v){return new Promise((I,_)=>{const O=(0,t.createServer)();O.on("error",_),O.listen(v,()=>{O.removeListener("error",_),I(new o(O))})})}e.serve=a;function u(v,I){return new Promise((_,O)=>{const M=(0,t.createConnection)(v,()=>{M.removeListener("error",O),_(p.Client.fromSocket(new h(M,`ipc-client${I}`),I))});M.once("error",O)})}e.connect=u}),define(ne[249],ie([0,1,56,248]),function(Y,e,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,R,C){const E=b=>C(b,void 0),P=k.createConnection({host:L,port:T},()=>{P.removeListener("error",E);const b=Buffer.alloc(16);for(let h=0;h<16;h++)b[h]=Math.round(Math.random()*256);const f=b.toString("base64"),p=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}/?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(p.join(`\r
`)+`\r
\r
`);const d=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",d),C(void 0,new t.NodeSocket(P,R)))};P.on("data",d)});P.setNoDelay(!0),P.once("error",E)}}}),define(ne[250],ie([0,1,56,115,249,5,2,19,8,27,184,64,92]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(y,w,S,l,i){let c;for(let r=3;r&&(c&&c.dispose(),c=await new d(y,w,S,l,i).waitForReady(),!(i&&t.BROWSER_RESTRICTED_PORTS[i]||!t.BROWSER_RESTRICTED_PORTS[c.tunnelLocalPort]));r--);return c}class d extends A.Disposable{constructor(w,S,l,i,c){super();this.defaultTunnelHost=S,this.suggestedLocalPort=c,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=w,this._server=k.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(S=>{S()})}async waitForReady(){let w=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),S=null;return this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address(),S||(w=0,this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address()),this.tunnelLocalPort=S.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${S.port}`,this}async _onConnection(w){w.pause();const S=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,S,this.tunnelRemotePort),i=l.getSocket().socket,c=l.readEntireBuffer();l.dispose(),c.byteLength>0&&w.write(c.buffer),w.on("end",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),i.end()}),w.on("close",()=>i.end()),w.on("error",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),i.destroy()}),i.on("end",()=>w.end()),i.on("close",()=>w.end()),i.on("error",()=>{w.destroy()}),w.pipe(i),i.pipe(w),w.localAddress&&this._socketsDispose.set(w.localAddress,()=>{w.end(),i.end()})}}let h=class extends b.AbstractTunnelService{constructor(w,S,l,i,c){super(S);this.socketFactory=w,this.signService=l,this.productService=i,this.configurationService=c}get defaultTunnelHost(){const w=this.configurationService.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(w,S,l,i,c,r,n){const s=this.getTunnelFromMap(S,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,S,l,i,c,r,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${S}:${l} on local port ${i}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:w,signService:this.signService,logService:this.logService,ipcLogger:null},a=p(o,this.defaultTunnelHost,S,l,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(S,l,a),a}}};h=he([K(1,C.ILogService),K(2,f.ISignService),K(3,E.IProductService),K(4,R.IConfigurationService)],h),e.BaseTunnelService=h;let m=class extends h{constructor(w,S,l,i){super(L.nodeSocketFactory,w,S,l,i)}};m=he([K(0,C.ILogService),K(1,f.ISignService),K(2,E.IProductService),K(3,R.IConfigurationService)],m),e.TunnelService=m;let g=class extends A.Disposable{constructor(w,S,l,i){super();this.logService=w,this.productService=S,this.signService=l,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(w,S,l,i,c,r,n,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${i} on local port ${c}.`),!this._tunnelServices.has(w)){const o=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(w,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(w))})}return this._tunnelServices.get(w).openTunnel(S,l,i,c,r,n,s)}};g=he([K(0,C.ILogService),K(1,E.IProductService),K(2,f.ISignService),K(3,R.IConfigurationService)],g),e.SharedTunnelsService=g}),define(ne[260],ie([0,1,75,34,37,9,2,18,21,7,36,118,178,200,179,170,171,172,157,159,19,182,81,204,82,193,14,197,199,209,30,186,206,247,83,155,11,175,177,51,6,167,86,168,169,59,190,8,87,60,88,27,192,43,23,202,203,20,93,94,95,44,210,211,96,213,219,63,98,24,65,235,237,238,66,236,240,241,242,243,244,92,198,64,250,191,220,91,196,207,32,222,4,223,162,181,180]),function(Y,e,k,t,L,T,A,R,C,E,P,b,f,p,d,h,m,g,y,w,S,l,i,c,r,n,s,o,a,u,v,I,_,O,M,D,U,F,x,q,G,te,W,j,J,H,Q,Z,B,N,$,z,V,ee,se,ae,de,ve,be,Se,pe,Ie,Ce,De,Ue,je,Ge,Be,re,ce,ue,we,Ee,Fe,Te,Oe,_e,X,oe,le,fe,ge,Le,ye,Re,ke,Pe,Ae,Ne,qe,We,Pt,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Me="vscode:electron-main->shared-process=disposeWorker",$e=(Ke,ze)=>this.onDisposeWorker(ze);k.ipcRenderer.on(Me,$e),this._register((0,A.toDisposable)(()=>k.ipcRenderer.removeListener(Me,$e)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ce.registerConfiguration)(),me.invokeFunction(Me=>{const $e=Me.get(Z.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler($e)}),this._register((0,A.combinedDisposable)(me.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(d.LanguagePackCachedDataCleaner),me.createInstance(g.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(m.LogsDataCleaner),me.createInstance(h.LocalizationsUpdater),me.createInstance(p.ExtensionsCleaner)))}async initServices(){const me=new W.ServiceCollection,Me={_serviceBrand:void 0,...$.default};me.set(z.IProductService,Me);const $e=new P.StaticRouter(Ve=>Ve==="main"),Ke=new j.MessagePortMainProcessService(this.server,$e);me.set(J.IMainProcessService,Ke);const ze=new o.SharedProcessEnvironmentService(this.configuration.args,Me);me.set(s.INativeEnvironmentService,ze);const it=new B.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Xe=new B.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Ke.getChannel("logger"));me.set(Z.ILoggerService,Xe);const ot=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,C.joinPath)(E.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ye=this._register(new B.FollowerLogService(it,ot));me.set(Z.ILogService,Ye),this.sharedProcessWorkerService=new Ne.SharedProcessWorkerService(Ye),me.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new F.FileService(Ye));me.set(U.IFileService,Je);const at=this._register(new x.DiskFileSystemProvider(Ye));Je.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ke.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ye));Je.registerProvider(R.Schemas.userData,ct);const xe=this._register(new l.ConfigurationService(ze.settingsResource,Je));me.set(S.IConfigurationService,xe);const et=new ae.NativeStorageService(void 0,Ke,ze);me.set(se.IStorageService,et),this._register((0,A.toDisposable)(()=>et.flush())),await Promise.all([xe.initialize(),et.initialize()]),me.set(We.IUriIdentityService,new Pt.UriIdentityService(Je)),me.set(ee.IRequestService,new q.SyncDescriptor(V.RequestService)),me.set(y.IChecksumService,new q.SyncDescriptor(w.ChecksumService)),me.set(St.IV8InspectProfilingService,new q.SyncDescriptor(kt.InspectProfilingService));const rt=P.ProxyChannel.toService(Ke.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(N.INativeHostService,rt),me.set(r.IDownloadService,new q.SyncDescriptor(n.DownloadService));const lt=this._register(new fe.ActiveWindowManager(rt)),ut=new P.StaticRouter(Ve=>lt.getActiveClientId().then(dt=>Ve===dt));me.set(M.IExtensionRecommendationNotificationService,new D.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new qe.AssignmentService(this.configuration.machineId,xe,Me);let tt;const Qe=[];if((0,Ie.supportsTelemetry)(Me,ze)){const Ve=new Se.TelemetryLogAppender(Xe,ze);Qe.push(Ve);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=ze;if(Me.aiConfig&&Me.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Me.quality!=="stable";if(ft&&st){const bt=new Ce.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,st,!0);this._register((0,A.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new Ce.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,A.toDisposable)(()=>Et.flush())),Qe.push(Et)}tt=new pe.TelemetryService({appenders:Qe,commonProperties:(0,de.resolveCommonProperties)(Je,(0,t.release)(),(0,t.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},xe)}else{tt=Ie.NullTelemetryService;const Ve=Ie.NullAppender;Qe.push(Ve)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(Qe)),me.set(ve.ITelemetryService,tt);const At=new De.CustomEndpointTelemetryService(xe,tt,Xe,ze);me.set(ve.ICustomEndpointTelemetryService,At),me.set(v.IExtensionManagementService,new q.SyncDescriptor(O.ExtensionManagementService)),me.set(v.IExtensionGalleryService,new q.SyncDescriptor(u.ExtensionGalleryService)),me.set(v.IExtensionTipsService,new q.SyncDescriptor(_.ExtensionTipsService)),me.set(H.ILocalizationsService,new q.SyncDescriptor(Q.LocalizationsService)),me.set(i.IDiagnosticsService,new q.SyncDescriptor(c.DiagnosticsService)),me.set(ue.IUserDataSyncAccountService,new q.SyncDescriptor(ue.UserDataSyncAccountService)),me.set(ce.IUserDataSyncLogService,new q.SyncDescriptor(Fe.UserDataSyncLogService)),me.set(ce.IUserDataSyncUtilService,new Ee.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),me.set(v.IGlobalExtensionEnablementService,new q.SyncDescriptor(a.GlobalExtensionEnablementService)),me.set(re.IIgnoredExtensionsManagementService,new q.SyncDescriptor(re.IgnoredExtensionsManagementService)),me.set(Be.IExtensionStorageService,new q.SyncDescriptor(Be.ExtensionStorageService)),me.set(ce.IUserDataSyncStoreManagementService,new q.SyncDescriptor(oe.UserDataSyncStoreManagementService)),me.set(ce.IUserDataSyncStoreService,new q.SyncDescriptor(oe.UserDataSyncStoreService)),me.set(Te.IUserDataSyncMachinesService,new q.SyncDescriptor(Te.UserDataSyncMachinesService)),me.set(ce.IUserDataSyncBackupStoreService,new q.SyncDescriptor(we.UserDataSyncBackupStoreService)),me.set(ce.IUserDataSyncEnablementService,new q.SyncDescriptor(Oe.UserDataSyncEnablementService)),me.set(ce.IUserDataSyncService,new q.SyncDescriptor(_e.UserDataSyncService));const wt=new Ge.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,ze,Ye,tt);return await wt.initialize(),me.set(je.ILocalPtyService,this._register(wt)),me.set(ge.ISignService,new q.SyncDescriptor(Le.SignService)),me.set(ye.ISharedTunnelsService,new q.SyncDescriptor(Re.SharedTunnelsService)),me.set(ke.ISharedProcessTunnelService,new q.SyncDescriptor(Pe.SharedProcessTunnelService)),new te.InstantiationService(me)}initChannels(me){const Me=new I.ExtensionManagementChannel(me.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const $e=P.ProxyChannel.fromService(me.get(H.ILocalizationsService));this.server.registerChannel("localizations",$e);const Ke=P.ProxyChannel.fromService(me.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Ke);const ze=new I.ExtensionTipsChannel(me.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const it=P.ProxyChannel.fromService(me.get(y.IChecksumService));this.server.registerChannel("checksum",it);const Xe=P.ProxyChannel.fromService(me.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Ee.UserDataSyncMachinesServiceChannel(me.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Ye=P.ProxyChannel.fromService(me.get(ve.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ye);const Je=new Ee.UserDataSyncAccountServiceChannel(me.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const at=new Ee.UserDataSyncStoreManagementServiceChannel(me.get(ce.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new X.UserDataSyncChannel(me.get(ce.IUserDataSyncService),me.get(Z.ILogService));this.server.registerChannel("userDataSync",ct);const xe=this._register(me.get(G.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new Ee.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",et);const rt=me.get(je.ILocalPtyService),lt=P.ProxyChannel.fromService(rt);this.server.registerChannel(Ue.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(me.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(me.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Me=>{(0,T.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Me=>{const $e=(0,L.toErrorMessage)(Me,!0);!$e||me.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Tt(yt){const me=new Lt(yt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/db4621a582f849d50f45d4826cb382a36720d002/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
