/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/async","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/platform/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/glob","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/extpath","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/core/range","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/editor/common/languageSelector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],ge=function(Z){for(var e=[],n=0,O=Z.length;n<O;n++)e[n]=me[Z[n]];return e};define(me[41],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function n(O,_){if(!O)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=n}),define(me[67],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const n=Object.prototype.hasOwnProperty;function O(N){const g=[];for(let t in N)n.call(N,t)&&g.push(N[t]);return g}e.values=O;function _(N,g){for(let t in N)if(n.call(N,t)&&g({key:t,value:N[t]},function(){delete N[t]})===!1)return}e.forEach=_;function C(N,g){const t=Object.create(null);for(const d of N){const s=g(d);let a=t[s];a||(a=t[s]=[]),a.push(d)}return t}e.groupBy=C;function x(N){const g=Object.create(null);return N&&N.forEach((t,d)=>{g[d]=t}),g}e.fromMap=x;function F(N,g){const t=[],d=[];for(let s of N)g.has(s)||t.push(s);for(let s of g)N.has(s)||d.push(s);return{removed:t,added:d}}e.diffSets=F;function y(N,g){const t=[],d=[];for(let[s,a]of N)g.has(s)||t.push(a);for(let[s,a]of g)N.has(s)||d.push(a);return{removed:t,added:d}}e.diffMaps=y;class L{constructor(){this.map=new Map}add(g,t){let d=this.map.get(g);d||(d=new Set,this.map.set(g,d)),d.add(t)}delete(g,t){const d=this.map.get(g);!d||(d.delete(t),d.size===0&&this.map.delete(g))}forEach(g,t){const d=this.map.get(g);!d||d.forEach(t)}}e.SetMap=L}),define(me[50],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function n(x){return(F,y,L)=>{let N=null,g=null;if(typeof L.value=="function"?(N="value",g=L.value):typeof L.get=="function"&&(N="get",g=L.get),!g)throw new Error("not supported");L[N]=x(g,y)}}e.createDecorator=n;function O(x,F,y){let L=null,N=null;if(typeof y.value=="function"?(L="value",N=y.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(L="get",N=y.get),!N)throw new Error("not supported");const g=`$memoize$${F}`;y[L]=function(...t){return this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,t)}),this[g]}}e.memoize=O;function _(x,F,y){return n((L,N)=>{const g=`$debounce$${N}`,t=`$debounce$result$${N}`;return function(...d){this[t]||(this[t]=y?y():void 0),clearTimeout(this[g]),F&&(this[t]=F(this[t],...d),d=[this[t]]),this[g]=setTimeout(()=>{L.apply(this,d),this[t]=y?y():void 0},x)}})}e.debounce=_;function C(x,F,y){return n((L,N)=>{const g=`$throttle$timer$${N}`,t=`$throttle$result$${N}`,d=`$throttle$lastRun$${N}`,s=`$throttle$pending$${N}`;return function(...a){if(this[t]||(this[t]=y?y():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),F&&(this[t]=F(this[t],...a)),this[s])return;const l=this[d]+x;l<=Date.now()?(this[d]=Date.now(),L.apply(this,[this[t]]),this[t]=y?y():void 0):(this[s]=!0,this[g]=setTimeout(()=>{this[s]=!1,this[d]=Date.now(),L.apply(this,[this[t]]),this[t]=y?y():void 0},l-Date.now()))}})}e.throttle=C}),define(me[51],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(me[97],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(i){i.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function x(i,T=!1){let o=0,c=i.length,w="",f=0,h=16,p=0;function m(z){let q=0,V=0;for(;q<z;){const j=i.charCodeAt(o);if(j>=48&&j<=57)V=V*16+j-48;else if(j>=65&&j<=70)V=V*16+j-65+10;else if(j>=97&&j<=102)V=V*16+j-97+10;else break;o++,q++}return q<z&&(V=-1),V}function b(z){o=z,w="",f=0,h=16,p=0}function I(){const z=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&L(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&L(i.charCodeAt(o)))for(o++;o<i.length&&L(i.charCodeAt(o));)o++;else return p=3,i.substring(z,o);let q=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&L(i.charCodeAt(o))){for(o++;o<i.length&&L(i.charCodeAt(o));)o++;q=o}else p=3;return i.substring(z,q)}function k(){let z="",q=o;for(;;){if(o>=c){z+=i.substring(q,o),p=2;break}const V=i.charCodeAt(o);if(V===34){z+=i.substring(q,o),o++;break}if(V===92){if(z+=i.substring(q,o),o++,o>=c){p=2;break}switch(i.charCodeAt(o++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Y=m(4);Y>=0?z+=String.fromCharCode(Y):p=4;break}default:p=5}q=o;continue}if(V>=0&&V<=31)if(y(V)){z+=i.substring(q,o),p=2;break}else p=6;o++}return z}function $(){if(w="",p=0,f=o,o>=c)return f=c,h=17;let z=i.charCodeAt(o);if(F(z)){do o++,w+=String.fromCharCode(z),z=i.charCodeAt(o);while(F(z));return h=15}if(y(z))return o++,w+=String.fromCharCode(z),z===13&&i.charCodeAt(o)===10&&(o++,w+=`
`),h=14;switch(z){case 123:return o++,h=1;case 125:return o++,h=2;case 91:return o++,h=3;case 93:return o++,h=4;case 58:return o++,h=6;case 44:return o++,h=5;case 34:return o++,w=k(),h=10;case 47:{const q=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<c&&!y(i.charCodeAt(o));)o++;return w=i.substring(q,o),h=12}if(i.charCodeAt(o+1)===42){o+=2;const V=c-1;let j=!1;for(;o<V;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,j=!0;break}o++}return j||(o++,p=1),w=i.substring(q,o),h=13}return w+=String.fromCharCode(z),o++,h=16}case 45:if(w+=String.fromCharCode(z),o++,o===c||!L(i.charCodeAt(o)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=I(),h=11;default:for(;o<c&&u(z);)o++,z=i.charCodeAt(o);if(f!==o){switch(w=i.substring(f,o),w){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return w+=String.fromCharCode(z),o++,h=16}}function u(z){if(F(z)||y(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=$();while(z>=12&&z<=15);return z}return{setPosition:b,getPosition:()=>o,scan:T?U:$,getToken:()=>h,getTokenValue:()=>w,getTokenOffset:()=>f,getTokenLength:()=>o-f,getTokenError:()=>p}}e.createScanner=x;function F(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function L(i){return i>=48&&i<=57}var N;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(N||(N={}));function g(i,T){const o=[],c=new Object;let w;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function p(m,b,I,k){f.value=m,f.offset=b,f.length=I,f.type=k,f.colonOffset=void 0,w=f}try{E(i,{onObjectBegin:(m,b)=>{if(T<=m)throw c;w=void 0,h=T>m,o.push("")},onObjectProperty:(m,b,I)=>{if(T<b||(p(m,b,I,"property"),o[o.length-1]=m,T<=b+I))throw c},onObjectEnd:(m,b)=>{if(T<=m)throw c;w=void 0,o.pop()},onArrayBegin:(m,b)=>{if(T<=m)throw c;w=void 0,o.push(0)},onArrayEnd:(m,b)=>{if(T<=m)throw c;w=void 0,o.pop()},onLiteralValue:(m,b,I)=>{if(T<b||(p(m,b,I,S(m)),T<=b+I))throw c},onSeparator:(m,b,I)=>{if(T<=b)throw c;if(m===":"&&w&&w.type==="property")w.colonOffset=b,h=!1,w=void 0;else if(m===","){const k=o[o.length-1];typeof k=="number"?o[o.length-1]=k+1:(h=!0,o[o.length-1]=""),w=void 0}}})}catch(m){if(m!==c)throw m}return{path:o,previousNode:w,isAtPropertyKey:h,matches:m=>{let b=0;for(let I=0;b<m.length&&I<o.length;I++)if(m[b]===o[I]||m[b]==="*")b++;else if(m[b]!=="**")return!1;return b===m.length}}}e.getLocation=g;function t(i,T=[],o=C.DEFAULT){let c=null,w=[];const f=[];function h(m){Array.isArray(w)?w.push(m):c!==null&&(w[c]=m)}return E(i,{onObjectBegin:()=>{const m={};h(m),f.push(w),w=m,c=null},onObjectProperty:m=>{c=m},onObjectEnd:()=>{w=f.pop()},onArrayBegin:()=>{const m=[];h(m),f.push(w),w=m,c=null},onArrayEnd:()=>{w=f.pop()},onLiteralValue:h,onError:(m,b,I)=>{T.push({error:m,offset:b,length:I})}},o),w[0]}e.parse=t;function d(i,T=[],o=C.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(m){c.type==="property"&&(c.length=m-c.offset,c=c.parent)}function f(m){return c.children.push(m),m}E(i,{onObjectBegin:m=>{c=f({type:"object",offset:m,length:-1,parent:c,children:[]})},onObjectProperty:(m,b,I)=>{c=f({type:"property",offset:b,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:m,offset:b,length:I,parent:c})},onObjectEnd:(m,b)=>{c.length=m+b-c.offset,c=c.parent,w(m+b)},onArrayBegin:(m,b)=>{c=f({type:"array",offset:m,length:-1,parent:c,children:[]})},onArrayEnd:(m,b)=>{c.length=m+b-c.offset,c=c.parent,w(m+b)},onLiteralValue:(m,b,I)=>{f({type:S(m),offset:b,length:I,parent:c,value:m}),w(b+I)},onSeparator:(m,b,I)=>{c.type==="property"&&(m===":"?c.colonOffset=b:m===","&&w(b))},onError:(m,b,I)=>{T.push({error:m,offset:b,length:I})}},o);const p=c.children[0];return p&&delete p.parent,p}e.parseTree=d;function s(i,T){if(!i)return;let o=i;for(let c of T)if(typeof c=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let w=!1;for(const f of o.children)if(Array.isArray(f.children)&&f.children[0].value===c){o=f.children[1],w=!0;break}if(!w)return}else{const w=c;if(o.type!=="array"||w<0||!Array.isArray(o.children)||w>=o.children.length)return;o=o.children[w]}return o}e.findNodeAtLocation=s;function a(i){if(!i.parent||!i.parent.children)return[];const T=a(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;T.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&T.push(o)}return T}e.getNodePath=a;function l(i){switch(i.type){case"array":return i.children.map(l);case"object":{const T=Object.create(null);for(let o of i.children){const c=o.children[1];c&&(T[o.children[0].value]=l(c))}return T}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=l;function P(i,T,o=!1){return T>=i.offset&&T<i.offset+i.length||o&&T===i.offset+i.length}e.contains=P;function v(i,T,o=!1){if(P(i,T,o)){const c=i.children;if(Array.isArray(c))for(let w=0;w<c.length&&c[w].offset<=T;w++){const f=v(c[w],T,o);if(f)return f}return i}}e.findNodeAtOffset=v;function E(i,T,o=C.DEFAULT){const c=x(i,!1);function w(Ce){return Ce?()=>Ce(c.getTokenOffset(),c.getTokenLength()):()=>!0}function f(Ce){return Ce?Pe=>Ce(Pe,c.getTokenOffset(),c.getTokenLength()):()=>!0}const h=w(T.onObjectBegin),p=f(T.onObjectProperty),m=w(T.onObjectEnd),b=w(T.onArrayBegin),I=w(T.onArrayEnd),k=f(T.onLiteralValue),$=f(T.onSeparator),u=w(T.onComment),U=f(T.onError),z=o&&o.disallowComments,q=o&&o.allowTrailingComma;function V(){for(;;){const Ce=c.scan();switch(c.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:z||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(Ce){case 12:case 13:z?j(10):u();break;case 16:j(1);break;case 15:case 14:break;default:return Ce}}}function j(Ce,Pe=[],Be=[]){if(U(Ce),Pe.length+Be.length>0){let je=c.getToken();for(;je!==17;){if(Pe.indexOf(je)!==-1){V();break}else if(Be.indexOf(je)!==-1)break;je=V()}}}function Y(Ce){const Pe=c.getTokenValue();return Ce?k(Pe):p(Pe),V(),!0}function se(){switch(c.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(c.getTokenValue()),typeof Ce!="number"&&(j(2),Ce=0)}catch{j(2)}k(Ce);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return V(),!0}function le(){return c.getToken()!==10?(j(3,[],[2,5]),!1):(Y(!1),c.getToken()===6?($(":"),V(),Ee()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function re(){h(),V();let Ce=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(Ce||j(4,[],[]),$(","),V(),c.getToken()===2&&q)break}else Ce&&j(6,[],[]);le()||j(4,[],[2,5]),Ce=!0}return m(),c.getToken()!==2?j(7,[2],[]):V(),!0}function he(){b(),V();let Ce=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(Ce||j(4,[],[]),$(","),V(),c.getToken()===4&&q)break}else Ce&&j(6,[],[]);Ee()||j(4,[],[4,5]),Ce=!0}return I(),c.getToken()!==4?j(8,[4],[]):V(),!0}function Ee(){switch(c.getToken()){case 3:return he();case 1:return re();case 10:return Y(!0);default:return se()}}return V(),c.getToken()===17?o.allowEmptyContent?!0:(j(4,[],[]),!1):Ee()?(c.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=E;function r(i,T){let o=x(i),c=[],w,f=0,h;do switch(h=o.getPosition(),w=o.scan(),w){case 12:case 13:case 17:f!==h&&c.push(i.substring(f,h)),T!==void 0&&c.push(o.getTokenValue().replace(/[^\r\n]/g,T)),f=o.getPosition();break}while(w!==17);return c.join("")}e.stripComments=r;function S(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(me[98],ge([0]),e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,e(Z.marked={}))}(this,function(Z){"use strict";function e(ve,ce){for(var M=0;M<ce.length;M++){var A=ce[M];A.enumerable=A.enumerable||!1,A.configurable=!0,"value"in A&&(A.writable=!0),Object.defineProperty(ve,A.key,A)}}function n(ve,ce,M){return ce&&e(ve.prototype,ce),M&&e(ve,M),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function O(ve,ce){if(!!ve){if(typeof ve=="string")return _(ve,ce);var M=Object.prototype.toString.call(ve).slice(8,-1);if(M==="Object"&&ve.constructor&&(M=ve.constructor.name),M==="Map"||M==="Set")return Array.from(ve);if(M==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(M))return _(ve,ce)}}function _(ve,ce){(ce==null||ce>ve.length)&&(ce=ve.length);for(var M=0,A=new Array(ce);M<ce;M++)A[M]=ve[M];return A}function C(ve,ce){var M=typeof Symbol!="undefined"&&ve[Symbol.iterator]||ve["@@iterator"];if(M)return(M=M.call(ve)).next.bind(M);if(Array.isArray(ve)||(M=O(ve))||ce&&ve&&typeof ve.length=="number"){M&&(ve=M);var A=0;return function(){return A>=ve.length?{done:!0}:{done:!1,value:ve[A++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function x(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=x();function F(ve){Z.defaults=ve}var y=/[&<>"']/,L=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,g=/[<>"']|&(?!#?\w+;)/g,t={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ce){return t[ce]};function s(ve,ce){if(ce){if(y.test(ve))return ve.replace(L,d)}else if(N.test(ve))return ve.replace(g,d);return ve}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(ve){return ve.replace(a,function(ce,M){return M=M.toLowerCase(),M==="colon"?":":M.charAt(0)==="#"?M.charAt(1)==="x"?String.fromCharCode(parseInt(M.substring(2),16)):String.fromCharCode(+M.substring(1)):""})}var P=/(^|[^\[])\^/g;function v(ve,ce){ve=ve.source||ve,ce=ce||"";var M={replace:function(D,R){return R=R.source||R,R=R.replace(P,"$1"),ve=ve.replace(D,R),M},getRegex:function(){return new RegExp(ve,ce)}};return M}var E=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(ve,ce,M){if(ve){var A;try{A=decodeURIComponent(l(M)).replace(E,"").toLowerCase()}catch{return null}if(A.indexOf("javascript:")===0||A.indexOf("vbscript:")===0||A.indexOf("data:")===0)return null}ce&&!r.test(M)&&(M=w(ce,M));try{M=encodeURI(M).replace(/%25/g,"%")}catch{return null}return M}var i={},T=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(ve,ce){i[" "+ve]||(T.test(ve)?i[" "+ve]=ve+"/":i[" "+ve]=m(ve,"/",!0)),ve=i[" "+ve];var M=ve.indexOf(":")===-1;return ce.substring(0,2)==="//"?M?ce:ve.replace(o,"$1")+ce:ce.charAt(0)==="/"?M?ce:ve.replace(c,"$1")+ce:ve+ce}var f={exec:function(){}};function h(ve){for(var ce=1,M,A;ce<arguments.length;ce++){M=arguments[ce];for(A in M)Object.prototype.hasOwnProperty.call(M,A)&&(ve[A]=M[A])}return ve}function p(ve,ce){var M=ve.replace(/\|/g,function(R,H,Q){for(var te=!1,de=H;--de>=0&&Q[de]==="\\";)te=!te;return te?"|":" |"}),A=M.split(/ \|/),D=0;if(A[0].trim()||A.shift(),A[A.length-1].trim()||A.pop(),A.length>ce)A.splice(ce);else for(;A.length<ce;)A.push("");for(;D<A.length;D++)A[D]=A[D].trim().replace(/\\\|/g,"|");return A}function m(ve,ce,M){var A=ve.length;if(A===0)return"";for(var D=0;D<A;){var R=ve.charAt(A-D-1);if(R===ce&&!M)D++;else if(R!==ce&&M)D++;else break}return ve.substr(0,A-D)}function b(ve,ce){if(ve.indexOf(ce[1])===-1)return-1;for(var M=ve.length,A=0,D=0;D<M;D++)if(ve[D]==="\\")D++;else if(ve[D]===ce[0])A++;else if(ve[D]===ce[1]&&(A--,A<0))return D;return-1}function I(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(ve,ce){if(ce<1)return"";for(var M="";ce>1;)ce&1&&(M+=ve),ce>>=1,ve+=ve;return M+ve}function $(ve,ce,M,A){var D=ce.href,R=ce.title?s(ce.title):null,H=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){A.state.inLink=!0;var Q={type:"link",raw:M,href:D,title:R,text:H,tokens:A.inlineTokens(H,[])};return A.state.inLink=!1,Q}else return{type:"image",raw:M,href:D,title:R,text:s(H)}}function u(ve,ce){var M=ve.match(/^(\s+)(?:```)/);if(M===null)return ce;var A=M[1];return ce.split(`
`).map(function(D){var R=D.match(/^\s+/);if(R===null)return D;var H=R[0];return H.length>=A.length?D.slice(A.length):D}).join(`
`)}var U=function(){function ve(M){this.options=M||Z.defaults}var ce=ve.prototype;return ce.space=function(A){var D=this.rules.block.newline.exec(A);if(D&&D[0].length>0)return{type:"space",raw:D[0]}},ce.code=function(A){var D=this.rules.block.code.exec(A);if(D){var R=D[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:D[0],codeBlockStyle:"indented",text:this.options.pedantic?R:m(R,`
`)}}},ce.fences=function(A){var D=this.rules.block.fences.exec(A);if(D){var R=D[0],H=u(R,D[3]||"");return{type:"code",raw:R,lang:D[2]?D[2].trim():D[2],text:H}}},ce.heading=function(A){var D=this.rules.block.heading.exec(A);if(D){var R=D[2].trim();if(/#$/.test(R)){var H=m(R,"#");(this.options.pedantic||!H||/ $/.test(H))&&(R=H.trim())}var Q={type:"heading",raw:D[0],depth:D[1].length,text:R,tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},ce.hr=function(A){var D=this.rules.block.hr.exec(A);if(D)return{type:"hr",raw:D[0]}},ce.blockquote=function(A){var D=this.rules.block.blockquote.exec(A);if(D){var R=D[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:D[0],tokens:this.lexer.blockTokens(R,[]),text:R}}},ce.list=function(A){var D=this.rules.block.list.exec(A);if(D){var R,H,Q,te,de,Se,Ae,Fe,Ue,Oe,ke,qe,it=D[1].trim(),De=it.length>1,Ze={type:"list",raw:"",ordered:De,start:De?+it.slice(0,-1):"",loose:!1,items:[]};it=De?"\\d{1,9}\\"+it.slice(-1):"\\"+it,this.options.pedantic&&(it=De?it:"[*+-]");for(var G=new RegExp("^( {0,3}"+it+")((?: [^\\n]*)?(?:\\n|$))");A&&(qe=!1,!(!(D=G.exec(A))||this.rules.block.hr.test(A)));){if(R=D[0],A=A.substring(R.length),Fe=D[2].split(`
`,1)[0],Ue=A.split(`
`,1)[0],this.options.pedantic?(te=2,ke=Fe.trimLeft()):(te=D[2].search(/[^ ]/),te=te>4?1:te,ke=Fe.slice(te),te+=D[1].length),Se=!1,!Fe&&/^ *$/.test(Ue)&&(R+=Ue+`
`,A=A.substring(Ue.length+1),qe=!0),!qe)for(var X=new RegExp("^ {0,"+Math.min(3,te-1)+"}(?:[*+-]|\\d{1,9}[.)])");A&&(Oe=A.split(`
`,1)[0],Fe=Oe,this.options.pedantic&&(Fe=Fe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!X.test(Fe));){if(Fe.search(/[^ ]/)>=te||!Fe.trim())ke+=`
`+Fe.slice(te);else if(!Se)ke+=`
`+Fe;else break;!Se&&!Fe.trim()&&(Se=!0),R+=Oe+`
`,A=A.substring(Oe.length+1)}Ze.loose||(Ae?Ze.loose=!0:/\n *\n *$/.test(R)&&(Ae=!0)),this.options.gfm&&(H=/^\[[ xX]\] /.exec(ke),H&&(Q=H[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Ze.items.push({type:"list_item",raw:R,task:!!H,checked:Q,loose:!1,text:ke}),Ze.raw+=R}Ze.items[Ze.items.length-1].raw=R.trimRight(),Ze.items[Ze.items.length-1].text=ke.trimRight(),Ze.raw=Ze.raw.trimRight();var oe=Ze.items.length;for(de=0;de<oe;de++){this.lexer.state.top=!1,Ze.items[de].tokens=this.lexer.blockTokens(Ze.items[de].text,[]);var Ie=Ze.items[de].tokens.filter(function(Ve){return Ve.type==="space"}),Ne=Ie.every(function(Ve){for(var Ye=Ve.raw.split(""),ht=0,_t=C(Ye),Dt;!(Dt=_t()).done;){var He=Dt.value;if(He===`
`&&(ht+=1),ht>1)return!0}return!1});!Ze.loose&&Ie.length&&Ne&&(Ze.loose=!0,Ze.items[de].loose=!0)}return Ze}},ce.html=function(A){var D=this.rules.block.html.exec(A);if(D){var R={type:"html",raw:D[0],pre:!this.options.sanitizer&&(D[1]==="pre"||D[1]==="script"||D[1]==="style"),text:D[0]};return this.options.sanitize&&(R.type="paragraph",R.text=this.options.sanitizer?this.options.sanitizer(D[0]):s(D[0]),R.tokens=[],this.lexer.inline(R.text,R.tokens)),R}},ce.def=function(A){var D=this.rules.block.def.exec(A);if(D){D[3]&&(D[3]=D[3].substring(1,D[3].length-1));var R=D[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:R,raw:D[0],href:D[2],title:D[3]}}},ce.table=function(A){var D=this.rules.block.table.exec(A);if(D){var R={type:"table",header:p(D[1]).map(function(Ae){return{text:Ae}}),align:D[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:D[3]?D[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(R.header.length===R.align.length){R.raw=D[0];var H=R.align.length,Q,te,de,Se;for(Q=0;Q<H;Q++)/^ *-+: *$/.test(R.align[Q])?R.align[Q]="right":/^ *:-+: *$/.test(R.align[Q])?R.align[Q]="center":/^ *:-+ *$/.test(R.align[Q])?R.align[Q]="left":R.align[Q]=null;for(H=R.rows.length,Q=0;Q<H;Q++)R.rows[Q]=p(R.rows[Q],R.header.length).map(function(Ae){return{text:Ae}});for(H=R.header.length,te=0;te<H;te++)R.header[te].tokens=[],this.lexer.inlineTokens(R.header[te].text,R.header[te].tokens);for(H=R.rows.length,te=0;te<H;te++)for(Se=R.rows[te],de=0;de<Se.length;de++)Se[de].tokens=[],this.lexer.inlineTokens(Se[de].text,Se[de].tokens);return R}}},ce.lheading=function(A){var D=this.rules.block.lheading.exec(A);if(D){var R={type:"heading",raw:D[0],depth:D[2].charAt(0)==="="?1:2,text:D[1],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},ce.paragraph=function(A){var D=this.rules.block.paragraph.exec(A);if(D){var R={type:"paragraph",raw:D[0],text:D[1].charAt(D[1].length-1)===`
`?D[1].slice(0,-1):D[1],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},ce.text=function(A){var D=this.rules.block.text.exec(A);if(D){var R={type:"text",raw:D[0],text:D[0],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},ce.escape=function(A){var D=this.rules.inline.escape.exec(A);if(D)return{type:"escape",raw:D[0],text:s(D[1])}},ce.tag=function(A){var D=this.rules.inline.tag.exec(A);if(D)return!this.lexer.state.inLink&&/^<a /i.test(D[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(D[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(D[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(D[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:D[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(D[0]):s(D[0]):D[0]}},ce.link=function(A){var D=this.rules.inline.link.exec(A);if(D){var R=D[2].trim();if(!this.options.pedantic&&/^</.test(R)){if(!/>$/.test(R))return;var H=m(R.slice(0,-1),"\\");if((R.length-H.length)%2==0)return}else{var Q=b(D[2],"()");if(Q>-1){var te=D[0].indexOf("!")===0?5:4,de=te+D[1].length+Q;D[2]=D[2].substring(0,Q),D[0]=D[0].substring(0,de).trim(),D[3]=""}}var Se=D[2],Ae="";if(this.options.pedantic){var Fe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Se);Fe&&(Se=Fe[1],Ae=Fe[3])}else Ae=D[3]?D[3].slice(1,-1):"";return Se=Se.trim(),/^</.test(Se)&&(this.options.pedantic&&!/>$/.test(R)?Se=Se.slice(1):Se=Se.slice(1,-1)),$(D,{href:Se&&Se.replace(this.rules.inline._escapes,"$1"),title:Ae&&Ae.replace(this.rules.inline._escapes,"$1")},D[0],this.lexer)}},ce.reflink=function(A,D){var R;if((R=this.rules.inline.reflink.exec(A))||(R=this.rules.inline.nolink.exec(A))){var H=(R[2]||R[1]).replace(/\s+/g," ");if(H=D[H.toLowerCase()],!H||!H.href){var Q=R[0].charAt(0);return{type:"text",raw:Q,text:Q}}return $(R,H,R[0],this.lexer)}},ce.emStrong=function(A,D,R){R===void 0&&(R="");var H=this.rules.inline.emStrong.lDelim.exec(A);if(!!H&&!(H[3]&&R.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Q=H[1]||H[2]||"";if(!Q||Q&&(R===""||this.rules.inline.punctuation.exec(R))){var te=H[0].length-1,de,Se,Ae=te,Fe=0,Ue=H[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ue.lastIndex=0,D=D.slice(-1*A.length+te);(H=Ue.exec(D))!=null;)if(de=H[1]||H[2]||H[3]||H[4]||H[5]||H[6],!!de){if(Se=de.length,H[3]||H[4]){Ae+=Se;continue}else if((H[5]||H[6])&&te%3&&!((te+Se)%3)){Fe+=Se;continue}if(Ae-=Se,!(Ae>0)){if(Se=Math.min(Se,Se+Ae+Fe),Math.min(te,Se)%2){var Oe=A.slice(1,te+H.index+Se);return{type:"em",raw:A.slice(0,te+H.index+Se+1),text:Oe,tokens:this.lexer.inlineTokens(Oe,[])}}var ke=A.slice(2,te+H.index+Se-1);return{type:"strong",raw:A.slice(0,te+H.index+Se+1),text:ke,tokens:this.lexer.inlineTokens(ke,[])}}}}}},ce.codespan=function(A){var D=this.rules.inline.code.exec(A);if(D){var R=D[2].replace(/\n/g," "),H=/[^ ]/.test(R),Q=/^ /.test(R)&&/ $/.test(R);return H&&Q&&(R=R.substring(1,R.length-1)),R=s(R,!0),{type:"codespan",raw:D[0],text:R}}},ce.br=function(A){var D=this.rules.inline.br.exec(A);if(D)return{type:"br",raw:D[0]}},ce.del=function(A){var D=this.rules.inline.del.exec(A);if(D)return{type:"del",raw:D[0],text:D[2],tokens:this.lexer.inlineTokens(D[2],[])}},ce.autolink=function(A,D){var R=this.rules.inline.autolink.exec(A);if(R){var H,Q;return R[2]==="@"?(H=s(this.options.mangle?D(R[1]):R[1]),Q="mailto:"+H):(H=s(R[1]),Q=H),{type:"link",raw:R[0],text:H,href:Q,tokens:[{type:"text",raw:H,text:H}]}}},ce.url=function(A,D){var R;if(R=this.rules.inline.url.exec(A)){var H,Q;if(R[2]==="@")H=s(this.options.mangle?D(R[0]):R[0]),Q="mailto:"+H;else{var te;do te=R[0],R[0]=this.rules.inline._backpedal.exec(R[0])[0];while(te!==R[0]);H=s(R[0]),R[1]==="www."?Q="http://"+H:Q=H}return{type:"link",raw:R[0],text:H,href:Q,tokens:[{type:"text",raw:H,text:H}]}}},ce.inlineText=function(A,D){var R=this.rules.inline.text.exec(A);if(R){var H;return this.lexer.state.inRawBlock?H=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):s(R[0]):R[0]:H=s(this.options.smartypants?D(R[0]):R[0]),{type:"text",raw:R[0],text:H}}},ve}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=v(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=v(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=v(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=v(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=v(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=v(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=h({},z),z.gfm=h({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=v(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=v(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=h({},z.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:v(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=v(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=v(z._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=v(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=v(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=v(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=v(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=v(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=v(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=v(q.reflink).replace("label",q._label).replace("ref",z._label).getRegex(),q.nolink=v(q.nolink).replace("ref",z._label).getRegex(),q.reflinkSearch=v(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=h({},q),q.pedantic=h({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=h({},q.normal,{escape:v(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=v(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=h({},q.gfm,{br:v(q.br).replace("{2,}","*").getRegex(),text:v(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function V(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(ve){var ce="",M,A,D=ve.length;for(M=0;M<D;M++)A=ve.charCodeAt(M),Math.random()>.5&&(A="x"+A.toString(16)),ce+="&#"+A+";";return ce}var Y=function(){function ve(M){this.tokens=[],this.tokens.links=Object.create(null),this.options=M||Z.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var A={block:z.normal,inline:q.normal};this.options.pedantic?(A.block=z.pedantic,A.inline=q.pedantic):this.options.gfm&&(A.block=z.gfm,this.options.breaks?A.inline=q.breaks:A.inline=q.gfm),this.tokenizer.rules=A}ve.lex=function(A,D){var R=new ve(D);return R.lex(A)},ve.lexInline=function(A,D){var R=new ve(D);return R.inlineTokens(A)};var ce=ve.prototype;return ce.lex=function(A){A=A.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(A,this.tokens);for(var D;D=this.inlineQueue.shift();)this.inlineTokens(D.src,D.tokens);return this.tokens},ce.blockTokens=function(A,D){var R=this;D===void 0&&(D=[]),this.options.pedantic&&(A=A.replace(/^ +$/gm,""));for(var H,Q,te,de;A;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ae){return(H=Ae.call({lexer:R},A,D))?(A=A.substring(H.raw.length),D.push(H),!0):!1}))){if(H=this.tokenizer.space(A)){A=A.substring(H.raw.length),H.raw.length===1&&D.length>0?D[D.length-1].raw+=`
`:D.push(H);continue}if(H=this.tokenizer.code(A)){A=A.substring(H.raw.length),Q=D[D.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+H.raw,Q.text+=`
`+H.text,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):D.push(H);continue}if(H=this.tokenizer.fences(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.heading(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.hr(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.blockquote(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.list(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.html(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.def(A)){A=A.substring(H.raw.length),Q=D[D.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+H.raw,Q.text+=`
`+H.raw,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):this.tokens.links[H.tag]||(this.tokens.links[H.tag]={href:H.href,title:H.title});continue}if(H=this.tokenizer.table(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.lheading(A)){A=A.substring(H.raw.length),D.push(H);continue}if(te=A,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ae=1/0,Fe=A.slice(1),Ue=void 0;R.options.extensions.startBlock.forEach(function(Oe){Ue=Oe.call({lexer:this},Fe),typeof Ue=="number"&&Ue>=0&&(Ae=Math.min(Ae,Ue))}),Ae<1/0&&Ae>=0&&(te=A.substring(0,Ae+1))}(),this.state.top&&(H=this.tokenizer.paragraph(te))){Q=D[D.length-1],de&&Q.type==="paragraph"?(Q.raw+=`
`+H.raw,Q.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):D.push(H),de=te.length!==A.length,A=A.substring(H.raw.length);continue}if(H=this.tokenizer.text(A)){A=A.substring(H.raw.length),Q=D[D.length-1],Q&&Q.type==="text"?(Q.raw+=`
`+H.raw,Q.text+=`
`+H.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):D.push(H);continue}if(A){var Se="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return this.state.top=!0,D},ce.inline=function(A,D){this.inlineQueue.push({src:A,tokens:D})},ce.inlineTokens=function(A,D){var R=this;D===void 0&&(D=[]);var H,Q,te,de=A,Se,Ae,Fe;if(this.tokens.links){var Ue=Object.keys(this.tokens.links);if(Ue.length>0)for(;(Se=this.tokenizer.rules.inline.reflinkSearch.exec(de))!=null;)Ue.includes(Se[0].slice(Se[0].lastIndexOf("[")+1,-1))&&(de=de.slice(0,Se.index)+"["+k("a",Se[0].length-2)+"]"+de.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Se=this.tokenizer.rules.inline.blockSkip.exec(de))!=null;)de=de.slice(0,Se.index)+"["+k("a",Se[0].length-2)+"]"+de.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Se=this.tokenizer.rules.inline.escapedEmSt.exec(de))!=null;)de=de.slice(0,Se.index)+"++"+de.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;A;)if(Ae||(Fe=""),Ae=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(H=ke.call({lexer:R},A,D))?(A=A.substring(H.raw.length),D.push(H),!0):!1}))){if(H=this.tokenizer.escape(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.tag(A)){A=A.substring(H.raw.length),Q=D[D.length-1],Q&&H.type==="text"&&Q.type==="text"?(Q.raw+=H.raw,Q.text+=H.text):D.push(H);continue}if(H=this.tokenizer.link(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.reflink(A,this.tokens.links)){A=A.substring(H.raw.length),Q=D[D.length-1],Q&&H.type==="text"&&Q.type==="text"?(Q.raw+=H.raw,Q.text+=H.text):D.push(H);continue}if(H=this.tokenizer.emStrong(A,de,Fe)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.codespan(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.br(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.del(A)){A=A.substring(H.raw.length),D.push(H);continue}if(H=this.tokenizer.autolink(A,j)){A=A.substring(H.raw.length),D.push(H);continue}if(!this.state.inLink&&(H=this.tokenizer.url(A,j))){A=A.substring(H.raw.length),D.push(H);continue}if(te=A,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,qe=A.slice(1),it=void 0;R.options.extensions.startInline.forEach(function(De){it=De.call({lexer:this},qe),typeof it=="number"&&it>=0&&(ke=Math.min(ke,it))}),ke<1/0&&ke>=0&&(te=A.substring(0,ke+1))}(),H=this.tokenizer.inlineText(te,V)){A=A.substring(H.raw.length),H.raw.slice(-1)!=="_"&&(Fe=H.raw.slice(-1)),Ae=!0,Q=D[D.length-1],Q&&Q.type==="text"?(Q.raw+=H.raw,Q.text+=H.text):D.push(H);continue}if(A){var Oe="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(Oe);break}else throw new Error(Oe)}}return D},n(ve,null,[{key:"rules",get:function(){return{block:z,inline:q}}}]),ve}(),se=function(){function ve(M){this.options=M||Z.defaults}var ce=ve.prototype;return ce.code=function(A,D,R){var H=(D||"").match(/\S*/)[0];if(this.options.highlight){var Q=this.options.highlight(A,H);Q!=null&&Q!==A&&(R=!0,A=Q)}return A=A.replace(/\n$/,"")+`
`,H?'<pre><code class="'+this.options.langPrefix+s(H,!0)+'">'+(R?A:s(A,!0))+`</code></pre>
`:"<pre><code>"+(R?A:s(A,!0))+`</code></pre>
`},ce.blockquote=function(A){return`<blockquote>
`+A+`</blockquote>
`},ce.html=function(A){return A},ce.heading=function(A,D,R,H){return this.options.headerIds?"<h"+D+' id="'+this.options.headerPrefix+H.slug(R)+'">'+A+"</h"+D+`>
`:"<h"+D+">"+A+"</h"+D+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(A,D,R){var H=D?"ol":"ul",Q=D&&R!==1?' start="'+R+'"':"";return"<"+H+Q+`>
`+A+"</"+H+`>
`},ce.listitem=function(A){return"<li>"+A+`</li>
`},ce.checkbox=function(A){return"<input "+(A?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(A){return"<p>"+A+`</p>
`},ce.table=function(A,D){return D&&(D="<tbody>"+D+"</tbody>"),`<table>
<thead>
`+A+`</thead>
`+D+`</table>
`},ce.tablerow=function(A){return`<tr>
`+A+`</tr>
`},ce.tablecell=function(A,D){var R=D.header?"th":"td",H=D.align?"<"+R+' align="'+D.align+'">':"<"+R+">";return H+A+"</"+R+`>
`},ce.strong=function(A){return"<strong>"+A+"</strong>"},ce.em=function(A){return"<em>"+A+"</em>"},ce.codespan=function(A){return"<code>"+A+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(A){return"<del>"+A+"</del>"},ce.link=function(A,D,R){if(A=S(this.options.sanitize,this.options.baseUrl,A),A===null)return R;var H='<a href="'+s(A)+'"';return D&&(H+=' title="'+D+'"'),H+=">"+R+"</a>",H},ce.image=function(A,D,R){if(A=S(this.options.sanitize,this.options.baseUrl,A),A===null)return R;var H='<img src="'+A+'" alt="'+R+'"';return D&&(H+=' title="'+D+'"'),H+=this.options.xhtml?"/>":">",H},ce.text=function(A){return A},ve}(),le=function(){function ve(){}var ce=ve.prototype;return ce.strong=function(A){return A},ce.em=function(A){return A},ce.codespan=function(A){return A},ce.del=function(A){return A},ce.html=function(A){return A},ce.text=function(A){return A},ce.link=function(A,D,R){return""+R},ce.image=function(A,D,R){return""+R},ce.br=function(){return""},ve}(),re=function(){function ve(){this.seen={}}var ce=ve.prototype;return ce.serialize=function(A){return A.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(A,D){var R=A,H=0;if(this.seen.hasOwnProperty(R)){H=this.seen[A];do H++,R=A+"-"+H;while(this.seen.hasOwnProperty(R))}return D||(this.seen[A]=H,this.seen[R]=0),R},ce.slug=function(A,D){D===void 0&&(D={});var R=this.serialize(A);return this.getNextSafeSlug(R,D.dryrun)},ve}(),he=function(){function ve(M){this.options=M||Z.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new re}ve.parse=function(A,D){var R=new ve(D);return R.parse(A)},ve.parseInline=function(A,D){var R=new ve(D);return R.parseInline(A)};var ce=ve.prototype;return ce.parse=function(A,D){D===void 0&&(D=!0);var R="",H,Q,te,de,Se,Ae,Fe,Ue,Oe,ke,qe,it,De,Ze,G,X,oe,Ie,Ne,Ve=A.length;for(H=0;H<Ve;H++){if(ke=A[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Ne=this.options.extensions.renderers[ke.type].call({parser:this},ke),Ne!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){R+=Ne||"";continue}switch(ke.type){case"space":continue;case"hr":{R+=this.renderer.hr();continue}case"heading":{R+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,l(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{R+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(Ue="",Fe="",de=ke.header.length,Q=0;Q<de;Q++)Fe+=this.renderer.tablecell(this.parseInline(ke.header[Q].tokens),{header:!0,align:ke.align[Q]});for(Ue+=this.renderer.tablerow(Fe),Oe="",de=ke.rows.length,Q=0;Q<de;Q++){for(Ae=ke.rows[Q],Fe="",Se=Ae.length,te=0;te<Se;te++)Fe+=this.renderer.tablecell(this.parseInline(Ae[te].tokens),{header:!1,align:ke.align[te]});Oe+=this.renderer.tablerow(Fe)}R+=this.renderer.table(Ue,Oe);continue}case"blockquote":{Oe=this.parse(ke.tokens),R+=this.renderer.blockquote(Oe);continue}case"list":{for(qe=ke.ordered,it=ke.start,De=ke.loose,de=ke.items.length,Oe="",Q=0;Q<de;Q++)G=ke.items[Q],X=G.checked,oe=G.task,Ze="",G.task&&(Ie=this.renderer.checkbox(X),De?G.tokens.length>0&&G.tokens[0].type==="paragraph"?(G.tokens[0].text=Ie+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=Ie+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:Ie}):Ze+=Ie),Ze+=this.parse(G.tokens,De),Oe+=this.renderer.listitem(Ze,oe,X);R+=this.renderer.list(Oe,qe,it);continue}case"html":{R+=this.renderer.html(ke.text);continue}case"paragraph":{R+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Oe=ke.tokens?this.parseInline(ke.tokens):ke.text;H+1<Ve&&A[H+1].type==="text";)ke=A[++H],Oe+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);R+=D?this.renderer.paragraph(Oe):Oe;continue}default:{var Ye='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return R},ce.parseInline=function(A,D){D=D||this.renderer;var R="",H,Q,te,de=A.length;for(H=0;H<de;H++){if(Q=A[H],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(te=this.options.extensions.renderers[Q.type].call({parser:this},Q),te!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Q.type))){R+=te||"";continue}switch(Q.type){case"escape":{R+=D.text(Q.text);break}case"html":{R+=D.html(Q.text);break}case"link":{R+=D.link(Q.href,Q.title,this.parseInline(Q.tokens,D));break}case"image":{R+=D.image(Q.href,Q.title,Q.text);break}case"strong":{R+=D.strong(this.parseInline(Q.tokens,D));break}case"em":{R+=D.em(this.parseInline(Q.tokens,D));break}case"codespan":{R+=D.codespan(Q.text);break}case"br":{R+=D.br();break}case"del":{R+=D.del(this.parseInline(Q.tokens,D));break}case"text":{R+=D.text(Q.text);break}default:{var Se='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Se);return}else throw new Error(Se)}}}return R},ve}();function Ee(ve,ce,M){if(typeof ve=="undefined"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof ce=="function"&&(M=ce,ce=null),ce=h({},Ee.defaults,ce||{}),I(ce),M){var A=ce.highlight,D;try{D=Y.lex(ve,ce)}catch(te){return M(te)}var R=function(de){var Se;if(!de)try{ce.walkTokens&&Ee.walkTokens(D,ce.walkTokens),Se=he.parse(D,ce)}catch(Ae){de=Ae}return ce.highlight=A,de?M(de):M(null,Se)};if(!A||A.length<3||(delete ce.highlight,!D.length))return R();var H=0;Ee.walkTokens(D,function(te){te.type==="code"&&(H++,setTimeout(function(){A(te.text,te.lang,function(de,Se){if(de)return R(de);Se!=null&&Se!==te.text&&(te.text=Se,te.escaped=!0),H--,H===0&&R()})},0))}),H===0&&R();return}try{var Q=Y.lex(ve,ce);return ce.walkTokens&&Ee.walkTokens(Q,ce.walkTokens),he.parse(Q,ce)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+s(te.message+"",!0)+"</pre>";throw te}}Ee.options=Ee.setOptions=function(ve){return h(Ee.defaults,ve),F(Ee.defaults),Ee},Ee.getDefaults=x,Ee.defaults=Z.defaults,Ee.use=function(){for(var ve=arguments.length,ce=new Array(ve),M=0;M<ve;M++)ce[M]=arguments[M];var A=h.apply(void 0,[{}].concat(ce)),D=Ee.defaults.extensions||{renderers:{},childTokens:{}},R;ce.forEach(function(H){if(H.extensions&&(R=!0,H.extensions.forEach(function(te){if(!te.name)throw new Error("extension name required");if(te.renderer){var de=D.renderers?D.renderers[te.name]:null;de?D.renderers[te.name]=function(){for(var Se=arguments.length,Ae=new Array(Se),Fe=0;Fe<Se;Fe++)Ae[Fe]=arguments[Fe];var Ue=te.renderer.apply(this,Ae);return Ue===!1&&(Ue=de.apply(this,Ae)),Ue}:D.renderers[te.name]=te.renderer}if(te.tokenizer){if(!te.level||te.level!=="block"&&te.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");D[te.level]?D[te.level].unshift(te.tokenizer):D[te.level]=[te.tokenizer],te.start&&(te.level==="block"?D.startBlock?D.startBlock.push(te.start):D.startBlock=[te.start]:te.level==="inline"&&(D.startInline?D.startInline.push(te.start):D.startInline=[te.start]))}te.childTokens&&(D.childTokens[te.name]=te.childTokens)})),H.renderer&&function(){var te=Ee.defaults.renderer||new se,de=function(Fe){var Ue=te[Fe];te[Fe]=function(){for(var Oe=arguments.length,ke=new Array(Oe),qe=0;qe<Oe;qe++)ke[qe]=arguments[qe];var it=H.renderer[Fe].apply(te,ke);return it===!1&&(it=Ue.apply(te,ke)),it}};for(var Se in H.renderer)de(Se);A.renderer=te}(),H.tokenizer&&function(){var te=Ee.defaults.tokenizer||new U,de=function(Fe){var Ue=te[Fe];te[Fe]=function(){for(var Oe=arguments.length,ke=new Array(Oe),qe=0;qe<Oe;qe++)ke[qe]=arguments[qe];var it=H.tokenizer[Fe].apply(te,ke);return it===!1&&(it=Ue.apply(te,ke)),it}};for(var Se in H.tokenizer)de(Se);A.tokenizer=te}(),H.walkTokens){var Q=Ee.defaults.walkTokens;A.walkTokens=function(te){H.walkTokens.call(this,te),Q&&Q.call(this,te)}}R&&(A.extensions=D),Ee.setOptions(A)})},Ee.walkTokens=function(ve,ce){for(var M=function(){var H=D.value;switch(ce.call(Ee,H),H.type){case"table":{for(var Q=C(H.header),te;!(te=Q()).done;){var de=te.value;Ee.walkTokens(de.tokens,ce)}for(var Se=C(H.rows),Ae;!(Ae=Se()).done;)for(var Fe=Ae.value,Ue=C(Fe),Oe;!(Oe=Ue()).done;){var ke=Oe.value;Ee.walkTokens(ke.tokens,ce)}break}case"list":{Ee.walkTokens(H.items,ce);break}default:Ee.defaults.extensions&&Ee.defaults.extensions.childTokens&&Ee.defaults.extensions.childTokens[H.type]?Ee.defaults.extensions.childTokens[H.type].forEach(function(qe){Ee.walkTokens(H[qe],ce)}):H.tokens&&Ee.walkTokens(H.tokens,ce)}},A=C(ve),D;!(D=A()).done;)M()},Ee.parseInline=function(ve,ce){if(typeof ve=="undefined"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");ce=h({},Ee.defaults,ce||{}),I(ce);try{var M=Y.lexInline(ve,ce);return ce.walkTokens&&Ee.walkTokens(M,ce.walkTokens),he.parseInline(M,ce)}catch(A){if(A.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+s(A.message+"",!0)+"</pre>";throw A}},Ee.Parser=he,Ee.parser=he.parse,Ee.Renderer=se,Ee.TextRenderer=le,Ee.Lexer=Y,Ee.lexer=Y.lex,Ee.Tokenizer=U,Ee.Slugger=re,Ee.parse=Ee;var Ce=Ee.options,Pe=Ee.setOptions,Be=Ee.use,je=Ee.walkTokens,tt=Ee.parseInline,Ge=Ee,ot=he.parse,mt=Y.lex;Z.Lexer=Y,Z.Parser=he,Z.Renderer=se,Z.Slugger=re,Z.TextRenderer=le,Z.Tokenizer=U,Z.getDefaults=x,Z.lexer=mt,Z.marked=Ee,Z.options=Ce,Z.parse=Ge,Z.parseInline=tt,Z.parser=ot,Z.setOptions=Pe,Z.use=Be,Z.walkTokens=je,Object.defineProperty(Z,"__esModule",{value:!0})}),define(me[99],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(F,y,L){return Math.min(Math.max(F,y),L)}e.clamp=n;function O(F,y){return(y+F%y)%y}e.rot=O;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class C{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=C;class x{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const L=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=L,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=x}),function(){function Z(_){const C=[];typeof _=="number"&&C.push("code/timeOrigin",_);function x(y){C.push(y,Date.now())}function F(){const y=[];for(let L=0;L<C.length;L+=2)y.push({name:C[L],startTime:C[L+1]});return y}return{mark:x,getMarks:F}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const x of performance.getEntriesByType("mark"))C.push({name:x.name,startTime:Math.round(_+x.startTime)});return C}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function n(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=n(O))}(),define(me[68],ge([1,0,19]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var O;(function(g){g.text="text/plain",g.binary="application/octet-stream",g.unknown="application/unknown",g.markdown="text/markdown",g.latex="text/latex"})(O=e.Mimes||(e.Mimes={}));const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function x(g){const t=(0,n.extname)(g),d=_[t.toLowerCase()];return d!==void 0?d:F(g)}e.getMediaOrTextMime=x;function F(g){const t=(0,n.extname)(g);return C[t.toLowerCase()]}e.getMediaMime=F;function y(g){for(const t in C)if(C[t]===g)return t}e.getExtensionForMimeType=y;const L=/^(.+)\/(.+?)(;.+)?$/;function N(g,t){const d=L.exec(g);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:t?void 0:g}e.normalizeMimeType=N}),define(me[100],ge([1,0,15,7]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(E){const r=E;return r?[r.on,r.pause,r.resume,r.destroy].every(S=>typeof S=="function"):!1}e.isReadableStream=_;function C(E){const r=E;return r?_(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=C;function x(E,r){return new F(E,r)}e.newWriteableStream=x;class F{constructor(r,S){this.reducer=r,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(S=>S(r))}emitError(r){this.listeners.error.length===0?(0,n.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(S=>S(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,S){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(r,S){if(this.state.destroyed)return;let i;switch(r){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const T=i.indexOf(S);T>=0&&i.splice(T,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(E,r){const S=[];let i;for(;(i=E.read())!==null;)S.push(i);return r(S)}e.consumeReadable=y;function L(E,r,S){const i=[];let T;for(;(T=E.read())!==null&&i.length<S;)i.push(T);return T===null&&i.length>0?r(i):{read:()=>{if(i.length>0)return i.shift();if(typeof T!="undefined"){const o=T;return T=void 0,o}return E.read()}}}e.peekReadable=L;function N(E,r){return new Promise((S,i)=>{const T=[];g(E,{onData:o=>{r&&T.push(o)},onError:o=>{r?i(o):S(void 0)},onEnd:()=>{S(r?r(T):void 0)}})})}e.consumeStream=N;function g(E,r){let S=!1;return E.on("error",i=>{S||r.onError(i)}),E.on("end",()=>{S||r.onEnd()}),E.on("data",i=>{S||r.onData(i)}),(0,O.toDisposable)(()=>S=!0)}e.listenStream=g;function t(E,r){return new Promise((S,i)=>{const T=new O.DisposableStore,o=[],c=h=>{if(o.push(h),o.length>r)return T.dispose(),E.pause(),S({stream:E,buffer:o,ended:!1})},w=h=>i(h),f=()=>S({stream:E,buffer:o,ended:!0});T.add((0,O.toDisposable)(()=>E.removeListener("error",w))),E.on("error",w),T.add((0,O.toDisposable)(()=>E.removeListener("end",f))),E.on("end",f),T.add((0,O.toDisposable)(()=>E.removeListener("data",c))),E.on("data",c)})}e.peekStream=t;function d(E,r){const S=x(r);return S.end(E),S}e.toStream=d;function s(){const E=x(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=s;function a(E){let r=!1;return{read:()=>r?null:(r=!0,E)}}e.toReadable=a;function l(E,r,S){const i=x(S);return g(E,{onData:T=>i.write(r.data(T)),onError:T=>i.error(r.error?r.error(T):T),onEnd:()=>i.end()}),i}e.transform=l;function P(E,r,S){let i=!1;return{read:()=>{const T=r.read();return i?T:(i=!0,T!==null?S([E,T]):E)}}}e.prefixedReadable=P;function v(E,r,S){let i=!1;const T=x(S);return g(r,{onData:o=>i?T.write(o):(i=!0,T.write(S([E,o]))),onError:o=>T.error(o),onEnd:()=>{i||(i=!0,T.write(E)),T.end()}}),T}e.prefixedStream=v}),define(me[21],ge([1,0,100]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer!="undefined";let _,C;class x{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return O?new x(Buffer.allocUnsafe(p)):new x(new Uint8Array(p))}static wrap(p){return O&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new x(p)}static fromString(p,m){return!(m?.dontUseNodeBuffer||!1)&&O?new x(Buffer.from(p)):(_||(_=new TextEncoder),new x(_.encode(p)))}static fromByteArray(p){const m=x.alloc(p.length);for(let b=0,I=p.length;b<I;b++)m.buffer[b]=p[b];return m}static concat(p,m){if(typeof m=="undefined"){m=0;for(let k=0,$=p.length;k<$;k++)m+=p[k].byteLength}const b=x.alloc(m);let I=0;for(let k=0,$=p.length;k<$;k++){const u=p[k];b.set(u,I),I+=u.byteLength}return b}clone(){const p=x.alloc(this.byteLength);return p.set(this),p}toString(){return O?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(p,m){return new x(this.buffer.subarray(p,m))}set(p,m){if(p instanceof x)this.buffer.set(p.buffer,m);else if(p instanceof Uint8Array)this.buffer.set(p,m);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),m);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),m);else throw new Error("Unkown argument 'array'")}readUInt32BE(p){return L(this.buffer,p)}writeUInt32BE(p,m){N(this.buffer,p,m)}readUInt32LE(p){return g(this.buffer,p)}writeUInt32LE(p,m){t(this.buffer,p,m)}readUInt8(p){return d(this.buffer,p)}writeUInt8(p,m){s(this.buffer,p,m)}}e.VSBuffer=x;function F(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0}e.readUInt16LE=F;function y(h,p,m){h[m+0]=p&255,p=p>>>8,h[m+1]=p&255}e.writeUInt16LE=y;function L(h,p){return h[p]*2**24+h[p+1]*2**16+h[p+2]*2**8+h[p+3]}e.readUInt32BE=L;function N(h,p,m){h[m+3]=p,p=p>>>8,h[m+2]=p,p=p>>>8,h[m+1]=p,p=p>>>8,h[m]=p}e.writeUInt32BE=N;function g(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0|h[p+2]<<16>>>0|h[p+3]<<24>>>0}e.readUInt32LE=g;function t(h,p,m){h[m+0]=p&255,p=p>>>8,h[m+1]=p&255,p=p>>>8,h[m+2]=p&255,p=p>>>8,h[m+3]=p&255}e.writeUInt32LE=t;function d(h,p){return h[p]}e.readUInt8=d;function s(h,p,m){h[m]=p}e.writeUInt8=s;function a(h){return n.consumeReadable(h,p=>x.concat(p))}e.readableToBuffer=a;function l(h){return n.toReadable(h)}e.bufferToReadable=l;function P(h){return n.consumeStream(h,p=>x.concat(p))}e.streamToBuffer=P;async function v(h){return h.ended?x.concat(h.buffer):x.concat([...h.buffer,await P(h.stream)])}e.bufferedStreamToBuffer=v;function E(h){return n.toStream(h,p=>x.concat(p))}e.bufferToStream=E;function r(h){return n.transform(h,{data:p=>typeof p=="string"?x.fromString(p):x.wrap(p)},p=>x.concat(p))}e.streamToBufferReadableStream=r;function S(h){return n.newWriteableStream(p=>x.concat(p),h)}e.newWriteableBufferStream=S;function i(h,p){return n.prefixedReadable(h,p,m=>x.concat(m))}e.prefixedBufferReadable=i;function T(h,p){return n.prefixedStream(h,p,m=>x.concat(m))}e.prefixedBufferStream=T;function o(h){let p=0,m=0,b=0;const I=new Uint8Array(Math.floor(h.length/4*3)),k=u=>{switch(m){case 3:I[b++]=p|u,m=0;break;case 2:I[b++]=p|u>>>2,p=u<<6,m=3;break;case 1:I[b++]=p|u>>>4,p=u<<4,m=2;break;default:p=u<<2,m=1}};for(let u=0;u<h.length;u++){const U=h.charCodeAt(u);if(U>=65&&U<=90)k(U-65);else if(U>=97&&U<=122)k(U-97+26);else if(U>=48&&U<=57)k(U-48+52);else if(U===43||U===45)k(62);else if(U===47||U===95)k(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${h[u]}`)}}const $=b;for(;m>0;)k(0);return x.wrap(I).slice(0,$)}e.decodeBase64=o;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:h},p=!0,m=!1){const b=m?w:c;let I="";const k=h.byteLength%3;let $=0;for(;$<h.byteLength-k;$+=3){const u=h[$+0],U=h[$+1],z=h[$+2];I+=b[u>>>2],I+=b[(u<<4|U>>>4)&63],I+=b[(U<<2|z>>>6)&63],I+=b[z&63]}if(k===1){const u=h[$+0];I+=b[u>>>2],I+=b[u<<4&63],p&&(I+="==")}else if(k===2){const u=h[$+0],U=h[$+1];I+=b[u>>>2],I+=b[(u<<4|U>>>4)&63],I+=b[U<<2&63],p&&(I+="=")}return I}e.encodeBase64=f}),define(me[101],ge([1,0,22,14]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...D){return function(R,H){for(let Q=0,te=D.length;Q<te;Q++){const de=D[Q](R,H);if(de)return de}return null}}e.or=_,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(D,R,H){if(!H||H.length<R.length)return null;let Q;return D?Q=O.startsWithIgnoreCase(H,R):Q=H.indexOf(R)===0,Q?R.length>0?[{start:0,end:R.length}]:[]:null}function x(D,R){const H=R.toLowerCase().indexOf(D.toLowerCase());return H===-1?null:[{start:H,end:H+D.length}]}e.matchesContiguousSubString=x;function F(D,R){return y(D.toLowerCase(),R.toLowerCase(),0,0)}e.matchesSubString=F;function y(D,R,H,Q){if(H===D.length)return[];if(Q===R.length)return null;if(D[H]===R[Q]){let te=null;return(te=y(D,R,H+1,Q+1))?P({start:Q,end:Q+1},te):null}return y(D,R,H,Q+1)}function L(D){return 97<=D&&D<=122}function N(D){return 65<=D&&D<=90}e.isUpper=N;function g(D){return 48<=D&&D<=57}function t(D){return D===32||D===9||D===10||D===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(D=>d.add(D.charCodeAt(0)));function s(D){return t(D)||d.has(D)}function a(D,R){return D===R||s(D)&&s(R)}function l(D){return L(D)||N(D)||g(D)}function P(D,R){return R.length===0?R=[D]:D.end===R[0].start?R[0].start=D.start:R.unshift(D),R}function v(D,R){for(let H=R;H<D.length;H++){const Q=D.charCodeAt(H);if(N(Q)||g(Q)||H>0&&!l(D.charCodeAt(H-1)))return H}return D.length}function E(D,R,H,Q){if(H===D.length)return[];if(Q===R.length)return null;if(D[H]!==R[Q].toLowerCase())return null;{let te=null,de=Q+1;for(te=E(D,R,H+1,Q+1);!te&&(de=v(R,de))<R.length;)te=E(D,R,H+1,de),de++;return te===null?null:P({start:Q,end:Q+1},te)}}function r(D){let R=0,H=0,Q=0,te=0,de=0;for(let Oe=0;Oe<D.length;Oe++)de=D.charCodeAt(Oe),N(de)&&R++,L(de)&&H++,l(de)&&Q++,g(de)&&te++;const Se=R/D.length,Ae=H/D.length,Fe=Q/D.length,Ue=te/D.length;return{upperPercent:Se,lowerPercent:Ae,alphaPercent:Fe,numericPercent:Ue}}function S(D){const{upperPercent:R,lowerPercent:H}=D;return H===0&&R>.6}function i(D){const{upperPercent:R,lowerPercent:H,alphaPercent:Q,numericPercent:te}=D;return H>.2&&R<.8&&Q>.6&&te<.2}function T(D){let R=0,H=0,Q=0,te=0;for(let de=0;de<D.length;de++)Q=D.charCodeAt(de),N(Q)&&R++,L(Q)&&H++,t(Q)&&te++;return(R===0||H===0)&&te===0?D.length<=30:R<=5}function o(D,R){if(!R||(R=R.trim(),R.length===0)||!T(D)||R.length>60)return null;const H=r(R);if(!i(H)){if(!S(H))return null;R=R.toLowerCase()}let Q=null,te=0;for(D=D.toLowerCase();te<R.length&&(Q=E(D,R,0,te))===null;)te=v(R,te+1);return Q}e.matchesCamelCase=o;function c(D,R,H=!1){if(!R||R.length===0)return null;let Q=null,te=0;for(D=D.toLowerCase(),R=R.toLowerCase();te<R.length&&(Q=w(D,R,0,te,H))===null;)te=f(R,te+1);return Q}e.matchesWords=c;function w(D,R,H,Q,te){if(H===D.length)return[];if(Q===R.length)return null;if(a(D.charCodeAt(H),R.charCodeAt(Q))){let de=null,Se=Q+1;if(de=w(D,R,H+1,Q+1,te),!te)for(;!de&&(Se=f(R,Se))<R.length;)de=w(D,R,H+1,Se,te),Se++;return de===null?null:P({start:Q,end:Q+1},de)}else return null}function f(D,R){for(let H=R;H<D.length;H++)if(s(D.charCodeAt(H))||H>0&&s(D.charCodeAt(H-1)))return H;return D.length}const h=_(e.matchesPrefix,o,x),p=_(e.matchesPrefix,o,F),m=new n.LRUCache(1e4);function b(D,R,H=!1){if(typeof D!="string"||typeof R!="string")return null;let Q=m.get(D);Q||(Q=new RegExp(O.convertSimple2RegExpPattern(D),"i"),m.set(D,Q));const te=Q.exec(R);return te?[{start:te.index,end:te.index+te[0].length}]:H?p(D,R):h(D,R)}e.matchesFuzzy=b;function I(D,R){const H=Ge(D,D.toLowerCase(),0,R,R.toLowerCase(),0,!0);return H?$(H):null}e.matchesFuzzy2=I;function k(D,R,H,Q,te,de){const Se=Math.min(13,D.length);for(;H<Se;H++){const Ae=Ge(D,R,H,Q,te,de,!1);if(Ae)return Ae}return[0,de]}e.anyScore=k;function $(D){if(typeof D=="undefined")return[];const R=[],H=D[1];for(let Q=D.length-1;Q>1;Q--){const te=D[Q]+H,de=R[R.length-1];de&&de.end===te?de.end=te+1:R.push({start:te,end:te+1})}return R}e.createMatches=$;const u=128;function U(){const D=[],R=[];for(let H=0;H<=u;H++)R[H]=0;for(let H=0;H<=u;H++)D.push(R.slice(0));return D}function z(D){const R=[];for(let H=0;H<=D;H++)R[H]=0;return R}const q=z(2*u),V=z(2*u),j=U(),Y=U(),se=U(),le=!1;function re(D,R,H,Q,te){function de(Ae,Fe,Ue=" "){for(;Ae.length<Fe;)Ae=Ue+Ae;return Ae}let Se=` |   |${Q.split("").map(Ae=>de(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=H;Ae++)Ae===0?Se+=" |":Se+=`${R[Ae-1]}|`,Se+=D[Ae].slice(0,te+1).map(Fe=>de(Fe.toString(),3)).join("|")+`
`;return Se}function he(D,R,H,Q){D=D.substr(R),H=H.substr(Q),console.log(re(Y,D,D.length,H,H.length)),console.log(re(se,D,D.length,H,H.length)),console.log(re(j,D,D.length,H,H.length))}function Ee(D,R){if(R<0||R>=D.length)return!1;const H=D.codePointAt(R);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!O.isEmojiImprecise(H)}}function Ce(D,R){if(R<0||R>=D.length)return!1;switch(D.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function Pe(D,R,H){return R[D]!==H[D]}function Be(D,R,H,Q,te,de,Se=!1){for(;R<H&&te<de;)D[R]===Q[te]&&(Se&&(q[R]=te),R+=1),te+=1;return R===H}e.isPatternInWord=Be;var je;(function(D){D[D.Diag=1]="Diag",D[D.Left=2]="Left",D[D.LeftLeft=3]="LeftLeft"})(je||(je={}));var tt;(function(D){D.Default=[-100,0];function R(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}D.isDefault=R})(tt=e.FuzzyScore||(e.FuzzyScore={}));function Ge(D,R,H,Q,te,de,Se){const Ae=D.length>u?u:D.length,Fe=Q.length>u?u:Q.length;if(H>=Ae||de>=Fe||Ae-H>Fe-de||!Be(R,H,Ae,te,de,Fe,!0))return;ot(Ae,Fe,H,de,R,te);let Ue=1,Oe=1,ke=H,qe=de;const it=[!1];for(Ue=1,ke=H;ke<Ae;Ue++,ke++){const oe=q[ke],Ie=V[ke],Ne=ke+1<Ae?V[ke+1]:Fe;for(Oe=oe-de+1,qe=oe;qe<Ne;Oe++,qe++){let Ve=Number.MIN_SAFE_INTEGER,Ye=!1;qe<=Ie&&(Ve=mt(D,R,ke,H,Q,te,qe,Fe,de,j[Ue-1][Oe-1]===0,it));let ht=0;Ve!==Number.MAX_SAFE_INTEGER&&(Ye=!0,ht=Ve+Y[Ue-1][Oe-1]);const _t=qe>oe,Dt=_t?Y[Ue][Oe-1]+(j[Ue][Oe-1]>0?-5:0):0,He=qe>oe+1&&j[Ue][Oe-1]>0,Pt=He?Y[Ue][Oe-2]+(j[Ue][Oe-2]>0?-5:0):0;if(He&&(!_t||Pt>=Dt)&&(!Ye||Pt>=ht))Y[Ue][Oe]=Pt,se[Ue][Oe]=3,j[Ue][Oe]=0;else if(_t&&(!Ye||Dt>=ht))Y[Ue][Oe]=Dt,se[Ue][Oe]=2,j[Ue][Oe]=0;else if(Ye)Y[Ue][Oe]=ht,se[Ue][Oe]=1,j[Ue][Oe]=j[Ue-1][Oe-1]+1;else throw new Error("not possible")}}if(le&&he(D,H,Q,de),!it[0]&&!Se)return;Ue--,Oe--;const De=[Y[Ue][Oe],de];let Ze=0,G=0;for(;Ue>=1;){let oe=Oe;do{const Ie=se[Ue][oe];if(Ie===3)oe=oe-2;else if(Ie===2)oe=oe-1;else break}while(oe>=1);Ze>1&&R[H+Ue-1]===te[de+Oe-1]&&!Pe(oe+de-1,Q,te)&&Ze+1>j[Ue][oe]&&(oe=Oe),oe===Oe?Ze++:Ze=1,G||(G=oe),Ue--,Oe=oe-1,De.push(Oe)}Fe===Ae&&(De[0]+=2);const X=G-Ae;return De[0]-=X,De}e.fuzzyScore=Ge;function ot(D,R,H,Q,te,de){let Se=D-1,Ae=R-1;for(;Se>=H&&Ae>=Q;)te[Se]===de[Ae]&&(V[Se]=Ae,Se--),Ae--}function mt(D,R,H,Q,te,de,Se,Ae,Fe,Ue,Oe){if(R[H]!==de[Se])return Number.MIN_SAFE_INTEGER;let ke=1,qe=!1;return Se===H-Q?ke=D[H]===te[Se]?7:5:Pe(Se,te,de)&&(Se===0||!Pe(Se-1,te,de))?(ke=D[H]===te[Se]?7:5,qe=!0):Ee(de,Se)&&(Se===0||!Ee(de,Se-1))?ke=5:(Ee(de,Se-1)||Ce(de,Se-1))&&(ke=5,qe=!0),ke>1&&H===Q&&(Oe[0]=!0),qe||(qe=Pe(Se,te,de)||Ee(de,Se-1)||Ce(de,Se-1)),H===Q?Se>Fe&&(ke-=qe?3:5):Ue?ke+=qe?2:0:ke+=qe?0:1,Se+1===Ae&&(ke-=qe?3:5),ke}function ve(D,R,H,Q,te,de,Se){return M(D,R,H,Q,te,de,!0,Se)}e.fuzzyScoreGracefulAggressive=ve;function ce(D,R,H,Q,te,de,Se){return M(D,R,H,Q,te,de,!1,Se)}e.fuzzyScoreGraceful=ce;function M(D,R,H,Q,te,de,Se,Ae){let Fe=Ge(D,R,H,Q,te,de,Ae);if(Fe&&!Se)return Fe;if(D.length>=3){const Ue=Math.min(7,D.length-1);for(let Oe=H+1;Oe<Ue;Oe++){const ke=A(D,Oe);if(ke){const qe=Ge(ke,ke.toLowerCase(),H,Q,te,de,Ae);qe&&(qe[0]-=3,(!Fe||qe[0]>Fe[0])&&(Fe=qe))}}}return Fe}function A(D,R){if(R+1>=D.length)return;const H=D[R],Q=D[R+1];if(H!==Q)return D.slice(0,R)+Q+H+D.slice(R+2)}}),define(me[102],ge([1,0,103,101,14]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?\\)`,"g"),x=new RegExp(n.CSSIcon.iconNameCharacter),F=new RegExp(`(\\\\)?${C.source}`,"g");function y(l){return l.replace(F,(P,v)=>v?P:`\\${P}`)}e.escapeIcons=y;const L=new RegExp(`\\\\${C.source}`,"g");function N(l){return l.replace(L,P=>`\\${P}`)}e.markdownEscapeEscapedIcons=N;const g=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function t(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(g,(P,v,E,r)=>E?P:v||r||"")}e.stripIcons=t;function d(l){const P=l.indexOf(e.iconStartMarker);return P===-1?{text:l}:s(l,P)}e.parseLabelWithIcons=d;function s(l,P){const v=[];let E="";function r(h){if(h){E+=h;for(const p of h)v.push(T)}}let S=-1,i="",T=0,o,c,w=P;const f=l.length;for(r(l.substr(0,P));w<f;)o=l[w],c=l[w+1],o===e.iconStartMarker[0]&&c===e.iconStartMarker[1]?(S=w,r(i),i=e.iconStartMarker,w++):o===")"&&S!==-1?(T+=w-S+1,S=-1,i=""):S!==-1?x.test(o)?i+=o:(r(i),S=-1,i=""):r(o),w++;return r(i),{text:E,iconOffsets:v}}function a(l,P,v=!1){const{text:E,iconOffsets:r}=P;if(!r||r.length===0)return(0,O.matchesFuzzy)(l,E,v);const S=(0,_.ltrim)(E," "),i=E.length-S.length,T=(0,O.matchesFuzzy)(l,S,v);if(T)for(const o of T){const c=r[o.start+i]+i;o.start+=c,o.end+=c}return T}e.matchesFuzzyIconAware=a}),define(me[69],ge([1,0,15,102]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(d="",s=!1){if(this.value=d,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(d,s=0){return this.value+=L(this.supportThemeIcons?(0,O.escapeIcons)(d):d).replace(/([ \t]+)/g,(a,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,s){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}}e.MarkdownString=C;function x(t){return F(t)?!t.value:Array.isArray(t)?t.every(x):!0}e.isEmptyMarkdownString=x;function F(t){return t instanceof C?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=F;function y(t,d){return t===d?!0:!t||!d?!1:t.value===d.value&&t.isTrusted===d.isTrusted&&t.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=y;function L(t){return t.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=L;function N(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=N;function g(t){const d=[],s=t.split("|").map(l=>l.trim());t=s[0];const a=s[1];if(a){const l=/height=(\d+)/.exec(a),P=/width=(\d+)/.exec(a),v=l?l[1]:"",E=P?P[1]:"",r=isFinite(parseInt(E)),S=isFinite(parseInt(v));r&&d.push(`width="${E}"`),S&&d.push(`height="${v}"`)}return{href:t,dimensions:d}}e.parseHrefAndDimensions=g}),define(me[33],ge([1,0,14]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(O||(O={})),function(_){const C="error",x="warning",F="warn",y="info",L="ignore";function N(t){return t?n.equalsIgnoreCase(C,t)?_.Error:n.equalsIgnoreCase(x,t)||n.equalsIgnoreCase(F,t)?_.Warning:n.equalsIgnoreCase(y,t)?_.Info:_.Ignore:_.Ignore}_.fromValue=N;function g(t){switch(t){case _.Error:return C;case _.Warning:return x;case _.Info:return y;default:return L}}_.toString=g}(O||(O={})),e.default=O}),define(me[52],ge([1,0,21,14,2]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(N){return JSON.stringify(N,y)}e.stringify=C;function x(N){let g=JSON.parse(N);return g=L(g),g}e.parse=x;var F;(function(N){N[N.Uri=1]="Uri",N[N.Regexp=2]="Regexp",N[N.ScmResource=3]="ScmResource",N[N.ScmResourceGroup=4]="ScmResourceGroup",N[N.ScmProvider=5]="ScmProvider",N[N.CommentController=6]="CommentController",N[N.CommentThread=7]="CommentThread",N[N.CommentThreadReply=8]="CommentThreadReply",N[N.CommentNode=9]="CommentNode",N[N.CommentThreadNode=10]="CommentThreadNode",N[N.TimelineActionContext=11]="TimelineActionContext",N[N.NotebookCellActionContext=12]="NotebookCellActionContext",N[N.TestItemContext=13]="TestItemContext",N[N.Date=14]="Date"})(F=e.MarshalledId||(e.MarshalledId={}));function y(N,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:(0,O.regExpFlags)(g)}:g}function L(N,g=0){if(!N||g>200)return N;if(typeof N=="object"){switch(N.$mid){case 1:return _.URI.revive(N);case 2:return new RegExp(N.source,N.flags);case 14:return new Date(N.source)}if(N instanceof n.VSBuffer||N instanceof Uint8Array)return N;if(Array.isArray(N))for(let t=0;t<N.length;++t)N[t]=L(N[t],g+1);else for(const t in N)Object.hasOwnProperty.call(N,t)&&(N[t]=L(N[t],g+1))}return N}e.revive=L}),define(me[104],ge([1,0,10,19]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new n.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),C=new n.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),x=new n.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function F(m,b,I=!1){const k=m||"",$=b||"",u=_.value.collator.compare(k,$);return _.value.collatorIsNumeric&&u===0&&k!==$?k<$?-1:1:u}e.compareFileNames=F;function y(m,b){const I=C.value.collator;return m=m||"",b=b||"",S(I,m,b)}e.compareFileNamesDefault=y;function L(m,b){const I=C.value.collator;return m=m||"",b=b||"",c(m,b)||S(I,m,b)}e.compareFileNamesUpper=L;function N(m,b){const I=C.value.collator;return m=m||"",b=b||"",o(m,b)||S(I,m,b)}e.compareFileNamesLower=N;function g(m,b){return m=m||"",b=b||"",m===b?0:m<b?-1:1}e.compareFileNamesUnicode=g;function t(m,b,I=!1){I||(m=m&&m.toLowerCase(),b=b&&b.toLowerCase());const[k,$]=E(m),[u,U]=E(b);return k!==u?k<u?-1:1:$===U?0:$<U?-1:1}e.noIntlCompareFileNames=t;function d(m,b){const[I,k]=E(m),[$,u]=E(b);let U=_.value.collator.compare(k,u);if(U===0){if(_.value.collatorIsNumeric&&k!==u)return k<u?-1:1;if(U=_.value.collator.compare(I,$),_.value.collatorIsNumeric&&U===0&&I!==$)return I<$?-1:1}return U}e.compareFileExtensions=d;function s(m,b){m=m||"",b=b||"";const I=r(m),k=r(b),$=C.value.collator,u=x.value.collator;return S(u,I,k)||S($,m,b)}e.compareFileExtensionsDefault=s;function a(m,b){m=m||"",b=b||"";const I=r(m),k=r(b),$=C.value.collator,u=x.value.collator;return S(u,I,k)||c(m,b)||S($,m,b)}e.compareFileExtensionsUpper=a;function l(m,b){m=m||"",b=b||"";const I=r(m),k=r(b),$=C.value.collator,u=x.value.collator;return S(u,I,k)||o(m,b)||S($,m,b)}e.compareFileExtensionsLower=l;function P(m,b){m=m||"",b=b||"";const I=r(m).toLowerCase(),k=r(b).toLowerCase();return I!==k?I<k?-1:1:m!==b?m<b?-1:1:0}e.compareFileExtensionsUnicode=P;const v=/^(.*?)(\.([^.]*))?$/;function E(m,b=!1){const I=m?v.exec(m):[];let k=[I&&I[1]||"",I&&I[3]||""];return b&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function r(m){const b=m?v.exec(m):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function S(m,b,I){let k=m.compare(b,I);return k!==0?k:b.length!==I.length?b.length<I.length?-1:1:0}function i(m){const b=m.charAt(0);return b.toLocaleUpperCase()!==b}function T(m){const b=m.charAt(0);return b.toLocaleLowerCase()!==b}function o(m,b){return i(m)&&T(b)?-1:T(m)&&i(b)?1:0}function c(m,b){return T(m)&&i(b)?-1:i(m)&&T(b)?1:0}function w(m,b,I=!1){return I||(m=m&&m.toLowerCase(),b=b&&b.toLowerCase()),m===b?0:m<b?-1:1}function f(m,b,I=!1){const k=m.split(O.sep),$=b.split(O.sep),u=k.length-1,U=$.length-1;let z,q;for(let V=0;;V++){if(z=u===V,q=U===V,z&&q)return F(k[V],$[V],I);if(z)return-1;if(q)return 1;const j=w(k[V],$[V],I);if(j!==0)return j}}e.comparePaths=f;function h(m,b,I){const k=m.toLowerCase(),$=b.toLowerCase(),u=p(m,b,I);if(u)return u;const U=k.endsWith(I),z=$.endsWith(I);if(U!==z)return U?-1:1;const q=F(k,$);return q!==0?q:k.localeCompare($)}e.compareAnything=h;function p(m,b,I){const k=m.toLowerCase(),$=b.toLowerCase(),u=k.startsWith(I),U=$.startsWith(I);if(u!==U)return u?-1:1;if(u&&U){if(k.length<$.length)return-1;if(k.length>$.length)return 1}return 0}e.compareByPrefix=p}),define(me[70],ge([1,0,71,11,19,28,24,14,2]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function L(c,w,f){if(typeof c=="string"&&(c=y.URI.file(c)),f){const p=f.getWorkspaceFolder(c);if(p){const m=f.getWorkspace().folders.length>1;let b;if((0,x.isEqual)(p.uri,c)?b="":b=(0,x.relativePath)(p.uri,c),m){const I=p.name?p.name:(0,x.basename)(p.uri);b=b?I+" \u2022 "+b:I}return b}}if(c.scheme!==O.Schemas.file&&c.scheme!==O.Schemas.untitled)return c.with({query:null,fragment:null}).toString(!0);if((0,n.hasDriveLetter)(c.fsPath))return(0,_.normalize)(g(c.fsPath));let h=(0,_.normalize)(c.fsPath);return!C.isWindows&&w?.userHome&&(h=d(h,w.userHome.fsPath)),h}e.getPathLabel=L;function N(c){if(!c)return;typeof c=="string"&&(c=y.URI.file(c));const w=(0,x.basename)(c)||(c.scheme===O.Schemas.file?c.fsPath:c.path);return C.isWindows&&(0,n.isRootOrDriveLetter)(w)?g(w):w}e.getBaseLabel=N;function g(c,w){return(0,n.hasDriveLetter)(c,w)?c.charAt(0).toUpperCase()+c.slice(1):c}e.normalizeDriveLetter=g;let t=Object.create(null);function d(c,w){if(C.isWindows||!c||!w)return c;let f=t.original===w?t.normalized:void 0;return f||(f=`${(0,F.rtrim)(w,_.posix.sep)}${_.posix.sep}`,t={original:w,normalized:f}),(C.isLinux?c.startsWith(f):(0,F.startsWithIgnoreCase)(c,f))&&(c=`~/${c.substr(f.length)}`),c}e.tildify=d;function s(c,w){return c.replace(/^~($|\/|\\)/,`${w}$1`)}e.untildify=s;const a="\u2026",l="\\\\",P="~";function v(c,w=_.sep){const f=new Array(c.length);let h=!1;for(let p=0;p<c.length;p++){let m=c[p];if(m===""){f[p]=`.${w}`;continue}if(!m){f[p]=m;continue}h=!0;let b="";m.indexOf(l)===0?(b=m.substr(0,m.indexOf(l)+l.length),m=m.substr(m.indexOf(l)+l.length)):m.indexOf(w)===0?(b=m.substr(0,m.indexOf(w)+w.length),m=m.substr(m.indexOf(w)+w.length)):m.indexOf(P)===0&&(b=m.substr(0,m.indexOf(P)+P.length),m=m.substr(m.indexOf(P)+P.length));const I=m.split(w);for(let k=1;h&&k<=I.length;k++)for(let $=I.length-k;h&&$>=0;$--){h=!1;let u=I.slice($,$+k).join(w);for(let U=0;!h&&U<c.length;U++)if(U!==p&&c[U]&&c[U].indexOf(u)>-1){const z=$+k===I.length,q=$>0&&c[U].indexOf(w)>-1?w+u:u,V=c[U].endsWith(q);h=!z||V}if(!h){let U="";(I[0].endsWith(":")||b!=="")&&($===1&&($=0,k++,u=I[0]+w+u),$>0&&(U=I[0]+w),U=b+U),$>0&&(U=U+a+w),U=U+u,$+k<I.length&&(U=U+w+a),f[p]=U}}h&&(f[p]=m)}return f}e.shorten=v;var E;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function r(c,w=Object.create(null)){const f=[];let h=!1,p="";for(const m of c)if(m==="$"||h&&m==="{")p&&f.push({value:p,type:E.TEXT}),p="",h=!0;else if(m==="}"&&h){const b=w[p];if(typeof b=="string")b.length&&f.push({value:b,type:E.VARIABLE});else if(b){const I=f[f.length-1];(!I||I.type!==E.SEPARATOR)&&f.push({value:b.label,type:E.SEPARATOR})}p="",h=!1}else p+=m;return p&&!h&&f.push({value:p,type:E.TEXT}),f.filter((m,b)=>{if(m.type===E.SEPARATOR){const I=f[b-1],k=f[b+1];return[I,k].every($=>$&&($.type===E.VARIABLE||$.type===E.TEXT)&&$.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=r;function S(c,w){return C.isMacintosh||w?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):c.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function i(c,w){return C.isMacintosh||w?c.replace(/\(&&\w\)|&&/g,""):C.isWindows?c.replace(/&&|&/g,f=>f==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function T(c){return c.replace(/&/g,"&&")}e.unmnemonicLabel=T;function o(c){const w=c.indexOf("/")!==-1?_.posix:_.win32,f=w.basename(c),h=w.dirname(c);return f.length?{name:f,parentPath:h}:{name:h,parentPath:""}}e.splitName=o}),define(me[105],ge([1,0,2]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function O(N){return N.toJSON()}class _{constructor(g){this._uriTransformer=g}transformIncoming(g){const t=this._uriTransformer.transformIncoming(g);return t===g?g:O(n.URI.from(t))}transformOutgoing(g){const t=this._uriTransformer.transformOutgoing(g);return t===g?g:O(n.URI.from(t))}transformOutgoingURI(g){const t=this._uriTransformer.transformOutgoing(g);return t===g?g:n.URI.from(t)}transformOutgoingScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function C(N,g,t){if(!N||t>200)return null;if(typeof N=="object"){if(N instanceof n.URI)return g.transformOutgoing(N);for(let d in N)if(Object.hasOwnProperty.call(N,d)){const s=C(N[d],g,t+1);s!==null&&(N[d]=s)}}return null}function x(N,g){const t=C(N,g,0);return t===null?N:t}e.transformOutgoingURIs=x;function F(N,g,t,d){if(!N||d>200)return null;if(typeof N=="object"){if(N.$mid===1)return t?n.URI.revive(g.transformIncoming(N)):g.transformIncoming(N);for(let s in N)if(Object.hasOwnProperty.call(N,s)){const a=F(N[s],g,t,d+1);a!==null&&(N[s]=a)}}return null}function y(N,g){const t=F(N,g,!1,0);return t===null?N:t}e.transformIncomingURIs=y;function L(N,g){const t=F(N,g,!0,0);return t===null?N:t}e.transformAndReviveIncomingURIs=L}),define(me[34],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(y){return n.test(y)}e.isUUID=O;const _=new Uint8Array(16),C=[];for(let y=0;y<256;y++)C.push(y.toString(16).padStart(2,"0"));let x;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?x=crypto.getRandomValues.bind(crypto):x=function(y){for(let L=0;L<y.length;L++)y[L]=Math.floor(Math.random()*256);return y};function F(){x(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let y=0,L="";return L+=C[_[y++]],L+=C[_[y++]],L+=C[_[y++]],L+=C[_[y++]],L+="-",L+=C[_[y++]],L+=C[_[y++]],L+="-",L+=C[_[y++]],L+=C[_[y++]],L+="-",L+=C[_[y++]],L+=C[_[y++]],L+="-",L+=C[_[y++]],L+=C[_[y++]],L+=C[_[y++]],L+=C[_[y++]],L+=C[_[y++]],L+=C[_[y++]],L}e.generateUuid=F}),define(me[106],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(me[107],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(x){x[x.None=0]="None",x[x.Indent=1]="Indent",x[x.IndentOutdent=2]="IndentOutdent",x[x.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class O{constructor(F){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=F.open,this.close=F.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(F.notIn))for(let y=0,L=F.notIn.length;y<L;y++)switch(F.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(F){switch(F){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(F,y){if(F.getTokenCount()===0)return!0;const L=F.findTokenIndexAtOffset(y-2),N=F.getStandardTokenType(L);return this.isOK(N)}_findNeutralCharacterInRange(F,y){for(let L=F;L<=y;L++){const N=String.fromCharCode(L);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=O;class _{constructor(F){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of F)C(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),C(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),C(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),C(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&C(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=_;function C(x,F,y){x.has(F)?x.get(F).push(y):x.set(F,[y])}}),define(me[72],ge([1,0,21,28]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(g){g[g.Full=1]="Full",g[g.Delta=2]="Delta"})(_||(_={}));function C(g){for(let t=0,d=g.length;t<d;t+=4){const s=g[t+0],a=g[t+1],l=g[t+2],P=g[t+3];g[t+0]=P,g[t+1]=l,g[t+2]=a,g[t+3]=s}}function x(g){const t=new Uint8Array(g.buffer,g.byteOffset,g.length*4);return O.isLittleEndian()||C(t),n.VSBuffer.wrap(t)}function F(g){const t=g.buffer;if(O.isLittleEndian()||C(t),t.byteOffset%4==0)return new Uint32Array(t.buffer,t.byteOffset,t.length/4);{const d=new Uint8Array(t.byteLength);return d.set(t),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function y(g){const t=new Uint32Array(L(g));let d=0;if(t[d++]=g.id,g.type==="full")t[d++]=1,t[d++]=g.data.length,t.set(g.data,d),d+=g.data.length;else{t[d++]=2,t[d++]=g.deltas.length;for(const s of g.deltas)t[d++]=s.start,t[d++]=s.deleteCount,s.data?(t[d++]=s.data.length,t.set(s.data,d),d+=s.data.length):t[d++]=0}return x(t)}e.encodeSemanticTokensDto=y;function L(g){let t=0;if(t+=1+1,g.type==="full")t+=1+g.data.length;else{t+=1,t+=(1+1+1)*g.deltas.length;for(const d of g.deltas)d.data&&(t+=d.data.length)}return t}function N(g){const t=F(g);let d=0;const s=t[d++];if(t[d++]===1){const v=t[d++],E=t.subarray(d,d+v);return d+=v,{id:s,type:"full",data:E}}const l=t[d++],P=[];for(let v=0;v<l;v++){const E=t[d++],r=t[d++],S=t[d++];let i;S>0&&(i=t.subarray(d,d+S),d+=S),P[v]={start:E,deleteCount:r,data:i}}return{id:s,type:"delta",deltas:P}}e.decodeSemanticTokensDto=N}),define(me[108],ge([17,18]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(me[109],ge([1,0,108]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,_=O*60,C=_*24,x=C*7,F=C*30,y=C*365;function L(g,t,d){typeof g!="number"&&(g=g.getTime());const s=Math.round((new Date().getTime()-g)/1e3);if(s<-30)return(0,n.localize)(0,null,L(new Date().getTime()+s*1e3,!1));if(s<30)return(0,n.localize)(1,null);let a;return s<O?(a=s,t?a===1?d?(0,n.localize)(2,null,a):(0,n.localize)(3,null,a):d?(0,n.localize)(4,null,a):(0,n.localize)(5,null,a):a===1?d?(0,n.localize)(6,null,a):(0,n.localize)(7,null,a):d?(0,n.localize)(8,null,a):(0,n.localize)(9,null,a)):s<_?(a=Math.floor(s/O),t?a===1?d?(0,n.localize)(10,null,a):(0,n.localize)(11,null,a):d?(0,n.localize)(12,null,a):(0,n.localize)(13,null,a):a===1?d?(0,n.localize)(14,null,a):(0,n.localize)(15,null,a):d?(0,n.localize)(16,null,a):(0,n.localize)(17,null,a)):s<C?(a=Math.floor(s/_),t?a===1?d?(0,n.localize)(18,null,a):(0,n.localize)(19,null,a):d?(0,n.localize)(20,null,a):(0,n.localize)(21,null,a):a===1?d?(0,n.localize)(22,null,a):(0,n.localize)(23,null,a):d?(0,n.localize)(24,null,a):(0,n.localize)(25,null,a)):s<x?(a=Math.floor(s/C),t?a===1?(0,n.localize)(26,null,a):(0,n.localize)(27,null,a):a===1?(0,n.localize)(28,null,a):(0,n.localize)(29,null,a)):s<F?(a=Math.floor(s/x),t?a===1?d?(0,n.localize)(30,null,a):(0,n.localize)(31,null,a):d?(0,n.localize)(32,null,a):(0,n.localize)(33,null,a):a===1?d?(0,n.localize)(34,null,a):(0,n.localize)(35,null,a):d?(0,n.localize)(36,null,a):(0,n.localize)(37,null,a)):s<y?(a=Math.floor(s/F),t?a===1?d?(0,n.localize)(38,null,a):(0,n.localize)(39,null,a):d?(0,n.localize)(40,null,a):(0,n.localize)(41,null,a):a===1?d?(0,n.localize)(42,null,a):(0,n.localize)(43,null,a):d?(0,n.localize)(44,null,a):(0,n.localize)(45,null,a)):(a=Math.floor(s/y),t?a===1?d?(0,n.localize)(46,null,a):(0,n.localize)(47,null,a):d?(0,n.localize)(48,null,a):(0,n.localize)(49,null,a):a===1?d?(0,n.localize)(50,null,a):(0,n.localize)(51,null,a):d?(0,n.localize)(52,null,a):(0,n.localize)(53,null,a))}e.fromNow=L;function N(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(me[110],ge([17,18]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(me[42],ge([1,0,16,13,110]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(L,N){return N&&(L.stack||L.stacktrace)?_.localize(0,null,F(L),x(L.stack)||x(L.stacktrace)):F(L)}function x(L){return Array.isArray(L)?L.join(`
`):L}function F(L){return typeof L.code=="string"&&typeof L.errno=="number"&&typeof L.syscall=="string"?_.localize(1,null,L.message):L.message||_.localize(2,null)}function y(L=null,N=!1){if(!L)return _.localize(3,null);if(Array.isArray(L)){const g=n.coalesce(L),t=y(g[0],N);return g.length>1?_.localize(4,null,t,g.length):t}if(O.isString(L))return L;if(L.detail){const g=L.detail;if(g.error)return C(g.error,N);if(g.exception)return C(g.exception,N)}return L.stack?C(L,N):L.message?L.message:_.localize(5,null)}e.toErrorMessage=y}),define(me[111],ge([17,18]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(me[112],ge([1,0,111,28,113,16,25,106]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class L{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=L;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class g{constructor(X,oe,Ie,Ne){this.id=X,this.name=oe,this.defaultValue=Ie,this.schema=Ne}applyUpdate(X,oe){return d(X,oe)}compute(X,oe,Ie){return Ie}}class t{constructor(X,oe){this.newValue=X,this.didChange=oe}}e.ApplyUpdateResult=t;function d(G,X){if(typeof G!="object"||typeof X!="object"||!G||!X)return new t(X,G!==X);if(Array.isArray(G)||Array.isArray(X)){const Ie=Array.isArray(G)&&Array.isArray(X)&&C.equals(G,X);return new t(X,Ie)}let oe=!1;for(const Ie in X)if(X.hasOwnProperty(Ie)){const Ne=d(G[Ie],X[Ie]);Ne.didChange&&(G[Ie]=Ne.newValue,oe=!0)}return new t(G,oe)}class s{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,oe){return d(X,oe)}validate(X){return this.defaultValue}}class a{constructor(X,oe,Ie,Ne){this.id=X,this.name=oe,this.defaultValue=Ie,this.schema=Ne}applyUpdate(X,oe){return d(X,oe)}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,oe,Ie){return Ie}}function l(G,X){return typeof G=="undefined"?X:G==="false"?!1:Boolean(G)}e.boolean=l;class P extends a{constructor(X,oe,Ie,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Ie);super(X,oe,Ie,Ne)}validate(X){return l(X,this.defaultValue)}}function v(G,X,oe,Ie){if(typeof G=="undefined")return X;let Ne=parseInt(G,10);return isNaN(Ne)?X:(Ne=Math.max(oe,Ne),Ne=Math.min(Ie,Ne),Ne|0)}e.clampedInt=v;class E extends a{constructor(X,oe,Ie,Ne,Ve,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Ie,Ye.minimum=Ne,Ye.maximum=Ve);super(X,oe,Ie,Ye);this.minimum=Ne,this.maximum=Ve}static clampedInt(X,oe,Ie,Ne){return v(X,oe,Ie,Ne)}validate(X){return E.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class r extends a{constructor(X,oe,Ie,Ne,Ve){typeof Ve!="undefined"&&(Ve.type="number",Ve.default=Ie);super(X,oe,Ie,Ve);this.validationFn=Ne}static clamp(X,oe,Ie){return X<oe?oe:X>Ie?Ie:X}static float(X,oe){if(typeof X=="number")return X;if(typeof X=="undefined")return oe;const Ie=parseFloat(X);return isNaN(Ie)?oe:Ie}validate(X){return this.validationFn(r.float(X,this.defaultValue))}}class S extends a{static string(X,oe){return typeof X!="string"?oe:X}constructor(X,oe,Ie,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Ie);super(X,oe,Ie,Ne)}validate(X){return S.string(X,this.defaultValue)}}function i(G,X,oe){return typeof G!="string"||oe.indexOf(G)===-1?X:G}e.stringSet=i;class T extends a{constructor(X,oe,Ie,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=Ne,Ve.default=Ie);super(X,oe,Ie,Ve);this._allowedValues=Ne}validate(X){return i(X,this.defaultValue,this._allowedValues)}}class o extends g{constructor(X,oe,Ie,Ne,Ve,Ye,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=Ve,ht.default=Ne);super(X,oe,Ie,ht);this._allowedValues=Ve,this._convert=Ye}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function c(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class w extends g{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",description:n.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,oe,Ie){return Ie===0?X.accessibilitySupport:Ie}}class f extends g{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:n.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{insertSpace:l(oe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(oe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var h;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(h=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function p(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function b(G){switch(G){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function I(G){switch(G){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class k extends s{constructor(){super(128)}compute(X,oe,Ie){const Ne=["monaco-editor"];return oe.get(33)&&Ne.push(oe.get(33)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),oe.get(66)==="default"?Ne.push("mouse-default"):oe.get(66)==="copy"&&Ne.push("mouse-copy"),oe.get(100)&&Ne.push("showUnused"),oe.get(126)&&Ne.push("showDeprecated"),Ne.join(" ")}}class $ extends P{constructor(){super(32,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(X,oe,Ie){return Ie&&X.emptySelectionClipboard}}class u extends g{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:n.localize(16,null),included:O.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:n.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{cursorMoveOnType:l(oe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":i(oe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":i(oe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(oe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(oe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(oe.loop,this.defaultValue.loop)}}}class U extends g{constructor(){super(45,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?U.OFF:X==="true"?U.ON:X:Boolean(X)?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class z extends s{constructor(){super(44)}compute(X,oe,Ie){return X.fontInfo}}class q extends a{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(22,null)})}validate(X){const oe=r.float(X,this.defaultValue);return oe===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(oe,6,100)}compute(X,oe,Ie){return X.fontInfo.fontSize}}class V extends g{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:n.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(E.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class j extends g{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},oe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[n.localize(25,null),n.localize(26,null),n.localize(27,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(29,null),...oe},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(30,null),...oe},"editor.gotoLocation.multipleDeclarations":{description:n.localize(31,null),...oe},"editor.gotoLocation.multipleImplementations":{description:n.localize(32,null),...oe},"editor.gotoLocation.multipleReferences":{description:n.localize(33,null),...oe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ie,description:n.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ie,description:n.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ie,description:n.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ie,description:n.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ie,description:n.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{multiple:i(oe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:oe.multipleDefinitions??i(oe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:oe.multipleTypeDefinitions??i(oe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:oe.multipleDeclarations??i(oe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:oe.multipleImplementations??i(oe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:oe.multipleReferences??i(oe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(oe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(oe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(oe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(oe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(oe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends g{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:n.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:n.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:n.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:n.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{enabled:l(oe.enabled,this.defaultValue.enabled),delay:E.clampedInt(oe.delay,this.defaultValue.delay,0,1e4),sticky:l(oe.sticky,this.defaultValue.sticky),above:l(oe.above,this.defaultValue.above)}}}var se;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(se=e.RenderMinimap||(e.RenderMinimap={}));class le extends s{constructor(){super(131)}compute(X,oe,Ie){return le.computeLayout(oe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const oe=X.height/X.lineHeight,Ie=X.scrollBeyondLastLine?oe-1:0,Ne=(X.viewLineCount+Ie)/(X.pixelRatio*X.height),Ve=Math.floor(X.viewLineCount/Ne);return{typicalViewportLineCount:oe,extraLinesBeyondLastLine:Ie,desiredRatio:Ne,minimapLineCount:Ve}}static _computeMinimapLayout(X,oe){const Ie=X.outerWidth,Ne=X.outerHeight,Ve=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Ye=oe.stableMinimapLayoutInput,ht=Ye&&X.outerHeight===Ye.outerHeight&&X.lineHeight===Ye.lineHeight&&X.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&X.pixelRatio===Ye.pixelRatio&&X.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&X.minimap.enabled===Ye.minimap.enabled&&X.minimap.side===Ye.minimap.side&&X.minimap.size===Ye.minimap.size&&X.minimap.showSlider===Ye.minimap.showSlider&&X.minimap.renderCharacters===Ye.minimap.renderCharacters&&X.minimap.maxColumn===Ye.minimap.maxColumn&&X.minimap.scale===Ye.minimap.scale&&X.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&X.isViewportWrapping===Ye.isViewportWrapping,_t=X.lineHeight,Dt=X.typicalHalfwidthCharacterWidth,He=X.scrollBeyondLastLine,Pt=X.minimap.renderCharacters;let Ke=Ve>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const ut=X.minimap.maxColumn,Tt=X.minimap.size,At=X.minimap.side,wt=X.verticalScrollbarWidth,at=X.viewLineCount,yt=X.remainingWidth,Mt=X.isViewportWrapping,Ot=Pt?2:3;let Me=Math.floor(Ve*Ne);const ae=Me/Ve;let ue=!1,ne=!1,K=Ot*Ke,pe=Ke/Ve,_e=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:lt,extraLinesBeyondLastLine:st,desiredRatio:Ut,minimapLineCount:Ct}=le.computeContainedMinimapLineCount({viewLineCount:at,scrollBeyondLastLine:He,height:Ne,lineHeight:_t,pixelRatio:Ve});if(at/Ct>1)ue=!0,ne=!0,Ke=1,K=1,pe=Ke/Ve;else{let Et=!1,dt=Ke+1;if(Tt==="fit"){const Lt=Math.ceil((at+st)*K);Mt&&ht&&yt<=oe.stableFitRemainingWidth?(Et=!0,dt=oe.stableFitMaxMinimapScale):Et=Lt>Me}if(Tt==="fill"||Et){ue=!0;const Lt=Ke;K=Math.min(_t*Ve,Math.max(1,Math.floor(1/Ut))),Mt&&ht&&yt<=oe.stableFitRemainingWidth&&(dt=oe.stableFitMaxMinimapScale),Ke=Math.min(dt,Math.max(1,Math.floor(K/Ot))),Ke>Lt&&(_e=Math.min(2,Ke/Lt)),pe=Ke/Ve/_e,Me=Math.ceil(Math.max(lt,at+st)*K),Mt?(oe.stableMinimapLayoutInput=X,oe.stableFitRemainingWidth=yt,oe.stableFitMaxMinimapScale=Ke):(oe.stableMinimapLayoutInput=null,oe.stableFitRemainingWidth=0)}}}const $e=Math.floor(ut*pe),Le=Math.min($e,Math.max(0,Math.floor((yt-wt-2)*pe/(Dt+pe)))+e.MINIMAP_GUTTER_WIDTH);let nt=Math.floor(Ve*Le);const pt=nt/Ve;nt=Math.floor(nt*_e);const vt=Pt?1:2,et=At==="left"?0:Ie-Le-wt;return{renderMinimap:vt,minimapLeft:et,minimapWidth:Le,minimapHeightIsEditorHeight:ue,minimapIsSampling:ne,minimapScale:Ke,minimapLineHeight:K,minimapCanvasInnerWidth:nt,minimapCanvasInnerHeight:Me,minimapCanvasOuterWidth:pt,minimapCanvasOuterHeight:ae}}static computeLayout(X,oe){const Ie=oe.outerWidth|0,Ne=oe.outerHeight|0,Ve=oe.lineHeight|0,Ye=oe.lineNumbersDigitCount|0,ht=oe.typicalHalfwidthCharacterWidth,_t=oe.maxDigitWidth,Dt=oe.pixelRatio,He=oe.viewLineCount,Pt=X.get(123),Ke=Pt==="inherit"?X.get(122):Pt,ut=Ke==="inherit"?X.get(118):Ke,Tt=X.get(121),At=X.get(2),wt=oe.isDominatedByLongLines,at=X.get(50),yt=X.get(60).renderType!==0,Mt=X.get(61),Ot=X.get(94),Me=X.get(65),ae=X.get(92),ue=ae.verticalScrollbarSize,ne=ae.verticalHasArrows,K=ae.arrowSize,pe=ae.horizontalScrollbarSize,_e=X.get(58),$e=X.get(37);let Le;if(typeof _e=="string"&&/^\d+(\.\d+)?ch$/.test(_e)){const Bt=parseFloat(_e.substr(0,_e.length-2));Le=E.clampedInt(Bt*ht,0,0,1e3)}else Le=E.clampedInt(_e,0,0,1e3);$e&&(Le+=16);let nt=0;if(yt){const Bt=Math.max(Ye,Mt);nt=Math.round(Bt*_t)}let pt=0;at&&(pt=Ve);let vt=0,et=vt+pt,lt=et+nt,st=lt+Le;const Ut=Ie-pt-nt-Le;let Ct=!1,Ft=!1,Et=-1;At!==2&&(Ke==="inherit"&&wt?(Ct=!0,Ft=!0):ut==="on"||ut==="bounded"?Ft=!0:ut==="wordWrapColumn"&&(Et=Tt));const dt=le._computeMinimapLayout({outerWidth:Ie,outerHeight:Ne,lineHeight:Ve,typicalHalfwidthCharacterWidth:ht,pixelRatio:Dt,scrollBeyondLastLine:Ot,minimap:Me,verticalScrollbarWidth:ue,viewLineCount:He,remainingWidth:Ut,isViewportWrapping:Ft},oe.memory||new N);dt.renderMinimap!==0&&dt.minimapLeft===0&&(vt+=dt.minimapWidth,et+=dt.minimapWidth,lt+=dt.minimapWidth,st+=dt.minimapWidth);const Lt=Ut-dt.minimapWidth,qt=Math.max(1,Math.floor((Lt-ue-2)/ht)),ct=ne?K:0;return Ft&&(Et=Math.max(1,qt),ut==="bounded"&&(Et=Math.min(Et,Tt))),{width:Ie,height:Ne,glyphMarginLeft:vt,glyphMarginWidth:pt,lineNumbersLeft:et,lineNumbersWidth:nt,decorationsLeft:lt,decorationsWidth:Le,contentLeft:st,contentWidth:Lt,minimap:dt,viewportColumn:qt,isWordWrapMinified:Ct,isViewportWrapping:Ft,wrappingColumn:Et,verticalScrollbarWidth:ue,horizontalScrollbarHeight:pe,overviewRuler:{top:ct,width:ue,height:Ne-2*ct,right:0}}}}e.EditorLayoutInfoComputer=le;class re extends g{constructor(){const X={enabled:!0};super(57,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:n.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:l(X.enabled,this.defaultValue.enabled)}}}class he extends g{constructor(){const X={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",X,{"editor.inlayHints.enabled":{type:"boolean",default:X.enabled,description:n.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:n.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:n.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{enabled:l(oe.enabled,this.defaultValue.enabled),fontSize:E.clampedInt(oe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(oe.fontFamily,this.defaultValue.fontFamily)}}}class Ee extends r{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>r.clamp(X,0,150),{markdownDescription:n.localize(47,null)})}compute(X,oe,Ie){return X.fontInfo.lineHeight}}class Ce extends g{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:n.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(49,null),n.localize(50,null),n.localize(51,null)],default:X.size,description:n.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:n.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:n.localize(54,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:n.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:n.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{enabled:l(oe.enabled,this.defaultValue.enabled),size:i(oe.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(oe.side,this.defaultValue.side,["right","left"]),showSlider:i(oe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(oe.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(oe.scale,1,1,3),maxColumn:E.clampedInt(oe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Pe(G){return G==="ctrlCmd"?O.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Be extends g{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{top:E.clampedInt(oe.top,0,0,1e3),bottom:E.clampedInt(oe.bottom,0,0,1e3)}}}class je extends g{constructor(){const X={enabled:!0,cycle:!1};super(76,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:n.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:n.localize(61,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{enabled:l(oe.enabled,this.defaultValue.enabled),cycle:l(oe.cycle,this.defaultValue.cycle)}}}class tt extends s{constructor(){super(129)}compute(X,oe,Ie){return X.pixelRatio}}class Ge extends g{constructor(){const X={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:n.localize(62,null)},comments:{type:"boolean",default:X.comments,description:n.localize(63,null)},other:{type:"boolean",default:X.other,description:n.localize(64,null)}}}],default:X,description:n.localize(65,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const oe=X,Ie={other:l(oe.other,this.defaultValue.other),comments:l(oe.comments,this.defaultValue.comments),strings:l(oe.strings,this.defaultValue.strings)};return Ie.other&&Ie.comments&&Ie.strings?!0:!Ie.other&&!Ie.comments&&!Ie.strings?!1:Ie}return this.defaultValue}}var ot;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(ot=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class mt extends g{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null),n.localize(69,null)],default:"on",description:n.localize(70,null)})}validate(X){let oe=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(oe=4,Ie=X):X==="interval"?oe=3:X==="relative"?oe=2:X==="on"?oe=1:oe=0),{renderType:oe,renderFn:Ie}}}function ve(G){const X=G.get(87);return X==="editable"?G.get(81):X!=="on"}e.filterValidationDecorations=ve;class ce extends g{constructor(){const X=[],oe={type:"number",description:n.localize(71,null)};super(91,"rulers",X,{type:"array",items:{anyOf:[oe,{type:["object"],properties:{column:oe,color:{type:"string",description:n.localize(72,null),format:"color-hex"}}}]},default:X,description:n.localize(73,null)})}validate(X){if(Array.isArray(X)){const oe=[];for(let Ie of X)if(typeof Ie=="number")oe.push({column:E.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Ne=Ie;oe.push({column:E.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return oe.sort((Ie,Ne)=>Ie.column-Ne.column),oe}return this.defaultValue}}function M(G,X){if(typeof G!="string")return X;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class A extends g{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(74,null),n.localize(75,null),n.localize(76,null)],default:"auto",description:n.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(78,null),n.localize(79,null),n.localize(80,null)],default:"auto",description:n.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:n.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:n.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:n.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X,Ie=E.clampedInt(oe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=E.clampedInt(oe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(oe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:M(oe.vertical,this.defaultValue.vertical),horizontal:M(oe.horizontal,this.defaultValue.horizontal),useShadows:l(oe.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(oe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(oe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(oe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(oe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:E.clampedInt(oe.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:E.clampedInt(oe.verticalSliderSize,Ne,0,1e3),scrollByPage:l(oe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class D extends g{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:n.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:n.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:n.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:n.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:n.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:n.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:n.localize(91,null)}})}applyUpdate(X,oe){let Ie=!1;oe.allowedCharacters&&(x.equals(X.allowedCharacters,oe.allowedCharacters)||(X={...X,allowedCharacters:oe.allowedCharacters},Ie=!0)),oe.allowedLocales&&(x.equals(X.allowedLocales,oe.allowedLocales)||(X={...X,allowedLocales:oe.allowedLocales},Ie=!0));const Ne=super.applyUpdate(X,oe);return Ie?new t(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{nonBasicASCII:te(oe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(oe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(oe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:te(oe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:te(oe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,oe){if(typeof X!="object"||!X)return oe;const Ie={};for(const[Ne,Ve]of Object.entries(X))Ve===!0&&(Ie[Ne]=!0);return Ie}}class R extends g{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:n.localize(92,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{enabled:l(oe.enabled,this.defaultValue.enabled),mode:i(oe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class H extends g{constructor(){const X={enabled:F.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,description:n.localize(93,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:l(X.enabled,this.defaultValue.enabled)}}}class Q extends g{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(94,null),n.localize(95,null),n.localize(96,null)],default:X.bracketPairs,description:n.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(98,null),n.localize(99,null),n.localize(100,null)],default:X.bracketPairsHorizontal,description:n.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:n.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:n.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:X.highlightActiveIndentation,description:n.localize(104,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{bracketPairs:te(oe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te(oe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(oe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(oe.indentation,this.defaultValue.indentation),highlightActiveIndentation:l(oe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function te(G,X,oe){const Ie=oe.indexOf(G);return Ie===-1?X:oe[Ie]}class de extends g{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(105,null),n.localize(106,null)],default:X.insertMode,description:n.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:n.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:n.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:n.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:n.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:n.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:n.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:n.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:n.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(146,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const oe=X;return{insertMode:i(oe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(oe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(oe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(oe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(oe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(oe.showIcons,this.defaultValue.showIcons),showStatusBar:l(oe.showStatusBar,this.defaultValue.showStatusBar),preview:l(oe.preview,this.defaultValue.preview),previewMode:i(oe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(oe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(oe.showMethods,this.defaultValue.showMethods),showFunctions:l(oe.showFunctions,this.defaultValue.showFunctions),showConstructors:l(oe.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(oe.showDeprecated,this.defaultValue.showDeprecated),showFields:l(oe.showFields,this.defaultValue.showFields),showVariables:l(oe.showVariables,this.defaultValue.showVariables),showClasses:l(oe.showClasses,this.defaultValue.showClasses),showStructs:l(oe.showStructs,this.defaultValue.showStructs),showInterfaces:l(oe.showInterfaces,this.defaultValue.showInterfaces),showModules:l(oe.showModules,this.defaultValue.showModules),showProperties:l(oe.showProperties,this.defaultValue.showProperties),showEvents:l(oe.showEvents,this.defaultValue.showEvents),showOperators:l(oe.showOperators,this.defaultValue.showOperators),showUnits:l(oe.showUnits,this.defaultValue.showUnits),showValues:l(oe.showValues,this.defaultValue.showValues),showConstants:l(oe.showConstants,this.defaultValue.showConstants),showEnums:l(oe.showEnums,this.defaultValue.showEnums),showEnumMembers:l(oe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(oe.showKeywords,this.defaultValue.showKeywords),showWords:l(oe.showWords,this.defaultValue.showWords),showColors:l(oe.showColors,this.defaultValue.showColors),showFiles:l(oe.showFiles,this.defaultValue.showFiles),showReferences:l(oe.showReferences,this.defaultValue.showReferences),showFolders:l(oe.showFolders,this.defaultValue.showFolders),showTypeParameters:l(oe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(oe.showSnippets,this.defaultValue.showSnippets),showUsers:l(oe.showUsers,this.defaultValue.showUsers),showIssues:l(oe.showIssues,this.defaultValue.showIssues)}}}class Se extends g{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(147,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ae extends s{constructor(){super(130)}compute(X,oe,Ie){return oe.get(81)?!0:X.tabFocusMode}}var Fe;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Fe=e.WrappingIndent||(e.WrappingIndent={}));function Ue(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Oe extends s{constructor(){super(132)}compute(X,oe,Ie){const Ne=oe.get(131);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",qe="Menlo, Monaco, 'Courier New', monospace",it="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:O.isMacintosh?qe:O.isLinux?it:ke,fontWeight:"normal",fontSize:O.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function De(G){return e.editorOptionsRegistry[G.id]=G,G}var Ze;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:De(new P(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(148,null)})),acceptSuggestionOnEnter:De(new T(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(149,null),""],markdownDescription:n.localize(150,null)})),accessibilitySupport:De(new w),accessibilityPageSize:De(new E(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(151,null)})),ariaLabel:De(new S(4,"ariaLabel",n.localize(152,null))),autoClosingBrackets:De(new T(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(153,null),n.localize(154,null),""],description:n.localize(155,null)})),autoClosingDelete:De(new T(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(156,null),""],description:n.localize(157,null)})),autoClosingOvertype:De(new T(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(158,null),""],description:n.localize(159,null)})),autoClosingQuotes:De(new T(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(160,null),n.localize(161,null),""],description:n.localize(162,null)})),autoIndent:De(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[n.localize(163,null),n.localize(164,null),n.localize(165,null),n.localize(166,null),n.localize(167,null)],description:n.localize(168,null)})),automaticLayout:De(new P(10,"automaticLayout",!1)),autoSurround:De(new T(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(169,null),n.localize(170,null),n.localize(171,null),""],description:n.localize(172,null)})),bracketPairColorization:De(new H),bracketPairGuides:De(new Q),stickyTabStops:De(new P(104,"stickyTabStops",!1,{description:n.localize(173,null)})),codeLens:De(new P(14,"codeLens",!0,{description:n.localize(174,null)})),codeLensFontFamily:De(new S(15,"codeLensFontFamily","",{description:n.localize(175,null)})),codeLensFontSize:De(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(176,null)})),colorDecorators:De(new P(17,"colorDecorators",!0,{description:n.localize(177,null)})),columnSelection:De(new P(18,"columnSelection",!1,{description:n.localize(178,null)})),comments:De(new f),contextmenu:De(new P(20,"contextmenu",!0)),copyWithSyntaxHighlighting:De(new P(21,"copyWithSyntaxHighlighting",!0,{description:n.localize(179,null)})),cursorBlinking:De(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:n.localize(180,null)})),cursorSmoothCaretAnimation:De(new P(23,"cursorSmoothCaretAnimation",!1,{description:n.localize(181,null)})),cursorStyle:De(new o(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:n.localize(182,null)})),cursorSurroundingLines:De(new E(25,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(183,null)})),cursorSurroundingLinesStyle:De(new T(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(184,null),n.localize(185,null)],description:n.localize(186,null)})),cursorWidth:De(new E(27,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(187,null)})),disableLayerHinting:De(new P(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:De(new P(29,"disableMonospaceOptimizations",!1)),domReadOnly:De(new P(30,"domReadOnly",!1)),dragAndDrop:De(new P(31,"dragAndDrop",!0,{description:n.localize(188,null)})),emptySelectionClipboard:De(new $),extraEditorClassName:De(new S(33,"extraEditorClassName","")),fastScrollSensitivity:De(new r(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:n.localize(189,null)})),find:De(new u),fixedOverflowWidgets:De(new P(36,"fixedOverflowWidgets",!1)),folding:De(new P(37,"folding",!0,{description:n.localize(190,null)})),foldingStrategy:De(new T(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(191,null),n.localize(192,null)],description:n.localize(193,null)})),foldingHighlight:De(new P(39,"foldingHighlight",!0,{description:n.localize(194,null)})),foldingImportsByDefault:De(new P(40,"foldingImportsByDefault",!1,{description:n.localize(195,null)})),foldingMaximumRegions:De(new E(41,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(196,null)})),unfoldOnClickAfterEndOfLine:De(new P(42,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(197,null)})),fontFamily:De(new S(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(198,null)})),fontInfo:De(new z),fontLigatures2:De(new U),fontSize:De(new q),fontWeight:De(new V),formatOnPaste:De(new P(48,"formatOnPaste",!1,{description:n.localize(199,null)})),formatOnType:De(new P(49,"formatOnType",!1,{description:n.localize(200,null)})),glyphMargin:De(new P(50,"glyphMargin",!0,{description:n.localize(201,null)})),gotoLocation:De(new j),hideCursorInOverviewRuler:De(new P(52,"hideCursorInOverviewRuler",!1,{description:n.localize(202,null)})),hover:De(new Y),inDiffEditor:De(new P(54,"inDiffEditor",!1)),letterSpacing:De(new r(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>r.clamp(G,-5,20),{description:n.localize(203,null)})),lightbulb:De(new re),lineDecorationsWidth:De(new a(58,"lineDecorationsWidth",10)),lineHeight:De(new Ee),lineNumbers:De(new mt),lineNumbersMinChars:De(new E(61,"lineNumbersMinChars",5,1,300)),linkedEditing:De(new P(62,"linkedEditing",!1,{description:n.localize(204,null)})),links:De(new P(63,"links",!0,{description:n.localize(205,null)})),matchBrackets:De(new T(64,"matchBrackets","always",["always","near","never"],{description:n.localize(206,null)})),minimap:De(new Ce),mouseStyle:De(new T(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:De(new r(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:n.localize(207,null)})),mouseWheelZoom:De(new P(68,"mouseWheelZoom",!1,{markdownDescription:n.localize(208,null)})),multiCursorMergeOverlapping:De(new P(69,"multiCursorMergeOverlapping",!0,{description:n.localize(209,null)})),multiCursorModifier:De(new o(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[n.localize(210,null),n.localize(211,null)],markdownDescription:n.localize(212,null)})),multiCursorPaste:De(new T(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(213,null),n.localize(214,null)],markdownDescription:n.localize(215,null)})),occurrencesHighlight:De(new P(72,"occurrencesHighlight",!0,{description:n.localize(216,null)})),overviewRulerBorder:De(new P(73,"overviewRulerBorder",!0,{description:n.localize(217,null)})),overviewRulerLanes:De(new E(74,"overviewRulerLanes",3,0,3)),padding:De(new Be),parameterHints:De(new je),peekWidgetDefaultFocus:De(new T(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(218,null),n.localize(219,null)],description:n.localize(220,null)})),definitionLinkOpensInPeek:De(new P(78,"definitionLinkOpensInPeek",!1,{description:n.localize(221,null)})),quickSuggestions:De(new Ge),quickSuggestionsDelay:De(new E(80,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(222,null)})),readOnly:De(new P(81,"readOnly",!1)),renameOnType:De(new P(82,"renameOnType",!1,{description:n.localize(223,null),markdownDeprecationMessage:n.localize(224,null)})),renderControlCharacters:De(new P(83,"renderControlCharacters",!0,{description:n.localize(225,null),restricted:!0})),renderFinalNewline:De(new P(84,"renderFinalNewline",!0,{description:n.localize(226,null)})),renderLineHighlight:De(new T(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(227,null)],description:n.localize(228,null)})),renderLineHighlightOnlyWhenFocus:De(new P(86,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(229,null)})),renderValidationDecorations:De(new T(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:De(new T(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(230,null),n.localize(231,null),n.localize(232,null),""],description:n.localize(233,null)})),revealHorizontalRightPadding:De(new E(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:De(new P(90,"roundedSelection",!0,{description:n.localize(234,null)})),rulers:De(new ce),scrollbar:De(new A),scrollBeyondLastColumn:De(new E(93,"scrollBeyondLastColumn",5,0,1073741824,{description:n.localize(235,null)})),scrollBeyondLastLine:De(new P(94,"scrollBeyondLastLine",!0,{description:n.localize(236,null)})),scrollPredominantAxis:De(new P(95,"scrollPredominantAxis",!0,{description:n.localize(237,null)})),selectionClipboard:De(new P(96,"selectionClipboard",!0,{description:n.localize(238,null),included:O.isLinux})),selectionHighlight:De(new P(97,"selectionHighlight",!0,{description:n.localize(239,null)})),selectOnLineNumbers:De(new P(98,"selectOnLineNumbers",!0)),showFoldingControls:De(new T(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[n.localize(240,null),n.localize(241,null)],description:n.localize(242,null)})),showUnused:De(new P(100,"showUnused",!0,{description:n.localize(243,null)})),showDeprecated:De(new P(126,"showDeprecated",!0,{description:n.localize(244,null)})),inlayHints:De(new he),snippetSuggestions:De(new T(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(245,null),n.localize(246,null),n.localize(247,null),n.localize(248,null)],description:n.localize(249,null)})),smartSelect:De(new Se),smoothScrolling:De(new P(103,"smoothScrolling",!1,{description:n.localize(250,null)})),stopRenderingLineAfter:De(new E(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:De(new de),inlineSuggest:De(new R),suggestFontSize:De(new E(107,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(251,null)})),suggestLineHeight:De(new E(108,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(252,null)})),suggestOnTriggerCharacters:De(new P(109,"suggestOnTriggerCharacters",!0,{description:n.localize(253,null)})),suggestSelection:De(new T(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null),n.localize(256,null)],description:n.localize(257,null)})),tabCompletion:De(new T(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(258,null),n.localize(259,null),n.localize(260,null)],description:n.localize(261,null)})),tabIndex:De(new E(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:De(new D),unusualLineTerminators:De(new T(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(262,null),n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),useShadowDOM:De(new P(115,"useShadowDOM",!0)),useTabStops:De(new P(116,"useTabStops",!0,{description:n.localize(266,null)})),wordSeparators:De(new S(117,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:n.localize(267,null)})),wordWrap:De(new T(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(268,null),n.localize(269,null),n.localize(270,null),n.localize(271,null)],description:n.localize(272,null)})),wordWrapBreakAfterCharacters:De(new S(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:De(new S(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:De(new E(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(273,null)})),wordWrapOverride1:De(new T(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:De(new T(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:De(new o(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ue,{enumDescriptions:[n.localize(274,null),n.localize(275,null),n.localize(276,null),n.localize(277,null)],description:n.localize(278,null)})),wrappingStrategy:De(new T(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[n.localize(279,null),n.localize(280,null)],description:n.localize(281,null)})),editorClassName:De(new k),pixelRatio:De(new tt),tabFocusMode:De(new Ae),layoutInfo:De(new le),wrappingInfo:De(new Oe)}}),define(me[114],ge([17,18]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[115],ge([17,18]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[116],ge([17,18]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(me[117],ge([17,18]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(me[118],ge([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[119],ge([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[120],ge([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(me[121],ge([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[122],ge([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[123],ge([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[124],ge([17,18]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[125],ge([17,18]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(me[126],ge([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[127],ge([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[128],ge([17,18]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[129],ge([17,18]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[130],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var n;(function(x){x[x.ACTIVATE=1]="ACTIVATE",x[x.RESTORE=2]="RESTORE",x[x.PRESERVE=3]="PRESERVE"})(n=e.EditorActivation||(e.EditorActivation={}));var O;(function(x){x[x.PICK=0]="PICK",x[x.DISABLED=1]="DISABLED",x[x.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(O=e.EditorResolution||(e.EditorResolution={}));var _;(function(x){x[x.API=0]="API",x[x.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(x){x[x.Center=0]="Center",x[x.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",x[x.NearTop=2]="NearTop",x[x.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[131],ge([1,0,115]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function C(t){return t=t.trim(),t==="*"||O.test(t)}e.isValidVersionStr=C;function x(t){if(!C(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=t.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=x;function F(t){if(!t)return null;let d=t.majorBase,s=t.majorMustEqual,a=t.minorBase,l=t.minorMustEqual,P=t.patchBase,v=t.patchMustEqual;t.hasCaret&&(d===0||(l=!1),v=!1);let E=0;if(t.preRelease){const r=_.exec(t.preRelease);if(r){const[,S,i,T]=r;E=Date.UTC(Number(S),Number(i)-1,Number(T))}}return{majorBase:d,majorMustEqual:s,minorBase:a,minorMustEqual:l,patchBase:P,patchMustEqual:v,isMinimum:t.hasGreaterEquals,notBefore:E}}e.normalizeVersion=F;function y(t,d,s){let a;typeof t=="string"?a=F(x(t)):a=t;let l;d instanceof Date?l=d.getTime():typeof d=="string"&&(l=new Date(d).getTime());let P;if(typeof s=="string"?P=F(x(s)):P=s,!a||!P)return!1;let v=a.majorBase,E=a.minorBase,r=a.patchBase,S=P.majorBase,i=P.minorBase,T=P.patchBase,o=P.notBefore,c=P.majorMustEqual,w=P.minorMustEqual,f=P.patchMustEqual;return P.isMinimum?v>S?!0:v<S?!1:E>i?!0:E<i||l&&l<o?!1:r>=T:(v===1&&S===0&&(!c||!w||!f)&&(S=1,i=0,T=0,c=!0,w=!1,f=!1),v<S?!1:v>S?!c:E<i?!1:E>i?!w:r<T?!1:r>T?!f:!(l&&l<o))}e.isValidVersion=y;function L(t,d,s,a){return s.isBuiltin||typeof s.main=="undefined"?!0:g(t,d,s.engines.vscode,a)}e.isValidExtensionVersion=L;function N(t,d,s){return t==="*"||g(d,s,t)}e.isEngineValid=N;function g(t,d,s,a=[]){let l=F(x(s));if(!l)return a.push(n.localize(0,null,s)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return a.push(n.localize(1,null,s)),!1}else if(!l.majorMustEqual)return a.push(n.localize(2,null,s)),!1;return y(t,d,l)?!0:(a.push(n.localize(3,null,t,s)),!1)}}),define(me[73],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(_,C=[],x=!1){this.ctor=_,this.staticArguments=C,this.supportsDelayedInstantiation=x}}e.SyncDescriptor=n}),define(me[43],ge([1,0,73]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const O=[];function _(x,F,y){F instanceof n.SyncDescriptor||(F=new n.SyncDescriptor(F,[],y)),O.push([x,F])}e.registerSingleton=_;function C(){return O}e.getSingletonServiceDescriptors=C}),define(me[132],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=n;class O{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let x of this._nodes.values())x.outgoing.size===0&&C.push(x);return C}insertEdge(C,x){const F=this.lookupOrInsertNode(C),y=this.lookupOrInsertNode(x);F.outgoing.set(this._hashFn(x),y),y.incoming.set(this._hashFn(C),F)}removeNode(C){const x=this._hashFn(C);this._nodes.delete(x);for(let F of this._nodes.values())F.outgoing.delete(x),F.incoming.delete(x)}lookupOrInsertNode(C){const x=this._hashFn(C);let F=this._nodes.get(x);return F||(F=new n(C),this._nodes.set(x,F)),F}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[x,F]of this._nodes)C.push(`${x}, (incoming)[${[...F.incoming.keys()].join(", ")}], (outgoing)[${[...F.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,x]of this._nodes){const F=new Set([C]),y=this._findCycle(x,F);if(y)return y}}_findCycle(C,x){for(let[F,y]of C.outgoing){if(x.has(F))return[...x,F].join(" -> ");x.add(F);const L=this._findCycle(y,x);if(L)return L;x.delete(F)}}}e.Graph=O}),define(me[3],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(x){x.serviceIds=new Map,x.DI_TARGET="$di$target",x.DI_DEPENDENCIES="$di$dependencies";function F(y){return y[x.DI_DEPENDENCIES]||[]}x.getServiceDependencies=F})(n=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function O(x,F,y,L){F[n.DI_TARGET]===F?F[n.DI_DEPENDENCIES].push({id:x,index:y,optional:L}):(F[n.DI_DEPENDENCIES]=[{id:x,index:y,optional:L}],F[n.DI_TARGET]=F)}function _(x){if(n.serviceIds.has(x))return n.serviceIds.get(x);const F=function(y,L,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(F,y,N,!1)};return F.toString=()=>x,n.serviceIds.set(x,F),F}e.createDecorator=_;function C(x){return x}e.refineServiceDecorator=C}),define(me[74],ge([1,0,13,2,3]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function C(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof O.URI)}e.isConfigurationOverrides=C;function x(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||n.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=x;var F;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(F=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function L(l,P){const v=Object.create(null);for(let E in l)N(v,E,l[E],P);return v}e.toValuesTree=L;function N(l,P,v,E){const r=P.split("."),S=r.pop();let i=l;for(let T=0;T<r.length;T++){let o=r[T],c=i[o];switch(typeof c){case"undefined":c=i[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${P} as ${r.slice(0,T+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[S]=v}catch{E(`Ignoring ${P} as ${r.join(".")} is ${JSON.stringify(i)}`)}else E(`Ignoring ${P} as ${r.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=N;function g(l,P){const v=P.split(".");t(l,v)}e.removeFromValueTree=g;function t(l,P){const v=P.shift();if(P.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const E=l[v];typeof E=="object"&&!Array.isArray(E)&&(t(E,P),Object.keys(E).length===0&&delete l[v])}}function d(l,P,v){function E(i,T){let o=i;for(const c of T){if(typeof o!="object"||o===null)return;o=o[c]}return o}const r=P.split("."),S=E(l,r);return typeof S=="undefined"?v:S}e.getConfigurationValue=d;function s(l,P,v){Object.keys(P).forEach(E=>{E!=="__proto__"&&(E in l?n.isObject(l[E])&&n.isObject(P[E])?s(l[E],P[E],v):v&&(l[E]=P[E]):l[E]=P[E])})}e.merge=s;function a(l,P,v){const E=l.inspect(P),r=l.inspect(v);return typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:E.defaultValue}e.getMigratedSettingValue=a}),define(me[53],ge([1,0,28,14,3]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",n.isMacintosh),C.set("isLinux",n.isLinux),C.set("isWindows",n.isWindows),C.set("isWeb",n.isWeb),C.set("isMacNative",n.isMacintosh&&!n.isWeb),C.set("isEdge",n.isEdge),C.set("isFirefox",n.isFirefox),C.set("isChrome",n.isChrome),C.set("isSafari",n.isSafari);const x=Object.prototype.hasOwnProperty;var F;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(F=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return g.INSTANCE}static true(){return t.INSTANCE}static has(u){return d.create(u)}static equals(u,U){return s.create(u,U)}static notEquals(u,U){return P.create(u,U)}static regex(u,U){return o.create(u,U)}static in(u,U){return a.create(u,U)}static not(u){return v.create(u)}static and(...u){return f.create(u,null)}static or(...u){return h.create(u,null,!0)}static greater(u,U){return r.create(u,U)}static greaterEquals(u,U){return S.create(u,U)}static smaller(u,U){return i.create(u,U)}static smallerEquals(u,U){return T.create(u,U)}static deserialize(u,U=!1){if(!!u)return this._deserializeOrExpression(u,U)}static _deserializeOrExpression(u,U){let z=u.split("||");return h.create(z.map(q=>this._deserializeAndExpression(q,U)),null,!0)}static _deserializeAndExpression(u,U){let z=u.split("&&");return f.create(z.map(q=>this._deserializeOne(q,U)),null)}static _deserializeOne(u,U){if(u=u.trim(),u.indexOf("!=")>=0){let z=u.split("!=");return P.create(z[0].trim(),this._deserializeValue(z[1],U))}if(u.indexOf("==")>=0){let z=u.split("==");return s.create(z[0].trim(),this._deserializeValue(z[1],U))}if(u.indexOf("=~")>=0){let z=u.split("=~");return o.create(z[0].trim(),this._deserializeRegexValue(z[1],U))}if(u.indexOf(" in ")>=0){let z=u.split(" in ");return a.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const z=u.split(">=");return S.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const z=u.split(">");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const z=u.split("<=");return T.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const z=u.split("<");return i.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(u)?v.create(u.substr(1).trim()):d.create(u)}static _deserializeValue(u,U){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let z=/^'([^']*)'$/.exec(u);return z?z[1].trim():u}static _deserializeRegexValue(u,U){if((0,O.isFalsyOrWhitespace)(u)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=u.indexOf("/"),q=u.lastIndexOf("/");if(z===q||z<0){if(U)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let V=u.slice(z+1,q),j=u[q+1]==="i"?"i":"";try{return new RegExp(V,j)}catch(Y){if(U)throw new Error(`bad regexp-value '${u}', parse error: ${Y}`);return console.warn(`bad regexp-value '${u}', parse error: ${Y}`),null}}}e.ContextKeyExpr=y;function L($,u){const U=$?$.substituteConstants():void 0,z=u?u.substituteConstants():void 0;return!U&&!z?!0:!U||!z?!1:U.equals(z)}e.expressionsAreEqualWithConstantSubstitution=L;function N($,u){return $.cmp(u)}class g{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return t.INSTANCE}}e.ContextKeyFalseExpr=g,g.INSTANCE=new g;class t{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return g.INSTANCE}}e.ContextKeyTrueExpr=t,t.INSTANCE=new t;class d{constructor(u,U){this.key=u,this.negated=U,this.type=2}static create(u,U=null){const z=C.get(u);return typeof z=="boolean"?z?t.INSTANCE:g.INSTANCE:new d(u,U)}cmp(u){return u.type!==this.type?this.type-u.type:m(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}substituteConstants(){const u=C.get(this.key);return typeof u=="boolean"?u?t.INSTANCE:g.INSTANCE:this}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class s{constructor(u,U,z){this.key=u,this.value=U,this.negated=z,this.type=4}static create(u,U,z=null){if(typeof U=="boolean")return U?d.create(u,z):v.create(u,z);const q=C.get(u);return typeof q=="boolean"?U===(q?"true":"false")?t.INSTANCE:g.INSTANCE:new s(u,U,z)}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){const u=C.get(this.key);if(typeof u=="boolean"){const U=u?"true":"false";return this.value===U?t.INSTANCE:g.INSTANCE}return this}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class a{constructor(u,U){this.key=u,this.valueKey=U,this.type=10,this.negated=null}static create(u,U){return new a(u,U)}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}substituteConstants(){return this}evaluate(u){const U=u.getValue(this.valueKey),z=u.getValue(this.key);return Array.isArray(U)?U.indexOf(z)>=0:typeof z=="string"&&typeof U=="object"&&U!==null?x.call(U,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyInExpr=a;class l{constructor(u){this._actual=u,this.type=11}static create(u){return new l(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}substituteConstants(){return this}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new l(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=l;class P{constructor(u,U,z){this.key=u,this.value=U,this.negated=z,this.type=5}static create(u,U,z=null){if(typeof U=="boolean")return U?v.create(u,z):d.create(u,z);const q=C.get(u);return typeof q=="boolean"?U===(q?"true":"false")?g.INSTANCE:t.INSTANCE:new P(u,U,z)}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){const u=C.get(this.key);if(typeof u=="boolean"){const U=u?"true":"false";return this.value===U?g.INSTANCE:t.INSTANCE}return this}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=P;class v{constructor(u,U){this.key=u,this.negated=U,this.type=3}static create(u,U=null){const z=C.get(u);return typeof z=="boolean"?z?g.INSTANCE:t.INSTANCE:new v(u,U)}cmp(u){return u.type!==this.type?this.type-u.type:m(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}substituteConstants(){const u=C.get(this.key);return typeof u=="boolean"?u?g.INSTANCE:t.INSTANCE:this}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function E($,u){if(typeof $=="string"){const U=parseFloat($);isNaN(U)||($=U)}return typeof $=="string"||typeof $=="number"?u($):g.INSTANCE}class r{constructor(u,U,z){this.key=u,this.value=U,this.negated=z,this.type=12}static create(u,U,z=null){return E(U,q=>new r(u,q,z))}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){return this}evaluate(u){return typeof this.value=="string"?!1:parseFloat(u.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=r;class S{constructor(u,U,z){this.key=u,this.value=U,this.negated=z,this.type=13}static create(u,U,z=null){return E(U,q=>new S(u,q,z))}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){return this}evaluate(u){return typeof this.value=="string"?!1:parseFloat(u.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=S;class i{constructor(u,U,z){this.key=u,this.value=U,this.negated=z,this.type=14}static create(u,U,z=null){return E(U,q=>new i(u,q,z))}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){return this}evaluate(u){return typeof this.value=="string"?!1:parseFloat(u.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class T{constructor(u,U,z){this.key=u,this.value=U,this.negated=z,this.type=15}static create(u,U,z=null){return E(U,q=>new T(u,q,z))}cmp(u){return u.type!==this.type?this.type-u.type:b(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){return this}evaluate(u){return typeof this.value=="string"?!1:parseFloat(u.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=T;class o{constructor(u,U){this.key=u,this.regexp=U,this.type=7,this.negated=null}static create(u,U){return new o(u,U)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const U=this.regexp?this.regexp.source:"",z=u.regexp?u.regexp.source:"";return U<z?-1:U>z?1:0}equals(u){if(u.type===this.type){const U=this.regexp?this.regexp.source:"",z=u.regexp?u.regexp.source:"";return this.key===u.key&&U===z}return!1}substituteConstants(){return this}evaluate(u){let U=u.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=c.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class c{constructor(u){this._actual=u,this.type=8}static create(u){return new c(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}substituteConstants(){return this}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new c(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=c;function w($){let u=null;for(let U=0,z=$.length;U<z;U++){const q=$[U].substituteConstants();if($[U]!==q&&u===null){u=[];for(let V=0;V<U;V++)u[V]=$[V]}u!==null&&(u[U]=q)}return u===null?$:u}class f{constructor(u,U){this.expr=u,this.negated=U,this.type=6}static create(u,U){return f._normalizeArr(u,U)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const q=N(this.expr[U],u.expr[U]);if(q!==0)return q}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(u.expr[U]))return!1;return!0}return!1}substituteConstants(){const u=w(this.expr);return u===this.expr?this:f.create(u,this.negated)}evaluate(u){for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].evaluate(u))return!1;return!0}static _normalizeArr(u,U){const z=[];let q=!1;for(const V of u)if(!!V){if(V.type===1){q=!0;continue}if(V.type===0)return g.INSTANCE;if(V.type===6){z.push(...V.expr);continue}z.push(V)}if(z.length===0&&q)return t.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(N);for(let V=1;V<z.length;V++)z[V-1].equals(z[V])&&(z.splice(V,1),V--);if(z.length===1)return z[0];for(;z.length>1;){const V=z[z.length-1];if(V.type!==9)break;z.pop();const j=z.pop(),Y=z.length===0,se=h.create(V.expr.map(le=>f.create([le,j],null)),null,Y);se&&(z.push(se),z.sort(N))}return z.length===1?z[0]:new f(z,U)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let U of this.expr)u.push(...U.keys());return u}map(u){return new f(this.expr.map(U=>U.map(u)),null)}negate(){if(!this.negated){const u=[];for(let U of this.expr)u.push(U.negate());this.negated=h.create(u,this,!0)}return this.negated}}class h{constructor(u,U){this.expr=u,this.negated=U,this.type=9}static create(u,U,z){return h._normalizeArr(u,U,z)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let U=0,z=this.expr.length;U<z;U++){const q=N(this.expr[U],u.expr[U]);if(q!==0)return q}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let U=0,z=this.expr.length;U<z;U++)if(!this.expr[U].equals(u.expr[U]))return!1;return!0}return!1}substituteConstants(){const u=w(this.expr);return u===this.expr?this:h.create(u,this.negated,!1)}evaluate(u){for(let U=0,z=this.expr.length;U<z;U++)if(this.expr[U].evaluate(u))return!0;return!1}static _normalizeArr(u,U,z){let q=[],V=!1;if(u){for(let j=0,Y=u.length;j<Y;j++){const se=u[j];if(!!se){if(se.type===0){V=!0;continue}if(se.type===1)return t.INSTANCE;if(se.type===9){q=q.concat(se.expr);continue}q.push(se)}}if(q.length===0&&V)return g.INSTANCE;q.sort(N)}if(q.length!==0){if(q.length===1)return q[0];for(let j=1;j<q.length;j++)q[j-1].equals(q[j])&&(q.splice(j,1),j--);if(q.length===1)return q[0];if(z){for(let j=0;j<q.length;j++)for(let Y=j+1;Y<q.length;Y++)I(q[j],q[Y])&&(q.splice(Y,1),Y--);if(q.length===1)return q[0]}return new h(q,U)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let U of this.expr)u.push(...U.keys());return u}map(u){return new h(this.expr.map(U=>U.map(u)),null)}negate(){if(!this.negated){let u=[];for(let U of this.expr)u.push(U.negate());for(;u.length>1;){const U=u.shift(),z=u.shift(),q=[];for(const j of k(U))for(const Y of k(z))q.push(f.create([j,Y],null));const V=u.length===0;u.unshift(h.create(q,null,V))}this.negated=u[0]}return this.negated}}class p extends d{constructor(u,U,z){super(u,null);this._defaultValue=U,typeof z=="object"?p._info.push({...z,key:u}):z!==!0&&p._info.push({key:u,description:z,type:U!=null?typeof U:void 0})}static all(){return p._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return s.create(this.key,u)}notEqualsTo(u){return P.create(this.key,u)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m($,u){return $<u?-1:$>u?1:0}function b($,u,U,z){return $<U?-1:$>U?1:u<z?-1:u>z?1:0}function I($,u){if(u.type===6&&$.type!==9&&$.type!==6){for(const q of u.expr)if($.equals(q))return!0}const U=$.negate(),z=k(U).concat(k(u));z.sort(N);for(let q=0;q<z.length;q++){const j=z[q].negate();for(let Y=q+1;Y<z.length;Y++){const se=z[Y];if(j.equals(se))return!0}}return!1}e.implies=I;function k($){return $.type===9?$.expr:[$]}}),define(me[133],ge([1,0,3]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(me[44],ge([1,0,22,19,14,13,2,116,3]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function L(V){return V.create===!0}e.isFileOpenForWriteOptions=L;var N;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(N=e.FileType||(e.FileType={}));var g;(function(V){V[V.Readonly=1]="Readonly"})(g=e.FilePermission||(e.FilePermission={}));var t;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead"})(t=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function s(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=s;function a(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function l(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=l;function P(V){return d(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=P;var v;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(j,Y){super(j);this.code=Y}}e.FileSystemProviderError=E;function r(V,j){const Y=new E(V.toString(),j);return i(Y,j),Y}e.createFileSystemProviderError=r;function S(V){return V||r((0,F.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=S;function i(V,j){return V.name=j?`${j} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=i;function T(V){if(!V)return v.Unknown;if(V instanceof E)return V.code;const j=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!j)return v.Unknown;switch(j[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=T;function o(V){if(V instanceof m)return V.fileOperationResult;switch(T(V)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var c;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(c=e.FileOperation||(e.FileOperation={}));class w{constructor(j,Y,se){this.resource=j,this.operation=Y,this.target=se}isOperation(j){return this.operation===j}}e.FileOperationEvent=w;var f;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class h{constructor(j,Y){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=j;const se=new Map;for(const le of j){const re=se.get(le.type);switch(re?re.push([le.resource,le]):se.set(le.type,[[le.resource,le]]),le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}}for(const[le,re]of se)switch(le){case 1:this.added=n.TernarySearchTree.forUris(()=>Y),this.added.fill(re);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>Y),this.updated.fill(re);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>Y),this.deleted.fill(re);break}}contains(j,...Y){return this.doContains(j,{includeChildren:!1},...Y)}affects(j,...Y){return this.doContains(j,{includeChildren:!0},...Y)}doContains(j,Y,...se){if(!j)return!1;const le=se.length>0;return!!((!le||se.includes(1))&&(this.added?.get(j)||Y.includeChildren&&this.added?.findSuperstr(j))||(!le||se.includes(0))&&(this.updated?.get(j)||Y.includeChildren&&this.updated?.findSuperstr(j))||(!le||se.includes(2))&&(this.deleted?.findSubstr(j)||Y.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function p(V,j,Y){return!V||!j||V===j||j.length>V.length?!1:(j.charAt(j.length-1)!==O.sep&&(j+=O.sep),Y?(0,_.startsWithIgnoreCase)(V,j):V.indexOf(j)===0)}e.isParent=p;class m extends Error{constructor(j,Y,se){super(j);this.fileOperationResult=Y,this.options=se}}e.FileOperationError=m;class b extends m{constructor(j,Y,se){super(j,2,se);this.stat=Y}}e.NotModifiedSinceFileOperationError=b;var I;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(I=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=$;async function u(V,j){if(!j.hasProvider(x.URI.from({scheme:V.scheme})))return new Promise(Y=>{const se=j.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===V.scheme&&le.added&&(se.dispose(),Y())})})}e.whenProviderRegistered=u,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(j){return(0,C.isNumber)(j)||(j=0),j<U.KB?(0,F.localize)(1,null,j.toFixed(0)):j<U.MB?(0,F.localize)(2,null,(j/U.KB).toFixed(2)):j<U.GB?(0,F.localize)(3,null,(j/U.MB).toFixed(2)):j<U.TB?(0,F.localize)(4,null,(j/U.GB).toFixed(2)):(0,F.localize)(5,null,(j/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var z;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function q(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=q}),define(me[54],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(..._){this._entries=new Map;for(let[C,x]of _)this.set(C,x)}set(_,C){const x=this._entries.get(_);return this._entries.set(_,C),x}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=n}),define(me[134],ge([1,0,10,15,73,132,3,54]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class L extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class N{constructor(s=new F.ServiceCollection,a=!1,l){this._activeInstantiations=new Set,this._services=s,this._strict=a,this._parent=l,this._services.set(x.IInstantiationService,this)}createChild(s){return new N(s,this._strict,this)}invokeFunction(s,...a){let l=t.traceInvocation(s),P=!1;try{return s({get:E=>{if(P)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(E,l);if(!r)throw new Error(`[invokeFunction] unknown service '${E}'`);return r}},...a)}finally{P=!0,l.stop()}}createInstance(s,...a){let l,P;return s instanceof _.SyncDescriptor?(l=t.traceCreation(s.ctor),P=this._createInstance(s.ctor,s.staticArguments.concat(a),l)):(l=t.traceCreation(s),P=this._createInstance(s,a,l)),l.stop(),P}_createInstance(s,a=[],l){let P=x._util.getServiceDependencies(s).sort((r,S)=>r.index-S.index),v=[];for(const r of P){let S=this._getOrCreateServiceInstance(r.id,l);if(!S&&this._strict&&!r.optional)throw new Error(`[createInstance] ${s.name} depends on UNKNOWN service ${r.id}.`);v.push(S)}let E=P.length>0?P[0].index:a.length;if(a.length!==E){console.warn(`[createInstance] First service dependency of ${s.name} at position ${E+1} conflicts with ${a.length} static arguments`);let r=E-a.length;r>0?a=a.concat(new Array(r)):a=a.slice(0,E)}return new s(...[...a,...v])}_setServiceInstance(s,a){if(this._services.get(s)instanceof _.SyncDescriptor)this._services.set(s,a);else if(this._parent)this._parent._setServiceInstance(s,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let a=this._services.get(s);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):a}_getOrCreateServiceInstance(s,a){let l=this._getServiceInstanceOrDescriptor(s);return l instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,l,a.branch(s,!0)):(a.branch(s,!1),l)}_safeCreateAndCacheServiceInstance(s,a,l){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,a,l)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,a,l){const P=new C.Graph(r=>r.id.toString());let v=0;const E=[{id:s,desc:a,_trace:l}];for(;E.length;){const r=E.pop();if(P.lookupOrInsertNode(r),v++>1e3)throw new L(P);for(let S of x._util.getServiceDependencies(r.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(S.id);if(!i&&!S.optional&&console.warn(`[createInstance] ${s} depends on ${S.id} which is NOT registered.`),i instanceof _.SyncDescriptor){const T={id:S.id,desc:i,_trace:r._trace.branch(S.id,!0)};P.insertEdge(r,T),E.push(T)}}}for(;;){const r=P.roots();if(r.length===0){if(!P.isEmpty())throw new L(P);break}for(const{data:S}of r){if(this._getServiceInstanceOrDescriptor(S.id)instanceof _.SyncDescriptor){const T=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,T)}P.removeNode(S)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,a,l=[],P,v){if(this._services.get(s)instanceof _.SyncDescriptor)return this._createServiceInstance(a,l,P,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,a,l,P,v);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(s,a=[],l,P){if(l){const v=new n.IdleValue(()=>this._createInstance(s,a,P));return new Proxy(Object.create(null),{get(E,r){if(r in E)return E[r];let S=v.value,i=S[r];return typeof i!="function"||(i=i.bind(S),E[r]=i),i},set(E,r,S){return v.value[r]=S,!0}})}else return this._createInstance(s,a,P)}}e.InstantiationService=N;var g;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(g||(g={}));class t{constructor(s,a){this.type=s,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return y?new t(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):t._None}static traceCreation(s){return y?new t(0,s.name):t._None}branch(s,a){let l=new t(2,s.toString());return this._dep.push([s,a,l]),l}stop(){let s=Date.now()-this._start;t._totals+=s;let a=!1;function l(v,E){let r=[],S=new Array(v+1).join("	");for(const[i,T,o]of E._dep)if(T&&o){a=!0,r.push(`${S}CREATES -> ${i}`);let c=l(v+1,o);c&&r.push(c)}else r.push(`${S}uses -> ${i}`);return r.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${t._totals.toFixed(2)}ms)`];(s>2||a)&&console.log(P.join(`
`))}}e.Trace=t,t._None=new class extends t{constructor(){super(-1,null)}stop(){}branch(){return this}},t._totals=0}),define(me[9],ge([1,0,42,5,7,28,3]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,x.createDecorator)("logService"),e.ILoggerService=(0,x.createDecorator)("loggerService");function F(){return new Date().toISOString()}var y;(function(T){T[T.Trace=0]="Trace",T[T.Debug=1]="Debug",T[T.Info=2]="Info",T[T.Warning=3]="Warning",T[T.Error=4]="Error",T[T.Critical=5]="Critical",T[T.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function L(T,o,c){switch(o){case y.Trace:T.trace(c);break;case y.Debug:T.debug(c);break;case y.Info:T.info(c);break;case y.Warning:T.warn(c);break;case y.Error:T.error(c);break;case y.Critical:T.critical(c);break;default:throw new Error("Invalid log level")}}e.log=L;function N(T){let o="";for(let c=0;c<T.length;c++){let w=T[c];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}o+=(c>0?" ":"")+w}return o}e.format=N;class g extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new O.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=g;class t extends g{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...c){this.checkLogLevel(y.Trace)&&this.log(y.Trace,N([o,...c]))}debug(o,...c){this.checkLogLevel(y.Debug)&&this.log(y.Debug,N([o,...c]))}info(o,...c){this.checkLogLevel(y.Info)&&this.log(y.Info,N([o,...c]))}warn(o,...c){this.checkLogLevel(y.Warning)&&this.log(y.Warning,N([o,...c]))}error(o,...c){if(this.checkLogLevel(y.Error))if(o instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=o.stack,this.log(y.Error,N(w))}else this.log(y.Error,N([o,...c]))}critical(o,...c){this.checkLogLevel(y.Critical)&&this.log(y.Critical,N([o,...c]))}flush(){}}e.AbstractMessageLogger=t;class d extends g{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!C.isWindows}trace(o,...c){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${F()}][0m`,o,...c):console.log(`[main ${F()}]`,o,...c))}debug(o,...c){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${F()}][0m`,o,...c):console.log(`[main ${F()}]`,o,...c))}info(o,...c){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${F()}][0m`,o,...c):console.log(`[main ${F()}]`,o,...c))}warn(o,...c){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${F()}][0m`,o,...c):console.warn(`[main ${F()}]`,o,...c))}error(o,...c){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${F()}][0m`,o,...c):console.error(`[main ${F()}]`,o,...c))}critical(o,...c){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${F()}][0m`,o,...c):console.error(`[main ${F()}]`,o,...c))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class s extends g{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...c){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",o,...c)}debug(o,...c){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...c)}info(o,...c){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",o,...c)}warn(o,...c){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",o,...c)}error(o,...c){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",o,...c)}critical(o,...c){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...c)}dispose(){}flush(){}}e.ConsoleLogger=s;class a extends g{constructor(o,c=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(c)}trace(o,...c){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(o),...c])}debug(o,...c){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(o),...c])}info(o,...c){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(o),...c])}warn(o,...c){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(o),...c])}error(o,...c){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(o),...c])}critical(o,...c){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(o),...c])}extractMessage(o){return typeof o=="string"?o:(0,n.toErrorMessage)(o,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class l extends g{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const c of this.logServices)c.setLevel(o);super.setLevel(o)}trace(o,...c){for(const w of this.logServices)w.trace(o,...c)}debug(o,...c){for(const w of this.logServices)w.debug(o,...c)}info(o,...c){for(const w of this.logServices)w.info(o,...c)}warn(o,...c){for(const w of this.logServices)w.warn(o,...c)}error(o,...c){for(const w of this.logServices)w.error(o,...c)}critical(o,...c){for(const w of this.logServices)w.critical(o,...c)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=l;class P extends _.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...c){this.logger.trace(o,...c)}debug(o,...c){this.logger.debug(o,...c)}info(o,...c){this.logger.info(o,...c)}warn(o,...c){this.logger.warn(o,...c)}error(o,...c){this.logger.error(o,...c)}critical(o,...c){this.logger.critical(o,...c)}flush(){this.logger.flush()}}e.LogService=P;class v extends _.Disposable{constructor(o,c){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(c(w=>{this.logLevel=w,this.logLevelChangeableLoggers.forEach(f=>f.setLevel(w))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,c){let w=this.loggers.get(o.toString());return w||(w=this.doCreateLogger(o,c?.always?y.Trace:this.logLevel,c),this.loggers.set(o.toString(),w),c?.always||this.logLevelChangeableLoggers.push(w)),w}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class E{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...c){}debug(o,...c){}info(o,...c){}warn(o,...c){}error(o,...c){}critical(o,...c){}dispose(){}flush(){}}e.NullLogService=E;function r(T){if(T.verbose)return y.Trace;if(typeof T.logLevel=="string"){const o=S(T.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function S(T){switch(T){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=S;function i(T){switch(T){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=i}),define(me[75],ge([1,0,33,117,3]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var x;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(x=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function L(s,a){return a-s}y.compare=L;const N=Object.create(null);N[y.Error]=(0,O.localize)(0,null),N[y.Warning]=(0,O.localize)(1,null),N[y.Info]=(0,O.localize)(2,null);function g(s){return N[s]||""}y.toString=g;function t(s){switch(s){case n.default.Error:return y.Error;case n.default.Warning:return y.Warning;case n.default.Info:return y.Info;case n.default.Ignore:return y.Hint}}y.fromSeverity=t;function d(s){switch(s){case y.Error:return n.default.Error;case y.Warning:return n.default.Warning;case y.Info:return n.default.Info;case y.Hint:return n.default.Ignore}}y.toSeverity=d}(x=e.MarkerSeverity||(e.MarkerSeverity={}));var F;(function(y){const L="";function N(t){return g(t,!0)}y.makeKey=N;function g(t,d){let s=[L];return t.source?s.push(t.source.replace("\xA6","\\\xA6")):s.push(L),t.code?typeof t.code=="string"?s.push(t.code.replace("\xA6","\\\xA6")):s.push(t.code.value.replace("\xA6","\\\xA6")):s.push(L),t.severity!==void 0&&t.severity!==null?s.push(x.toString(t.severity)):s.push(L),t.message&&d?s.push(t.message.replace("\xA6","\\\xA6")):s.push(L),t.startLineNumber!==void 0&&t.startLineNumber!==null?s.push(t.startLineNumber.toString()):s.push(L),t.startColumn!==void 0&&t.startColumn!==null?s.push(t.startColumn.toString()):s.push(L),t.endLineNumber!==void 0&&t.endLineNumber!==null?s.push(t.endLineNumber.toString()):s.push(L),t.endColumn!==void 0&&t.endColumn!==null?s.push(t.endColumn.toString()):s.push(L),s.push(L),s.join("\xA6")}y.makeKeyOptionalMessage=g})(F=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(me[135],ge([1,0,5,33,3]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=O.default,e.INotificationService=(0,_.createDecorator)("notificationService");var C;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var x;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(x=e.NotificationsFilter||(e.NotificationsFilter={}));class F{constructor(){this.progress=new y,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=F;class y{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=y}),define(me[136],ge([1,0,7,14,2,3]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return n.Disposable.None},registerValidator(){return n.Disposable.None},registerExternalUriResolver(){return n.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return n.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function x(L,N){return _.URI.isUri(L)?(0,O.equalsIgnoreCase)(L.scheme,N):(0,O.startsWithIgnoreCase)(L,N+":")}e.matchesScheme=x;function F(L,...N){return N.some(g=>x(L,g))}e.matchesSomeScheme=F;function y(L){let N;const g=/^L?(\d+)(?:,(\d+))?/.exec(L.fragment);return g&&(N={startLineNumber:parseInt(g[1]),startColumn:g[2]?parseInt(g[2]):1}),N}e.selectionFragment=y});var Te=this&&this.__decorate||function(Z,e,n,O){var _=arguments.length,C=_<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,n):O,x;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Z,e,n,O);else for(var F=Z.length-1;F>=0;F--)(x=Z[F])&&(C=(_<3?x(C):_>3?x(e,n,C):x(e,n))||C);return _>3&&C&&Object.defineProperty(e,n,C),C},Re=this&&this.__param||function(Z,e){return function(n,O){e(n,O,Z)}};define(me[137],ge([1,0,10,20,7,3]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var x;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(x=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class F{constructor(g){this.callback=g}get value(){return this._value}report(g){this._value=g,this.callback(this._value)}}e.Progress=F,F.None=Object.freeze({report(){}});let y=class extends _.Disposable{constructor(g,t){super();this.deferred=new n.DeferredPromise,t.withProgress(g,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(g){this.reporter?this.reporter.report(g):this.lastStep=g}};y=Te([Re(1,e.IProgressService)],y),e.UnmanagedProgress=y;class L extends _.Disposable{constructor(g){super();this.progressIndicator=g,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(g){this.stop();const t=++this.currentOperationId,d=new O.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{t===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},g),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:t,token:d.token,stop:()=>this.doStop(t),isCurrent:()=>this.currentOperationId===t}}stop(){this.doStop(this.currentOperationId)}doStop(g){this.currentOperationId===g&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=L,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(me[35],ge([1,0,41,13]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(x,F){n.ok(O.isString(x)),n.ok(O.isObject(F)),n.ok(!this.data.has(x),"There is already an extension with this id"),this.data.set(x,F)}knows(x){return this.data.has(x)}as(x){return this.data.get(x)||null}}e.Registry=new _}),define(me[138],ge([1,0,5,35]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(F){return F.length>0&&F.charAt(F.length-1)==="#"?F.substring(0,F.length-1):F}class C{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,L){this.schemasById[_(y)]=L,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const x=new C;O.Registry.add(e.Extensions.JSONContribution,x)}),define(me[76],ge([1,0,16,5,13,114,138,35]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const N=F.Registry.as(x.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(S,i=!0){this.registerConfigurations([S],i)}registerConfigurations(S,i=!0){const T=this.doRegisterConfigurations(S,i);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:T})}deregisterConfigurations(S){const i=this.doDeregisterConfigurations(S);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}updateConfigurations({add:S,remove:i}){const T=[];T.push(...this.doDeregisterConfigurations(i)),T.push(...this.doRegisterConfigurations(S,!1)),N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,n.distinct)(T)})}registerDefaultConfigurations(S){const i=[],T=[];for(const{overrides:o,source:c}of S)for(const w in o)if(i.push(w),e.OVERRIDE_PROPERTY_REGEX.test(w)){const f={...this.configurationDefaultsOverrides.get(w)?.value||{},...o[w]};this.configurationDefaultsOverrides.set(w,{source:c,value:f});const h={type:"object",default:f,description:C.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:_.isString(c)?void 0:c};T.push(...s(w)),this.configurationProperties[w]=h,this.defaultLanguageConfigurationOverridesNode.properties[w]=h}else{this.configurationDefaultsOverrides.set(w,{value:o[w],source:c});const f=this.configurationProperties[w];f&&(this.updatePropertyDefaultValue(w,f),this.updateSchema(w,f))}this.registerOverrideIdentifiers(T),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(S){const i=[];for(const{overrides:T,source:o}of S)for(const c in T){const w=this.configurationDefaultsOverrides.get(c),f=_.isString(o)?o:o?.id,h=_.isString(w?.source)?w?.source:w?.source?.id;if(f===h)if(i.push(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const p=this.configurationProperties[c];p&&(this.updatePropertyDefaultValue(c,p),this.updateSchema(c,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...S){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(S){for(const i of S)this.overrideIdentifiers.add(i);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(S,i){const T=[];return S.forEach(o=>{T.push(...this.validateAndRegisterProperties(o,i,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),T}doDeregisterConfigurations(S){const i=[],T=o=>{if(o.properties)for(const c in o.properties)i.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,o.properties[c]);o.allOf&&o.allOf.forEach(c=>T(c))};for(const o of S){T(o);const c=this.configurationContributors.indexOf(o);c!==-1&&this.configurationContributors.splice(c,1)}return i}validateAndRegisterProperties(S,i=!0,T,o,c=3){c=_.isUndefinedOrNull(S.scope)?c:S.scope;let w=[],f=S.properties;if(f)for(let p in f){if(i&&v(p)){delete f[p];continue}const m=f[p];if(m.source=T,m.defaultDefaultValue=f[p].default,this.updatePropertyDefaultValue(p,m),e.OVERRIDE_PROPERTY_REGEX.test(p)?m.scope=void 0:(m.scope=_.isUndefinedOrNull(m.scope)?c:m.scope,m.restricted=_.isUndefinedOrNull(m.restricted)?!!o?.includes(p):m.restricted),f[p].hasOwnProperty("included")&&!f[p].included){this.excludedConfigurationProperties[p]=f[p],delete f[p];continue}else this.configurationProperties[p]=f[p];!f[p].deprecationMessage&&f[p].markdownDeprecationMessage&&(f[p].deprecationMessage=f[p].markdownDeprecationMessage),w.push(p)}let h=S.allOf;if(h)for(let p of h)w.push(...this.validateAndRegisterProperties(p,i,T,o,c));return w}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(S){const i=T=>{let o=T.properties;if(o)for(const w in o)this.updateSchema(w,o[w]);let c=T.allOf;c&&c.forEach(i)};i(S)}updateSchema(S,i){switch(e.allSettings.properties[S]=i,i.scope){case 1:e.applicationSettings.properties[S]=i;break;case 2:e.machineSettings.properties[S]=i;break;case 6:e.machineOverridableSettings.properties[S]=i;break;case 3:e.windowSettings.properties[S]=i;break;case 4:e.resourceSettings.properties[S]=i;break;case 5:e.resourceSettings.properties[S]=i,this.resourceLanguageSettingsSchema.properties[S]=i;break}}removeFromSchema(S,i){switch(delete e.allSettings.properties[S],i.scope){case 1:delete e.applicationSettings.properties[S];break;case 2:delete e.machineSettings.properties[S];break;case 6:delete e.machineOverridableSettings.properties[S];break;case 3:delete e.windowSettings.properties[S];break;case 4:case 5:delete e.resourceSettings.properties[S],delete this.resourceLanguageSettingsSchema.properties[S];break}}updateOverridePropertyPatternKey(){for(const S of this.overrideIdentifiers.values()){const i=`[${S}]`,T={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(i,T),e.allSettings.properties[i]=T,e.applicationSettings.properties[i]=T,e.machineSettings.properties[i]=T,e.machineOverridableSettings.properties[i]=T,e.windowSettings.properties[i]=T,e.resourceSettings.properties[i]=T}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const S={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=S,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(S,i){const T=this.configurationDefaultsOverrides.get(S);let o=T?.value,c=T?.source;_.isUndefined(o)&&(o=i.defaultDefaultValue,c=void 0),_.isUndefined(o)&&(o=l(i.type)),i.default=o,i.defaultValueSource=c}}const t="\\[([^\\]]+)\\]",d=new RegExp(t,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${t})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(r){const S=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let i=d.exec(r);for(;i?.length;){const T=i[1].trim();T&&S.push(T),i=d.exec(r)}}return(0,n.distinct)(S)}e.overrideIdentifiersFromKey=s;function a(r){return r.reduce((S,i)=>`${S}[${i}]`,"")}e.keyFromOverrideIdentifiers=a;function l(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const P=new g;F.Registry.add(e.Extensions.Configuration,P);function v(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?C.localize(7,null,r):P.getConfigurationProperties()[r]!==void 0?C.localize(8,null,r):null:C.localize(6,null)}e.validateProperty=v;function E(){const r=[],S=P.getConfigurationProperties();for(const i of Object.keys(S))r.push([i,S[i].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=E}),define(me[139],ge([1,0,16,5,97,7,22,25,13,2,74,76,35]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(o={},c=[],w=[]){this._contents=o,this._keys=c,this._overrides=w,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,N.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,c){const w=this.getContentsForOverrideIdentifer(c);return w?o?(0,N.getConfigurationValue)(w,o):w:void 0}getKeysForOverrideIdentifier(o){const c=[];for(const w of this.overrides)w.identifiers.includes(o)&&c.push(...w.keys);return n.distinct(c)}getAllOverrideIdentifiers(){const o=[];for(const c of this.overrides)o.push(...c.identifiers);return n.distinct(o)}override(o){let c=this.overrideConfigurations.get(o);return c||(c=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,c)),c}merge(...o){const c=F.deepClone(this.contents),w=F.deepClone(this.overrides),f=[...this.keys];for(const h of o){this.mergeContents(c,h.contents);for(const p of h.overrides){const[m]=w.filter(b=>n.equals(b.identifiers,p.identifiers));m?(this.mergeContents(m.contents,p.contents),m.keys.push(...p.keys),m.keys=n.distinct(m.keys)):w.push(F.deepClone(p))}for(const p of h.keys)f.indexOf(p)===-1&&f.push(p)}return new d(c,f,w)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const c=this.getContentsForOverrideIdentifer(o);if(!c||typeof c!="object"||!Object.keys(c).length)return this;let w={};for(const f of n.distinct([...Object.keys(this.contents),...Object.keys(c)])){let h=this.contents[f],p=c[f];p&&(typeof h=="object"&&typeof p=="object"?(h=F.deepClone(h),this.mergeContents(h,p)):h=p),w[f]=h}return new d(w,this.keys,this.overrides)}mergeContents(o,c){for(const w of Object.keys(c)){if(w in o&&y.isObject(o[w])&&y.isObject(c[w])){this.mergeContents(o[w],c[w]);continue}o[w]=F.deepClone(c[w])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?F.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let c=null,w=null;const f=h=>{h&&(w?this.mergeContents(w,h):w=F.deepClone(h))};for(const h of this.overrides)n.equals(h.identifiers,[o])?c=h.contents:h.identifiers.includes(o)&&f(h.contents);return f(c),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,c){this.addKey(o),(0,N.addToValueTree)(this.contents,o,c,w=>{throw new Error(w)})}removeValue(o){this.removeKey(o)&&(0,N.removeFromValueTree)(this.contents,o)}addKey(o){let c=this.keys.length;for(let w=0;w<c;w++)o.indexOf(this.keys[w])===0&&(c=w);this.keys.splice(c,1,o)}removeKey(o){let c=this.keys.indexOf(o);return c!==-1?(this.keys.splice(c,1),!0):!1}}e.ConfigurationModel=d;class s extends d{constructor(o={}){const c=t.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),w=Object.keys(c),f=Object.create(null),h=[];for(const p in c){const m=o[p],b=m!==void 0?m:c[p].default;(0,N.addToValueTree)(f,p,b,I=>console.error(`Conflict in default settings: ${I}`))}for(const p of Object.keys(f))g.OVERRIDE_PROPERTY_REGEX.test(p)&&h.push({identifiers:(0,g.overrideIdentifiersFromKey)(p),keys:Object.keys(f[p]),contents:(0,N.toValuesTree)(f[p],m=>console.error(`Conflict in default settings file: ${m}`))});super(f,w,h)}}e.DefaultConfigurationModel=s;class a{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,c){if(!y.isUndefinedOrNull(o)){const w=this.doParseContent(o);this.parseRaw(w,c)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,c){this._raw=o;const{contents:w,keys:f,overrides:h,restricted:p}=this.doParseRaw(o,c);this._configurationModel=new d(w,f,h),this._restrictedConfigurations=p||[]}doParseContent(o){let c={},w=null,f=[],h=[],p=[];function m(I){Array.isArray(f)?f.push(I):w!==null&&(f[w]=I)}let b={onObjectBegin:()=>{let I={};m(I),h.push(f),f=I,w=null},onObjectProperty:I=>{w=I},onObjectEnd:()=>{f=h.pop()},onArrayBegin:()=>{let I=[];m(I),h.push(f),f=I,w=null},onArrayEnd:()=>{f=h.pop()},onLiteralValue:m,onError:(I,k,$)=>{p.push({error:I,offset:k,length:$})}};if(o)try{_.visit(o,b),c=f[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return c}doParseRaw(o,c){const w=t.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),f=this.filter(o,w,!0,c);o=f.raw;const h=(0,N.toValuesTree)(o,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),p=Object.keys(o),m=this.toOverrides(o,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:h,keys:p,overrides:m,restricted:f.restricted}}filter(o,c,w,f){if(!f?.scopes&&!f?.skipRestricted)return{raw:o,restricted:[]};const h={},p=[];for(let m in o)if(g.OVERRIDE_PROPERTY_REGEX.test(m)&&w){const b=this.filter(o[m],c,!1,f);h[m]=b.raw,p.push(...b.restricted)}else{const b=c[m],I=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&p.push(m),(I===void 0||f.scopes===void 0||f.scopes.includes(I))&&(f.skipRestricted&&b?.restricted||(h[m]=o[m]))}return{raw:h,restricted:p}}toOverrides(o,c){const w=[];for(const f of Object.keys(o))if(g.OVERRIDE_PROPERTY_REGEX.test(f)){const h={};for(const p in o[f])h[p]=o[f][p];w.push({identifiers:(0,g.overrideIdentifiersFromKey)(f),keys:Object.keys(h),contents:(0,N.toValuesTree)(h,c)})}return w}}e.ConfigurationModelParser=a;class l extends C.Disposable{constructor(o,c,w,f){super();this.userSettingsResource=o,this.scopes=c,this.fileService=f,this._onDidChange=this._register(new O.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(w.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(O.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=l;class P{constructor(o,c,w=new d,f=new d,h=new x.ResourceMap,p=new d,m=new x.ResourceMap,b=!0){this._defaultConfiguration=o,this._localUserConfiguration=c,this._remoteUserConfiguration=w,this._workspaceConfiguration=f,this._folderConfigurations=h,this._memoryConfiguration=p,this._memoryConfigurationByResource=m,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new x.ResourceMap,this._userConfiguration=null}getValue(o,c,w){return this.getConsolidateConfigurationModel(c,w).getValue(o)}updateValue(o,c,w={}){let f;w.resource?(f=this._memoryConfigurationByResource.get(w.resource),f||(f=new d,this._memoryConfigurationByResource.set(w.resource,f))):f=this._memoryConfiguration,c===void 0?f.removeValue(o):f.setValue(o,c),w.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,c,w){const f=this.getConsolidateConfigurationModel(c,w),h=this.getFolderConfigurationModelForResource(c.resource,w),p=c.resource?this._memoryConfigurationByResource.get(c.resource)||this._memoryConfiguration:this._memoryConfiguration,m=c.overrideIdentifier?this._defaultConfiguration.freeze().override(c.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),b=c.overrideIdentifier?this.userConfiguration.freeze().override(c.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),I=c.overrideIdentifier?this.localUserConfiguration.freeze().override(c.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),k=c.overrideIdentifier?this.remoteUserConfiguration.freeze().override(c.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),$=w?c.overrideIdentifier?this._workspaceConfiguration.freeze().override(c.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,u=h?c.overrideIdentifier?h.freeze().override(c.overrideIdentifier).getValue(o):h.freeze().getValue(o):void 0,U=c.overrideIdentifier?p.override(c.overrideIdentifier).getValue(o):p.getValue(o),z=f.getValue(o),q=n.distinct(n.flatten(f.overrides.map(V=>V.identifiers))).filter(V=>f.getOverrideValue(o,V)!==void 0);return{defaultValue:m,userValue:b,userLocalValue:I,userRemoteValue:k,workspaceValue:$,workspaceFolderValue:u,memoryValue:U,value:z,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:c.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,c.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:c.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,c.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:c.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,c.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:c.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,c.overrideIdentifier):void 0}:void 0,workspace:$!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:c.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,c.overrideIdentifier):void 0}:void 0,workspaceFolder:u!==void 0?{value:h?.freeze().getValue(o),override:c.overrideIdentifier?h?.freeze().getOverrideValue(o,c.overrideIdentifier):void 0}:void 0,memory:U!==void 0?{value:p.getValue(o),override:c.overrideIdentifier?p.getOverrideValue(o,c.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(o){const c=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:c?c.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,c){this._folderConfigurations.set(o,c),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,c){const w=[];if(!c){const{added:f,updated:h,removed:p}=S(this._defaultConfiguration,o);c=[...f,...h,...p]}for(const f of c)for(const h of(0,g.overrideIdentifiersFromKey)(f)){const p=this._defaultConfiguration.getKeysForOverrideIdentifier(h),m=o.getKeysForOverrideIdentifier(h),b=[...m.filter(I=>p.indexOf(I)===-1),...p.filter(I=>m.indexOf(I)===-1),...p.filter(I=>!F.equals(this._defaultConfiguration.override(h).getValue(I),o.override(h).getValue(I)))];w.push([h,b])}return this.updateDefaultConfiguration(o),{keys:c,overrides:w}}compareAndUpdateLocalUserConfiguration(o){const{added:c,updated:w,removed:f,overrides:h}=S(this.localUserConfiguration,o),p=[...c,...w,...f];return p.length&&this.updateLocalUserConfiguration(o),{keys:p,overrides:h}}compareAndUpdateRemoteUserConfiguration(o){const{added:c,updated:w,removed:f,overrides:h}=S(this.remoteUserConfiguration,o);let p=[...c,...w,...f];return p.length&&this.updateRemoteUserConfiguration(o),{keys:p,overrides:h}}compareAndUpdateWorkspaceConfiguration(o){const{added:c,updated:w,removed:f,overrides:h}=S(this.workspaceConfiguration,o);let p=[...c,...w,...f];return p.length&&this.updateWorkspaceConfiguration(o),{keys:p,overrides:h}}compareAndUpdateFolderConfiguration(o,c){const w=this.folderConfigurations.get(o),{added:f,updated:h,removed:p,overrides:m}=S(w,c);let b=[...f,...h,...p];return(b.length||!w)&&this.updateFolderConfiguration(o,c),{keys:b,overrides:m}}compareAndDeleteFolderConfiguration(o){const c=this.folderConfigurations.get(o);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:w,updated:f,removed:h,overrides:p}=S(c,void 0);return{keys:[...w,...f,...h],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,c){let w=this.getConsolidatedConfigurationModelForResource(o,c);return o.overrideIdentifier?w.override(o.overrideIdentifier):w}getConsolidatedConfigurationModelForResource({resource:o},c){let w=this.getWorkspaceConsolidatedConfiguration();if(c&&o){const f=c.getFolder(o);f&&(w=this.getFolderConsolidatedConfiguration(f.uri)||w);const h=this._memoryConfigurationByResource.get(o);h&&(w=w.merge(h))}return w}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let c=this._foldersConsolidatedConfigurations.get(o);if(!c){const w=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(o);f?(c=w.merge(f),this._freeze&&(c=c.freeze()),this._foldersConsolidatedConfigurations.set(o,c)):c=w}return c}getFolderConfigurationModelForResource(o,c){if(c&&o){const w=c.getFolder(o);if(w)return this._folderConfigurations.get(w.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,c)=>{const{contents:w,overrides:f,keys:h}=this._folderConfigurations.get(c);return o.push([c,{contents:w,overrides:f,keys:h}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(c=>o.add(c)),this.userConfiguration.freeze().keys.forEach(c=>o.add(c)),this._workspaceConfiguration.freeze().keys.forEach(c=>o.add(c)),this._folderConfigurations.forEach(c=>c.freeze().keys.forEach(w=>o.add(w))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>o.add(c)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>o.add(c)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(c=>o.add(c)),this._folderConfigurations.forEach(c=>c.freeze().getAllOverrideIdentifiers().forEach(w=>o.add(w))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const c=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(w=>c.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(w=>c.add(w)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(w=>c.add(w)),this._folderConfigurations.forEach(w=>w.getKeysForOverrideIdentifier(o).forEach(f=>c.add(f))),[...c.values()]}static parse(o){const c=this.parseConfigurationModel(o.defaults),w=this.parseConfigurationModel(o.user),f=this.parseConfigurationModel(o.workspace),h=o.folders.reduce((p,m)=>(p.set(L.URI.revive(m[0]),this.parseConfigurationModel(m[1])),p),new x.ResourceMap);return new P(c,w,new d,f,h,new d,new x.ResourceMap,!1)}static parseConfigurationModel(o){return new d(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=P;function v(...T){if(T.length===0)return{keys:[],overrides:[]};if(T.length===1)return T[0];const o=new Set,c=new Map;for(const f of T)f.keys.forEach(h=>o.add(h)),f.overrides.forEach(([h,p])=>{const m=(0,x.getOrSet)(c,h,new Set);p.forEach(b=>m.add(b))});const w=[];return c.forEach((f,h)=>w.push([h,[...f.values()]])),{keys:[...o.values()],overrides:w}}e.mergeChanges=v;class E{constructor(o,c,w,f){this.change=o,this.previous=c,this.currentConfiguraiton=w,this.currentWorkspace=f,this._previousConfiguration=void 0;const h=new Set;o.keys.forEach(m=>h.add(m)),o.overrides.forEach(([,m])=>m.forEach(b=>h.add(b))),this.affectedKeys=[...h.values()];const p=new d;this.affectedKeys.forEach(m=>p.setValue(m,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,c){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(c){const w=this.previousConfiguration?this.previousConfiguration.getValue(o,c,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(o,c,this.currentWorkspace);return!F.equals(w,f)}return!0}return!1}doesAffectedKeysTreeContains(o,c){let w=(0,N.toValuesTree)({[c]:!0},()=>{}),f;for(;typeof w=="object"&&(f=Object.keys(w)[0]);){if(o=o[f],!o)return!1;w=w[f]}return!0}}e.ConfigurationChangeEvent=E;class r extends E{constructor(o,c,w,f){super({keys:o.allKeys(),overrides:[]},void 0,o,c);this.source=w,this.sourceConfig=f}}e.AllKeysConfigurationChangeEvent=r;function S(T,o){const{added:c,removed:w,updated:f}=i(o,T),h=[],p=T?.getAllOverrideIdentifiers()||[],m=o?.getAllOverrideIdentifiers()||[];if(o){const b=m.filter(I=>!p.includes(I));for(const I of b)h.push([I,o.getKeysForOverrideIdentifier(I)])}if(T){const b=p.filter(I=>!m.includes(I));for(const I of b)h.push([I,T.getKeysForOverrideIdentifier(I)])}if(o&&T){for(const b of p)if(m.includes(b)){const I=i({contents:T.getOverrideValue(void 0,b)||{},keys:T.getKeysForOverrideIdentifier(b)},{contents:o.getOverrideValue(void 0,b)||{},keys:o.getKeysForOverrideIdentifier(b)});h.push([b,[...I.added,...I.removed,...I.updated]])}}return{added:c,removed:w,updated:f,overrides:h}}function i(T,o){const c=T?o?T.keys.filter(h=>o.keys.indexOf(h)===-1):[...T.keys]:[],w=o?T?o.keys.filter(h=>T.keys.indexOf(h)===-1):[...o.keys]:[],f=[];if(T&&o){for(const h of o.keys)if(T.keys.indexOf(h)!==-1){const p=(0,N.getConfigurationValue)(o.contents,h),m=(0,N.getConfigurationValue)(T.contents,h);F.equals(p,m)||f.push(h)}}return{added:c,removed:w,updated:f}}}),define(me[77],ge([1,0,3]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var O;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(O=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(x,F=O.Unknown,y){super(x);this._message=x,this._code=F,this._detail=y,this.isHandled=F===O.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(x){return x instanceof _&&x._code===O.TemporarilyNotAvailable}static isNoResolverFound(x){return x instanceof _&&x._code===O.NoResolverFound}static isHandled(x){return x instanceof _&&x.isHandled}}e.RemoteAuthorityResolverError=_}),define(me[78],ge([1,0,11]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function O(C){return C.scheme===n.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=O;function _(C){if(!C)return;const x=C.indexOf("+");return x<0?C:C.substr(0,x)}e.getRemoteName=_}),define(me[23],ge([1,0,14,3,78]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=C;function x(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=x,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(F=e.ExtensionType||(e.ExtensionType={}));class y{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,s){if(typeof d=="undefined"||d===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof d=="string"||typeof s=="string"){let a=typeof d=="string"?d:d.value,l=typeof s=="string"?s:s.value;return n.equalsIgnoreCase(a,l)}return d._lower===s._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=y;function L(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function N(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=N;function g(t,d){if(d){const s=`onResolveRemoteAuthority:${(0,_.getRemoteName)(d)}`;return t.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[140],ge([1,0,14,23]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(s,a){return s.uuid&&a.uuid?s.uuid===a.uuid:s.id===a.id?!0:(0,n.compareIgnoreCase)(s.id,a.id)===0}e.areSameExtensions=_;class C{constructor(a,l){this.version=l,this.id=a.id,this.uuid=a.uuid}key(){return`${this.id}-${this.version}`}equals(a){return a instanceof C?_(this,a)&&this.version===a.version:!1}}e.ExtensionIdentifierWithVersion=C;function x(s,a){return`${s}.${a}`}e.getExtensionId=x;function F(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=F;function y(s,a){return F(x(s,a))}e.getGalleryExtensionId=y;function L(s,a){const l=[],P=v=>{for(const E of l)if(E.some(r=>_(a(r),a(v))))return E;return null};for(const v of s){const E=P(v);E?E.push(v):l.push([v])}return l}e.groupByExtension=L;function N(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=N;function g(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new O.ExtensionIdentifier("pprice.better-merge");function t(s){const a=new Set;if(s.malicious)for(const l of s.malicious)a.add(l.id);return a}e.getMaliciousExtensionsSet=t;function d(s,a){const l=[],P=a.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const v=P.shift();if(v&&l.every(E=>!_(E.identifier,{id:v}))){const E=s.filter(r=>_(r.identifier,{id:v}));E.length===1&&(l.push(E[0]),P.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=d}),define(me[141],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,C,x=5){let F;return F=C(y=>{const L=typeof y=="string"?y:y.data;let N=this._terminalBufferMap.get(_);if(N){N.data.push(L);return}const g=setTimeout(()=>this.flushBuffer(_),x);N={data:[L],timeoutId:g,dispose:()=>{clearTimeout(g),this.flushBuffer(_),F.dispose()}},this._terminalBufferMap.set(_,N)}),F}stopBuffering(_){const C=this._terminalBufferMap.get(_);C&&C.dispose()}flushBuffer(_){const C=this._terminalBufferMap.get(_);C&&(this._terminalBufferMap.delete(_),this._callback(_,C.data.join("")))}}e.TerminalDataBufferer=n}),define(me[142],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var n;(function(O){O.DARK="dark",O.LIGHT="light",O.HIGH_CONTRAST="hc"})(n=e.ColorScheme||(e.ColorScheme={}))}),define(me[55],ge([1,0,103,5,7,3,35,142]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var y;(function(l){function P(v){return v&&typeof v=="object"&&typeof v.id=="string"}l.isThemeColor=P})(y=e.ThemeColor||(e.ThemeColor={}));function L(l){return{id:l}}e.themeColorFromId=L;var N;(function(l){function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color=="undefined"||y.isThemeColor(c.color))}l.isThemeIcon=P;const v=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function E(c){const w=v.exec(c);if(!w)return;let[,f]=w;return{id:f}}l.fromString=E;function r(c){return{id:c}}l.fromId=r;function S(c,w){let f=c.id;const h=f.lastIndexOf("~");return h!==-1&&(f=f.substring(0,h)),w&&(f=`${f}~${w}`),{id:f}}l.modify=S;function i(c){const w=c.id.lastIndexOf("~");if(w!==-1)return c.id.substring(w+1)}l.getModifier=i;function T(c,w){return c.id===w.id&&c.color?.id===w.color?.id}l.isEqual=T;function o(c,w){return{id:c.id,color:w?L(w):void 0}}l.asThemeIcon=o,l.asClassNameArray=n.CSSIcon.asClassNameArray,l.asClassName=n.CSSIcon.asClassName,l.asCSSSelector=n.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function g(l){switch(l){case F.ColorScheme.DARK:return"vs-dark";case F.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=g,e.Extensions={ThemingContribution:"base.contributions.theming"};class t{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new O.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,_.toDisposable)(()=>{const v=this.themingParticipants.indexOf(P);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new t;x.Registry.add(e.Extensions.ThemingContribution,d);function s(l){return d.onColorThemeChange(l)}e.registerThemingParticipant=s;class a extends _.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,v){let E=this.theme.getColor(P);return E&&v&&(E=v(E,this.theme)),E?E.toString():null}}e.Themable=a}),define(me[143],ge([1,0,5,28,3,9]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,_.createDecorator)("sharedTunnelsService");var x;(function(s){s.Http="http",s.Https="https"})(x=e.TunnelProtocol||(e.TunnelProtocol={}));var F;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(F=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function L(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=L,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=g;function t(s,a){return a?a!==1&&s<1024:!O.isWindows&&s<1024}e.isPortPrivileged=t;let d=class{constructor(a){this.logService=a,this._onTunnelOpened=new n.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new n.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new n.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(a){return this._tunnelProvider=a,a?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this._canElevate=a.elevation,this._privacyOptions=a.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const a=[],l=Array.from(this._tunnels.values());for(let P of l){const v=Array.from(P.values());for(let E of v){const r=await E.value;r&&a.push(r)}}return a}async dispose(){for(const a of this._tunnels.values()){for(const{value:l}of a.values())await l.then(P=>P?.dispose());a.clear()}this._tunnels.clear()}openTunnel(a,l,P,v,E=!1,r=F.Private,S){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${P} on local port ${v}.`),!a)return;l||(l="localhost");const i=this.retainOrCreateTunnel(a,l,P,v,E,r,S);return i?i.then(T=>{if(!T){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(l,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(T);return(T.tunnelRemoteHost!==l||T.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const l=this._tunnels.get(a.tunnelRemoteHost);if(l){const P=l.get(a.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(a.tunnelRemoteHost,a.tunnelRemotePort,P))}}}}async tryDisposeTunnel(a,l,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${l}.`);const v=P.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(a)&&this._tunnels.get(a).delete(l),v}}async closeTunnel(a,l){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${l} `);const P=this._tunnels.get(a);if(P&&P.has(l)){const v=P.get(l);v.refcount=0,await this.tryDisposeTunnel(a,l,v)}}addTunnelToMap(a,l,P){this._tunnels.has(a)||this._tunnels.set(a,new Map),this._tunnels.get(a).set(l,{refcount:1,value:P})}async removeEmptyTunnelFromMap(a,l){const P=this._tunnels.get(a);P&&(await P.get(l)||P.delete(l),P.size===0&&this._tunnels.delete(a))}getTunnelFromMap(a,l){let P=[a];N(a)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):g(a)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const v=P.map(E=>this._tunnels.get(E));for(const E of v){const r=E?.get(l);if(r)return r}}canTunnel(a){return!!L(a)}createWithProvider(a,l,P,v,E,r,S){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${P} on local port ${v}.`);const T={elevationRequired:E?t(v===void 0?P:v):!1},o={remoteAddress:{host:l,port:P},localAddressPort:v,privacy:r,public:r!==F.Private,protocol:S},c=a.forwardPort(o,T);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),c&&this.addTunnelToMap(l,P,c),c}};d=Te([Re(0,C.ILogService)],d),e.AbstractTunnelService=d}),define(me[144],ge([1,0,11]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function O(F){return F.scheme!==n.Schemas.file&&F.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=O;function _(F){if(F.folders.length)return F.folders.every(y=>O(y.uri))?F.folders[0].uri:void 0;if(F.configuration&&O(F.configuration))return F.configuration}e.getVirtualWorkspaceLocation=_;function C(F){return _(F)?.scheme}e.getVirtualWorkspaceScheme=C;function x(F){return _(F)!==void 0}e.isVirtualWorkspace=x}),define(me[45],ge([1,0,22,24,2,3]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var x;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(x=e.WorkbenchState||(e.WorkbenchState={}));function F(t){const d=t;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=F;function y(t){const d=t;return!!(d&&typeof d=="object"&&_.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=y;class L{constructor(d,s,a,l,P){this._id=d,this._transient=a,this._configuration=l,this._ignorePathCasing=P,this._foldersMap=n.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=s}update(d){this._id=d.id,this._configuration=d.configuration,this._transient=d.transient,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=n.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=L;class N{constructor(d,s){this.raw=s,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,O.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=N;function g(t){return new N({uri:t,index:0,name:(0,O.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g}),define(me[56],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const C=this._idPool++;return this._data.set(C,_),this.logDebugInfo(),C}get(_,C){return this._data.has(_)?this._data.get(_)[C]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!n.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=n,n.enableDebugLogging=!1}),define(me[29],ge([1,0,11,24,3]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(n.Schemas)),this._providerInfo=new Map,this.extUri=new O.ExtUri(F=>{const y=this._providerInfo.get(F.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(F,y){y===null?this._providerInfo.delete(F.scheme):this._providerInfo.set(F.scheme,y)}isFreeScheme(F){return!this._providerInfo.has(F)&&!this._systemSchemes.has(F)}getCapabilities(F){return this._providerInfo.get(F)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([1,0,3]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(me[145],ge([1,0,10]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class O{constructor(x,F,y){this._deferredPromises=new Map,this._id=x,this._shared=F,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(L=>(this._value=L,this)),this._storageListener=this._storage.onDidChangeStorage(L=>{L.shared===this._shared&&L.key===this._id&&(this._value=L.value)}),this._scheduler=new n.RunOnceScheduler(()=>{const L=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const N of L.values())N.complete()}catch(N){for(const g of L.values())g.error(N)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,x])=>x!==void 0).map(([x])=>x)}get whenReady(){return this._init}get(x,F){let y=this._value[x];return typeof y=="undefined"&&(y=F),y}update(x,F){this._value[x]=F;let y=this._deferredPromises.get(x);if(y!==void 0)return y.p;const L=new n.DeferredPromise;return this._deferredPromises.set(x,L),this._scheduler.isScheduled()||this._scheduler.schedule(),L.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=O;class _ extends O{constructor(x,F){super(x.identifier.value,!0,F);this._extension=x}setKeysForSync(x){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},x)}}e.ExtensionGlobalMemento=_}),define(me[146],ge([1,0,5,2,9]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(F,y){this._logService=F,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new n.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new n.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(F,y,L){this._notebooksAndEditors.getNotebookDocument(O.URI.revive(F)).acceptModelChanged(y.value,L)}$acceptDirtyStateChanged(F,y){this._notebooksAndEditors.getNotebookDocument(O.URI.revive(F)).acceptDirty(y)}$acceptModelSaved(F){const y=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(F));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(F,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",F.path,y);const L=this._notebooksAndEditors.getNotebookDocument(O.URI.revive(F));L.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:L.apiNotebook})}};C=Te([Re(0,_.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(me[12],ge([1,0,3]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class O{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=O});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[147],ge([1,0,23,5]),function(Z,e,n,O){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(F,y){_.set(this,void 0),this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._id=n.ExtensionIdentifier.toKey(F.identifier),ze(this,_,y,"f"),we(this,_,"f").onDidChangePassword(L=>{L.extensionId===this._id&&this._onDidChange.fire({key:L.key})})}get(F){return we(this,_,"f").get(this._id,F)}store(F,y){return we(this,_,"f").store(this._id,F,y)}delete(F){return we(this,_,"f").delete(this._id,F)}}e.ExtensionSecrets=C,_=new WeakMap}),define(me[79],ge([1,0,3,5]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new O.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new O.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(x){this._level=x}$onDidChangeTelemetryLevel(x){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=x,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(me[46],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var n;(function(v){v[v.Upsert=0]="Upsert",v[v.RemoveChild=1]="RemoveChild",v[v.Invalidated=2]="Invalidated",v[v.SetProp=3]="SetProp",v[v.Bulk=4]="Bulk"})(n=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const O=new WeakMap,_=(v,E)=>{const r={controllerId:E};return O.set(v,r),r};e.createPrivateApiFor=_;const C=v=>O.get(v);e.getPrivateApiFor=C;const x=(v,E,r,S)=>{let i=r;return{enumerable:!0,configurable:!1,get(){return i},set(T){if(!S(i,T)){const o=i;i=T,v.listener?.({op:3,key:E,value:T,previous:o})}}}},F=(v,E)=>v===E,y={range:(v,E)=>v===E?!0:!v||!E?!1:v.isEqual(E),label:F,description:F,sortText:F,busy:F,error:F,canResolveChildren:F,tags:(v,E)=>!(v.length!==E.length||v.some(r=>!E.find(S=>r.id===S.id)))},L=Object.keys(y),N=(v,E)=>({range:x(v,"range",void 0,y.range),label:x(v,"label",E,y.label),description:x(v,"description",void 0,y.description),sortText:x(v,"sortText",void 0,y.sortText),canResolveChildren:x(v,"canResolveChildren",!1,y.canResolveChildren),busy:x(v,"busy",!1,y.busy),error:x(v,"error",void 0,y.error),tags:x(v,"tags",[],y.tags)}),g=(v,E)=>{const r=new Map;for(const S of L)y[S](v[S],E[S])||r.set(S,E[S]);return r};e.diffTestItems=g;class t extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=t;class d extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class s extends Error{constructor(E,r,S){super(`TestItem with ID "${E}" is from controller "${r}" and cannot be added as a child of an item from controller "${S}".`)}}e.MixedTestItemController=s;const a=v=>{const E=(0,e.getPrivateApiFor)(v);let r=new Map;return{get size(){return r.size},forEach(S,i){for(const T of r.values())S.call(i,T,this)},replace(S){const i=new Map,T=new Set(r.keys()),o={op:4,ops:[]};for(const c of S){if(!(c instanceof l))throw new d(c.id);const w=(0,e.getPrivateApiFor)(c).controllerId;if(w!==E.controllerId)throw new s(c.id,w,E.controllerId);if(i.has(c.id))throw new t(c.id);i.set(c.id,c),T.delete(c.id),o.ops.push({op:0,item:c})}for(const c of T.keys())o.ops.push({op:1,id:c});E.listener?.(o),r=i},add(S){if(!(S instanceof l))throw new d(S.id);r.set(S.id,S),E.listener?.({op:0,item:S})},delete(S){r.delete(S)&&E.listener?.({op:1,id:S})},get(S){return r.get(S)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class l{constructor(E,r,S,i){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const T=(0,e.createPrivateApiFor)(this,E);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return T.parent instanceof P?void 0:T.parent}},children:{value:a(this),enumerable:!0,writable:!1},...N(T,S)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=l;class P extends l{constructor(E,r){super(E,E,r,void 0)}}e.TestItemRootImpl=P}),define(me[57],ge([1,0,3,143,5,12]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var x;(function(y){function L(g){return{remoteAddress:g.remoteAddress,localAddress:g.localAddress,public:!!g.public,privacy:g.privacy??(g.public?O.TunnelPrivacyId.Public:O.TunnelPrivacyId.Private),protocol:g.protocol}}y.fromApiTunnel=L;function N(g){return{remoteAddress:{host:g.tunnelRemoteHost,port:g.tunnelRemotePort},localAddress:g.localAddress,public:g.privacy!==O.TunnelPrivacyId.ConstantPrivate&&g.privacy!==O.TunnelPrivacyId.ConstantPrivate,privacy:g.privacy,protocol:g.protocol}}y.fromServiceTunnel=N})(x=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let F=class{constructor(L){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(L){return L}async openTunnel(L,N){}async getTunnels(){return[]}async setTunnelFactory(L){return{dispose:()=>{}}}registerPortsAttributesProvider(L,N){return{dispose:()=>{}}}async $providePortAttributes(L,N,g,t,d){return[]}async $forwardPort(L,N){}async $closeTunnel(L){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};F=Te([Re(0,C.IExtHostRpcService)],F),e.ExtHostTunnelService=F});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[6],ge([1,0,16,15,69,22,68,14,13,2,34,44,77]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t){"use strict";var d,s,a,l,P,v,E,r,S,i,T,o,c,w,f,h,p,m,b,I;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(W){function B(){return Reflect.construct(W,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(W,"name")),Object.setPrototypeOf(B,W),Object.setPrototypeOf(B.prototype,W.prototype),B}let $=P=class{constructor(B){d.set(this,void 0),ze(this,d,B,"f")}static from(...B){let ee=B;return new P(function(){if(ee){for(const fe of ee)fe&&typeof fe.dispose=="function"&&fe.dispose();ee=void 0}})}dispose(){typeof we(this,d,"f")=="function"&&(we(this,d,"f").call(this),ze(this,d,void 0,"f"))}};d=new WeakMap,$=P=Te([k],$),e.Disposable=$;let u=v=class{constructor(B,ee){if(B<0)throw(0,O.illegalArgument)("line must be non-negative");if(ee<0)throw(0,O.illegalArgument)("character must be non-negative");this._line=B,this._character=ee}static Min(...B){if(B.length===0)throw new TypeError;let ee=B[0];for(let fe=1;fe<B.length;fe++){const xe=B[fe];xe.isBefore(ee)&&(ee=xe)}return ee}static Max(...B){if(B.length===0)throw new TypeError;let ee=B[0];for(let fe=1;fe<B.length;fe++){const xe=B[fe];xe.isAfter(ee)&&(ee=xe)}return ee}static isPosition(B){if(!B)return!1;if(B instanceof v)return!0;let{line:ee,character:fe}=B;return typeof ee=="number"&&typeof fe=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,ee=0){if(B===null||ee===null)throw(0,O.illegalArgument)();let fe;return typeof B=="undefined"?fe=0:typeof B=="number"?fe=B:(fe=typeof B.lineDelta=="number"?B.lineDelta:0,ee=typeof B.characterDelta=="number"?B.characterDelta:0),fe===0&&ee===0?this:new v(this.line+fe,this.character+ee)}with(B,ee=this.character){if(B===null||ee===null)throw(0,O.illegalArgument)();let fe;return typeof B=="undefined"?fe=this.line:typeof B=="number"?fe=B:(fe=typeof B.line=="number"?B.line:this.line,ee=typeof B.character=="number"?B.character:this.character),fe===this.line&&ee===this.character?this:new v(fe,ee)}toJSON(){return{line:this.line,character:this.character}}};u=v=Te([k],u),e.Position=u;let U=E=class{constructor(B,ee,fe,xe){let We,Qe;if(typeof B=="number"&&typeof ee=="number"&&typeof fe=="number"&&typeof xe=="number"?(We=new u(B,ee),Qe=new u(fe,xe)):B instanceof u&&ee instanceof u&&(We=B,Qe=ee),!We||!Qe)throw new Error("Invalid arguments");We.isBefore(Qe)?(this._start=We,this._end=Qe):(this._start=Qe,this._end=We)}static isRange(B){return B instanceof E?!0:B?u.isPosition(B.start)&&u.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof E?this.contains(B._start)&&this.contains(B._end):B instanceof u?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const ee=u.Max(B.start,this._start),fe=u.Min(B.end,this._end);if(!ee.isAfter(fe))return new E(ee,fe)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ee=u.Min(B.start,this._start),fe=u.Max(B.end,this.end);return new E(ee,fe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,ee=this.end){if(B===null||ee===null)throw(0,O.illegalArgument)();let fe;return B?u.isPosition(B)?fe=B:(fe=B.start||this.start,ee=B.end||this.end):fe=this.start,fe.isEqual(this._start)&&ee.isEqual(this.end)?this:new E(fe,ee)}toJSON(){return[this.start,this.end]}};U=E=Te([k],U),e.Range=U;let z=r=class extends U{constructor(B,ee,fe,xe){let We,Qe;if(typeof B=="number"&&typeof ee=="number"&&typeof fe=="number"&&typeof xe=="number"?(We=new u(B,ee),Qe=new u(fe,xe)):B instanceof u&&ee instanceof u&&(We=B,Qe=ee),!We||!Qe)throw new Error("Invalid arguments");super(We,Qe);this._anchor=We,this._active=Qe}static isSelection(B){return B instanceof r?!0:B?U.isRange(B)&&u.isPosition(B.anchor)&&u.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};z=r=Te([k],z),e.Selection=z;class q{constructor(B,ee,fe){if(typeof B!="string"||B.length===0)throw(0,O.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,O.illegalArgument)("port");if(typeof fe!="undefined"&&(typeof fe!="string"||fe.length===0||!/^[0-9A-Za-z\-]+$/.test(fe)))throw(0,O.illegalArgument)("connectionToken");this.host=B,this.port=Math.round(ee),this.connectionToken=fe}}e.ResolvedAuthority=q;class V extends Error{constructor(B,ee=t.RemoteAuthorityResolverErrorCode.Unknown,fe){super(B);this._message=B,this._code=ee,this._detail=fe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(B,ee){return new V(B,t.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(B){return new V(B,t.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var j;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var Y;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(Y=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let se=S=class{constructor(B,ee){this._range=B,this._newText=ee}static isTextEdit(B){return B instanceof S?!0:B?U.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ee){return new S(B,ee)}static insert(B,ee){return S.replace(new U(B,B),ee)}static delete(B){return S.replace(B,"")}static setEndOfLine(B){const ee=new S(new U(new u(0,0),new u(0,0)),"");return ee.newEol=B,ee}get range(){return this._range}set range(B){if(B&&!U.isRange(B))throw(0,O.illegalArgument)("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw(0,O.illegalArgument)("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw(0,O.illegalArgument)("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};se=S=Te([k],se),e.TextEdit=se;var le;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace"})(le=e.FileEditType||(e.FileEditType={}));let re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,ee,fe,xe){this._edits.push({_type:1,from:B,to:ee,options:fe,metadata:xe})}createFile(B,ee,fe){this._edits.push({_type:1,from:void 0,to:B,options:ee,metadata:fe})}deleteFile(B,ee,fe){this._edits.push({_type:1,from:B,to:void 0,options:ee,metadata:fe})}replaceNotebookMetadata(B,ee,fe){this._edits.push({_type:3,metadata:fe,uri:B,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(B,ee,fe,xe,We){let Qe,Je,bt=[],kt;if(Wt.isNotebookRange(ee)&&$t.isNotebookCellDataArray(fe)&&!$t.isNotebookCellDataArray(xe)?(Qe=ee.start,Je=ee.end,bt=fe,kt=xe):typeof ee=="number"&&typeof fe=="number"&&$t.isNotebookCellDataArray(xe)&&(Qe=ee,Je=fe,bt=xe,kt=We),Qe===void 0||Je===void 0)throw new Error("Invalid arguments");(Qe!==Je||bt.length>0)&&this._edits.push({_type:5,uri:B,index:Qe,count:Je-Qe,cells:bt,metadata:kt})}replaceNotebookCellMetadata(B,ee,fe,xe){this._edits.push({_type:3,metadata:xe,uri:B,edit:{editType:8,index:ee,metadata:fe}})}replace(B,ee,fe,xe){this._edits.push({_type:2,uri:B,edit:new se(ee,fe),metadata:xe})}insert(B,ee,fe,xe){this.replace(B,new U(ee,ee),fe,xe)}delete(B,ee,fe){this.replace(B,ee,"",fe)}has(B){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===B.toString())}set(B,ee){if(ee)for(const fe of ee)fe&&this._edits.push({_type:2,uri:B,edit:fe});else{for(let fe=0;fe<this._edits.length;fe++){const xe=this._edits[fe];xe._type===2&&xe.uri.toString()===B.toString()&&(this._edits[fe]=void 0)}(0,n.coalesceInPlace)(this._edits)}}get(B){const ee=[];for(let fe of this._edits)fe._type===2&&fe.uri.toString()===B.toString()&&ee.push(fe.edit);return ee}entries(){const B=new C.ResourceMap;for(let ee of this._edits)if(ee._type===2){let fe=B.get(ee.uri);fe||(fe=[ee.uri,[]],B.set(ee.uri,fe)),fe[1].push(ee.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};re=Te([k],re),e.WorkspaceEdit=re;let he=i=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof i?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=i._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ee=this._tabstop++){if(typeof B=="function"){const fe=new i;fe._tabstop=this._tabstop,B(fe),this._tabstop=fe._tabstop,B=fe.value}else B=i._escape(B);return this.value+="${",this.value+=ee,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ee=this._tabstop++){const fe=B.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=fe,this.value+="|}",this}appendVariable(B,ee){if(typeof ee=="function"){const fe=new i;fe._tabstop=this._tabstop,ee(fe),this._tabstop=fe._tabstop,ee=fe.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};he=i=Te([k],he),e.SnippetString=he;var Ee;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Ee=e.DiagnosticTag||(e.DiagnosticTag={}));var Ce;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(Ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Pe=T=class{constructor(B,ee){if(this.uri=B,ee)if(ee instanceof U)this.range=ee;else if(ee instanceof u)this.range=new U(ee,ee);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof T?!0:B?U.isRange(B.range)&&L.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Pe=T=Te([k],Pe),e.Location=Pe;let Be=class{constructor(B,ee){this.location=B,this.message=ee}static is(B){return B?typeof B.message=="string"&&B.location&&U.isRange(B.location.range)&&L.URI.isUri(B.location.uri):!1}static isEqual(B,ee){return B===ee?!0:!B||!ee?!1:B.message===ee.message&&B.location.range.isEqual(ee.location.range)&&B.location.uri.toString()===ee.location.uri.toString()}};Be=Te([k],Be),e.DiagnosticRelatedInformation=Be;let je=class{constructor(B,ee,fe=Ce.Error){if(!U.isRange(B))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=B,this.message=ee,this.severity=fe}toJSON(){return{severity:Ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ee){return B===ee?!0:!B||!ee?!1:B.message===ee.message&&B.severity===ee.severity&&B.code===ee.code&&B.severity===ee.severity&&B.source===ee.source&&B.range.isEqual(ee.range)&&(0,n.equals)(B.tags,ee.tags)&&(0,n.equals)(B.relatedInformation,ee.relatedInformation,Be.isEqual)}};je=Te([k],je),e.Diagnostic=je;let tt=class{constructor(B,ee){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:this.contents=[B],this.range=ee}};tt=Te([k],tt),e.Hover=tt;var Ge;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(Ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ot=class{constructor(B,ee=Ge.Text){this.range=B,this.kind=ee}toJSON(){return{range:this.range,kind:Ge[this.kind]}}};ot=Te([k],ot),e.DocumentHighlight=ot;var mt;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(mt=e.SymbolKind||(e.SymbolKind={}));var ve;(function(W){W[W.Deprecated=1]="Deprecated"})(ve=e.SymbolTag||(e.SymbolTag={}));let ce=o=class{constructor(B,ee,fe,xe,We){this.name=B,this.kind=ee,this.containerName=We,typeof fe=="string"&&(this.containerName=fe),xe instanceof Pe?this.location=xe:fe instanceof U&&(this.location=new Pe(xe,fe)),o.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:mt[this.kind],location:this.location,containerName:this.containerName}}};ce=o=Te([k],ce),e.SymbolInformation=ce;let M=c=class{constructor(B,ee,fe,xe,We){this.name=B,this.detail=ee,this.kind=fe,this.range=xe,this.selectionRange=We,this.children=[],c.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(c.validate)}};M=c=Te([k],M),e.DocumentSymbol=M;var A;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(A=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let D=class{constructor(B,ee){this.title=B,this.kind=ee}};D=Te([k],D),e.CodeAction=D;let R=w=class{constructor(B){this.value=B}append(B){return new w(this.value?this.value+w.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+w.sep)}};R.sep=".",R=w=Te([k],R),e.CodeActionKind=R,R.Empty=new R(""),R.QuickFix=R.Empty.append("quickfix"),R.Refactor=R.Empty.append("refactor"),R.RefactorExtract=R.Refactor.append("extract"),R.RefactorInline=R.Refactor.append("inline"),R.RefactorRewrite=R.Refactor.append("rewrite"),R.Source=R.Empty.append("source"),R.SourceOrganizeImports=R.Source.append("organizeImports"),R.SourceFixAll=R.Source.append("fixAll");let H=class{constructor(B,ee){if(this.range=B,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};H=Te([k],H),e.SelectionRange=H;class Q{constructor(B,ee,fe,xe,We,Qe){this.kind=B,this.name=ee,this.detail=fe,this.uri=xe,this.range=We,this.selectionRange=Qe}}e.CallHierarchyItem=Q;class te{constructor(B,ee){this.fromRanges=ee,this.from=B}}e.CallHierarchyIncomingCall=te;class de{constructor(B,ee){this.fromRanges=ee,this.to=B}}e.CallHierarchyOutgoingCall=de;var Se;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(Se=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ae=class{constructor(B,ee){this.range=B,this.command=ee}get isResolved(){return!!this.command}};Ae=Te([k],Ae),e.CodeLens=Ae;let Fe=f=class{constructor(B,ee=!1){s.set(this,void 0),ze(this,s,new _.MarkdownString(B,{supportThemeIcons:ee}),"f")}static isMarkdownString(B){return B instanceof f?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return we(this,s,"f").value}set value(B){we(this,s,"f").value=B}get isTrusted(){return we(this,s,"f").isTrusted}set isTrusted(B){we(this,s,"f").isTrusted=B}get supportThemeIcons(){return we(this,s,"f").supportThemeIcons}set supportThemeIcons(B){we(this,s,"f").supportThemeIcons=B}get supportHtml(){return we(this,s,"f").supportHtml}set supportHtml(B){we(this,s,"f").supportHtml=B}appendText(B){return we(this,s,"f").appendText(B),this}appendMarkdown(B){return we(this,s,"f").appendMarkdown(B),this}appendCodeblock(B,ee){return we(this,s,"f").appendCodeblock(ee??"",B),this}};s=new WeakMap,Fe=f=Te([k],Fe),e.MarkdownString=Fe;let Ue=class{constructor(B,ee){this.label=B,this.documentation=ee}};Ue=Te([k],Ue),e.ParameterInformation=Ue;let Oe=class{constructor(B,ee){this.label=B,this.documentation=ee,this.parameters=[]}};Oe=Te([k],Oe),e.SignatureInformation=Oe;let ke=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ke=Te([k],ke),e.SignatureHelp=ke;var qe;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var it;(function(W){W[W.Other=0]="Other",W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(it=e.InlayHintKind||(e.InlayHintKind={}));let De=class{constructor(B){this.label=B}};De=Te([k],De),e.InlayHintLabelPart=De;let Ze=class{constructor(B,ee,fe){this.label=B,this.position=ee,this.kind=fe}};Ze=Te([k],Ze),e.InlayHint=Ze;var G;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(G=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var X;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var oe;(function(W){W[W.Deprecated=1]="Deprecated"})(oe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ie=class{constructor(B,ee){this.label=B,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&X[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ie=Te([k],Ie),e.CompletionItem=Ie;let Ne=class{constructor(B=[],ee=!1){this.items=B,this.isIncomplete=ee}};Ne=Te([k],Ne),e.CompletionList=Ne;let Ve=class{constructor(B,ee,fe){this.text=B,this.range=ee,this.command=fe}};Ve=Te([k],Ve),e.InlineSuggestion=Ve;let Ye=class{constructor(B){this.items=B}};Ye=Te([k],Ye),e.InlineSuggestions=Ye;var ht;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(ht=e.ViewColumn||(e.ViewColumn={}));var _t;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(_t=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Dt;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var He;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(He=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Pt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Pt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ke;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(Ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ut;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(ut=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function B(ee){switch(ee){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=B}(Ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let At=class{constructor(B,ee){if(ee&&!L.URI.isUri(ee))throw(0,O.illegalArgument)("target");if(!U.isRange(B)||B.isEmpty)throw(0,O.illegalArgument)("range");this.range=B,this.target=ee}};At=Te([k],At),e.DocumentLink=At;let wt=class{constructor(B,ee,fe,xe){this.red=B,this.green=ee,this.blue=fe,this.alpha=xe}};wt=Te([k],wt),e.Color=wt;let at=class{constructor(B,ee){if(ee&&!(ee instanceof wt))throw(0,O.illegalArgument)("color");if(!U.isRange(B)||B.isEmpty)throw(0,O.illegalArgument)("range");this.range=B,this.color=ee}};at=Te([k],at),e.ColorInformation=at;let yt=class{constructor(B){if(!B||typeof B!="string")throw(0,O.illegalArgument)("label");this.label=B}};yt=Te([k],yt),e.ColorPresentation=yt;var Mt;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var Ot;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(Ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Me{constructor(B,ee,fe){if(this.startIndex=B,this.length=ee,this.tooltip=fe,typeof B!="number"||B<0)throw(0,O.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,O.illegalArgument)("length");if(fe!==void 0&&typeof fe!="string")throw(0,O.illegalArgument)("tooltip")}}e.TerminalLink=Me;var ae;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(ae=e.TerminalLocation||(e.TerminalLocation={}));class ue{constructor(B){this.options=B,typeof B!="object"&&(0,O.illegalArgument)("options")}}e.TerminalProfile=ue;var ne;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let pe=h=class{constructor(B,ee){if(this.label=ee,typeof B!="string"||typeof ee!="string")throw(0,O.illegalArgument)("name");this._id=B}static from(B){switch(B){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};pe.Clean=new h("clean","Clean"),pe.Build=new h("build","Build"),pe.Rebuild=new h("rebuild","Rebuild"),pe.Test=new h("test","Test"),pe=h=Te([k],pe),e.TaskGroup=pe;function _e(W){let B="";for(let ee=0;ee<W.length;ee++)B+=W[ee].replace(/,/g,",,")+",";return B}let $e=class{constructor(B,ee,fe){if(typeof B!="string")throw(0,O.illegalArgument)("process");this._args=[],this._process=B,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=fe):this._options=ee)}get process(){return this._process}set process(B){if(typeof B!="string")throw(0,O.illegalArgument)("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)B.push(ee);return _e(B)}};$e=Te([k],$e),e.ProcessExecution=$e;let Le=class{constructor(B,ee,fe){if(this._args=[],Array.isArray(ee)){if(!B)throw(0,O.illegalArgument)("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw(0,O.illegalArgument)("command");this._command=B,this._args=ee,this._options=fe}else{if(typeof B!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=B,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw(0,O.illegalArgument)("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw(0,O.illegalArgument)("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)B.push(typeof ee=="string"?ee:ee.value);return _e(B)}};Le=Te([k],Le),e.ShellExecution=Le;var nt;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(nt=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class vt{constructor(B){this._callback=B}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=vt;let et=p=class{constructor(B,ee,fe,xe,We,Qe){this.__deprecated=!1,this._definition=this.definition=B;let Je;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=fe,this.execution=xe,Je=We,this.__deprecated=!0):ee===pt.Global||ee===pt.Workspace?(this.target=ee,this._name=this.name=fe,this._source=this.source=xe,this.execution=We,Je=Qe):(this.target=ee,this._name=this.name=fe,this._source=this.source=xe,this.execution=We,Je=Qe),typeof Je=="string"?(this._problemMatchers=[Je],this._hasDefinedMatchers=!0):Array.isArray(Je)?(this._problemMatchers=Je,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof $e?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,N.generateUuid)()}}get definition(){return this._definition}set definition(B){if(B==null)throw(0,O.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw(0,O.illegalArgument)("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const ee=this._definition.type;(p.EmptyType===ee||p.ProcessType===ee||p.ShellType===ee||p.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw(0,O.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};et.ExtensionCallbackType="customExecution",et.ProcessType="process",et.ShellType="shell",et.EmptyType="$empty",et=p=Te([k],et),e.Task=et;var lt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(lt=e.ProgressLocation||(e.ProgressLocation={}));let st=class{constructor(B,ee=Ut.None){this.collapsibleState=ee,L.URI.isUri(B)?this.resourceUri=B:this.label=B}};st=Te([k],st),e.TreeItem=st;var Ut;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ct=class{constructor(B){this._value=B}async asString(){return JSON.stringify(this._value)}};Ct=Te([k],Ct),e.TreeDataTransferItem=Ct;let Ft=class{constructor(){this._items=new Map}get(B){return this._items.get(B)}set(B,ee){this._items.set(B,ee)}forEach(B){this._items.forEach(B)}};Ft=Te([k],Ft),e.TreeDataTransfer=Ft;let Et=class{constructor(B,ee){this.id=B,this.color=ee}};Et=Te([k],Et),e.ThemeIcon=Et,Et.File=new Et("file"),Et.Folder=new Et("folder");let dt=class{constructor(B){this.id=B}};dt=Te([k],dt),e.ThemeColor=dt;var Lt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Lt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let qt=class{constructor(B,ee){if(typeof B!="string"&&(!B||!L.URI.isUri(B)&&!L.URI.isUri(B.uri)))throw(0,O.illegalArgument)("base");if(typeof ee!="string")throw(0,O.illegalArgument)("pattern");typeof B=="string"?this.baseUri=L.URI.file(B):L.URI.isUri(B)?this.baseUri=B:this.baseUri=B.uri,this.pattern=ee}get base(){return this._base}set base(B){this._base=B,this._baseUri=L.URI.file(B)}get baseUri(){return this._baseUri}set baseUri(B){this._baseUri=B,this._base=B.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};qt=Te([k],qt),e.RelativePattern=qt;let ct=class{constructor(B,ee,fe,xe){this.enabled=typeof B=="boolean"?B:!0,typeof ee=="string"&&(this.condition=ee),typeof fe=="string"&&(this.hitCondition=fe),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this._id||(this._id=(0,N.generateUuid)()),this._id}};ct=Te([k],ct),e.Breakpoint=ct;let Bt=class extends ct{constructor(B,ee,fe,xe,We){super(ee,fe,xe,We);if(B===null)throw(0,O.illegalArgument)("location");this.location=B}};Bt=Te([k],Bt),e.SourceBreakpoint=Bt;let Gt=class extends ct{constructor(B,ee,fe,xe,We){super(ee,fe,xe,We);this.functionName=B}};Gt=Te([k],Gt),e.FunctionBreakpoint=Gt;let Xt=class extends ct{constructor(B,ee,fe,xe,We,Qe,Je){super(xe,We,Qe,Je);if(!ee)throw(0,O.illegalArgument)("dataId");this.label=B,this.dataId=ee,this.canPersist=fe}};Xt=Te([k],Xt),e.DataBreakpoint=Xt;let ai=class{constructor(B,ee,fe){this.command=B,this.args=ee||[],this.options=fe}};ai=Te([k],ai),e.DebugAdapterExecutable=ai;let It=class{constructor(B,ee){this.port=B,this.host=ee}};It=Te([k],It),e.DebugAdapterServer=It;let Jt=class{constructor(B){this.path=B}};Jt=Te([k],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(B){this.implementation=B}};li=Te([k],li),e.DebugAdapterInlineImplementation=li;let Kt=class{constructor(B,ee){this.range=B,this.expression=ee}};Kt=Te([k],Kt),e.EvaluatableExpression=Kt;var Zt;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let rt=class{constructor(B,ee){this.range=B,this.text=ee}};rt=Te([k],rt),e.InlineValueText=rt;let ci=class{constructor(B,ee,fe=!0){this.range=B,this.variableName=ee,this.caseSensitiveLookup=fe}};ci=Te([k],ci),e.InlineValueVariableLookup=ci;let Nt=class{constructor(B,ee){this.range=B,this.expression=ee}};Nt=Te([k],Nt),e.InlineValueEvaluatableExpression=Nt;let zt=class{constructor(B,ee){this.frameId=B,this.stoppedLocation=ee}};zt=Te([k],zt),e.InlineValueContext=zt;var vi;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=m=class extends Error{constructor(B,ee=g.FileSystemProviderErrorCode.Unknown,fe){super(L.URI.isUri(B)?B.toString(!0):B);this.code=fe?.name??"Unknown",(0,g.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof fe=="function"&&Error.captureStackTrace(this,fe)}static FileExists(B){return new m(B,g.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(B){return new m(B,g.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(B){return new m(B,g.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(B){return new m(B,g.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(B){return new m(B,g.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(B){return new m(B,g.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};ui=m=Te([k],ui),e.FileSystemError=ui;let ei=class{constructor(B,ee,fe){this.start=B,this.end=ee,this.kind=fe}};ei=Te([k],ei),e.FoldingRange=ei;var yi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(yi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Ci{constructor(B,ee=[]){this.tokenTypes=B,this.tokenModifiers=ee}}e.SemanticTokensLegend=Ci;function di(W){return typeof W=="undefined"||(0,y.isStringArray)(W)}class Qt{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let ee=0,fe=B.tokenTypes.length;ee<fe;ee++)this._tokenTypeStrToInt.set(B.tokenTypes[ee],ee);for(let ee=0,fe=B.tokenModifiers.length;ee<fe;ee++)this._tokenModifierStrToInt.set(B.tokenModifiers[ee],ee)}}push(B,ee,fe,xe,We){if(typeof B=="number"&&typeof ee=="number"&&typeof fe=="number"&&typeof xe=="number"&&(typeof We=="number"||typeof We=="undefined"))return typeof We=="undefined"&&(We=0),this._pushEncoded(B,ee,fe,xe,We);if(U.isRange(B)&&typeof ee=="string"&&di(fe))return this._push(B,ee,fe);throw(0,O.illegalArgument)()}_push(B,ee,fe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const xe=B.start.line,We=B.start.character,Qe=B.end.character-B.start.character,Je=this._tokenTypeStrToInt.get(ee);let bt=0;if(fe)for(const kt of fe){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(kt);bt|=1<<xt>>>0}this._pushEncoded(xe,We,Qe,Je,bt)}_pushEncoded(B,ee,fe,xe,We){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const bt=this._data.length/5|0;let kt=0,xt=0;for(let Ht=0;Ht<bt;Ht++){let Vt=this._data[5*Ht],gi=this._data[5*Ht+1];Vt===0?(Vt=kt,gi+=xt):Vt+=kt,this._data[5*Ht]=Vt,this._data[5*Ht+1]=gi,kt=Vt,xt=gi}}let Qe=B,Je=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Qe-=this._prevLine,Qe===0&&(Je-=this._prevChar)),this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=fe,this._data[this._dataLen++]=xe,this._data[this._dataLen++]=We,this._prevLine=B,this._prevChar=ee}static _sortAndDeltaEncode(B){let ee=[];const fe=B.length/5|0;for(let Je=0;Je<fe;Je++)ee[Je]=Je;ee.sort((Je,bt)=>{const kt=B[5*Je],xt=B[5*bt];if(kt===xt){const Ht=B[5*Je+1],Vt=B[5*bt+1];return Ht-Vt}return kt-xt});const xe=new Uint32Array(B.length);let We=0,Qe=0;for(let Je=0;Je<fe;Je++){const bt=5*ee[Je],kt=B[bt+0],xt=B[bt+1],Ht=B[bt+2],Vt=B[bt+3],gi=B[bt+4],Wi=kt-We,Ji=Wi===0?xt-Qe:xt,pi=5*Je;xe[pi+0]=Wi,xe[pi+1]=Ji,xe[pi+2]=Ht,xe[pi+3]=Vt,xe[pi+4]=gi,We=kt,Qe=xt}return xe}build(B){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),B):new hi(Qt._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=Qt;class hi{constructor(B,ee){this.resultId=ee,this.data=B}}e.SemanticTokens=hi;class Ii{constructor(B,ee,fe){this.start=B,this.deleteCount=ee,this.data=fe}}e.SemanticTokensEdit=Ii;class Yt{constructor(B,ee){this.resultId=ee,this.edits=B}}e.SemanticTokensEdits=Yt;var ki;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(ki=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(W){W[W.Initial=1]="Initial",W[W.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new Et("arrow-left")},ii=Te([k],ii),e.QuickInputButtons=ii;var Ti;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Ti=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor(B,ee,fe){this.badge=B,this.tooltip=ee,this.color=fe}static validate(B){if(B.badge){let ee=(0,F.nextCharLength)(B.badge,0);if(ee<B.badge.length&&(ee+=(0,F.nextCharLength)(B.badge,ee)),B.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor(B){this.kind=B}};ni=Te([k],ni),e.ColorTheme=ni;var ye;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast"})(ye=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(B,ee){if(B<0)throw(0,O.illegalArgument)("start must be positive");if(ee<0)throw(0,O.illegalArgument)("end must be positive");B<=ee?(this._start=B,this._end=ee):(this._start=ee,this._end=B)}static isNotebookRange(B){return B instanceof Wt?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let ee=this._start,fe=this._end;return B.start!==void 0&&(ee=B.start),B.end!==void 0&&(fe=B.end),ee===this._start&&fe===this._end?this:new Wt(ee,fe)}}e.NotebookRange=Wt;class $t{constructor(B,ee,fe,xe,We,Qe,Je){this.kind=B,this.value=ee,this.languageId=fe,this.mime=xe,this.outputs=We??[],this.metadata=Qe,this.executionSummary=Je,$t.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ee=>$t.isNotebookCellData(ee))}static isNotebookCellData(B){return!0}}e.NotebookCellData=$t;class ft{constructor(B){this.cells=B}}e.NotebookData=ft;class Rt{constructor(B,ee){this.data=B,this.mime=ee;const fe=(0,x.normalizeMimeType)(ee,!0);if(!fe)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=fe}static isNotebookCellOutputItem(B){return B instanceof Rt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const ee={name:B.name,message:B.message,stack:B.stack};return Rt.json(ee,"application/vnd.code.notebook.error")}static stdout(B){return Rt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Rt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,ee="application/octet-stream"){return new Rt(B,ee)}static text(B,ee=x.Mimes.text){const fe=we(Rt,a,"f",l).encode(String(B));return new Rt(fe,ee)}static json(B,ee="application/json"){const fe=JSON.stringify(B,void 0,"	");return Rt.text(fe,ee)}}e.NotebookCellOutputItem=Rt,a=Rt,l={value:new TextEncoder};class ri{constructor(B,ee,fe){this.items=ri.ensureUniqueMimeTypes(B,!0),typeof ee=="string"?(this.id=ee,this.metadata=fe):(this.id=(0,N.generateUuid)(),this.metadata=ee??fe)}static isNotebookCellOutput(B){return B instanceof ri?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&(0,y.isArray)(B.items)}static ensureUniqueMimeTypes(B,ee=!1){const fe=new Set,xe=new Set;for(let We=0;We<B.length;We++){const Qe=B[We],Je=(0,x.normalizeMimeType)(Qe.mime);if(!fe.has(Je)){fe.add(Je);continue}xe.add(We),ee&&console.warn(`DUPLICATED mime type '${Qe.mime}' will be dropped`)}return xe.size===0?B:B.filter((We,Qe)=>!xe.has(Qe))}}e.NotebookCellOutput=ri;var wi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(wi=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Fi{constructor(B,ee){this.text=B,this.alignment=ee}}e.NotebookCellStatusBarItem=Fi;var Mi;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(Mi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(B,ee=[]){this.uri=B,this.provides=(0,n.asArray)(ee)}}e.NotebookRendererScript=_i;let mi=class{constructor(B,ee){this.label=B,this.timestamp=ee}};mi=Te([k],mi),e.TimelineItem=mi;var Oi;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(Oi=e.ExtensionMode||(e.ExtensionMode={}));var Li;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(Li=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class xi{constructor(B,ee){this.ranges=B,this.wordPattern=ee}}e.LinkedEditingRanges=xi;class J{constructor(B,ee){this._port=B,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=J;var ie;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(ie=e.TestResultState||(e.TestResultState={}));var be;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(be=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xe=class{constructor(B=void 0,ee=void 0,fe=void 0){this.include=B,this.exclude=ee,this.profile=fe}};Xe=Te([k],Xe),e.TestRunRequest=Xe;let gt=b=class{constructor(B){this.message=B}static diff(B,ee,fe){const xe=new b(B);return xe.expectedOutput=ee,xe.actualOutput=fe,xe}};gt=b=Te([k],gt),e.TestMessage=gt;let St=class{constructor(B){this.id=B}};St=Te([k],St),e.TestTag=St;let oi=class{constructor(B,ee){this.covered=B,this.total=ee}};oi=Te([k],oi),e.CoveredCount=oi;let Ui=I=class{constructor(B,ee,fe,xe){this.uri=B,this.statementCoverage=ee,this.branchCoverage=fe,this.functionCoverage=xe}static fromDetails(B,ee){const fe=new oi(0,0),xe=new oi(0,0),We=new oi(0,0);for(const Je of ee)if("branches"in Je){fe.total+=1,fe.covered+=Je.executionCount>0?1:0;for(const bt of Je.branches)xe.total+=1,xe.covered+=bt.executionCount>0?1:0}else We.total+=1,We.covered+=Je.executionCount>0?1:0;const Qe=new I(B,fe,xe.total>0?xe:void 0,We.total>0?We:void 0);return Qe.detailedCoverage=ee,Qe}};Ui=I=Te([k],Ui),e.FileCoverage=Ui;let Bi=class{constructor(B,ee,fe=[]){this.executionCount=B,this.location=ee,this.branches=fe}};Bi=Te([k],Bi),e.StatementCoverage=Bi;let $i=class{constructor(B,ee){this.executionCount=B,this.location=ee}};$i=Te([k],$i),e.BranchCoverage=$i;let Hi=class{constructor(B,ee){this.executionCount=B,this.location=ee}};Hi=Te([k],Hi),e.FunctionCoverage=Hi;var Gi;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(Gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Yi;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(Yi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Xi{constructor(B,ee,fe,xe,We,Qe){this.kind=B,this.name=ee,this.detail=fe,this.uri=xe,this.range=We,this.selectionRange=Qe}}e.TypeHierarchyItem=Xi}),define(me[80],ge([1,0,41,11,14,223,113,6,16]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const L=new Map;function N(s,a){a?L.set(s,a):L.delete(s)}e.setWordDefinitionFor=N;function g(s){return L.get(s)}e.getWordDefinitionFor=g;class t extends C.MirrorTextModel{constructor(a,l,P,v,E,r,S,i){super(l,P,v,E);this._proxy=a,this._languageId=r,this._isDirty=S,this._notebook=i,this._isDisposed=!1}dispose(){(0,n.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,y.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===O.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(l){return l?a._getTextInRange(l):a.getText()},get eol(){return a._eol===`
`?F.EndOfLine.LF:F.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(l){return a._lineAt(l)},offsetAt(l){return a._offsetAt(l)},positionAt(l){return a._positionAt(l)},validateRange(l){return a._validateRange(l)},validatePosition(l){return a._validatePosition(l)},getWordRangeAtPosition(l,P){return a._getWordRangeAtPosition(l,P)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,n.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,n.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const l=this._validateRange(a);if(l.isEmpty)return"";if(l.isSingleLine)return this._lines[l.start.line].substring(l.start.character,l.end.character);const P=this._eol,v=l.start.line,E=l.end.line,r=[];r.push(this._lines[v].substring(l.start.character));for(let S=v+1;S<E;S++)r.push(this._lines[S]);return r.push(this._lines[E].substring(0,l.end.character)),r.join(P)}_lineAt(a){let l;if(a instanceof F.Position?l=a.line:typeof a=="number"&&(l=a),typeof l!="number"||l<0||l>=this._lines.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new d(l,this._lines[l],l===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(a),P=this._lines[l.index].length;return new F.Position(l.index,Math.min(l.remainder,P))}_validateRange(a){if(!(a instanceof F.Range))throw new Error("Invalid argument");const l=this._validatePosition(a.start),P=this._validatePosition(a.end);return l===a.start&&P===a.end?a:new F.Range(l.line,l.character,P.line,P.character)}_validatePosition(a){if(!(a instanceof F.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:l,character:P}=a,v=!1;if(l<0)l=0,P=0,v=!0;else if(l>=this._lines.length)l=this._lines.length-1,P=this._lines[l].length,v=!0;else{const E=this._lines[l].length;P<0?(P=0,v=!0):P>E&&(P=E,v=!0)}return v?new F.Position(l,P):a}_getWordRangeAtPosition(a,l){const P=this._validatePosition(a);if(!l)l=g(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const v=(0,x.getWordAtText)(P.character+1,(0,x.ensureValidWordDefinition)(l),this._lines[P.line],0);if(v)return new F.Range(P.line,v.startColumn-1,P.line,v.endColumn-1)}}e.ExtHostDocumentData=t;class d{constructor(a,l,P){this._line=a,this._text=l,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new F.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new F.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(me[148],ge([1,0,6,5,224,7,149,22,2,34]),function(Z,e,n,O,_,C,x,F,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class N{constructor(t,d,s,a){this._notebook=s,this._selector=a,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,L.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(P=>{const v=this._cellUris.get(P.document.uri);v!==void 0&&(this._cellLengths.setValue(v,this._cells[v].document.getText().length+1),this._cellLines.setValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const l=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(t.onDidChangeNotebookCells(P=>l(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new F.ResourceMap;const t=[],d=[];for(const s of this._notebook.getCells())s.kind===n.NotebookCellKind.Code&&(!this._selector||(0,x.score)(this._selector,s.document.uri,s.document.languageId,!0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),t.push(s.document.getText().length+1),d.push(s.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(t)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(t){if(!t){let v="";for(const E of this._cells)v+=E.document.getText()+`
`;return v=v.slice(0,-1),v}if(t.isEmpty)return"";const d=this.locationAt(t.start),s=this.locationAt(t.end),a=this._cellUris.get(d.uri),l=this._cellUris.get(s.uri);if(a===void 0||l===void 0)return"";if(a===l)return this._cells[a].document.getText(new n.Range(d.range.start,s.range.end));const P=[this._cells[a].document.getText(new n.Range(d.range.start,new n.Position(this._cells[a].document.lineCount,0)))];for(let v=a+1;v<l;v++)P.push(this._cells[v].document.getText());return P.push(this._cells[l].document.getText(new n.Range(new n.Position(0,0),s.range.end))),P.join(`
`)}offsetAt(t){const d=this._cellLines.getIndexOf(t.line),s=this._cellLengths.getPrefixSum(d.index-1),a=this._cells[d.index].document.offsetAt(t.with(d.remainder));return s+a}positionAt(t){if(typeof t=="number"){const s=this._cellLengths.getIndexOf(t),a=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(a)}const d=this._cellUris.get(t.uri);if(d!==void 0){const s=this._cellLines.getPrefixSum(d-1);return new n.Position(s+t.range.start.line,t.range.start.character)}return new n.Position(0,0)}locationAt(t){n.Range.isRange(t)||(t=new n.Range(t,t));const d=this._cellLines.getIndexOf(t.start.line);let s=d;t.isEmpty||(s=this._cellLines.getIndexOf(t.end.line));const a=new n.Position(d.remainder,t.start.character),l=new n.Position(s.remainder,t.end.character),P=new n.Range(a,l),v=this._cells[d.index];return new n.Location(v.document.uri,v.document.validateRange(P))}contains(t){return this._cellUris.has(t)}validateRange(t){const d=this.validatePosition(t.start),s=this.validatePosition(t.end);return t.with(d,s)}validatePosition(t){const d=this._cellLines.getIndexOf(t.line),s=new n.Position(d.remainder,t.character),a=this._cells[d.index].document.validatePosition(s),l=this._cellLines.getPrefixSum(d.index-1);return new n.Position(l+a.line,a.character)}}e.ExtHostNotebookConcatDocument=N}),define(me[150],ge([1,0,6,12,5]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(F){this._actual=new n.ColorTheme(n.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(F){let y=F==="light"?n.ColorThemeKind.Light:F==="dark"?n.ColorThemeKind.Dark:n.ColorThemeKind.HighContrast;this._actual=new n.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Te([Re(0,O.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(me[58],ge([1,0,3]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class O{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=x=>x,this.transformOutgoing=x=>x,this.transformOutgoingURI=x=>x,this.transformOutgoingScheme=x=>x)}}e.URITransformerService=O}),define(me[151],ge([1,0,21]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class O{constructor(){this.buffers=[]}add(y){let L=this.buffers.indexOf(y);return L<0&&(L=this.buffers.length,this.buffers.push(y)),L}}function _(F,y){if(y.serializeBuffersForPostMessage){const L=new O,N=(d,s)=>{if(s instanceof ArrayBuffer){const a=L.add(s);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(s)){const a=C(s);if(a){const l=L.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:l,view:{type:a,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},g=JSON.stringify(F,N),t=L.buffers.map(d=>{const s=new Uint8Array(d);return n.VSBuffer.wrap(s)});return{message:g,buffers:t}}else return{message:JSON.stringify(F),buffers:[]}}e.serializeWebviewMessage=_;function C(F){switch(F.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function x(F,y){const L=y.map(t=>{const d=new ArrayBuffer(t.byteLength);return new Uint8Array(d).set(t.buffer),d}),N=y.length?(t,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const s=d,{index:a}=s,l=L[a];if(s.view)switch(s.view.type){case 1:return new Int8Array(l,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return d}:void 0;return{message:JSON.parse(F,N),arrayBuffers:L}}e.deserializeWebviewMessage=x}),define(me[152],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var n;(function(O){function _(x){const F=new Map;return x.types.forEach((y,L)=>{F.set(y,{asString:async()=>x.items[L].asString})}),F}O.toITreeDataTransfer=_;async function C(x){const F={types:[],items:[]},y=Array.from(x.entries());for(const L of y)F.types.push(L[0]),F.items.push({asString:await L[1].asString()});return F}O.toTreeDataTransferDTO=C})(n=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[59],ge([1,0,11,2]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(F,y){return F.scheme===n.Schemas.http||F.scheme===n.Schemas.https?F:(y&&y.authority&&y.isRemote&&F.scheme===n.Schemas.file&&(F=O.URI.from({scheme:n.Schemas.vscodeRemote,authority:y.authority,path:F.path})),O.URI.from({scheme:n.Schemas.https,authority:`${F.scheme}+${C(F.authority)}.${e.webviewRootResourceAuthority}`,path:F.path,fragment:F.fragment,query:F.query}))}e.asWebviewUri=_;function C(F){return F.replace(/./g,y=>{const L=y.charCodeAt(0);return L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57?y:"-"+L.toString(16).padStart(4,"0")})}function x(F){return F.replace(/-([0-9a-f]{4})/g,(y,L)=>String.fromCharCode(parseInt(L,16)))}e.decodeAuthority=x}),define(me[153],ge([1,0,5,7,59]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(F,y,L){this._proxy=F,this._editors=y,this._initData=L,this._handlePool=0,this._disposables=new O.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const N=y.getVisibleTextEditors();for(const g of this._insets.values())N.indexOf(g.editor)<0&&g.inset.dispose()}))}dispose(){this._insets.forEach(F=>F.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(F,y,L,N,g){let t;for(const E of this._editors.getVisibleTextEditors(!0))if(E.value===F){t=E;break}if(!t)throw new Error("not a visible editor");const d=this,s=this._handlePool++,a=new n.Emitter,l=new n.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(E){return(0,_.asWebviewUri)(E,d._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(E){this._options=E,d._proxy.$setOptions(s,E)}get options(){return this._options}set html(E){this._html=E,d._proxy.$setHtml(s,E)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(E){return d._proxy.$postMessage(s,E)}},v=new class{constructor(){this.editor=F,this.line=y,this.height=L,this.webview=P,this.onDidDispose=l.event}dispose(){d._insets.has(s)&&(d._insets.delete(s),d._proxy.$disposeEditorInset(s),l.fire(),l.dispose(),a.dispose())}};return this._proxy.$createEditorInset(s,t.id,t.value.document.uri,y+1,L,N||{},g.identifier,g.extensionLocation),this._insets.set(s,{editor:F,inset:v,onDidReceiveMessage:a}),v}$onDidDispose(F){const y=this._insets.get(F);y&&y.inset.dispose()}$onDidReceiveMessage(F,y){const L=this._insets.get(F);L&&L.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=C}),define(me[154],ge([1,0,125,13,2,7,3,35,44,16,11]),function(Z,e,n,O,_,C,x,F,y,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function g(u,U,z){for(const q of z.visibleEditorPanes)if(q.group.id===U&&u.matches(q.input))return q.getViewState()}e.findViewStateForEditor=g;function t(u){if(r(u))return!1;const U=u;return _.URI.isUri(U?.resource)}e.isResourceEditorInput=t;function d(u){if(r(u))return!1;const U=u;return U?.original!==void 0&&U.modified!==void 0}e.isResourceDiffEditorInput=d;function s(u){if(r(u)||d(u))return!1;const U=u;return U?.primary!==void 0&&U.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function a(u){if(r(u))return!1;const U=u;return U?U.resource===void 0||U.resource.scheme===N.Schemas.untitled||U.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var l;(function(u){u[u.SHORT=0]="SHORT",u[u.MEDIUM=1]="MEDIUM",u[u.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var P;(function(u){u[u.EXPLICIT=1]="EXPLICIT",u[u.AUTO=2]="AUTO",u[u.FOCUS_CHANGE=3]="FOCUS_CHANGE",u[u.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(P=e.SaveReason||(e.SaveReason={}));var v;(function(u){u[u.None=0]="None",u[u.Readonly=2]="Readonly",u[u.Untitled=4]="Untitled",u[u.Singleton=8]="Singleton",u[u.RequiresTrust=16]="RequiresTrust",u[u.CanSplitInGroup=32]="CanSplitInGroup",u[u.ForceDescription=64]="ForceDescription"})(v=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends C.Disposable{}e.AbstractEditorInput=E;function r(u){return u instanceof E}e.isEditorInput=r;function S(u){const U=u;return _.URI.isUri(U?.preferredResource)}function i(u){const U=u;return r(U?.primary)&&r(U?.secondary)}e.isSideBySideEditorInput=i;function T(u){const U=u;return r(U?.modified)&&r(U?.original)}e.isDiffEditorInput=T;function o(u){return r(u?.editor)}e.isEditorInputWithOptions=o;function c(u){const U=u;return o(u)&&U?.group!==void 0}e.isEditorInputWithOptionsAndGroup=c;function w(u){const U=u;return typeof U?.groupId=="number"&&r(U.editor)}e.isEditorIdentifier=w;var f;(function(u){u[u.UNKNOWN=0]="UNKNOWN",u[u.REPLACE=1]="REPLACE",u[u.MOVE=2]="MOVE",u[u.UNPIN=3]="UNPIN"})(f=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY",u[u.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(h=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var p;(function(u){u[u.PRIMARY=1]="PRIMARY",u[u.SECONDARY=2]="SECONDARY",u[u.BOTH=3]="BOTH",u[u.ANY=4]="ANY"})(p=e.SideBySideEditor||(e.SideBySideEditor={}));class m{getOriginalUri(U,z){if(!U)return;if(z?.supportSideBySide){const{primary:V,secondary:j}=this.getSideEditors(U);if(V&&j){if(z?.supportSideBySide===p.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===p.ANY)return this.getOriginalUri(V,{filterByScheme:z.filterByScheme})??this.getOriginalUri(j,{filterByScheme:z.filterByScheme});U=z.supportSideBySide===p.PRIMARY?V:j}}if(d(U)||s(U))return;const q=S(U)?U.preferredResource:U.resource;return!q||!z||!z.filterByScheme?q:this.filterUri(q,z.filterByScheme)}getSideEditors(U){return i(U)||s(U)?{primary:U.primary,secondary:U.secondary}:T(U)||d(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,z){if(!U)return;if(z?.supportSideBySide){const{primary:V,secondary:j}=this.getSideEditors(U);if(V&&j){if(z?.supportSideBySide===p.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===p.ANY)return this.getCanonicalUri(V,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:z.filterByScheme});U=z.supportSideBySide===p.PRIMARY?V:j}}if(d(U)||s(U))return;const q=U.resource;return!q||!z||!z.filterByScheme?q:this.filterUri(q,z.filterByScheme)}filterUri(U,z){if(Array.isArray(z)){if(z.some(q=>U.scheme===q))return U}else if(z===U.scheme)return U}}e.EditorResourceAccessor=new m;var b;(function(u){u[u.LEFT=0]="LEFT",u[u.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class I{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(U){const z=this.instantiationService=U.get(x.IInstantiationService);for(const[q,V]of this.editorSerializerConstructors)this.createEditorSerializer(q,V,z);this.editorSerializerConstructors.clear()}createEditorSerializer(U,z,q){const V=q.createInstance(z);this.editorSerializerInstances.set(U,V)}registerFileEditorFactory(U){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=U}getFileEditorFactory(){return(0,O.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(U,z){if(this.editorSerializerConstructors.has(U)||this.editorSerializerInstances.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.instantiationService?this.createEditorSerializer(U,z,this.instantiationService):this.editorSerializerConstructors.set(U,z),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(U),this.editorSerializerInstances.delete(U)})}getEditorSerializer(U){return this.editorSerializerInstances.get(typeof U=="string"?U:U.typeId)}}F.Registry.add(e.EditorExtensions.EditorFactory,new I);async function k(u,U){if(!u||!u.length)return[];const z=await Promise.all(u.map(async q=>{const V=_.URI.revive(q.fileUri);if(!V||!await U.canHandleResource(V))return;let Y=q.exists,se=q.type;if(typeof Y!="boolean"||typeof se!="number")try{se=(await U.resolve(V)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Y=!0}catch{Y=!1}if(!Y&&q.openOnlyIfExists||se===y.FileType.Directory)return;const le={selection:Y?q.selection:void 0,pinned:!0,override:q.editorOverrideId};let re;return Y?re={resource:V,options:le}:re={resource:V,options:le,forceUntitled:!0},re}));return(0,L.coalesce)(z)}e.pathsToEditors=k;var $;(function(u){u[u.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",u[u.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[155],ge([1,0,5,10,126]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new n.Emitter,this._onExit=new n.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(F){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=F}onEvent(F){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=F}onRequest(F){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=F}sendResponse(F){F.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${F.command}`)):this.internalSend("response",F)}sendRequest(F,y,L,N){const g={command:F};if(y&&Object.keys(y).length>0&&(g.arguments=y),this.internalSend("request",g),typeof N=="number"){const t=setTimeout(()=>{clearTimeout(t);const d=this.pendingRequests.get(g.seq);if(d){this.pendingRequests.delete(g.seq);const s={type:"response",seq:0,request_seq:g.seq,success:!1,command:F,message:(0,_.localize)(0,null,N,F)};d(s)}},N)}return L&&this.pendingRequests.set(g.seq,L),g.seq}acceptMessage(F){this.messageCallback?this.messageCallback(F):(this.queue.push(F),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(F,y){return F.type!=="event"||y.type!=="event"}async processQueue(){let F;for(;this.queue.length;){if((!F||this.needsTaskBoundaryBetween(this.queue[0],F))&&await(0,O.timeout)(0),F=this.queue.shift(),!F)return;switch(F.type){case"event":this.eventCallback&&this.eventCallback(F);break;case"request":this.requestCallback&&this.requestCallback(F);break;case"response":{const y=F,L=this.pendingRequests.get(y.request_seq);L&&(this.pendingRequests.delete(y.request_seq),L(y));break}}}}internalSend(F,y){y.type=F,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const F=new Map;this.pendingRequests.forEach((y,L)=>F.set(L,y)),await(0,O.timeout)(500),F.forEach((y,L)=>{y({type:"response",seq:0,request_seq:L,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(L)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(me[156],ge([1,0,14,2,19,25,11]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const F=/{([^}]+)}/g;function y(o,c,w){return o.replace(F,function(f,h){return c&&h.length>0&&h[0]!=="_"?f:w&&w.hasOwnProperty(h)?w[h]:f})}e.formatPII=y;function L(o){const c={};for(const w of Object.keys(o))w.startsWith("!")||(c[w]=o[w]);return c}e.filterExceptionsFromTelemetry=L;function N(o){return o.configuration.request==="attach"&&!g(o)&&(!o.parentSession||N(o.parentSession))}e.isSessionAttach=N;function g(o){let c=o.configuration.type;if(!!c)return c==="vslsShare"&&(c=o.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(c,"extensionhost")||(0,n.equalsIgnoreCase)(c,"pwa-extensionhost")?o:o.parentSession?g(o.parentSession):void 0}e.getExtensionHostDebugSession=g;function t(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=t;function d(o,c,w){let f,h=0;const p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=p.exec(o);){const b=m.index+1,I=b+m[0].length;if(b<=c&&I>=w){f=m[0],h=b;break}}if(f){const b=/\w+/g;let I=null;for(;(I=b.exec(f))&&!(I.index+1+h+I[0].length>=w););I&&(f=f.substring(0,b.lastIndex))}return f?{start:h,end:h+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(o){return!!(o&&o.match(s))}e.isUri=a;function l(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(a(o.path))return O.URI.parse(o.path);if((0,_.isAbsolute)(o.path))return O.URI.file(o.path)}return o.path}function P(o){if(typeof o.path=="object"){const c=O.URI.revive(o.path);if(c)return c.scheme===x.Schemas.file?c.fsPath:c.toString()}return o.path}function v(o,c){const w=c?l:P,f=(0,C.deepClone)(o);return r(f,(h,p)=>{h&&p&&(p.path=w(p))}),f}e.convertToDAPaths=v;function E(o,c){const w=c?l:P,f=(0,C.deepClone)(o);return r(f,(h,p)=>{!h&&p&&(p.path=w(p))}),f}e.convertToVSCPaths=E;function r(o,c){switch(o.type){case"event":{const w=o;switch(w.event){case"output":c(!1,w.body.source);break;case"loadedSource":c(!1,w.body.source);break;case"breakpoint":c(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=o;switch(w.command){case"setBreakpoints":c(!0,w.arguments.source);break;case"breakpointLocations":c(!0,w.arguments.source);break;case"source":c(!0,w.arguments.source);break;case"gotoTargets":c(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(f=>c(!1,f));break;default:break}break}case"response":{const w=o;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(f=>c(!1,f.source));break;case"loadedSources":w.body.sources.forEach(f=>c(!1,f));break;case"scopes":w.body.scopes.forEach(f=>c(!1,f.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(f=>c(!1,f.source));break;case"setBreakpoints":w.body.breakpoints.forEach(f=>c(!1,f.source));break;default:break}break}}}function S(o){return o.filter(c=>!c.presentation?.hidden).sort((c,w)=>c.presentation?w.presentation?c.presentation.group?w.presentation.group?c.presentation.group!==w.presentation.group?c.presentation.group.localeCompare(w.presentation.group):i(c.presentation.order,w.presentation.order):-1:w.presentation.group?1:i(c.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.getVisibleAndSorted=S;function i(o,c){return typeof o!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:o-c}async function T(o,c){const w=o.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(w!=="none"&&(await c.saveAll(),w==="allEditorsInActiveGroup")){const f=c.activeEditorPane;f&&f.input.resource?.scheme===x.Schemas.untitled&&await c.save({editor:f.input,groupId:f.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=T}),define(me[81],ge([1,0,36,157,68,11,19,28,53]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var L;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.latex,_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.latex,_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var N;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(N=e.NotebookRunState||(e.NotebookRunState={}));var g;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(g=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var t;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(t=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(b){b.Always="always",b.Never="never",b.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.ChangeCellMime=13]="ChangeCellMime",b[b.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var P;(function(b){b.scheme=C.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function k(V,j){return V.with({scheme:b.scheme,fragment:`ch${j.toString().padStart(7,"0")}${V.scheme!==C.Schemas.file?V.scheme:""}`})}b.generate=k;function $(V){if(V.scheme!==b.scheme)return;const j=I.exec(V.fragment);return j?{handle:Number(j[1]),notebook:V.with({scheme:V.fragment.substring(j[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parse=$;function u(V,j,Y){return V.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${j.toString().padStart(7,"0")},${Y??""},${V.scheme!==C.Schemas.file?V.scheme:""}`})}b.generateCellOutputUri=u;function U(V){if(V.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const j=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(V.fragment);if(!j)return;const Y=Number(j[1]),se=j[2]&&j[2]!==""?j[2]:void 0,le=j[3];return{handle:Y,outputId:se,notebook:V.with({scheme:le||C.Schemas.file,fragment:null})}}b.parseCellOutputUri=U;function z(V,j,Y){return V.with({scheme:Y,fragment:`ch${j.toString().padStart(7,"0")}${V.scheme!==C.Schemas.file?V.scheme:""}`})}b.generateCellUri=z;function q(V,j){if(V.scheme!==j)return;const Y=I.exec(V.fragment);return Y?{handle:Number(Y[1]),notebook:V.with({scheme:V.fragment.substring(Y[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parseCellUri=q})(P=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(b){return v.get(b)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function r(b){return v.get(b)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function S(b){return v.get(b)?.mergeable??!1}e.mimeTypeIsMergeable=S;const i=b=>F.isWindows?b.replace(/\//g,"\\"):b;class T{constructor(I=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(I)].map($=>({pattern:$,matches:n.parse(i($))}))}sort(I){const k=new Map(O.Iterable.map(I,u=>[u,i(u)]));let $=[];for(const{matches:u}of this.order)for(const[U,z]of k)if(u(z)){$.push(U),k.delete(U);break}return k.size&&($=$.concat([...k.keys()].sort((u,U)=>this.defaultOrder.indexOf(u)-this.defaultOrder.indexOf(U)))),$}prioritize(I,k){const $=this.findIndex(I);if($===-1){this.order.unshift({pattern:I,matches:n.parse(i(I))});return}const u=new Set(k.map(z=>this.findIndex(z,$)));u.delete(-1);const U=Array.from(u).sort();this.order.splice($+1,0,...U.map(z=>this.order[z]));for(let z=U.length-1;z>=0;z--)this.order.splice(U[z],1)}toArray(){return this.order.map(I=>I.pattern)}findIndex(I,k=this.order.length){const $=i(I);for(let u=0;u<k;u++)if(this.order[u].matches($))return u;return-1}}e.MimeTypeDisplayOrder=T;function o(b,I,k,$=(u,U)=>u===U){const u=[];function U(V,j,Y){if(j===0&&Y.length===0)return;const se=u[u.length-1];se&&se.start+se.deleteCount===V?(se.deleteCount+=j,se.toInsert.push(...Y)):u.push({start:V,deleteCount:j,toInsert:Y})}let z=0,q=0;for(;;){if(z===b.length){U(z,0,I.slice(q));break}if(q===I.length){U(z,b.length-z,[]);break}const V=b[z],j=I[q];if($(V,j)){z+=1,q+=1;continue}k(j)?(U(z,1,[]),z+=1):(U(z,0,[j]),q+=1)}return u}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var c;(function(b){b.default="default",b.option="option"})(c=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function w(b){const I=b;return!!((typeof I.include=="string"||n.isRelativePattern(I.include))&&(typeof I.exclude=="string"||n.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=w;function f(b,I,k){if(Array.isArray(b.viewType)&&b.viewType.indexOf(I)>=0||b.viewType===I)return!0;if(b.filenamePattern){const $=w(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,u=w(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(n.match($,(0,x.basename)(k.fsPath).toLowerCase()))return!(u&&n.match(u,(0,x.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class h{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)I[k]=this.textModel.cells[k].getHashValue();return I}}e.CellSequence=h,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var p;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(p=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class m{static create(I){return`${m._prefix}${I}`}static parse(I){if(I.startsWith(m._prefix))return I.substring(m._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=m,m._prefix="notebook/"}),define(me[158],ge([1,0,3]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var O;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState"})(O=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(me[159],ge([1,0,3,53]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new O.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new O.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new O.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,n.createDecorator)(e.OUTPUT_SERVICE_ID);var _;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(_=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(me[160],ge([1,0,128,3,53]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,n.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,n.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,n.localize(2,null)),e.ITaskService=(0,O.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[161],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=n;function O(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=O}),define(me[82],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var n;(function(g){g[g.Unset=0]="Unset",g[g.Queued=1]="Queued",g[g.Running=2]="Running",g[g.Passed=3]="Passed",g[g.Failed=4]="Failed",g[g.Skipped=5]="Skipped",g[g.Errored=6]="Errored"})(n=e.TestResultState||(e.TestResultState={}));var O;(function(g){g[g.Run=2]="Run",g[g.Debug=4]="Debug",g[g.Coverage=8]="Coverage",g[g.HasNonDefaultProfile=16]="HasNonDefaultProfile",g[g.HasConfigurable=32]="HasConfigurable"})(O=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(g){g[g.Error=0]="Error",g[g.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var C;(function(g){g[g.NotExpandable=0]="NotExpandable",g[g.Expandable=1]="Expandable",g[g.BusyExpanding=2]="BusyExpanding",g[g.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const x=(g,t)=>{t.expand!==void 0&&(g.expand=t.expand),t.item!==void 0&&(g.item=g.item?Object.assign(g.item,t.item):t.item)};e.applyTestItemUpdate=x;var F;(function(g){g[g.Function=0]="Function",g[g.Statement=1]="Statement"})(F=e.DetailType||(e.DetailType={}));var y;(function(g){g[g.Add=0]="Add",g[g.Update=1]="Update",g[g.Remove=2]="Remove",g[g.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",g[g.Retire=4]="Retire",g[g.AddTag=5]="AddTag",g[g.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class L{add(t){}update(t){}remove(t,d){}complete(){}}e.IncrementalChangeCollector=L;class N{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const d=this.createChangeCollector();for(const s of t)switch(s[0]){case 0:{const a=s[1];if(a.parent){if(this.items.has(a.parent)){const l=this.items.get(a.parent);l.children.add(a.item.extId);const P=this.createItem(a,l);this.items.set(a.item.extId,P),d.add(P)}}else{const l=this.createItem(a);this.roots.add(l),this.items.set(a.item.extId,l),d.add(l)}a.expand===2&&this.busyControllerCount++;break}case 1:{const a=s[1],l=this.items.get(a.extId);if(!l)break;a.expand!==void 0&&(l.expand===2&&this.busyControllerCount--,a.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(l,a),d.update(l);break}case 2:{const a=this.items.get(s[1]);if(!a)break;a.parent?this.items.get(a.parent).children.delete(a.item.extId):this.roots.delete(a);const l=[[s[1]]];for(;l.length;)for(const P of l.pop()){const v=this.items.get(P);v&&(l.push(v.children),this.items.delete(P),d.remove(v,v!==a),v.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(s[1]);break;case 3:this.updatePendingRoots(s[1]);break;case 5:this._tags.set(s[1].id,s[1]);break;case 6:this._tags.delete(s[1]);break}d.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new L}}e.AbstractIncrementalTestCollection=N}),define(me[60],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(C){C.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var O;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(O=e.TestPosition||(e.TestPosition={}));class _{constructor(x,F=x.length){if(this.path=x,this.viewEnd=F,x.length===0||F<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(x,F,y=x.parent){if(x.id===F)return new _([F]);let L=[x.id];for(let N=y;N&&N.id!==F;N=N.parent)L.push(N.id);return L.push(F),new _(L.reverse())}static isRoot(x){return!x.includes("\0")}static root(x){const F=x.indexOf("\0");return F===-1?x:x.slice(0,F)}static fromString(x){return new _(x.split("\0"))}static join(x,F){return new _([...x.path,F])}static joinToString(x,F){return x.toString()+"\0"+F}static compare(x,F){return x===F?0:F.startsWith(x+"\0")?2:x.startsWith(F+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let x=1;x<=this.viewEnd;x++)yield new _(this.path,x)}compare(x){if(typeof x=="string")return _.compare(this.toString(),x);for(let F=0;F<x.viewEnd&&F<this.viewEnd;F++)if(x.path[F]!==this.path[F])return 1;return x.viewEnd>this.viewEnd?2:x.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let x=1;x<this.viewEnd;x++)this.stringifed+="\0",this.stringifed+=this.path[x]}return this.stringifed}}e.TestId=_}),define(me[162],ge([1,0,19,83,13,25,28,70,129]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class L{constructor(g,t,d){this._contributedVariables=new Map,this._context=g,this._labelService=t,d&&(this._envVariablesPromise=d.then(s=>this.prepareEnv(s)))}prepareEnv(g){if(x.isWindows){const t=Object.create(null);return Object.keys(g).forEach(d=>{t[d.toLowerCase()]=g[d]}),t}return g}resolveWithEnvironment(g,t,d){return this.recursiveResolve(this.prepareEnv(g),t?t.uri:void 0,d)}async resolveAsync(g,t){return this.recursiveResolve(await this._envVariablesPromise,g?g.uri:void 0,t)}async resolveAnyBase(g,t,d,s){const a=C.deepClone(t);return x.isWindows&&a.windows?Object.keys(a.windows).forEach(l=>a[l]=a.windows[l]):x.isMacintosh&&a.osx?Object.keys(a.osx).forEach(l=>a[l]=a.osx[l]):x.isLinux&&a.linux&&Object.keys(a.linux).forEach(l=>a[l]=a.linux[l]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,g?g.uri:void 0,a,d,s)}async resolveAnyAsync(g,t,d){return this.resolveAnyBase(g,t,d)}async resolveAnyMap(g,t,d){const s=new Map;return{newConfig:await this.resolveAnyBase(g,t,d,s),resolvedVariables:s}}resolveWithInteractionReplace(g,t,d,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(g,t,d,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(g,t){if(this._contributedVariables.has(g))throw new Error("Variable "+g+" is contributed twice.");this._contributedVariables.set(g,t)}recursiveResolve(g,t,d,s,a){if(_.isString(d))return this.resolveString(g,t,d,s,a);if(_.isArray(d))return d.map(l=>this.recursiveResolve(g,t,l,s,a));if(_.isObject(d)){let l=Object.create(null);return Object.keys(d).forEach(P=>{const v=this.resolveString(g,t,P,s,a);l[v]=this.recursiveResolve(g,t,d[P],s,a)}),l}return d}resolveString(g,t,d,s,a){return d.replace(L.VARIABLE_REGEXP,(P,v)=>{if(v.includes(L.VARIABLE_LHS))return P;let E=this.evaluateSingleVariable(g,P,v,t,s);return a&&a.set(v,E),E!==P&&_.isString(E)&&E.match(L.VARIABLE_REGEXP)&&(E=this.resolveString(g,t,E,s,a)),E})}fsPath(g){return this._labelService?this._labelService.getUriLabel(g,{noPrefix:!0}):g.fsPath}evaluateSingleVariable(g,t,d,s,a){let l;const P=d.split(":");P.length>1&&(d=P[0],l=P[1]);const v=()=>{const S=this._context.getFilePath();if(S)return S;throw new Error((0,y.localize)(0,null,t))},E=()=>{const S=v();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,y.localize)(1,null,t,n.basename(S)))},r=()=>{if(l){const S=this._context.getFolderUri(l);if(S)return S;throw new Error((0,y.localize)(2,null,t,l))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,t)):new Error((0,y.localize)(4,null,t))};switch(d){case"env":if(l){if(g){const S=g[x.isWindows?l.toLowerCase():l];if(_.isString(S))return S}return""}throw new Error((0,y.localize)(5,null,t));case"config":if(l){const S=this._context.getConfigurationValue(s,l);if(_.isUndefinedOrNull(S))throw new Error((0,y.localize)(6,null,t,l));if(_.isObject(S))throw new Error((0,y.localize)(7,null,t,l));return S}throw new Error((0,y.localize)(8,null,t));case"command":return this.resolveFromMap(t,l,a,"command");case"input":return this.resolveFromMap(t,l,a,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,F.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return s||l?(0,F.normalizeDriveLetter)(this.fsPath(r())):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return n.basename(this.fsPath(r()));case"lineNumber":{const S=this._context.getLineNumber();if(S)return S;throw new Error((0,y.localize)(9,null,t))}case"selectedText":{const S=this._context.getSelectedText();if(S)return S;throw new Error((0,y.localize)(10,null,t))}case"file":return v();case"fileWorkspaceFolder":return E();case"relativeFile":return s||l?n.relative(this.fsPath(r()),v()):v();case"relativeFileDirname":{const S=n.dirname(v());if(s||l){const i=n.relative(this.fsPath(r()),S);return i.length===0?".":i}return S}case"fileDirname":return n.dirname(v());case"fileExtname":return n.extname(v());case"fileBasename":return n.basename(v());case"fileBasenameNoExtension":{const S=n.basename(v());return S.slice(0,S.length-n.extname(S).length)}case"fileDirnameBasename":return n.basename(n.dirname(v()));case"execPath":{const S=this._context.getExecPath();return S||t}case"execInstallFolder":{const S=this._context.getAppRoot();return S||t}case"pathSeparator":return n.sep;default:try{const S=l?`${d}:${l}`:d;return this.resolveFromMap(t,S,a,void 0)}catch{return t}}}}resolveFromMap(g,t,d,s){if(t&&d){const a=s===void 0?d[t]:d[s+":"+t];if(typeof a=="string")return a;throw new Error((0,y.localize)(11,null,g))}return g}}e.AbstractVariableResolverService=L,L.VARIABLE_LHS="${",L.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[84],ge([1,0,3,154]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var _;(function(s){s[s.UP=0]="UP",s[s.DOWN=1]="DOWN",s[s.LEFT=2]="LEFT",s[s.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var C;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var x;(function(s){s[s.FIRST=0]="FIRST",s[s.LAST=1]="LAST",s[s.NEXT=2]="NEXT",s[s.PREVIOUS=3]="PREVIOUS"})(x=e.GroupLocation||(e.GroupLocation={}));var F;(function(s){s[s.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",s[s.EVEN=1]="EVEN",s[s.TOGGLE=2]="TOGGLE"})(F=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(s){s[s.COPY_EDITORS=0]="COPY_EDITORS",s[s.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function L(s){const a=s;return(0,O.isEditorInput)(a?.editor)&&(0,O.isEditorInput)(a?.replacement)}e.isEditorReplacement=L;var N;(function(s){s[s.CREATION_TIME=0]="CREATION_TIME",s[s.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",s[s.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var g;(function(s){s[s.NEW_EDITOR=1]="NEW_EDITOR",s[s.MOVE_EDITOR=2]="MOVE_EDITOR",s[s.COPY_EDITOR=3]="COPY_EDITOR"})(g=e.OpenEditorContext||(e.OpenEditorContext={}));function t(s){const a=s;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=t;function d(s){return s.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(me[163],ge([1,0,3,84]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(C){const x=C;return typeof C=="number"||(0,O.isEditorGroup)(x)}e.isPreferredGroup=_}),define(me[8],ge([1,0,16,21,69,98,52,25,13,2,85,86,130,75,46,81,60,163,6]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(ae){function ue(K){const{selectionStartLineNumber:pe,selectionStartColumn:_e,positionLineNumber:$e,positionColumn:Le}=K,nt=new v.Position(pe-1,_e-1),pt=new v.Position($e-1,Le-1);return new v.Selection(nt,pt)}ae.to=ue;function ne(K){const{anchor:pe,active:_e}=K;return{selectionStartLineNumber:pe.line+1,selectionStartColumn:pe.character+1,positionLineNumber:_e.line+1,positionColumn:_e.character+1}}ae.from=ne})(E=e.Selection||(e.Selection={}));var r;(function(ae){function ue(K){if(!K)return;const{start:pe,end:_e}=K;return{startLineNumber:pe.line+1,startColumn:pe.character+1,endLineNumber:_e.line+1,endColumn:_e.character+1}}ae.from=ue;function ne(K){if(!K)return;const{startLineNumber:pe,startColumn:_e,endLineNumber:$e,endColumn:Le}=K;return new v.Range(pe-1,_e-1,$e-1,Le-1)}ae.to=ne})(r=e.Range||(e.Range={}));var S;(function(ae){function ue(ne){switch(ne){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 3:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}ae.to=ue})(S=e.TokenType||(e.TokenType={}));var i;(function(ae){function ue(K){return new v.Position(K.lineNumber-1,K.column-1)}ae.to=ue;function ne(K){return{lineNumber:K.line+1,column:K.character+1}}ae.from=ne})(i=e.Position||(e.Position={}));var T;(function(ae){function ue(pe,_e){return(0,n.coalesce)((0,n.asArray)(pe).map($e=>ne($e,_e)))}ae.from=ue;function ne(pe,_e){if(typeof pe=="string")return{$serialized:!0,language:pe};if(pe)return{$serialized:!0,language:pe.language,scheme:K(pe.scheme,_e),pattern:X.from(pe.pattern)??void 0,exclusive:pe.exclusive}}function K(pe,_e){return _e&&typeof pe=="string"?_e.transformOutgoingScheme(pe):pe}})(T=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(ae){function ue(K){switch(K){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}ae.from=ue;function ne(K){switch(K){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}ae.to=ne})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(ae){function ue(K){let pe;return K.code&&((0,y.isString)(K.code)||(0,y.isNumber)(K.code)?pe=String(K.code):pe={value:String(K.code.value),target:K.code.target}),{...r.from(K.range),message:K.message,source:K.source,code:pe,severity:f.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(w.from),tags:Array.isArray(K.tags)?(0,n.coalesce)(K.tags.map(o.from)):void 0}}ae.from=ue;function ne(K){const pe=new v.Diagnostic(r.to(K),K.message,f.to(K.severity));return pe.source=K.source,pe.code=(0,y.isString)(K.code)?K.code:K.code?.value,pe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(w.to),pe.tags=K.tags&&(0,n.coalesce)(K.tags.map(o.to)),pe}ae.to=ne})(c=e.Diagnostic||(e.Diagnostic={}));var w;(function(ae){function ue(K){return{...r.from(K.location.range),message:K.message,resource:K.location.uri}}ae.from=ue;function ne(K){return new v.DiagnosticRelatedInformation(new v.Location(K.resource,r.to(K)),K.message)}ae.to=ne})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(ae){function ue(K){switch(K){case v.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ae.from=ue;function ne(K){switch(K){case d.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}ae.to=ne})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(ae){function ue(K){return typeof K=="number"&&K>=v.ViewColumn.One?K-1:K===v.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}ae.from=ue;function ne(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ae.to=ne})(h=e.ViewColumn||(e.ViewColumn={}));function p(ae){return typeof ae.range!="undefined"}function m(ae){return ae.length===0?!0:!!p(ae[0])}e.isDecorationOptionsArr=m;var b;(function(ae){function ue(Le){return Le.map(ae.from)}ae.fromMany=ue;function ne(Le){return Le&&typeof Le=="object"&&typeof Le.language=="string"&&typeof Le.value=="string"}function K(Le){let nt;if(ne(Le)){const{language:lt,value:st}=Le;nt={value:"```"+lt+`
`+st+"\n```\n"}}else v.MarkdownString.isMarkdownString(Le)?nt={value:Le.value,isTrusted:Le.isTrusted,supportThemeIcons:Le.supportThemeIcons,supportHtml:Le.supportHtml}:typeof Le=="string"?nt={value:Le}:nt={value:""};const pt=Object.create(null);nt.uris=pt;const vt=lt=>{try{let st=L.URI.parse(lt,!0);st=st.with({query:pe(st.query,pt)}),pt[lt]=st}catch{}return""},et=new C.marked.Renderer;return et.link=vt,et.image=lt=>typeof lt=="string"?vt(_.parseHrefAndDimensions(lt).href):"",(0,C.marked)(nt.value,{renderer:et}),nt}ae.from=K;function pe(Le,nt){if(!Le)return Le;let pt;try{pt=(0,x.parse)(Le)}catch{}if(!pt)return Le;let vt=!1;return pt=(0,F.cloneAndChange)(pt,et=>{if(L.URI.isUri(et)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[lt]=et,vt=!0,lt}else return}),vt?JSON.stringify(pt):Le}function _e(Le){const nt=new v.MarkdownString(Le.value,Le.supportThemeIcons);return nt.isTrusted=Le.isTrusted,nt.supportHtml=Le.supportHtml,nt}ae.to=_e;function $e(Le){if(!!Le)return typeof Le=="string"?Le:ae.from(Le)}ae.fromStrict=$e})(b=e.MarkdownString||(e.MarkdownString={}));function I(ae){return m(ae)?ae.map(ue=>({range:r.from(ue.range),hoverMessage:Array.isArray(ue.hoverMessage)?b.fromMany(ue.hoverMessage):ue.hoverMessage?b.from(ue.hoverMessage):void 0,renderOptions:ue.renderOptions})):ae.map(ue=>({range:r.from(ue)}))}e.fromRangeOrRangeWithMessage=I;function k(ae){return typeof ae=="undefined"?ae:typeof ae=="string"?L.URI.file(ae):ae}e.pathOrURIToURI=k;var $;(function(ae){function ue(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?k(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}ae.from=ue})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var u;(function(ae){function ue(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?k(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?$.from(ne.before):void 0,after:ne.after?$.from(ne.after):void 0}}ae.from=ue})(u=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var U;(function(ae){function ue(ne){if(typeof ne=="undefined")return ne;switch(ne){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}ae.from=ue})(U=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(ae){function ue(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?U.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?u.from(ne.light):void 0,dark:ne.dark?u.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?k(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?$.from(ne.before):void 0,after:ne.after?$.from(ne.after):void 0}}ae.from=ue})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var q;(function(ae){function ue(K){return{text:K.newText,eol:K.newEol&&qe.from(K.newEol),range:r.from(K.range)}}ae.from=ue;function ne(K){const pe=new v.TextEdit(r.to(K.range),K.text);return pe.newEol=typeof K.eol=="undefined"?void 0:qe.to(K.eol),pe}ae.to=ne})(q=e.TextEdit||(e.TextEdit={}));var V;(function(ae){function ue(K,pe,_e){const $e={edits:[]};if(K instanceof v.WorkspaceEdit)for(let Le of K._allEntries())if(Le._type===1)$e.edits.push({_type:1,oldUri:Le.from,newUri:Le.to,options:Le.options,metadata:Le.metadata});else if(Le._type===2){const nt=pe?.getDocument(Le.uri);$e.edits.push({_type:2,resource:Le.uri,edit:q.from(Le.edit),modelVersionId:nt?.version,metadata:Le.metadata})}else Le._type===3?$e.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,edit:Le.edit,notebookMetadata:Le.notebookMetadata,notebookVersionId:_e?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version}):Le._type===5&&$e.edits.push({_type:3,metadata:Le.metadata,resource:Le.uri,notebookVersionId:_e?.getNotebookDocument(Le.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Le.index,count:Le.count,cells:Le.cells.map(ht.from)}});return $e}ae.from=ue;function ne(K){const pe=new v.WorkspaceEdit;for(const _e of K.edits)_e.edit?pe.replace(L.URI.revive(_e.resource),r.to(_e.edit.range),_e.edit.text):pe.renameFile(L.URI.revive(_e.oldUri),L.URI.revive(_e.newUri),_e.options);return pe}ae.to=ne})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(ae){const ue=Object.create(null);ue[v.SymbolKind.File]=0,ue[v.SymbolKind.Module]=1,ue[v.SymbolKind.Namespace]=2,ue[v.SymbolKind.Package]=3,ue[v.SymbolKind.Class]=4,ue[v.SymbolKind.Method]=5,ue[v.SymbolKind.Property]=6,ue[v.SymbolKind.Field]=7,ue[v.SymbolKind.Constructor]=8,ue[v.SymbolKind.Enum]=9,ue[v.SymbolKind.Interface]=10,ue[v.SymbolKind.Function]=11,ue[v.SymbolKind.Variable]=12,ue[v.SymbolKind.Constant]=13,ue[v.SymbolKind.String]=14,ue[v.SymbolKind.Number]=15,ue[v.SymbolKind.Boolean]=16,ue[v.SymbolKind.Array]=17,ue[v.SymbolKind.Object]=18,ue[v.SymbolKind.Key]=19,ue[v.SymbolKind.Null]=20,ue[v.SymbolKind.EnumMember]=21,ue[v.SymbolKind.Struct]=22,ue[v.SymbolKind.Event]=23,ue[v.SymbolKind.Operator]=24,ue[v.SymbolKind.TypeParameter]=25;function ne(pe){return typeof ue[pe]=="number"?ue[pe]:6}ae.from=ne;function K(pe){for(const _e in ue)if(ue[_e]===pe)return Number(_e);return v.SymbolKind.Property}ae.to=K})(j=e.SymbolKind||(e.SymbolKind={}));var Y;(function(ae){function ue(K){switch(K){case v.SymbolTag.Deprecated:return 1}}ae.from=ue;function ne(K){switch(K){case 1:return v.SymbolTag.Deprecated}}ae.to=ne})(Y=e.SymbolTag||(e.SymbolTag={}));var se;(function(ae){function ue(K){return{name:K.name,kind:j.from(K.kind),tags:K.tags&&K.tags.map(Y.from),containerName:K.containerName,location:Ce.from(K.location)}}ae.from=ue;function ne(K){const pe=new v.SymbolInformation(K.name,j.to(K.kind),K.containerName,Ce.to(K.location));return pe.tags=K.tags&&K.tags.map(Y.to),pe}ae.to=ne})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(ae){function ue(K){const pe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:r.from(K.range),selectionRange:r.from(K.selectionRange),kind:j.from(K.kind),tags:K.tags?.map(Y.from)??[]};return K.children&&(pe.children=K.children.map(ue)),pe}ae.from=ue;function ne(K){const pe=new v.DocumentSymbol(K.name,K.detail,j.to(K.kind),r.to(K.range),r.to(K.selectionRange));return(0,n.isNonEmptyArray)(K.tags)&&(pe.tags=K.tags.map(Y.to)),K.children&&(pe.children=K.children.map(ne)),pe}ae.to=ne})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(ae){function ue(K){const pe=new v.CallHierarchyItem(j.to(K.kind),K.name,K.detail||"",L.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return pe._sessionId=K._sessionId,pe._itemId=K._itemId,pe}ae.to=ue;function ne(K,pe,_e){if(pe=pe??K._sessionId,_e=_e??K._itemId,pe===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:pe,_itemId:_e,name:K.name,detail:K.detail,kind:j.from(K.kind),uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(Y.from)}}ae.from=ne})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(ae){function ue(ne){return new v.CallHierarchyIncomingCall(re.to(ne.from),ne.fromRanges.map(K=>r.to(K)))}ae.to=ue})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Ee;(function(ae){function ue(ne){return new v.CallHierarchyOutgoingCall(re.to(ne.to),ne.fromRanges.map(K=>r.to(K)))}ae.to=ue})(Ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ce;(function(ae){function ue(K){return{range:K.range&&r.from(K.range),uri:K.uri}}ae.from=ue;function ne(K){return new v.Location(L.URI.revive(K.uri),r.to(K.range))}ae.to=ne})(Ce=e.location||(e.location={}));var Pe;(function(ae){function ue(K){const pe=K,_e=K;return{originSelectionRange:pe.originSelectionRange?r.from(pe.originSelectionRange):void 0,uri:pe.targetUri?pe.targetUri:_e.uri,range:r.from(pe.targetRange?pe.targetRange:_e.range),targetSelectionRange:pe.targetSelectionRange?r.from(pe.targetSelectionRange):void 0}}ae.from=ue;function ne(K){return{targetUri:L.URI.revive(K.uri),targetRange:r.to(K.range),targetSelectionRange:K.targetSelectionRange?r.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?r.to(K.originSelectionRange):void 0}}ae.to=ne})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Be;(function(ae){function ue(K){return{range:r.from(K.range),contents:b.fromMany(K.contents)}}ae.from=ue;function ne(K){return new v.Hover(K.contents.map(b.to),r.to(K.range))}ae.to=ne})(Be=e.Hover||(e.Hover={}));var je;(function(ae){function ue(K){return{range:r.from(K.range),expression:K.expression}}ae.from=ue;function ne(K){return new v.EvaluatableExpression(r.to(K.range),K.expression)}ae.to=ne})(je=e.EvaluatableExpression||(e.EvaluatableExpression={}));var tt;(function(ae){function ue(K){if(K instanceof v.InlineValueText)return{type:"text",range:r.from(K.range),text:K.text};if(K instanceof v.InlineValueVariableLookup)return{type:"variable",range:r.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ae.from=ue;function ne(K){switch(K.type){case"text":return{range:r.to(K.range),text:K.text};case"variable":return{range:r.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:r.to(K.range),expression:K.expression}}}ae.to=ne})(tt=e.InlineValue||(e.InlineValue={}));var Ge;(function(ae){function ue(K){return{frameId:K.frameId,stoppedLocation:r.from(K.stoppedLocation)}}ae.from=ue;function ne(K){return new v.InlineValueContext(K.frameId,r.to(K.stoppedLocation))}ae.to=ne})(Ge=e.InlineValueContext||(e.InlineValueContext={}));var ot;(function(ae){function ue(K){return{range:r.from(K.range),kind:K.kind}}ae.from=ue;function ne(K){return new v.DocumentHighlight(r.to(K.range),K.kind)}ae.to=ne})(ot=e.DocumentHighlight||(e.DocumentHighlight={}));var mt;(function(ae){function ue(ne){switch(ne){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}ae.to=ue})(mt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ve;(function(ae){function ue(ne){return{triggerKind:mt.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}ae.to=ue})(ve=e.CompletionContext||(e.CompletionContext={}));var ce;(function(ae){function ue(K){switch(K){case v.CompletionItemTag.Deprecated:return 1}}ae.from=ue;function ne(K){switch(K){case 1:return v.CompletionItemTag.Deprecated}}ae.to=ne})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));var M;(function(ae){const ue=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function ne(_e){return ue.get(_e)??9}ae.from=ne;const K=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function pe(_e){return K.get(_e)??v.CompletionItemKind.Property}ae.to=pe})(M=e.CompletionItemKind||(e.CompletionItemKind={}));var A;(function(ae){function ue(ne,K){const pe=new v.CompletionItem(ne.label);return pe.insertText=ne.insertText,pe.kind=M.to(ne.kind),pe.tags=ne.tags?.map(ce.to),pe.detail=ne.detail,pe.documentation=_.isMarkdownString(ne.documentation)?b.to(ne.documentation):ne.documentation,pe.sortText=ne.sortText,pe.filterText=ne.filterText,pe.preselect=ne.preselect,pe.commitCharacters=ne.commitCharacters,N.Range.isIRange(ne.range)?pe.range=r.to(ne.range):typeof ne.range=="object"&&(pe.range={inserting:r.to(ne.range.insert),replacing:r.to(ne.range.replace)}),pe.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?pe.insertText=new v.SnippetString(ne.insertText):(pe.insertText=ne.insertText,pe.textEdit=pe.range instanceof v.Range?new v.TextEdit(pe.range,pe.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(pe.additionalTextEdits=ne.additionalTextEdits.map(_e=>q.to(_e))),pe.command=K&&ne.command?K.fromInternal(ne.command):void 0,pe}ae.to=ue})(A=e.CompletionItem||(e.CompletionItem={}));var D;(function(ae){function ue(K){return{label:K.label,documentation:K.documentation?b.fromStrict(K.documentation):void 0}}ae.from=ue;function ne(K){return{label:K.label,documentation:_.isMarkdownString(K.documentation)?b.to(K.documentation):K.documentation}}ae.to=ne})(D=e.ParameterInformation||(e.ParameterInformation={}));var R;(function(ae){function ue(K){return{label:K.label,documentation:K.documentation?b.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(D.from):[],activeParameter:K.activeParameter}}ae.from=ue;function ne(K){return{label:K.label,documentation:_.isMarkdownString(K.documentation)?b.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(D.to):[],activeParameter:K.activeParameter}}ae.to=ne})(R=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(ae){function ue(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(R.from):[]}}ae.from=ue;function ne(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(R.to):[]}}ae.to=ne})(H=e.SignatureHelp||(e.SignatureHelp={}));var Q;(function(ae){function ue(ne,K){const pe=new v.InlayHint(typeof K.label=="string"?K.label:K.label.map(te.to.bind(void 0,ne)),i.to(K.position),de.to(K.kind));return pe.tooltip=_.isMarkdownString(K.tooltip)?b.to(K.tooltip):K.tooltip,pe.paddingLeft=K.paddingLeft,pe.paddingRight=K.paddingRight,pe}ae.to=ue})(Q=e.InlayHint||(e.InlayHint={}));var te;(function(ae){function ue(ne,K){const pe=new v.InlayHintLabelPart(K.label);return pe.tooltip=_.isMarkdownString(K.tooltip)?b.to(K.tooltip):K.tooltip,g.Command.is(K.command)&&(pe.command=ne.fromInternal(K.command)),K.location&&(pe.location=Ce.to(K.location)),pe}ae.to=ue})(te=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var de;(function(ae){function ue(K){return K}ae.from=ue;function ne(K){return K}ae.to=ne})(de=e.InlayHintKind||(e.InlayHintKind={}));var Se;(function(ae){function ue(K){return{range:r.from(K.range),url:K.target,tooltip:K.tooltip}}ae.from=ue;function ne(K){let pe;if(K.url)try{pe=typeof K.url=="string"?L.URI.parse(K.url,!0):L.URI.revive(K.url)}catch{}return new v.DocumentLink(r.to(K.range),pe)}ae.to=ne})(Se=e.DocumentLink||(e.DocumentLink={}));var Ae;(function(ae){function ue(K){const pe=new v.ColorPresentation(K.label);return K.textEdit&&(pe.textEdit=q.to(K.textEdit)),K.additionalTextEdits&&(pe.additionalTextEdits=K.additionalTextEdits.map(_e=>q.to(_e))),pe}ae.to=ue;function ne(K){return{label:K.label,textEdit:K.textEdit?q.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(pe=>q.from(pe)):void 0}}ae.from=ne})(Ae=e.ColorPresentation||(e.ColorPresentation={}));var Fe;(function(ae){function ue(K){return new v.Color(K[0],K[1],K[2],K[3])}ae.to=ue;function ne(K){return[K.red,K.green,K.blue,K.alpha]}ae.from=ne})(Fe=e.Color||(e.Color={}));var Ue;(function(ae){function ue(K){return{range:r.from(K.range)}}ae.from=ue;function ne(K){return new v.SelectionRange(r.to(K.range))}ae.to=ne})(Ue=e.SelectionRange||(e.SelectionRange={}));var Oe;(function(ae){function ue(ne){switch(ne){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}ae.to=ue})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ke;(function(ae){function ue(K){switch(K){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.On:default:return 1}}ae.from=ue;function ne(K){switch(K){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 1:default:return v.TextEditorLineNumbersStyle.On}}ae.to=ne})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var qe;(function(ae){function ue(K){if(K===v.EndOfLine.CRLF)return 1;if(K===v.EndOfLine.LF)return 0}ae.from=ue;function ne(K){if(K===1)return v.EndOfLine.CRLF;if(K===0)return v.EndOfLine.LF}ae.to=ne})(qe=e.EndOfLine||(e.EndOfLine={}));var it;(function(ae){function ue(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ae.from=ue})(it=e.ProgressLocation||(e.ProgressLocation={}));var De;(function(ae){function ue(ne){const K={start:ne.start+1,end:ne.end+1};return ne.kind&&(K.kind=Ze.from(ne.kind)),K}ae.from=ue})(De=e.FoldingRange||(e.FoldingRange={}));var Ze;(function(ae){function ue(ne){if(ne)switch(ne){case v.FoldingRangeKind.Comment:return g.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return g.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return g.FoldingRangeKind.Region}}ae.from=ue})(Ze=e.FoldingRangeKind||(e.FoldingRangeKind={}));var G;(function(ae){function ue(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?r.from(ne.selection):void 0,override:typeof ne.override=="boolean"?t.EditorResolution.DISABLED:void 0}}ae.from=ue})(G=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var X;(function(ae){function ue(_e){return _e instanceof v.RelativePattern?_e.toJSON():typeof _e=="string"?_e:ne(_e)||K(_e)?new v.RelativePattern(_e.baseUri??_e.base,_e.pattern).toJSON():_e}ae.from=ue;function ne(_e){const $e=_e;return $e?L.URI.isUri($e.baseUri)&&typeof $e.pattern=="string":!1}function K(_e){const $e=_e;return $e?typeof $e.base=="string"&&typeof $e.pattern=="string":!1}function pe(_e){return typeof _e=="string"?_e:new v.RelativePattern(L.URI.revive(_e.baseUri),_e.pattern)}ae.to=pe})(X=e.GlobPattern||(e.GlobPattern={}));var oe;(function(ae){function ue(ne){if(ne){if(Array.isArray(ne))return ne.map(ue);if(typeof ne=="string")return ne;{const K=ne;return{language:K.language,scheme:K.scheme,pattern:X.from(K.pattern),exclusive:K.exclusive}}}else return}ae.from=ue})(oe=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(ae){function ue(K){return{start:K.start,end:K.end}}ae.from=ue;function ne(K){return new v.NotebookRange(K.start,K.end)}ae.to=ne})(Ie=e.NotebookRange||(e.NotebookRange={}));var Ne;(function(ae){function ue(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ae.to=ue;function ne(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ae.from=ne})(Ne=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ve;(function(ae){function ue(K){switch(K){case v.NotebookCellKind.Markup:return a.CellKind.Markup;case v.NotebookCellKind.Code:default:return a.CellKind.Code}}ae.from=ue;function ne(K){switch(K){case a.CellKind.Markup:return v.NotebookCellKind.Markup;case a.CellKind.Code:default:return v.NotebookCellKind.Code}}ae.to=ne})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(ae){function ue(K){const pe={metadata:K.metadata??Object.create(null),cells:[]};for(let _e of K.cells)v.NotebookCellData.validate(_e),pe.cells.push(ht.from(_e));return pe}ae.from=ue;function ne(K){const pe=new v.NotebookData(K.cells.map(ht.to));return(0,y.isEmptyObject)(K.metadata)||(pe.metadata=K.metadata),pe}ae.to=ne})(Ye=e.NotebookData||(e.NotebookData={}));var ht;(function(ae){function ue(K){return{cellKind:Ve.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ne.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Dt.from):[]}}ae.from=ue;function ne(K){return new v.NotebookCellData(Ve.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Dt.to):void 0,K.metadata,K.internalMetadata?Ne.to(K.internalMetadata):void 0)}ae.to=ne})(ht=e.NotebookCellData||(e.NotebookCellData={}));var _t;(function(ae){function ue(K){return{mime:K.mime,valueBytes:O.VSBuffer.wrap(K.data)}}ae.from=ue;function ne(K){return new v.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ae.to=ne})(_t=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Dt;(function(ae){function ue(K){return{outputId:K.id,items:K.items.map(_t.from),metadata:K.metadata}}ae.from=ue;function ne(K){const pe=K.items.map(_t.to);return new v.NotebookCellOutput(pe,K.outputId,K.metadata)}ae.to=ne})(Dt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var He;(function(ae){function ue(pe){return K(pe)?{include:(0,y.withNullAsUndefined)(X.from(pe.include)),exclude:(0,y.withNullAsUndefined)(X.from(pe.exclude))}:(0,y.withNullAsUndefined)(X.from(pe))}ae.from=ue;function ne(pe){return K(pe)?{include:X.to(pe.include),exclude:X.to(pe.exclude)}:X.to(pe)}ae.to=ne;function K(pe){const _e=pe;return _e?!!_e.include&&!!_e.exclude:!1}})(He=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pt;(function(ae){function ue(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?$.from(ne.top):void 0}}ae.from=ue})(Pt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ke;(function(ae){function ue(ne,K,pe){const _e=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(_e,pe),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}ae.from=ue})(Ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ut;(function(ae){function ue(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}ae.from=ue})(ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Tt;(function(ae){function ue(K){return{uri:K.uri,provides:K.provides}}ae.from=ue;function ne(K){return new v.NotebookRendererScript(L.URI.revive(K.uri),K.provides)}ae.to=ne})(Tt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(ae){function ue(K){return{message:b.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Ce.from(K.location):void 0}}ae.from=ue;function ne(K){const pe=new v.TestMessage(typeof K.message=="string"?K.message:b.to(K.message));return pe.actualOutput=K.actual,pe.expectedOutput=K.expected,pe.location=K.location?Ce.to(K.location):void 0,pe}ae.to=ne})(At=e.TestMessage||(e.TestMessage={}));var wt;(function(ae){let ue;(function(ne){ne.Delimiter="\0"})(ue||(ue={})),ae.namespace=(ne,K)=>ne+"\0"+K,ae.denamespace=ne=>{const K=ne.indexOf("\0");return{ctrlId:ne.slice(0,K),tagId:ne.slice(K+1)}}})(wt=e.TestTag||(e.TestTag={}));var at;(function(ae){function ue(_e){const $e=(0,s.getPrivateApiFor)(_e).controllerId;return{extId:l.TestId.fromExtHostTestItem(_e,$e).toString(),label:_e.label,uri:_e.uri,tags:_e.tags.map(Le=>wt.namespace($e,Le.id)),range:r.from(_e.range)||null,description:_e.description||null,sortText:_e.sortText||null,error:_e.error&&b.fromStrict(_e.error)||null}}ae.from=ue;function ne(_e){return{parent:void 0,error:void 0,id:l.TestId.fromString(_e.extId).localId,label:_e.label,uri:L.URI.revive(_e.uri),tags:(_e.tags||[]).map($e=>{const{tagId:Le}=wt.denamespace($e);return new v.TestTag(Le)}),range:r.to(_e.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:_e.description||void 0,sortText:_e.sortText||void 0}}ae.toPlain=ne;function K(_e){const $e=l.TestId.fromString(_e.extId),Le=new s.TestItemImpl($e.controllerId,$e.localId,_e.label,L.URI.revive(_e.uri));return Le.range=r.to(_e.range||void 0),Le.description=_e.description||void 0,Le.sortText=_e.sortText||void 0,Le}function pe(_e){let $e;for(const Le of _e.tests){const nt=K(Le.item);(0,s.getPrivateApiFor)(nt).parent=$e,$e=nt}return $e}ae.toItemFromContext=pe})(at=e.TestItem||(e.TestItem={})),function(ae){function ue(K){return{id:K.id}}ae.from=ue;function ne(K){return new v.TestTag(K.id)}ae.to=ne}(wt=e.TestTag||(e.TestTag={}));var yt;(function(ae){const ue=(K,pe)=>{const _e={...at.toPlain(K.item),parent:void 0,taskStates:K.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(Le=>Le.type===0).map(At.to)})),children:K.children.map($e=>pe.get($e)).filter(y.isDefined).map($e=>ue($e,pe))};for(const $e of _e.children)$e.parent=_e;return _e};function ne(K){const pe=[],_e=new Map;for(const $e of K.items)_e.set($e.item.extId,$e),K.request.targets.some(Le=>Le.controllerId===$e.controllerId&&Le.testIds.includes($e.item.extId))&&pe.push($e);return{completedAt:K.completedAt,results:pe.map($e=>ue($e,_e))}}ae.to=ne})(yt=e.TestResults||(e.TestResults={}));var Mt;(function(ae){function ue(_e){return{covered:_e.covered,total:_e.covered}}function ne(_e){return"line"in _e?i.from(_e):r.from(_e)}function K(_e){return"branches"in _e?{count:_e.executionCount,location:ne(_e.location),type:1,branches:_e.branches.length?_e.branches.map($e=>({count:$e.executionCount,location:$e.location&&ne($e.location)})):void 0}:{type:0,count:_e.executionCount,location:ne(_e.location)}}ae.fromDetailed=K;function pe(_e){return{uri:_e.uri,statement:ue(_e.statementCoverage),branch:_e.branchCoverage&&ue(_e.branchCoverage),function:_e.functionCoverage&&ue(_e.functionCoverage),details:_e.detailedCoverage?.map(K)}}ae.fromFile=pe})(Mt=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(ae){function ue(ne){switch(ne){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}ae.to=ue})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Me;(function(ae){function ue(K){const pe=new v.TypeHierarchyItem(j.to(K.kind),K.name,K.detail||"",L.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return pe._sessionId=K._sessionId,pe._itemId=K._itemId,pe}ae.to=ue;function ne(K,pe,_e){if(pe=pe??K._sessionId,_e=_e??K._itemId,pe===void 0||_e===void 0)throw new Error("invalid item");return{_sessionId:pe,_itemId:_e,kind:j.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(Y.from)}}ae.from=ne})(Me=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[164],ge([1,0,2,15,6,8,225]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class F{constructor(L,N,g,t={timeout:1500,errors:3}){this._logService=L,this._documents=N,this._mainThreadBulkEdits=g,this._thresholds=t,this._callbacks=new x.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(L){return(N,g,t)=>{const s={dispose:this._callbacks.push([N,g,L])};return Array.isArray(t)&&t.push(s),s}}async $participateInSave(L,N){const g=n.URI.revive(L);let t=!1;const d=setTimeout(()=>t=!0,this._thresholds.timeout),s=[];try{for(let a of[...this._callbacks]){if(t)break;const l=this._documents.getDocument(g),P=await this._deliverEventAsyncAndBlameBadListeners(a,{document:l,reason:C.TextDocumentSaveReason.to(N)});s.push(P)}}finally{clearTimeout(d)}return s}_deliverEventAsyncAndBlameBadListeners([L,N,g],t){const d=this._badListeners.get(L);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(g,L,N,t).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const a=this._badListeners.get(L);this._badListeners.set(L,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(L,N,g,t){const d=[],s=Date.now(),{document:a,reason:l}=t,{version:P}=a,v=Object.freeze({document:a,reason:l,waitUntil(E){if(Object.isFrozen(d))throw(0,O.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(E))}});try{N.apply(g,[v])}catch(E){return Promise.reject(E)}return Object.freeze(d),new Promise((E,r)=>{const S=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${L.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(S),E(i)}).catch(i=>{clearTimeout(S),r(i)})}).then(E=>{const r={edits:[]};for(const S of E)if(Array.isArray(S)&&S.every(i=>i instanceof _.TextEdit))for(const{newText:i,newEol:T,range:o}of S)r.edits.push({_type:2,resource:a.uri,edit:{range:o&&C.Range.from(o),text:i,eol:T&&C.EndOfLine.from(T)}});if(r.edits.length!==0)return P===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=F}),define(me[165],ge([1,0,11,25,2,8,81]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class F{constructor(g,t,d,s){this.start=g,this.deletedCount=t,this.deletedItems=d,this.items=s}static asApiEvents(g){return g.map(t=>({start:t.start,deletedCount:t.deletedCount,deletedItems:t.deletedItems,items:t.items.map(d=>d.apiCell)}))}}class y{constructor(g,t,d){this.notebook=g,this._extHostDocument=t,this._cellData=d,this.handle=d.handle,this.uri=_.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=d.internalMetadata??{},this._metadata=Object.freeze(d.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(d.internalMetadata??{}))}static asModelAddData(g,t){return{EOL:t.eol,lines:t.source,languageId:t.language,uri:t.uri,isDirty:!1,versionId:1,notebook:g}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const g=this,t=this._extHostDocument.getDocument(this.uri);if(!t)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return g.notebook.getCellIndex(g)},notebook:g.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:t.document,get mime(){return g._mime},set mime(d){g._mime=d},get outputs(){return g._outputs.slice(0)},get metadata(){return g._metadata},get executionSummary(){return g._previousResult}})}return this._apiCell}setOutputs(g){this._outputs=g.map(C.NotebookCellOutput.to)}setOutputItems(g,t,d){const s=d.map(C.NotebookCellOutputItem.to),a=this._outputs.find(l=>l.id===g);a&&(t||(a.items.length=0),a.items.push(...s))}setMetadata(g){this._metadata=Object.freeze(g)}setInternalMetadata(g){this._internalMetadata=g,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(g))}setMime(g){}}e.ExtHostCell=y;class L{constructor(g,t,d,s,a,l){this._proxy=g,this._textDocumentsAndEditors=t,this._textDocuments=d,this._emitter=s,this.uri=a,this.handle=L._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=l.viewType,this._metadata=Object.freeze(l.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,l.cells]],!0),this._versionId=l.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const g=this;this._notebook={get uri(){return g.uri},get version(){return g._versionId},get notebookType(){return g._notebookType},get isDirty(){return g._isDirty},get isUntitled(){return g.uri.scheme===n.Schemas.untitled},get isClosed(){return g._disposed},get metadata(){return g._metadata},get cellCount(){return g._cells.length},cellAt(t){return t=g._validateIndex(t),g._cells[t].apiCell},getCells(t){return(t?g._getCells(t):g._cells).map(s=>s.apiCell)},save(){return g._save()}}}return this._notebook}updateBackup(g){this._backup?.delete(),this._backup=g}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(g){g.metadata&&(this._metadata=Object.freeze({...this._metadata,...g.metadata}))}acceptDirty(g){this._isDirty=g}acceptModelChanged(g,t){this._versionId=g.versionId,this._isDirty=t;for(const d of g.rawEvents)d.kind===x.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===x.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===x.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===x.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===x.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===x.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===x.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===x.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(g){return g=g|0,g<0?0:g>=this._cells.length?this._cells.length-1:g}_validateRange(g){let t=g.start|0,d=g.end|0;return t<0&&(t=0),d>this._cells.length&&(d=this._cells.length),g.with({start:t,end:d})}_getCells(g){g=this._validateRange(g);const t=[];for(let d=g.start;d<g.end;d++)t.push(this._cells[d]);return t}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(g,t){if(this._disposed)return;const d=[],s=[],a=[];g.reverse().forEach(l=>{const v=l[2].map(S=>{const i=new y(this,this._textDocumentsAndEditors,S);return t||s.push(y.asModelAddData(this.apiNotebook,S)),i}),E=new F(l[0],l[1],[],v),r=this._cells.splice(l[0],l[1],...v);for(const S of r)a.push(S.uri),E.deletedItems.push(S.apiCell);d.push(E)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:a}),t||this._emitter.emitModelChange((0,O.deepFreeze)({document:this.apiNotebook,changes:F.asApiEvents(d)}))}_moveCell(g,t){const d=this._cells.splice(g,1);this._cells.splice(t,0,...d);const s=[new F(g,1,d.map(a=>a.apiCell),[]),new F(t,0,[],d)];this._emitter.emitModelChange((0,O.deepFreeze)({document:this.apiNotebook,changes:F.asApiEvents(s)}))}_setCellOutputs(g,t){const d=this._cells[g];d.setOutputs(t),this._emitter.emitCellOutputsChange((0,O.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(g,t,d,s){const a=this._cells[g];a.setOutputItems(t,d,s),this._emitter.emitCellOutputsChange((0,O.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_changeCellLanguage(g,t){const d=this._cells[g];d.apiCell.document.languageId!==t&&this._textDocuments.$acceptModelLanguageChanged(d.uri,t)}_changeCellMime(g,t){const d=this._cells[g];d.apiCell.mime=t}_changeCellMetadata(g,t){const d=this._cells[g],s=d.apiCell.metadata;d.setMetadata(t);const a=d.apiCell.metadata;(0,O.equals)(s,a)||this._emitter.emitCellMetadataChange((0,O.deepFreeze)({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(g,t){this._cells[g].setInternalMetadata(t)}getCellFromApiCell(g){return this._cells.find(t=>t.apiCell===g)}getCellFromIndex(g){return this._cells[g]}getCell(g){return this._cells.find(t=>t.handle===g)}getCellIndex(g){return this._cells.indexOf(g)}}e.ExtHostNotebookDocument=L,L._handlePool=0}),define(me[87],ge([1,0,6,8,15]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,L){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:L})}replaceCells(y,L,N){this._throwIfFinalized(),!(y===L&&N.length===0)&&this._collectedEdits.push({editType:1,index:y,count:L-y,cells:N.map(O.NotebookCellData.from)})}}class x{constructor(y,L,N,g,t,d){this.id=y,this._proxy=L,this.notebookData=N,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=t,this._visibleRanges=g,this._viewColumn=d}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(L){if(!Array.isArray(L)||!L.every(n.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");y._selections=L,y._trySetSelections(L)},get visibleRanges(){return y._visibleRanges},revealRange(L,N){y._proxy.$tryRevealRange(y.id,O.NotebookRange.from(L),N??n.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(L){const N=new C(this.document.version);return L(N),y._applyEdit(N.finalize())},setDecorations(L,N){return y.setDecorations(L,N)}},x.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(O.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const L=[];let N=-1;for(let g=0;g<y.cellEdits.length;g++){if(N<0){L.push(y.cellEdits[g]),N++;continue}const d=L[N],s=y.cellEdits[g];if(d.editType===1&&s.editType===1&&d.index===s.index){d.cells.push(...y.cellEdits[g].cells),d.count+=y.cellEdits[g].count;continue}L.push(y.cellEdits[g]),N++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,L)}setDecorations(y,L){if(!(L.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return L.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,O.NotebookRange.from(L),y.key)}}e.ExtHostNotebookEditor=x,x.apiEditorsToExtHost=new WeakMap}),define(me[166],ge([1,0,8,137,120,20,50,15]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(t){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=t}async withProgress(t,d,s){const a=this._handles++,{title:l,location:P,cancellable:v}=d,E={label:(0,_.localize)(0,null,t.displayName||t.name),id:t.identifier.value};return this._proxy.$startProgress(a,{location:n.ProgressLocation.from(P),title:l,source:E,cancellable:v},t.isUnderDevelopment?void 0:t.identifier.value).catch(F.onUnexpectedExternalError),this._withProgress(a,s,!!v)}_withProgress(t,d,s){let a;s&&(a=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(t,a));const l=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a&&a.dispose()};let P;try{P=d(new N(this._proxy,t),s&&a?a.token:C.CancellationToken.None)}catch(v){throw l(t),v}return P.then(v=>l(t),v=>l(t)),P}$acceptProgressCanceled(t){const d=this._mapHandleToCancellationSource.get(t);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(t))}}e.ExtHostProgress=y;function L(g,t){return g.message=t.message,typeof t.increment=="number"&&(typeof g.increment=="number"?g.increment+=t.increment:g.increment=t.increment),g}class N extends O.Progress{constructor(t,d){super(s=>this.throttledReport(s));this._proxy=t,this._handle=d}throttledReport(t){this._proxy.$progressReport(this._handle,t)}}Te([(0,x.throttle)(100,(g,t)=>L(g,t),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(me[88],ge([1,0,41,15,51,8,6]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class F{constructor(t,d,s){const a=F._Keys.nextId();t.$registerTextEditorDecorationType(d.identifier,a,C.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:a,dispose(){t.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=F,F._Keys=new _.IdGenerator("TextEditorDecorationType");class y{constructor(t,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=t,this._documentVersionId=t.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(t,d){this._throwIfFinalized();let s=null;if(t instanceof x.Position)s=new x.Range(t,t);else if(t instanceof x.Range)s=t;else throw new Error("Unrecognized location");this._pushEdit(s,d,!1)}insert(t,d){this._throwIfFinalized(),this._pushEdit(new x.Range(t,t),d,!0)}delete(t){this._throwIfFinalized();let d=null;if(t instanceof x.Range)d=t;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(t,d,s){const a=this._document.validateRange(t);this._collectedEdits.push({range:a,text:d,forceMoveMarkers:s})}setEndOfLine(t){if(this._throwIfFinalized(),t!==x.EndOfLine.LF&&t!==x.EndOfLine.CRLF)throw(0,O.illegalArgument)("endOfLine");this._setEndOfLine=t}}e.TextEditorEdit=y;class L{constructor(t,d,s,a){this._proxy=t,this._id=d,this._accept(s),this._logService=a;const l=this;this.value={get tabSize(){return l._tabSize},set tabSize(P){l._setTabSize(P)},get insertSpaces(){return l._insertSpaces},set insertSpaces(P){l._setInsertSpaces(P)},get cursorStyle(){return l._cursorStyle},set cursorStyle(P){l._setCursorStyle(P)},get lineNumbers(){return l._lineNumbers},set lineNumbers(P){l._setLineNumbers(P)}}}_accept(t){this._tabSize=t.tabSize,this._insertSpaces=t.insertSpaces,this._cursorStyle=t.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(t.lineNumbers)}_validateTabSize(t){if(t==="auto")return"auto";if(typeof t=="number"){const d=Math.floor(t);return d>0?d:null}if(typeof t=="string"){const d=parseInt(t,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(t){const d=this._validateTabSize(t);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(t){return t==="auto"?"auto":t==="false"?!1:Boolean(t)}_setInsertSpaces(t){const d=this._validateInsertSpaces(t);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(t){this._cursorStyle!==t&&(this._cursorStyle=t,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:t})))}_setLineNumbers(t){this._lineNumbers!==t&&(this._lineNumbers=t,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(t)})))}assign(t){const d={};let s=!1;if(typeof t.tabSize!="undefined"){const a=this._validateTabSize(t.tabSize);a==="auto"?(s=!0,d.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,s=!0,d.tabSize=a)}if(typeof t.insertSpaces!="undefined"){const a=this._validateInsertSpaces(t.insertSpaces);a==="auto"?(s=!0,d.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,s=!0,d.insertSpaces=a)}typeof t.cursorStyle!="undefined"&&this._cursorStyle!==t.cursorStyle&&(this._cursorStyle=t.cursorStyle,s=!0,d.cursorStyle=t.cursorStyle),typeof t.lineNumbers!="undefined"&&this._lineNumbers!==t.lineNumbers&&(this._lineNumbers=t.lineNumbers,s=!0,d.lineNumbers=C.TextEditorLineNumbersStyle.from(t.lineNumbers)),s&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,d))}_warnOnError(t,d){d.catch(s=>{this._logService.warn(`ExtHostTextEditorOptions '${t}' failed:'`),this._logService.warn(s)})}}e.ExtHostTextEditorOptions=L;class N{constructor(t,d,s,a,l,P,v,E){this.id=t,this._proxy=d,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._options=new L(this._proxy,this.id,P,s),this._visibleRanges=v,this._viewColumn=E;const r=this;this.value=Object.freeze({get document(){return a.getValue()},set document(S){throw(0,O.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(S){if(!(S instanceof x.Selection))throw(0,O.illegalArgument)("selection");r._selections=[S],r._trySetSelection()},get selections(){return r._selections},set selections(S){if(!Array.isArray(S)||S.some(i=>!(i instanceof x.Selection)))throw(0,O.illegalArgument)("selections");r._selections=S,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(S){throw(0,O.readonly)("visibleRanges")},get options(){return r._options.value},set options(S){r._disposed||r._options.assign(S)},get viewColumn(){return r._viewColumn},set viewColumn(S){throw(0,O.readonly)("viewColumn")},edit(S,i={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const T=new y(a.getValue(),i);return S(T),r._applyEdit(T)},insertSnippet(S,i,T={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!i||Array.isArray(i)&&i.length===0)o=r._selections.map(c=>C.Range.from(c));else if(i instanceof x.Position){const{lineNumber:c,column:w}=C.Position.from(i);o=[{startLineNumber:c,startColumn:w,endLineNumber:c,endColumn:w}]}else if(i instanceof x.Range)o=[C.Range.from(i)];else{o=[];for(const c of i)if(c instanceof x.Range)o.push(C.Range.from(c));else{const{lineNumber:w,column:f}=C.Position.from(c);o.push({startLineNumber:w,startColumn:f,endLineNumber:w,endColumn:f})}}return d.$tryInsertSnippet(t,S.value,o,T)},setDecorations(S,i){const T=i.length===0;T&&!r._hasDecorationsForKey.has(S.key)||(T?r._hasDecorationsForKey.delete(S.key):r._hasDecorationsForKey.add(S.key),r._runOnProxy(()=>{if(C.isDecorationOptionsArr(i))return d.$trySetDecorations(t,S.key,C.fromRangeOrRangeWithMessage(i));{const o=new Array(4*i.length);for(let c=0,w=i.length;c<w;c++){const f=i[c];o[4*c]=f.start.line+1,o[4*c+1]=f.start.character+1,o[4*c+2]=f.end.line+1,o[4*c+3]=f.end.character+1}return d.$trySetDecorationsFast(t,S.key,o)}}))},revealRange(S,i){r._runOnProxy(()=>d.$tryRevealRange(t,C.Range.from(S),i||x.TextEditorRevealType.Default))},show(S){d.$tryShowEditor(t,C.ViewColumn.from(S))},hide(){d.$tryHideEditor(t)}})}dispose(){(0,n.ok)(!this._disposed),this._disposed=!0}_acceptOptions(t){(0,n.ok)(!this._disposed),this._options._accept(t)}_acceptVisibleRanges(t){(0,n.ok)(!this._disposed),this._visibleRanges=t}_acceptViewColumn(t){(0,n.ok)(!this._disposed),this._viewColumn=t}_acceptSelections(t){(0,n.ok)(!this._disposed),this._selections=t}async _trySetSelection(){const t=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,t)),this.value}_applyEdit(t){const d=t.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const s=d.edits.map(l=>l.range);s.sort((l,P)=>l.end.line===P.end.line?l.end.character===P.end.character?l.start.line===P.start.line?l.start.character-P.start.character:l.start.line-P.start.line:l.end.character-P.end.character:l.end.line-P.end.line);for(let l=0,P=s.length-1;l<P;l++){const v=s[l].end;if(s[l+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=d.edits.map(l=>({range:C.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,a,{setEndOfLine:typeof d.setEndOfLine=="number"?C.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(t){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):t().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=N}),define(me[167],ge([1,0,10,5,7,13,46,8,82,60]),function(Z,e,n,O,_,C,x,F,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class N extends _.Disposable{constructor(t){super();this.controllerId=t,this.debounceSendDiff=this._register(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new O.Emitter),this.root=new x.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(t){this._resolveHandler=t;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const t=this.diff;return this.diff=[],t}pushDiff(t){const d=this.diff[this.diff.length-1];if(d&&t[0]===1){if(d[0]===1&&d[1].extId===t[1].extId){(0,y.applyTestItemUpdate)(d[1],t[1]);return}if(d[0]===0&&d[1].item.extId===t[1].extId){(0,y.applyTestItemUpdate)(d[1],t[1]);return}}this.diff.push(t),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(t,d){const s=this.tree.get(t);if(!!s){if((s.expandLevels===void 0||d>s.expandLevels)&&(s.expandLevels=d),s.expand===1){const a=this.resolveChildren(s);return a.isOpen()?this.expandChildren(s,d-1):a.wait().then(()=>this.expandChildren(s,d-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.expandChildren(s,d-1)):this.expandChildren(s,d-1)}}dispose(){for(const t of this.tree.values())(0,x.getPrivateApiFor)(t.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(t,d){switch(d.op){case 2:this.pushDiff([4,t.fullId.toString()]);break;case 1:this.removeItem(L.TestId.joinToString(t.fullId,d.id));break;case 0:this.upsertItem(d.item,t);break;case 4:for(const s of d.ops)this.onTestItemEvent(t,s);break;case 3:{const{key:s,value:a,previous:l}=d,P=t.fullId.toString();switch(s){case"canResolveChildren":this.updateExpandability(t);break;case"tags":this.diffTagRefs(a,l,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:F.Range.from(a)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:F.MarkdownString.fromStrict(a)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[s]:a??null}}]);break}break}default:(0,C.assertNever)(d)}}upsertItem(t,d){if(!(t instanceof x.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${t.id} did not`);const s=L.TestId.fromExtHostTestItem(t,this.root.id,d?.actual),a=(0,x.getPrivateApiFor)(t);a.parent&&a.parent!==d?.actual&&a.parent.children.delete(t.id);let l=this.tree.get(s.toString());if(!l){l={fullId:s,actual:t,parent:d?s.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},t.tags.forEach(this.incrementTagRefs,this),this.tree.set(l.fullId.toString(),l),this.setItemParent(t,d),this.pushDiff([0,{parent:l.parent&&l.parent.toString(),controllerId:this.controllerId,expand:l.expand,item:F.TestItem.from(t)}]),this.connectItemAndChildren(t,l,d);return}if(l.actual===t){this.connectItem(t,l,d);return}const P=l.actual.children,v=l.actual,E=(0,x.diffTestItems)(v,t);(0,x.getPrivateApiFor)(v).listener=void 0,l.actual=t,l.expand=0;for(const[r,S]of E)this.onTestItemEvent(l,{op:3,key:r,value:S,previous:v[r]});this.connectItemAndChildren(t,l,d);for(const r of P)t.children.get(r.id)||this.removeItem(L.TestId.joinToString(s,r.id))}diffTagRefs(t,d,s){const a=new Set(d.map(l=>l.id));for(const l of t)a.delete(l.id)||this.incrementTagRefs(l);this.pushDiff([1,{extId:s,item:{tags:t.map(l=>F.TestTag.namespace(this.controllerId,l.id))}}]),a.forEach(this.decrementTagRefs,this)}incrementTagRefs(t){const d=this.tags.get(t.id);d?d.refCount++:(this.tags.set(t.id,{refCount:1}),this.pushDiff([5,{id:F.TestTag.namespace(this.controllerId,t.id),ctrlLabel:this.root.label}]))}decrementTagRefs(t){const d=this.tags.get(t);d&&!--d.refCount&&(this.tags.delete(t),this.pushDiff([6,F.TestTag.namespace(this.controllerId,t)]))}setItemParent(t,d){(0,x.getPrivateApiFor)(t).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(t,d,s){this.setItemParent(t,s);const a=(0,x.getPrivateApiFor)(t);a.parent=s?.actual,a.listener=l=>this.onTestItemEvent(d,l),this.updateExpandability(d)}connectItemAndChildren(t,d,s){this.connectItem(t,d,s);for(const a of t.children)this.upsertItem(a,d)}updateExpandability(t){let d;this._resolveHandler?t.resolveBarrier?d=t.resolveBarrier.isOpen()?3:2:d=t.actual.canResolveChildren?1:0:d=0,d!==t.expand&&(t.expand=d,this.pushDiff([1,{extId:t.fullId.toString(),expand:d}]),d===1&&t.expandLevels!==void 0&&this.resolveChildren(t))}expandChildren(t,d){if(d<0)return;const s=[];for(const a of t.actual.children){const l=this.expand(L.TestId.joinToString(t.fullId,a.id),d);(0,n.isThenable)(l)&&s.push(l)}if(s.length)return Promise.all(s).then(()=>{})}resolveChildren(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this._resolveHandler){const l=new n.Barrier;return l.open(),l}t.expand=2,this.pushExpandStateUpdate(t);const d=t.resolveBarrier=new n.Barrier,s=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),t.actual!==this.root&&(t.actual.error=l.stack||l.message||String(l))};let a;try{a=this._resolveHandler(t.actual===this.root?void 0:t.actual)}catch(l){s(l)}return(0,n.isThenable)(a)?a.catch(s).then(()=>{d.open(),this.updateExpandability(t)}):(d.open(),this.updateExpandability(t)),t.resolveBarrier}pushExpandStateUpdate(t){this.pushDiff([1,{extId:t.fullId.toString(),expand:t.expand}])}removeItem(t){const d=this.tree.get(t);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,t]);const s=[d];for(;s.length;){const a=s.pop();if(!!a){(0,x.getPrivateApiFor)(a.actual).listener=void 0;for(const l of a.actual.tags)this.decrementTagRefs(l.id);this.tree.delete(a.fullId.toString());for(const l of a.actual.children)s.push(this.tree.get(L.TestId.joinToString(a.fullId,l.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.diffOpEmitter.fire(t)}}e.SingleUseTestCollection=N}),define(me[168],ge([1,0,3,133]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(O.IEnvironmentService)}),define(me[169],ge([1,0,23,5,19]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(N){this.removedDueToLooping=N}}e.DeltaExtensionsResult=C;class x{constructor(N){this._onDidChange=new O.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=N,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const N of this._extensionDescriptions){if(this._extensionsMap.has(n.ExtensionIdentifier.toKey(N.identifier))){console.error("Extension `"+N.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(n.ExtensionIdentifier.toKey(N.identifier),N),this._extensionsArr.push(N),Array.isArray(N.activationEvents))for(let g of N.activationEvents)g==="onUri"&&(g=`onUri:${n.ExtensionIdentifier.toKey(N.identifier)}`),this._activationMap.has(g)||this._activationMap.set(g,[]),this._activationMap.get(g).push(N)}}keepOnly(N){const g=new Set;N.forEach(t=>g.add(n.ExtensionIdentifier.toKey(t))),this._extensionDescriptions=this._extensionDescriptions.filter(t=>g.has(n.ExtensionIdentifier.toKey(t.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(N,g){N.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(N));const t=x._findLoopingExtensions(this._extensionDescriptions);if(g=g.concat(t.map(d=>d.identifier)),g.length>0){const d=new Set;g.forEach(s=>d.add(n.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!d.has(n.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(t)}static _findLoopingExtensions(N){const g=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(l){this._nodesSet.has(l)||(this._nodesSet.add(l),this._nodesArr.push(l))}addArc(l,P){this.addNode(l),this.addNode(P),this._arcs.has(l)?this._arcs.get(l).push(P):this._arcs.set(l,[P])}getArcs(l){return this._arcs.has(l)?this._arcs.get(l):[]}hasOnlyGoodArcs(l,P){const v=g.getArcs(l);for(let E=0;E<v.length;E++)if(!P.has(v[E]))return!1;return!0}getNodes(){return this._nodesArr}};let t=new Map;for(let l of N){const P=n.ExtensionIdentifier.toKey(l.identifier);if(t.set(P,l),l.extensionDependencies)for(let v of l.extensionDependencies){const E=n.ExtensionIdentifier.toKey(v);g.addArc(P,E)}}let d=new Set;g.getNodes().filter(l=>g.getArcs(l).length===0).forEach(l=>d.add(l));let s=g.getNodes().filter(l=>!d.has(l)),a;do{a=!1;for(let l=0;l<s.length;l++){const P=s[l];g.hasOnlyGoodArcs(P,d)&&(s.splice(l,1),l--,d.add(P),a=!0)}}while(a);return s.map(l=>t.get(l))}containsActivationEvent(N){return this._activationMap.has(N)}containsExtension(N){return this._extensionsMap.has(n.ExtensionIdentifier.toKey(N))}getExtensionDescriptionsForActivationEvent(N){const g=this._activationMap.get(N);return g?g.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(N){const g=this._extensionsMap.get(n.ExtensionIdentifier.toKey(N));return g||void 0}}e.ExtensionDescriptionRegistry=x;var F;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(F||(F={}));function y(L,N){const g=L.isBuiltin?0:L.isUnderDevelopment?2:1,t=N.isBuiltin?0:N.isUnderDevelopment?2:1;if(g!==t)return g-t;const d=_.posix.basename(L.extensionLocation.path),s=_.posix.basename(N.extensionLocation.path);return d<s?-1:d>s?1:0}}),define(me[170],ge([1,0,21]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var O;(function(F){F[F.VersionMismatch=55]="VersionMismatch",F[F.UnexpectedError=81]="UnexpectedError"})(O=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(F){F[F.Initialized=0]="Initialized",F[F.Ready=1]="Ready",F[F.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function C(F){const y=n.VSBuffer.alloc(1);switch(F){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=C;function x(F,y){if(F.byteLength!==1)return!1;switch(F.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=x}),define(me[26],ge([1,0,5,2,3,23,140]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var F;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(F=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class L{constructor(S){this.dependency=S}}e.MissingExtensionDependency=L;var N;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(N=e.ExtensionHostKind||(e.ExtensionHostKind={}));function g(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=g;function t(r,S){return r.enabledApiProposals?r.enabledApiProposals.includes(S):!1}e.isProposedApiEnabled=t;function d(r,S){if(!t(r,S))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${S}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${S}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=d;class s{constructor(S,i,T,o){this.codeLoadingTime=S,this.activateCallTime=i,this.activateResolvedTime=T,this.activationReason=o}}e.ActivationTimes=s;class a{constructor(S,i){this.description=S,this.value=i}}e.ExtensionPointContribution=a,e.ExtensionHostLogFileName="exthost";var l;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(l=e.ActivationKind||(e.ActivationKind={}));function P(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,x.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=P;function v(r,S){return{identifier:new C.ExtensionIdentifier((0,x.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!S,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=v;class E{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,i){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,i,T,o,c){}_onDidActivateExtensionError(S,i){}_onExtensionRuntimeError(S,i){}_onExtensionHostExit(S){}}e.NullExtensionService=E}),define(me[171],ge([1,0,15,23,26,9]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const x=Promise.resolve(void 0);class F{constructor(a,l,P,v){this.startup=a,this.codeLoadingTime=l,this.activateCallTime=P,this.activateResolvedTime=v}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class y{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,l){return a===-1||l===-1?-1:l-a}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class L{constructor(a,l,P,v,E,r){this.activationFailed=a,this.activationFailedError=l,this.activationTimes=P,this.module=v,this.exports=E,this.subscriptions=r}}e.ActivatedExtension=L;class N extends L{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=N;class g extends L{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=g;class t extends L{constructor(a){super(!0,a,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=t;let d=class{constructor(a,l,P,v,E){this._logService=E,this._isDisposed=!1,this._registry=a,this._resolvedExtensionsSet=new Set,l.forEach(r=>this._resolvedExtensionsSet.add(O.ExtensionIdentifier.toKey(r))),this._hostExtensionsMap=new Map,P.forEach(r=>this._hostExtensionsMap.set(O.ExtensionIdentifier.toKey(r),r)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(a){const l=O.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(l)}getActivatedExtension(a){const l=O.ExtensionIdentifier.toKey(a),P=this._activatedExtensions.get(l);if(!P)throw new Error("Extension `"+a.value+"` is not known or not activated");return P}activateByEvent(a,l){if(this._alreadyActivatedEvents[a])return x;const P=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(P.map(v=>({id:v.identifier,reason:{startup:l,extensionId:v.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,l){const P=this._registry.getExtensionDescription(a);if(!P)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:P.identifier,reason:l}])}_handleActivateRequest(a,l,P){if(this._hostExtensionsMap.has(O.ExtensionIdentifier.toKey(a.id))){l[O.ExtensionIdentifier.toKey(a.id)]=a;return}const v=this._registry.getExtensionDescription(a.id);if(!v){const S=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,S,new _.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(O.ExtensionIdentifier.toKey(a.id),new t(S));return}const E=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let r=!0;for(let S=0,i=E.length;S<i;S++){const T=E[S];if(this._resolvedExtensionsSet.has(O.ExtensionIdentifier.toKey(T)))continue;const o=this._activatedExtensions.get(O.ExtensionIdentifier.toKey(T));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const h=v.displayName||v.identifier.value,p=this._registry.getExtensionDescription(T),m=p&&p.displayName||T,b=new Error(`Cannot activate the '${h}' extension because its dependency '${m}' failed to activate`);b.detail=o.activationFailedError,this._host.onExtensionActivationError(v.identifier,b,null),this._activatedExtensions.set(O.ExtensionIdentifier.toKey(v.identifier),new t(b));return}if(this._hostExtensionsMap.has(O.ExtensionIdentifier.toKey(T))){r=!1,l[O.ExtensionIdentifier.toKey(T)]={id:this._hostExtensionsMap.get(O.ExtensionIdentifier.toKey(T)),reason:a.reason};continue}const c=this._registry.getExtensionDescription(T);if(c){if(!c.main&&!c.browser)continue;r=!1,l[O.ExtensionIdentifier.toKey(T)]={id:c.identifier,reason:a.reason};continue}const w=v.displayName||v.identifier.value,f=new Error(`Cannot activate the '${w}' extension because it depends on unknown extension '${T}'`);this._host.onExtensionActivationError(v.identifier,f,new _.MissingExtensionDependency(T)),this._activatedExtensions.set(O.ExtensionIdentifier.toKey(v.identifier),new t(f));return}r?l[O.ExtensionIdentifier.toKey(v.identifier)]=a:P.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(E=>!this._activatedExtensions.has(O.ExtensionIdentifier.toKey(E.id))),a.length===0))return Promise.resolve(void 0);const l=Object.create(null),P=[];for(let E=0,r=a.length;E<r;E++)this._handleActivateRequest(a[E],l,P);for(let E=0,r=P.length;E<r;E++){const S=O.ExtensionIdentifier.toKey(P[E].id);l[S]&&delete l[S]}const v=Object.keys(l).map(E=>l[E]);return P.length===0?Promise.all(v.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(v).then(E=>this._activateExtensions(P))}_activateExtension(a,l){const P=O.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(P))return Promise.resolve(void 0);const v=this._activatingExtensions.get(P);if(v)return v;const E=this._host.actualActivateExtension(a,l).then(void 0,r=>{const S=new Error;return r&&r.name&&(S.name=r.name),r&&r.message?S.message=`Activating extension '${a.value}' failed: ${r.message}.`:S.message=`Activating extension '${a.value}' failed: ${r}.`,r&&r.stack&&(S.stack=r.stack),this._isDisposed&&n.isCancellationError(r)?new t(r):(this._host.onExtensionActivationError(a,S,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(r),new t(r))}).then(r=>{this._activatedExtensions.set(P,r),this._activatingExtensions.delete(P)});return this._activatingExtensions.set(P,E),E}};d=Te([Re(4,C.ILogService)],d),e.ExtensionsActivator=d}),define(me[172],ge([1,0,9,27,26]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends n.LogService{constructor(F,y){super(F.createLogger(y.logFile,{name:_.ExtensionHostLogFileName}))}};C=Te([Re(0,n.ILoggerService),Re(1,O.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(me[173],ge([1,0,15]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class O{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,x)=>{this._actualOk=C,this._actualErr=x,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,n.onUnexpectedError)(C))}then(C,x){return this._ensureActual().then(C,x)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=O}),define(me[37],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++n.count}}e.ProxyIdentifier=n,n.count=0;const O=[];function _(F){const y=new n(F);return O[y.nid]=y,y}e.createProxyIdentifier=_;function C(F){return O[F].sid}e.getStringIdentifierForProxy=C;class x{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=x}),define(me[4],ge([1,0,52,2,37]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var x;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(x=e.TextEditorRevealType||(e.TextEditorRevealType={}));var F;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(F=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var L;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(L=e.CellOutputKind||(e.CellOutputKind={}));var N;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(N=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var g;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(g=e.CandidatePortSource||(e.CandidatePortSource={}));class t{static mixin(E){return E._id=t._n++,E}}e.IdObject=t,t._n=0;var d;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.command="m",v.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var s;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(s=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var a;(function(v){v[v.File=1]="File",v[v.Text=2]="Text",v[v.Cell=3]="Cell"})(a=e.WorkspaceEditType||(e.WorkspaceEditType={}));function l(v){if(v&&v.edits)for(const E of v.edits)typeof E.resource=="object"?E.resource=O.URI.revive(E.resource):(E.newUri=O.URI.revive(E.newUri),E.oldUri=O.URI.revive(E.oldUri)),E.metadata&&E.metadata.iconPath&&(E.metadata=(0,n.revive)(E.metadata));return v}e.reviveWorkspaceEditDto=l;var P;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,_.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,_.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,_.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,_.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createProxyIdentifier)("ExtHostTelemetry")}}),define(me[61],ge([1,0,4,5,3]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(F){this._onDidChangePassword=new O.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=F.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(F){this._onDidChangePassword.fire(F)}get(F,y){return this._proxy.$getPassword(F,y)}store(F,y,L){return this._proxy.$setPassword(F,y,L)}delete(F,y){return this._proxy.$deletePassword(F,y)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(me[62],ge([1,0,3,9,4,12]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let x=class{constructor(y,L){this._extHostLogService=L,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(_.MainContext.MainThreadTelemetry)}report(y,L,N){const g=this.getUsageKey(y,L);this._reportedUsages.has(g)||(this._reportedUsages.add(g),L.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${N}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:L.identifier.value,apiId:y}))}getUsageKey(y,L){return`${y}-${L.identifier.value}`}};x=Te([Re(0,C.IExtHostRpcService),Re(1,O.ILogService)],x),e.ExtHostApiDeprecationService=x,e.NullApiDeprecationService=Object.freeze(new class{report(F,y,L){}})}),define(me[174],ge([1,0,5,4,6,23]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class x{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new n.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(O.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,L,N,g={}){const t=C.ExtensionIdentifier.toKey(y.identifier),d=this._inFlightRequests.get(t)||[],s=[...N].sort().join(" ");let a=d.find(l=>l.scopes===s);if(a)return a.result;{const l=this._getSession(y,t,L,N,g);a={scopes:s,result:l},d.push(a),this._inFlightRequests.set(t,d);try{await l}finally{const P=d.findIndex(v=>v.scopes===s);P>-1&&(d.splice(P),this._inFlightRequests.set(t,d))}return l}}async _getSession(y,L,N,g,t={}){await this._proxy.$ensureProvider(N);const d=y.displayName||y.name;return this._proxy.$getSession(N,g,L,d,t)}async removeSession(y,L){const N=this._authenticationProviders.get(y);return N?N.provider.removeSession(L):this._proxy.$removeSession(y,L)}registerAuthenticationProvider(y,L,N,g){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:L,provider:N,options:g??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===y)||this._providers.push({id:y,label:L});const t=N.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(y,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,L,g?.supportsMultipleAccounts??!1),new _.Disposable(()=>{t.dispose(),this._authenticationProviders.delete(y);const d=this._providers.findIndex(s=>s.id===y);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,L){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.createSession(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,L){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,L){const N=this._authenticationProviders.get(y);if(N)return Promise.resolve(N.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,L){return this._onDidChangeSessions.fire({provider:{id:y,label:L}}),Promise.resolve()}}e.ExtHostAuthentication=x}),define(me[175],ge([1,0,4,12,8]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(F,y){this._extHostDocumentsAndEditors=y,this._proxy=F.getProxy(n.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(F){const y=_.WorkspaceEdit.from(F,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};C=Te([Re(0,O.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(me[176],ge([1,0,4]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class O{constructor(C){const x=C.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return x.$readText()},writeText(F){return x.$writeText(F)}})}}e.ExtHostClipboard=O});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[38],ge([1,0,13,6,8,25,4,16,9,52,85,226,2,7,3,12,46,21,37,42]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(f,h){r.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,ze(this,r,f.getProxy(x.MainContext.MainThreadCommands),"f"),this._logService=h,this.converter=new i(this,p=>{const m=this._apiCommands.get(p);return m?.result===o.Void?m:void 0},h),this._argumentProcessors=[{processArgument(p){return(0,L.revive)(p)}},{processArgument(p){return(0,C.cloneAndChange)(p,function(m){if(N.Range.isIRange(m))return _.Range.to(m);if(g.Position.isIPosition(m))return _.Position.to(m);if(N.Range.isIRange(m.range)&&t.URI.isUri(m.uri))return _.location.to(m);if(m instanceof P.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(f){this._argumentProcessors.push(f)}registerApiCommand(f){const h=this.registerCommand(!1,f.id,async(...p)=>{const m=f.args.map((I,k)=>{if(!I.validate(p[k]))throw new Error(`Invalid argument '${I.name}' when running '${f.id}', received: ${p[k]}`);return I.convert(p[k])}),b=await this.executeCommand(f.internalId,...m);return f.result.convert(b,p,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this._apiCommands.set(f.id,f),new O.Disposable(()=>{h.dispose(),this._apiCommands.delete(f.id)})}registerCommand(f,h,p,m,b,I){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:p,thisArg:m,description:b,extension:I}),f&&we(this,r,"f").$registerCommand(h),new O.Disposable(()=>{this._commands.delete(h)&&f&&we(this,r,"f").$unregisterCommand(h)})}executeCommand(f,...h){return this._logService.trace("ExtHostCommands#executeCommand",f),this._doExecuteCommand(f,h,!0)}async _doExecuteCommand(f,h,p){if(this._commands.has(f))return this._executeContributedCommand(f,h,!1);{let m=!1;const b=(0,C.cloneAndChange)(h,function(I){if(I instanceof O.Position)return _.Position.from(I);if(I instanceof O.Range)return _.Range.from(I);if(I instanceof O.Location)return _.location.from(I);if(O.NotebookRange.isNotebookRange(I))return _.NotebookRange.from(I);if(I instanceof ArrayBuffer)return m=!0,P.VSBuffer.wrap(new Uint8Array(I));if(I instanceof Uint8Array)return m=!0,P.VSBuffer.wrap(I);if(!Array.isArray(I))return I});try{const I=await we(this,r,"f").$executeCommand(f,m?new v.SerializableObjectWithBuffers(b):b,p);return(0,L.revive)(I)}catch(I){if(I instanceof Error&&I.message==="$executeCommand:retry")return this._doExecuteCommand(f,h,!1);throw I}}}async _executeContributedCommand(f,h,p){const m=this._commands.get(f);if(!m)throw new Error("Unknown command");let{callback:b,thisArg:I,description:k}=m;if(k)for(let $=0;$<k.args.length;$++)try{(0,n.validateConstraint)(h[$],k.args[$].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${k.args[$].name}' - ${k.args[$].description}`)}try{return await b.apply(I,h)}catch($){if(f===this.converter.delegatingCommandId){const u=this.converter.getActualCommand(...h);u&&(f=u.command)}throw this._logService.error($,f,m.extension?.identifier),p?new class extends Error{constructor(){super((0,E.toErrorMessage)($));this.id=f,this.source=m.extension?.displayName??m.extension?.name}}:$}}$executeContributedCommand(f,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",f),this._commands.has(f)?(h=h.map(p=>this._argumentProcessors.reduce((m,b)=>b.processArgument(m),p)),this._executeContributedCommand(f,h,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this._logService.trace("ExtHostCommands#getCommands",f),we(this,r,"f").$getCommands().then(h=>(f&&(h=h.filter(p=>p[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(let[h,p]of this._commands){let{description:m}=p;m&&(f[h]=m)}return Promise.resolve(f)}};r=new WeakMap,S=Te([Re(0,a.IExtHostRpcService),Re(1,y.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class i{constructor(f,h,p){this._commands=f,this._lookupApiCommand=h,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(f,h){if(!f)return;const p={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return p;const m=this._lookupApiCommand(f.command);if(m)p.id=m.internalId,p.arguments=m.args.map((b,I)=>b.convert(f.arguments&&f.arguments[I]));else if((0,F.isNonEmptyArray)(f.arguments)){const b=++this._cachIdPool;this._cache.set(b,f),h.add((0,d.toDisposable)(()=>{this._cache.delete(b),this._logService.trace("CommandsConverter#DISPOSE",b)})),p.$ident=b,p.id=this.delegatingCommandId,p.arguments=[b],this._logService.trace("CommandsConverter#CREATE",f.command,b)}return p}fromInternal(f){return typeof f.$ident=="number"?this._cache.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this._cache.get(f[0])}_executeConvertedCommand(...f){const h=this.getActualCommand(...f);return this._logService.trace("CommandsConverter#EXECUTE",f[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=i;class T{constructor(f,h,p,m){this.name=f,this.description=h,this.validate=p,this.convert=m}optional(){return new T(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,h){return new T(f??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=T,T.Uri=new T("uri","Uri of a text document",w=>t.URI.isUri(w),w=>w),T.Position=new T("position","A position in a text document",w=>O.Position.isPosition(w),_.Position.from),T.Range=new T("range","A range in a text document",w=>O.Range.isRange(w),_.Range.from),T.Selection=new T("selection","A selection in a text document",w=>O.Selection.isSelection(w),_.Selection.from),T.Number=new T("number","",w=>typeof w=="number",w=>w),T.String=new T("string","",w=>typeof w=="string",w=>w),T.CallHierarchyItem=new T("item","A call hierarchy item",w=>w instanceof O.CallHierarchyItem,_.CallHierarchyItem.from),T.TypeHierarchyItem=new T("item","A type hierarchy item",w=>w instanceof O.TypeHierarchyItem,_.TypeHierarchyItem.from),T.TestItem=new T("testItem","A VS Code TestItem",w=>w instanceof l.TestItemImpl,_.TestItem.from);class o{constructor(f,h){this.description=f,this.convert=h}}e.ApiCommandResult=o,o.Void=new o("no result",w=>w);class c{constructor(f,h,p,m,b){this.id=f,this.internalId=h,this.description=p,this.args=m,this.result=b}}e.ApiCommand=c}),define(me[177],ge([1,0,8,6,86,38,16,72]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",N(n.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,d)=>{if((0,x.isFalsyOrEmpty)(t))return;class s extends O.SymbolInformation{static to(l){const P=new s(l.name,n.SymbolKind.to(l.kind),l.containerName||"",new O.Location(d[0],n.Range.to(l.range)));return P.detail=l.detail,P.range=P.location.range,P.selectionRange=n.Range.to(l.selectionRange),P.children=l.children?l.children.map(s.to):[],P}}return t.map(s.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",N(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",N(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",N(n.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",N(n.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",N(n.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(d=>O.Position.isPosition(d)),t=>t.map(n.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(d=>{let s;for(const a of d.reverse())s=new O.SelectionRange(n.Range.to(a),s);return s}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(n.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(n.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(n.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(n.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:n.Range.to(t.range),placeholder:t.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return n.WorkspaceEdit.to(t)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(n.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new O.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const d=(0,F.decodeSemanticTokensDto)(t);if(d.type==="full")return new O.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new O.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const d=(0,F.decodeSemanticTokensDto)(t);if(d.type==="full")return new O.SemanticTokens(d.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,d,s)=>{if(!t)return new O.CompletionList([]);const a=t.suggestions.map(l=>n.CompletionItem.to(l,s));return new O.CompletionList(a,t.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return n.SignatureHelp.to(t)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,d,s)=>N(a=>new O.CodeLens(n.Range.to(a.range),a.command&&s.fromInternal(a.command)))(t))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>O.Range.isRange(t),t=>O.Selection.isSelection(t)?n.Selection.from(t):n.Range.from(t)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,d,s)=>N(a=>{if(a._isSynthetic){if(!a.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(a.command)}else{const l=new O.CodeAction(a.title,a.kind?new O.CodeActionKind(a.kind):void 0);return a.edit&&(l.edit=n.WorkspaceEdit.to(a.edit)),a.command&&(l.command=s.fromInternal(a.command)),l.isPreferred=a.isPreferred,l}})(t))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(d=>new O.ColorInformation(n.Range.to(d.range),n.Color.to(d.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",t=>t instanceof O.Color,n.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:n.Range.from(t.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(n.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,d,s)=>t.map(n.InlayHint.to.bind(void 0,s)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",N(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(d=>n.NotebookExclusiveDocumentPattern.to(d))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(n.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[n.ViewColumn.from(t),void 0]:[n.ViewColumn.from(t.viewColumn),n.TextEditorOpenOptions.from(t)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[n.ViewColumn.from(t),void 0]:[n.ViewColumn.from(t.viewColumn),n.TextEditorOpenOptions.from(t)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[n.ViewColumn.from(t.viewColumn),n.TextEditorOpenOptions.from(t)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class L{static register(d){y.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=L;function N(t){return d=>{if(Array.isArray(d))return d.map(t)}}function g(t){if(!Array.isArray(t))return;const d=[];for(const s of t)_.isLocationLink(s)?d.push(n.DefinitionLink.to(s)):d.push(n.location.to(s));return d}}),define(me[178],ge([1,0,10,50,5,7,2,86,23,8,6,26,4]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function d(s,a,l){const P=s.getProxy(t.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===6){const f=this._commentControllers.get(w.handle);return f||w}else if(w&&w.$mid===7){const f=this._commentControllers.get(w.commentControlHandle);if(!f)return w;const h=f.getCommentThread(w.commentThreadHandle);return h||w}else if(w&&w.$mid===8){const f=this._commentControllers.get(w.thread.commentControlHandle);if(!f)return w;const h=f.getCommentThread(w.thread.commentThreadHandle);return h?{thread:h,text:w.text}:w}else if(w&&w.$mid===9){const f=this._commentControllers.get(w.thread.commentControlHandle);if(!f)return w;const h=f.getCommentThread(w.thread.commentThreadHandle);if(!h)return w;let p=w.commentUniqueId,m=h.getCommentByUniqueId(p);return m||w}else if(w&&w.$mid===10){const f=this._commentControllers.get(w.thread.commentControlHandle);if(!f)return w;const h=f.getCommentThread(w.thread.commentThreadHandle);if(!h)return w;let p=w.text,m=w.commentUniqueId,b=h.getCommentByUniqueId(m);return b?(b.body=p,b):w}return w}})}createCommentController(w,f,h){const p=v.handlePool++,m=new r(w,p,f,h);this._commentControllers.set(m.handle,m);const b=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(w.identifier))||[];return b.push(m),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(w.identifier),b),m.value}$createCommentThreadTemplate(w,f,h){const p=this._commentControllers.get(w);!p||p.$createCommentThreadTemplate(f,h)}async $updateCommentThreadTemplate(w,f,h){const p=this._commentControllers.get(w);!p||p.$updateCommentThreadTemplate(f,h)}$deleteCommentThread(w,f){const h=this._commentControllers.get(w);h&&h.$deleteCommentThread(f)}$provideCommentingRanges(w,f,h){const p=this._commentControllers.get(w);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const m=l.getDocument(x.URI.revive(f));return(0,n.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(m,h)).then(b=>b?b.map(I=>L.Range.from(I)):void 0)}$toggleReaction(w,f,h,p,m){const b=this._commentControllers.get(w);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const I=b.getCommentThread(f);if(I){const k=I.getCommentByUniqueId(p.uniqueIdInThread);if(b!==void 0&&k&&b.reactionHandler)return b.reactionHandler(k,T(m))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class E{constructor(w,f,h,p,m,b,I){this._commentControllerHandle=f,this._id=h,this._uri=p,this._range=m,this._comments=b,this.extensionDescription=I,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${w}.${this.handle}`),P.$createCommentThread(f,this.handle,this._id,this._uri,L.Range.from(this._range),I.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{P.$deleteCommentThread(f,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range($){k.range=$},get comments(){return k.comments},set comments($){k.comments=$},get collapsibleState(){return k.collapsibleState},set collapsibleState($){k.collapsibleState=$},get canReply(){return k.canReply},set canReply($){k.canReply=$},get contextValue(){return k.contextValue},set contextValue($){k.contextValue=$},get label(){return k.label},set label($){k.label=$},dispose:()=>{k.dispose()}}}set threadId(w){this._id=w}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(w){w.isEqual(this._range)||(this._range=w,this.modifications.range=w,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(w){this._canReply!==w&&(this._canReply=w,this.modifications.canReply=w,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(w){this._label=w,this.modifications.label=w,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(w){this._contextValue=w,this.modifications.contextValue=w,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(w){this._comments=w,this.modifications.comments=w,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(w){this._collapseState=w,this.modifications.collapsibleState=w,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const w=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),f={};w("range")&&(f.range=L.Range.from(this._range)),w("label")&&(f.label=this.label),w("contextValue")&&(f.contextValue=this.contextValue??null),w("comments")&&(f.comments=this._comments.map(h=>S(this,h,this._commentsMap))),w("collapsibleState")&&(f.collapseState=o(this._collapseState)),w("canReply")&&(f.canReply=this.canReply),this.modifications={},P.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(w){for(let f of this._commentsMap){let h=f[0],p=f[1];if(w===p)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(w=>w.dispose())}}E._handlePool=0,Te([(0,O.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class r{constructor(w,f,h,p){this._extension=w,this._handle=f,this._id=h,this._label=p,this._threads=new Map,P.$registerCommentController(this.handle,h,p);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(b){m.options=b},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(b){m.commentingRangeProvider=b},get reactionHandler(){return m.reactionHandler},set reactionHandler(b){m.reactionHandler=b},createCommentThread(b,I,k){return m.createCommentThread(b,I,k).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{P.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(w){this._commentingRangeProvider=w,P.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(w){this._reactionHandler=w,P.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this._options}set options(w){this._options=w,P.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(w,f,h,p){if(typeof w=="string"){const m=new E(this.id,this.handle,w,f,h,p,this._extension);return this._threads.set(m.handle,m),m}else{const m=new E(this.id,this.handle,void 0,w,f,h,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(w,f){const h=new E(this.id,this.handle,void 0,x.URI.revive(w),L.Range.to(f),[],this._extension);return h.collapsibleState=F.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(w,f){let h=this._threads.get(w);h&&(h.range=L.Range.to(f))}$deleteCommentThread(w){let f=this._threads.get(w);f&&f.dispose(),this._threads.delete(w)}getCommentThread(w){return this._threads.get(w)}dispose(){this._threads.forEach(w=>{w.dispose()}),this._localDisposables.forEach(w=>w.dispose())}}function S(c,w,f){let h=f.get(w);h||(h=++c.commentHandle,f.set(w,h));const p=w.author&&w.author.iconPath?w.author.iconPath.toString():void 0;w.timestamp&&(0,g.checkProposedApiEnabled)(c.extensionDescription,"commentTimestamp");let m;return w.timestamp&&(m={source:w.timestamp,$mid:14}),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:h,body:typeof w.body=="string"?w.body:L.MarkdownString.from(w.body),userName:w.author.name,userIconPath:p,label:w.label,commentReactions:w.reactions?w.reactions.map(b=>i(b)):void 0,timestamp:m}}function i(c){return{label:c.label,iconPath:c.iconPath?L.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function T(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?x.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function o(c){if(c!==void 0)switch(c){case N.CommentThreadCollapsibleState.Expanded:return F.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return F.CommentThreadCollapsibleState.Collapsed}return F.CommentThreadCollapsibleState.Collapsed}return new v}e.createExtHostComments=d}),define(me[89],ge([1,0,2,4,6,3,12,9,16,14,19]),function(Z,e,n,O,_,C,x,F,y,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let g=class Di{constructor(d,s){this._logService=s,this._provider=new Map,this._proxy=d.getProxy(O.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,s){const a=Di._handlePool++;this._provider.set(a,{provider:d,extensionId:s}),this._proxy.$registerDecorationProvider(a,s.value);const l=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(a,null);return}let v=(0,y.asArray)(P);if(v.length<=Di._maxEventSize){this._proxy.$onDidChange(a,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,v.length);const E=v.map(i=>({uri:i,rank:(0,L.count)(i.path,"/")})),r=(0,y.groupBy)(E,(i,T)=>i.rank-T.rank||(0,L.compare)(i.uri.path,T.uri.path));let S=[];e:for(let i of r){let T;for(let o of i){let c=(0,N.dirname)(o.uri.path);if(T!==c&&(T=c,S.push(o.uri)>=Di._maxEventSize))break e}}this._proxy.$onDidChange(a,S)});return new _.Disposable(()=>{l?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(d,s,a){if(!this._provider.has(d))return Object.create(null);const l=Object.create(null),{provider:P,extensionId:v}=this._provider.get(d);return await Promise.all(s.map(async E=>{try{const{uri:r,id:S}=E,i=await Promise.resolve(P.provideFileDecoration(n.URI.revive(r),a));if(!i)return;try{_.FileDecoration.validate(i),l[S]=[i.propagate,i.tooltip,i.badge,i.color]}catch(T){this._logService.warn(`INVALID decoration from extension '${v.value}': ${T}`)}}catch(r){this._logService.error(r)}})),l}};g._handlePool=0,g._maxEventSize=250,g=Te([Re(0,x.IExtHostRpcService),Re(1,F.ILogService)],g),e.ExtHostDecorations=g,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[179],ge([1,0,118,75,2,4,6,8,5,9,22,29]),function(Z,e,n,O,_,C,x,F,y,L,N,g){"use strict";var t,d,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(v,E,r,S,i,T){this._name=v,this._owner=E,this._maxDiagnosticsPerFile=r,t.set(this,void 0),d.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,ze(this,s,new N.ResourceMap(o=>S.getComparisonKey(o)),"f"),ze(this,t,i,"f"),ze(this,d,T,"f")}dispose(){this._isDisposed||(we(this,d,"f").fire([...we(this,s,"f").keys()]),we(this,t,"f")&&we(this,t,"f").$clear(this._owner),we(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,E){if(!v){this.clear();return}this._checkDisposed();let r=[];if(_.URI.isUri(v)){if(!E){this.delete(v);return}we(this,s,"f").set(v,E.slice()),r=[v]}else if(Array.isArray(v)){r=[];let i;v=[...v].sort(a._compareIndexedTuplesByUri);for(const T of v){const[o,c]=T;if((!i||o.toString()!==i.toString())&&(i&&we(this,s,"f").get(i).length===0&&we(this,s,"f").delete(i),i=o,r.push(o),we(this,s,"f").set(o,[])),c){const w=we(this,s,"f").get(o);w&&w.push(...c)}else{const w=we(this,s,"f").get(o);w&&(w.length=0)}}}if(we(this,d,"f").fire(r),!we(this,t,"f"))return;const S=[];for(let i of r){let T=[];const o=we(this,s,"f").get(i);if(o)if(o.length>this._maxDiagnosticsPerFile){T=[];const c=[x.DiagnosticSeverity.Error,x.DiagnosticSeverity.Warning,x.DiagnosticSeverity.Information,x.DiagnosticSeverity.Hint];e:for(let w=0;w<4;w++)for(let f of o)if(f.severity===c[w]&&T.push(F.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;T.push({severity:O.MarkerSeverity.Info,message:(0,n.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:T[T.length-1].startLineNumber,startColumn:T[T.length-1].startColumn,endLineNumber:T[T.length-1].endLineNumber,endColumn:T[T.length-1].endColumn})}else T=o.map(c=>F.Diagnostic.from(c));S.push([i,T])}we(this,t,"f").$changeMany(this._owner,S)}delete(v){this._checkDisposed(),we(this,d,"f").fire([v]),we(this,s,"f").delete(v),we(this,t,"f")&&we(this,t,"f").$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),we(this,d,"f").fire([...we(this,s,"f").keys()]),we(this,s,"f").clear(),we(this,t,"f")&&we(this,t,"f").$clear(this._owner)}forEach(v,E){this._checkDisposed();for(let r of we(this,s,"f").keys())v.apply(E,[r,this.get(r),this])}get(v){this._checkDisposed();const E=we(this,s,"f").get(v);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(we(this,s,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,E){return v[0].toString()<E[0].toString()?-1:v[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=a,t=new WeakMap,d=new WeakMap,s=new WeakMap;let l=class si{constructor(v,E,r){this._logService=E,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=v.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(v){const E=new N.ResourceMap;for(const r of v)E.set(r,r);return{uris:Object.freeze(Array.from(E.values()))}}createDiagnosticCollection(v,E){const{_collections:r,_proxy:S,_onDidChangeDiagnostics:i,_logService:T,_fileSystemInfoService:o}=this,c=new class{$changeMany(h,p){S.$changeMany(h,p),T.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,h,p.length===0?"CLEARING":p)}$clear(h){S.$clear(h),T.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,h)}dispose(){S.dispose()}};let w;if(!E)E="_generated_diagnostic_collection_name_#"+si._idPool++,w=E;else if(!r.has(E))w=E;else{this._logService.warn(`DiagnosticCollection with name '${E}' does already exist.`);do w=E+si._idPool++;while(r.has(w))}return new class extends a{constructor(){super(E,w,si._maxDiagnosticsPerFile,o.extUri,c,i);r.set(w,this)}dispose(){super.dispose(),r.delete(w)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const E=new Map,r=[];for(const S of this._collections.values())S.forEach((i,T)=>{let o=E.get(i.toString());typeof o=="undefined"&&(o=r.length,E.set(i.toString(),o),r.push([i,[]])),r[o][1]=r[o][1].concat(...T)});return r}}_getDiagnostics(v){let E=[];for(let r of this._collections.values())r.has(v)&&(E=E.concat(r.get(v)));return E}$acceptMarkersChange(v){if(!this._mirrorCollection){const E="_generated_mirror",r=new a(E,E,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(E,r),this._mirrorCollection=r}for(const[E,r]of v)this._mirrorCollection.set(_.URI.revive(E),r.map(F.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=Te([Re(1,L.ILogService),Re(2,g.IExtHostFileSystemInfo)],l),e.ExtHostDiagnostics=l}),define(me[180],ge([1,0,2,4]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(x){this._proxy=x.getProxy(O.MainContext.MainThreadDialogs)}showOpenDialog(x){return this._proxy.$showOpenDialog(x).then(F=>F?F.map(y=>n.URI.revive(y)):void 0)}showSaveDialog(x){return this._proxy.$showSaveDialog(x).then(F=>F?n.URI.revive(F):void 0)}}e.ExtHostDialogs=_}),define(me[181],ge([1,0,15,2,6,4,11,20,14]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class L{constructor(g,t,d){this._documentsAndEditors=t,this._logService=d,this._documentContentProviders=new Map,this._proxy=g.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(g,t){if(Object.keys(x.Schemas).indexOf(g)>=0)throw new Error(`scheme '${g}' already registered`);const d=L._handlePool++;this._documentContentProviders.set(d,t),this._proxy.$registerTextContentProvider(d,g);let s;return typeof t.onDidChange=="function"&&(s=t.onDidChange(a=>{if(a.scheme!==g){this._logService.warn(`Provider for scheme '${g}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(d,a).then(l=>{if(!l&&typeof l!="string")return;const P=this._documentsAndEditors.getDocument(a);if(!P)return;const v=(0,y.splitLines)(l);if(!P.equalLines(v))return this._proxy.$onVirtualDocumentChange(a,l)},n.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(g,t){const d=this._documentContentProviders.get(g);return d?Promise.resolve(d.provideTextDocumentContent(O.URI.revive(t),F.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${t.scheme}`))}}e.ExtHostDocumentContentProvider=L,L._handlePool=0}),define(me[182],ge([1,0,5,7,2,4,80,8,13,25,6]),function(Z,e,n,O,_,C,x,F,y,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class g{constructor(d,s){this._onDidAddDocument=new n.Emitter,this._onDidRemoveDocument=new n.Emitter,this._onDidChangeDocument=new n.Emitter,this._onDidSaveDocument=new n.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new O.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const l of a)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const l of a)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const s=this._documentsAndEditors.getDocument(d);if(s)return s}getDocument(d){const s=this.getDocumentData(d);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return s.document}ensureDocumentData(d){const s=this._documentsAndEditors.getDocument(d);if(s)return Promise.resolve(s);let a=this._documentLoader.get(d.toString());return a||(a=this._proxy.$tryOpenDocument(d).then(l=>{this._documentLoader.delete(d.toString());const P=_.URI.revive(l);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(P))},l=>(this._documentLoader.delete(d.toString()),Promise.reject(l))),this._documentLoader.set(d.toString(),a)),a}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(s=>_.URI.revive(s))}$acceptModelLanguageChanged(d,s){const a=_.URI.revive(d),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(s),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(d){const s=_.URI.revive(d),a=this._documentsAndEditors.getDocument(s);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(d,s){const a=_.URI.revive(d),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");l._acceptIsDirty(s),this._onDidChangeDocument.fire({document:l.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,s,a){const l=_.URI.revive(d),P=this._documentsAndEditors.getDocument(l);if(!P)throw new Error("unknown document");P._acceptIsDirty(a),P.onEvents(s);let v;s.isUndoing?v=N.TextDocumentChangeReason.Undo:s.isRedoing&&(v=N.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,L.deepFreeze)({document:P.document,contentChanges:s.changes.map(E=>({range:F.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:v}))}setWordDefinitionFor(d,s){(0,x.setWordDefinitionFor)(d,s)}}e.ExtHostDocuments=g}),define(me[47],ge([1,0,41,5,7,2,3,4,80,12,88,8,9,22,11,157,227]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(r,S){this._extHostRpc=r,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new O.Emitter,this._onDidRemoveDocuments=new O.Emitter,this._onDidChangeVisibleTextEditors=new O.Emitter,this._onDidChangeActiveTextEditor=new O.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const S=[],i=[],T=[];if(r.removedDocuments)for(const o of r.removedDocuments){const c=C.URI.revive(o),w=this._documents.get(c);w?.unref()&&(this._documents.delete(c),S.push(w.value))}if(r.addedDocuments)for(const o of r.addedDocuments){const c=C.URI.revive(o.uri);let w=this._documents.get(c);if(w&&c.scheme!==s.Schemas.vscodeNotebookCell&&c.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);w||(w=new P(new y.ExtHostDocumentData(this._extHostRpc.getProxy(F.MainContext.MainThreadDocuments),c,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(c,w),i.push(w.value)),w.ref()}if(r.removedEditors)for(const o of r.removedEditors){const c=this._editors.get(o);this._editors.delete(o),c&&T.push(c)}if(r.addedEditors)for(const o of r.addedEditors){const c=C.URI.revive(o.documentUri);n.ok(this._documents.has(c),`document '${c}' does not exist`),n.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const w=this._documents.get(c).value,f=new N.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(F.MainContext.MainThreadTextEditors),this._logService,new l.Lazy(()=>w.document),o.selections.map(g.Selection.to),o.options,o.visibleRanges.map(h=>g.Range.to(h)),typeof o.editorPosition=="number"?g.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,f)}r.newActiveEditor!==void 0&&(n.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,_.dispose)(S),(0,_.dispose)(T),r.removedDocuments&&this._onDidRemoveDocuments.fire(S),r.addedDocuments&&this._onDidAddDocuments.fire(i),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return r?S:S?.value}allEditors(){return[...this._editors.values()]}};v=Te([Re(0,L.IExtHostRpcService),Re(1,t.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,x.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[63],ge([1,0,8,4,2,5,3,12,10]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,x.createDecorator)("IExtHostEditorTabs");let L=class{constructor(g){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=g.getProxy(O.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(g){let t=-1;this._tabs=g.map((s,a)=>(s.isActive&&(t=a),Object.freeze({label:s.label,viewColumn:n.ViewColumn.to(s.viewColumn),index:a,resource:_.URI.revive(s.resource),additionalResourcesAndViewIds:s.additionalResourcesAndViewIds.map(({resource:l,viewId:P})=>({resource:_.URI.revive(l),viewId:P})),viewId:s.editorId,isActive:s.isActive,move:async(l,P)=>{this._proxy.$moveTab(s,l,n.ViewColumn.from(P)),await(0,y.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(s),await(0,y.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((s,a)=>s.viewColumn===a.viewColumn?s.index-a.index:s.viewColumn-a.viewColumn);const d=this._activeTab;this._activeTab=t===-1?void 0:this._tabs[t],this._activeTab!==d&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};L=Te([Re(0,F.IExtHostRpcService)],L),e.ExtHostEditorTabs=L}),define(me[183],ge([1,0,2,4,7,6,8,228,14,21,26]),function(Z,e,n,O,_,C,x,F,y,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class g{constructor(){this._schemes=[]}add(s){this._stateMachine=void 0,this._schemes.push(s)}delete(s){const a=this._schemes.indexOf(s);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const s=this._schemes.sort(),a=[];let l,P,v=14,E=14;for(const r of s){let S=l?(0,y.commonPrefixLength)(l,r):0;for(S===0?P=1:P=E;S<r.length;S++)S+1===r.length?(v=E,E=9):E+=1,a.push([P,r.toUpperCase().charCodeAt(S),E]),a.push([P,r.toLowerCase().charCodeAt(S),E]),P=E;l=r,E=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new F.StateMachine(a)}}provideDocumentLinks(s){this._initStateMachine();const a=[],l=F.LinkComputer.computeLinks({getLineContent(P){return s.lineAt(P-1).text},getLineCount(){return s.lineCount}},this._stateMachine);for(const P of l){const v=x.DocumentLink.to(P);v.target&&a.push(v)}return a}}class t{constructor(s,a){this._extHostLanguageFeatures=a,this._linkProvider=new g,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=s.getProxy(O.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(s,a,l,P={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(s,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(v,l);let E=2;P.isCaseSensitive&&(E+=1024),P.isReadonly&&(E+=2048),typeof l.copy=="function"&&(E+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&((0,N.checkProposedApiEnabled)(s,"fsChunks"),E+=4),this._proxy.$registerFileSystemProvider(v,a,E).catch(S=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${a}`),console.error(S)});const r=l.onDidChangeFile(S=>{const i=[];for(const T of S){let{uri:o,type:c}=T;if(o.scheme!==a)continue;let w;switch(c){case C.FileChangeType.Changed:w=0;break;case C.FileChangeType.Created:w=1;break;case C.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:o,type:w})}this._proxy.$onFileSystemChange(v,i)});return(0,_.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(s){const{type:a,ctime:l,mtime:P,size:v,permissions:E}=s;return{type:a,ctime:l,mtime:P,size:v,permissions:E}}$stat(s,a){return Promise.resolve(this._getFsProvider(s).stat(n.URI.revive(a))).then(l=>t._asIStat(l))}$readdir(s,a){return Promise.resolve(this._getFsProvider(s).readDirectory(n.URI.revive(a)))}$readFile(s,a){return Promise.resolve(this._getFsProvider(s).readFile(n.URI.revive(a))).then(l=>L.VSBuffer.wrap(l))}$writeFile(s,a,l,P){return Promise.resolve(this._getFsProvider(s).writeFile(n.URI.revive(a),l.buffer,P))}$delete(s,a,l){return Promise.resolve(this._getFsProvider(s).delete(n.URI.revive(a),l))}$rename(s,a,l,P){return Promise.resolve(this._getFsProvider(s).rename(n.URI.revive(a),n.URI.revive(l),P))}$copy(s,a,l,P){const v=this._getFsProvider(s);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(n.URI.revive(a),n.URI.revive(l),P))}$mkdir(s,a){return Promise.resolve(this._getFsProvider(s).createDirectory(n.URI.revive(a)))}$watch(s,a,l,P){const v=this._getFsProvider(s).watch(n.URI.revive(l),P);this._watches.set(a,v)}$unwatch(s,a){const l=this._watches.get(a);l&&(l.dispose(),this._watches.delete(a))}$open(s,a,l){const P=this._getFsProvider(s);if(!P.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(P.open(n.URI.revive(a),l))}$close(s,a){const l=this._getFsProvider(s);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(a))}$read(s,a,l,P){const v=this._getFsProvider(s);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const E=L.VSBuffer.alloc(P);return Promise.resolve(v.read(a,l,E.buffer,0,P)).then(r=>E.slice(0,r))}$write(s,a,l,P){const v=this._getFsProvider(s);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,l,P.buffer,0,P.byteLength))}_getFsProvider(s){const a=this._fsProvider.get(s);if(!a){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return a}}e.ExtHostFileSystem=t}),define(me[48],ge([1,0,4,44,6,21,3,12,29,7]),function(Z,e,n,O,_,C,x,F,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class jt{constructor(t,d){this._fileSystemProvider=new Map,this._proxy=t.getProxy(n.MainContext.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(a){try{const l=s._fileSystemProvider.get(a.scheme);if(!l)return await s._proxy.$stat(a);await s._proxy.$ensureActivation(a.scheme);const P=await l.stat(a);return{type:P.type,ctime:P.ctime,mtime:P.mtime,size:P.size,permissions:P.permissions}}catch(l){jt._handleError(l)}},async readDirectory(a){try{const l=s._fileSystemProvider.get(a.scheme);return l?(await s._proxy.$ensureActivation(a.scheme),(await l.readDirectory(a)).slice()):await s._proxy.$readdir(a)}catch(l){return jt._handleError(l)}},async createDirectory(a){try{return await s._proxy.$mkdir(a)}catch(l){return jt._handleError(l)}},async readFile(a){try{const l=s._fileSystemProvider.get(a.scheme);return l?(await s._proxy.$ensureActivation(a.scheme),(await l.readFile(a)).slice()):(await s._proxy.$readFile(a)).buffer}catch(l){return jt._handleError(l)}},async writeFile(a,l){try{return await s._proxy.$writeFile(a,C.VSBuffer.wrap(l))}catch(P){return jt._handleError(P)}},async delete(a,l){try{const P=s._fileSystemProvider.get(a.scheme);return P?(await s._proxy.$ensureActivation(a.scheme),await P.delete(a,{recursive:!1,...l})):await s._proxy.$delete(a,{recursive:!1,useTrash:!1,...l})}catch(P){return jt._handleError(P)}},async rename(a,l,P){try{return await s._proxy.$rename(a,l,{overwrite:!1,...P})}catch(v){return jt._handleError(v)}},async copy(a,l,P){try{return await s._proxy.$copy(a,l,{overwrite:!1,...P})}catch(v){return jt._handleError(v)}},isWritableFileSystem(a){const l=d.getCapabilities(a);if(typeof l=="number")return!(l&2048)}})}static _handleError(t){if(t instanceof _.FileSystemError)throw t;if(!(t instanceof Error))throw new _.FileSystemError(String(t));if(t.name==="ENOPRO")throw _.FileSystemError.Unavailable(t.message);switch(t.name){case O.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(t.message);case O.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(t.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(t.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(t.message);case O.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(t.message);case O.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(t.message);default:throw new _.FileSystemError(t.message,t.name)}}addFileSystemProvider(t,d){return this._fileSystemProvider.set(t,d),(0,L.toDisposable)(()=>this._fileSystemProvider.delete(t))}};N=Te([Re(0,F.IExtHostRpcService),Re(1,y.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,x.createDecorator)("IExtHostConsumerFileSystem")}),define(me[184],ge([1,0,5,36,2,4,8,6]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(g,t,d,s,a,l,P,v){this._onDidCreate=new n.Emitter,this._onDidChange=new n.Emitter,this._onDidDelete=new n.Emitter;const E=this.ensureWatching(g,d,a);this._config=0,l&&(this._config+=1),P&&(this._config+=2),v&&(this._config+=4);const r=(0,O.parse)(a),S=typeof a=="string",i=s(T=>{if(!l)for(let o of T.created){const c=_.URI.revive(o);r(c.fsPath)&&(!S||t.getWorkspaceFolder(c))&&this._onDidCreate.fire(c)}if(!P)for(let o of T.changed){const c=_.URI.revive(o);r(c.fsPath)&&(!S||t.getWorkspaceFolder(c))&&this._onDidChange.fire(c)}if(!v)for(let o of T.deleted){const c=_.URI.revive(o);r(c.fsPath)&&(!S||t.getWorkspaceFolder(c))&&this._onDidDelete.fire(c)}});this._disposable=F.Disposable.from(E,this._onDidCreate,this._onDidChange,this._onDidDelete,i)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(g,t,d){let s=F.Disposable.from();if(typeof d=="string")return s;const a=g.getProxy(C.MainContext.MainThreadFileSystem);let l=!1;(d.pattern.includes(O.GLOBSTAR)||d.pattern.includes(O.GLOB_SPLIT))&&(l=!0);const P=Math.random();return a.$watch(t.identifier.value,P,d.baseUri,{recursive:l,excludes:[]}),F.Disposable.from({dispose:()=>a.$unwatch(P)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class L{constructor(g,t,d){this._mainContext=g,this._logService=t,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new n.Emitter,this._onDidRenameFile=new n.Emitter,this._onDidCreateFile=new n.Emitter,this._onDidDeleteFile=new n.Emitter,this._onWillRenameFile=new n.AsyncEmitter,this._onWillCreateFile=new n.AsyncEmitter,this._onWillDeleteFile=new n.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(g,t,d,s,a,l){return new y(this._mainContext,g,t,this._onFileSystemEvent.event,x.GlobPattern.from(d),s,a,l)}$onFileEvent(g){this._onFileSystemEvent.fire(g)}$onDidRunFileOperation(g,t){switch(g){case 2:this._onDidRenameFile.fire(Object.freeze({files:t.map(d=>({oldUri:_.URI.revive(d.source),newUri:_.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:t.map(d=>_.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:t.map(d=>_.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(g){return this._createWillExecuteEvent(g,this._onWillRenameFile)}getOnWillCreateFileEvent(g){return this._createWillExecuteEvent(g,this._onWillCreateFile)}getOnWillDeleteFileEvent(g){return this._createWillExecuteEvent(g,this._onWillDeleteFile)}_createWillExecuteEvent(g,t){return(d,s,a)=>{const l=function(v){d.call(s,v)};return l.extension=g,t.event(l,void 0,a)}}async $onWillRunFileOperation(g,t,d,s){switch(g){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:t.map(a=>({oldUri:_.URI.revive(a.source),newUri:_.URI.revive(a.target)}))},d,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:t.map(a=>_.URI.revive(a.target))},d,s);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:t.map(a=>_.URI.revive(a.target))},d,s)}}async _fireWillEvent(g,t,d,s){const a=new Set,l=[];if(await g.fireAsync(t,s,async(v,E)=>{const r=Date.now(),S=await Promise.resolve(v);S instanceof F.WorkspaceEdit&&(l.push(S),a.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-r>d&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),s.isCancellationRequested||l.length===0)return;const P={edits:[]};for(let v of l){let{edits:E}=x.WorkspaceEdit.from(v,this._extHostDocumentsAndEditors);P.edits=P.edits.concat(E)}return{edit:P,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=L}),define(me[185],ge([1,0,2,38]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(x,F,y,L){this._extHostNotebooks=F,this._textDocumentsAndEditors=y,this._commands=L;const N=new O.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new O.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new O.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new O.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new O.ApiCommandResult("Notebook and input URI",g=>{if(g.notebookEditorId!==void 0){const t=this._extHostNotebooks.getEditorById(g.notebookEditorId);return{notebookUri:n.URI.revive(g.notebookUri),inputUri:n.URI.revive(g.inputUri),notebookEditor:t.apiEditor}}return{notebookUri:n.URI.revive(g.notebookUri),inputUri:n.URI.revive(g.inputUri)}}));this._commands.registerApiCommand(N)}$willAddInteractiveDocument(x,F,y,L){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:F,lines:[""],languageId:y,uri:x,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(n.URI.revive(L))?.apiNotebook}]})}$willRemoveInteractiveDocument(x,F){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[x]})}}e.ExtHostInteractive=_}),define(me[186],ge([1,0,7,4]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(x){this._handlePool=0,this._proxy=x.getProxy(O.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(x){const F=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(F,x),(0,n.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(F)})}}e.ExtHostLabelService=_}),define(me[187],ge([1,0,2,25,8,6,4,14,85,16,13,229,20,7,72,51,56,188,15,5,10]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class S{constructor(M,A){this._documents=M,this._provider=A}async provideDocumentSymbols(M,A){const D=this._documents.getDocument(M),R=await this._provider.provideDocumentSymbols(D,A);if(!(0,L.isFalsyOrEmpty)(R))return R[0]instanceof C.DocumentSymbol?R.map(_.DocumentSymbol.from):S._asDocumentSymbolTree(R)}static _asDocumentSymbolTree(M){M=M.slice(0).sort((R,H)=>{let Q=R.location.range.start.compareTo(H.location.range.start);return Q===0&&(Q=H.location.range.end.compareTo(R.location.range.end)),Q});const A=[],D=[];for(const R of M){const H={name:R.name||"!!MISSING: name!!",kind:_.SymbolKind.from(R.kind),tags:R.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:R.containerName,range:_.Range.from(R.location.range),selectionRange:_.Range.from(R.location.range),children:[]};for(;;){if(D.length===0){D.push(H),A.push(H);break}const Q=D[D.length-1];if(y.Range.containsRange(Q.range,H.range)&&!y.Range.equalsRange(Q.range,H.range)){Q.children&&Q.children.push(H),D.push(H);break}D.pop()}}return A}}class i{constructor(M,A,D){this._documents=M,this._commands=A,this._provider=D,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(M,A){const D=this._documents.getDocument(M),R=await this._provider.provideCodeLenses(D,A);if(!R||A.isCancellationRequested)return;const H=this._cache.add(R),Q=new d.DisposableStore;this._disposables.set(H,Q);const te={cacheId:H,lenses:[]};for(let de=0;de<R.length;de++)te.lenses.push({cacheId:[H,de],range:_.Range.from(R[de].range),command:this._commands.toInternal(R[de].command,Q)});return te}async resolveCodeLens(M,A){const D=M.cacheId&&this._cache.get(...M.cacheId);if(!D)return;let R;if(typeof this._provider.resolveCodeLens!="function"||D.isResolved?R=D:R=await this._provider.resolveCodeLens(D,A),R||(R=D),A.isCancellationRequested)return;const H=M.cacheId&&this._disposables.get(M.cacheId[0]);if(!!H)return M.command=this._commands.toInternal(R.command??i._badCmd,H),M}releaseCodeLenses(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}}i._badCmd={command:"missing",title:"!!MISSING: command!!"};function T(ce){return Array.isArray(ce)?ce.map(_.DefinitionLink.from):ce?[_.DefinitionLink.from(ce)]:[]}class o{constructor(M,A){this._documents=M,this._provider=A}async provideDefinition(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.provideDefinition(R,H,D);return T(Q)}}class c{constructor(M,A){this._documents=M,this._provider=A}async provideDeclaration(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.provideDeclaration(R,H,D);return T(Q)}}class w{constructor(M,A){this._documents=M,this._provider=A}async provideImplementation(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.provideImplementation(R,H,D);return T(Q)}}class f{constructor(M,A){this._documents=M,this._provider=A}async provideTypeDefinition(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.provideTypeDefinition(R,H,D);return T(Q)}}class h{constructor(M,A){this._documents=M,this._provider=A}async provideHover(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.provideHover(R,H,D);if(!(!Q||(0,L.isFalsyOrEmpty)(Q.contents)))return Q.range||(Q.range=R.getWordRangeAtPosition(H)),Q.range||(Q.range=new C.Range(H,H)),_.Hover.from(Q)}}class p{constructor(M,A){this._documents=M,this._provider=A}async provideEvaluatableExpression(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.provideEvaluatableExpression(R,H,D);if(Q)return _.EvaluatableExpression.from(Q)}}class m{constructor(M,A){this._documents=M,this._provider=A}async provideInlineValues(M,A,D,R){const H=this._documents.getDocument(M),Q=await this._provider.provideInlineValues(H,_.Range.to(A),_.InlineValueContext.to(D),R);if(Array.isArray(Q))return Q.map(te=>_.InlineValue.from(te))}}class b{constructor(M,A){this._documents=M,this._provider=A}async provideDocumentHighlights(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.provideDocumentHighlights(R,H,D);if(Array.isArray(Q))return Q.map(_.DocumentHighlight.from)}}class I{constructor(M,A){this._documents=M,this._provider=A}async provideLinkedEditingRanges(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.provideLinkedEditingRanges(R,H,D);if(Q&&Array.isArray(Q.ranges))return{ranges:(0,L.coalesce)(Q.ranges.map(_.Range.from)),wordPattern:Q.wordPattern}}}class k{constructor(M,A){this._documents=M,this._provider=A}async provideReferences(M,A,D,R){const H=this._documents.getDocument(M),Q=_.Position.to(A),te=await this._provider.provideReferences(H,Q,D,R);if(Array.isArray(te))return te.map(_.location.from)}}class ${constructor(M,A,D,R,H,Q,te){this._documents=M,this._commands=A,this._diagnostics=D,this._provider=R,this._logService=H,this._extension=Q,this._apiDeprecation=te,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(M,A,D,R){const H=this._documents.getDocument(M),Q=g.Selection.isISelection(A)?_.Selection.to(A):_.Range.to(A),te=[];for(const Oe of this._diagnostics.getDiagnostics(M))if(Q.intersection(Oe.range)&&te.push(Oe)>$._maxCodeActionsPerFile)break;const de={diagnostics:te,only:D.only?new C.CodeActionKind(D.only):void 0,triggerKind:_.CodeActionTriggerKind.to(D.trigger)},Se=await this._provider.provideCodeActions(H,Q,de,R);if(!(0,L.isNonEmptyArray)(Se)||R.isCancellationRequested)return;const Ae=this._cache.add(Se),Fe=new d.DisposableStore;this._disposables.set(Ae,Fe);const Ue=[];for(let Oe=0;Oe<Se.length;Oe++){const ke=Se[Oe];!ke||($._isCommand(ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ue.push({_isSynthetic:!0,title:ke.title,command:this._commands.toInternal(ke,Fe)})):(de.only&&(ke.kind?de.only.contains(ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${de.only.value} 'requested but returned code action is of kind '${ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${de.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ue.push({cacheId:[Ae,Oe],title:ke.title,command:ke.command&&this._commands.toInternal(ke.command,Fe),diagnostics:ke.diagnostics&&ke.diagnostics.map(_.Diagnostic.from),edit:ke.edit&&_.WorkspaceEdit.from(ke.edit),kind:ke.kind&&ke.kind.value,isPreferred:ke.isPreferred,disabled:ke.disabled?.reason})))}return{cacheId:Ae,actions:Ue}}async resolveCodeAction(M,A){const[D,R]=M,H=this._cache.get(D,R);if(!H||$._isCommand(H)||!this._provider.resolveCodeAction)return;const Q=await this._provider.resolveCodeAction(H,A)??H;return Q?.edit?_.WorkspaceEdit.from(Q.edit):void 0}releaseCodeActions(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}static _isCommand(M){return typeof M.command=="string"&&typeof M.title=="string"}}$._maxCodeActionsPerFile=1e3;class u{constructor(M,A){this._documents=M,this._provider=A}async provideDocumentFormattingEdits(M,A,D){const R=this._documents.getDocument(M),H=await this._provider.provideDocumentFormattingEdits(R,A,D);if(Array.isArray(H))return H.map(_.TextEdit.from)}}class U{constructor(M,A){this._documents=M,this._provider=A}async provideDocumentRangeFormattingEdits(M,A,D,R){const H=this._documents.getDocument(M),Q=_.Range.to(A),te=await this._provider.provideDocumentRangeFormattingEdits(H,Q,D,R);if(Array.isArray(te))return te.map(_.TextEdit.from)}}class z{constructor(M,A){this._documents=M,this._provider=A,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,A,D,R,H){const Q=this._documents.getDocument(M),te=_.Position.to(A),de=await this._provider.provideOnTypeFormattingEdits(Q,te,D,R,H);if(Array.isArray(de))return de.map(_.TextEdit.from)}}class q{constructor(M,A){this._provider=M,this._logService=A,this._cache=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,A){const D=await this._provider.provideWorkspaceSymbols(M,A);if(!(0,L.isNonEmptyArray)(D))return{symbols:[]};const R=this._cache.add(D),H={cacheId:R,symbols:[]};for(let Q=0;Q<D.length;Q++){const te=D[Q];if(!te||!te.name){this._logService.warn("INVALID SymbolInformation",te);continue}H.symbols.push({..._.WorkspaceSymbol.from(te),cacheId:[R,Q]})}return H}async resolveWorkspaceSymbol(M,A){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const D=this._cache.get(...M.cacheId);if(D){const R=await this._provider.resolveWorkspaceSymbol(D,A);return R&&(0,O.mixin)(M,_.WorkspaceSymbol.from(R),!0)}}releaseWorkspaceSymbols(M){this._cache.delete(M)}}class V{constructor(M,A,D){this._documents=M,this._provider=A,this._logService=D}static supportsResolving(M){return typeof M.prepareRename=="function"}async provideRenameEdits(M,A,D,R){const H=this._documents.getDocument(M),Q=_.Position.to(A);try{const te=await this._provider.provideRenameEdits(H,Q,D,R);return te?_.WorkspaceEdit.from(te):void 0}catch(te){const de=V._asMessage(te);return de?{rejectReason:de,edits:void 0}:Promise.reject(te)}}async resolveRenameLocation(M,A,D){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const R=this._documents.getDocument(M),H=_.Position.to(A);try{const Q=await this._provider.prepareRename(R,H,D);let te,de;if(C.Range.isRange(Q)?(te=Q,de=R.getText(Q)):(0,N.isObject)(Q)&&(te=Q.range,de=Q.placeholder),!te||!de)return;if(te.start.line>H.line||te.end.line<H.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(te),text:de}}catch(Q){const te=V._asMessage(Q);return te?{rejectReason:te,range:void 0,text:void 0}:Promise.reject(Q)}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class j{constructor(M,A){this.resultId=M,this.tokens=A}}class Y{constructor(M,A){this._documents=M,this._provider=A,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(M,A,D){const R=this._documents.getDocument(M),H=A!==0?this._previousResults.get(A):null;let Q=typeof H?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(R,H.resultId,D):await this._provider.provideDocumentSemanticTokens(R,D);return H&&this._previousResults.delete(A),Q?(Q=Y._fixProvidedSemanticTokens(Q),this._send(Y._convertToEdits(H,Q),Q)):null}async releaseDocumentSemanticColoring(M){this._previousResults.delete(M)}static _fixProvidedSemanticTokens(M){return Y._isSemanticTokens(M)?Y._isCorrectSemanticTokens(M)?M:new C.SemanticTokens(new Uint32Array(M.data),M.resultId):Y._isSemanticTokensEdits(M)?Y._isCorrectSemanticTokensEdits(M)?M:new C.SemanticTokensEdits(M.edits.map(A=>new C.SemanticTokensEdit(A.start,A.deleteCount,A.data?new Uint32Array(A.data):A.data)),M.resultId):M}static _isSemanticTokens(M){return M&&!!M.data}static _isCorrectSemanticTokens(M){return M.data instanceof Uint32Array}static _isSemanticTokensEdits(M){return M&&Array.isArray(M.edits)}static _isCorrectSemanticTokensEdits(M){for(const A of M.edits)if(!(A.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(M,A){if(!Y._isSemanticTokens(A)||!M||!M.tokens)return A;const D=M.tokens,R=D.length,H=A.data,Q=H.length;let te=0;const de=Math.min(R,Q);for(;te<de&&D[te]===H[te];)te++;if(te===R&&te===Q)return new C.SemanticTokensEdits([],A.resultId);let Se=0;const Ae=de-te;for(;Se<Ae&&D[R-Se-1]===H[Q-Se-1];)Se++;return new C.SemanticTokensEdits([{start:te,deleteCount:R-te-Se,data:H.subarray(te,Q-Se)}],A.resultId)}_send(M,A){if(Y._isSemanticTokens(M)){const D=this._nextResultId++;return this._previousResults.set(D,new j(M.resultId,M.data)),(0,s.encodeSemanticTokensDto)({id:D,type:"full",data:M.data})}if(Y._isSemanticTokensEdits(M)){const D=this._nextResultId++;return Y._isSemanticTokens(A)?this._previousResults.set(D,new j(A.resultId,A.data)):this._previousResults.set(D,new j(M.resultId)),(0,s.encodeSemanticTokensDto)({id:D,type:"delta",deltas:(M.edits||[]).map(R=>({start:R.start,deleteCount:R.deleteCount,data:R.data}))})}return null}}e.DocumentSemanticTokensAdapter=Y;class se{constructor(M,A){this._documents=M,this._provider=A}async provideDocumentRangeSemanticTokens(M,A,D){const R=this._documents.getDocument(M),H=await this._provider.provideDocumentRangeSemanticTokens(R,_.Range.to(A),D);return H?this._send(H):null}_send(M){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}e.DocumentRangeSemanticTokensAdapter=se;class le{constructor(M,A,D,R,H){this._documents=M,this._commands=A,this._provider=D,this._apiDeprecation=R,this._extension=H,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}async provideCompletionItems(M,A,D,R){const H=this._documents.getDocument(M),Q=_.Position.to(A),te=H.getWordRangeAtPosition(Q)||new C.Range(Q,Q),de=te.with({end:Q}),Se=new P.StopWatch(!0),Ae=await this._provider.provideCompletionItems(H,Q,R,_.CompletionContext.to(D));if(!Ae||R.isCancellationRequested)return;const Fe=Array.isArray(Ae)?new C.CompletionList(Ae):Ae,Ue=le.supportsResolving(this._provider)?this._cache.add(Fe.items):this._cache.add([]),Oe=new d.DisposableStore;this._disposables.set(Ue,Oe);const ke=[],qe={x:Ue,b:ke,a:{replace:_.Range.from(te),insert:_.Range.from(de)},c:Fe.isIncomplete||void 0,d:Se.elapsed()};for(let it=0;it<Fe.items.length;it++){const De=Fe.items[it],Ze=this._convertCompletionItem(De,[Ue,it],de,te);ke.push(Ze)}return qe}async resolveCompletionItem(M,A){if(typeof this._provider.resolveCompletionItem!="function")return;const D=this._cache.get(...M);if(!D)return;const R=await this._provider.resolveCompletionItem(D,A);if(!!R)return this._convertCompletionItem(R,M)}releaseCompletionItems(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_convertCompletionItem(M,A,D,R){const H=this._disposables.get(A[0]);if(!H)throw Error("DisposableStore is missing...");const Q={x:A,a:M.label,b:M.kind!==void 0?_.CompletionItemKind.from(M.kind):void 0,n:M.tags&&M.tags.map(_.CompletionItemTag.from),c:M.detail,d:typeof M.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters,l:M.additionalTextEdits&&M.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(M.command,H)};M.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Q.h=M.textEdit.newText):typeof M.insertText=="string"?Q.h=M.insertText:M.insertText instanceof C.SnippetString&&(Q.h=M.insertText.value,Q.i|=4);let te;return M.textEdit?te=M.textEdit.range:M.range&&(te=M.range),C.Range.isRange(te)?Q.j=_.Range.from(te):te&&(!D?.isEqual(te.inserting)||!R?.isEqual(te.replacing))&&(Q.j={insert:_.Range.from(te.inserting),replace:_.Range.from(te.replacing)}),Q}}class re{constructor(M,A,D){this._documents=M,this._provider=A,this._commands=D,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(M,A,D,R){const H=this._documents.getDocument(M),Q=_.Position.to(A),te=await this._provider.provideInlineCompletionItems(H,Q,{selectedCompletionInfo:D.selectedSuggestionInfo?{range:_.Range.to(D.selectedSuggestionInfo.range),text:D.selectedSuggestionInfo.text,isSnippetText:D.selectedSuggestionInfo.isSnippetText,completionKind:_.CompletionItemKind.to(D.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:D.triggerKind},R);if(!te||R.isCancellationRequested)return;const de=(0,N.isArray)(te)?{items:te}:te,Se=this._cache.add(de.items);let Ae;return{pid:Se,items:de.items.map((Fe,Ue)=>{let Oe;return Fe.command&&(Ae||(Ae=new d.DisposableStore,this._disposables.set(Se,Ae)),Oe=this._commands.toInternal(Fe.command,Ae)),{text:Fe.text,range:Fe.range?_.Range.from(Fe.range):void 0,command:Oe,idx:Ue,completeBracketPairs:Fe.completeBracketPairs}})}}disposeCompletions(M){this._cache.delete(M);const A=this._disposables.get(M);A&&A.clear(),this._disposables.delete(M)}handleDidShowCompletionItem(M,A){const D=this._cache.get(M,A);D&&he.get(this._provider).fireOnDidShowCompletionItem({completionItem:D})}}class he{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(M){let A=he.map.get(M);return A||(A=new he,he.map.set(M,A)),A}fireOnDidShowCompletionItem(M){this._onDidShowCompletionItemEmitter.fire(M)}}e.InlineCompletionController=he,he.map=new WeakMap;class Ee{constructor(M,A){this._documents=M,this._provider=A,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(M,A,D,R){const H=this._documents.getDocument(M),Q=_.Position.to(A),te=this.reviveContext(D),de=await this._provider.provideSignatureHelp(H,Q,R,te);if(de){const Se=this._cache.add([de]);return{..._.SignatureHelp.from(de),id:Se}}}reviveContext(M){let A;if(M.activeSignatureHelp){const D=_.SignatureHelp.to(M.activeSignatureHelp),R=this._cache.get(M.activeSignatureHelp.id,0);R?(A=R,A.activeSignature=D.activeSignature,A.activeParameter=D.activeParameter):A=D}return{...M,activeSignatureHelp:A}}releaseSignatureHelp(M){this._cache.delete(M)}}class Ce{constructor(M,A,D,R,H){this._documents=M,this._commands=A,this._provider=D,this._logService=R,this._extension=H,this._cache=new l.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(M,A,D){const R=this._documents.getDocument(M),H=_.Range.to(A),Q=await this._provider.provideInlayHints(R,H,D);if(!Array.isArray(Q)||Q.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${A}`);return}if(D.isCancellationRequested)return;const te=this._cache.add(Q);this._disposables.set(te,new d.DisposableStore);const de={hints:[],cacheId:te};for(let Se=0;Se<Q.length;Se++)this._isValidInlayHint(Q[Se],H)&&de.hints.push(this._convertInlayHint(Q[Se],[te,Se]));return this._logService.trace(`[InlayHints] ${de.hints.length} inlay hints from '${this._extension.identifier.value}' for ${A}`),de}async resolveInlayHint(M,A){if(typeof this._provider.resolveInlayHint!="function")return;const D=this._cache.get(...M);if(!D)return;const R=await this._provider.resolveInlayHint(D,A);if(!!R&&!!this._isValidInlayHint(R))return this._convertInlayHint(R,M)}releaseHints(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_isValidInlayHint(M,A){return M.label.length===0||Array.isArray(M.label)&&M.label.every(D=>D.label.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(A&&!A.contains(M.position))}_convertInlayHint(M,A){const D=this._disposables.get(A[0]);if(!D)throw Error("DisposableStore is missing...");const R={label:"",cacheId:A,tooltip:M.tooltip&&_.MarkdownString.from(M.tooltip),position:_.Position.from(M.position),kind:_.InlayHintKind.from(M.kind??C.InlayHintKind.Other),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?R.label=M.label:R.label=M.label.map(H=>{let Q={label:H.label};return Q.tooltip=H.tooltip&&_.MarkdownString.from(H.tooltip),C.Location.isLocation(H.location)&&(Q.location=_.location.from(H.location)),H.command&&(Q.command=this._commands.toInternal(H.command,D)),Q}),R}}class Pe{constructor(M,A){this._documents=M,this._provider=A,this._cache=new l.Cache("DocumentLink")}async provideLinks(M,A){const D=this._documents.getDocument(M),R=await this._provider.provideDocumentLinks(D,A);if(!(!Array.isArray(R)||R.length===0)&&!A.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:R.filter(Pe._validateLink).map(_.DocumentLink.from)};{const H=this._cache.add(R),Q={links:[],cacheId:H};for(let te=0;te<R.length;te++){if(!Pe._validateLink(R[te]))continue;const de=_.DocumentLink.from(R[te]);de.cacheId=[H,te],Q.links.push(de)}return Q}}}static _validateLink(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,A){if(typeof this._provider.resolveDocumentLink!="function")return;const D=this._cache.get(...M);if(!D)return;const R=await this._provider.resolveDocumentLink(D,A);if(!(!R||!Pe._validateLink(R)))return _.DocumentLink.from(R)}releaseLinks(M){this._cache.delete(M)}}class Be{constructor(M,A){this._documents=M,this._provider=A}async provideColors(M,A){const D=this._documents.getDocument(M),R=await this._provider.provideDocumentColors(D,A);return Array.isArray(R)?R.map(Q=>({color:_.Color.from(Q.color),range:_.Range.from(Q.range)})):[]}async provideColorPresentations(M,A,D){const R=this._documents.getDocument(M),H=_.Range.to(A.range),Q=_.Color.to(A.color),te=await this._provider.provideColorPresentations(Q,{document:R,range:H},D);if(!!Array.isArray(te))return te.map(_.ColorPresentation.from)}}class je{constructor(M,A){this._documents=M,this._provider=A}async provideFoldingRanges(M,A,D){const R=this._documents.getDocument(M),H=await this._provider.provideFoldingRanges(R,A,D);if(!!Array.isArray(H))return H.map(_.FoldingRange.from)}}class tt{constructor(M,A,D){this._documents=M,this._provider=A,this._logService=D}async provideSelectionRanges(M,A,D){const R=this._documents.getDocument(M),H=A.map(_.Position.to),Q=await this._provider.provideSelectionRanges(R,H,D);if(!(0,L.isNonEmptyArray)(Q))return[];if(Q.length!==H.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const te=[];for(let de=0;de<H.length;de++){const Se=[];te.push(Se);let Ae=H[de],Fe=Q[de];for(;;){if(!Fe.range.contains(Ae))throw new Error("INVALID selection range, must contain the previous range");if(Se.push(_.SelectionRange.from(Fe)),!Fe.parent)break;Ae=Fe.range,Fe=Fe.parent}}return te}}class Ge{constructor(M,A){this._documents=M,this._provider=A,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.prepareCallHierarchy(R,H,D);if(!Q)return;const te=this._idPool.nextId();return this._cache.set(te,new Map),Array.isArray(Q)?Q.map(de=>this._cacheAndConvertItem(te,de)):[this._cacheAndConvertItem(te,Q)]}async provideCallsTo(M,A,D){const R=this._itemFromCache(M,A);if(!R)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyIncomingCalls(R,D);if(!!H)return H.map(Q=>({from:this._cacheAndConvertItem(M,Q.from),fromRanges:Q.fromRanges.map(te=>_.Range.from(te))}))}async provideCallsFrom(M,A,D){const R=this._itemFromCache(M,A);if(!R)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyOutgoingCalls(R,D);if(!!H)return H.map(Q=>({to:this._cacheAndConvertItem(M,Q.to),fromRanges:Q.fromRanges.map(te=>_.Range.from(te))}))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,A){const D=this._cache.get(M),R=_.CallHierarchyItem.from(A,M,D.size.toString(36));return D.set(R._itemId,A),R}_itemFromCache(M,A){return this._cache.get(M)?.get(A)}}class ot{constructor(M,A){this._documents=M,this._provider=A,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(M,A,D){const R=this._documents.getDocument(M),H=_.Position.to(A),Q=await this._provider.prepareTypeHierarchy(R,H,D);if(!Q)return;const te=this._idPool.nextId();return this._cache.set(te,new Map),Array.isArray(Q)?Q.map(de=>this._cacheAndConvertItem(te,de)):[this._cacheAndConvertItem(te,Q)]}async provideSupertypes(M,A,D){const R=this._itemFromCache(M,A);if(!R)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySupertypes(R,D);if(!!H)return H.map(Q=>this._cacheAndConvertItem(M,Q))}async provideSubtypes(M,A,D){const R=this._itemFromCache(M,A);if(!R)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySubtypes(R,D);if(!!H)return H.map(Q=>this._cacheAndConvertItem(M,Q))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,A){const D=this._cache.get(M),R=_.TypeHierarchyItem.from(A,M,D.size.toString(36));return D.set(R._itemId,A),R}_itemFromCache(M,A){return this._cache.get(M)?.get(A)}}class mt{constructor(M,A){this.adapter=M,this.extension=A}}class ve{constructor(M,A,D,R,H,Q,te){this._adapter=new Map,this._uriTransformer=A,this._proxy=M.getProxy(x.MainContext.MainThreadLanguageFeatures),this._documents=D,this._commands=R,this._diagnostics=H,this._logService=Q,this._apiDeprecation=te}_transformDocumentSelector(M){return _.DocumentSelector.from(M,this._uriTransformer)}_createDisposable(M){return new C.Disposable(()=>{this._adapter.delete(M),this._proxy.$unregister(M)})}_nextHandle(){return ve._handlePool++}async _withAdapter(M,A,D,R,H){const Q=this._adapter.get(M);if(!Q||!(Q.adapter instanceof A))return R;const te=Date.now();this._logService.trace(`[${Q.extension.identifier.value}] INVOKE provider '${D.toString().replace(/[\r\n]/g,"")}'`);const de=D(Q.adapter,Q.extension);return Promise.resolve(de).catch(Se=>{(0,v.isCancellationError)(Se)||(this._logService.error(`[${Q.extension.identifier.value}] provider FAILED`),this._logService.error(Se))}).finally(()=>{this._logService.trace(`[${Q.extension.identifier.value}] provider DONE after ${Date.now()-te}ms`)}),t.CancellationToken.isCancellationToken(H)?(0,r.raceCancellationError)(de,H):de}_addNewAdapter(M,A){const D=this._nextHandle();return this._adapter.set(D,new mt(M,A)),D}static _extLabel(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,A,D,R){const H=this._addNewAdapter(new S(this._documents,D),M),Q=R&&R.label||ve._extLabel(M);return this._proxy.$registerDocumentSymbolProvider(H,this._transformDocumentSelector(A),Q),this._createDisposable(H)}$provideDocumentSymbols(M,A,D){return this._withAdapter(M,S,R=>R.provideDocumentSymbols(n.URI.revive(A),D),void 0,D)}registerCodeLensProvider(M,A,D){const R=this._nextHandle(),H=typeof D.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(R,new mt(new i(this._documents,this._commands.converter,D),M)),this._proxy.$registerCodeLensSupport(R,this._transformDocumentSelector(A),H);let Q=this._createDisposable(R);if(H!==void 0){const te=D.onDidChangeCodeLenses(de=>this._proxy.$emitCodeLensEvent(H));Q=C.Disposable.from(Q,te)}return Q}$provideCodeLenses(M,A,D){return this._withAdapter(M,i,R=>R.provideCodeLenses(n.URI.revive(A),D),void 0,void 0)}$resolveCodeLens(M,A,D){return this._withAdapter(M,i,R=>R.resolveCodeLens(A,D),void 0,void 0)}$releaseCodeLenses(M,A){this._withAdapter(M,i,D=>Promise.resolve(D.releaseCodeLenses(A)),void 0,void 0)}registerDefinitionProvider(M,A,D){const R=this._addNewAdapter(new o(this._documents,D),M);return this._proxy.$registerDefinitionSupport(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideDefinition(M,A,D,R){return this._withAdapter(M,o,H=>H.provideDefinition(n.URI.revive(A),D,R),[],R)}registerDeclarationProvider(M,A,D){const R=this._addNewAdapter(new c(this._documents,D),M);return this._proxy.$registerDeclarationSupport(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideDeclaration(M,A,D,R){return this._withAdapter(M,c,H=>H.provideDeclaration(n.URI.revive(A),D,R),[],R)}registerImplementationProvider(M,A,D){const R=this._addNewAdapter(new w(this._documents,D),M);return this._proxy.$registerImplementationSupport(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideImplementation(M,A,D,R){return this._withAdapter(M,w,H=>H.provideImplementation(n.URI.revive(A),D,R),[],R)}registerTypeDefinitionProvider(M,A,D){const R=this._addNewAdapter(new f(this._documents,D),M);return this._proxy.$registerTypeDefinitionSupport(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideTypeDefinition(M,A,D,R){return this._withAdapter(M,f,H=>H.provideTypeDefinition(n.URI.revive(A),D,R),[],R)}registerHoverProvider(M,A,D,R){const H=this._addNewAdapter(new h(this._documents,D),M);return this._proxy.$registerHoverProvider(H,this._transformDocumentSelector(A)),this._createDisposable(H)}$provideHover(M,A,D,R){return this._withAdapter(M,h,H=>H.provideHover(n.URI.revive(A),D,R),void 0,void 0)}registerEvaluatableExpressionProvider(M,A,D,R){const H=this._addNewAdapter(new p(this._documents,D),M);return this._proxy.$registerEvaluatableExpressionProvider(H,this._transformDocumentSelector(A)),this._createDisposable(H)}$provideEvaluatableExpression(M,A,D,R){return this._withAdapter(M,p,H=>H.provideEvaluatableExpression(n.URI.revive(A),D,R),void 0,void 0)}registerInlineValuesProvider(M,A,D,R){const H=typeof D.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new m(this._documents,D),M);this._proxy.$registerInlineValuesProvider(Q,this._transformDocumentSelector(A),H);let te=this._createDisposable(Q);if(H!==void 0){const de=D.onDidChangeInlineValues(Se=>this._proxy.$emitInlineValuesEvent(H));te=C.Disposable.from(te,de)}return te}$provideInlineValues(M,A,D,R,H){return this._withAdapter(M,m,Q=>Q.provideInlineValues(n.URI.revive(A),D,R,H),void 0,void 0)}registerDocumentHighlightProvider(M,A,D){const R=this._addNewAdapter(new b(this._documents,D),M);return this._proxy.$registerDocumentHighlightProvider(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideDocumentHighlights(M,A,D,R){return this._withAdapter(M,b,H=>H.provideDocumentHighlights(n.URI.revive(A),D,R),void 0,void 0)}registerLinkedEditingRangeProvider(M,A,D){const R=this._addNewAdapter(new I(this._documents,D),M);return this._proxy.$registerLinkedEditingRangeProvider(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideLinkedEditingRanges(M,A,D,R){return this._withAdapter(M,I,async H=>{const Q=await H.provideLinkedEditingRanges(n.URI.revive(A),D,R);if(Q)return{ranges:Q.ranges,wordPattern:Q.wordPattern?ve._serializeRegExp(Q.wordPattern):void 0}},void 0,void 0)}registerReferenceProvider(M,A,D){const R=this._addNewAdapter(new k(this._documents,D),M);return this._proxy.$registerReferenceSupport(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideReferences(M,A,D,R,H){return this._withAdapter(M,k,Q=>Q.provideReferences(n.URI.revive(A),D,R,H),void 0,H)}registerCodeActionProvider(M,A,D,R){const H=new d.DisposableStore,Q=this._addNewAdapter(new $(this._documents,this._commands.converter,this._diagnostics,D,this._logService,M,this._apiDeprecation),M);return this._proxy.$registerQuickFixSupport(Q,this._transformDocumentSelector(A),{providedKinds:R?.providedCodeActionKinds?.map(te=>te.value),documentation:R?.documentation?.map(te=>({kind:te.kind.value,command:this._commands.converter.toInternal(te.command,H)}))},ve._extLabel(M),Boolean(D.resolveCodeAction)),H.add(this._createDisposable(Q)),H}$provideCodeActions(M,A,D,R,H){return this._withAdapter(M,$,Q=>Q.provideCodeActions(n.URI.revive(A),D,R,H),void 0,void 0)}$resolveCodeAction(M,A,D){return this._withAdapter(M,$,R=>R.resolveCodeAction(A,D),void 0,void 0)}$releaseCodeActions(M,A){this._withAdapter(M,$,D=>Promise.resolve(D.releaseCodeActions(A)),void 0,void 0)}registerDocumentFormattingEditProvider(M,A,D){const R=this._addNewAdapter(new u(this._documents,D),M);return this._proxy.$registerDocumentFormattingSupport(R,this._transformDocumentSelector(A),M.identifier,M.displayName||M.name),this._createDisposable(R)}$provideDocumentFormattingEdits(M,A,D,R){return this._withAdapter(M,u,H=>H.provideDocumentFormattingEdits(n.URI.revive(A),D,R),void 0,void 0)}registerDocumentRangeFormattingEditProvider(M,A,D){const R=this._addNewAdapter(new U(this._documents,D),M);return this._proxy.$registerRangeFormattingSupport(R,this._transformDocumentSelector(A),M.identifier,M.displayName||M.name),this._createDisposable(R)}$provideDocumentRangeFormattingEdits(M,A,D,R,H){return this._withAdapter(M,U,Q=>Q.provideDocumentRangeFormattingEdits(n.URI.revive(A),D,R,H),void 0,void 0)}registerOnTypeFormattingEditProvider(M,A,D,R){const H=this._addNewAdapter(new z(this._documents,D),M);return this._proxy.$registerOnTypeFormattingSupport(H,this._transformDocumentSelector(A),R,M.identifier),this._createDisposable(H)}$provideOnTypeFormattingEdits(M,A,D,R,H,Q){return this._withAdapter(M,z,te=>te.provideOnTypeFormattingEdits(n.URI.revive(A),D,R,H,Q),void 0,void 0)}registerWorkspaceSymbolProvider(M,A){const D=this._addNewAdapter(new q(A,this._logService),M);return this._proxy.$registerNavigateTypeSupport(D,typeof A.resolveWorkspaceSymbol=="function"),this._createDisposable(D)}$provideWorkspaceSymbols(M,A,D){return this._withAdapter(M,q,R=>R.provideWorkspaceSymbols(A,D),{symbols:[]},D)}$resolveWorkspaceSymbol(M,A,D){return this._withAdapter(M,q,R=>R.resolveWorkspaceSymbol(A,D),void 0,void 0)}$releaseWorkspaceSymbols(M,A){this._withAdapter(M,q,D=>D.releaseWorkspaceSymbols(A),void 0,void 0)}registerRenameProvider(M,A,D){const R=this._addNewAdapter(new V(this._documents,D,this._logService),M);return this._proxy.$registerRenameSupport(R,this._transformDocumentSelector(A),V.supportsResolving(D)),this._createDisposable(R)}$provideRenameEdits(M,A,D,R,H){return this._withAdapter(M,V,Q=>Q.provideRenameEdits(n.URI.revive(A),D,R,H),void 0,void 0)}$resolveRenameLocation(M,A,D,R){return this._withAdapter(M,V,H=>H.resolveRenameLocation(n.URI.revive(A),D,R),void 0,void 0)}registerDocumentSemanticTokensProvider(M,A,D,R){const H=this._addNewAdapter(new Y(this._documents,D),M),Q=typeof D.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(H,this._transformDocumentSelector(A),R,Q);let te=this._createDisposable(H);if(Q){const de=D.onDidChangeSemanticTokens(Se=>this._proxy.$emitDocumentSemanticTokensEvent(Q));te=C.Disposable.from(te,de)}return te}$provideDocumentSemanticTokens(M,A,D,R){return this._withAdapter(M,Y,H=>H.provideDocumentSemanticTokens(n.URI.revive(A),D,R),null,void 0)}$releaseDocumentSemanticTokens(M,A){this._withAdapter(M,Y,D=>D.releaseDocumentSemanticColoring(A),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,A,D,R){const H=this._addNewAdapter(new se(this._documents,D),M);return this._proxy.$registerDocumentRangeSemanticTokensProvider(H,this._transformDocumentSelector(A),R),this._createDisposable(H)}$provideDocumentRangeSemanticTokens(M,A,D,R){return this._withAdapter(M,se,H=>H.provideDocumentRangeSemanticTokens(n.URI.revive(A),D,R),null,void 0)}registerCompletionItemProvider(M,A,D,R){const H=this._addNewAdapter(new le(this._documents,this._commands.converter,D,this._apiDeprecation,M),M);return this._proxy.$registerSuggestSupport(H,this._transformDocumentSelector(A),R,le.supportsResolving(D),`${M.identifier.value}(${R.join("")})`),this._createDisposable(H)}$provideCompletionItems(M,A,D,R,H){return this._withAdapter(M,le,Q=>Q.provideCompletionItems(n.URI.revive(A),D,R,H),void 0,H)}$resolveCompletionItem(M,A,D){return this._withAdapter(M,le,R=>R.resolveCompletionItem(A,D),void 0,D)}$releaseCompletionItems(M,A){this._withAdapter(M,le,D=>D.releaseCompletionItems(A),void 0,void 0)}registerInlineCompletionsProvider(M,A,D){const R=this._addNewAdapter(new re(this._documents,D,this._commands.converter),M);return this._proxy.$registerInlineCompletionsSupport(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideInlineCompletions(M,A,D,R,H){return this._withAdapter(M,re,Q=>Q.provideInlineCompletions(n.URI.revive(A),D,R,H),void 0,void 0)}$handleInlineCompletionDidShow(M,A,D){this._withAdapter(M,re,async R=>{R.handleDidShowCompletionItem(A,D)},void 0,void 0)}$freeInlineCompletionsList(M,A){this._withAdapter(M,re,async D=>{D.disposeCompletions(A)},void 0,void 0)}registerSignatureHelpProvider(M,A,D,R){const H=Array.isArray(R)?{triggerCharacters:R,retriggerCharacters:[]}:R,Q=this._addNewAdapter(new Ee(this._documents,D),M);return this._proxy.$registerSignatureHelpProvider(Q,this._transformDocumentSelector(A),H),this._createDisposable(Q)}$provideSignatureHelp(M,A,D,R,H){return this._withAdapter(M,Ee,Q=>Q.provideSignatureHelp(n.URI.revive(A),D,R,H),void 0,void 0)}$releaseSignatureHelp(M,A){this._withAdapter(M,Ee,D=>D.releaseSignatureHelp(A),void 0,void 0)}registerInlayHintsProvider(M,A,D){const R=typeof D.onDidChangeInlayHints=="function"?this._nextHandle():void 0,H=this._addNewAdapter(new Ce(this._documents,this._commands.converter,D,this._logService,M),M);this._proxy.$registerInlayHintsProvider(H,this._transformDocumentSelector(A),typeof D.resolveInlayHint=="function",R);let Q=this._createDisposable(H);if(R!==void 0){const te=D.onDidChangeInlayHints(de=>this._proxy.$emitInlayHintsEvent(R));Q=C.Disposable.from(Q,te)}return Q}$provideInlayHints(M,A,D,R){return this._withAdapter(M,Ce,H=>H.provideInlayHints(n.URI.revive(A),D,R),void 0,R)}$resolveInlayHint(M,A,D){return this._withAdapter(M,Ce,R=>R.resolveInlayHint(A,D),void 0,D)}$releaseInlayHints(M,A){this._withAdapter(M,Ce,D=>D.releaseHints(A),void 0,void 0)}registerDocumentLinkProvider(M,A,D){const R=this._addNewAdapter(new Pe(this._documents,D),M);return this._proxy.$registerDocumentLinkProvider(R,this._transformDocumentSelector(A),typeof D.resolveDocumentLink=="function"),this._createDisposable(R)}$provideDocumentLinks(M,A,D){return this._withAdapter(M,Pe,R=>R.provideLinks(n.URI.revive(A),D),void 0,void 0)}$resolveDocumentLink(M,A,D){return this._withAdapter(M,Pe,R=>R.resolveLink(A,D),void 0,void 0)}$releaseDocumentLinks(M,A){this._withAdapter(M,Pe,D=>D.releaseLinks(A),void 0,void 0)}registerColorProvider(M,A,D){const R=this._addNewAdapter(new Be(this._documents,D),M);return this._proxy.$registerDocumentColorProvider(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideDocumentColors(M,A,D){return this._withAdapter(M,Be,R=>R.provideColors(n.URI.revive(A),D),[],void 0)}$provideColorPresentations(M,A,D,R){return this._withAdapter(M,Be,H=>H.provideColorPresentations(n.URI.revive(A),D,R),void 0,void 0)}registerFoldingRangeProvider(M,A,D){const R=this._nextHandle(),H=typeof D.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(R,new mt(new je(this._documents,D),M)),this._proxy.$registerFoldingRangeProvider(R,this._transformDocumentSelector(A),H);let Q=this._createDisposable(R);if(H!==void 0){const te=D.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(H));Q=C.Disposable.from(Q,te)}return Q}$provideFoldingRanges(M,A,D,R){return this._withAdapter(M,je,H=>H.provideFoldingRanges(n.URI.revive(A),D,R),void 0,void 0)}registerSelectionRangeProvider(M,A,D){const R=this._addNewAdapter(new tt(this._documents,D,this._logService),M);return this._proxy.$registerSelectionRangeProvider(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$provideSelectionRanges(M,A,D,R){return this._withAdapter(M,tt,H=>H.provideSelectionRanges(n.URI.revive(A),D,R),[],R)}registerCallHierarchyProvider(M,A,D){const R=this._addNewAdapter(new Ge(this._documents,D),M);return this._proxy.$registerCallHierarchyProvider(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$prepareCallHierarchy(M,A,D,R){return this._withAdapter(M,Ge,H=>Promise.resolve(H.prepareSession(n.URI.revive(A),D,R)),void 0,R)}$provideCallHierarchyIncomingCalls(M,A,D,R){return this._withAdapter(M,Ge,H=>H.provideCallsTo(A,D,R),void 0,R)}$provideCallHierarchyOutgoingCalls(M,A,D,R){return this._withAdapter(M,Ge,H=>H.provideCallsFrom(A,D,R),void 0,R)}$releaseCallHierarchy(M,A){this._withAdapter(M,Ge,D=>Promise.resolve(D.releaseSession(A)),void 0,void 0)}registerTypeHierarchyProvider(M,A,D){const R=this._addNewAdapter(new ot(this._documents,D),M);return this._proxy.$registerTypeHierarchyProvider(R,this._transformDocumentSelector(A)),this._createDisposable(R)}$prepareTypeHierarchy(M,A,D,R){return this._withAdapter(M,ot,H=>Promise.resolve(H.prepareSession(n.URI.revive(A),D,R)),void 0,R)}$provideTypeHierarchySupertypes(M,A,D,R){return this._withAdapter(M,ot,H=>H.provideSupertypes(A,D,R),void 0,R)}$provideTypeHierarchySubtypes(M,A,D,R){return this._withAdapter(M,ot,H=>H.provideSubtypes(A,D,R),void 0,R)}$releaseTypeHierarchy(M,A){this._withAdapter(M,ot,D=>Promise.resolve(D.releaseSession(A)),void 0,void 0)}static _serializeRegExp(M){return{pattern:M.source,flags:(0,F.regExpFlags)(M)}}static _serializeIndentationRule(M){return{decreaseIndentPattern:ve._serializeRegExp(M.decreaseIndentPattern),increaseIndentPattern:ve._serializeRegExp(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ve._serializeRegExp(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ve._serializeRegExp(M.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(M){return{beforeText:ve._serializeRegExp(M.beforeText),afterText:M.afterText?ve._serializeRegExp(M.afterText):void 0,previousLineText:M.previousLineText?ve._serializeRegExp(M.previousLineText):void 0,action:M.action}}static _serializeOnEnterRules(M){return M.map(ve._serializeOnEnterRule)}setLanguageConfiguration(M,A,D){let{wordPattern:R}=D;if(R&&(0,F.regExpLeadsToEndlessLoop)(R))throw new Error(`Invalid language configuration: wordPattern '${R}' is not allowed to match the empty string.`);R?this._documents.setWordDefinitionFor(A,R):this._documents.setWordDefinitionFor(A,void 0),D.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),D.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const H=this._nextHandle(),Q={comments:D.comments,brackets:D.brackets,wordPattern:D.wordPattern?ve._serializeRegExp(D.wordPattern):void 0,indentationRules:D.indentationRules?ve._serializeIndentationRule(D.indentationRules):void 0,onEnterRules:D.onEnterRules?ve._serializeOnEnterRules(D.onEnterRules):void 0,__electricCharacterSupport:D.__electricCharacterSupport,__characterPairSupport:D.__characterPairSupport};return this._proxy.$setLanguageConfiguration(H,A,Q),this._createDisposable(H)}$setWordDefinitions(M){for(const A of M)this._documents.setWordDefinitionFor(A.languageId,new RegExp(A.regexSource,A.regexFlags))}}e.ExtHostLanguageFeatures=ve,ve._handlePool=0}),define(me[189],ge([1,0,4,8,6,33,10,7]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(N,g,t,d){this._documents=g,this._commands=t,this._uriTransformer=d,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=N.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this._languageIds=N}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(N,g){await this._proxy.$changeLanguage(N,g);const t=this._documents.getDocumentData(N);if(!t)throw new Error(`document '${N.toString}' NOT found`);return t.document}async tokenAtPosition(N,g){const t=N.version,d=O.Position.from(g),s=await this._proxy.$tokensAtPosition(N.uri,d),a={type:_.StandardTokenType.Other,range:N.getWordRangeAtPosition(g)??new _.Range(g.line,g.character,g.line,g.character)};if(!s)return a;const l={range:O.Range.to(s.range),type:O.TokenType.to(s.type)};return!l.range.contains(g)||t!==N.version?a:l}createLanguageStatusItem(N,g,t){const d=this._handlePool++,s=this._proxy,a=this._ids,l=`${N.identifier.value}/${g}`;if(a.has(l))throw new Error(`LanguageStatusItem with id '${g}' ALREADY exists`);a.add(l);const P={selector:t,id:g,name:N.displayName??N.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v,E=new F.DisposableStore;const r=()=>{v?.dispose(),v=(0,x.disposableTimeout)(()=>{E.clear(),this._proxy.$setLanguageStatus(d,{id:l,name:P.name??N.displayName??N.name,source:N.displayName??N.name,selector:O.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===_.LanguageStatusSeverity.Error?C.default.Error:P.severity===_.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:P.command&&this._commands.toInternal(P.command,E),accessibilityInfo:P.accessibilityInformation,busy:P.busy})},0)},S={dispose(){E.dispose(),v?.dispose(),s.$removeLanguageStatus(d),a.delete(l)},get id(){return P.id},get name(){return P.name},set name(i){P.name=i,r()},get selector(){return P.selector},set selector(i){P.selector=i,r()},get text(){return P.text},set text(i){P.text=i,r()},get detail(){return P.detail},set detail(i){P.detail=i,r()},get severity(){return P.severity},set severity(i){P.severity=i,r()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(i){P.accessibilityInformation=i,r()},get command(){return P.command},set command(i){P.command=i,r()},get busy(){return P.busy},set busy(i){P.busy=i,r()}};return r(),S}}e.ExtHostLanguages=y}),define(me[190],ge([1,0,9,4,27,12,5]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let F=class extends n.AbstractLoggerService{constructor(N,g){const t=new x.Emitter;super(g.logLevel,t.event);this._proxy=N.getProxy(O.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(t)}$setLevel(N){this._onDidChangeLogLevel.fire(N)}doCreateLogger(N,g,t){return new y(this._proxy,N,g,t)}};F=Te([Re(0,C.IExtHostRpcService),Re(1,_.IExtHostInitDataService)],F),e.ExtHostLoggerService=F;class y extends n.AbstractMessageLogger{constructor(N,g,t,d){super(d?.always);this.proxy=N,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.proxy.$createLogger(g,d).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(N,g){const t=[[N,g]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(N){this.proxy.$log(this.file,N)}}}),define(me[191],ge([1,0,4,9,26]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(F){return F&&F.title}let x=class{constructor(y,L){this._logService=L,this._proxy=y.getProxy(n.MainContext.MainThreadMessageService)}showMessage(y,L,N,g,t){const d={source:{identifier:y.identifier,label:y.displayName||y.name}};let s;typeof g=="string"||C(g)?s=[g,...t]:(d.modal=g?.modal,d.useCustom=g?.useCustom,d.detail=g?.detail,s=t),d.useCustom&&(0,_.checkProposedApiEnabled)(y,"resolvers");const a=[];for(let l=0;l<s.length;l++){const P=s[l];if(typeof P=="string")a.push({title:P,handle:l,isCloseAffordance:!1});else if(typeof P=="object"){let{title:v,isCloseAffordance:E}=P;a.push({title:v,isCloseAffordance:!!E,handle:l})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(L,N,d,a).then(l=>{if(typeof l=="number")return s[l]})}};x=Te([Re(1,O.ILogService)],x),e.ExtHostMessageService=x}),define(me[192],ge([1,0,21,5,90,7,22,14,13,2,56,4,8,6,37,165,87]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(E,r,S,i,T){this._textDocumentsAndEditors=S,this._textDocuments=i,this._extensionStoragePaths=T,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new x.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new O.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new O.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new O.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new O.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new O.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new O.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new O.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new N.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=E.getProxy(g.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=E.getProxy(g.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=E.getProxy(g.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const c=o.notebookEditor?.notebookUri,w=o.cell.handle,h=this._documents.get(c)?.getCell(w);if(h)return h.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(E=>E.apiEditor)}getEditorById(E){const r=this._editors.get(E);if(!r)throw new Error(`unknown text editor: ${E}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(E){for(const[r,S]of this._editors)if(S.apiEditor===E)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(E,r){const S=this._documents.get(E);if(!S&&!r)throw new Error(`NO notebook document for '${E}'`);return S}_getProviderData(E){const r=this._notebookContentProviders.get(E);if(!r)throw new Error(`NO provider for '${E}'`);return r}registerNotebookContentProvider(E,r,S,i,T){if((0,F.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:E,provider:S});let o;return S.onDidChangeNotebookContentOptions&&(o=S.onDidChangeNotebookContentOptions(()=>{const c=t.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(r,c)})),this._notebookProxy.$registerNotebookProvider({id:E.identifier,location:E.extensionLocation},r,t.NotebookDocumentContentOptions.from(i),P._convertNotebookRegistrationData(E,T)),new d.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(E,r){if(!r)return;const S=r.filenamePattern.map(i=>t.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(r.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:r.displayName,filenamePattern:S,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,r,S){const i=P._notebookStatusBarItemProviderHandlePool++,T=typeof S.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,T,r);let o;return T!==void 0&&(o=S.onDidChangeCellStatusBarItems(c=>this._notebookProxy.$emitCellStatusBarEvent(T))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,T),o&&o.dispose()})}async createNotebookDocument(E){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:E.viewType,content:E.content&&t.NotebookData.from(E.content)});return L.URI.revive(r)}async openNotebookDocument(E){const r=this._documents.get(E);if(r)return r.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(E),i=this._documents.get(L.URI.revive(S));return(0,y.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(E,r){L.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let S;typeof r=="object"?S={position:t.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(t.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:S={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(E.uri,E.notebookType,S),T=i&&this._editors.get(i)?.apiEditor;if(T)return T;throw i?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,r,S,i){const T=this._notebookStatusBarItemProviders.get(E),o=L.URI.revive(r),c=this._documents.get(o);if(!c||!T)return;const w=c.getCellFromIndex(S);if(!w)return;const f=await T.provideCellStatusBarItems(w.apiCell,i);if(!f)return;const h=new C.DisposableStore,p=this._statusBarCache.add([h]),b=(Array.isArray(f)?f:[f]).map(I=>t.NotebookStatusBarItem.from(I,this._commandsConverter,h));return{cacheId:p,items:b}}$releaseNotebookCellStatusBarItems(E){this._statusBarCache.delete(E)}registerNotebookSerializer(E,r,S,i,T){if((0,F.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,S),this._notebookProxy.$registerNotebookSerializer(o,{id:E.identifier,location:E.extensionLocation},r,t.NotebookDocumentContentOptions.from(i),P._convertNotebookRegistrationData(E,T)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(E,r,S){const i=this._notebookSerializer.get(E);if(!i)throw new Error("NO serializer found");const T=await i.deserializeNotebook(r.buffer,S);return new s.SerializableObjectWithBuffers(t.NotebookData.from(T))}async $notebookToData(E,r,S){const i=this._notebookSerializer.get(E);if(!i)throw new Error("NO serializer found");const T=await i.serializeNotebook(t.NotebookData.to(r.value),S);return n.VSBuffer.wrap(T)}async $openNotebook(E,r,S,i,T){const{provider:o}=this._getProviderData(E),c=await o.openNotebook(L.URI.revive(r),{backupId:S,untitledDocumentData:i?.buffer},T);return new s.SerializableObjectWithBuffers({metadata:c.metadata??Object.create(null),cells:c.cells.map(t.NotebookCellData.from)})}async $saveNotebook(E,r,S){const i=this.getNotebookDocument(L.URI.revive(r)),{provider:T}=this._getProviderData(E);return await T.saveNotebook(i.apiNotebook,S),!0}async $saveNotebookAs(E,r,S,i){const T=this.getNotebookDocument(L.URI.revive(r)),{provider:o}=this._getProviderData(E);return await o.saveNotebookAs(L.URI.revive(S),T.apiNotebook,i),!0}async $backupNotebook(E,r,S){const i=this.getNotebookDocument(L.URI.revive(r)),T=this._getProviderData(E),o=this._extensionStoragePaths.workspaceValue(T.extension)??this._extensionStoragePaths.globalValue(T.extension),c=String((0,_.hash)([i.uri.toString(),this._backupIdPool++])),w=L.URI.joinPath(o,c),f=await T.provider.backupNotebook(i.apiNotebook,{destination:w},S);return i.updateBackup(f),f.id}_createExtHostEditor(E,r,S){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const i=new l.ExtHostNotebookEditor(r,this._notebookEditorsProxy,E,S.visibleRanges.map(t.NotebookRange.to),S.selections.map(t.NotebookRange.to),typeof S.viewColumn=="number"?t.ViewColumn.to(S.viewColumn):void 0);this._editors.set(r,i)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const S of E.value.removedDocuments){const i=L.URI.revive(S),T=this._documents.get(i);T&&(T.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:T.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(T.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===i.toString()&&this._editors.delete(o.id)}if(E.value.addedDocuments){const S=[];for(const i of E.value.addedDocuments){const T=L.URI.revive(i.uri);if(this._documents.has(T))throw new Error(`adding EXISTING notebook ${T} `);const o=this,c=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(w){o._onDidChangeNotebookCells.fire(w)},emitCellOutputsChange(w){o._onDidChangeCellOutputs.fire(w)},emitCellMetadataChange(w){o._onDidChangeCellMetadata.fire(w)}},T,i);S.push(...i.cells.map(w=>a.ExtHostCell.asModelAddData(c.apiNotebook,w))),this._documents.get(T)?.dispose(),this._documents.set(T,c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(c.apiNotebook)}}if(E.value.addedEditors)for(const S of E.value.addedEditors){if(this._editors.has(S.id))return;const i=L.URI.revive(S.documentUri),T=this._documents.get(i);T&&this._createExtHostEditor(T,S.id,S)}const r=[];if(E.value.removedEditors)for(const S of E.value.removedEditors){const i=this._editors.get(S);i&&(this._editors.delete(S),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),r.push(i))}if(E.value.visibleEditors){this._visibleNotebookEditors=E.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const S=new Set;this._visibleNotebookEditors.forEach(i=>S.add(i.id));for(const i of this._editors.values()){const T=S.has(i.id);i._acceptVisibility(T)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this._activeNotebookEditor=void 0:E.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(me[193],ge([1,0,5,51,9,4,12,8]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(g,t){const d=y._Keys.nextId();g.$registerNotebookEditorDecorationType(d,F.NotebookDecorationRenderOptions.from(t)),this.value={key:d,dispose(){g.$removeNotebookEditorDecorationType(d)}}}}y._Keys=new O.IdGenerator("NotebookEditorDecorationType");let L=class{constructor(g,t,d){this._logService=g,this._extHostRpc=t,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new n.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new n.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(g){return new y(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),g).value}$acceptEditorPropertiesChanged(g,t){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,t);const d=this._notebooksAndEditors.getEditorById(g);t.visibleRanges&&d._acceptVisibleRanges(t.visibleRanges.ranges.map(F.NotebookRange.to)),t.selections&&d._acceptSelections(t.selections.selections.map(F.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const t in g)this._notebooksAndEditors.getEditorById(t)._acceptViewColumn(F.ViewColumn.to(g[t]))}};L=Te([Re(0,_.ILogService),Re(1,x.IExtHostRpcService)],L),e.ExtHostNotebookEditors=L}),define(me[194],ge([1,0,16,10,20,5,7,22,2,23,9,4,38,8,6,59,158,26,37]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let E=class{constructor(c,w,f,h,p){this._initData=w,this._extHostNotebook=f,this._commands=h,this._logService=p,this._activeExecutions=new F.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new C.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=c.getProxy(g.MainContext.MainThreadNotebookKernels);const m=new t.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new t.ApiCommandArgument("options","Select kernel options",b=>!0,b=>{if(b&&"notebookEditor"in b&&"id"in b){const I=this._extHostNotebook.getIdByEditor(b.notebookEditor);return{id:b.id,extension:b.extension,notebookEditorId:I}}else if(b&&"notebookEditor"in b){const I=this._extHostNotebook.getIdByEditor(b.notebookEditor);if(I===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${b.notebookEditor.document.uri.toString()}`);return{notebookEditorId:I}}return b})],t.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(c,w,f,h,p,m){for(const he of this._kernelData.values())if(he.controller.id===w&&L.ExtensionIdentifier.equals(c.identifier,he.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const b=this._handlePool++,I=this;this._logService.trace(`NotebookController[${b}], CREATED by ${c.identifier.value}, ${w}`);const k=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${c.identifier}'`);let $=!1;const u=new x.DisposableStore,U=new C.Emitter,z=new C.Emitter,q={id:T(c,w),notebookType:f,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:h||c.identifier.value,preloads:m?m.map(d.NotebookRendererScript.from):[]};let V=p??k,j;this._proxy.$addKernel(b,q).catch(he=>{console.log(he),$=!0});let Y=0;const se=()=>{if($)return;const he=++Y;Promise.resolve().then(()=>{he===Y&&this._proxy.$updateKernel(b,q)})},le=new F.ResourceMap,re={get id(){return w},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return q.label},set label(he){q.label=he??c.displayName??c.name,se()},get detail(){return q.detail??""},set detail(he){q.detail=he,se()},get description(){return q.description??""},set description(he){q.description=he,se()},get kind(){return(0,P.checkProposedApiEnabled)(c,"notebookControllerKind"),q.kind??""},set kind(he){(0,P.checkProposedApiEnabled)(c,"notebookControllerKind"),q.kind=he,se()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(he){q.supportedLanguages=he,se()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(he){q.supportsExecutionOrder=he,se()},get rendererScripts(){return q.preloads?q.preloads.map(d.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(he){V=he??k},get interruptHandler(){return j},set interruptHandler(he){j=he,q.supportsInterrupt=Boolean(he),se()},createNotebookCellExecution(he){if($)throw new Error("notebook controller is DISPOSED");if(!le.has(he.notebook.uri))throw I._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(Ee=>Ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${he.notebook.uri.toString()}`);return I._createNotebookCellExecution(he,T(c,this.id))},dispose:()=>{$||(this._logService.trace(`NotebookController[${b}], DISPOSED`),$=!0,this._kernelData.delete(b),u.dispose(),U.dispose(),z.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(he,Ee){I._proxy.$updateNotebookPriority(b,he.uri,Ee)},onDidReceiveMessage:z.event,postMessage(he,Ee){return(0,P.checkProposedApiEnabled)(c,"notebookMessaging"),I._proxy.$postMessage(b,Ee&&I._extHostNotebook.getIdByEditor(Ee),he)},asWebviewUri(he){return(0,P.checkProposedApiEnabled)(c,"notebookMessaging"),(0,a.asWebviewUri)(he,I._initData.remote)}};return this._kernelData.set(b,{extensionId:c.identifier,controller:re,onDidReceiveMessage:z,onDidChangeSelection:U,associatedNotebooks:le}),re}$acceptNotebookAssociation(c,w,f){const h=this._kernelData.get(c);if(h){const p=this._extHostNotebook.getNotebookDocument(y.URI.revive(w));f?h.associatedNotebooks.set(p.uri,!0):h.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${c}] ASSOCIATE notebook`,p.uri.toString(),f),h.onDidChangeSelection.fire({selected:f,notebook:p.apiNotebook})}}async $executeCells(c,w,f){const h=this._kernelData.get(c);if(!h)return;const p=this._extHostNotebook.getNotebookDocument(y.URI.revive(w)),m=[];for(const b of f){const I=p.getCell(b);I&&m.push(I.apiCell)}try{this._logService.trace(`NotebookController[${c}] EXECUTE cells`,p.uri.toString(),m.length),await h.controller.executeHandler.call(h.controller,m,p.apiNotebook,h.controller)}catch(b){this._logService.error(`NotebookController[${c}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(c,w,f){const h=this._kernelData.get(c);if(!h)return;const p=this._extHostNotebook.getNotebookDocument(y.URI.revive(w));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,p.apiNotebook);else for(const m of f){const b=p.getCell(m);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,w,f){const h=this._kernelData.get(c);if(!h)return;const p=this._extHostNotebook.getEditorById(w);h.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:f}))}$cellExecutionChanged(c,w,f){const p=this._extHostNotebook.getNotebookDocument(y.URI.revive(c)).getCell(w);p&&this._onDidChangeCellExecutionState.fire({cell:p.apiCell,state:f??s.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(c,w){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!h)throw new Error("invalid cell");if(this._activeExecutions.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const p=new S(w,h,this._proxy);this._activeExecutions.set(h.uri,p);const m=p.onDidChangeState(()=>{p.state===r.Resolved&&(p.dispose(),m.dispose(),this._activeExecutions.delete(h.uri))});return p.asApiObject()}};E=Te([Re(4,N.ILogService)],E),e.ExtHostNotebookKernels=E;var r;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(r||(r={}));class S extends x.Disposable{constructor(c,w,f){super();this._cell=w,this._proxy=f,this._handle=S.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new i(10,h=>this.update(h)),this._executionOrder=w.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,c,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(c){await this._collector.addItem(c)}async update(c){const w=Array.isArray(c)?c:[c];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(w))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(c){return c.map(w=>{const f=s.NotebookCellOutput.ensureUniqueMimeTypes(w.items,!0);return f===w.items?d.NotebookCellOutput.from(w):d.NotebookCellOutput.from({items:f,id:w.id,metadata:w.metadata})})}async updateOutputs(c,w,f){const h=this.validateAndConvertOutputs((0,n.asArray)(c));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,append:f,outputs:h})}async updateOutputItems(c,w,f){return c=s.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(c),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,items:c.map(d.NotebookCellOutputItem.from),outputId:w.id,append:f})}asApiObject(){const c=this;return Object.freeze({get token(){return c._tokenSource.token},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(f){c._executionOrder=f,c.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:c._executionOrder}])},start(f){if(c._state===r.Resolved||c._state===r.Started)throw new Error("Cannot call start again");c._state=r.Started,c._onDidChangeState.fire(),c.update({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,h){if(c._state===r.Resolved)throw new Error("Cannot call resolve twice");c._state=r.Resolved,c._onDidChangeState.fire(),c._collector.flush(),c._proxy.$completeExecution(c._handle,new v.SerializableObjectWithBuffers({runEndTime:h,lastRunSuccess:f}))},clearOutput(f){return c.verifyStateForOutput(),c.updateOutputs([],f,!1)},appendOutput(f,h){return c.verifyStateForOutput(),c.updateOutputs(f,h,!0)},replaceOutput(f,h){return c.verifyStateForOutput(),c.updateOutputs(f,h,!1)},appendOutputItems(f,h){return c.verifyStateForOutput(),c.updateOutputItems(f,h,!0)},replaceOutputItems(f,h){return c.verifyStateForOutput(),c.updateOutputItems(f,h,!1)}})}}S.HANDLE=0;class i{constructor(c,w){this.delay=c,this.callback=w,this.batch=[],this.startedTimer=Date.now()}addItem(c){return this.batch.push(c),this.currentDeferred||(this.currentDeferred=new O.DeferredPromise,this.startedTimer=Date.now(),(0,O.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const c=this.currentDeferred;this.currentDeferred=void 0;const w=this.batch;return this.batch=[],this.callback(w).finally(()=>c.complete())}}function T(o,c){return`${o.identifier.value}/${c}`}}),define(me[195],ge([1,0,5,4,87,26]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class x{constructor(y,L){this._extHostNotebook=L,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(O.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,L,N){const g=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(L)?.fire({editor:g.apiEditor,message:N})}createRendererMessaging(y,L){if(!y.contributes?.notebookRenderer?.some(d=>d.id===L))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${L})`);const N=(0,C.isProposedApiEnabled)(y,"notebookEditor"),g=new WeakMap;return{onDidReceiveMessage:(d,s,a)=>{const l=N?d:P=>{const v={};g.set(v,P.editor),d({editor:v,message:P.message})};return this.getOrCreateEmitterFor(L).event(l,s,a)},postMessage:(d,s)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(d)&&([d,s]=[s,d]);const a=N?s:g.get(s),l=a&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(a);return this.proxy.$postMessage(l?.id,L,d)}}}getOrCreateEmitterFor(y){let L=this._rendererMessageEmitters.get(y);return L||(L=new n.Emitter({onLastListenerRemove:()=>{L?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,L),L)}}e.ExtHostNotebookRenderers=x}),define(me[91],ge([1,0,4,7,3,12,9,159,48,27,29,109,21]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class d extends O.Disposable{constructor(l,P,v,E){super();this.id=l,this.name=P,this.logger=v,this.proxy=E,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(l){this.append(l+`
`)}append(l){this.write(l),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,F.OutputChannelUpdateMode.Append))}clear(){const l=this.offset;this.logger.flush(),this.proxy.$update(this.id,F.OutputChannelUpdateMode.Clear,l)}replace(l){const P=this.offset;this.write(l),this.proxy.$update(this.id,F.OutputChannelUpdateMode.Replace,P),this.visible&&this.logger.flush()}show(l,P){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof l=="boolean"?l:P))}hide(){this.proxy.$close(this.id)}write(l){this.offset+=t.VSBuffer.fromString(l).byteLength,this.logger.info(l)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=d;let s=class{constructor(l,P,v,E,r){this.extHostFileSystem=v,this.extHostFileSystemInfo=E,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=l.getProxy(n.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(P.logsLocation,`output_logging_${(0,g.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.visibleChannelId=l;for(const[P,v]of this.channels)v.visible=P===this.visibleChannelId}createOutputChannel(l,P){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const v=this.doCreateOutputChannel(l,P);return v.then(E=>{this.channels.set(E.id,E),E.visible=E.id===this.visibleChannelId}),this.createExtHostOutputChannel(l,v)}async doCreateOutputChannel(l,P){const v=await this.createOutputDirectory(),E=this.extHostFileSystemInfo.extUri.joinPath(v,`${this.namePool++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(E,{always:!0,donotRotate:!0,donotUseFormatters:!0}),S=await this.proxy.$register(l,!1,E,P.identifier.value);return new d(S,l,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(l,P){let v=!1;const E=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return l},append(r){E(),P.then(S=>S.append(r))},appendLine(r){E(),P.then(S=>S.appendLine(r))},clear(){E(),P.then(r=>r.clear())},replace(r){E(),P.then(S=>S.replace(r))},show(r,S){E(),P.then(i=>i.show(r,S))},hide(){E(),P.then(r=>r.hide())},dispose(){v=!0,P.then(r=>r.dispose())}}}};s=Te([Re(0,C.IExtHostRpcService),Re(1,L.IExtHostInitDataService),Re(2,y.IExtHostConsumerFileSystem),Re(3,N.IExtHostFileSystemInfo),Re(4,x.ILoggerService)],s),e.ExtHostOutputService=s,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(me[196],ge([1,0,10,20,5,7,4,2,6,15,16,33,55]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(s,a,l){const P=s.getProxy(x.MainContext.MainThreadQuickOpen);class v{constructor(f,h){this._sessions=new Map,this._instances=0,this._workspace=f,this._commands=h}showQuickPick(f,h,p=O.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(f),b=++this._instances,I=P.$show(b,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},p),k={},$=I.then(()=>k);return Promise.race([$,m]).then(u=>{if(u!==k)return m.then(U=>{const z=[];for(let q=0;q<U.length;q++){const V=U[q];typeof V=="string"?z.push({label:V,handle:q}):V.kind===y.QuickPickItemKind.Separator?z.push({type:"separator",label:V.label}):z.push({label:V.label,description:V.description,detail:V.detail,picked:V.picked,alwaysShow:V.alwaysShow,handle:q})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{h.onDidSelectItem(U[q])}),P.$setItems(b,z),I.then(q=>{if(typeof q=="number")return U[q];if(Array.isArray(q))return q.map(V=>U[V])})})}).then(void 0,u=>{if(!(0,L.isCancellationError)(u))return P.$setError(b,u),Promise.reject(u)})}$onItemSelected(f){this._onDidSelectItem&&this._onDidSelectItem(f)}showInput(f,h=O.CancellationToken.None){return this._validateInput=f?f.validateInput:void 0,P.$input(f,typeof this._validateInput=="function",h).then(void 0,p=>{if(!(0,L.isCancellationError)(p))return Promise.reject(p)})}$validateInput(f){return this._validateInput?(0,n.asPromise)(()=>this._validateInput(f)):Promise.resolve(void 0)}async showWorkspaceFolderPick(f,h=O.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!p)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(b=>b.uri.toString()===p.uri.toString())}createQuickPick(f){const h=new o(f,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(f){const h=new c(f,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(f,h){const p=this._sessions.get(f);p&&p._fireDidChangeValue(h)}$onDidAccept(f){const h=this._sessions.get(f);h&&h._fireDidAccept()}$onDidChangeActive(f,h){const p=this._sessions.get(f);p instanceof o&&p._fireDidChangeActive(h)}$onDidChangeSelection(f,h){const p=this._sessions.get(f);p instanceof o&&p._fireDidChangeSelection(h)}$onDidTriggerButton(f,h){const p=this._sessions.get(f);p&&p._fireDidTriggerButton(h)}$onDidTriggerItemButton(f,h,p){const m=this._sessions.get(f);m instanceof o&&m._fireDidTriggerItemButton(h,p)}$onDidHide(f){const h=this._sessions.get(f);h&&h._fireDidHide()}}class E{constructor(f,h){this._extensionId=f,this._onDidDispose=h,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(f){this._title=f,this.update({title:f})}get step(){return this._steps}set step(f){this._steps=f,this.update({step:f})}get totalSteps(){return this._totalSteps}set totalSteps(f){this._totalSteps=f,this.update({totalSteps:f})}get enabled(){return this._enabled}set enabled(f){this._enabled=f,this.update({enabled:f})}get busy(){return this._busy}set busy(f){this._busy=f,this.update({busy:f})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(f){this._ignoreFocusOut=f,this.update({ignoreFocusOut:f})}get value(){return this._value}set value(f){this._value=f,this.update({value:f})}get placeholder(){return this._placeholder}set placeholder(f){this._placeholder=f,this.update({placeholder:f})}get buttons(){return this._buttons}set buttons(f){this._buttons=f.slice(),this._handlesToButtons.clear(),f.forEach((h,p)=>{const m=h===y.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(m,h)}),this.update({buttons:f.map((h,p)=>({...T(h),tooltip:h.tooltip,handle:h===y.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(f){this._value=f,this._onDidChangeValueEmitter.fire(f)}_fireDidTriggerButton(f){const h=this._handlesToButtons.get(f);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(f){if(!this._disposed){for(const h of Object.keys(f)){const p=f[h];this._pendingUpdate[h]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function r(w){if(w instanceof y.ThemeIcon)return{id:w.id};const f=i(w),h=S(w);return{dark:typeof f=="string"?F.URI.file(f):f,light:typeof h=="string"?F.URI.file(h):h}}function S(w){return typeof w=="object"&&"light"in w?w.light:w}function i(w){return typeof w=="object"&&"dark"in w?w.dark:w}function T(w){const f=r(w.iconPath);let h,p;return"id"in f?p=t.ThemeIcon.asClassName(f):h=f,{iconPath:h,iconClass:p}}class o extends E{constructor(f,h){super(f.identifier,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(f){this._items=f.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),f.forEach((p,m)=>{this._handlesToItems.set(m,p),this._itemsToHandles.set(p,m)});const h=[];for(let p=0;p<f.length;p++){const m=f[p];m.kind===y.QuickPickItemKind.Separator?h.push({type:"separator",label:m.label}):h.push({handle:p,label:m.label,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons?.map((b,I)=>({...T(b),tooltip:b.tooltip,handle:I}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(f){this._canSelectMany=f,this.update({canSelectMany:f})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(f){this._matchOnDescription=f,this.update({matchOnDescription:f})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(f){this._matchOnDetail=f,this.update({matchOnDetail:f})}get sortByLabel(){return this._sortByLabel}set sortByLabel(f){this._sortByLabel=f,this.update({sortByLabel:f})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(f){this._keepScrollPosition=f,this.update({keepScrollPosition:f})}get activeItems(){return this._activeItems}set activeItems(f){this._activeItems=f.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(f){this._selectedItems=f.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(f){const h=(0,N.coalesce)(f.map(p=>this._handlesToItems.get(p)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(f){const h=(0,N.coalesce)(f.map(p=>this._handlesToItems.get(p)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(f,h){const p=this._handlesToItems.get(f);if(!p||!p.buttons||!p.buttons.length)return;const m=p.buttons[h];m&&this._onDidTriggerItemButtonEmitter.fire({button:m,item:p})}}class c extends E{constructor(f,h){super(f,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(f){this._password=f,this.update({password:f})}get prompt(){return this._prompt}set prompt(f){this._prompt=f,this.update({prompt:f})}get validationMessage(){return this._validationMessage}set validationMessage(f){this._validationMessage=f,this.update({validationMessage:f,severity:f?g.default.Error:g.default.Ignore})}}return new v(a,l)}e.createExtHostQuickOpen=d});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[197],ge([1,0,2,5,50,7,10,4,16,104,9,23,55,8,26]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s){"use strict";var a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function P(p){if(p)return typeof p.iconPath=="string"?n.URI.file(p.iconPath):n.URI.isUri(p.iconPath)||t.ThemeIcon.isThemeIcon(p.iconPath)?p.iconPath:void 0}function v(p,m){if(!p.iconPath&&!m.iconPath)return 0;if(p.iconPath){if(!m.iconPath)return 1}else return-1;const b=typeof p.iconPath=="string"?p.iconPath:n.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id,I=typeof m.iconPath=="string"?m.iconPath:n.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,L.comparePaths)(b,I)}function E(p,m){let b=0;if(p.strikeThrough!==m.strikeThrough)return p.strikeThrough?1:-1;if(p.faded!==m.faded)return p.faded?1:-1;if(p.tooltip!==m.tooltip)return(p.tooltip||"").localeCompare(m.tooltip||"");if(b=v(p,m),b!==0)return b;if(p.light&&m.light)b=v(p.light,m.light);else{if(p.light)return 1;if(m.light)return-1}if(b!==0)return b;if(p.dark&&m.dark)b=v(p.dark,m.dark);else{if(p.dark)return 1;if(m.dark)return-1}return b}function r(p,m){if(p.command!==m.command)return p.command<m.command?-1:1;if(p.title!==m.title)return p.title<m.title?-1:1;if(p.tooltip!==m.tooltip){if(p.tooltip!==void 0&&m.tooltip!==void 0)return p.tooltip<m.tooltip?-1:1;if(p.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(p.arguments===m.arguments)return 0;if(p.arguments)if(m.arguments){if(p.arguments.length!==m.arguments.length)return p.arguments.length-m.arguments.length}else return 1;else return-1;for(let b=0;b<p.arguments.length;b++){const I=p.arguments[b],k=m.arguments[b];if(I!==k)return I<k?-1:1}return 0}function S(p,m){let b=(0,L.comparePaths)(p.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(b!==0)return b;if(p.command&&m.command)b=r(p.command,m.command);else{if(p.command)return 1;if(m.command)return-1}if(b!==0)return b;if(p.decorations&&m.decorations)b=E(p.decorations,m.decorations);else{if(p.decorations)return 1;if(m.decorations)return-1}return b}function i(p,m){for(let b=0;b<p.length;b++)if(p[b]!==m[b])return!1;return!0}function T(p,m){return p.command===m.command&&p.title===m.title&&p.tooltip===m.tooltip&&(p.arguments&&m.arguments?i(p.arguments,m.arguments):p.arguments===m.arguments)}function o(p,m){return(0,y.equals)(p,m,T)}class c{constructor(m,b,I){this._extension=m,this._sourceControlHandle=I,a.set(this,void 0),this._value="",this._onDidChange=new O.Emitter,this._placeholder="",this._visible=!0,ze(this,a,b,"f")}get value(){return this._value}set value(m){m=m??"",we(this,a,"f").$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){we(this,a,"f").$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,we(this,a,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,we(this,a,"f").$setInputBoxVisibility(this._sourceControlHandle,m))}showValidationMessage(m,b){(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),we(this,a,"f").$showValidationMessage(this._sourceControlHandle,m,b)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=c,a=new WeakMap;class w{constructor(m,b,I,k,$){this._proxy=m,this._commands=b,this._sourceControlHandle=I,this._id=k,this._label=$,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new O.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new O.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=w._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,b){const I=this._resourceStatesCommandsMap.get(m);return I?(0,x.asPromise)(()=>this._commands.executeCommand(I.command,...I.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(S),I=(0,y.sortedDiff)(this._resourceSnapshot,m,S).map(u=>{const U=u.toInsert.map(z=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,z);const V=z.resourceUri;let j;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const je=new C.DisposableStore;j=this._commands.converter.toInternal(z.command,je),this._resourceStatesDisposablesMap.set(q,je)}else this._resourceStatesCommandsMap.set(q,z.command);const Y=P(z.decorations),se=z.decorations&&P(z.decorations.light)||Y,le=z.decorations&&P(z.decorations.dark)||Y,re=[se,le],he=z.decorations&&z.decorations.tooltip||"",Ee=z.decorations&&!!z.decorations.strikeThrough,Ce=z.decorations&&!!z.decorations.faded,Pe=z.contextValue||"";return{rawResource:[q,V,re,he,Ee,Ce,Pe,j],handle:q}});return{start:u.start,deleteCount:u.deleteCount,toInsert:U}}),k=I.map(({start:u,deleteCount:U,toInsert:z})=>[u,U,z.map(q=>q.rawResource)]),$=I.reverse();for(const{start:u,deleteCount:U,toInsert:z}of $){const q=z.map(j=>j.handle),V=this._handlesSnapshot.splice(u,U,...q);for(const j of V)this._resourceStatesMap.delete(j),this._resourceStatesCommandsMap.delete(j),this._resourceStatesDisposablesMap.get(j)?.dispose(),this._resourceStatesDisposablesMap.delete(j)}return this._resourceSnapshot=m,k}dispose(){this._disposed=!0,this._onDidDispose.fire()}}w._handlePool=0;class f{constructor(m,b,I,k,$,u){this._extension=m,this._commands=I,this._id=k,this._label=$,this._rootUri=u,l.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new O.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,ze(this,l,b,"f"),this._inputBox=new c(m,we(this,l,"f"),this.handle),we(this,l,"f").$registerSourceControl(this.handle,k,$,u)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,we(this,l,"f").$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,we(this,l,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,we(this,l,"f").$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=m;const b=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);we(this,l,"f").$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=m;const b=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),description:m.description}:void 0;we(this,l,"f").$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&o(this._statusBarCommands,m))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=m;const b=(m||[]).map(I=>this._commands.converter.toInternal(I,this._statusBarDisposables.value));we(this,l,"f").$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(m,b){const I=new w(we(this,l,"f"),this._commands,this.handle,m,b),k=O.Event.once(I.onDidDispose)(()=>this.createdResourceGroups.delete(I));return this.createdResourceGroups.set(I,k),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const m=[],b=[];for(const[I,k]of this.createdResourceGroups){k.dispose();const $=I.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(I),this.eventuallyUpdateResourceStates()});O.Event.once(I.onDidDispose)(()=>{this.updatedResourceGroups.delete(I),$.dispose(),this._groups.delete(I.handle),we(this,l,"f").$unregisterGroup(this.handle,I.handle)}),m.push([I.handle,I.id,I.label,I.features]);const u=I._takeResourceStateSnapshot();u.length>0&&b.push([I.handle,u]),this._groups.set(I.handle,I)}we(this,l,"f").$registerGroups(this.handle,m,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(b=>{const I=b._takeResourceStateSnapshot();I.length!==0&&m.push([b.handle,I])}),m.length>0&&we(this,l,"f").$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),we(this,l,"f").$unregisterSourceControl(this.handle)}}l=new WeakMap,f._handlePool=0,Te([(0,_.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),Te([(0,_.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let h=class Vi{constructor(m,b,I){this._commands=b,this.logService=I,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new O.Emitter,this._proxy=m.getProxy(F.MainContext.MainThreadSCM),this._telemetry=m.getProxy(F.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const $=this._sourceControls.get(k.sourceControlHandle);if(!$)return k;const u=$.getResourceGroup(k.groupHandle);return u?u.getResourceState(k.handle):k}else if(k&&k.$mid===4){const $=this._sourceControls.get(k.sourceControlHandle);return $?$.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const $=this._sourceControls.get(k.handle);return $||k}return k}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,b,I,k){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,b,I,k),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const $=Vi._handlePool++,u=new f(m,this._proxy,this._commands,b,I,k);this._sourceControls.set($,u);const U=this._sourceControlsByExtension.get(g.ExtensionIdentifier.toKey(m.identifier))||[];return U.push(u),this._sourceControlsByExtension.set(g.ExtensionIdentifier.toKey(m.identifier),U),u}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const b=this._sourceControlsByExtension.get(g.ExtensionIdentifier.toKey(m.identifier)),I=b&&b[b.length-1];return I&&I.inputBox}$provideOriginalResource(m,b,I){const k=n.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,k.toString());const $=this._sourceControls.get(m);return!$||!$.quickDiffProvider||!$.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,x.asPromise)(()=>$.quickDiffProvider.provideOriginalResource(k,I)).then(u=>u||null)}$onInputBoxValueChange(m,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const I=this._sourceControls.get(m);return I&&I.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(m,b,I,k){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,b,I);const $=this._sourceControls.get(m);if(!$)return Promise.resolve(void 0);const u=$.getResourceGroup(b);return u?u.$executeResourceCommand(I,k):Promise.resolve(void 0)}$validateInput(m,b,I){this.logService.trace("ExtHostSCM#$validateInput",m);const k=this._sourceControls.get(m);return!k||!k.inputBox.validateInput?Promise.resolve(void 0):(0,x.asPromise)(()=>k.inputBox.validateInput(b,I)).then($=>{if(!$)return Promise.resolve(void 0);const u=d.MarkdownString.fromStrict($.message);return u?Promise.resolve([u,$.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};h._handlePool=0,h=Te([Re(2,N.ILogService)],h),e.ExtHostSCM=h});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[198],ge([1,0,6,4,121,7,8,13]),function(Z,e,n,O,_,C,x,F){"use strict";var y,L;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(s,a,l,P,v=n.StatusBarAlignment.Left,E){y.set(this,void 0),L.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,ze(this,y,s,"f"),ze(this,L,a,"f"),this._entryId=N.ID_GEN++,this._extension=l,this._id=P,this._alignment=v,this._priority=this.validatePriority(E)}validatePriority(s){if(!!(0,F.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!N.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:we(this,L,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:we(this,L,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,we(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let a;this._name?a=this._name:a=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=N.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=this._tooltip?x.MarkdownString.fromStrict(this._tooltip):void 0;we(this,y,"f").$setEntry(this._entryId,s,a,this._text,P,this._command?.internal,l,this._backgroundColor,this._alignment===n.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=N,y=new WeakMap,L=new WeakMap,N.ID_GEN=0,N.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]);class g{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const a={message:s};return this._messages.unshift(a),this._update(),new n.Disposable(()=>{const l=this._messages.indexOf(a);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class t{constructor(s,a){this._proxy=s.getProxy(O.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new g(this)}createStatusBarEntry(s,a,l,P){return new N(this._proxy,this._commands,s,a,l,P)}setStatusBarMessage(s,a){const l=this._statusMessage.setMessage(s);let P;return typeof a=="number"?P=setTimeout(()=>l.dispose(),a):typeof a!="undefined"&&a.then(()=>l.dispose(),()=>l.dispose()),new n.Disposable(()=>{l.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=t}),define(me[64],ge([1,0,4,5,3]),function(Z,e,n,O,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(F){this._onDidChangeStorage=new O.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=F.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(F,y){this._proxy.$registerExtensionStorageKeysToSync(F,y)}initializeExtensionStorage(F,y,L){return this._proxy.$initializeExtensionStorage(F,y).then(N=>N||L)}setValue(F,y,L){return this._proxy.$setValue(F,y,L)}$acceptValue(F,y,L){this._onDidChangeStorage.fire({shared:F,key:y,value:L})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(me[65],ge([1,0,3,27,9,48,2]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let F=class{constructor(L,N,g){this._logService=N,this._extHostFileSystem=g,this._workspace=L.workspace??void 0,this._environment=L.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(t=>this._value=t)}async _getWorkspaceStorageURI(L){return x.URI.joinPath(this._environment.workspaceStorageHome,L)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const L=this._workspace.id,N=await this._getWorkspaceStorageURI(L);try{return await this._extHostFileSystem.value.stat(N),this._logService.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",N),await this._extHostFileSystem.value.createDirectory(N),await this._extHostFileSystem.value.writeFile(x.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:x.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),N}catch(g){this._logService.error("[ExtHostStorage]",g);return}}workspaceValue(L){if(this._value)return x.URI.joinPath(this._value,L.identifier.value)}globalValue(L){return x.URI.joinPath(this._environment.globalStorageHome,L.identifier.value.toLowerCase())}onWillDeactivateAll(){}};F=Te([Re(0,O.IExtHostInitDataService),Re(1,_.ILogService),Re(2,C.IExtHostConsumerFileSystem)],F),e.ExtensionStoragePaths=F}),define(me[39],ge([1,0,5,4,3,2,12,7,6,122,15,161,20,34,141,55,13,10]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class v{constructor(f,h,p,m){this._proxy=f,this._id=h,this._creationOptions=p,this._name=m,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(I=>this._pidPromiseComplete=I);const b=this;this.value={get name(){return b._name||""},get processId(){return b._pidPromise},get creationOptions(){return b._creationOptions},get exitStatus(){return b._exitStatus},get state(){return b._state},sendText(I,k=!0){b._checkDisposed(),b._proxy.$sendText(b._id,I,k)},show(I){b._checkDisposed(),b._proxy.$show(b._id,I)},hide(){b._checkDisposed(),b._proxy.$hide(b._id)},dispose(){b._disposed||(b._disposed=!0,b._proxy.$dispose(b._id))},get dimensions(){if(!(b._cols===void 0||b._rows===void 0))return{columns:b._cols,rows:b._rows}}}}async create(f,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,l.withNullAsUndefined)(f.shellPath),shellArgs:(0,l.withNullAsUndefined)(f.shellArgs),cwd:(0,l.withNullAsUndefined)(f.cwd),env:(0,l.withNullAsUndefined)(f.env),icon:(0,l.withNullAsUndefined)(o(f.iconPath)),color:a.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,l.withNullAsUndefined)(f.message),strictEnv:(0,l.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,l.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,l.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,l.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(f.location,h?.resolvedExtHostIdentifier),disablePersistence:(0,l.withNullAsUndefined)(f.disablePersistence)})}async createExtensionTerminal(f,h,p,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:a.ThemeColor.isThemeColor(m)?m.id:void 0,location:this._serializeParentTerminal(f,h),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,h){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in f?{viewColumn:f.viewColumn,preserveFocus:f.preserveFocus}:void 0:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,h){return f===this._cols&&h===this._rows||f===0||h===0?!1:(this._cols=f,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=v;class E{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new n.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new n.Emitter,this._onDidChangeProperty=new n.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new n.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput?.(f)}resize(f,h){this._pty.setDimensions?.({columns:f,rows:h})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(f||void 0),f&&this._pty.setDimensions?.(f),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let r=1,S=class extends F.Disposable{constructor(f,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new n.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new n.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new n.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new n.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new n.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=h.getProxy(O.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new n.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[p,m]of this._terminalProcesses)m.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,h){const p=new v(this._proxy,(0,d.generateUuid)(),f,f.name),m=new E(f.pty);return p.createExtensionTerminal(f.location,this._serializeParentTerminal(f,h).resolvedExtHostIdentifier,o(f.iconPath),c(f.color)).then(b=>{const I=this._setupExtHostProcessListeners(b,m);this._terminalProcessDisposables[b]=I}),this._terminals.push(p),p.value}_serializeParentTerminal(f,h){if(h=h||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const p=f.location.parentTerminal;if(p){const m=this._terminals.find(b=>b.value===p);m&&(h.resolvedExtHostIdentifier=m._id)}}else f.location&&typeof f.location!="object"?h.location=f.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(f,h){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const m=new E(h),b=this._setupExtHostProcessListeners(f,m);this._terminalProcessDisposables[f]=b}async $acceptActiveTerminalChanged(f){const h=this._activeTerminal;if(f===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(f);p&&(this._activeTerminal=p,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,h){const p=this._getTerminalById(f);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:h})}async $acceptTerminalDimensions(f,h,p){const m=this._getTerminalById(f);m&&m.setDimensions(h,p)&&this._onDidChangeTerminalDimensions.fire({terminal:m.value,dimensions:m.value.dimensions})}async $acceptTerminalMaximumDimensions(f,h,p){this._terminalProcesses.get(f)?.resize(h,p)}async $acceptTerminalTitleChange(f,h){const p=this._getTerminalById(f);p&&(p.name=h)}async $acceptTerminalClosed(f,h){const p=this._getTerminalObjectIndexById(this._terminals,f);if(p!==null){const m=this._terminals.splice(p,1)[0];m.setExitCode(h),this._onDidCloseTerminal.fire(m.value)}}$acceptTerminalOpened(f,h,p,m){if(h){const k=this._getTerminalObjectIndexById(this._terminals,h);if(k!==null){this._terminals[k]._id=f,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const b={name:m.name,shellPath:m.executable,shellArgs:m.args,cwd:typeof m.cwd=="string"?m.cwd:C.URI.revive(m.cwd),env:m.env,hideFromUser:m.hideFromUser},I=new v(this._proxy,f,b,p);this._terminals.push(I),this._onDidOpenTerminal.fire(I.value),I.isOpen=!0}async $acceptTerminalProcessId(f,h){const p=this._getTerminalById(f);p&&p._setProcessId(h)}async $startExtensionTerminal(f,h){const p=this._getTerminalById(f);if(!p)return{message:(0,L.localize)(0,null,f)};p.isOpen||await new Promise(b=>{const I=this.onDidOpenTerminal(async k=>{k===p.value&&(I.dispose(),b())})});const m=this._terminalProcesses.get(f);m?m.startSendingEvents(h):this._extensionTerminalAwaitingStart[f]={initialDimensions:h}}_setupExtHostProcessListeners(f,h){const p=new F.DisposableStore;p.add(h.onProcessReady(b=>this._proxy.$sendProcessReady(f,b.pid,b.cwd))),p.add(h.onDidChangeProperty(b=>this._proxy.$sendProcessProperty(f,b))),this._bufferer.startBuffering(f,h.onProcessData),p.add(h.onProcessExit(b=>this._onProcessExit(f,b))),this._terminalProcesses.set(f,h);const m=this._extensionTerminalAwaitingStart[f];return m&&h instanceof E&&(h.startSendingEvents(m.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),p}$acceptProcessAckDataEvent(f,h){this._terminalProcesses.get(f)?.acknowledgeDataEvent(h)}$acceptProcessInput(f,h){this._terminalProcesses.get(f)?.input(h)}$acceptTerminalInteraction(f){const h=this._getTerminalById(f);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(f,h,p){try{this._terminalProcesses.get(f)?.resize(h,p)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(f,h){this._terminalProcesses.get(f)?.shutdown(h)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(f,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(h=>this._proxy.$sendProcessProperty(f,{type:"cwd",value:h}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,h,p){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,p),this._proxy.$registerProfileProvider(h,f.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(f,h){const p=new t.CancellationTokenSource().token;let m=await this._profileProviders.get(f)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(m&&!("options"in m)&&(m={options:m}),!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,h);return}this.createTerminalFromOptions(m.options,h)}}async $provideLinks(f,h){const p=this._getTerminalById(f);if(!p)return[];this._terminalLinkCache.delete(f);const m=this._terminalLinkCancellationSource.get(f);m&&m.dispose(!0);const b=new t.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,b);const I=[],k={terminal:p.value,line:h},$=[];for(const z of this._linkProviders)$.push(P.Promises.withAsyncBody(async q=>{b.token.onCancellationRequested(()=>q({provider:z,links:[]}));const V=await z.provideTerminalLinks(k,b.token)||[];b.token.isCancellationRequested||q({provider:z,links:V})}));const u=await Promise.all($);if(b.token.isCancellationRequested)return[];const U=new Map;for(const z of u)z&&z.links.length>0&&I.push(...z.links.map(q=>{const V={id:r++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return U.set(V.id,{provider:z.provider,link:q}),V}));return this._terminalLinkCache.set(f,U),I}$activateLink(f,h){const p=this._terminalLinkCache.get(f)?.get(h);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(f,h){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const p=this._terminalProcessDisposables[f];p&&(p.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,h)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,h){const p=this._getTerminalObjectIndexById(f,h);return p!==null?f[p]:null}_getTerminalObjectIndexById(f,h){let p=null;return f.some((m,b)=>m._id===h?(p=b,!0):!1),p}getEnvironmentVariableCollection(f){let h=this._environmentVariableCollections.get(f.identifier.value);return h||(h=new i,this._setEnvironmentVariableCollection(f.identifier.value,h)),h}_syncEnvironmentVariableCollection(f,h){const p=(0,g.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(f,h.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(f){f.forEach(h=>{const p=h[0],m=new i(h[1]);this._setEnvironmentVariableCollection(p,m)})}$acceptDefaultProfile(f,h){this._defaultProfile=f,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(f,h){this._environmentVariableCollections.set(f,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,h)})}};S=Te([Re(1,x.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class i{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new n.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,h){this._setIfDiffers(f,{value:h,type:y.EnvironmentVariableMutatorType.Replace})}append(f,h){this._setIfDiffers(f,{value:h,type:y.EnvironmentVariableMutatorType.Append})}prepend(f,h){this._setIfDiffers(f,{value:h,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,h){const p=this.map.get(f);(!p||p.value!==h.value||p.type!==h.type)&&(this.map.set(f,h),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,h){this.map.forEach((p,m)=>f.call(h,m,p,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let T=class extends S{constructor(f){super(!1,f)}createTerminal(f,h,p){throw new N.NotSupportedError}createTerminalFromOptions(f,h){throw new N.NotSupportedError}};T=Te([Re(0,x.IExtHostRpcService)],T),e.WorkerExtHostTerminalService=T;function o(w){if(!(!w||typeof w=="string"))return"id"in w?{id:w.id,color:w.color}:w}function c(w){return a.ThemeColor.isThemeColor(w)?w:void 0}});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[199],ge([1,0,16,21,20,5,230,90,7,25,13,34,4,12,46,8,6,167,82,60]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let S=class{constructor(k,$){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(t.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new T(this.proxy),$.registerArgumentProcessor({processArgument:u=>u?.$mid===13?a.TestItem.toItemFromContext(u):u})}createTestController(k,$,u){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const U=new y.DisposableStore,z=U.add(new P.SingleUseTestCollection(k));z.root.label=$;const q=new Map,V=this.proxy,j={items:z.root.children,get label(){return $},set label(se){$=se,z.root.label=se,V.$updateController(k,{label:$})},get refreshHandler(){return u},set refreshHandler(se){u=se,V.$updateController(k,{canRefresh:!!se})},get id(){return k},createRunProfile:(se,le,re,he,Ee)=>{let Ce=(0,F.hash)(se);for(;q.has(Ce);)Ce++;const Pe=new m(this.proxy,k,Ce,se,le,re,he,Ee);return q.set(Ce,Pe),Pe},createTestItem(se,le,re){return new s.TestItemImpl(k,se,le,re)},createTestRun:(se,le,re=!0)=>this.runTracker.createTestRun(k,z,se,le,re),set resolveHandler(se){z.resolveHandler=se},get resolveHandler(){return z.resolveHandler},dispose:()=>{U.dispose()}};V.$registerTestController(k,$,!!u),U.add((0,y.toDisposable)(()=>V.$unregisterTestController(k)));const Y={controller:j,collection:z,profiles:q};return this.controllers.set(k,Y),U.add((0,y.toDisposable)(()=>this.controllers.delete(k))),U.add(z.onDidGenerateDiff(se=>V.$publishDiff(k,se))),j}createTestObserver(){return this.observer.checkout()}async runTests(k,$=_.CancellationToken.None){const u=o(k);if(!u)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(u.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:k.include?.map(z=>z.id)??[U.collection.root.id],profileGroup:b[u.kind],profileId:u.profileId,controllerId:u.controllerId}],exclude:k.exclude?.map(z=>z.id)},$)}$provideFileCoverage(k,$,u){return(0,n.mapFind)(this.runTracker.trackers,z=>z.id===k?z.getCoverage($):void 0)?.provideFileCoverage(u)??Promise.resolve([])}$resolveFileCoverage(k,$,u,U){return(0,n.mapFind)(this.runTracker.trackers,q=>q.id===k?q.getCoverage($):void 0)?.resolveFileCoverage(u,U)??Promise.resolve([])}$configureRunProfile(k,$){this.controllers.get(k)?.profiles.get($)?.configureHandler?.()}async $refreshTests(k,$){await this.controllers.get(k)?.controller.refreshHandler?.($)}$publishTestResults(k){this.results=Object.freeze(k.map($=>(0,L.deepFreeze)(a.TestResults.to($))).concat(this.results).sort(($,u)=>u.completedAt-$.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,$){const u=this.controllers.get(E.TestId.fromString(k).controllerId)?.collection;u&&(await u.expand(k,$<0?1/0:$),u.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,$){const u=this.controllers.get(k.controllerId);if(!u)return;const{collection:U,profiles:z}=u,q=z.get(k.profileId);if(!q)return;const V=k.testIds.map(le=>U.tree.get(le)).filter(N.isDefined),j=k.excludeExtIds.map(le=>u.collection.tree.get(le)).filter(N.isDefined).filter(le=>V.some(re=>re.fullId.compare(le.fullId)===2));if(!V.length)return;const Y=new l.TestRunRequest(V.some(le=>le.actual instanceof s.TestItemRootImpl)?void 0:V.map(le=>le.actual),j.map(le=>le.actual),q),se=this.runTracker.prepareForMainThreadTestRun(Y,c.fromInternal(k,u.collection),$);try{await q.runHandler(Y,$)}finally{se.isRunning&&!$.isCancellationRequested&&await C.Event.toPromise(se.onEnd),se.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};S=Te([Re(0,d.IExtHostRpcService)],S),e.ExtHostTesting=S;class i extends y.Disposable{constructor(k,$,u){super();this.dto=k,this.proxy=$,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(u)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const $=this.dto.id,u=this.dto.controllerId,U=(0,g.generateUuid)(),z=new w(this.proxy,$,U),q=se=>(le,...re)=>{if(j){console.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(le)||(this.ensureTestIsKnown(le),se(le,...re))},V=(se,le)=>{const re=le instanceof Array?le.map(a.TestMessage.from):[a.TestMessage.from(le)];if(se.uri&&se.range){const he={range:a.Range.from(se.range),uri:se.uri};for(const Ee of re)Ee.location=Ee.location||he}this.proxy.$appendTestMessagesInRun($,U,E.TestId.fromExtHostTestItem(se,u).toString(),re)};let j=!1;const Y={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return z.coverageProvider},set coverageProvider(se){z.coverageProvider=se},enqueued:q(se=>{this.proxy.$updateTestStateInRun($,U,E.TestId.fromExtHostTestItem(se,u).toString(),1)}),skipped:q(se=>{this.proxy.$updateTestStateInRun($,U,E.TestId.fromExtHostTestItem(se,u).toString(),5)}),started:q(se=>{this.proxy.$updateTestStateInRun($,U,E.TestId.fromExtHostTestItem(se,u).toString(),2)}),errored:q((se,le,re)=>{V(se,le),this.proxy.$updateTestStateInRun($,U,E.TestId.fromExtHostTestItem(se,u).toString(),6,re)}),failed:q((se,le,re)=>{V(se,le),this.proxy.$updateTestStateInRun($,U,E.TestId.fromExtHostTestItem(se,u).toString(),4,re)}),passed:q((se,le)=>{this.proxy.$updateTestStateInRun($,U,E.TestId.fromExtHostTestItem(se,this.dto.controllerId).toString(),3,le)}),appendOutput:(se,le,re)=>{j||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun($,U,O.VSBuffer.fromString(se),le&&a.location.from(le),re&&E.TestId.fromExtHostTestItem(re,u).toString()))},end:()=>{j||(j=!0,this.proxy.$finishedTestRunTask($,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:Y,coverage:z}),this.proxy.$startedTestRunTask($,{id:U,name:k,running:!0}),Y}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof s.TestItemImpl))throw new s.InvalidTestItemError(k.id);if(this.sharedTestIds.has(E.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const $=[],u=this.dto.colllection.root;for(;;){const U=a.TestItem.from(k);if($.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),k===u))break;k=k.parent||u}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,$)}}class T{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,$,u){return this.getTracker(k,$,u)}cancelRunById(k){for(const $ of this.tracked.values())if($.id===k){$.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,$,u,U,z){const q=this.tracked.get(u);if(q)return q.createRun(U);const V=c.fromPublic(k,$,u,z),j=o(u);this.proxy.$startedExtensionTestRun({controllerId:k,profile:j&&{group:b[j.kind],id:j.profileId},exclude:u.exclude?.map(se=>se.id)??[],id:V.id,include:u.include?.map(se=>se.id)??[$.root.id],persist:z});const Y=this.getTracker(u,V);return Y.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),Y.createRun(U)}getTracker(k,$,u){const U=new i($,this.proxy,u);return this.tracked.set(k,U),U.onEnd(()=>this.tracked.delete(k)),U}}e.TestRunCoordinator=T;const o=I=>{if(!!I.profile){if(!(I.profile instanceof m))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class c{constructor(k,$,u,U,z,q){this.controllerId=k,this.id=$,this.isPersisted=z,this.colllection=q,this.includePrefix=u.map(V=>V+"\0"),this.excludePrefix=U.map(V=>V+"\0")}static fromPublic(k,$,u,U){return new c(k,(0,g.generateUuid)(),u.include?.map(z=>E.TestId.fromExtHostTestItem(z,k).toString())??[k],u.exclude?.map(z=>E.TestId.fromExtHostTestItem(z,k).toString())??[],U,$)}static fromInternal(k,$){return new c(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,$)}isIncluded(k){const $=E.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const u of this.excludePrefix)if($===u||$.startsWith(u))return!1;for(const u of this.includePrefix)if($===u||$.startsWith(u))return!0;return!1}}e.TestRunDto=c;class w{constructor(k,$,u){this.proxy=k,this.runId=$,this.taskId=u}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch($){throw this.fileCoverage=void 0,$}}async resolveFileCoverage(k,$){const u=await this.fileCoverage;let U=u?.[k];return!this._coverageProvider||!u||!U?[]:(U.detailedCoverage||(U=u[k]=await this._coverageProvider.resolveFileCoverage?.(U,$)??U),U.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class f extends v.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,a.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:$,removed:u}=this;return{get added(){return[...k].map(U=>U.revived)},get updated(){return[...$].map(U=>U.revived)},get removed(){return[...u].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,$){return{...k,revived:a.TestItem.toPlain(k.item),depth:$?$.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=h;class p{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map($=>$.revived)},dispose:(0,x.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class m{constructor(k,$,u,U,z,q,V=!1,j=void 0){this.controllerId=$,this.profileId=u,this._label=U,this.kind=z,this.runHandler=q,this._isDefault=V,this._tag=j,r.set(this,void 0),ze(this,r,k,"f");const Y=b[z];if(typeof Y!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);we(this,r,"f").$publishTestRunProfile({profileId:u,controllerId:$,tag:j?a.TestTag.namespace(this.controllerId,j.id):null,label:U,group:Y,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,we(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,we(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,we(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?a.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,we(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){we(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=m,r=new WeakMap;const b={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(me[200],ge([1,0,5,16,4,88,8,6]),function(Z,e,n,O,_,C,x,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(N,g){this._extHostDocumentsAndEditors=g,this._onDidChangeTextEditorSelection=new n.Emitter,this._onDidChangeTextEditorOptions=new n.Emitter,this._onDidChangeTextEditorVisibleRanges=new n.Emitter,this._onDidChangeTextEditorViewColumn=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=N.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(t=>this._onDidChangeVisibleTextEditors.fire(t)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(t=>this._onDidChangeActiveTextEditor.fire(t))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(N){const g=this._extHostDocumentsAndEditors.allEditors();return N?g:g.map(t=>t.value)}async showTextDocument(N,g,t){let d;typeof g=="number"?d={position:x.ViewColumn.from(g),preserveFocus:t}:typeof g=="object"?d={position:x.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:typeof g.selection=="object"?x.Range.from(g.selection):void 0,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:d={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(N.uri,d),a=s&&this._extHostDocumentsAndEditors.getEditor(s);if(a)return a.value;throw s?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,g){return new C.TextEditorDecorationType(this._proxy,N,g).value}$acceptEditorPropertiesChanged(N,g){const t=this._extHostDocumentsAndEditors.getEditor(N);if(!t)throw new Error("unknown text editor");if(g.options&&t._acceptOptions(g.options),g.selections){const d=g.selections.selections.map(x.Selection.to);t._acceptSelections(d)}if(g.visibleRanges){const d=O.coalesce(g.visibleRanges.map(x.Range.to));t._acceptVisibleRanges(d)}if(g.options&&this._onDidChangeTextEditorOptions.fire({textEditor:t.value,options:{...g.options,lineNumbers:x.TextEditorLineNumbersStyle.to(g.options.lineNumbers)}}),g.selections){const d=F.TextEditorSelectionChangeKind.fromValue(g.selections.source),s=g.selections.selections.map(x.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:t.value,selections:s,kind:d})}if(g.visibleRanges){const d=O.coalesce(g.visibleRanges.map(x.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:t.value,visibleRanges:d})}}$acceptEditorPositionData(N){for(const g in N){const t=this._extHostDocumentsAndEditors.getEditor(g);if(!t)throw new Error("Unknown text editor");const d=x.ViewColumn.to(N[g]);t.value.viewColumn!==d&&(t._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:t.value,viewColumn:d}))}}getDiffInformation(N){return Promise.resolve(this._proxy.$getDiffInformation(N))}}e.ExtHostEditors=y}),define(me[201],ge([1,0,2,3,4,7,6]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,O.createDecorator)("IExtHostTimeline");class F{constructor(N,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=N.getProxy(_.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===11){const d=t.uri===void 0?void 0:n.URI.revive(t.uri);return this._itemsBySourceAndUriMap.get(t.source)?.get(y(d))?.get(t.handle)}return t}})}async $getTimeline(N,g,t,d,s){return this._providers.get(N)?.provideTimeline(n.URI.revive(g),t,d,s)}registerTimelineProvider(N,g,t,d){const s=new C.DisposableStore,a=this.convertTimelineItem(g.id,d,s).bind(this);let l;g.onDidChange&&(l=g.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:g.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:N,onDidChange:void 0,async provideTimeline(v,E,r,S){S?.resetCache&&(s.clear(),P.get(g.id)?.clear());const i=await g.provideTimeline(v,E,r);if(i==null)return;const T=a(v,S);return{...i,source:g.id,items:i.items.map(T)}},dispose(){for(const v of P.values())v.get(g.id)?.clear();l?.dispose(),s.dispose()}})}convertTimelineItem(N,g,t){return(d,s)=>{let a;if(s?.cacheResults){let l=this._itemsBySourceAndUriMap.get(N);l===void 0&&(l=new Map,this._itemsBySourceAndUriMap.set(N,l));const P=y(d);a=l.get(P),a===void 0&&(a=new Map,l.set(P,a))}return l=>{const{iconPath:P,...v}=l,E=`${N}|${l.id??l.timestamp}`;a?.set(E,l);let r,S,i;return l.iconPath&&(P instanceof x.ThemeIcon?i={id:P.id,color:P.color}:n.URI.isUri(P)?(r=P,S=P):{light:r,dark:S}=P),{...v,id:v.id??void 0,handle:E,source:N,command:l.command?g.toInternal(l.command,t):void 0,icon:r,iconDark:S,themeIcon:i,accessibilityInformation:l.accessibilityInformation}}}}registerTimelineProviderCore(N){if(this._providers.get(N.id))throw new Error(`Timeline Provider ${N.id} already exists.`);return this._proxy.$registerTimelineProvider({id:N.id,label:N.label,scheme:N.scheme}),this._providers.set(N.id,N),(0,C.toDisposable)(()=>{for(const t of this._itemsBySourceAndUriMap.values())t.get(N.id)?.clear();this._providers.delete(N.id),this._proxy.$unregisterTimelineProvider(N.id),N.dispose()})}}e.ExtHostTimeline=F;function y(L){return L?.toString()}}),define(me[202],ge([1,0,7,11,2,4]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class x{constructor(y){this._openers=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,L,N,g){if(this._openers.has(L))throw new Error(`Opener with id '${L}' already registered`);const t=g.schemes.find(d=>!x.supportedSchemes.has(d));if(t)throw new Error(`Scheme '${t}' is not supported. Only http and https are currently supported.`);return this._openers.set(L,N),this._proxy.$registerUriOpener(L,g.schemes,y,g.label),(0,n.toDisposable)(()=>{this._openers.delete(L),this._proxy.$unregisterUriOpener(L)})}async $canOpenUri(y,L,N){const g=this._openers.get(y);if(!g)throw new Error(`Unknown opener with id: ${y}`);const t=_.URI.revive(L);return g.canOpenExternalUri(t,N)}async $openUri(y,L,N){const g=this._openers.get(y);if(!g)throw new Error(`Unknown opener id: '${y}'`);return g.openExternalUri(_.URI.revive(L.resolvedUri),{sourceUri:_.URI.revive(L.sourceUri)},N)}}e.ExtHostUriOpeners=x,x.supportedSchemes=new Set([O.Schemas.http,O.Schemas.https])}),define(me[203],ge([1,0,4,2,7,15,23]),function(Z,e,n,O,_,C,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class F{constructor(L){this.handles=new Set,this.handlers=new Map,this._proxy=L.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(L,N){if(this.handles.has(x.ExtensionIdentifier.toKey(L)))throw new Error(`Protocol handler already registered for extension ${L}`);const g=F.HandlePool++;return this.handles.add(x.ExtensionIdentifier.toKey(L)),this.handlers.set(g,N),this._proxy.$registerUriHandler(g,L),(0,_.toDisposable)(()=>{this.handles.delete(x.ExtensionIdentifier.toKey(L)),this.handlers.delete(g),this._proxy.$unregisterUriHandler(g)})}$handleExternalUri(L,N){const g=this.handlers.get(L);if(!g)return Promise.resolve(void 0);try{g.handleUri(O.URI.revive(N))}catch(t){(0,C.onUnexpectedError)(t)}return Promise.resolve(void 0)}async createAppUri(L){return O.URI.revive(await this._proxy.$createAppUri(L))}}e.ExtHostUrls=F,F.HandlePool=0});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[49],ge([1,0,5,11,2,131,151,59,4]),function(Z,e,n,O,_,C,x,F,y){"use strict";var L,N,g,t,d,s,a,l,P,v,E,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class S{constructor(p,m,b,I,k,$,u){L.set(this,void 0),N.set(this,void 0),g.set(this,void 0),t.set(this,void 0),d.set(this,void 0),s.set(this,void 0),a.set(this,""),l.set(this,void 0),P.set(this,!1),v.set(this,!1),E.set(this,!1),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new n.Emitter),this._onDidDispose=we(this,r,"f").event,ze(this,L,p,"f"),ze(this,N,m,"f"),ze(this,l,b,"f"),ze(this,t,I,"f"),ze(this,d,k,"f"),ze(this,s,$,"f"),ze(this,E,i($),"f"),ze(this,g,u,"f")}dispose(){ze(this,P,!0,"f"),we(this,r,"f").fire(),we(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return ze(this,v,!0,"f"),(0,F.asWebviewUri)(p,we(this,t,"f").remote)}get cspSource(){const p=we(this,s,"f").extensionLocation;if(p.scheme===O.Schemas.https||p.scheme===O.Schemas.http){let m=p.toString();return m.endsWith("/")||(m+="/"),m+" "+F.webviewGenericCspSource}return F.webviewGenericCspSource}get html(){return this.assertNotDisposed(),we(this,a,"f")}set html(p){this.assertNotDisposed(),we(this,a,"f")!==p&&(ze(this,a,p,"f"),!we(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(ze(this,v,!0,"f"),we(this,g,"f").report("Webview vscode-resource: uris",we(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),we(this,N,"f").$setHtml(we(this,L,"f"),p))}get options(){return this.assertNotDisposed(),we(this,l,"f")}set options(p){this.assertNotDisposed(),we(this,N,"f").$setOptions(we(this,L,"f"),c(we(this,s,"f"),we(this,d,"f"),p)),ze(this,l,p,"f")}async postMessage(p){if(we(this,P,"f"))return!1;const m=(0,x.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:we(this,E,"f")});return we(this,N,"f").$postMessage(we(this,L,"f"),m.message,...m.buffers)}assertNotDisposed(){if(we(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=S,L=new WeakMap,N=new WeakMap,g=new WeakMap,t=new WeakMap,d=new WeakMap,s=new WeakMap,a=new WeakMap,l=new WeakMap,P=new WeakMap,v=new WeakMap,E=new WeakMap,r=new WeakMap;function i(h){try{const p=(0,C.normalizeVersion)((0,C.parseVersion)(h.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class T{constructor(p,m,b,I,k){this.initData=m,this.workspace=b,this._logService=I,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=p.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(p,m,b){const I=this.getWebview(p);if(I){const{message:k}=(0,x.deserializeWebviewMessage)(m,b.value);I._onMessageEmitter.fire(k)}}$onMissingCsp(p,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,m,b){const I=new S(p,this._webviewProxy,w(m),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(p,I),I._onDidDispose(()=>{this._webviews.delete(p)}),I}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=T;function o(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=o;function c(h,p,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||f(h,p)}}e.serializeWebviewOptions=c;function w(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(p=>_.URI.from(p))}}e.reviveOptions=w;function f(h,p){return[...(p?.getWorkspaceFolders()||[]).map(m=>m.uri),h.extensionLocation]}}),define(me[204],ge([1,0,20,90,7,11,24,2,8,49,56,4,6]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(i,T){this.document=i,this._storagePath=T,this._backupCounter=1,this._edits=new N.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,T){await this.getEdit(i).undo(),T||this.disposeBackup()}async redo(i,T){await this.getEdit(i).redo(),T||this.disposeBackup()}disposeEdits(i){for(const T of i)this._edits.delete(T)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=r(this.document.uri)+this._backupCounter++;return(0,x.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const T=this._edits.get(i,0);if(!T)throw new Error("No edit found");return T}}class s{constructor(){this._documents=new Map}get(i,T){return this._documents.get(this.key(i,T))}add(i,T,o){const c=this.key(i,T.uri);if(this._documents.has(c))throw new Error(`Document already exists for viewType:${i} resource:${T.uri}`);const w=new d(T,o);return this._documents.set(c,w),w}delete(i,T){const o=this.key(i,T.uri);this._documents.delete(o)}key(i,T){return`${i}@@@${T}`}}var a;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(a||(a={}));class l{constructor(){this._providers=new Map}addTextProvider(i,T,o){return this.add(0,i,T,o)}addCustomProvider(i,T,o){return this.add(1,i,T,o)}get(i){return this._providers.get(i)}add(i,T,o,c){if(this._providers.has(T))throw new Error(`Provider for viewType:${T} already registered`);return this._providers.set(T,{type:i,extension:o,provider:c}),new t.Disposable(()=>this._providers.delete(T))}}class P{constructor(i,T,o,c,w){this._extHostDocuments=T,this._extensionStoragePaths=o,this._extHostWebview=c,this._extHostWebviewPanels=w,this._editorProviders=new l,this._documents=new s,this._proxy=i.getProxy(g.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,T,o,c){const w=new _.DisposableStore;return v(o)?(w.add(this._editorProviders.addTextProvider(T,i,o)),this._proxy.$registerTextEditorProvider((0,L.toExtensionData)(i),T,c.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,L.shouldSerializeBuffersForPostMessage)(i))):(w.add(this._editorProviders.addCustomProvider(T,i,o)),this.supportEditing(o)&&w.add(o.onDidChangeCustomDocument(f=>{const h=this.getCustomDocumentEntry(T,f.document.uri);if(E(f)){const p=h.addEdit(f);this._proxy.$onDidEdit(f.document.uri,T,p,f.label)}else this._proxy.$onContentChange(f.document.uri,T)})),this._proxy.$registerCustomEditorProvider((0,L.toExtensionData)(i),T,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,L.shouldSerializeBuffersForPostMessage)(i))),t.Disposable.from(w,new t.Disposable(()=>{this._proxy.$unregisterEditorProvider(T)}))}async $createCustomDocument(i,T,o,c,w){const f=this._editorProviders.get(T);if(!f)throw new Error(`No provider found for '${T}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${T}'`);const h=F.URI.revive(i),p=await f.provider.openCustomDocument(h,{backupId:o,untitledDocumentData:c?.buffer},w);let m;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(T,p,m),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(i,T){const o=this._editorProviders.get(T);if(!o)throw new Error(`No provider found for '${T}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${T}'`);const c=F.URI.revive(i),{document:w}=this.getCustomDocumentEntry(T,c);this._documents.delete(T,w),w.dispose()}async $resolveWebviewEditor(i,T,o,c,w,f){const h=this._editorProviders.get(o);if(!h)throw new Error(`No provider found for '${o}'`);const p=y.ViewColumn.to(w),m=this._extHostWebview.createNewWebview(T,c.webviewOptions,h.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(T,o,c.title,p,c.panelOptions,m),I=F.URI.revive(i);switch(h.type){case 1:{const{document:k}=this.getCustomDocumentEntry(o,I);return h.provider.resolveCustomEditor(k,b,f)}case 0:{const k=this._extHostDocuments.getDocument(I);return h.provider.resolveCustomTextEditor(k,b,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,T,o){this.getCustomDocumentEntry(T,i).disposeEdits(o)}async $onMoveCustomEditor(i,T,o){const c=this._editorProviders.get(o);if(!c)throw new Error(`No provider found for '${o}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const w=this._extHostWebviewPanels.getWebviewPanel(i);if(!w)throw new Error("No webview found");const f=F.URI.revive(T),h=this._extHostDocuments.getDocument(f);await c.provider.moveCustomTextEditor(h,w,n.CancellationToken.None)}async $undo(i,T,o,c){return this.getCustomDocumentEntry(T,i).undo(o,c)}async $redo(i,T,o,c){return this.getCustomDocumentEntry(T,i).redo(o,c)}async $revert(i,T,o){const c=this.getCustomDocumentEntry(T,i);await this.getCustomEditorProvider(T).revertCustomDocument(c.document,o),c.disposeBackup()}async $onSave(i,T,o){const c=this.getCustomDocumentEntry(T,i);await this.getCustomEditorProvider(T).saveCustomDocument(c.document,o),c.disposeBackup()}async $onSaveAs(i,T,o,c){const w=this.getCustomDocumentEntry(T,i);return this.getCustomEditorProvider(T).saveCustomDocumentAs(w.document,F.URI.revive(o),c)}async $backup(i,T,o){const c=this.getCustomDocumentEntry(T,i),f=await this.getCustomEditorProvider(T).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},o);return c.updateBackup(f),f.id}getCustomDocumentEntry(i,T){const o=this._documents.get(i,F.URI.revive(T));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(i){const o=this._editorProviders.get(i)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function v(S){return typeof S.resolveCustomTextEditor=="function"}function E(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function r(S){const i=S.scheme===C.Schemas.file||S.scheme===C.Schemas.untitled?S.fsPath:S.toString();return(0,O.hash)(i)+""}});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[205],ge([1,0,5,7,2,34,8,49,4,6]),function(Z,e,n,O,_,C,x,F,y,L){"use strict";var N,g,t,d,s,a,l,P,v,E,r,S,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends O.Disposable{constructor(f,h,p,m,b,I,k){super();N.set(this,void 0),g.set(this,void 0),t.set(this,void 0),d.set(this,void 0),s.set(this,void 0),a.set(this,void 0),l.set(this,void 0),P.set(this,void 0),v.set(this,!0),E.set(this,!0),r.set(this,!1),S.set(this,this._register(new n.Emitter)),this.onDidDispose=we(this,S,"f").event,i.set(this,this._register(new n.Emitter)),this.onDidChangeViewState=we(this,i,"f").event,ze(this,N,f,"f"),ze(this,g,h,"f"),ze(this,t,p,"f"),ze(this,s,I,"f"),ze(this,P,b,"f"),ze(this,a,m,"f"),ze(this,d,k,"f")}dispose(){we(this,r,"f")||(ze(this,r,!0,"f"),we(this,S,"f").fire(),we(this,g,"f").$disposeWebview(we(this,N,"f")),we(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),we(this,d,"f")}get viewType(){return this.assertNotDisposed(),we(this,t,"f")}get title(){return this.assertNotDisposed(),we(this,a,"f")}set title(f){this.assertNotDisposed(),we(this,a,"f")!==f&&(ze(this,a,f,"f"),we(this,g,"f").$setTitle(we(this,N,"f"),f))}get iconPath(){return this.assertNotDisposed(),we(this,l,"f")}set iconPath(f){this.assertNotDisposed(),we(this,l,"f")!==f&&(ze(this,l,f,"f"),we(this,g,"f").$setIconPath(we(this,N,"f"),_.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return we(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof we(this,P,"f")=="number"&&we(this,P,"f")<0))return we(this,P,"f")}get active(){return this.assertNotDisposed(),we(this,E,"f")}get visible(){return this.assertNotDisposed(),we(this,v,"f")}_updateViewState(f){we(this,r,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(ze(this,E,f.active,"f"),ze(this,v,f.visible,"f"),ze(this,P,f.viewColumn,"f"),we(this,i,"f").fire({webviewPanel:this}))}reveal(f,h){this.assertNotDisposed(),we(this,g,"f").$reveal(we(this,N,"f"),{viewColumn:typeof f=="undefined"?void 0:x.ViewColumn.from(f),preserveFocus:!!h})}assertNotDisposed(){if(we(this,r,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,g=new WeakMap,t=new WeakMap,d=new WeakMap,s=new WeakMap,a=new WeakMap,l=new WeakMap,P=new WeakMap,v=new WeakMap,E=new WeakMap,r=new WeakMap,S=new WeakMap,i=new WeakMap;class o{constructor(f,h,p){this.webviews=h,this.workspace=p,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(f,h,p,m,b={}){const I=typeof m=="object"?m.viewColumn:m,k={viewColumn:x.ViewColumn.from(I),preserveFocus:typeof m=="object"&&!!m.preserveFocus},$=(0,F.shouldSerializeBuffersForPostMessage)(f),u=o.newHandle();this._proxy.$createWebviewPanel((0,F.toExtensionData)(f),u,h,{title:p,panelOptions:c(b),webviewOptions:(0,F.serializeWebviewOptions)(f,this.workspace,b),serializeBuffersForPostMessage:$},k);const U=this.webviews.createNewWebview(u,b,f);return this.createNewWebviewPanel(u,h,p,I,b,U)}$onDidChangeWebviewPanelViewStates(f){const h=Object.keys(f);h.sort((p,m)=>{const b=f[p],I=f[m];return b.active?1:I.active?-1:+b.visible-+I.visible});for(const p of h){const m=this.getWebviewPanel(p);if(!m)continue;const b=f[p];m._updateViewState({active:b.active,visible:b.visible,viewColumn:x.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,h,p){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:p,extension:f}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,F.shouldSerializeBuffersForPostMessage)(f)}),new L.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(f,h,p,m){const b=this._serializers.get(h);if(!b)throw new Error(`No serializer found for '${h}'`);const{serializer:I,extension:k}=b,$=this.webviews.createNewWebview(f,p.webviewOptions,k),u=this.createNewWebviewPanel(f,h,p.title,m,p.panelOptions,$);await I.deserializeWebviewPanel(u,p.state)}createNewWebviewPanel(f,h,p,m,b,I){const k=new T(f,this._proxy,h,p,m,b,I);return this._webviewPanels.set(f,k),k}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=o;function c(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[206],ge([1,0,5,7,49,4,6]),function(Z,e,n,O,_,C,x){"use strict";var F,y,L,N,g,t,d,s,a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends O.Disposable{constructor(r,S,i,T,o,c){super();F.set(this,void 0),y.set(this,void 0),L.set(this,void 0),N.set(this,void 0),g.set(this,!1),t.set(this,void 0),d.set(this,void 0),s.set(this,void 0),a.set(this,this._register(new n.Emitter)),this.onDidChangeVisibility=we(this,a,"f").event,l.set(this,this._register(new n.Emitter)),this.onDidDispose=we(this,l,"f").event,ze(this,L,i,"f"),ze(this,d,T,"f"),ze(this,F,r,"f"),ze(this,y,S,"f"),ze(this,N,o,"f"),ze(this,t,c,"f")}dispose(){we(this,g,"f")||(ze(this,g,!0,"f"),we(this,l,"f").fire(),we(this,N,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),we(this,d,"f")}set title(r){this.assertNotDisposed(),we(this,d,"f")!==r&&(ze(this,d,r,"f"),we(this,y,"f").$setWebviewViewTitle(we(this,F,"f"),r))}get description(){return this.assertNotDisposed(),we(this,s,"f")}set description(r){this.assertNotDisposed(),we(this,s,"f")!==r&&(ze(this,s,r,"f"),we(this,y,"f").$setWebviewViewDescription(we(this,F,"f"),r))}get visible(){return we(this,t,"f")}get webview(){return we(this,N,"f")}get viewType(){return we(this,L,"f")}_setVisible(r){r===we(this,t,"f")||we(this,g,"f")||(ze(this,t,r,"f"),we(this,a,"f").fire())}show(r){this.assertNotDisposed(),we(this,y,"f").$show(we(this,F,"f"),!!r)}assertNotDisposed(){if(we(this,g,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,y=new WeakMap,L=new WeakMap,N=new WeakMap,g=new WeakMap,t=new WeakMap,d=new WeakMap,s=new WeakMap,a=new WeakMap,l=new WeakMap;class v{constructor(r,S){this._extHostWebview=S,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,S,i,T){if(this._viewProviders.has(S))throw new Error(`View provider for '${S}' already registered`);return this._viewProviders.set(S,{provider:i,extension:r}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(r),S,{retainContextWhenHidden:T?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new x.Disposable(()=>{this._viewProviders.delete(S),this._proxy.$unregisterWebviewViewProvider(S)})}async $resolveWebviewView(r,S,i,T,o){const c=this._viewProviders.get(S);if(!c)throw new Error(`No view provider found for '${S}'`);const{provider:w,extension:f}=c,h=this._extHostWebview.createNewWebview(r,{},f),p=new P(r,this._proxy,S,i,h,!0);this._webviewViews.set(r,p),await w.resolveWebviewView(p,{state:T},o)}async $onDidChangeWebviewViewVisibility(r,S){this.getWebviewView(r)._setVisible(S)}async $disposeWebviewView(r){const S=this.getWebviewView(r);this._webviewViews.delete(r),S.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const S=this._webviewViews.get(r);if(!S)throw new Error("No webview found");return S}}e.ExtHostWebviewViews=v}),define(me[92],ge([1,0,5,4,2,11,14,3,12]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let L=class ji{constructor(g){this._onDidChangeWindowState=new n.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=g.getProxy(O.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(t=>this.$onDidChangeWindowFocus(t))}get state(){return this._state}$onDidChangeWindowFocus(g){g!==this._state.focused&&(this._state={...this._state,focused:g},this._onDidChangeWindowState.fire(this._state))}openUri(g,t){let d;if(typeof g=="string"){d=g;try{g=_.URI.parse(g)}catch{return Promise.reject(`Invalid uri - '${g}'`)}}return(0,x.isFalsyOrWhitespace)(g.scheme)?Promise.reject("Invalid scheme - cannot be empty"):g.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${g.scheme}'`):this._proxy.$openUri(g,d,t)}async asExternalUri(g,t){if((0,x.isFalsyOrWhitespace)(g.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(g,t);return _.URI.from(d)}};L.InitialState={focused:!0},L=Te([Re(0,y.IExtHostRpcService)],L),e.ExtHostWindow=L,e.IExtHostWindow=(0,F.createDecorator)("IExtHostWindow")}),define(me[207],ge([1,0,10,21,20,15,5,7,105,173,37]),function(Z,e,n,O,_,C,x,F,y,L,N){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function t(b,I){try{return JSON.stringify(b,I)}catch{return"null"}}const d="$$ref$$",s={[d]:-1};class a{constructor(I,k){this.jsonString=I,this.referencedBuffers=k}}function l(b,I=null,k=!1){const $=[];return{jsonString:(k?t:JSON.stringify)(b,(U,z)=>{if(typeof z=="undefined")return s;if(typeof z=="object"){if(z instanceof O.VSBuffer){const q=$.push(z)-1;return{[d]:q}}if(I)return I(U,z)}return z}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=l;function P(b,I,k){return JSON.parse(b,($,u)=>{if(u){const U=u[d];if(typeof U=="number")return I[U];if(k&&u.$mid===1)return k.transformIncoming(u)}return u})}e.parseJsonAndRestoreBufferRefs=P;function v(b,I){return JSON.stringify(b,I)}function E(b){return b?(I,k)=>k&&k.$mid===1?b.transformOutgoing(k):k:null}var r;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},T=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class c extends F.Disposable{constructor(I,k=null,$=null){super();this[g]=!0,this._onDidChangeResponsiveState=this._register(new x.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=I,this._logger=k,this._uriTransformer=$,this._uriReplacer=E(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let u=0,U=N.ProxyIdentifier.count;u<U;u++)this._locals[u]=null,this._proxies[u]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new n.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(u=>this._receiveOneMessage(u))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(I=>{this._pendingRPCReplies[I].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(I){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(I){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(I){this._responsiveState!==I&&(this._responsiveState=I,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(I){return this._uriTransformer?(0,y.transformIncomingURIs)(I,this._uriTransformer):I}getProxy(I){const{nid:k,sid:$}=I;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,$)),this._proxies[k]}_createProxy(I,k){let $={get:(u,U)=>(typeof U=="string"&&!u[U]&&U.charCodeAt(0)===36&&(u[U]=(...z)=>this._remoteCall(I,U,z)),U===o?k:u[U])};return new Proxy(Object.create(null),$)}set(I,k){return this._locals[I.nid]=k,k}assertRegistered(I){for(let k=0,$=I.length;k<$;k++){const u=I[k];if(!this._locals[u.nid])throw new Error(`Missing proxy instance ${u.sid}`)}}_receiveOneMessage(I){if(this._isDisposed)return;const k=I.byteLength,$=w.read(I,0),u=$.readUInt8(),U=$.readUInt32();switch(u){case 1:case 2:{let{rpcId:z,method:q,args:V}=h.deserializeRequestJSONArgs($);this._uriTransformer&&(V=(0,y.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(k,U,z,q,V,u===2);break}case 3:case 4:{let{rpcId:z,method:q,args:V}=h.deserializeRequestMixedArgs($);this._uriTransformer&&(V=(0,y.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(k,U,z,q,V,u===4);break}case 5:{this._logger&&this._logger.logIncoming(k,U,0,"ack"),this._onDidReceiveAcknowledge(U);break}case 6:{this._receiveCancel(k,U);break}case 7:{this._receiveReply(k,U,void 0);break}case 9:{let z=h.deserializeReplyOKJSON($);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(k,U,z);break}case 10:{const z=h.deserializeReplyOKJSONWithBuffers($,this._uriTransformer);this._receiveReply(k,U,z);break}case 8:{let z=h.deserializeReplyOKVSBuffer($);this._receiveReply(k,U,z);break}case 11:{let z=h.deserializeReplyErrError($);this._uriTransformer&&(z=(0,y.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(k,U,z);break}case 12:{this._receiveReplyErr(k,U,void 0);break}default:console.error("received unexpected message"),console.error(I)}}_receiveRequest(I,k,$,u,U,z){this._logger&&this._logger.logIncoming(I,k,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)($)}.${u}(`,U);const q=String(k);let V,j;if(z){const se=new _.CancellationTokenSource;U.push(se.token),V=this._invokeHandler($,u,U),j=()=>se.cancel()}else V=this._invokeHandler($,u,U),j=i;this._cancelInvokedHandlers[q]=j;const Y=h.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(Y.byteLength,k,1,"ack"),this._protocol.send(Y),V.then(se=>{delete this._cancelInvokedHandlers[q];const le=h.serializeReplyOK(k,se,this._uriReplacer);this._logger&&this._logger.logOutgoing(le.byteLength,k,1,"reply:",se),this._protocol.send(le)},se=>{delete this._cancelInvokedHandlers[q];const le=h.serializeReplyErr(k,se);this._logger&&this._logger.logOutgoing(le.byteLength,k,1,"replyErr:",se),this._protocol.send(le)})}_receiveCancel(I,k){this._logger&&this._logger.logIncoming(I,k,1,"receiveCancel");const $=String(k);this._cancelInvokedHandlers[$]&&this._cancelInvokedHandlers[$]()}_receiveReply(I,k,$){this._logger&&this._logger.logIncoming(I,k,0,"receiveReply:",$);const u=String(k);if(!this._pendingRPCReplies.hasOwnProperty(u))return;const U=this._pendingRPCReplies[u];delete this._pendingRPCReplies[u],U.resolveOk($)}_receiveReplyErr(I,k,$){this._logger&&this._logger.logIncoming(I,k,0,"receiveReplyErr:",$);const u=String(k);if(!this._pendingRPCReplies.hasOwnProperty(u))return;const U=this._pendingRPCReplies[u];delete this._pendingRPCReplies[u];let z;$&&($.$isError?(z=new Error,z.name=$.name,z.message=$.message,z.stack=$.stack):z=$),U.resolveErr(z)}_invokeHandler(I,k,$){try{return Promise.resolve(this._doInvokeHandler(I,k,$))}catch(u){return Promise.reject(u)}}_doInvokeHandler(I,k,$){const u=this._locals[I];if(!u)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(I));let U=u[k];if(typeof U!="function")throw new Error("Unknown method "+k+" on actor "+(0,N.getStringIdentifierForProxy)(I));return U.apply(u,$)}_remoteCall(I,k,$){if(this._isDisposed)return Promise.reject(C.canceled());let u=null;if($.length>0&&_.CancellationToken.isCancellationToken($[$.length-1])&&(u=$.pop()),u&&u.isCancellationRequested)return Promise.reject(C.canceled());const U=h.serializeRequestArguments($,this._uriReplacer),z=++this._lastMessageId,q=String(z),V=new L.LazyPromise;u&&u.onCancellationRequested(()=>{const Y=h.serializeCancel(z);this._logger&&this._logger.logOutgoing(Y.byteLength,z,0,"cancel"),this._protocol.send(h.serializeCancel(z))}),this._pendingRPCReplies[q]=V,this._onWillSendRequest(z);const j=h.serializeRequest(z,I,k,U,!!u);return this._logger&&this._logger.logOutgoing(j.byteLength,z,0,`request: ${(0,N.getStringIdentifierForProxy)(I)}.${k}(`,$),this._protocol.send(j),V}}e.RPCProtocol=c,g=T,c.UNRESPONSIVE_TIME=3*1e3;class w{constructor(I,k){this._buff=I,this._offset=k}static alloc(I,k,$){let u=new w(O.VSBuffer.alloc($+1+4),0);return u.writeUInt8(I),u.writeUInt32(k),u}static read(I,k){return new w(I,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(I){this._buff.writeUInt8(I,this._offset),this._offset+=1}readUInt8(){const I=this._buff.readUInt8(this._offset);return this._offset+=1,I}writeUInt32(I){this._buff.writeUInt32BE(I,this._offset),this._offset+=4}readUInt32(){const I=this._buff.readUInt32BE(this._offset);return this._offset+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this._buff.writeUInt8(I.byteLength,this._offset),this._offset+=1,this._buff.set(I,this._offset),this._offset+=I.byteLength}readShortString(){const I=this._buff.readUInt8(this._offset);this._offset+=1;const $=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,$}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readLongString(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,$}writeBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readVSBuffer(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+I);return this._offset+=I,k}static sizeMixedArray(I){let k=0;k+=1;for(let $=0,u=I.length;$<u;$++){const U=I[$];switch(k+=1,U.type){case 1:k+=this.sizeLongString(U.value);break;case 2:k+=this.sizeVSBuffer(U.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(U.value);for(let z=0;z<U.buffers.length;++z)k+=this.sizeVSBuffer(U.buffers[z]);break;case 4:break}}return k}writeMixedArray(I){this._buff.writeUInt8(I.length,this._offset),this._offset+=1;for(let k=0,$=I.length;k<$;k++){const u=I[k];switch(u.type){case 1:this.writeUInt8(1),this.writeLongString(u.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(u.value);break;case 3:this.writeUInt8(3),this.writeUInt32(u.buffers.length),this.writeLongString(u.value);for(let U=0;U<u.buffers.length;++U)this.writeBuffer(u.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(I);for(let $=0;$<I;$++)switch(this.readUInt8()){case 1:k[$]=this.readLongString();break;case 2:k[$]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),z=this.readLongString(),q=[];for(let V=0;V<U;++V)q.push(this.readVSBuffer());k[$]=new N.SerializableObjectWithBuffers(P(z,q,null));break}case 4:k[$]=void 0;break}return k}}w.sizeUInt32=4;var f;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(f||(f={}));class h{static _useMixedArgSerialization(I){for(let k=0,$=I.length;k<$;k++)if(I[k]instanceof O.VSBuffer||I[k]instanceof N.SerializableObjectWithBuffers||typeof I[k]=="undefined")return!0;return!1}static serializeRequestArguments(I,k){if(this._useMixedArgSerialization(I)){const $=[];for(let u=0,U=I.length;u<U;u++){const z=I[u];if(z instanceof O.VSBuffer)$[u]={type:2,value:z};else if(typeof z=="undefined")$[u]={type:4};else if(z instanceof N.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:V}=l(z.value,k);$[u]={type:3,value:O.VSBuffer.fromString(q),buffers:V}}else $[u]={type:1,value:O.VSBuffer.fromString(v(z,k))}}return{type:1,args:$}}return{type:0,args:v(I,k)}}static serializeRequest(I,k,$,u,U){switch(u.type){case 0:return this._requestJSONArgs(I,k,$,u.args,U);case 1:return this._requestMixedArgs(I,k,$,u.args,U)}}static _requestJSONArgs(I,k,$,u,U){const z=O.VSBuffer.fromString($),q=O.VSBuffer.fromString(u);let V=0;V+=w.sizeUInt8(),V+=w.sizeShortString(z),V+=w.sizeLongString(q);let j=w.alloc(U?2:1,I,V);return j.writeUInt8(k),j.writeShortString(z),j.writeLongString(q),j.buffer}static deserializeRequestJSONArgs(I){const k=I.readUInt8(),$=I.readShortString(),u=I.readLongString();return{rpcId:k,method:$,args:JSON.parse(u)}}static _requestMixedArgs(I,k,$,u,U){const z=O.VSBuffer.fromString($);let q=0;q+=w.sizeUInt8(),q+=w.sizeShortString(z),q+=w.sizeMixedArray(u);let V=w.alloc(U?4:3,I,q);return V.writeUInt8(k),V.writeShortString(z),V.writeMixedArray(u),V.buffer}static deserializeRequestMixedArgs(I){const k=I.readUInt8(),$=I.readShortString(),u=I.readMixedArray(),U=new Array(u.length);for(let z=0,q=u.length;z<q;z++){const V=u[z];typeof V=="string"?U[z]=JSON.parse(V):U[z]=V}return{rpcId:k,method:$,args:U}}static serializeAcknowledged(I){return w.alloc(5,I,0).buffer}static serializeCancel(I){return w.alloc(6,I,0).buffer}static serializeReplyOK(I,k,$){if(typeof k=="undefined")return this._serializeReplyOKEmpty(I);if(k instanceof O.VSBuffer)return this._serializeReplyOKVSBuffer(I,k);if(k instanceof N.SerializableObjectWithBuffers){const{jsonString:u,referencedBuffers:U}=l(k.value,$,!0);return this._serializeReplyOKJSONWithBuffers(I,u,U)}else return this._serializeReplyOKJSON(I,t(k,$))}static _serializeReplyOKEmpty(I){return w.alloc(7,I,0).buffer}static _serializeReplyOKVSBuffer(I,k){let $=0;$+=w.sizeVSBuffer(k);let u=w.alloc(8,I,$);return u.writeVSBuffer(k),u.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static _serializeReplyOKJSON(I,k){const $=O.VSBuffer.fromString(k);let u=0;u+=w.sizeLongString($);let U=w.alloc(9,I,u);return U.writeLongString($),U.buffer}static _serializeReplyOKJSONWithBuffers(I,k,$){const u=O.VSBuffer.fromString(k);let U=0;U+=w.sizeUInt32,U+=w.sizeLongString(u);for(const q of $)U+=w.sizeVSBuffer(q);let z=w.alloc(10,I,U);z.writeUInt32($.length),z.writeLongString(u);for(const q of $)z.writeBuffer(q);return z.buffer}static deserializeReplyOKJSON(I){const k=I.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(I,k){const $=I.readUInt32(),u=I.readLongString(),U=[];for(let z=0;z<$;++z)U.push(I.readVSBuffer());return new N.SerializableObjectWithBuffers(P(u,U,k))}static serializeReplyErr(I,k){return k?this._serializeReplyErrEror(I,k):this._serializeReplyErrEmpty(I)}static _serializeReplyErrEror(I,k){const $=O.VSBuffer.fromString(t(C.transformErrorForSerialization(k),null));let u=0;u+=w.sizeLongString($);let U=w.alloc(11,I,u);return U.writeLongString($),U.buffer}static deserializeReplyErrError(I){const k=I.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(I){return w.alloc(12,I,0).buffer}}var p;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var m;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(m||(m={}))}),define(me[208],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(C){const x=F=>{self.removeEventListener("message",x);const y=F.data;Object.defineProperties(self,{postMessage:{value(L,N){y.postMessage(L,N)}},onmessage:{get(){return y.onmessage},set(L){y.onmessage=L}}}),y.addEventListener("message",L=>{self.dispatchEvent(new MessageEvent("message",{data:L.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(C)};self.addEventListener("message",x)}.toString();class O extends EventTarget{constructor(C,x,F){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${n})('${x}'))`,L=new Blob([y],{type:"application/javascript"}),N=URL.createObjectURL(L),g=new MessageChannel,t=N,d={type:"_newWorker",id:t,port:g.port2,url:N,options:F};C(d,[g.port2]),this.postMessage=g.port1.postMessage.bind(g.port1),this.terminate=()=>{const s={type:"_terminateWorker",id:t};g.port1.postMessage(s),URL.revokeObjectURL(N),g.port1.close(),g.port2.close()},Object.defineProperties(this,{onmessage:{get(){return g.port1.onmessage},set(s){g.port1.onmessage=s}},onmessageerror:{get(){return g.port1.onmessageerror},set(s){g.port1.onmessageerror=s}}}),g.port1.addEventListener("messageerror",s=>{const a=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(a)}),g.port1.addEventListener("message",s=>{const a=new MessageEvent("message",{data:s.data});this.dispatchEvent(a)}),g.port1.start()}}e.NestedWorker=O}),define(me[209],ge([1,0,3]),function(Z,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(me[210],ge([1,0,71,11,19,28,24,2,3,144,45,168,209]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let d=class qi{constructor(a,l,P,v){this.localUserHome=a,this.remoteAgentService=l,this.environmentService=P,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const E=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=E?.userHome||a})()}hasValidBasename(a,l,P){return typeof l=="string"||typeof l=="undefined"?this.resolveOS.then(v=>this.doHasValidBasename(a,v,l)):this.doHasValidBasename(a,l,P)}doHasValidBasename(a,l,P){return a.scheme===O.Schemas.file||a.scheme===O.Schemas.vscodeRemote?(0,n.isValidBasename)(P??(0,x.basename)(a),l===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,l){if(a.remoteAuthority)return O.Schemas.vscodeRemote;const P=(0,L.getVirtualWorkspaceScheme)(l.getWorkspace());if(P)return P;const v=l.getWorkspace().folders[0];if(v)return v.uri.scheme;const E=l.getWorkspace().configuration;return E?E.scheme:O.Schemas.file}async userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?_.win32:_.posix)}async fileURI(a){let l="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const v=a.indexOf("/",2);v===-1?(l=a.substring(2),a="/"):(l=a.substring(2,v),a=a.substring(v)||"/")}return F.URI.from({scheme:O.Schemas.file,authority:l,path:a,query:"",fragment:""})}};d=Te([Re(1,t.IRemoteAgentService),Re(2,g.IWorkbenchEnvironmentService),Re(3,N.IWorkspaceContextService)],d),e.AbstractPathService=d}),define(me[93],ge([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(x,F){this.line=x,this.character=F}isBefore(x){return!1}isBeforeOrEqual(x){return!1}isAfter(x){return!1}isAfterOrEqual(x){return!1}isEqual(x){return!1}compareTo(x){return 0}translate(x,F){return new n(0,0)}with(x){return new n(0,0)}}e.Position=n;class O{constructor(x,F,y,L){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(x,F),this.end=new n(y,L)}contains(x){return!1}isEqual(x){return!1}intersection(x){}union(x){return new O(0,0,0,0)}with(x){return new O(0,0,0,0)}}e.Range=O;var _;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[40],ge([1,0,16,36,25,71,14,3,19,15,93,10]),function(Z,e,n,O,_,C,x,F,y,L,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const t="\u27EA ",d=" characters skipped \u27EB",s=(t.length+d.length+5)*2;e.ISearchService=(0,F.createDecorator)("searchService");var a;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function P(Y){return!!Y.preview}e.resultIsMatch=P;function v(Y){return!!Y.resource}e.isFileMatch=v;function E(Y){return!!Y.message}e.isProgressMessage=E;var r;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(se){this.resource=se,this.results=[]}}e.FileMatch=S;class i{constructor(se,le,re){this.ranges=le;const he=Array.isArray(le)?le:[le];if(re&&re.matchLines===1&&T(he)){se=(0,x.getNLines)(se,re.matchLines);let Ee="",Ce=0,Pe=0;const Be=Math.floor(re.charsPerLine/5),je=[];for(const tt of he){const Ge=Math.max(tt.startColumn-Be,0),ot=tt.startColumn+re.charsPerLine;if(Ge>Pe+Be+s){const mt=t+(Ge-Pe)+d;Ee+=mt+se.slice(Ge,ot),Ce+=Ge-(Pe+mt.length)}else Ee+=se.slice(Pe,ot);je.push(new c(0,tt.startColumn-Ce,tt.endColumn-Ce)),Pe=ot}this.preview={text:Ee,matches:Array.isArray(this.ranges)?je:je[0]}}else{const Ee=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:se,matches:(0,n.mapArrayOrNot)(le,Ce=>new o(Ce.startLineNumber-Ee,Ce.startColumn,Ce.endLineNumber-Ee,Ce.endColumn))}}}}e.TextSearchMatch=i;function T(Y){const se=Y[0].startLineNumber;for(const le of Y)if(le.startLineNumber!==se||le.endLineNumber!==se)return!1;return!0}class o{constructor(se,le,re,he){this.startLineNumber=se,this.startColumn=le,this.endLineNumber=re,this.endColumn=he}}e.SearchRange=o;class c extends o{constructor(se,le,re){super(se,le,se,re)}}e.OneLineRange=c;var w;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(w=e.SearchSortOrder||(e.SearchSortOrder={}));function f(Y,se=!0){const le=Y&&Y.files&&Y.files.exclude,re=se&&Y&&Y.search&&Y.search.exclude;if(!le&&!re)return;if(!le||!re)return le||re;let he=Object.create(null);return he=_.mixin(he,_.deepClone(le)),he=_.mixin(he,_.deepClone(re),!0),he}e.getExcludes=f;function h(Y,se){return Y.excludePattern&&O.match(Y.excludePattern,se)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&O.match(Y.includePattern,se)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(le=>{const re=le.folder.fsPath;if(C.isEqualOrParent(se,re)){const he=y.relative(re,se);return!le.includePattern||!!O.match(le.includePattern,he)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var p;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(se,le){super(se);this.code=le}}e.SearchError=m;function b(Y){const se=Y.message;if((0,L.isCancellationError)(Y))return new m(se,p.canceled);try{const le=JSON.parse(se);return new m(le.message,le.code)}catch{return new m(se,p.other)}}e.deserializeSearchError=b;function I(Y){const se={message:Y.message,code:Y.code};return new Error(JSON.stringify(se))}e.serializeSearchError=I;function k(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=k;function $(Y){return Y.type==="success"}e.isSerializedSearchSuccess=$;function u(Y){return!!Y.path}e.isSerializedFileMatch=u;function U(Y,se){const le=Y.searchPath?Y.searchPath:Y.relativePath;return(0,x.fuzzyContains)(le,se)}e.isFilePatternMatch=U;class z{constructor(se){this.path=se,this.results=[]}addMatch(se){this.results.push(se)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function q(Y,se){const le={...Y||{},...se||{}};return Object.keys(le).filter(re=>{const he=le[re];return typeof he=="boolean"&&he})}e.resolvePatternsForProvider=q;class V{constructor(se,le){this._parsedIncludeExpression=null,this._excludeExpression={...se.excludePattern||{},...le.excludePattern||{}},this._parsedExcludeExpression=O.parse(this._excludeExpression);let re=se.includePattern;le.includePattern&&(re?re={...re,...le.includePattern}:re=le.includePattern),re&&(this._parsedIncludeExpression=O.parse(re))}matchesExcludesSync(se,le,re){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(se,le,re))}includedInQuerySync(se,le,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(se,le,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(se,le,re))}includedInQuery(se,le,re){const he=this._parsedExcludeExpression(se,le,re),Ee=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(se,le,re):!0;return(0,g.isThenable)(he)?he.then(Ce=>Ce?!1:Ee()):Ee()}hasSiblingExcludeClauses(){return j(this._excludeExpression)}}e.QueryGlobTester=V;function j(Y){for(const se in Y)if(typeof Y[se]!="boolean")return!0;return!1}}),define(me[30],ge([1,0,16,10,20,5,22,11,99,24,14,13,2,124,3,9,135,45,29,27,12,8,6,40,4]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E,r,S,i,T,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(k,$,u){return new L.ExtUri(U=>p(U,u)).isEqual(k,$)}function w(k,$,u){return c(k.uri,$.uri,u)?0:(0,N.compare)(k.uri.toString(),$.uri.toString())}function f(k,$,u){return k.index!==$.index?k.index<$.index?-1:1:c(k.uri,$.uri,u)?(0,N.compare)(k.name,$.name):(0,N.compare)(k.uri.toString(),$.uri.toString())}function h(k,$,u,U){const z=k.slice(0).sort((V,j)=>u(V,j,U)),q=$.slice(0).sort((V,j)=>u(V,j,U));return(0,n.delta)(z,q,(V,j)=>u(V,j,U))}function p(k,$){const u=$.getCapabilities(k.scheme);return!(u&&u&1024)}class m extends P.Workspace{constructor($,u,U,z,q,V,j){super($,U.map(Y=>new P.WorkspaceFolder(Y)),z,q,j);this._name=u,this._isUntitled=V,this._workspaceFolders=[],this._structure=x.TernarySearchTree.forUris(j),U.forEach(Y=>{this._workspaceFolders.push(Y),this._structure.set(Y.uri,Y)})}static toExtHostWorkspace($,u,U,z){if(!$)return{workspace:null,added:[],removed:[]};const{id:q,name:V,folders:j,configuration:Y,transient:se,isUntitled:le}=$,re=[],he=u;u?j.forEach((Be,je)=>{const tt=t.URI.revive(Be.uri),Ge=m._findFolder(U||u,tt,z);Ge?(Ge.name=Be.name,Ge.index=Be.index,re.push(Ge)):re.push({uri:tt,name:Be.name,index:je})}):re.push(...j.map(({uri:Be,name:je,index:tt})=>({uri:t.URI.revive(Be),name:je,index:tt}))),re.sort((Be,je)=>Be.index<je.index?-1:1);const Ee=new m(q,V,re,!!se,Y?t.URI.revive(Y):null,!!le,Be=>p(Be,z)),{added:Ce,removed:Pe}=h(he?he.workspaceFolders:[],Ee.workspaceFolders,w,z);return{workspace:Ee,added:Ce,removed:Pe}}static _findFolder($,u,U){for(let z=0;z<$.folders.length;z++){const q=$.workspaceFolders[z];if(c(q.uri,u,U))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,u){return u&&this._structure.get($)&&($=(0,L.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let b=class{constructor($,u,U,z){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=z,this._extHostFileSystemInfo=U,this._requestIdProvider=new y.Counter,this._barrier=new O.Barrier,this._proxy=$.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(o.MainContext.MainThreadMessageService);const q=u.workspace;this._confirmedWorkspace=q?new m(q.id,q.name,[],!!q.transient,q.configuration?t.URI.revive(q.configuration):null,!!q.isUntitled,V=>p(V,U)):void 0}$initializeWorkspace($,u){this._trusted=u,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?t.URI.from({scheme:F.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,u,U,...z){const q=[];if(Array.isArray(z)&&z.forEach(le=>{t.URI.isUri(le.uri)&&!q.some(re=>c(re.uri,le.uri,this._extHostFileSystemInfo))&&q.push({uri:le.uri,name:le.name||(0,L.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[u,U].some(le=>typeof le!="number"||le<0)||U===0&&q.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(u+U>V.length)return!1;const j=V.slice(0);j.splice(u,U,...q.map(le=>({uri:le.uri,name:le.name||(0,L.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<j.length;le++){const re=j[le];if(j.some((he,Ee)=>Ee!==le&&c(re.uri,he.uri,this._extHostFileSystemInfo)))return!1}j.forEach((le,re)=>le.index=re);const{added:Y,removed:se}=h(V,j,f,this._extHostFileSystemInfo);if(Y.length===0&&se.length===0)return!1;if(this._proxy){const le=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(le,u,U,q).then(void 0,re=>{this._unconfirmedWorkspace=void 0;const he={source:{identifier:$.identifier,label:$.displayName||$.name}};this._messageService.$showMessage(l.Severity.Error,(0,d.localize)(0,null,le,re.toString()),he,[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder($,u){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,u)}async getWorkspaceFolder2($,u){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,u)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!this._actualWorkspace)return;const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}getRelativePath($,u){let U,z="";if(typeof $=="string"?(U=t.URI.file($),z=$):typeof $!="undefined"&&(U=$,z=$.fsPath),!U)return z;const q=this.getWorkspaceFolder(U,!0);if(!q)return z;typeof u=="undefined"&&this._actualWorkspace&&(u=this._actualWorkspace.folders.length>1);let V=(0,L.relativePath)(q.uri,U);return u&&q.name&&(V=`${q.name}/${V}`),V}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:u,added:U,removed:z}=m.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=u||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:U,removed:z}))}findFiles($,u,U,z,q=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let V;if(u===null?V=!1:u&&(typeof u=="string"?V=u:V=u.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:Y}=I(S.GlobPattern.from($));return this._proxy.$startFileSearch((0,g.withUndefinedAsNull)(j),(0,g.withUndefinedAsNull)(Y),(0,g.withUndefinedAsNull)(V),(0,g.withUndefinedAsNull)(U),q).then(se=>Array.isArray(se)?se.map(le=>t.URI.revive(le)):[])}async findTextInFiles($,u,U,z,q=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),j=typeof u.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:u.previewOptions,{includePattern:Y,folder:se}=I(S.GlobPattern.from(u.include)),le=typeof u.exclude=="string"?u.exclude:u.exclude?u.exclude.pattern:void 0,re={ignoreSymlinks:typeof u.followSymlinks=="boolean"?!u.followSymlinks:void 0,disregardIgnoreFiles:typeof u.useIgnoreFiles=="boolean"?!u.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof u.useGlobalIgnoreFiles=="boolean"?!u.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof u.useParentIgnoreFiles=="boolean"?!u.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof u.useDefaultExcludes=="boolean"?!u.useDefaultExcludes:!0,fileEncoding:u.encoding,maxResults:u.maxResults,previewOptions:j,afterContext:u.afterContext,beforeContext:u.beforeContext,includePattern:Y,excludePattern:le},he=!1;if(this._activeSearchCallbacks[V]=Ee=>{if(he)return;const Ce=t.URI.revive(Ee.resource);Ee.results.forEach(Pe=>{(0,T.resultIsMatch)(Pe)?U({uri:Ce,preview:{text:Pe.preview.text,matches:(0,n.mapArrayOrNot)(Pe.preview.matches,Be=>new i.Range(Be.startLineNumber,Be.startColumn,Be.endLineNumber,Be.endColumn))},ranges:(0,n.mapArrayOrNot)(Pe.ranges,Be=>new i.Range(Be.startLineNumber,Be.startColumn,Be.endLineNumber,Be.endColumn))}):U({uri:Ce,text:Pe.text,lineNumber:Pe.lineNumber})})},q.isCancellationRequested)return{};try{const Ee=await this._proxy.$startTextSearch($,(0,g.withUndefinedAsNull)(se),re,V,q);return delete this._activeSearchCallbacks[V],Ee||{}}catch(Ee){throw delete this._activeSearchCallbacks[V],Ee}}$handleTextSearchResult($,u){this._activeSearchCallbacks[u]&&this._activeSearchCallbacks[u]($)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=Te([Re(0,r.IExtHostRpcService),Re(1,E.IExtHostInitDataService),Re(2,v.IExtHostFileSystemInfo),Re(3,a.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function I(k){let $,u;return k&&(typeof k=="string"?$=k:($=k.pattern,u=t.URI.revive(k.baseUri))),{includePattern:$,folder:u}}}),define(me[31],ge([1,0,25,5,30,4,6,139,76,13,10,3,12,9,2]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(T,o){if(o){const c=o.split(".");let w=T;for(let f=0;w&&f<c.length;f++)w=w[c[f]];return w}}function l(T){return T instanceof s.URI}function P(T){return T&&T.uri instanceof s.URI&&T.languageId&&typeof T.languageId=="string"}function v(T){return T&&!T.uri&&T.languageId&&typeof T.languageId=="string"}function E(T){return T&&T.uri instanceof s.URI&&(!T.name||typeof T.name=="string")&&(!T.index||typeof T.index=="number")}function r(T){if(l(T))return{resource:T};if(P(T))return{resource:T.uri,overrideIdentifier:T.languageId};if(v(T))return{overrideIdentifier:T.languageId};if(E(T))return{resource:T.uri};if(T===null)return{resource:null}}let S=class{constructor(o,c,w){this._proxy=o.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=c,this._logService=w,this._barrier=new N.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new i(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,c){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(o,c))}};S=Te([Re(0,t.IExtHostRpcService),Re(1,_.IExtHostWorkspace),Re(2,d.ILogService)],S),e.ExtHostConfiguration=S;class i{constructor(o,c,w,f){this._onDidChangeConfiguration=new O.Emitter,this._proxy=o,this._logService=f,this._extHostWorkspace=c,this._configuration=F.Configuration.parse(w),this._configurationScopes=this._toMap(w.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,c){const w={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=F.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(c,w))}getConfiguration(o,c,w){const f=r(c)||{},h=this._toReadonlyValue(o?a(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,f,w?.identifier);function p(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case x.ConfigurationTarget.Global:return 1;case x.ConfigurationTarget.Workspace:return 4;case x.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(b){return typeof a(h,b)!="undefined"},get:(b,I)=>{this._validateConfigurationAccess(o?`${o}.${b}`:b,f,w?.identifier);let k=a(h,b);if(typeof k=="undefined")k=I;else{let $;const u=(U,z)=>{let q;const V=()=>{$=$||(0,n.deepClone)(h),q=q||a($,z)};return(0,L.isObject)(U)?new Proxy(U,{get:(j,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return V(),()=>q;if($)return q=q||a($,z),q[Y];const se=j[Y];return typeof Y=="string"?u(se,`${z}.${Y}`):se},set:(j,Y,se)=>(V(),q&&(q[Y]=se),!0),deleteProperty:(j,Y)=>(V(),q&&delete q[Y],!0),defineProperty:(j,Y,se)=>(V(),q&&Object.defineProperty(q,Y,se),!0)}):U};k=u(k,b)}return k},update:(b,I,k,$)=>{b=o?`${o}.${b}`:b;const u=p(k);return I!==void 0?this._proxy.$updateConfigurationOption(u,b,I,f,$):this._proxy.$removeConfigurationOption(u,b,f,$)},inspect:b=>{b=o?`${o}.${b}`:b;const I=(0,n.deepClone)(this._configuration.inspect(b,f,this._extHostWorkspace.workspace));if(I)return{key:b,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof h=="object"&&(0,n.mixin)(m,h,!1),Object.freeze(m)}_toReadonlyValue(o){const c=w=>(0,L.isObject)(w)?new Proxy(w,{get:(f,h)=>c(f[h]),set:(f,h,p)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(f,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(f,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return c(o)}_validateConfigurationAccess(o,c,w){const f=y.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),h=w?`[${w.value}] `:"";if(f===4){typeof c?.resource=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){c?.resource&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,c){const w=new F.ConfigurationChangeEvent(o,c,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,h)=>w.affectsConfiguration(f,r(h))})}_toMap(o){return o.reduce((c,w)=>(c.set(w[0],w[1]),c),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,g.createDecorator)("IExtHostConfiguration")});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[94],ge([1,0,2,10,5,4,6,30,47,31,20,39,12,27,3,11,28,9,62,160,15]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E,r){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(z){function q(j){if(j!=null)return j}z.from=q;function V(j){if(j!=null)return j}z.to=V})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var T;(function(z){function q(j){if(j!=null)return j}z.from=q;function V(j){if(j!=null)return j}z.to=V})(T=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(z){function q(j){if(j!=null)return j}z.from=q;function V(j){if(j!=null)return j}z.to=V})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var c;(function(z){function q(Y){if(Y){const se=Y;return se&&!!se.process}else return!1}z.is=q;function V(Y){if(Y==null)return;const se={process:Y.process,args:Y.args};return Y.options&&(se.options=o.from(Y.options)),se}z.from=V;function j(Y){if(Y!=null)return new x.ProcessExecution(Y.process,Y.args,Y.options)}z.to=j})(c=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var w;(function(z){function q(j){if(j!=null)return j}z.from=q;function V(j){if(j!=null)return j}z.to=V})(w=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(z){function q(Y){if(Y){const se=Y;return se&&(!!se.commandLine||!!se.command)}else return!1}z.is=q;function V(Y){if(Y==null)return;const se={};return Y.commandLine!==void 0?se.commandLine=Y.commandLine:(se.command=Y.command,se.args=Y.args),Y.options&&(se.options=w.from(Y.options)),se}z.from=V;function j(Y){if(!(Y==null||Y.command===void 0&&Y.commandLine===void 0))return Y.commandLine?new x.ShellExecution(Y.commandLine,Y.options):new x.ShellExecution(Y.command,Y.args?Y.args:[],Y.options)}z.to=j})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(z){function q(Y){if(Y){let se=Y;return se&&se.customExecution==="customExecution"}else return!1}z.is=q;function V(Y){return{customExecution:"customExecution"}}z.from=V;function j(Y,se){return se.get(Y)}z.to=j})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var p;(function(z){function q(V,j){let Y;return V.scope!==void 0&&typeof V.scope!="number"?Y=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===x.TaskScope.Workspace&&j&&j.workspaceFile?Y=j.workspaceFile:Y=E.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:Y}}z.from=q})(p=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(z){function q(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}z.from=q})(m=e.TaskGroupDTO||(e.TaskGroupDTO={}));var b;(function(z){function q(Y,se){if(Y==null)return[];const le=[];for(let re of Y){const he=V(re,se);he&&le.push(he)}return le}z.fromMany=q;function V(Y,se){if(Y==null)return;let le;Y.execution instanceof x.ProcessExecution?le=c.from(Y.execution):Y.execution instanceof x.ShellExecution?le=f.from(Y.execution):Y.execution&&Y.execution instanceof x.CustomExecution&&(le=h.from(Y.execution));const re=i.from(Y.definition);let he;return Y.scope?typeof Y.scope=="number"?he=Y.scope:he=Y.scope.uri:he=x.TaskScope.Workspace,!re||!he?void 0:{_id:Y._id,definition:re,name:Y.name,source:{extensionId:se.identifier.value,label:Y.source,scope:he},execution:le,isBackground:Y.isBackground,group:m.from(Y.group),presentationOptions:T.from(Y.presentationOptions),problemMatchers:Y.problemMatchers,hasDefinedMatchers:Y.hasDefinedMatchers,runOptions:Y.runOptions?Y.runOptions:{reevaluateOnRerun:!0},detail:Y.detail}}z.from=V;async function j(Y,se,le){if(Y==null)return;let re;c.is(Y.execution)?re=c.to(Y.execution):f.is(Y.execution)?re=f.to(Y.execution):h.is(Y.execution)&&(re=h.to(Y._id,le));const he=i.to(Y.definition);let Ee;if(Y.source&&(Y.source.scope!==void 0?typeof Y.source.scope=="number"?Ee=Y.source.scope:Ee=await se.resolveWorkspaceFolder(n.URI.revive(Y.source.scope)):Ee=x.TaskScope.Workspace),!he||!Ee)return;const Ce=new x.Task(he,Ee,Y.name,Y.source.label,re,Y.problemMatchers);return Y.isBackground!==void 0&&(Ce.isBackground=Y.isBackground),Y.group!==void 0&&(Ce.group=x.TaskGroup.from(Y.group._id),Ce.group&&Y.group.isDefault&&(Ce.group=new x.TaskGroup(Ce.group.id,Ce.group.label),Y.group.isDefault&&(Ce.group.isDefault=Y.group.isDefault))),Y.presentationOptions&&(Ce.presentationOptions=T.to(Y.presentationOptions)),Y._id&&(Ce._id=Y._id),Y.detail&&(Ce.detail=Y.detail),Ce}z.to=j})(b=e.TaskDTO||(e.TaskDTO={}));var I;(function(z){function q(j){return j}z.from=q;function V(j){if(!!j)return Object.assign(Object.create(null),j)}z.to=V})(I=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(q,V,j){this._id=V,this._task=j,S.set(this,void 0),ze(this,S,q,"f")}get task(){return this._task}terminate(){we(this,S,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}S=new WeakMap;var $;(function(z){function q(V){return{id:V._id,task:void 0}}z.from=q})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let u=class{constructor(q,V,j,Y,se,le,re,he){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=q.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=j,this._editorService=Y,this._configurationService=se,this._terminalService=le,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=he,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,V,j){if(!j)return new x.Disposable(()=>{});const Y=this.nextHandle();return this._handlers.set(Y,{type:V,provider:j,extension:q}),this._proxy.$registerTaskProvider(Y,V),new x.Disposable(()=>{this._handlers.delete(Y),this._proxy.$unregisterTaskProvider(Y)})}registerTaskSystem(q,V){this._proxy.$registerTaskSystem(q,V)}fetchTasks(q){return this._proxy.$fetchTasks(I.from(q)).then(async V=>{const j=[];for(let Y of V){const se=await b.to(Y,this._workspaceProvider,this._providedCustomExecutions2);se&&j.push(se)}return j})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(V=>q.push(V)),q}terminateTask(q){if(!(q instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,V,j){const Y=this._providedCustomExecutions2.get(q.id);Y&&(this._activeCustomExecutions2.set(q.id,Y),this._terminalService.attachPtyToTerminal(V,await Y.callback(j))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const V=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const V=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:V,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const V=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:q.exitCode})}$provideTasks(q,V){const j=this._handlers.get(q);if(!j)return Promise.reject(new Error("no handler found"));const Y=[],se=(0,O.asPromise)(()=>j.provider.provideTasks(N.CancellationToken.None)).then(le=>this.provideTasksInternal(V,Y,j,le));return new Promise(le=>{se.then(re=>{Promise.all(Y).then(()=>{le(re)})})})}async $resolveTask(q,V){const j=this._handlers.get(q);if(!j)return Promise.reject(new Error("no handler found"));if(V.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${j.type}].`);const Y=await b.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");const se=await j.provider.resolveTask(Y,N.CancellationToken.None);if(!se)return;this.checkDeprecation(se,j);const le=b.from(se,j.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(se.definition!==Y.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(le.execution)&&await this.addCustomExecution(le,se,!0),await this.resolveTaskInternal(le)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,V,j){const Y=await this._proxy.$createTaskId(q);!j&&!this._providedCustomExecutions2.has(Y)&&(this._notProvidedCustomExecutions.add(Y),this._activeCustomExecutions2.set(Y,V.execution)),this._providedCustomExecutions2.set(Y,V.execution)}async getTaskExecution(q,V){if(typeof q=="string"){const se=this._taskExecutionPromises.get(q);if(!se)throw new Error("Unexpected: The specified task is missing an execution");return se}let j=this._taskExecutionPromises.get(q.id);if(j)return j;const Y=new Promise((se,le)=>{function re(he,Ee,Ce){Ce?se(new k(he,Ee.id,Ce)):le("Unexpected: Task does not exist.")}V?re(this,q,V):b.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(he=>re(this,q,he))});return this._taskExecutionPromises.set(q.id,Y),Y.then(se=>(this._taskExecutions.set(q.id,se),se),se=>Promise.reject(se))}checkDeprecation(q,V){q._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let j=this._notProvidedCustomExecutions.values(),Y=j.next();for(;!Y.done;)!this._activeCustomExecutions2.has(Y.value)&&this._lastStartedTask!==Y.value&&(this._providedCustomExecutions2.delete(Y.value),this._notProvidedCustomExecutions.delete(Y.value)),Y=j.next()}};u=Te([Re(0,t.IExtHostRpcService),Re(1,d.IExtHostInitDataService),Re(2,F.IExtHostWorkspace),Re(3,y.IExtHostDocumentsAndEditors),Re(4,L.IExtHostConfiguration),Re(5,g.IExtHostTerminalService),Re(6,P.ILogService),Re(7,v.IExtHostApiDeprecationService)],u),e.ExtHostTaskBase=u;let U=class extends u{constructor(q,V,j,Y,se,le,re,he){super(q,V,j,Y,se,le,re,he);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:l.PlatformToString(0)})}async executeTask(q,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const j=b.from(V,q);if(j===void 0)throw new Error("Task is not valid");if(h.is(j.execution))await this.addCustomExecution(j,V,!1);else throw new r.NotSupportedError;const Y=await this.getTaskExecution(await this._proxy.$getTaskExecution(j),V);return this._proxy.$executeTask(j).catch(se=>{throw new Error(se)}),Y}provideTasksInternal(q,V,j,Y){const se=[];if(Y)for(let le of Y){this.checkDeprecation(le,j),(!le.definition||!q[le.definition.type])&&this._logService.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const re=b.from(le,j.extension);re&&h.is(re.execution)?(se.push(re),V.push(this.addCustomExecution(re,le,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:se,extension:j.extension}}async resolveTaskInternal(q){if(h.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,V,j){}};U=Te([Re(0,t.IExtHostRpcService),Re(1,d.IExtHostInitDataService),Re(2,F.IExtHostWorkspace),Re(3,y.IExtHostDocumentsAndEditors),Re(4,L.IExtHostConfiguration),Re(5,g.IExtHostTerminalService),Re(6,P.ILogService),Re(7,v.IExtHostApiDeprecationService)],U),e.WorkerExtHostTask=U,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(me[211],ge([1,0,16,67,36,70,22,11,19,24,14,13,2,231,127,74,45,84,210,40]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(p,m,b,I){this.configurationService=p,this.workspaceContextService=m,this.editorGroupsService=b,this.pathService=I}text(p,m,b={}){p=this.getContentPattern(p,b);const I=this.configurationService.getValue(),k=m&&m.some(u=>!this.configurationService.getValue({resource:u}).search.useRipgrep);return{...this.commonQuery(m?.map(l.toWorkspaceFolder),b),type:2,contentPattern:p,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:I.search.usePCRE2||k||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}getContentPattern(p,m){const b=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const I={...p,wordSeparators:b.editor.wordSeparators};return this.isCaseSensitive(p,m)&&(I.isCaseSensitive=!0),this.isMultiline(p)&&(I.isMultiline=!0),I}file(p,m={}){return{...this.commonQuery(p,m),type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey}}handleIncludeExclude(p,m){return p?(p=Array.isArray(p)?p.map(c):c(p),m?this.parseSearchPaths(p):{pattern:i(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],m={}){const b=this.handleIncludeExclude(m.includePattern,m.expandPatterns),I=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),k=p.length>1,$=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,m,I)):p.map(z=>this.getFolderQueryForRoot(z,m,I,k))).filter(z=>!!z),u={_reason:m._reason,folderQueries:$,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:I.pattern,includePattern:b.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const q=n.coalesce(n.flatten(this.editorGroupsService.groups.map(j=>j.editors.map(Y=>Y.resource)))).filter(j=>(0,E.pathIncludedInQuery)(u,j.fsPath)),V=this.commonQueryFromFileList(q);return{...u,...V}}const U=m.extraFileResources&&m.extraFileResources.filter(z=>(0,E.pathIncludedInQuery)(u,z.fsPath));return u.extraFileResources=U&&U.length?U:void 0,u}commonQueryFromFileList(p){const m=[],b=new x.ResourceMap,I={};let k=!1;return p.forEach($=>{if($.scheme===F.Schemas.walkThrough)return;if((0,L.isAbsolutePath)($)){const U=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:y.dirname($.fsPath)});let z=b.get(U);z||(k=!0,z={folder:U,includePattern:{}},m.push(z),b.set(U,z));const q=y.relative(U.fsPath,$.fsPath);(0,g.assertIsDefined)(z.includePattern)[q.replace(/\\/g,"/")]=!0}else $.fsPath&&(k=!0,I[$.fsPath]=!0)}),{folderQueries:m,includePattern:I,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(p,m){if(m.isSmartCase){if(p.isRegExp){if(N.containsUppercaseCharacter(p.pattern,!0))return!0}else if(N.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,d.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const m=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),I=(Array.isArray(p)?p:T(p)).map(V=>{const j=this.pathService.resolvedUserHome;return j?(0,C.untildify)(V,j.scheme===F.Schemas.file?j.fsPath:j.path):V}),k=O.groupBy(I,V=>m(V)?"searchPaths":"exprSegments"),$=(k.exprSegments||[]).map(V=>N.rtrim(V,"/")).map(V=>N.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),o(V))),u={},U=this.expandSearchPathPatterns(k.searchPaths||[]);U&&U.length&&(u.searchPaths=U);const z=n.flatten($),q=i(...z);return q&&(u.pattern=q),u}getExcludesForFolder(p,m){return m.disregardExcludeSettings?void 0:(0,E.getExcludes)(p,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const m=n.flatten(p.map(I=>{let{pathPortion:k,globPortion:$}=S(I);$&&($=w($));const u=this.expandOneSearchPath(k);return n.flatten(u.map(U=>this.resolveOneSearchPathPattern(U,$)))})),b=new Map;return m.forEach(I=>{const k=I.searchPath.toString(),$=b.get(k);$?I.pattern&&($.pattern=$.pattern||{},$.pattern[I.pattern]=!0):b.set(k,{searchPath:I.searchPath,pattern:I.pattern?i(I.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(p){if(y.isAbsolute(p)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==F.Schemas.file?[{searchPath:m[0].uri.with({path:p})}]:[{searchPath:t.URI.file(y.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=c(p),p.startsWith("../")||p===".."){const I=y.posix.resolve(m.path,p);return[{searchPath:m.with({path:I})}]}const b=w(p);return[{searchPath:m,pattern:b}]}else{if(p==="./"||p===".\\")return[];{const m=p.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(k=>{const $=m.match(new RegExp(`^${N.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return $?{match:$,folder:k}:null}).filter(g.isDefined);if(I.length)return I.map(k=>{const $=k.match[1];return{searchPath:k.folder.uri,pattern:$&&w($)}});{const k=p.match(/\.[\/\\](.+)[\/\\]?/),$=k?k[1]:p,u=s.localize(0,null,$);throw new Error(u)}}}}resolveOneSearchPathPattern(p,m){const b=p.pattern&&m?`${p.pattern}/${m}`:p.pattern||m,I=[{searchPath:p.searchPath,pattern:b}];return b&&!b.endsWith("**")&&I.push({searchPath:p.searchPath,pattern:b+"/**"}),I}getFolderQueryForSearchPath(p,m,b){const I=this.getFolderQueryForRoot((0,l.toWorkspaceFolder)(p.searchPath),m,b,!1);return I?{...I,includePattern:p.pattern}:null}getFolderQueryForRoot(p,m,b,I){let k;const $=t.URI.isUri(p)?p:p.uri;if(b.searchPaths){const V=b.searchPaths.filter(j=>(0,L.isEqual)(j.searchPath,$))[0];if(V&&!V.pattern)return null;V&&(k=V.pattern)}const u=this.configurationService.getValue({resource:$}),z={...this.getExcludesForFolder(u,m)||{},...k||{}},q=t.URI.isUri(p)?(0,L.basename)(p):p.name;return{folder:$,folderName:I?q:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:u.files&&u.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!u.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!u.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!u.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!u.search.followSymlinks}}};r=Te([Re(0,a.IConfigurationService),Re(1,l.IWorkspaceContextService),Re(2,P.IEditorGroupsService),Re(3,v.IPathService)],r),e.QueryBuilder=r;function S(h){const p=h.match(/[\*\{\}\(\)\[\]\?]/);if(p){const m=p.index,b=h.substr(0,m).match(/[/|\\][^/\\]*$/);if(b){let I=h.substr(0,b.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:h.substr((b.index||0)+1)}}}return{pathPortion:h}}function i(...h){return h.length?h.reduce((p,m)=>(p[m]=!0,p),Object.create(null)):void 0}function T(h){return _.splitGlobAware(h,",").map(p=>p.trim()).filter(p=>!!p.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function c(h){return h.replace(/\\/g,"/")}function w(h){return c(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(h,p){h=n.distinct(h,I=>I.toString());const m=[],b=p.getWorkspace();return h&&h.forEach(I=>{let k;if(p.getWorkbenchState()===2)k=(0,L.relativePath)(b.folders[0].uri,I),k&&k!=="."&&(k="./"+k);else{const $=p.getWorkspaceFolder(I);if($){const u=$.name;if(b.folders.filter(z=>z.name===u).length===1){const z=(0,L.relativePath)($.uri,I);z===""?k=`./${$.name}`:k=`./${$.name}/${z}`}else k=I.fsPath}}k&&m.push(k)}),m}e.resolveResourcesForSearchIncludes=f}),define(me[212],ge([1,0,24,2,20,15,3,211,40,45]),function(Z,e,n,O,_,C,x,F,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function g(a,l){const P=l.activationEvents;if(!P)return Promise.resolve(void 0);const v=[],E=[];for(const c of P)if(/^workspaceContains:/.test(c)){const w=c.substr("workspaceContains:".length);w.indexOf("*")>=0||w.indexOf("?")>=0||a.forceUsingSearch?E.push(w):v.push(w)}if(v.length===0&&E.length===0)return Promise.resolve(void 0);let r;const S=new Promise((c,w)=>{r=c}),i=c=>r({activationEvent:c}),T=Promise.all(v.map(c=>t(a,c,i))).then(()=>{}),o=d(a,l.identifier,E,i);return Promise.all([T,o]).then(()=>{r(void 0)}),S}e.checkActivateWorkspaceContainsExtension=g;async function t(a,l,P){for(const v of a.folders)if(await a.exists(n.joinPath(O.URI.revive(v),l))){P(`workspaceContains:${l}`);return}}async function d(a,l,P,v){if(P.length===0)return Promise.resolve(void 0);const E=new _.CancellationTokenSource,r=a.checkExists(a.folders,P,E.token),S=setTimeout(async()=>{E.cancel(),a.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${P.join(",")}`)},N);let i=!1;try{i=await r}catch(T){C.isCancellationError(T)||C.onUnexpectedError(T)}E.dispose(),clearTimeout(S),i&&v(`workspaceContains:${P.join(",")}`)}function s(a,l,P,v){const E=a.get(x.IInstantiationService),r=a.get(y.ISearchService),i=E.createInstance(F.QueryBuilder).file(l.map(T=>(0,L.toWorkspaceFolder)(O.URI.revive(T))),{_reason:"checkExists",includePattern:P,exists:!0});return r.fileSearch(i,v).then(T=>!!T.limitHit,T=>C.isCancellationError(T)?!1:Promise.reject(T))}e.checkGlobFileExists=s});var ze=this&&this.__classPrivateFieldSet||function(Z,e,n,O,_){if(O==="m")throw new TypeError("Private method is not writable");if(O==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!_:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return O==="a"?_.call(Z,n):_?_.value=n:e.set(Z,n),n},we=this&&this.__classPrivateFieldGet||function(Z,e,n,O){if(n==="a"&&!O)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!O:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?O:n==="a"?O.call(Z):O?O.value:e.get(Z)};define(me[32],ge([1,0,119,19,66,24,10,7,22,2,9,4,31,171,64,30,26,169,15,23,21,145,6,77,3,27,65,12,54,57,39,5,212,61,147,11]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E,r,S,i,T,o,c,w,f,h,p,m,b,I,k,$,u){"use strict";var U,z,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let V=class Ki extends F.Disposable{constructor(re,he,Ee,Ce,Pe,Be,je,tt,Ge,ot){super();this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=he,this._extHostContext=Ee,this._initData=je,this._extHostWorkspace=Ce,this._extHostConfiguration=Pe,this._logService=Be,this._extHostTunnelService=Ge,this._extHostTerminalService=ot,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(g.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(g.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(g.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new x.Barrier,this._readyToStartExtensionHost=new x.Barrier,this._readyToRunExtensions=new x.Barrier,this._eagerExtensionsActivated=new x.Barrier,this._registry=new P.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=tt,this._instaService=re.createChild(new h.ServiceCollection([s.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const mt=new Set;this._initData.hostExtensions.forEach(ve=>mt.add(E.ExtensionIdentifier.toKey(ve))),this._activator=this._register(new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ve,ce,M)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ve,v.transformErrorForSerialization(ce),M)},actualActivateExtension:async(ve,ce)=>{if(mt.has(E.ExtensionIdentifier.toKey(ve)))return await this._mainThreadExtensionsProxy.$activateExtension(ve,ce),new d.HostExtension;const M=this._registry.getExtensionDescription(ve);return this._activateExtension(M,ce)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(re){v.onUnexpectedError(re)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let re=[];try{re=this._registry.getAllExtensionDescriptions().map(Pe=>Pe.identifier).filter(Pe=>this.isActivated(Pe)).map(Pe=>this._deactivate(Pe))}catch{}await Promise.all(re)}isActivated(re){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(re):!1}_activateByEvent(re,he){return this._activator.activateByEvent(re,he)}_activateById(re,he){return this._activator.activateById(re,he)}activateByIdWithErrors(re,he){return this._activateById(re,he).then(()=>{const Ee=this._activator.getActivatedExtension(re);if(Ee.activationFailed)return Promise.reject(Ee.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(re=>this._registry)}getExtensionExports(re){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(re).exports:null}async _realPathExtensionUri(re){if(re.scheme!==u.Schemas.file)return re;const he=await this._hostUtils.realpath(re.fsPath);return L.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const re=y.TernarySearchTree.forUris(he=>C.extUriBiasedIgnorePathCase.ignorePathCasing(he));for(const he of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(he)){const Ee=await this._realPathExtensionUri(he.extensionLocation);re.set(Ee,he)}return re})()),this._extensionPathIndex}_deactivate(re){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(re))return he;const Ee=this._activator.getActivatedExtension(re);if(!Ee)return he;try{typeof Ee.module.deactivate=="function"&&(he=Promise.resolve(Ee.module.deactivate()).then(void 0,Ce=>(this._logService.error(Ce),Promise.resolve(void 0))))}catch(Ce){this._logService.error(`An error occurred when deactivating the extension '${re.value}':`),this._logService.error(Ce)}try{(0,F.dispose)(Ee.subscriptions)}catch(Ce){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this._logService.error(Ce)}return he}async _activateExtension(re,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(re.identifier),this._doActivateExtension(re,he).then(Ee=>{const Ce=Ee.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(re.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,he),this._logExtensionActivationTimes(re,he,"success",Ce),Ee},Ee=>{throw this._logExtensionActivationTimes(re,he,"failure"),Ee})}_logExtensionActivationTimes(re,he,Ee,Ce){const Pe=j(re,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Pe,...Ce||{},outcome:Ee})}_doActivateExtension(re,he){const Ee=j(re,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Ee);const Ce=this._getEntryPoint(re);if(!Ce)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${re.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const Pe=new d.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(re.identifier,(0,C.joinPath)(re.extensionLocation,Ce),Pe),this._loadExtensionContext(re)]).then(Be=>(_.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Ki._callActivate(this._logService,re.identifier,Be[0],Be[1],Pe))).then(Be=>(_.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Be))}_loadExtensionContext(re){const he=new S.ExtensionGlobalMemento(re,this._storage),Ee=new S.ExtensionMemento(re.identifier.value,!1,this._storage),Ce=new $.ExtensionSecrets(re,this._secretState),Pe=re.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Be=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([he.whenReady,Ee.whenReady,this._storagePath.whenReady]).then(()=>{const je=this;let tt,Ge;const ot=(0,l.isProposedApiEnabled)(re,"ipc")?this._initData.messagePorts?.get(E.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:Ee,secrets:Ce,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(mt){return O.join(re.extensionLocation.fsPath,mt)},get storagePath(){return je._storagePath.workspaceValue(re)?.fsPath},get globalStoragePath(){return je._storagePath.globalValue(re).fsPath},get logPath(){return O.join(je._initData.logsLocation.fsPath,re.identifier.value)},get logUri(){return L.URI.joinPath(je._initData.logsLocation,re.identifier.value)},get storageUri(){return je._storagePath.workspaceValue(re)},get globalStorageUri(){return je._storagePath.globalValue(re)},get extensionMode(){return Pe},get extension(){return tt===void 0&&(tt=new Y(je,re.identifier,re,Be)),tt},get extensionRuntime(){return(0,l.checkProposedApiEnabled)(re,"extensionRuntime"),je.extensionRuntime},get environmentVariableCollection(){return je._extHostTerminalService.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Ge){if(!ot)return;const mt=b.Event.buffer(b.Event.fromDOMEventEmitter(ot,"message",ve=>ve.data));ot.start(),Ge={onDidReceiveMessage:mt,postMessage:ot.postMessage.bind(ot)}}return Ge}})})}static _callActivate(re,he,Ee,Ce,Pe){return Ee=Ee||{activate:void 0,deactivate:void 0},this._callActivateOptional(re,he,Ee,Ce,Pe).then(Be=>new d.ActivatedExtension(!1,null,Pe.build(),Ee,Be,Ce.subscriptions))}static _callActivateOptional(re,he,Ee,Ce,Pe){if(typeof Ee.activate=="function")try{Pe.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${he.value}`);const Be=typeof global=="object"?global:self,je=Ee.activate.apply(Be,[Ce]);return Pe.activateCallStop(),Pe.activateResolveStart(),Promise.resolve(je).then(tt=>(Pe.activateResolveStop(),tt))}catch(Be){return Promise.reject(Be)}else return Promise.resolve(Ee)}_activateOneStartupFinished(re,he){this._activateById(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:he}).then(void 0,Ee=>{this._logService.error(Ee)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const re of this._registry.getAllExtensionDescriptions())if(re.activationEvents)for(const he of re.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(re,he)}_handleEagerExtensions(){const re=this._activateByEvent("*",!0).then(void 0,Pe=>{this._logService.error(Pe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Pe=>this._handleWorkspaceContainsEagerExtensions(Pe.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Ee=this._handleWorkspaceContainsEagerExtensions(he),Ce=Promise.all([re,Ee]).then(()=>{});return Promise.race([Ce,(0,x.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Ce}_handleWorkspaceContainsEagerExtensions(re){return re.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(re,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(re,he){if(this.isActivated(he.identifier))return;const Ee=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Ce={logService:this._logService,folders:re.map(Be=>Be.uri),forceUsingSearch:Ee,exists:Be=>this._hostUtils.exists(Be.fsPath),checkExists:(Be,je,tt)=>this._mainThreadWorkspaceProxy.$checkExists(Be,je,tt)},Pe=await(0,I.checkActivateWorkspaceContainsExtension)(Ce,he);if(!!Pe)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:Pe.activationEvent}).then(void 0,Be=>this._logService.error(Be))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(re){throw console.error(re),re}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:he}=this._initData.environment;if(!re||!he)throw new Error(n.localize(0,null));const Ee=await this._loadCommonJSModule(null,he,new d.ExtensionActivationTimesBuilder(!1));if(!Ee||typeof Ee.run!="function")throw new Error(n.localize(1,null,he.toString()));return new Promise((Ce,Pe)=>{const Be=(Ge,ot)=>{Ge?Pe(Ge):Ce(typeof ot=="number"&&ot>0?1:0)},je=(0,C.originalFSPath)(he),tt=Ee.run(je,Be);tt&&tt.then&&tt.then(()=>{Ce(0)}).catch(Ge=>{Pe(Ge instanceof Error&&Ge.stack?Ge.stack:String(Ge))})})}async $extensionTestsExit(re){this._logService.info(`Extension host terminating: test runner requested exit with code ${re}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${re}`),this._logService.flush(),this._hostUtils.exit(re)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,he){return this._resolvers[re]=he,(0,F.toDisposable)(()=>{delete this._resolvers[re]})}async _activateAndGetResolver(re){const he=re.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const Ee=re.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Ee}`,!1),{authorityPrefix:Ee,resolver:this._resolvers[Ee]}}async $resolveAuthority(re,he){this._logService.info(`$resolveAuthority invoked for authority (${se(re)})`);const{authorityPrefix:Ee,resolver:Ce}=await this._activateAndGetResolver(re);if(!Ce)return{type:"error",error:{code:T.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ee}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Ce)),_.mark(`code/extHost/willResolveAuthority/${Ee}`);const Pe=await Ce.resolve(re,{resolveAttempt:he});_.mark(`code/extHost/didResolveAuthorityOK/${Ee}`);const Be={authority:re,host:Pe.host,port:Pe.port,connectionToken:Pe.connectionToken},je={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Be,options:je,tunnelInformation:{environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures}}}}catch(Pe){if(_.mark(`code/extHost/didResolveAuthorityError/${Ee}`),Pe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Pe._code,message:Pe._message,detail:Pe._detail}};throw Pe}}async $getCanonicalURI(re,he){this._logService.info(`$getCanonicalURI invoked for authority (${se(re)})`);const{authorityPrefix:Ee,resolver:Ce}=await this._activateAndGetResolver(re);if(!Ce)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${Ee}`);const Pe=L.URI.revive(he);if(typeof Ce.getCanonicalURI=="undefined")return Pe;const Be=await(0,x.asPromise)(()=>Ce.getCanonicalURI(Pe));return Be||Pe}$startExtensionHost(re){return this._registry.keepOnly(re),this._startExtensionHost()}$activateByEvent(re,he){return he===1?this._activateByEvent(re,!1):this._readyToRunExtensions.wait().then(Ee=>this._activateByEvent(re,!1))}async $activate(re,he){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(re)?(await this._activateById(re,he),!0):!1}async $deltaExtensions(re,he){re.forEach(Ce=>Ce.extensionLocation=L.URI.revive(Ce.extensionLocation));const Ee=await this.getExtensionPathIndex();return await Promise.all(he.map(async Ce=>{const Pe=this._registry.getExtensionDescription(Ce);Pe&&Ee.delete(await this._realPathExtensionUri(Pe.extensionLocation))})),await Promise.all(re.map(async Ce=>{const Pe=await this._realPathExtensionUri(Ce.extensionLocation);Ee.set(Pe,Ce)})),this._registry.deltaExtensions(re,he),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){let he=r.VSBuffer.alloc(re),Ee=Math.random()%256;for(let Ce=0;Ce<re;Ce++)he.writeUInt8(Ee,Ce);return he}async $updateRemoteConnectionData(re){this._remoteConnectionData=re,this._onDidChangeRemoteConnectionData.fire()}};V=Te([Re(0,o.IInstantiationService),Re(1,e.IHostUtils),Re(2,f.IExtHostRpcService),Re(3,a.IExtHostWorkspace),Re(4,t.IExtHostConfiguration),Re(5,N.ILogService),Re(6,c.IExtHostInitDataService),Re(7,w.IExtensionStoragePaths),Re(8,p.IExtHostTunnelService),Re(9,m.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function j(le,re){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class Y{constructor(re,he,Ee,Ce){U.set(this,void 0),z.set(this,void 0),q.set(this,void 0),ze(this,U,re,"f"),ze(this,z,he,"f"),ze(this,q,Ee.identifier,"f"),this.id=Ee.identifier.value,this.extensionUri=Ee.extensionLocation,this.extensionPath=O.normalize((0,C.originalFSPath)(Ee.extensionLocation)),this.packageJSON=Ee,this.extensionKind=Ce}get isActive(){return we(this,U,"f").isActivated(we(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return we(this,U,"f").getExtensionExports(we(this,q,"f"))}activate(){return we(this,U,"f").activateByIdWithErrors(we(this,q,"f"),{startup:!1,extensionId:we(this,z,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=Y,U=new WeakMap,z=new WeakMap,q=new WeakMap;function se(le){const re=le.indexOf("+");return re===-1?le:le.substring(0,re)}}),define(me[95],ge([1,0,19,2,5,10,4,6,155,30,32,47,162,31,156,12,3,13,83,63]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,l.createDecorator)("IExtHostDebugService");let r=class{constructor(h,p,m,b,I,k){this._workspaceService=p,this._extensionService=m,this._editorsService=b,this._configurationService=I,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=h.getProxy(x.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(u=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,p){const m=h;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let b=`debug:${encodeURIComponent(m.path||"")}`,I="?";return p&&(b+=`${I}session=${encodeURIComponent(p.id)}`,I="&"),b+=`${I}ref=${m.sourceReference}`,O.URI.parse(b)}else{if(m.path)return O.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const p=[];for(const m of h.getAllExtensionDescriptions())if(m.contributes){const b=m.contributes.debuggers;if(b&&b.length>0)for(const I of b)(0,s.isDebuggerMainContribution)(I)&&p.push(I.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(p=>h.push(p)),h}addBreakpoints(h){this.startBreakpoints();const p=h.filter(I=>{const k=I.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,I),!0)});this.fireBreakpointChanges(p,[],[]);const m=[],b=new Map;for(const I of p)if(I instanceof F.SourceBreakpoint){let k=b.get(I.location.uri.toString());k||(k={type:"sourceMulti",uri:I.location.uri,lines:[]},b.set(I.location.uri.toString(),k),m.push(k)),k.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof F.FunctionBreakpoint&&m.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(m)}removeBreakpoints(h){this.startBreakpoints();const p=h.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],p,[]);const m=p.filter(k=>k instanceof F.SourceBreakpoint).map(k=>k.id),b=p.filter(k=>k instanceof F.FunctionBreakpoint).map(k=>k.id),I=p.filter(k=>k instanceof F.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(m,b,I)}startDebugging(h,p,m){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,p,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===F.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,debugUI:m.debugUI,suppressSaveBeforeStart:m.suppressSaveBeforeStart})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,p,m){if(!p)return new F.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:b,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,m,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,b),new F.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(h,p,m){if(!m)return new F.Disposable(()=>{});if(!this.definesDebugType(h,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:b,factory:m}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,b),new F.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==m),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(h,p){if(!p)return new F.Disposable(()=>{});const m=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:m,factory:p}),new F.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==p)})}async $runInTerminal(h,p){return Promise.resolve(void 0)}async $substituteVariables(h,p){if(!this._variableResolver){const[I,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,k)}let m;const b=await this.getFolder(h);return b&&(m={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(m,p)}createDebugAdapter(h,p){if(h.type==="implementation")return new c(h.implementation)}createSignService(){}async $startDASession(h,p){const m=this,b=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const k=this.convertToDto(I),$=this.createDebugAdapter(k,b);if(!$)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const u=$;return this._debugAdapters.set(h,u),this.getDebugAdapterTrackers(b).then(U=>(U&&this._debugAdaptersTrackers.set(h,U),u.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const q=z,V={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const j=await this._signService.sign(q.arguments.value);V.body={signature:j},u.sendResponse(V)}else throw new Error("no signer")}catch(j){V.success=!1,V.message=j.message,u.sendResponse(V)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(z),z=(0,s.convertToVSCPaths)(z,!0),m._debugServiceProxy.$acceptDAMessage(h,z)}),u.onError(z=>{U&&U.onError&&U.onError(z),this._debugServiceProxy.$acceptDAError(h,z.name,z.message,z.stack)}),u.onExit(z=>{U&&U.onExit&&U.onExit((0,P.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,P.withNullAsUndefined)(z),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),u.startSession()))})}$sendDAMessage(h,p){p=(0,s.convertToDAPaths)(p,!1);const m=this._debugAdaptersTrackers.get(h);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(p);const b=this._debugAdapters.get(h);b&&b.sendMessage(p)}$stopDASession(h){const p=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),p&&p.onWillStopSession&&p.onWillStopSession();const m=this._debugAdapters.get(h);return this._debugAdapters.delete(h),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const p=[],m=[],b=[];if(h.added)for(const I of h.added){const k=I.id;if(k&&!this._breakpoints.has(k)){let $;if(I.type==="function")$=new F.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")$=new F.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const u=O.URI.revive(I.uri);$=new F.SourceBreakpoint(new F.Location(u,new F.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}$._id=k,this._breakpoints.set(k,$),p.push($)}}if(h.removed)for(const I of h.removed){const k=this._breakpoints.get(I);k&&(this._breakpoints.delete(I),m.push(k))}if(h.changed){for(const I of h.changed)if(I.id){const k=this._breakpoints.get(I.id);if(k){if(k instanceof F.FunctionBreakpoint&&I.type==="function"){const $=k;$.enabled=I.enabled,$.condition=I.condition,$.hitCondition=I.hitCondition,$.logMessage=I.logMessage,$.functionName=I.functionName}else if(k instanceof F.SourceBreakpoint&&I.type==="source"){const $=k;$.enabled=I.enabled,$.condition=I.condition,$.hitCondition=I.hitCondition,$.logMessage=I.logMessage,$.location=new F.Location(O.URI.revive(I.uri),new F.Position(I.line,I.character))}b.push(k)}}}this.fireBreakpointChanges(p,m,b)}$provideDebugConfigurations(h,p,m){return(0,C.asPromise)(async()=>{const b=this.getConfigProviderByHandle(h);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(p);return b.provideDebugConfigurations(I,m)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(h,p,m,b){return(0,C.asPromise)(async()=>{const I=this.getConfigProviderByHandle(h);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(p);return I.resolveDebugConfiguration(k,m,b)})}$resolveDebugConfigurationWithSubstitutedVariables(h,p,m,b){return(0,C.asPromise)(async()=>{const I=this.getConfigProviderByHandle(h);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(p);return I.resolveDebugConfigurationWithSubstitutedVariables(k,m,b)})}async $provideDebugAdapter(h,p){const m=this.getAdapterDescriptorFactoryByHandle(h);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(p);return this.getAdapterDescriptor(m,b).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(h){const p=await this.getSession(h);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(h){const p=await this.getSession(h);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,p){const m=await this.getSession(h);m&&m._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(h,p){const b={session:await this.getSession(h),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(h){if(h instanceof F.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof F.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof F.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof F.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const p=this._adapterFactories.filter(m=>m.type===h);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(h){const p=this._adapterFactories.filter(m=>m.handle===h);if(p.length>0)return p[0].factory}getConfigProviderByHandle(h){const p=this._configProviders.filter(m=>m.handle===h);if(p.length>0)return p[0].provider}definesDebugType(h,p){if(h.contributes){const m=h.contributes.debuggers;if(m&&m.length>0){for(const b of m)if(b.label&&b.type&&b.type===p)return!0}}return!1}getDebugAdapterTrackers(h){const m=h.configuration.type,b=this._trackerFactories.filter(I=>I.type===m||I.type==="*").map(I=>(0,C.asPromise)(()=>I.factory.createDebugAdapterTracker(h)).then(k=>k,k=>null));return Promise.race([Promise.all(b).then(I=>{const k=I.filter($=>!!$);if(k.length>0)return new o(k)}),new Promise((I,k)=>{const $=setTimeout(()=>{clearTimeout($),k(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(h,p){const m=p.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new F.DebugAdapterServer(m));if(h){const I=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>h.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,I))).then(k=>{if(k)return k})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,b))}daExecutableFromPackage(h,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,p,m){(h.length>0||p.length>0||m.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:p,changed:m}))}async getSession(h){if(h)if(typeof h=="string"){const p=this._debugSessions.get(h);if(p)return p}else{let p=this._debugSessions.get(h.id);if(!p){const m=await this.getFolder(h.folderUri),b=h.parent?this._debugSessions.get(h.parent):void 0;p=new S(this._debugServiceProxy,h.id,h.type,h.name,m,h.configuration,b),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(h){if(h){const p=O.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};r=Te([Re(0,a.IExtHostRpcService),Re(1,L.IExtHostWorkspace),Re(2,N.IExtHostExtensionService),Re(3,g.IExtHostDocumentsAndEditors),Re(4,d.IExtHostConfiguration),Re(5,E.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class S{constructor(h,p,m,b,I,k,$){this._debugServiceProxy=h,this._id=p,this._type=m,this._name=b,this._workspaceFolder=I,this._configuration=k,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}get parentSession(){return this._parentSession}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,p)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=S;class i{constructor(h){this.value=Object.freeze({append(p){h.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=i;class T extends t.AbstractVariableResolverService{constructor(h,p,m,b,I){function k(){if(p){const $=p.activeEditor();if($)return $.document.uri;const u=b.tabs.filter(U=>U.isActive);if(u.length>0){const U=u[0].resource;return U&&(U.primary||U.secondary)?U.primary??U.secondary:u[0].resource}}}super({getFolderUri:$=>{const u=h.filter(U=>U.name===$);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:($,u)=>m.getConfiguration(void 0,$).get(u),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=k();if($)return n.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const $=k();if($){const u=I.getWorkspaceFolder($);if(u)return n.normalize(u.uri.fsPath)}}},getSelectedText:()=>{if(p){const $=p.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(p){const $=p.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(v.env))}}e.ExtHostVariableResolverService=T;class o{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(p=>p.onError?p.onError(h):void 0)}onExit(h,p){this.trackers.forEach(m=>m.onExit?m.onExit(h,p):void 0)}}class c extends y.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let w=class extends r{constructor(h,p,m,b,I,k){super(h,p,m,b,I,k)}createVariableResolver(h,p,m){return new T(h,p,m,this._editorTabs)}};w=Te([Re(0,a.IExtHostRpcService),Re(1,L.IExtHostWorkspace),Re(2,N.IExtHostExtensionService),Re(3,g.IExtHostDocumentsAndEditors),Re(4,d.IExtHostConfiguration),Re(5,E.IExtHostEditorTabs)],w),e.WorkerExtHostDebugService=w}),define(me[213],ge([1,0,66,2,4,31,26,23,12,27,3,32,83,9,14]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(S,i,T,o,c,w,f){this._apiFactory=S,this._extensionRegistry=i,this._instaService=T,this._extHostConfiguration=o,this._extHostExtensionService=c,this._initData=w,this._logService=f,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),n.mark("code/extHost/willWaitForConfig");const S=await this._extHostConfiguration.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new P(this._apiFactory,i,this._extensionRegistry,S,this._logService)),this.register(this._instaService.createInstance(v,i)),this.register(this._instaService.createInstance(l)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(E,i,this._initData.environment.appUriScheme))}register(S){if("nodeModuleName"in S)if(Array.isArray(S.nodeModuleName))for(let i of S.nodeModuleName)this._factories.set(i,S);else this._factories.set(S.nodeModuleName,S);typeof S.alternativeModuleName=="function"&&this._alternatives.push(i=>S.alternativeModuleName(i))}};a=Te([Re(2,N.IInstantiationService),Re(3,C.IExtHostConfiguration),Re(4,g.IExtHostExtensionService),Re(5,L.IExtHostInitDataService),Re(6,d.ILogService)],a),e.RequireInterceptor=a;let l=class zi{constructor(S){if(S.environment.appRoot&&zi.aliased.size){const i=(0,s.escapeRegExpCharacters)(this.forceForwardSlashes(S.environment.appRoot.fsPath)),T="[a-z0-9_.-]",o=`@${T}+\\/${T}+|${T}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${c}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(S){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(S));if(!i)return;const[,T,o,c]=i,w=zi.aliased.get(o);if(w!==void 0)return console.warn(`${o} as been renamed to ${w}, please update your imports`),T+w+c}forceForwardSlashes(S){return S.replace(/\\/g,"/")}};l.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),l=Te([Re(0,L.IExtHostInitDataService)],l);class P{constructor(S,i,T,o,c){this._apiFactory=S,this._extensionPaths=i,this._extensionRegistry=T,this._configProvider=o,this._logService=c,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(S,i){const T=this._extensionPaths.findSubstr(i);if(T){let o=this._extApiImpl.get(F.ExtensionIdentifier.toKey(T.identifier));return o||(o=this._apiFactory(T,this._extensionRegistry,this._configProvider),this._extApiImpl.set(F.ExtensionIdentifier.toKey(T.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((c,w)=>o+=`	${w} -> ${c.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(x.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(S,i,T){this._extensionPaths=S,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(_.MainContext.MainThreadTelemetry);const{environment:o}=T,c=i.getProxy(_.MainContext.MainThreadKeytar);if(o.appRoot){let w=o.appRoot.fsPath;t.platform==="win32"&&(w=w.replace(/\\/g,"/")),w[w.length-1]==="/"&&(w=w.substr(0,w.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${w}/node_modules.asar/keytar`),this.alternativeNames.add(`${w}/node_modules/keytar`)}this._impl={getPassword:(w,f)=>c.$getPassword(w,f),setPassword:(w,f,h)=>c.$setPassword(w,f,h),deletePassword:(w,f)=>c.$deletePassword(w,f),findPassword:w=>c.$findPassword(w),findCredentials(w){return c.$findCredentials(w)}}}load(S,i){const T=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:T?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(S){const i=S.length;if(i<=7||!this.alternativeNames)return;const T=i-7;if((S.charAt(T)==="/"||S.charAt(T)==="\\")&&S.endsWith("keytar")&&(S=S.replace(/\\/g,"/"),this.alternativeNames.has(S)))return"keytar"}};v=Te([Re(1,y.IExtHostRpcService),Re(2,L.IExtHostInitDataService)],v);let E=class{constructor(S,i,T){this._extensionPaths=S,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=T.getProxy(_.MainContext.MainThreadTelemetry);const o=T.getProxy(_.MainContext.MainThreadWindow);this._impl=(c,w)=>{const f=O.URI.parse(c);return w?this.callOriginal(c,w):f.scheme==="http"||f.scheme==="https"?o.$openUri(f,c,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this._appUriScheme?o.$openUri(f,c,{}):this.callOriginal(c,w)}}load(S,i,T){const o=this._extensionPaths.findSubstr(i);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=T(S),this._impl}callOriginal(S,i){return this.sendNoForwardTelemetry(),this._original(S,i)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};E=Te([Re(2,y.IExtHostRpcService)],E)}),define(me[214],ge([1,0,10,15,66,7,2,4,207,9,43,54,27,134,12,58,32,39]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(r,S,i,T,o){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new y.RPCProtocol(r,null,T),S=v._transform(S,this._rpcProtocol);const c=new g.ServiceCollection(...(0,N.getSingletonServiceDescriptors)());c.set(t.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:o}),c.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),c.set(a.IURITransformerService,new a.URITransformerService(T)),c.set(l.IHostUtils,i);const w=new d.InstantiationService(c,!0);this._disposables.add(w.invokeFunction(m=>m.get(P.IExtHostTerminalService))),this._disposables.add(w.invokeFunction(m=>m.get(l.IExtHostExtensionService))),this._logService=w.invokeFunction(m=>m.get(L.ILogService)),_.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",S),this._extensionService=w.invokeFunction(m=>m.get(l.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(m=>{Error.prepareStackTrace=(b,I)=>{let k="",$,u;for(const U of I)k+=`
	at ${U.toString()}`,u=U.getFileName(),!$&&u&&($=m.findSubstr(x.URI.file(u)));return f.set(b,$),`${b.name||"Error"}: ${b.message||""}${k}`}});const h=this._rpcProtocol.getProxy(F.MainContext.MainThreadExtensionService),p=this._rpcProtocol.getProxy(F.MainContext.MainThreadErrors);O.setUnexpectedErrorHandler(m=>{const b=O.transformErrorForSerialization(m),I=f.get(m);I?h.$onExtensionRuntimeError(I.identifier,b):p.$onUnexpectedError(b)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),O.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const S=this._extensionService.deactivateAll();Promise.race([(0,n.timeout)(5e3),S]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,S){r.extensions.forEach(T=>T.extensionLocation=x.URI.revive(S.transformIncomingURIs(T.extensionLocation))),r.environment.appRoot=x.URI.revive(S.transformIncomingURIs(r.environment.appRoot));const i=r.environment.extensionDevelopmentLocationURI;return i&&(r.environment.extensionDevelopmentLocationURI=i.map(T=>x.URI.revive(S.transformIncomingURIs(T)))),r.environment.extensionTestsLocationURI=x.URI.revive(S.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=x.URI.revive(S.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=x.URI.revive(S.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=x.URI.revive(S.transformIncomingURIs(r.logsLocation)),r.logFile=x.URI.revive(S.transformIncomingURIs(r.logFile)),r.workspace=S.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=v}),define(me[215],ge([1,0,19,20,42,36,24,188,40]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class L{constructor(t,d,s){this.config=t,this.provider=d,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=t.filePattern,this.includePattern=t.includePattern&&C.parse(t.includePattern),this.maxResults=t.maxResults||void 0,this.exists=t.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=t.excludePattern&&C.parse(t.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(t=>t.cancel()),this.activeCancellationTokens=new Set}search(t){const d=this.config.folderQueries||[];return new Promise((s,a)=>{const l=P=>{this.resultCount++,t(P)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const v=P.toString(),E=n.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,E)||this.matchFile(l,{base:P,basename:E})}),Promise.all(d.map(P=>this.searchInFolder(P,l))).then(P=>{s({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{a(new Error((0,_.toErrorMessage)(P)))})})}async searchInFolder(t,d){const s=new O.CancellationTokenSource,a=this.getSearchOptionsForFolder(t),l=this.initDirectoryTree(),P=new y.QueryGlobTester(this.config,t),v=!P.hasSiblingExcludeClauses();let E;try{this.activeCancellationTokens.add(s),E=F.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,s.token),S=E.elapsed(),i=F.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(T=>{const o=n.posix.relative(t.folder.path,T.path);if(v){const c=n.basename(T.path);this.matchFile(d,{base:t.folder,relativePath:o,basename:c});return}this.addDirectoryEntries(l,t.folder,o,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(l,P,d),{providerTime:S,postProcessTime:i.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(t){const d=(0,y.resolvePatternsForProvider)(this.config.includePattern,t.includePattern),s=(0,y.resolvePatternsForProvider)(this.config.excludePattern,t.excludePattern);return{folder:t.folder,excludes:s,includes:d,useIgnoreFiles:!t.disregardIgnoreFiles,useGlobalIgnoreFiles:!t.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!t.disregardParentIgnoreFiles,followSymlinks:!t.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries({pathToEntries:t},d,s,a){if(s===this.filePattern){const P=n.basename(this.filePattern);this.matchFile(a,{base:d,relativePath:this.filePattern,basename:P})}function l(P){const v=n.basename(P),E=n.dirname(P);let r=t[E];r||(r=t[E]=[],l(E)),r.push({base:d,relativePath:P,basename:v})}l(s)}matchDirectoryTree({rootEntries:t,pathToEntries:d},s,a){const l=this,P=this.filePattern;function v(E){const r=C.hasSiblingFn(()=>E.map(S=>S.basename));for(let S=0,i=E.length;S<i;S++){const T=E[S],{relativePath:o,basename:c}=T;if(s.matchesExcludesSync(o,c,P!==c?r:void 0))continue;const w=d[o];if(w)v(w);else{if(o===P)continue;l.matchFile(a,T)}if(l.isLimitHit)break}}v(t)}matchFile(t,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||t(d))}}class N{constructor(){this.sessions=new Map}fileSearch(t,d,s,a){const l=this.getSessionTokenSource(t.cacheKey),P=new L(t,d,l&&l.token);let v=0;const E=r=>{v+=r.length,s(r.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(P,N.BATCH_SIZE,E,a).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:r.stats}}))}clearCache(t){const d=this.getSessionTokenSource(t);d&&d.cancel()}getSessionTokenSource(t){if(!!t)return this.sessions.has(t)||this.sessions.set(t,new O.CancellationTokenSource),this.sessions.get(t)}rawMatchToSearchItem(t){return t.relativePath?{resource:x.joinPath(t.base,t.relativePath)}:{resource:t.base}}doSearch(t,d,s,a){a.onCancellationRequested(()=>{t.cancel()});const l=v=>{v&&(P.push(v),d>0&&P.length>=d&&(s(P),P=[]))};let P=[];return t.search(l).then(v=>(P.length&&s(P),v),v=>(P.length&&s(P),Promise.reject(v)))}}e.FileSearchManager=N,N.BATCH_SIZE=512}),define(me[216],ge([1,0,16,10,20,42,36,11,19,24,13,2,40]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(r,S,i,T){this.query=r,this.provider=S,this.fileUtils=i,this.processType=T,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(r,S){const i=this.query.folderQueries||[],T=new _.CancellationTokenSource;return S.onCancellationRequested(()=>T.cancel()),new Promise((o,c)=>{this.collector=new a(r);let w=!1;const f=(h,p)=>{if(!w&&!this.isLimitHit){const m=this.resultSize(h);P(h)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,w=!0,T.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const b=this.resultSize(h);this.resultCount+=b,(b>0||!P(h))&&this.collector.add(h,p)}};Promise.all(i.map((h,p)=>this.searchInFolder(h,m=>f(m,p),T.token))).then(h=>{T.dispose(),this.collector.flush();const p=h.some(m=>!!m&&!!m.limitHit);o({limitHit:this.isLimitHit||p,messages:(0,n.flatten)(h.map(m=>m?.message?(0,N.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},h=>{T.dispose();const p=(0,C.toErrorMessage)(h);c(new Error(p))})})}resultSize(r){return P(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}trimResultToSize(r,S){const i=Array.isArray(r.ranges)?r.ranges:[r.ranges],T=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:i.slice(0,S),preview:{matches:T.slice(0,S),text:r.preview.text},uri:r.uri}}async searchInFolder(r,S,i){const T=new t.QueryGlobTester(this.query,r),o=[],c={report:h=>{if(!this.validateProviderResult(h))return;const p=r.folder.scheme===F.Schemas.file?x.hasSiblingPromiseFn(()=>this.fileUtils.readdir(L.dirname(h.uri))):void 0,m=L.relativePath(r.folder,h.uri);if(m){const b=T.includedInQuery(m,y.basename(m),p);(0,O.isThenable)(b)?o.push(b.then(I=>{I&&S(h)})):b&&S(h)}}},w=this.getSearchOptionsForFolder(r),f=await this.provider.provideTextSearchResults(s(this.query.contentPattern),w,c,i);return o.length&&await Promise.all(o),f}validateProviderResult(r){if(P(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(r){const S=(0,t.resolvePatternsForProvider)(this.query.includePattern,r.includePattern),i=(0,t.resolvePatternsForProvider)(this.query.excludePattern,r.excludePattern),T={folder:g.URI.from(r.folder),excludes:i,includes:S,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.fileUtils.toCanonicalName(r.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return T.usePCRE2=this.query.usePCRE2,T}}e.TextSearchManager=d;function s(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class a{constructor(r){this._onResult=r,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new v(512,S=>this.sendItems(S))}add(r,S){this._currentFileMatch&&(this._currentFolderIdx!==S||!L.isEqual(this._currentUri,r.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=S,this._currentFileMatch={resource:r.uri,results:[]}),this._currentFileMatch.results.push(l(r))}pushToCollector(){const r=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,r)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(r){this._onResult(r)}}e.TextSearchResultsCollector=a;function l(E){return P(E)?{preview:{matches:(0,n.mapArrayOrNot)(E.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:E.preview.text},ranges:(0,n.mapArrayOrNot)(E.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function P(E){return!!E.preview}e.extensionResultIsMatch=P;class v{constructor(r,S){this.maxBatchSize=r,this.cb=S,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(r,S){!r||this.addItemToBatch(r,S)}addItems(r,S){!r||this.addItemsToBatch(r,S)}addItemToBatch(r,S){this.batch.push(r),this.batchSize+=S,this.onUpdate()}addItemsToBatch(r,S){this.batch=this.batch.concat(r),this.batchSize+=S,this.onUpdate()}onUpdate(){this.totalNumberCompleted<v.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},v.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=v,v.TIMEOUT=4e3,v.START_BATCH_AFTER_COUNT=50}),define(me[96],ge([1,0,7,4,3,215,12,58,9,2,216]),function(Z,e,n,O,_,C,x,F,y,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let g=class{constructor(a,l,P){this.extHostRpc=a,this._uriTransformer=l,this._logService=P,this._proxy=this.extHostRpc.getProxy(O.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,l){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const P=this._handlePool++;return this._textSearchProvider.set(P,l),this._proxy.$registerTextSearchProvider(P,this._transformScheme(a)),(0,n.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(a,l){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const P=this._handlePool++;return this._fileSearchProvider.set(P,l),this._proxy.$registerFileSearchProvider(P,this._transformScheme(a)),(0,n.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(a,l,P,v){const E=t(P),r=this._fileSearchProvider.get(a);if(r)return this._fileSearchManager.fileSearch(E,r,S=>{this._proxy.$handleFileMatch(a,l,S.map(i=>i.resource))},v);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,l,P,v){const E=this._textSearchProvider.get(a);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const r=t(P);return this.createTextSearchManager(r,E).search(i=>this._proxy.$handleTextMatch(a,l,i),v)}$enableExtensionHostSearch(){}createTextSearchManager(a,l){return new N.TextSearchManager(a,l,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};g=Te([Re(0,x.IExtHostRpcService),Re(1,F.IURITransformerService),Re(2,y.ILogService)],g),e.ExtHostSearch=g;function t(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(d),extraFileResources:s.extraFileResources&&s.extraFileResources.map(a=>L.URI.revive(a))}}e.reviveQuery=t;function d(s){return{...s,folder:L.URI.revive(s.folder)}}}),define(me[217],ge([1,0,43,91,30,89,31,38,47,39,94,95,96,64,57,62,92,48,29,61,79,63,190,9,172]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E,r,S,i,T,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(T.ILoggerService,i.ExtHostLoggerService),(0,n.registerSingleton)(T.ILogService,o.ExtHostLogService),(0,n.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService),(0,n.registerSingleton)(F.IExtHostCommands,F.ExtHostCommands),(0,n.registerSingleton)(x.IExtHostConfiguration,x.ExtHostConfiguration),(0,n.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,n.registerSingleton)(g.IExtHostDebugService,g.WorkerExtHostDebugService),(0,n.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,n.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,n.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,n.registerSingleton)(O.IExtHostOutputService,O.ExtHostOutputService),(0,n.registerSingleton)(t.IExtHostSearch,t.ExtHostSearch),(0,n.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,n.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask),(0,n.registerSingleton)(L.IExtHostTerminalService,L.WorkerExtHostTerminalService),(0,n.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,n.registerSingleton)(l.IExtHostWindow,l.ExtHostWindow),(0,n.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,n.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState),(0,n.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,n.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs)}),define(me[218],ge([1,0,43,3]),function(Z,e,n,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,O.createDecorator)("treeViewsDragAndDropService");class _{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(x){if(x&&this._dragOperations.has(x)){const F=this._dragOperations.get(x);return this._dragOperations.delete(x),F}}addDragOperationTransfer(x,F){this._dragOperations.set(x,F)}}e.TreeViewsDragAndDropService=_,(0,n.registerSingleton)(e.ITreeViewsDragAndDropService,_)}),define(me[219],ge([1,0,123,24,2,5,7,10,6,13,16,8,20,152,218]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(v,E){if((0,L.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let r;return Array.isArray(v.highlights)&&(r=v.highlights.filter(S=>S.length===2&&typeof S[0]=="number"&&typeof S[1]=="number"),r=r.length?r:void 0),{label:v.label,highlights:r}}}class l{constructor(E,r,S){this._proxy=E,this.commands=r,this.logService=S,this.treeViews=new Map,this.treeDragAndDropService=new s.TreeViewsDragAndDropService;function i(T){return T&&T.$treeViewId&&T.$treeItemHandle}r.registerArgumentProcessor({processArgument:T=>i(T)?this.convertArgument(T):Array.isArray(T)&&T.length>0?T.map(o=>i(o)?this.convertArgument(o):o):T})}registerTreeDataProvider(E,r,S){const i=this.createTreeView(E,{treeDataProvider:r},S);return{dispose:()=>i.dispose()}}createTreeView(E,r,S){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=r.dragAndDropController?.supportedMimeTypes,T=!!r.dragAndDropController?.handleDrag,o=this._proxy.$registerTreeViewDataProvider(E,{showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dragAndDropMimeTypes:i,hasHandleDrag:T}),c=this.createExtHostTreeView(E,r,S);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(w){c.message=w},get title(){return c.title},set title(w){c.title=w},get description(){return c.description},set description(w){c.description=w},reveal:(w,f)=>c.reveal(w,f),dispose:async()=>{await o,this.treeViews.delete(E),c.dispose()}}}$getChildren(E,r){const S=this.treeViews.get(E);return S?S.getChildren(r):Promise.reject(new Error((0,n.localize)(0,null,E)))}async $handleDrop(E,r,S,i,T,o){const c=this.treeViews.get(E);if(!c)return Promise.reject(new Error((0,n.localize)(1,null,E)));const w=d.TreeDataTransferConverter.toITreeDataTransfer(r);return T===E&&o&&await this.addAdditionalTransferItems(w,c,o,i),c.onDrop(w,S)}async addAdditionalTransferItems(E,r,S,i){const T=this.treeDragAndDropService.removeDragOperationTransfer(i);if(T)(await T)?.forEach((o,c)=>{o&&E.set(c,o)});else if(i&&r.handleDrag){const o=r.handleDrag(S,E);this.treeDragAndDropService.addDragOperationTransfer(i,o),await o}return E}async $handleDrag(E,r,S){const i=this.treeViews.get(E);if(!i)return Promise.reject(new Error((0,n.localize)(2,null,E)));const T=await this.addAdditionalTransferItems(new Map,i,r,S);if(!!T)return d.TreeDataTransferConverter.toTreeDataTransferDTO(T)}async $hasResolve(E){const r=this.treeViews.get(E);if(!r)throw new Error((0,n.localize)(3,null,E));return r.hasResolve}$resolve(E,r,S){const i=this.treeViews.get(E);if(!i)throw new Error((0,n.localize)(4,null,E));return i.resolveTreeItem(r,S)}$setExpanded(E,r,S){const i=this.treeViews.get(E);if(!i)throw new Error((0,n.localize)(5,null,E));i.setExpanded(r,S)}$setSelection(E,r){const S=this.treeViews.get(E);if(!S)throw new Error((0,n.localize)(6,null,E));S.setSelection(r)}$setVisible(E,r){const S=this.treeViews.get(E);if(!S)throw new Error((0,n.localize)(7,null,E));S.setVisible(r)}createExtHostTreeView(E,r,S){const i=new P(E,r,this._proxy,this.commands.converter,this.logService,S);return this.treeViews.set(E,i),i}convertArgument(E){const r=this.treeViews.get(E.$treeViewId);return r?r.getExtensionElement(E.$treeItemHandle):null}}e.ExtHostTreeViews=l;class P extends x.Disposable{constructor(E,r,S,i,T,o){super();if(this.viewId=E,this.proxy=S,this.commands=i,this.logService=T,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new t.CancellationTokenSource,o.contributes&&o.contributes.views)for(const f in o.contributes.views)for(const h of o.contributes.views[f])h.id===E&&(this._title=h.name);this.dataProvider=r.treeDataProvider,this.dndController=r.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let c,w;this._register(C.Event.debounce(this._onDidChangeData.event,(f,h)=>(f||(f={message:!1,elements:[]}),h.element!==!1&&(c||(c=new Promise(p=>w=p),this.refreshPromise=this.refreshPromise.then(()=>c)),Array.isArray(h.element)?f.elements.push(...h.element):f.elements.push(h.element)),h.message&&(f.message=!0),f),200,!0)(({message:f,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=w;return c=null,this.refresh(h).then(()=>p())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(E=>this.getExtensionElement(E)).filter(E=>!(0,L.isUndefinedOrNull)(E))}async getChildren(E){const r=E?this.getExtensionElement(E):void 0;if(E&&!r)return this.logService.error(`No tree item with id '${E}' found.`),Promise.resolve([]);let S=this.getChildrenNodes(E);return S||(S=await this.fetchChildrenNodes(r)),S?S.map(i=>i.item):void 0}getExtensionElement(E){return this.elements.get(E)}reveal(E,r){r=r||{select:!0,focus:!1};const S=(0,L.isUndefinedOrNull)(r.select)?!0:r.select,i=(0,L.isUndefinedOrNull)(r.focus)?!1:r.focus,T=(0,L.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):E?this.refreshPromise.then(()=>this.resolveUnknownParentChain(E)).then(o=>this.resolveTreeNode(E,o[o.length-1]).then(c=>this.proxy.$reveal(this.viewId,{item:c.item,parentChain:o.map(w=>w.item)},{select:S,focus:i,expand:T})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:S,focus:i,expand:T})}get message(){return this._message}set message(E){this._message=E,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(E){this._title=E,this.proxy.$setTitle(this.viewId,E,this._description)}get description(){return this._description}set description(E){this._description=E,this.proxy.$setTitle(this.viewId,this._title,E)}setExpanded(E,r){const S=this.getExtensionElement(E);S&&(r?this._onDidExpandElement.fire(Object.freeze({element:S})):this._onDidCollapseElement.fire(Object.freeze({element:S})))}setSelection(E){(0,N.equals)(this._selectedHandles,E)||(this._selectedHandles=E,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(E){E!==this._visible&&(this._visible=E,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(E,r){const S=[];for(const i of E){const T=this.getExtensionElement(i);T&&S.push(T)}if(!(!this.dndController?.handleDrag||S.length===0))return await this.dndController.handleDrag(S,r),r}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(E,r){const S=this.getExtensionElement(r);if(!!S)return(0,F.asPromise)(()=>this.dndController?.handleDrop(E,S))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(E,r){if(!this.dataProvider.resolveTreeItem)return;const S=this.elements.get(E);if(S){const i=this.nodes.get(S);if(i){const T=await this.dataProvider.resolveTreeItem(i.extensionItem,S,r)??i.extensionItem;return i.item.tooltip=this.getTooltip(T.tooltip),i.item.command=this.getCommand(i.disposableStore,T.command),i.item}}}resolveUnknownParentChain(E){return this.resolveParent(E).then(r=>r?this.resolveUnknownParentChain(r).then(S=>this.resolveTreeNode(r,S[S.length-1]).then(i=>(S.push(i),S))):Promise.resolve([]))}resolveParent(E){const r=this.nodes.get(E);return r?Promise.resolve(r.parent?this.elements.get(r.parent.item.handle):void 0):(0,F.asPromise)(()=>this.dataProvider.getParent(E))}resolveTreeNode(E,r){const S=this.nodes.get(E);return S?Promise.resolve(S):(0,F.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(i=>this.createHandle(E,i,r,!0)).then(i=>this.getChildren(r?r.item.handle:void 0).then(()=>{const T=this.getExtensionElement(i);if(T){const o=this.nodes.get(T);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(E){if(E){let r;if(typeof E=="string"){const S=this.getExtensionElement(E);r=S?this.nodes.get(S):void 0}else r=E;return r&&r.children||void 0}return this.roots}async fetchChildrenNodes(E){this.clearChildren(E);const r=new t.CancellationTokenSource(this._refreshCancellationSource.token);try{const S=E?this.nodes.get(E):void 0,i=await this.dataProvider.getChildren(E);if(r.token.isCancellationRequested)return;const T=await Promise.all((0,N.coalesce)(i||[]).map(async o=>{const c=await this.dataProvider.getTreeItem(o);return c&&!r.token.isCancellationRequested?this.createAndRegisterTreeNode(o,c,S):null}));return r.token.isCancellationRequested?void 0:(0,N.coalesce)(T)}finally{r.dispose()}}refresh(E){if(E.some(S=>!S))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new t.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const S=this.getHandlesToRefresh(E);if(S.length)return this.refreshHandles(S)}return Promise.resolve(void 0)}getHandlesToRefresh(E){const r=new Set,S=E.map(T=>this.nodes.get(T));for(const T of S)if(T&&!r.has(T.item.handle)){let o=T;for(;o&&o.parent&&S.findIndex(c=>o&&o.parent&&c&&c.item.handle===o.parent.item.handle)===-1;){const c=this.elements.get(o.parent.item.handle);o=c?this.nodes.get(c):void 0}o&&!o.parent&&r.add(T.item.handle)}const i=[];return r.forEach(T=>{const o=this.elements.get(T);if(o){const c=this.nodes.get(o);c&&(!c.parent||!r.has(c.parent.item.handle))&&i.push(T)}}),i}refreshHandles(E){const r={};return Promise.all(E.map(S=>this.refreshNode(S).then(i=>{i&&(r[S]=i.item)}))).then(()=>Object.keys(r).length?this.proxy.$refresh(this.viewId,r):void 0)}refreshNode(E){const r=this.getExtensionElement(E);if(r){const S=this.nodes.get(r);if(S)return this.clearChildren(r),(0,F.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(i=>{if(i){const T=this.createTreeNode(r,i,S.parent);return this.updateNodeCache(r,T,S,S.parent),S.dispose(),T}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(E,r,S){const i=this.createTreeNode(E,r,S);if(r.id&&this.elements.has(i.item.handle))throw new Error((0,n.localize)(8,null,r.id));return this.addNodeToCache(E,i),this.addNodeToParentCache(i,S),i}getTooltip(E){return y.MarkdownString.isMarkdownString(E)?g.MarkdownString.from(E):E}getCommand(E,r){return r?this.commands.toInternal(r,E):void 0}createTreeNode(E,r,S){const i=new x.DisposableStore,T=this.createHandle(E,r,S),o=this.getLightIconPath(r);return{item:{handle:T,parentHandle:S?S.item.handle:void 0,label:a(r.label,this.extension),description:r.description,resourceUri:r.resourceUri,tooltip:this.getTooltip(r.tooltip),command:this.getCommand(i,r.command),contextValue:r.contextValue,icon:o,iconDark:this.getDarkIconPath(r)||o,themeIcon:this.getThemeIcon(r),collapsibleState:(0,L.isUndefinedOrNull)(r.collapsibleState)?y.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation},extensionItem:r,parent:S,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(E){return E.iconPath instanceof y.ThemeIcon?E.iconPath:void 0}createHandle(E,{id:r,label:S,resourceUri:i},T,o){if(r)return`${P.ID_HANDLE_PREFIX}/${r}`;const c=a(S,this.extension),w=T?T.item.handle:P.LABEL_HANDLE_PREFIX;let f=c?c.label:i?(0,O.basename)(i):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const h=this.nodes.has(E)?this.nodes.get(E).item.handle:void 0,p=this.getChildrenNodes(T)||[];let m,b=0;do{if(m=`${w}/${b}:${f}`,o||!this.elements.has(m)||h===m)break;b++}while(b<=p.length);return m}getLightIconPath(E){if(E.iconPath&&!(E.iconPath instanceof y.ThemeIcon))return typeof E.iconPath=="string"||_.URI.isUri(E.iconPath)?this.getIconPath(E.iconPath):this.getIconPath(E.iconPath.light)}getDarkIconPath(E){if(E.iconPath&&!(E.iconPath instanceof y.ThemeIcon)&&E.iconPath.dark)return this.getIconPath(E.iconPath.dark)}getIconPath(E){return _.URI.isUri(E)?E:_.URI.file(E)}addNodeToCache(E,r){this.elements.set(r.item.handle,E),this.nodes.set(E,r)}updateNodeCache(E,r,S,i){this.elements.delete(r.item.handle),this.nodes.delete(E),r.item.handle!==S.item.handle&&this.elements.delete(S.item.handle),this.addNodeToCache(E,r);const T=this.getChildrenNodes(i)||[],o=T.filter(c=>c.item.handle===S.item.handle)[0];o&&T.splice(T.indexOf(o),1,r)}addNodeToParentCache(E,r){r?(r.children||(r.children=[]),r.children.push(E)):(this.roots||(this.roots=[]),this.roots.push(E))}clearChildren(E){if(E){const r=this.nodes.get(E);if(r){if(r.children)for(const S of r.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}r.children=void 0}}else this.clearAll()}clear(E){const r=this.nodes.get(E);if(r){if(r.children)for(const S of r.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}this.nodes.delete(E),this.elements.delete(r.item.handle),r.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(E=>E.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(me[220],ge([1,0,20,15,5,33,2,112,232,107,149,44,4,177,176,38,178,31,179,180,181,164,182,47,32,183,184,187,189,191,91,166,196,197,198,64,39,200,219,8,6,203,49,92,30,67,153,186,78,89,94,95,96,9,58,12,27,192,150,57,62,174,201,148,65,48,206,204,205,175,29,199,202,61,63,79,194,93,195,11,136,193,146,185,7,26]),function(Z,e,n,O,_,C,x,F,y,L,N,g,t,d,s,a,l,P,v,E,r,S,i,T,o,c,w,f,h,p,m,b,I,k,$,u,U,z,q,V,j,Y,se,le,re,he,Ee,Ce,Pe,Be,je,tt,Ge,ot,mt,ve,ce,M,A,D,R,H,Q,te,de,Se,Ae,Fe,Ue,Oe,ke,qe,it,De,Ze,G,X,oe,Ie,Ne,Ve,Ye,ht,_t,Dt,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Pt(Ke){const ut=Ke.get(ce.IExtHostInitDataService),Tt=Ke.get(ke.IExtHostFileSystemInfo),At=Ke.get(Se.IExtHostConsumerFileSystem),wt=Ke.get(o.IExtHostExtensionService),at=Ke.get(re.IExtHostWorkspace),yt=Ke.get(G.IExtHostTelemetry),Mt=Ke.get(P.IExtHostConfiguration),Ot=Ke.get(mt.IURITransformerService),Me=Ke.get(ve.IExtHostRpcService),ae=Ke.get(u.IExtHostStorage),ue=Ke.get(de.IExtensionStoragePaths),ne=Ke.get(ot.ILoggerService),K=Ke.get(ot.ILogService),pe=Ke.get(D.IExtHostTunnelService),_e=Ke.get(R.IExtHostApiDeprecationService),$e=Ke.get(le.IExtHostWindow),Le=Ke.get(De.IExtHostSecretState),nt=Ke.get(Ze.IExtHostEditorTabs);Me.set(t.ExtHostContext.ExtHostFileSystemInfo,Tt),Me.set(t.ExtHostContext.ExtHostLogLevelServiceShape,ne),Me.set(t.ExtHostContext.ExtHostWorkspace,at),Me.set(t.ExtHostContext.ExtHostConfiguration,Mt),Me.set(t.ExtHostContext.ExtHostExtensionService,wt),Me.set(t.ExtHostContext.ExtHostStorage,ae),Me.set(t.ExtHostContext.ExtHostTunnelService,pe),Me.set(t.ExtHostContext.ExtHostWindow,$e),Me.set(t.ExtHostContext.ExtHostSecretState,Le),Me.set(t.ExtHostContext.ExtHostTelemetry,yt),Me.set(t.ExtHostContext.ExtHostEditorTabs,nt);const pt=Me.set(t.ExtHostContext.ExtHostDecorations,Ke.get(Be.IExtHostDecorations)),vt=Me.set(t.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(T.IExtHostDocumentsAndEditors)),et=Me.set(t.ExtHostContext.ExtHostCommands,Ke.get(a.IExtHostCommands)),lt=Me.set(t.ExtHostContext.ExtHostTerminalService,Ke.get(U.IExtHostTerminalService)),st=Me.set(t.ExtHostContext.ExtHostDebugService,Ke.get(tt.IExtHostDebugService)),Ut=Me.set(t.ExtHostContext.ExtHostSearch,Ke.get(Ge.IExtHostSearch)),Ct=Me.set(t.ExtHostContext.ExtHostTask,Ke.get(je.IExtHostTask)),Ft=Me.set(t.ExtHostContext.ExtHostOutputService,Ke.get(m.IExtHostOutputService)),Et=Me.set(t.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(Me)),dt=Me.set(t.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Me,vt)),Lt=Me.set(t.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(Me,vt,K)),qt=Me.set(t.ExtHostContext.ExtHostDocumentSaveParticipant,new S.ExtHostDocumentSaveParticipant(K,dt,Me.getProxy(t.MainContext.MainThreadBulkEdits))),ct=Me.set(t.ExtHostContext.ExtHostNotebook,new M.ExtHostNotebookController(Me,et,vt,dt,ue)),Bt=Me.set(t.ExtHostContext.ExtHostNotebookDocuments,new ht.ExtHostNotebookDocuments(K,ct)),Gt=Me.set(t.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(K,Me,ct)),Xt=Me.set(t.ExtHostContext.ExtHostNotebookKernels,new X.ExtHostNotebookKernels(Me,ut,ct,et,K)),ai=Me.set(t.ExtHostContext.ExtHostNotebookRenderers,new Ie.ExtHostNotebookRenderers(Me,ct)),It=Me.set(t.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(Me,vt)),Jt=Me.set(t.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(Me.getProxy(t.MainContext.MainThreadTreeViews),et,K)),li=Me.set(t.ExtHostContext.ExtHostEditorInsets,new Ee.ExtHostEditorInsets(Me.getProxy(t.MainContext.MainThreadEditorInsets),It,ut)),Kt=Me.set(t.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Me,K,Tt)),Zt=Me.set(t.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Me,dt,et.converter,Ot)),rt=Me.set(t.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(Me,Ot,dt,et,Kt,K,_e)),ci=Me.set(t.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Me,rt)),Nt=Me.set(t.ExtHostContext.ExtHostFileSystemEventService,new w.ExtHostFileSystemEventService(Me,K,vt)),zt=Me.set(t.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(Me,at,et)),vi=Me.set(t.ExtHostContext.ExtHostSCM,new k.ExtHostSCM(Me,et,K)),ui=Me.set(t.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Me,et,dt)),ei=Me.set(t.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(Me.getProxy(t.MainContext.MainThreadProgress))),yi=Me.set(t.ExtHostContext.ExtHosLabelService,new Ce.ExtHostLabelService(Me)),Ei=Me.set(t.ExtHostContext.ExtHostTheming,new A.ExtHostTheming(Me)),ti=Me.set(t.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Me)),Ci=Me.set(t.ExtHostContext.ExtHostTimeline,new Q.ExtHostTimeline(Me,et)),di=Me.set(t.ExtHostContext.ExtHostWebviews,new se.ExtHostWebviews(Me,{remote:ut.remote},at,K,_e)),Qt=Me.set(t.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(Me,di,at)),hi=Me.set(t.ExtHostContext.ExtHostCustomEditors,new Fe.ExtHostCustomEditors(Me,dt,ue,di,Qt)),Ii=Me.set(t.ExtHostContext.ExtHostWebviewViews,new Ae.ExtHostWebviewViews(Me,di)),Yt=Me.set(t.ExtHostContext.ExtHostTesting,new qe.ExtHostTesting(Me,et)),ki=Me.set(t.ExtHostContext.ExtHostUriOpeners,new it.ExtHostUriOpeners(Me));Me.set(t.ExtHostContext.ExtHostInteractive,new _t.ExtHostInteractive(Me,ct,vt,et));const Pi=(0,he.values)(t.ExtHostContext);Me.assertRegistered(Pi);const ii=new Oe.ExtHostBulkEdits(Me,vt),Ti=new s.ExtHostClipboard(Me),fi=new p.ExtHostMessageService(Me,K),bi=new E.ExtHostDialogs(Me),ni=new $.ExtHostStatusBar(Me,et.converter);return d.ExtHostApiCommands.register(et),function(ye,Wt,$t){const ft=function(){let J=!ye.isUnderDevelopment;function ie(){J||(K.info(`Extension '${ye.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function be(Xe){if(Array.isArray(Xe))Xe.forEach(be);else if(typeof Xe=="string")ie();else{const gt=Xe;typeof gt.scheme=="undefined"&&ie(),typeof gt.exclusive=="boolean"&&(0,He.checkProposedApiEnabled)(ye,"documentFiltersExclusive")}return Xe}}(),Rt={getSession(J,ie,be){return ti.getSession(ye,J,ie,be)},async hasSession(J,ie){return(0,He.checkProposedApiEnabled)(ye,"authSession"),!!await ti.getSession(ye,J,ie,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(J,ie,be,Xe){return ti.registerAuthenticationProvider(J,ie,be,Xe)}},ri={registerCommand(J,ie,be){return et.registerCommand(!0,J,ie,be,void 0,ye)},registerTextEditorCommand(J,ie,be){return et.registerCommand(!0,J,(...Xe)=>{const gt=It.getActiveTextEditor();if(!gt){K.warn("Cannot execute "+J+" because there is no active text editor.");return}return gt.edit(St=>{ie.apply(be,[gt,St,...Xe])}).then(St=>{St||K.warn("Edits from command "+J+" were not applied.")},St=>{K.warn("An error occurred while running command "+J,St)})},void 0,void 0,ye)},registerDiffInformationCommand:(J,ie,be)=>((0,He.checkProposedApiEnabled)(ye,"diffCommand"),et.registerCommand(!0,J,async(...Xe)=>{const gt=vt.activeEditor(!0);if(!gt){K.warn("Cannot execute "+J+" because there is no active text editor.");return}const St=await It.getDiffInformation(gt.id);ie.apply(be,[St,...Xe])},void 0,void 0,ye)),executeCommand(J,...ie){return et.executeCommand(J,...ie)},getCommands(J=!1){return et.getCommands(J)}},wi={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return lt.getDefaultShell(!1)},get isTelemetryEnabled(){return yt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return yt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,He.checkProposedApiEnabled)(ye,"telemetry"),yt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,He.checkProposedApiEnabled)(ye,"telemetry"),yt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const J=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ie){return $e.openUri(J,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:ie?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===ut.environment.appUriScheme)return Et.createAppUri(J);try{return await $e.asExternalUri(J,{allowTunneling:!!ut.remote.authority})}catch(ie){if((0,Ve.matchesScheme)(J,Ne.Schemas.http)||(0,Ve.matchesScheme)(J,Ne.Schemas.https))return J;throw ie}},get remoteName(){return(0,Pe.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,He.checkProposedApiEnabled)(ye,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(wi);const Si=ut.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Ai={createTestController(J,ie,be){return be&&(0,He.checkProposedApiEnabled)(ye,"testRefresh"),Yt.createTestController(J,ie,be)},createTestObserver(){return(0,He.checkProposedApiEnabled)(ye,"testObserver"),Yt.createTestObserver()},runTests(J){return(0,He.checkProposedApiEnabled)(ye,"testObserver"),Yt.runTests(J)},get onDidChangeTestResults(){return(0,He.checkProposedApiEnabled)(ye,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,He.checkProposedApiEnabled)(ye,"testObserver"),Yt.results}},Ri={getExtension(J){const ie=Wt.getExtensionDescription(J);if(ie)return new o.Extension(wt,ye.identifier,ie,Si)},get all(){return Wt.getAllExtensionDescriptions().map(J=>new o.Extension(wt,ye.identifier,J,Si))},get onDidChange(){return Wt.onDidChange}},Fi={createDiagnosticCollection(J){return Kt.createDiagnosticCollection(ye.identifier,J)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:J=>Kt.getDiagnostics(J),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(J,ie){return Zt.changeLanguage(J.uri,ie)},match(J,ie){return(0,N.score)(V.LanguageSelector.from(J),ie.uri,ie.languageId,!0)},registerCodeActionsProvider(J,ie,be){return rt.registerCodeActionProvider(ye,ft(J),ie,be)},registerCodeLensProvider(J,ie){return rt.registerCodeLensProvider(ye,ft(J),ie)},registerDefinitionProvider(J,ie){return rt.registerDefinitionProvider(ye,ft(J),ie)},registerDeclarationProvider(J,ie){return rt.registerDeclarationProvider(ye,ft(J),ie)},registerImplementationProvider(J,ie){return rt.registerImplementationProvider(ye,ft(J),ie)},registerTypeDefinitionProvider(J,ie){return rt.registerTypeDefinitionProvider(ye,ft(J),ie)},registerHoverProvider(J,ie){return rt.registerHoverProvider(ye,ft(J),ie,ye.identifier)},registerEvaluatableExpressionProvider(J,ie){return rt.registerEvaluatableExpressionProvider(ye,ft(J),ie,ye.identifier)},registerInlineValuesProvider(J,ie){return rt.registerInlineValuesProvider(ye,ft(J),ie,ye.identifier)},registerDocumentHighlightProvider(J,ie){return rt.registerDocumentHighlightProvider(ye,ft(J),ie)},registerLinkedEditingRangeProvider(J,ie){return rt.registerLinkedEditingRangeProvider(ye,ft(J),ie)},registerReferenceProvider(J,ie){return rt.registerReferenceProvider(ye,ft(J),ie)},registerRenameProvider(J,ie){return rt.registerRenameProvider(ye,ft(J),ie)},registerDocumentSymbolProvider(J,ie,be){return rt.registerDocumentSymbolProvider(ye,ft(J),ie,be)},registerWorkspaceSymbolProvider(J){return rt.registerWorkspaceSymbolProvider(ye,J)},registerDocumentFormattingEditProvider(J,ie){return rt.registerDocumentFormattingEditProvider(ye,ft(J),ie)},registerDocumentRangeFormattingEditProvider(J,ie){return rt.registerDocumentRangeFormattingEditProvider(ye,ft(J),ie)},registerOnTypeFormattingEditProvider(J,ie,be,...Xe){return rt.registerOnTypeFormattingEditProvider(ye,ft(J),ie,[be].concat(Xe))},registerDocumentSemanticTokensProvider(J,ie,be){return rt.registerDocumentSemanticTokensProvider(ye,ft(J),ie,be)},registerDocumentRangeSemanticTokensProvider(J,ie,be){return rt.registerDocumentRangeSemanticTokensProvider(ye,ft(J),ie,be)},registerSignatureHelpProvider(J,ie,be,...Xe){return typeof be=="object"?rt.registerSignatureHelpProvider(ye,ft(J),ie,be):rt.registerSignatureHelpProvider(ye,ft(J),ie,typeof be=="undefined"?[]:[be,...Xe])},registerCompletionItemProvider(J,ie,...be){return rt.registerCompletionItemProvider(ye,ft(J),ie,be)},registerInlineCompletionItemProvider(J,ie){return(0,He.checkProposedApiEnabled)(ye,"inlineCompletions"),rt.registerInlineCompletionsProvider(ye,ft(J),ie)},registerDocumentLinkProvider(J,ie){return rt.registerDocumentLinkProvider(ye,ft(J),ie)},registerColorProvider(J,ie){return rt.registerColorProvider(ye,ft(J),ie)},registerFoldingRangeProvider(J,ie){return rt.registerFoldingRangeProvider(ye,ft(J),ie)},registerSelectionRangeProvider(J,ie){return rt.registerSelectionRangeProvider(ye,J,ie)},registerCallHierarchyProvider(J,ie){return rt.registerCallHierarchyProvider(ye,J,ie)},registerTypeHierarchyProvider(J,ie){return rt.registerTypeHierarchyProvider(ye,J,ie)},setLanguageConfiguration:(J,ie)=>rt.setLanguageConfiguration(ye,J,ie),getTokenInformationAtPosition(J,ie){return(0,He.checkProposedApiEnabled)(ye,"tokenInformation"),Zt.tokenAtPosition(J,ie)},registerInlayHintsProvider(J,ie){return(0,He.checkProposedApiEnabled)(ye,"inlayHints"),rt.registerInlayHintsProvider(ye,J,ie)},createLanguageStatusItem(J,ie){return(0,He.checkProposedApiEnabled)(ye,"languageStatus"),Zt.createLanguageStatusItem(ye,J,ie)}},Mi={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(J,ie,be){const Xe=await(x.URI.isUri(J)?Promise.resolve(_i.openTextDocument(J)):Promise.resolve(J));return It.showTextDocument(Xe,ie,be)},createTextEditorDecorationType(J){return It.createTextEditorDecorationType(ye,J)},onDidChangeActiveTextEditor(J,ie,be){return It.onDidChangeActiveTextEditor(J,ie,be)},onDidChangeVisibleTextEditors(J,ie,be){return It.onDidChangeVisibleTextEditors(J,ie,be)},onDidChangeTextEditorSelection(J,ie,be){return It.onDidChangeTextEditorSelection(J,ie,be)},onDidChangeTextEditorOptions(J,ie,be){return It.onDidChangeTextEditorOptions(J,ie,be)},onDidChangeTextEditorVisibleRanges(J,ie,be){return It.onDidChangeTextEditorVisibleRanges(J,ie,be)},onDidChangeTextEditorViewColumn(J,ie,be){return It.onDidChangeTextEditorViewColumn(J,ie,be)},onDidCloseTerminal(J,ie,be){return lt.onDidCloseTerminal(J,ie,be)},onDidOpenTerminal(J,ie,be){return lt.onDidOpenTerminal(J,ie,be)},onDidChangeActiveTerminal(J,ie,be){return lt.onDidChangeActiveTerminal(J,ie,be)},onDidChangeTerminalDimensions(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"terminalDimensions"),lt.onDidChangeTerminalDimensions(J,ie,be)},onDidChangeTerminalState(J,ie,be){return lt.onDidChangeTerminalState(J,ie,be)},onDidWriteTerminalData(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"terminalDataWriteEvent"),lt.onDidWriteTerminalData(J,ie,be)},get state(){return $e.state},onDidChangeWindowState(J,ie,be){return $e.onDidChangeWindowState(J,ie,be)},showInformationMessage(J,...ie){return fi.showMessage(ye,C.default.Info,J,ie[0],ie.slice(1))},showWarningMessage(J,...ie){return fi.showMessage(ye,C.default.Warning,J,ie[0],ie.slice(1))},showErrorMessage(J,...ie){return fi.showMessage(ye,C.default.Error,J,ie[0],ie.slice(1))},showQuickPick(J,ie,be){return zt.showQuickPick(J,ie,be)},showWorkspaceFolderPick(J){return zt.showWorkspaceFolderPick(J)},showInputBox(J,ie){return zt.showInput(J,ie)},showOpenDialog(J){return bi.showOpenDialog(J)},showSaveDialog(J){return bi.showSaveDialog(J)},createStatusBarItem(J,ie,be){let Xe,gt,St;return typeof J=="string"?(Xe=J,gt=ie,St=be):(gt=J,St=ie),ni.createStatusBarEntry(ye,Xe,gt,St)},setStatusBarMessage(J,ie){return ni.setStatusBarMessage(J,ie)},withScmProgress(J){return _e.report("window.withScmProgress",ye,"Use 'withProgress' instead."),ei.withProgress(ye,{location:j.ProgressLocation.SourceControl},(ie,be)=>J({report(Xe){}}))},withProgress(J,ie){return ei.withProgress(ye,J,ie)},createOutputChannel(J){return Ft.createOutputChannel(J,ye)},createWebviewPanel(J,ie,be,Xe){return Qt.createWebviewPanel(ye,J,ie,be,Xe)},createWebviewTextEditorInset(J,ie,be,Xe){return(0,He.checkProposedApiEnabled)(ye,"editorInsets"),li.createWebviewEditorInset(J,ie,be,Xe,ye)},createTerminal(J,ie,be){return J&&typeof J=="object"&&"disablePersistence"in J&&(0,He.checkProposedApiEnabled)(ye,"terminalDisablePersistence"),typeof J=="object"?"pty"in J?lt.createExtensionTerminal(J):lt.createTerminalFromOptions(J):lt.createTerminal(J,ie,be)},registerTerminalLinkProvider(J){return lt.registerLinkProvider(J)},registerTerminalProfileProvider(J,ie){return lt.registerProfileProvider(ye,J,ie)},registerTreeDataProvider(J,ie){return Jt.registerTreeDataProvider(J,ie,ye)},createTreeView(J,ie){return Jt.createTreeView(J,ie,ye)},registerWebviewPanelSerializer:(J,ie)=>Qt.registerWebviewPanelSerializer(ye,J,ie),registerCustomEditorProvider:(J,ie,be={})=>hi.registerCustomEditorProvider(ye,J,ie,be),registerFileDecorationProvider(J){return pt.registerFileDecorationProvider(J,ye.identifier)},registerUriHandler(J){return Et.registerUriHandler(ye.identifier,J)},createQuickPick(){return zt.createQuickPick(ye)},createInputBox(){return zt.createInputBox(ye.identifier)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(J,ie,be){return Ei.onDidChangeActiveColorTheme(J,ie,be)},registerWebviewViewProvider(J,ie,be){return Ii.registerWebviewViewProvider(ye,J,ie,be?.webviewOptions)},get activeNotebookEditor(){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),ct.onDidChangeActiveNotebookEditor(J,ie,be)},get visibleNotebookEditors(){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),Gt.onDidChangeNotebookEditorSelection(J,ie,be)},onDidChangeNotebookEditorVisibleRanges(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),Gt.onDidChangeNotebookEditorVisibleRanges(J,ie,be)},showNotebookDocument(J,ie){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),ct.showNotebookDocument(J,ie)},registerExternalUriOpener(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"externalUriOpener"),ki.registerExternalUriOpener(ye.identifier,J,ie,be)},get tabs(){return(0,He.checkProposedApiEnabled)(ye,"tabs"),nt.tabs},get activeTab(){return(0,He.checkProposedApiEnabled)(ye,"tabs"),nt.activeTab},get onDidChangeTabs(){return(0,He.checkProposedApiEnabled)(ye,"tabs"),nt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,He.checkProposedApiEnabled)(ye,"tabs"),nt.onDidChangeActiveTab},getInlineCompletionItemController(J){return(0,He.checkProposedApiEnabled)(ye,"inlineCompletions"),f.InlineCompletionController.get(J)}},_i={get rootPath(){return _e.report("workspace.rootPath",ye,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(J){throw O.readonly()},getWorkspaceFolder(J){return at.getWorkspaceFolder(J)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(J){throw O.readonly()},get workspaceFile(){return at.workspaceFile},set workspaceFile(J){throw O.readonly()},updateWorkspaceFolders:(J,ie,...be)=>at.updateWorkspaceFolders(ye,J,ie||0,...be),onDidChangeWorkspaceFolders:function(J,ie,be){return at.onDidChangeWorkspace(J,ie,be)},asRelativePath:(J,ie)=>at.getRelativePath(J,ie),findFiles:(J,ie,be,Xe)=>at.findFiles(J,ie,be,ye.identifier,Xe),findTextInFiles:(J,ie,be,Xe)=>{(0,He.checkProposedApiEnabled)(ye,"findTextInFiles");let gt,St;return typeof ie=="object"?(gt=ie,St=be):(gt={},St=ie,Xe=be),at.findTextInFiles(J,gt||{},St,ye.identifier,Xe)},saveAll:J=>at.saveAll(J),applyEdit(J){return ii.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ie,be,Xe)=>Nt.createFileSystemWatcher(at,ye,J,ie,be,Xe),get textDocuments(){return dt.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw O.readonly()},openTextDocument(J){let ie;const be=J;if(typeof J=="string")ie=Promise.resolve(x.URI.file(J));else if(x.URI.isUri(J))ie=Promise.resolve(J);else if(!be||typeof be=="object")ie=dt.createDocumentData(be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ie.then(Xe=>dt.ensureDocumentData(Xe).then(gt=>gt.document))},onDidOpenTextDocument:(J,ie,be)=>dt.onDidAddDocument(J,ie,be),onDidCloseTextDocument:(J,ie,be)=>dt.onDidRemoveDocument(J,ie,be),onDidChangeTextDocument:(J,ie,be)=>dt.onDidChangeDocument(J,ie,be),onDidSaveTextDocument:(J,ie,be)=>dt.onDidSaveDocument(J,ie,be),onWillSaveTextDocument:(J,ie,be)=>qt.getOnWillSaveTextDocumentEvent(ye)(J,ie,be),get notebookDocuments(){return ct.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ie){let be;if(x.URI.isUri(J))be=J,await ct.openNotebookDocument(J);else if(typeof J=="string")be=x.URI.revive(await ct.createNotebookDocument({viewType:J,content:ie}));else throw new Error("Invalid arguments");return ct.getNotebookDocument(be).apiNotebook},get onDidOpenNotebookDocument(){return ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ct.onDidCloseNotebookDocument},registerNotebookSerializer(J,ie,be,Xe){return ct.registerNotebookSerializer(ye,J,ie,be,(0,He.isProposedApiEnabled)(ye,"notebookLiveShare")?Xe:void 0)},registerNotebookContentProvider:(J,ie,be,Xe)=>((0,He.checkProposedApiEnabled)(ye,"notebookContentProvider"),ct.registerNotebookContentProvider(ye,J,ie,be,(0,He.isProposedApiEnabled)(ye,"notebookLiveShare")?Xe:void 0)),onDidChangeConfiguration:(J,ie,be)=>$t.onDidChangeConfiguration(J,ie,be),getConfiguration(J,ie){return ie=arguments.length===1?void 0:ie,$t.getConfiguration(J,ie,ye)},registerTextDocumentContentProvider(J,ie){return Lt.registerTextDocumentContentProvider(J,ie)},registerTaskProvider:(J,ie)=>(_e.report("window.registerTaskProvider",ye,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(ye,J,ie)),registerFileSystemProvider(J,ie,be){return(0,Dt.combinedDisposable)(ci.registerFileSystemProvider(ye,J,ie,be),At.addFileSystemProvider(J,ie))},get fs(){return At.value},registerFileSearchProvider:(J,ie)=>((0,He.checkProposedApiEnabled)(ye,"fileSearchProvider"),Ut.registerFileSearchProvider(J,ie)),registerTextSearchProvider:(J,ie)=>((0,He.checkProposedApiEnabled)(ye,"textSearchProvider"),Ut.registerTextSearchProvider(J,ie)),registerRemoteAuthorityResolver:(J,ie)=>((0,He.checkProposedApiEnabled)(ye,"resolvers"),wt.registerRemoteAuthorityResolver(J,ie)),registerResourceLabelFormatter:J=>((0,He.checkProposedApiEnabled)(ye,"resolvers"),yi.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ie,be)=>Nt.onDidCreateFile(J,ie,be),onDidDeleteFiles:(J,ie,be)=>Nt.onDidDeleteFile(J,ie,be),onDidRenameFiles:(J,ie,be)=>Nt.onDidRenameFile(J,ie,be),onWillCreateFiles:(J,ie,be)=>Nt.getOnWillCreateFileEvent(ye)(J,ie,be),onWillDeleteFiles:(J,ie,be)=>Nt.getOnWillDeleteFileEvent(ye)(J,ie,be),onWillRenameFiles:(J,ie,be)=>Nt.getOnWillRenameFileEvent(ye)(J,ie,be),openTunnel:J=>((0,He.checkProposedApiEnabled)(ye,"resolvers"),pe.openTunnel(ye,J).then(ie=>{if(!ie)throw new Error("cannot open tunnel");return ie})),get tunnels(){return(0,He.checkProposedApiEnabled)(ye,"resolvers"),pe.getTunnels()},onDidChangeTunnels:(J,ie,be)=>((0,He.checkProposedApiEnabled)(ye,"resolvers"),pe.onDidChangeTunnels(J,ie,be)),registerPortAttributesProvider:(J,ie)=>((0,He.checkProposedApiEnabled)(ye,"portsAttributes"),pe.registerPortsAttributesProvider(J,ie)),registerTimelineProvider:(J,ie)=>((0,He.checkProposedApiEnabled)(ye,"timeline"),Ci.registerTimelineProvider(J,ie,ye.identifier,et.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:J=>((0,He.checkProposedApiEnabled)(ye,"workspaceTrust"),at.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ie,be)=>at.onDidGrantWorkspaceTrust(J,ie,be)},mi={get inputBox(){return _e.report("scm.inputBox",ye,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(ye)},createSourceControl(J,ie,be){return vi.createSourceControl(ye,J,ie,be)}},Oi={createCommentController(J,ie){return ui.createCommentController(ye,J,ie)}},Li={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(J,ie,be){return st.onDidStartDebugSession(J,ie,be)},onDidTerminateDebugSession(J,ie,be){return st.onDidTerminateDebugSession(J,ie,be)},onDidChangeActiveDebugSession(J,ie,be){return st.onDidChangeActiveDebugSession(J,ie,be)},onDidReceiveDebugSessionCustomEvent(J,ie,be){return st.onDidReceiveDebugSessionCustomEvent(J,ie,be)},onDidChangeBreakpoints(J,ie,be){return st.onDidChangeBreakpoints(J,ie,be)},registerDebugConfigurationProvider(J,ie,be){return st.registerDebugConfigurationProvider(J,ie,be||j.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ie){return st.registerDebugAdapterDescriptorFactory(ye,J,ie)},registerDebugAdapterTrackerFactory(J,ie){return st.registerDebugAdapterTrackerFactory(J,ie)},startDebugging(J,ie,be){return!be||typeof be=="object"&&"configuration"in be?st.startDebugging(J,ie,{parentSession:be}):st.startDebugging(J,ie,be||{})},stopDebugging(J){return st.stopDebugging(J)},addBreakpoints(J){return st.addBreakpoints(J)},removeBreakpoints(J){return st.removeBreakpoints(J)},asDebugSourceUri(J,ie){return st.asDebugSourceUri(J,ie)}},Ni={registerTaskProvider:(J,ie)=>Ct.registerTaskProvider(ye,J,ie),fetchTasks:J=>Ct.fetchTasks(J),executeTask:J=>Ct.executeTask(ye,J),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(J,ie,be)=>Ct.onDidStartTask(J,ie,be),onDidEndTask:(J,ie,be)=>Ct.onDidEndTask(J,ie,be),onDidStartTaskProcess:(J,ie,be)=>Ct.onDidStartTaskProcess(J,ie,be),onDidEndTaskProcess:(J,ie,be)=>Ct.onDidEndTaskProcess(J,ie,be)},xi={createNotebookController(J,ie,be,Xe,gt){return Xt.createNotebookController(ye,J,ie,be,Xe,(0,He.isProposedApiEnabled)(ye,"notebookMessaging")?gt:void 0)},registerNotebookCellStatusBarItemProvider:(J,ie)=>ct.registerNotebookCellStatusBarItemProvider(ye,J,ie),get onDidSaveNotebookDocument(){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),Bt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,He.checkProposedApiEnabled)(ye,"notebookEditorDecorationType"),Gt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ai.createRendererMessaging(ye,J)},onDidChangeNotebookDocumentMetadata(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),Bt.onDidChangeNotebookDocumentMetadata(J,ie,be)},onDidChangeNotebookCells(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),ct.onDidChangeNotebookCells(J,ie,be)},onDidChangeNotebookCellExecutionState(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"notebookCellExecutionState"),Xt.onDidChangeNotebookCellExecutionState(J,ie,be)},onDidChangeCellOutputs(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),ct.onDidChangeCellOutputs(J,ie,be)},onDidChangeCellMetadata(J,ie,be){return(0,He.checkProposedApiEnabled)(ye,"notebookEditor"),ct.onDidChangeCellMetadata(J,ie,be)},createConcatTextDocument(J,ie){return(0,He.checkProposedApiEnabled)(ye,"notebookConcatTextDocument"),new te.ExtHostNotebookConcatDocument(ct,dt,J,ie)}};return{version:ut.version,authentication:Rt,commands:ri,comments:Oi,debug:Li,env:wi,extensions:Ri,languages:Fi,notebooks:xi,scm:mi,tasks:Ni,tests:Ai,window:Mi,workspace:_i,Breakpoint:j.Breakpoint,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:O.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:t.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:j.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestions,Hover:j.Hover,IndentAction:L.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,TextEditorCursorStyle:F.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:t.UIKind,Uri:x.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:oe.TextSearchCompleteMessageType,TreeDataTransfer:j.TreeDataTransfer,TreeDataTransferItem:j.TreeDataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Pt}),define(me[221],ge([1,0,220,32,213,6,10,4,11]),function(Z,e,n,O,_,C,x,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class L extends _.RequireInterceptor{_installInterceptor(){}getModule(s,a){for(let l of this._alternatives){let P=l(s);if(P){s=P;break}}if(this._factories.has(s))return this._factories.get(s).load(s,a,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends O.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(F.MainContext.MainThreadConsole);t(s,this._initData.environment.isExtensionDevelopmentDebug);const a=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(L,a,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,a,l){a=a.with({path:g(a.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const P=await fetch(y.FileAccess.asBrowserUri(a).toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),P.status!==200)throw new Error(P.statusText);const v=await P.text(),E=`${a.toString(!0)}#vscode-extension`,r=`${v}
//# sourceURL=${E}`;let S;try{S=new Function("module","exports","require",r)}catch(c){throw console.error(s?`Loading code for extension ${s.value} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${a.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const i={},T={exports:i},o=c=>{const w=this._fakeModules.getModule(c,a);if(w===void 0)throw new Error(`Cannot load module '${c}'`);return w};try{return l.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),S(T,i,o),T.exports!==i?T.exports:i}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),l.codeLoadingStop()}}async $setRemoteEnvironment(s){}async _waitForDebuggerAttachment(s=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const a=Date.now()+s;for(;Date.now()<a&&!("__jsDebugIsReady"in globalThis);)await(0,x.timeout)(10)}}e.ExtHostExtensionService=N;function g(d,s){return d.endsWith(s)?d:d+s}function t(d,s){a("info","log"),a("log","log"),a("warn","warn"),a("error","error");function a(v,E){const r=console[v];console[v]=function(){d.$logExtensionHostMessage({type:"__$console",severity:E,arguments:P(arguments)}),s&&r.apply(console,arguments)}}const l=1e5;function P(v){const E=[],r=[];if(v.length)for(let S=0;S<v.length;S++){if(typeof v[S]=="undefined")v[S]="undefined";else if(v[S]instanceof Error){const i=v[S];i.stack?v[S]=i.stack:v[S]=i.toString()}r.push(v[S])}try{const S=JSON.stringify(r,function(i,T){if(T&&typeof T=="object"){if(E.indexOf(T)!==-1)return"[Circular]";E.push(T)}return T});return S.length>l?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}}),define(me[222],ge([1,0,43,32,65,221]),function(Z,e,n,O,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(O.IExtHostExtensionService,C.ExtHostExtensionService),(0,n.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(me[233],ge([1,0,21,5,170,214,208,19,66,11,2,217,222]),function(Z,e,n,O,_,C,x,F,y,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const g=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const t=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const d=fetch.bind(self);if(self.fetch=function(E,r){return E instanceof Request||/^file:/i.test(String(E))&&(E=L.FileAccess.asBrowserUri(N.URI.parse(String(E))).toString(!0)),d(E,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(E,r,S,i,T){return/^file:/i.test(r.toString())&&(r=L.FileAccess.asBrowserUri(N.URI.parse(r.toString())).toString(!0)),super.open(E,r,S??!0,i,T)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const E=self.Worker;Worker=function(r,S){/^file:/i.test(r.toString())&&(r=L.FileAccess.asBrowserUri(N.URI.parse(r.toString())).toString(!0));const T=`(${function(f){function h(b){return typeof b=="string"||b instanceof URL?String(b).replace(/^file:\/\//i,"vscode-file://vscode-app"):b}const p=fetch.bind(self);self.fetch=function(b,I){return b instanceof Request?p(b,I):p(h(b),I)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,I,k,$,u){return super.open(b,h(I),k??!0,$,u)}};const m=importScripts.bind(self);self.importScripts=(...b)=>{m(...b.map(h))},m(f)}.toString()}('${r}'))`;S=S||{},S.name=S.name||F.basename(r.toString());const o=new Blob([T],{type:"application/javascript"}),c=URL.createObjectURL(o);return new E(c,S)}}else self.Worker=class extends x.NestedWorker{constructor(E,r){super(t,E,{name:F.basename(E.toString()),...r})}};const s=new class{constructor(){this.pid=void 0}exit(E){g()}async exists(E){return!0}async realpath(E){return E}};class a{constructor(){const r=new MessageChannel,S=new O.Emitter;let i=!1;t(r.port2,[r.port2]),r.port1.onmessage=T=>{const{data:o}=T;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const c=n.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,_.isMessageOfType)(c,2)){i=!0,P("received terminate message from renderer");return}S.fire(c)},this.protocol={onMessage:S.event,send:T=>{if(!i){const o=T.buffer.buffer.slice(T.buffer.byteOffset,T.buffer.byteOffset+T.buffer.byteLength);r.port1.postMessage(o,[o])}}}}}function l(E){return new Promise(r=>{const S=E.onMessage(i=>{S.dispose();const T=JSON.parse(i.toString());E.send((0,_.createMessageOfType)(0)),r({protocol:E,initData:T})});E.send((0,_.createMessageOfType)(1))})}let P=E=>g();function v(){y.mark("code/extHost/willConnectToRenderer");const E=new a;return{onmessage(r){l(E.protocol).then(S=>{y.mark("code/extHost/didWaitForInitData");const i=new C.ExtensionHostMain(S.protocol,S.initData,s,null,r);P=T=>i.terminate(T)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/db4621a582f849d50f45d4826cb382a36720d002/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
